// This is a generated file (see the discoveryapis_generator project).

// ignore_for_file: camel_case_types
// ignore_for_file: comment_references
// ignore_for_file: file_names
// ignore_for_file: library_names
// ignore_for_file: lines_longer_than_80_chars
// ignore_for_file: non_constant_identifier_names
// ignore_for_file: prefer_expression_function_bodies
// ignore_for_file: prefer_interpolation_to_compose_strings
// ignore_for_file: unnecessary_brace_in_string_interps
// ignore_for_file: unnecessary_lambdas
// ignore_for_file: unnecessary_string_interpolations

/// Compute Engine API - v1
///
/// Creates and runs virtual machines on Google Cloud Platform.
///
/// For more information, see <https://cloud.google.com/compute/>
///
/// Create an instance of [ComputeApi] to access these resources:
///
/// - [AcceleratorTypesResource]
/// - [AddressesResource]
/// - [AutoscalersResource]
/// - [BackendBucketsResource]
/// - [BackendServicesResource]
/// - [DiskTypesResource]
/// - [DisksResource]
/// - [ExternalVpnGatewaysResource]
/// - [FirewallPoliciesResource]
/// - [FirewallsResource]
/// - [ForwardingRulesResource]
/// - [GlobalAddressesResource]
/// - [GlobalForwardingRulesResource]
/// - [GlobalNetworkEndpointGroupsResource]
/// - [GlobalOperationsResource]
/// - [GlobalOrganizationOperationsResource]
/// - [GlobalPublicDelegatedPrefixesResource]
/// - [HealthChecksResource]
/// - [HttpHealthChecksResource]
/// - [HttpsHealthChecksResource]
/// - [ImageFamilyViewsResource]
/// - [ImagesResource]
/// - [InstanceGroupManagersResource]
/// - [InstanceGroupsResource]
/// - [InstanceTemplatesResource]
/// - [InstancesResource]
/// - [InterconnectAttachmentsResource]
/// - [InterconnectLocationsResource]
/// - [InterconnectsResource]
/// - [LicenseCodesResource]
/// - [LicensesResource]
/// - [MachineImagesResource]
/// - [MachineTypesResource]
/// - [NetworkEdgeSecurityServicesResource]
/// - [NetworkEndpointGroupsResource]
/// - [NetworkFirewallPoliciesResource]
/// - [NetworksResource]
/// - [NodeGroupsResource]
/// - [NodeTemplatesResource]
/// - [NodeTypesResource]
/// - [PacketMirroringsResource]
/// - [ProjectsResource]
/// - [PublicAdvertisedPrefixesResource]
/// - [PublicDelegatedPrefixesResource]
/// - [RegionAutoscalersResource]
/// - [RegionBackendServicesResource]
/// - [RegionCommitmentsResource]
/// - [RegionDiskTypesResource]
/// - [RegionDisksResource]
/// - [RegionHealthCheckServicesResource]
/// - [RegionHealthChecksResource]
/// - [RegionInstanceGroupManagersResource]
/// - [RegionInstanceGroupsResource]
/// - [RegionInstancesResource]
/// - [RegionNetworkEndpointGroupsResource]
/// - [RegionNetworkFirewallPoliciesResource]
/// - [RegionNotificationEndpointsResource]
/// - [RegionOperationsResource]
/// - [RegionSecurityPoliciesResource]
/// - [RegionSslCertificatesResource]
/// - [RegionSslPoliciesResource]
/// - [RegionTargetHttpProxiesResource]
/// - [RegionTargetHttpsProxiesResource]
/// - [RegionTargetTcpProxiesResource]
/// - [RegionUrlMapsResource]
/// - [RegionsResource]
/// - [ReservationsResource]
/// - [ResourcePoliciesResource]
/// - [RoutersResource]
/// - [RoutesResource]
/// - [SecurityPoliciesResource]
/// - [ServiceAttachmentsResource]
/// - [SnapshotsResource]
/// - [SslCertificatesResource]
/// - [SslPoliciesResource]
/// - [SubnetworksResource]
/// - [TargetGrpcProxiesResource]
/// - [TargetHttpProxiesResource]
/// - [TargetHttpsProxiesResource]
/// - [TargetInstancesResource]
/// - [TargetPoolsResource]
/// - [TargetSslProxiesResource]
/// - [TargetTcpProxiesResource]
/// - [TargetVpnGatewaysResource]
/// - [UrlMapsResource]
/// - [VpnGatewaysResource]
/// - [VpnTunnelsResource]
/// - [ZoneOperationsResource]
/// - [ZonesResource]
library compute.v1;

import 'dart:async' as async;
import 'dart:convert' as convert;
import 'dart:core' as core;

import 'package:_discoveryapis_commons/_discoveryapis_commons.dart' as commons;
import 'package:http/http.dart' as http;

// ignore: deprecated_member_use_from_same_package
import '../shared.dart';
import '../src/user_agent.dart';

export 'package:_discoveryapis_commons/_discoveryapis_commons.dart'
    show ApiRequestError, DetailedApiRequestError;

/// Creates and runs virtual machines on Google Cloud Platform.
class ComputeApi {
  /// See, edit, configure, and delete your Google Cloud data and see the email
  /// address for your Google Account.
  static const cloudPlatformScope =
      'https://www.googleapis.com/auth/cloud-platform';

  /// View and manage your Google Compute Engine resources
  static const computeScope = 'https://www.googleapis.com/auth/compute';

  /// View your Google Compute Engine resources
  static const computeReadonlyScope =
      'https://www.googleapis.com/auth/compute.readonly';

  /// Manage your data and permissions in Cloud Storage and see the email
  /// address for your Google Account
  static const devstorageFullControlScope =
      'https://www.googleapis.com/auth/devstorage.full_control';

  /// View your data in Google Cloud Storage
  static const devstorageReadOnlyScope =
      'https://www.googleapis.com/auth/devstorage.read_only';

  /// Manage your data in Cloud Storage and see the email address of your Google
  /// Account
  static const devstorageReadWriteScope =
      'https://www.googleapis.com/auth/devstorage.read_write';

  final commons.ApiRequester _requester;

  AcceleratorTypesResource get acceleratorTypes =>
      AcceleratorTypesResource(_requester);
  AddressesResource get addresses => AddressesResource(_requester);
  AutoscalersResource get autoscalers => AutoscalersResource(_requester);
  BackendBucketsResource get backendBuckets =>
      BackendBucketsResource(_requester);
  BackendServicesResource get backendServices =>
      BackendServicesResource(_requester);
  DiskTypesResource get diskTypes => DiskTypesResource(_requester);
  DisksResource get disks => DisksResource(_requester);
  ExternalVpnGatewaysResource get externalVpnGateways =>
      ExternalVpnGatewaysResource(_requester);
  FirewallPoliciesResource get firewallPolicies =>
      FirewallPoliciesResource(_requester);
  FirewallsResource get firewalls => FirewallsResource(_requester);
  ForwardingRulesResource get forwardingRules =>
      ForwardingRulesResource(_requester);
  GlobalAddressesResource get globalAddresses =>
      GlobalAddressesResource(_requester);
  GlobalForwardingRulesResource get globalForwardingRules =>
      GlobalForwardingRulesResource(_requester);
  GlobalNetworkEndpointGroupsResource get globalNetworkEndpointGroups =>
      GlobalNetworkEndpointGroupsResource(_requester);
  GlobalOperationsResource get globalOperations =>
      GlobalOperationsResource(_requester);
  GlobalOrganizationOperationsResource get globalOrganizationOperations =>
      GlobalOrganizationOperationsResource(_requester);
  GlobalPublicDelegatedPrefixesResource get globalPublicDelegatedPrefixes =>
      GlobalPublicDelegatedPrefixesResource(_requester);
  HealthChecksResource get healthChecks => HealthChecksResource(_requester);
  HttpHealthChecksResource get httpHealthChecks =>
      HttpHealthChecksResource(_requester);
  HttpsHealthChecksResource get httpsHealthChecks =>
      HttpsHealthChecksResource(_requester);
  ImageFamilyViewsResource get imageFamilyViews =>
      ImageFamilyViewsResource(_requester);
  ImagesResource get images => ImagesResource(_requester);
  InstanceGroupManagersResource get instanceGroupManagers =>
      InstanceGroupManagersResource(_requester);
  InstanceGroupsResource get instanceGroups =>
      InstanceGroupsResource(_requester);
  InstanceTemplatesResource get instanceTemplates =>
      InstanceTemplatesResource(_requester);
  InstancesResource get instances => InstancesResource(_requester);
  InterconnectAttachmentsResource get interconnectAttachments =>
      InterconnectAttachmentsResource(_requester);
  InterconnectLocationsResource get interconnectLocations =>
      InterconnectLocationsResource(_requester);
  InterconnectsResource get interconnects => InterconnectsResource(_requester);
  LicenseCodesResource get licenseCodes => LicenseCodesResource(_requester);
  LicensesResource get licenses => LicensesResource(_requester);
  MachineImagesResource get machineImages => MachineImagesResource(_requester);
  MachineTypesResource get machineTypes => MachineTypesResource(_requester);
  NetworkEdgeSecurityServicesResource get networkEdgeSecurityServices =>
      NetworkEdgeSecurityServicesResource(_requester);
  NetworkEndpointGroupsResource get networkEndpointGroups =>
      NetworkEndpointGroupsResource(_requester);
  NetworkFirewallPoliciesResource get networkFirewallPolicies =>
      NetworkFirewallPoliciesResource(_requester);
  NetworksResource get networks => NetworksResource(_requester);
  NodeGroupsResource get nodeGroups => NodeGroupsResource(_requester);
  NodeTemplatesResource get nodeTemplates => NodeTemplatesResource(_requester);
  NodeTypesResource get nodeTypes => NodeTypesResource(_requester);
  PacketMirroringsResource get packetMirrorings =>
      PacketMirroringsResource(_requester);
  ProjectsResource get projects => ProjectsResource(_requester);
  PublicAdvertisedPrefixesResource get publicAdvertisedPrefixes =>
      PublicAdvertisedPrefixesResource(_requester);
  PublicDelegatedPrefixesResource get publicDelegatedPrefixes =>
      PublicDelegatedPrefixesResource(_requester);
  RegionAutoscalersResource get regionAutoscalers =>
      RegionAutoscalersResource(_requester);
  RegionBackendServicesResource get regionBackendServices =>
      RegionBackendServicesResource(_requester);
  RegionCommitmentsResource get regionCommitments =>
      RegionCommitmentsResource(_requester);
  RegionDiskTypesResource get regionDiskTypes =>
      RegionDiskTypesResource(_requester);
  RegionDisksResource get regionDisks => RegionDisksResource(_requester);
  RegionHealthCheckServicesResource get regionHealthCheckServices =>
      RegionHealthCheckServicesResource(_requester);
  RegionHealthChecksResource get regionHealthChecks =>
      RegionHealthChecksResource(_requester);
  RegionInstanceGroupManagersResource get regionInstanceGroupManagers =>
      RegionInstanceGroupManagersResource(_requester);
  RegionInstanceGroupsResource get regionInstanceGroups =>
      RegionInstanceGroupsResource(_requester);
  RegionInstancesResource get regionInstances =>
      RegionInstancesResource(_requester);
  RegionNetworkEndpointGroupsResource get regionNetworkEndpointGroups =>
      RegionNetworkEndpointGroupsResource(_requester);
  RegionNetworkFirewallPoliciesResource get regionNetworkFirewallPolicies =>
      RegionNetworkFirewallPoliciesResource(_requester);
  RegionNotificationEndpointsResource get regionNotificationEndpoints =>
      RegionNotificationEndpointsResource(_requester);
  RegionOperationsResource get regionOperations =>
      RegionOperationsResource(_requester);
  RegionSecurityPoliciesResource get regionSecurityPolicies =>
      RegionSecurityPoliciesResource(_requester);
  RegionSslCertificatesResource get regionSslCertificates =>
      RegionSslCertificatesResource(_requester);
  RegionSslPoliciesResource get regionSslPolicies =>
      RegionSslPoliciesResource(_requester);
  RegionTargetHttpProxiesResource get regionTargetHttpProxies =>
      RegionTargetHttpProxiesResource(_requester);
  RegionTargetHttpsProxiesResource get regionTargetHttpsProxies =>
      RegionTargetHttpsProxiesResource(_requester);
  RegionTargetTcpProxiesResource get regionTargetTcpProxies =>
      RegionTargetTcpProxiesResource(_requester);
  RegionUrlMapsResource get regionUrlMaps => RegionUrlMapsResource(_requester);
  RegionsResource get regions => RegionsResource(_requester);
  ReservationsResource get reservations => ReservationsResource(_requester);
  ResourcePoliciesResource get resourcePolicies =>
      ResourcePoliciesResource(_requester);
  RoutersResource get routers => RoutersResource(_requester);
  RoutesResource get routes => RoutesResource(_requester);
  SecurityPoliciesResource get securityPolicies =>
      SecurityPoliciesResource(_requester);
  ServiceAttachmentsResource get serviceAttachments =>
      ServiceAttachmentsResource(_requester);
  SnapshotsResource get snapshots => SnapshotsResource(_requester);
  SslCertificatesResource get sslCertificates =>
      SslCertificatesResource(_requester);
  SslPoliciesResource get sslPolicies => SslPoliciesResource(_requester);
  SubnetworksResource get subnetworks => SubnetworksResource(_requester);
  TargetGrpcProxiesResource get targetGrpcProxies =>
      TargetGrpcProxiesResource(_requester);
  TargetHttpProxiesResource get targetHttpProxies =>
      TargetHttpProxiesResource(_requester);
  TargetHttpsProxiesResource get targetHttpsProxies =>
      TargetHttpsProxiesResource(_requester);
  TargetInstancesResource get targetInstances =>
      TargetInstancesResource(_requester);
  TargetPoolsResource get targetPools => TargetPoolsResource(_requester);
  TargetSslProxiesResource get targetSslProxies =>
      TargetSslProxiesResource(_requester);
  TargetTcpProxiesResource get targetTcpProxies =>
      TargetTcpProxiesResource(_requester);
  TargetVpnGatewaysResource get targetVpnGateways =>
      TargetVpnGatewaysResource(_requester);
  UrlMapsResource get urlMaps => UrlMapsResource(_requester);
  VpnGatewaysResource get vpnGateways => VpnGatewaysResource(_requester);
  VpnTunnelsResource get vpnTunnels => VpnTunnelsResource(_requester);
  ZoneOperationsResource get zoneOperations =>
      ZoneOperationsResource(_requester);
  ZonesResource get zones => ZonesResource(_requester);

  ComputeApi(http.Client client,
      {core.String rootUrl = 'https://compute.googleapis.com/',
      core.String servicePath = 'compute/v1/'})
      : _requester =
            commons.ApiRequester(client, rootUrl, servicePath, requestHeaders);
}

class AcceleratorTypesResource {
  final commons.ApiRequester _requester;

  AcceleratorTypesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of accelerator types.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AcceleratorTypeAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AcceleratorTypeAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/acceleratorTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AcceleratorTypeAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified accelerator type.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [acceleratorType] - Name of the accelerator type to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AcceleratorType].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AcceleratorType> get(
    core.String project,
    core.String zone,
    core.String acceleratorType, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/acceleratorTypes/' +
        commons.escapeVariable('$acceleratorType');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AcceleratorType.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of accelerator types that are available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AcceleratorTypeList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AcceleratorTypeList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/acceleratorTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AcceleratorTypeList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class AddressesResource {
  final commons.ApiRequester _requester;

  AddressesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of addresses.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AddressAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AddressAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/addresses';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AddressAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified address resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [address] - Name of the address resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String address, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/addresses/' +
        commons.escapeVariable('$address');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified address resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [address] - Name of the address resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Address].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Address> get(
    core.String project,
    core.String region,
    core.String address, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/addresses/' +
        commons.escapeVariable('$address');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Address.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an address resource in the specified project by using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Address request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/addresses';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of addresses contained within the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AddressList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AddressList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/addresses';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AddressList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on an Address.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/addresses/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class AutoscalersResource {
  final commons.ApiRequester _requester;

  AutoscalersResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of autoscalers.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AutoscalerAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AutoscalerAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/autoscalers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AutoscalerAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified autoscaler.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String autoscaler, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers/' +
        commons.escapeVariable('$autoscaler');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified autoscaler resource.
  ///
  /// Gets a list of available autoscalers by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Autoscaler].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Autoscaler> get(
    core.String project,
    core.String zone,
    core.String autoscaler, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers/' +
        commons.escapeVariable('$autoscaler');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Autoscaler.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Autoscaler request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of autoscalers contained within the specified zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AutoscalerList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AutoscalerList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AutoscalerList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Autoscaler request,
    core.String project,
    core.String zone, {
    core.String? autoscaler,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (autoscaler != null) 'autoscaler': [autoscaler],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Autoscaler request,
    core.String project,
    core.String zone, {
    core.String? autoscaler,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (autoscaler != null) 'autoscaler': [autoscaler],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class BackendBucketsResource {
  final commons.ApiRequester _requester;

  BackendBucketsResource(commons.ApiRequester client) : _requester = client;

  /// Adds a key for validating requests with signed URLs for this backend
  /// bucket.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to which the Signed
  /// URL Key should be added. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addSignedUrlKey(
    SignedUrlKey request,
    core.String project,
    core.String backendBucket, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket') +
        '/addSignedUrlKey';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified BackendBucket resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String backendBucket, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a key for validating requests with signed URLs for this backend
  /// bucket.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to which the Signed
  /// URL Key should be added. The name should conform to RFC1035.
  ///
  /// [keyName] - The name of the Signed URL Key to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteSignedUrlKey(
    core.String project,
    core.String backendBucket,
    core.String keyName, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'keyName': [keyName],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket') +
        '/deleteSignedUrlKey';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified BackendBucket resource.
  ///
  /// Gets a list of available backend buckets by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendBucket].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendBucket> get(
    core.String project,
    core.String backendBucket, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendBucket.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a BackendBucket resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    BackendBucket request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of BackendBucket resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendBucketList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendBucketList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendBucketList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified BackendBucket resource with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    BackendBucket request,
    core.String project,
    core.String backendBucket, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the edge security policy for the specified backend bucket.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendService resource to which the
  /// security policy should be set. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setEdgeSecurityPolicy(
    SecurityPolicyReference request,
    core.String project,
    core.String backendBucket, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket') +
        '/setEdgeSecurityPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified BackendBucket resource with the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendBucket] - Name of the BackendBucket resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    BackendBucket request,
    core.String project,
    core.String backendBucket, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendBuckets/' +
        commons.escapeVariable('$backendBucket');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class BackendServicesResource {
  final commons.ApiRequester _requester;

  BackendServicesResource(commons.ApiRequester client) : _requester = client;

  /// Adds a key for validating requests with signed URLs for this backend
  /// service.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to which the Signed
  /// URL Key should be added. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addSignedUrlKey(
    SignedUrlKey request,
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/addSignedUrlKey';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of all BackendService resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendServiceAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendServiceAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/backendServices';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendServiceAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified BackendService resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a key for validating requests with signed URLs for this backend
  /// service.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to which the Signed
  /// URL Key should be added. The name should conform to RFC1035.
  ///
  /// [keyName] - The name of the Signed URL Key to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteSignedUrlKey(
    core.String project,
    core.String backendService,
    core.String keyName, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'keyName': [keyName],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/deleteSignedUrlKey';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified BackendService resource.
  ///
  /// Gets a list of available backend services.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendService].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendService> get(
    core.String project,
    core.String backendService, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendService.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the most recent health check results for this BackendService.
  ///
  /// Example request body: { "group":
  /// "/zones/us-east1-b/instanceGroups/lb-backend-example" }
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - null
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to which the
  /// queried instance belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendServiceGroupHealth].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendServiceGroupHealth> getHealth(
    ResourceGroupReference request,
    core.String project,
    core.String backendService, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/getHealth';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return BackendServiceGroupHealth.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a BackendService resource in the specified project using the data
  /// included in the request.
  ///
  /// For more information, see Backend services overview .
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    BackendService request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of BackendService resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendServiceList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendServiceList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendServiceList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified BackendService resource with the data included in
  /// the request.
  ///
  /// For more information, see Backend services overview. This method supports
  /// PATCH semantics and uses the JSON merge patch format and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    BackendService request,
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the edge security policy for the specified backend service.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to which the edge
  /// security policy should be set. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setEdgeSecurityPolicy(
    SecurityPolicyReference request,
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/setEdgeSecurityPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the Google Cloud Armor security policy for the specified backend
  /// service.
  ///
  /// For more information, see Google Cloud Armor Overview
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to which the
  /// security policy should be set. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSecurityPolicy(
    SecurityPolicyReference request,
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/setSecurityPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified BackendService resource with the data included in
  /// the request.
  ///
  /// For more information, see Backend services overview.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [backendService] - Name of the BackendService resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    BackendService request,
    core.String project,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class DiskTypesResource {
  final commons.ApiRequester _requester;

  DiskTypesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of disk types.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskTypeAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskTypeAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/diskTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskTypeAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified disk type.
  ///
  /// Gets a list of available disk types by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [diskType] - Name of the disk type to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskType].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskType> get(
    core.String project,
    core.String zone,
    core.String diskType, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/diskTypes/' +
        commons.escapeVariable('$diskType');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskType.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of disk types available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskTypeList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskTypeList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/diskTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskTypeList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class DisksResource {
  final commons.ApiRequester _requester;

  DisksResource(commons.ApiRequester client) : _requester = client;

  /// Adds existing resource policies to a disk.
  ///
  /// You can only add one policy which will be applied to this disk for
  /// scheduling snapshot creation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - The disk name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addResourcePolicies(
    DisksAddResourcePoliciesRequest request,
    core.String project,
    core.String zone,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/addResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves an aggregated list of persistent disks.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/aggregated/disks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a snapshot of a specified persistent disk.
  ///
  /// For regular snapshot creation, consider using snapshots.insert instead, as
  /// that method supports more features, such as creating snapshots in a
  /// project different from the source disk project.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the persistent disk to snapshot.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [guestFlush] - \[Input Only\] Whether to attempt an application consistent
  /// snapshot by informing the OS to prepare for the snapshot process.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> createSnapshot(
    Snapshot request,
    core.String project,
    core.String zone,
    core.String disk, {
    core.bool? guestFlush,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (guestFlush != null) 'guestFlush': ['${guestFlush}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/createSnapshot';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified persistent disk.
  ///
  /// Deleting a disk removes its data permanently and is irreversible. However,
  /// deleting a disk does not delete any snapshots previously made from the
  /// disk. You must separately delete snapshots.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the persistent disk to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns a specified persistent disk.
  ///
  /// Gets a list of available persistent disks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the persistent disk to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Disk].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Disk> get(
    core.String project,
    core.String zone,
    core.String disk, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Disk.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String zone,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a persistent disk in the specified project using the data in the
  /// request.
  ///
  /// You can create a disk from a source (sourceImage, sourceSnapshot, or
  /// sourceDisk) or create an empty 500 GB data disk by omitting all
  /// properties. You can also create a disk that is larger than the default
  /// size by specifying the sizeGb property.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceImage] - Source image to restore onto a disk. This field is
  /// optional.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Disk request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? sourceImage,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceImage != null) 'sourceImage': [sourceImage],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of persistent disks contained within the specified zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskList.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes resource policies from a disk.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - The disk name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeResourcePolicies(
    DisksRemoveResourcePoliciesRequest request,
    core.String project,
    core.String zone,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/removeResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Resizes the specified persistent disk.
  ///
  /// You can only increase the size of the disk.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - The name of the persistent disk.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resize(
    DisksResizeRequest request,
    core.String project,
    core.String zone,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/resize';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    ZoneSetPolicyRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a disk.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    ZoneSetLabelsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class ExternalVpnGatewaysResource {
  final commons.ApiRequester _requester;

  ExternalVpnGatewaysResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified externalVpnGateway.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [externalVpnGateway] - Name of the externalVpnGateways to delete.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String externalVpnGateway, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways/' +
        commons.escapeVariable('$externalVpnGateway');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified externalVpnGateway.
  ///
  /// Get a list of available externalVpnGateways by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [externalVpnGateway] - Name of the externalVpnGateway to return.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ExternalVpnGateway].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ExternalVpnGateway> get(
    core.String project,
    core.String externalVpnGateway, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways/' +
        commons.escapeVariable('$externalVpnGateway');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ExternalVpnGateway.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a ExternalVpnGateway in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    ExternalVpnGateway request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of ExternalVpnGateway available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ExternalVpnGatewayList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ExternalVpnGatewayList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ExternalVpnGatewayList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on an ExternalVpnGateway.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/externalVpnGateways/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class FirewallPoliciesResource {
  final commons.ApiRequester _requester;

  FirewallPoliciesResource(commons.ApiRequester client) : _requester = client;

  /// Inserts an association for the specified firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [replaceExistingAssociation] - Indicates whether or not to replace it if
  /// an association of the attachment already exists. This is false by default,
  /// in which case an error will be returned if an association already exists.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addAssociation(
    FirewallPolicyAssociation request,
    core.String firewallPolicy, {
    core.bool? replaceExistingAssociation,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (replaceExistingAssociation != null)
        'replaceExistingAssociation': ['${replaceExistingAssociation}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts a rule into a firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addRule(
    FirewallPolicyRule request,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Copies rules to the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceFirewallPolicy] - The firewall policy from which to copy rules.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> cloneRules(
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? sourceFirewallPolicy,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceFirewallPolicy != null)
        'sourceFirewallPolicy': [sourceFirewallPolicy],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/cloneRules';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified policy.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to delete.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to get.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicy> get(
    core.String firewallPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets an association with the specified name.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried rule
  /// belongs.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [name] - The name of the association to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyAssociation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyAssociation> getAssociation(
    core.String firewallPolicy, {
    core.String? name,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getAssociation';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyAssociation.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried rule
  /// belongs.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [priority] - The priority of the rule to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyRule> getRule(
    core.String firewallPolicy, {
    core.int? priority,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getRule';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new policy in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [parentId] - Parent ID for this request. The ID can be either be
  /// "folders/\[FOLDER_ID\]" if the parent is a folder or
  /// "organizations/\[ORGANIZATION_ID\]" if the parent is an organization.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    FirewallPolicy request, {
    core.String? parentId,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (parentId != null) 'parentId': [parentId],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    const url_ = 'locations/global/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the policies that have been configured for the specified folder
  /// or organization.
  ///
  /// Request parameters:
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [parentId] - Parent ID for this request.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyList> list({
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.String? parentId,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (parentId != null) 'parentId': [parentId],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    const url_ = 'locations/global/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists associations of a specified target, i.e., organization or folder.
  ///
  /// Request parameters:
  ///
  /// [targetResource] - The target resource to list associations. It is an
  /// organization, or a folder.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPoliciesListAssociationsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPoliciesListAssociationsResponse> listAssociations({
    core.String? targetResource,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (targetResource != null) 'targetResource': [targetResource],
      if ($fields != null) 'fields': [$fields],
    };

    const url_ = 'locations/global/firewallPolicies/listAssociations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPoliciesListAssociationsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Moves the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [parentId] - The new parent of the firewall policy.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> move(
    core.String firewallPolicy, {
    core.String? parentId,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (parentId != null) 'parentId': [parentId],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/move';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    FirewallPolicy request,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches a rule of the specified priority.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [priority] - The priority of the rule to patch.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchRule(
    FirewallPolicyRule request,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/patchRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes an association for the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [name] - Name for the attachment that will be removed.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeAssociation(
    core.String firewallPolicy, {
    core.String? name,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [priority] - The priority of the rule to remove from the firewall policy.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeRule(
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalOrganizationSetPolicyRequest request,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern `(firewallPolicies/)?\[0-9\]{0,20}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'locations/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class FirewallsResource {
  final commons.ApiRequester _requester;

  FirewallsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified firewall.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewall] - Name of the firewall rule to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String firewall, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewalls/' +
        commons.escapeVariable('$firewall');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified firewall.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewall] - Name of the firewall rule to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Firewall].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Firewall> get(
    core.String project,
    core.String firewall, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewalls/' +
        commons.escapeVariable('$firewall');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Firewall.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a firewall rule in the specified project using the data included
  /// in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Firewall request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/firewalls';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of firewall rules available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/firewalls';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified firewall rule with the data included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewall] - Name of the firewall rule to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Firewall request,
    core.String project,
    core.String firewall, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewalls/' +
        commons.escapeVariable('$firewall');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified firewall rule with the data included in the request.
  ///
  /// Note that all fields will be updated if using PUT, even fields that are
  /// not specified. To update individual fields, please use PATCH instead.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewall] - Name of the firewall rule to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Firewall request,
    core.String project,
    core.String firewall, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewalls/' +
        commons.escapeVariable('$firewall');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ForwardingRulesResource {
  final commons.ApiRequester _requester;

  ForwardingRulesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of forwarding rules.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ForwardingRuleAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ForwardingRuleAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/forwardingRules';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ForwardingRuleAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified ForwardingRule resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified ForwardingRule resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ForwardingRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ForwardingRule> get(
    core.String project,
    core.String region,
    core.String forwardingRule, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ForwardingRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a ForwardingRule resource in the specified project and region
  /// using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    ForwardingRule request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of ForwardingRule resources available to the specified
  /// project and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ForwardingRuleList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ForwardingRuleList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ForwardingRuleList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified forwarding rule with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules. Currently, you can only patch the network_tier
  /// field.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    ForwardingRule request,
    core.String project,
    core.String region,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on the specified resource.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes target URL for forwarding rule.
  ///
  /// The new target should be of the same type as the old target.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource in which target is
  /// to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setTarget(
    TargetReference request,
    core.String project,
    core.String region,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/forwardingRules/' +
        commons.escapeVariable('$forwardingRule') +
        '/setTarget';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalAddressesResource {
  final commons.ApiRequester _requester;

  GlobalAddressesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified address resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [address] - Name of the address resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String address, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/addresses/' +
        commons.escapeVariable('$address');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified address resource.
  ///
  /// Gets a list of available addresses by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [address] - Name of the address resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Address].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Address> get(
    core.String project,
    core.String address, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/addresses/' +
        commons.escapeVariable('$address');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Address.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an address resource in the specified project by using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Address request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/addresses';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of global addresses.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [AddressList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<AddressList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/addresses';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return AddressList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a GlobalAddress.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/addresses/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalForwardingRulesResource {
  final commons.ApiRequester _requester;

  GlobalForwardingRulesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified GlobalForwardingRule resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified GlobalForwardingRule resource.
  ///
  /// Gets a list of available forwarding rules by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ForwardingRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ForwardingRule> get(
    core.String project,
    core.String forwardingRule, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ForwardingRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a GlobalForwardingRule resource in the specified project using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    ForwardingRule request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of GlobalForwardingRule resources available to the
  /// specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ForwardingRuleList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ForwardingRuleList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ForwardingRuleList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified forwarding rule with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules. Currently, you can only patch the network_tier
  /// field.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    ForwardingRule request,
    core.String project,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules/' +
        commons.escapeVariable('$forwardingRule');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on the specified resource.
  ///
  /// To learn more about labels, read the Labeling resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes target URL for the GlobalForwardingRule resource.
  ///
  /// The new target should be of the same type as the old target.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [forwardingRule] - Name of the ForwardingRule resource in which target is
  /// to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setTarget(
    TargetReference request,
    core.String project,
    core.String forwardingRule, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/forwardingRules/' +
        commons.escapeVariable('$forwardingRule') +
        '/setTarget';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalNetworkEndpointGroupsResource {
  final commons.ApiRequester _requester;

  GlobalNetworkEndpointGroupsResource(commons.ApiRequester client)
      : _requester = client;

  /// Attach a network endpoint to the specified network endpoint group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group where you
  /// are attaching network endpoints to. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> attachNetworkEndpoints(
    GlobalNetworkEndpointGroupsAttachEndpointsRequest request,
    core.String project,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/attachNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified network endpoint group.Note that the NEG cannot be
  /// deleted if there are backend services referencing it.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group to delete.
  /// It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Detach the network endpoint from the specified network endpoint group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group where you
  /// are removing network endpoints. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> detachNetworkEndpoints(
    GlobalNetworkEndpointGroupsDetachEndpointsRequest request,
    core.String project,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/detachNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network endpoint group.
  ///
  /// Gets a list of available network endpoint groups by making a list()
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group. It should
  /// comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroup> get(
    core.String project,
    core.String networkEndpointGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroup.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a network endpoint group in the specified project using the
  /// parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NetworkEndpointGroup request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of network endpoint groups that are located in the
  /// specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the network endpoints in the specified network endpoint group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group from which
  /// you want to generate a list of included network endpoints. It should
  /// comply with RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupsListNetworkEndpoints].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupsListNetworkEndpoints> listNetworkEndpoints(
    core.String project,
    core.String networkEndpointGroup, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/listNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupsListNetworkEndpoints.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalOperationsResource {
  final commons.ApiRequester _requester;

  GlobalOperationsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of all operations.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [OperationAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<OperationAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/operations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return OperationAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [operation] - Name of the Operations resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<void> delete(
    core.String project,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/operations/' +
        commons.escapeVariable('$operation');

    await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
      downloadOptions: null,
    );
  }

  /// Retrieves the specified Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> get(
    core.String project,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/operations/' +
        commons.escapeVariable('$operation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of Operation resources contained within the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [OperationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<OperationList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/operations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return OperationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Waits for the specified Operation resource to return as `DONE` or for the
  /// request to approach the 2 minute deadline, and retrieves the specified
  /// Operation resource.
  ///
  /// This method differs from the `GET` method in that it waits for no more
  /// than the default deadline (2 minutes) and then returns the current state
  /// of the operation, which might be `DONE` or still in progress. This method
  /// is called on a best-effort basis. Specifically: - In uncommon cases, when
  /// the server is overloaded, the request might return before the default
  /// deadline is reached, or might return after zero seconds. - If the default
  /// deadline is reached, there is no guarantee that the operation is actually
  /// done when the method returns. Be prepared to retry if the operation is not
  /// `DONE`.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> wait(
    core.String project,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/operations/' +
        commons.escapeVariable('$operation') +
        '/wait';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalOrganizationOperationsResource {
  final commons.ApiRequester _requester;

  GlobalOrganizationOperationsResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified Operations resource.
  ///
  /// Request parameters:
  ///
  /// [operation] - Name of the Operations resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [parentId] - Parent ID for this request.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<void> delete(
    core.String operation, {
    core.String? parentId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (parentId != null) 'parentId': [parentId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'locations/global/operations/' + commons.escapeVariable('$operation');

    await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
      downloadOptions: null,
    );
  }

  /// Retrieves the specified Operations resource.
  ///
  /// Gets a list of operations by making a `list()` request.
  ///
  /// Request parameters:
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [parentId] - Parent ID for this request.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> get(
    core.String operation, {
    core.String? parentId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (parentId != null) 'parentId': [parentId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'locations/global/operations/' + commons.escapeVariable('$operation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of Operation resources contained within the specified
  /// organization.
  ///
  /// Request parameters:
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [parentId] - Parent ID for this request.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [OperationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<OperationList> list({
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.String? parentId,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (parentId != null) 'parentId': [parentId],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    const url_ = 'locations/global/operations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return OperationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class GlobalPublicDelegatedPrefixesResource {
  final commons.ApiRequester _requester;

  GlobalPublicDelegatedPrefixesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified global PublicDelegatedPrefix.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String publicDelegatedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified global PublicDelegatedPrefix resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicDelegatedPrefix].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicDelegatedPrefix> get(
    core.String project,
    core.String publicDelegatedPrefix, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicDelegatedPrefix.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a global PublicDelegatedPrefix in the specified project using the
  /// parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    PublicDelegatedPrefix request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicDelegatedPrefixes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the global PublicDelegatedPrefixes for a project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicDelegatedPrefixList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicDelegatedPrefixList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicDelegatedPrefixes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicDelegatedPrefixList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified global PublicDelegatedPrefix resource with the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    PublicDelegatedPrefix request,
    core.String project,
    core.String publicDelegatedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class HealthChecksResource {
  final commons.ApiRequester _requester;

  HealthChecksResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all HealthCheck resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthChecksAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthChecksAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/healthChecks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthChecksAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified HealthCheck resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified HealthCheck resource.
  ///
  /// Gets a list of available health checks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheck].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheck> get(
    core.String project,
    core.String healthCheck, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheck.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    HealthCheck request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of HealthCheck resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheckList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheckList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheckList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    HealthCheck request,
    core.String project,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    HealthCheck request,
    core.String project,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class HttpHealthChecksResource {
  final commons.ApiRequester _requester;

  HttpHealthChecksResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified HttpHealthCheck resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpHealthCheck] - Name of the HttpHealthCheck resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String httpHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks/' +
        commons.escapeVariable('$httpHealthCheck');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified HttpHealthCheck resource.
  ///
  /// Gets a list of available HTTP health checks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpHealthCheck] - Name of the HttpHealthCheck resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HttpHealthCheck].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HttpHealthCheck> get(
    core.String project,
    core.String httpHealthCheck, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks/' +
        commons.escapeVariable('$httpHealthCheck');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HttpHealthCheck.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a HttpHealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    HttpHealthCheck request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of HttpHealthCheck resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HttpHealthCheckList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HttpHealthCheckList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HttpHealthCheckList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HttpHealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpHealthCheck] - Name of the HttpHealthCheck resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    HttpHealthCheck request,
    core.String project,
    core.String httpHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks/' +
        commons.escapeVariable('$httpHealthCheck');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HttpHealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpHealthCheck] - Name of the HttpHealthCheck resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    HttpHealthCheck request,
    core.String project,
    core.String httpHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpHealthChecks/' +
        commons.escapeVariable('$httpHealthCheck');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class HttpsHealthChecksResource {
  final commons.ApiRequester _requester;

  HttpsHealthChecksResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified HttpsHealthCheck resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpsHealthCheck] - Name of the HttpsHealthCheck resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String httpsHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks/' +
        commons.escapeVariable('$httpsHealthCheck');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified HttpsHealthCheck resource.
  ///
  /// Gets a list of available HTTPS health checks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpsHealthCheck] - Name of the HttpsHealthCheck resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HttpsHealthCheck].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HttpsHealthCheck> get(
    core.String project,
    core.String httpsHealthCheck, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks/' +
        commons.escapeVariable('$httpsHealthCheck');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HttpsHealthCheck.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a HttpsHealthCheck resource in the specified project using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    HttpsHealthCheck request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of HttpsHealthCheck resources available to the
  /// specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HttpsHealthCheckList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HttpsHealthCheckList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HttpsHealthCheckList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HttpsHealthCheck resource in the specified project using the
  /// data included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpsHealthCheck] - Name of the HttpsHealthCheck resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    HttpsHealthCheck request,
    core.String project,
    core.String httpsHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks/' +
        commons.escapeVariable('$httpsHealthCheck');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HttpsHealthCheck resource in the specified project using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [httpsHealthCheck] - Name of the HttpsHealthCheck resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    HttpsHealthCheck request,
    core.String project,
    core.String httpsHealthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/httpsHealthChecks/' +
        commons.escapeVariable('$httpsHealthCheck');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ImageFamilyViewsResource {
  final commons.ApiRequester _requester;

  ImageFamilyViewsResource(commons.ApiRequester client) : _requester = client;

  /// Returns the latest image that is part of an image family, is not
  /// deprecated and is rolled out in the specified zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [family] - Name of the image family to search for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ImageFamilyView].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ImageFamilyView> get(
    core.String project,
    core.String zone,
    core.String family, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/imageFamilyViews/' +
        commons.escapeVariable('$family');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ImageFamilyView.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class ImagesResource {
  final commons.ApiRequester _requester;

  ImagesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified image.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [image] - Name of the image resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String image, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$image');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the deprecation status of an image.
  ///
  /// If an empty request body is given, clears the deprecation status instead.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [image] - Image name.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deprecate(
    DeprecationStatus request,
    core.String project,
    core.String image, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$image') +
        '/deprecate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified image.
  ///
  /// Gets a list of available images by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [image] - Name of the image resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Image].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Image> get(
    core.String project,
    core.String image, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$image');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Image.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the latest image that is part of an image family and is not
  /// deprecated.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [family] - Name of the image family to search for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Image].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Image> getFromFamily(
    core.String project,
    core.String family, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/family/' +
        commons.escapeVariable('$family');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Image.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an image in the specified project using the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [forceCreate] - Force image creation if true.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Image request,
    core.String project, {
    core.bool? forceCreate,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (forceCreate != null) 'forceCreate': ['${forceCreate}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/images';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of custom images available to the specified project.
  ///
  /// Custom images are images you create that belong to your project. This
  /// method does not get any images that belong to other projects, including
  /// publicly-available images, like Debian 8. If you want to get a list of
  /// publicly-available images, use this method to make a request to the
  /// respective image project, such as debian-cloud or windows-cloud.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ImageList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ImageList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/images';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ImageList.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified image with the data included in the request.
  ///
  /// Only the following fields can be modified: family, description,
  /// deprecation status.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [image] - Name of the image resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Image request,
    core.String project,
    core.String image, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$image');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on an image.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/images/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class InstanceGroupManagersResource {
  final commons.ApiRequester _requester;

  InstanceGroupManagersResource(commons.ApiRequester client)
      : _requester = client;

  /// Flags the specified instances to be removed from the managed instance
  /// group.
  ///
  /// Abandoning an instance does not delete the instance, but it does remove
  /// the instance from any target pools that are applied by the managed
  /// instance group. This method reduces the targetSize of the managed instance
  /// group by the number of instances that you abandon. This operation is
  /// marked as DONE when the action is scheduled even if the instances have not
  /// yet been removed from the group. You must separately verify the status of
  /// the abandoning action with the listmanagedinstances method. If the group
  /// is part of a backend service that has enabled connection draining, it can
  /// take up to 60 seconds after the connection draining duration has elapsed
  /// before the VM instance is removed or deleted. You can specify a maximum of
  /// 1000 instances with this method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> abandonInstances(
    InstanceGroupManagersAbandonInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/abandonInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of managed instance groups and groups them by zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManagerAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManagerAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/instanceGroupManagers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupManagerAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Applies changes to selected instances on the managed instance group.
  ///
  /// This method can be used to apply new overrides and/or new versions.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// Should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group, should
  /// conform to RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> applyUpdatesToInstances(
    InstanceGroupManagersApplyUpdatesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/applyUpdatesToInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates instances with per-instance configurations in this managed
  /// instance group.
  ///
  /// Instances are created using the current instance template. The create
  /// instances operation is marked DONE if the createInstances request is
  /// successful. The underlying actions take additional time. You must
  /// separately verify the status of the creating or actions with the
  /// listmanagedinstances method.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. The request ID must
  /// be a valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> createInstances(
    InstanceGroupManagersCreateInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/createInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified managed instance group and all of the instances in
  /// that group.
  ///
  /// Note that the instance group must not belong to a backend service. Read
  /// Deleting an instance group for more information.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Flags the specified instances in the managed instance group for immediate
  /// deletion.
  ///
  /// The instances are also removed from any target pools of which they were a
  /// member. This method reduces the targetSize of the managed instance group
  /// by the number of instances that you delete. This operation is marked as
  /// DONE when the action is scheduled even if the instances are still being
  /// deleted. You must separately verify the status of the deleting action with
  /// the listmanagedinstances method. If the group is part of a backend service
  /// that has enabled connection draining, it can take up to 60 seconds after
  /// the connection draining duration has elapsed before the VM instance is
  /// removed or deleted. You can specify a maximum of 1000 instances with this
  /// method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteInstances(
    InstanceGroupManagersDeleteInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/deleteInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes selected per-instance configurations for the managed instance
  /// group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deletePerInstanceConfigs(
    InstanceGroupManagersDeletePerInstanceConfigsReq request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/deletePerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns all of the details about the specified managed instance group.
  ///
  /// Gets a list of available managed instance groups by making a list()
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManager].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManager> get(
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupManager.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a managed instance group using the information that you specify in
  /// the request.
  ///
  /// After the group is created, instances in the group are created using the
  /// specified instance template. This operation is marked as DONE when the
  /// group is created even if the instances in the group have not yet been
  /// created. You must separately verify the status of the individual instances
  /// with the listmanagedinstances method. A managed instance group can have up
  /// to 1000 VM instances per group. Please contact Cloud Support if you need
  /// an increase in this limit.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where you want to create the managed
  /// instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    InstanceGroupManager request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of managed instance groups that are contained within the
  /// specified project and zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManagerList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManagerList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupManagerList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all errors thrown by actions on instances for a given managed
  /// instance group.
  ///
  /// The filter and orderBy query parameters are not supported.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It must
  /// be a string that meets the requirements in RFC1035, or an unsigned long
  /// integer: must match regexp pattern:
  /// (?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?)|1-9{0,19}.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManagersListErrorsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManagersListErrorsResponse> listErrors(
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listErrors';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupManagersListErrorsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all of the instances in the managed instance group.
  ///
  /// Each instance in the list has a currentAction, which indicates the action
  /// that the managed instance group is performing on the instance. For
  /// example, if the group is still creating an instance, the currentAction is
  /// CREATING. If a previous action failed, the list displays the errors for
  /// that failed action. The orderBy query parameter is not supported. The
  /// `pageToken` query parameter is supported only in the alpha and beta API
  /// and only if the group's `listManagedInstancesResults` field is set to
  /// `PAGINATED`.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManagersListManagedInstancesResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManagersListManagedInstancesResponse>
      listManagedInstances(
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listManagedInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return InstanceGroupManagersListManagedInstancesResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all of the per-instance configurations defined for the managed
  /// instance group.
  ///
  /// The orderBy query parameter is not supported.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManagersListPerInstanceConfigsResp].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManagersListPerInstanceConfigsResp>
      listPerInstanceConfigs(
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listPerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return InstanceGroupManagersListPerInstanceConfigsResp.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a managed instance group using the information that you specify in
  /// the request.
  ///
  /// This operation is marked as DONE when the group is patched even if the
  /// instances in the group are still in the process of being patched. You must
  /// separately verify the status of the individual instances with the
  /// listManagedInstances method. This method supports PATCH semantics and uses
  /// the JSON merge patch format and processing rules. If you update your group
  /// to specify a new template or instance configuration, it's possible that
  /// your intended specification for each VM in the group is different from the
  /// current state of that VM. To learn how to apply an updated configuration
  /// to the VMs in a MIG, see Updating instances in a MIG.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where you want to create the managed
  /// instance group.
  ///
  /// [instanceGroupManager] - The name of the instance group manager.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    InstanceGroupManager request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts or patches per-instance configurations for the managed instance
  /// group.
  ///
  /// perInstanceConfig.name serves as a key used to distinguish whether to
  /// perform insert or patch.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchPerInstanceConfigs(
    InstanceGroupManagersPatchPerInstanceConfigsReq request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/patchPerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Flags the specified VM instances in the managed instance group to be
  /// immediately recreated.
  ///
  /// Each instance is recreated using the group's current configuration. This
  /// operation is marked as DONE when the flag is set even if the instances
  /// have not yet been recreated. You must separately verify the status of each
  /// instance by checking its currentAction field; for more information, see
  /// Checking the status of managed instances. If the group is part of a
  /// backend service that has enabled connection draining, it can take up to 60
  /// seconds after the connection draining duration has elapsed before the VM
  /// instance is removed or deleted. You can specify a maximum of 1000
  /// instances with this method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> recreateInstances(
    InstanceGroupManagersRecreateInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/recreateInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Resizes the managed instance group.
  ///
  /// If you increase the size, the group creates new instances using the
  /// current instance template. If you decrease the size, the group deletes
  /// instances. The resize operation is marked DONE when the resize actions are
  /// scheduled even if the group has not yet added or deleted any instances.
  /// You must separately verify the status of the creating or deleting actions
  /// with the listmanagedinstances method. When resizing down, the instance
  /// group arbitrarily chooses the order in which VMs are deleted. The group
  /// takes into account some VM attributes when making the selection including:
  /// + The status of the VM instance. + The health of the VM instance. + The
  /// instance template version the VM is based on. + For regional managed
  /// instance groups, the location of the VM instance. This list is subject to
  /// change. If the group is part of a backend service that has enabled
  /// connection draining, it can take up to 60 seconds after the connection
  /// draining duration has elapsed before the VM instance is removed or
  /// deleted.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [size] - The number of running instances that the managed instance group
  /// should maintain at any given time. The group automatically adds or removes
  /// instances to maintain the number of instances specified by this parameter.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resize(
    core.String project,
    core.String zone,
    core.String instanceGroupManager,
    core.int size, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'size': ['${size}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/resize';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Specifies the instance template to use when creating new instances in this
  /// group.
  ///
  /// The templates for existing instances in the group do not change unless you
  /// run recreateInstances, run applyUpdatesToInstances, or set the group's
  /// updatePolicy.type to PROACTIVE.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setInstanceTemplate(
    InstanceGroupManagersSetInstanceTemplateRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/setInstanceTemplate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Modifies the target pools to which all instances in this managed instance
  /// group are assigned.
  ///
  /// The target pools automatically apply to all of the instances in the
  /// managed instance group. This operation is marked DONE when you make the
  /// request even if the instances have not yet been added to their target
  /// pools. The change might take some time to apply to all of the instances in
  /// the group depending on the size of the group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setTargetPools(
    InstanceGroupManagersSetTargetPoolsRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/setTargetPools';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts or updates per-instance configurations for the managed instance
  /// group.
  ///
  /// perInstanceConfig.name serves as a key used to distinguish whether to
  /// perform insert or patch.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the managed instance group is located.
  /// It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updatePerInstanceConfigs(
    InstanceGroupManagersUpdatePerInstanceConfigsReq request,
    core.String project,
    core.String zone,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/updatePerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class InstanceGroupsResource {
  final commons.ApiRequester _requester;

  InstanceGroupsResource(commons.ApiRequester client) : _requester = client;

  /// Adds a list of instances to the specified instance group.
  ///
  /// All of the instances in the instance group must be in the same
  /// network/subnetwork. Read Adding instances for more information.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group where you are adding
  /// instances.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addInstances(
    InstanceGroupsAddInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/addInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of instance groups and sorts them by zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/instanceGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified instance group.
  ///
  /// The instances in the group are not deleted. Note that instance group must
  /// not belong to a backend service. Read Deleting an instance group for more
  /// information.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified zonal instance group.
  ///
  /// Get a list of available zonal instance groups by making a list() request.
  /// For managed instance groups, use the instanceGroupManagers or
  /// regionInstanceGroupManagers methods instead.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroup> get(
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroup.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an instance group in the specified project using the parameters
  /// that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where you want to create the instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    InstanceGroup request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of zonal instance group resources contained within the
  /// specified zone.
  ///
  /// For managed instance groups, use the instanceGroupManagers or
  /// regionInstanceGroupManagers methods instead.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the instances in the specified instance group.
  ///
  /// The orderBy query parameter is not supported. The filter query parameter
  /// is supported, but only for expressions that use `eq` (equal) or `ne` (not
  /// equal) operators.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group from which you want to
  /// generate a list of included instances.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupsListInstances].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupsListInstances> listInstances(
    InstanceGroupsListInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/listInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return InstanceGroupsListInstances.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes one or more instances from the specified instance group, but does
  /// not delete those instances.
  ///
  /// If the group is part of a backend service that has enabled connection
  /// draining, it can take up to 60 seconds after the connection draining
  /// duration before the VM instance is removed or deleted.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group where the specified
  /// instances will be removed.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeInstances(
    InstanceGroupsRemoveInstancesRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/removeInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the named ports for the specified instance group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the instance group is located.
  ///
  /// [instanceGroup] - The name of the instance group where the named ports are
  /// updated.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setNamedPorts(
    InstanceGroupsSetNamedPortsRequest request,
    core.String project,
    core.String zone,
    core.String instanceGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/setNamedPorts';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class InstanceTemplatesResource {
  final commons.ApiRequester _requester;

  InstanceTemplatesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified instance template.
  ///
  /// Deleting an instance template is permanent and cannot be undone. It is not
  /// possible to delete templates that are already in use by a managed instance
  /// group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [instanceTemplate] - The name of the instance template to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String instanceTemplate, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates/' +
        commons.escapeVariable('$instanceTemplate');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified instance template.
  ///
  /// Gets a list of available instance templates by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [instanceTemplate] - The name of the instance template.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceTemplate].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceTemplate> get(
    core.String project,
    core.String instanceTemplate, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates/' +
        commons.escapeVariable('$instanceTemplate');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceTemplate.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an instance template in the specified project using the data that
  /// is included in the request.
  ///
  /// If you are creating a new template to update an existing instance group,
  /// your new instance template must use the same network or, if applicable,
  /// the same subnetwork as the original template.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    InstanceTemplate request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of instance templates that are contained within the
  /// specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceTemplateList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceTemplateList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceTemplateList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/instanceTemplates/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class InstancesResource {
  final commons.ApiRequester _requester;

  InstancesResource(commons.ApiRequester client) : _requester = client;

  /// Adds an access config to an instance's network interface.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [networkInterface] - The name of the network interface to add to this
  /// instance.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addAccessConfig(
    AccessConfig request,
    core.String project,
    core.String zone,
    core.String instance,
    core.String networkInterface, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      'networkInterface': [networkInterface],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/addAccessConfig';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Adds existing resource policies to an instance.
  ///
  /// You can only add one policy right now which will be applied to this
  /// instance for scheduling live migrations.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addResourcePolicies(
    InstancesAddResourcePoliciesRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/addResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves an aggregated list of all of the instances in your project
  /// across all regions and zones.
  ///
  /// The performance of this method degrades when a filter is specified on a
  /// project that has a very large number of instances.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/instances';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Attaches an existing Disk resource to an instance.
  ///
  /// You must first create the disk before you can attach it. It is not
  /// possible to create and attach a disk at the same time. For more
  /// information, read Adding a persistent disk to your instance.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [forceAttach] - Whether to force attach the regional disk even if it's
  /// currently attached to another instance. If you try to force attach a zonal
  /// disk to an instance, you will receive an error.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> attachDisk(
    AttachedDisk request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.bool? forceAttach,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (forceAttach != null) 'forceAttach': ['${forceAttach}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/attachDisk';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates multiple instances.
  ///
  /// Count specifies the number of instances to create. For more information,
  /// see About bulk creation of VMs.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> bulkInsert(
    BulkInsertInstanceResource request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/bulkInsert';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified Instance resource.
  ///
  /// For more information, see Deleting an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes an access config from an instance's network interface.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [accessConfig] - The name of the access config to delete.
  ///
  /// [networkInterface] - The name of the network interface.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteAccessConfig(
    core.String project,
    core.String zone,
    core.String instance,
    core.String accessConfig,
    core.String networkInterface, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'accessConfig': [accessConfig],
      'networkInterface': [networkInterface],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/deleteAccessConfig';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Detaches a disk from an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [deviceName] - The device name of the disk to detach. Make a get() request
  /// on the instance to view currently attached disks and device names.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> detachDisk(
    core.String project,
    core.String zone,
    core.String instance,
    core.String deviceName, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'deviceName': [deviceName],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/detachDisk';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified Instance resource.
  ///
  /// Gets a list of available instances by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Instance].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Instance> get(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Instance.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns effective firewalls applied to an interface of the instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [networkInterface] - The name of the network interface to get the
  /// effective firewalls.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstancesGetEffectiveFirewallsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstancesGetEffectiveFirewallsResponse> getEffectiveFirewalls(
    core.String project,
    core.String zone,
    core.String instance,
    core.String networkInterface, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'networkInterface': [networkInterface],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/getEffectiveFirewalls';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstancesGetEffectiveFirewallsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified guest attributes entry.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [queryPath] - Specifies the guest attributes path to be queried.
  ///
  /// [variableKey] - Specifies the key for the guest attributes entry.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [GuestAttributes].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<GuestAttributes> getGuestAttributes(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? queryPath,
    core.String? variableKey,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (queryPath != null) 'queryPath': [queryPath],
      if (variableKey != null) 'variableKey': [variableKey],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/getGuestAttributes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return GuestAttributes.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String zone,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the screenshot from the specified instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Screenshot].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Screenshot> getScreenshot(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/screenshot';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Screenshot.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the last 1 MB of serial port output from the specified instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [port] - Specifies which COM or serial port to retrieve data from.
  /// Value must be between "1" and "4".
  ///
  /// [start_1] - Specifies the starting byte position of the output to return.
  /// To start with the first byte of output to the specified port, omit this
  /// field or set it to `0`. If the output for that byte position is available,
  /// this field matches the `start` parameter sent with the request. If the
  /// amount of serial console output exceeds the size of the buffer (1 MB), the
  /// oldest output is discarded and is no longer available. If the requested
  /// start position refers to discarded output, the start position is adjusted
  /// to the oldest output still available, and the adjusted start position is
  /// returned as the `start` property value. You can also provide a negative
  /// start position, which translates to the most recent number of bytes
  /// written to the serial port. For example, -3 is interpreted as the most
  /// recent 3 bytes written to the serial console.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SerialPortOutput].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SerialPortOutput> getSerialPortOutput(
    core.String project,
    core.String zone,
    core.String instance, {
    core.int? port,
    core.String? start_1,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (port != null) 'port': ['${port}'],
      if (start_1 != null) 'start': [start_1],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/serialPort';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SerialPortOutput.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the Shielded Instance Identity of an instance
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name or id of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ShieldedInstanceIdentity].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ShieldedInstanceIdentity> getShieldedInstanceIdentity(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/getShieldedInstanceIdentity';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ShieldedInstanceIdentity.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an instance resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceInstanceTemplate] - Specifies instance template to create the
  /// instance. This field is optional. It can be a full or partial URL. For
  /// example, the following are all valid URLs to an instance template: -
  /// https://www.googleapis.com/compute/v1/projects/project
  /// /global/instanceTemplates/instanceTemplate -
  /// projects/project/global/instanceTemplates/instanceTemplate -
  /// global/instanceTemplates/instanceTemplate
  ///
  /// [sourceMachineImage] - Specifies the machine image to use to create the
  /// instance. This field is optional. It can be a full or partial URL. For
  /// example, the following are all valid URLs to a machine image: -
  /// https://www.googleapis.com/compute/v1/projects/project/global/global
  /// /machineImages/machineImage -
  /// projects/project/global/global/machineImages/machineImage -
  /// global/machineImages/machineImage
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Instance request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? sourceInstanceTemplate,
    core.String? sourceMachineImage,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceInstanceTemplate != null)
        'sourceInstanceTemplate': [sourceInstanceTemplate],
      if (sourceMachineImage != null)
        'sourceMachineImage': [sourceMachineImage],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of instances contained within the specified zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of resources that refer to the VM instance specified in
  /// the request.
  ///
  /// For example, if the VM instance is part of a managed or unmanaged instance
  /// group, the referrers list includes the instance group. For more
  /// information, read Viewing referrers to VM instances.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the target instance scoping this request, or '-' if
  /// the request should span over all instances in the container.
  /// Value must have pattern
  /// `-|\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceListReferrers].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceListReferrers> listReferrers(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/referrers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceListReferrers.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes resource policies from an instance.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeResourcePolicies(
    InstancesRemoveResourcePoliciesRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/removeResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Performs a reset on the instance.
  ///
  /// This is a hard reset. The VM does not do a graceful shutdown. For more
  /// information, see Resetting an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> reset(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/reset';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Resumes an instance that was suspended using the instances().suspend
  /// method.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to resume.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resume(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/resume';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sends diagnostic interrupt to the instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<void> sendDiagnosticInterrupt(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/sendDiagnosticInterrupt';

    await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
      downloadOptions: null,
    );
  }

  /// Sets deletion protection on the instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [deletionProtection] - Whether the resource should be protected against
  /// deletion.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setDeletionProtection(
    core.String project,
    core.String zone,
    core.String resource, {
    core.bool? deletionProtection,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (deletionProtection != null)
        'deletionProtection': ['${deletionProtection}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$resource') +
        '/setDeletionProtection';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the auto-delete flag for a disk attached to an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [autoDelete] - Whether to auto-delete the disk when the instance is
  /// deleted.
  ///
  /// [deviceName] - The device name of the disk to modify. Make a get() request
  /// on the instance to view currently attached disks and device names.
  /// Value must have pattern `\w\[\w.-\]{0,254}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setDiskAutoDelete(
    core.String project,
    core.String zone,
    core.String instance,
    core.bool autoDelete,
    core.String deviceName, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'autoDelete': ['${autoDelete}'],
      'deviceName': [deviceName],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setDiskAutoDelete';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    ZoneSetPolicyRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets labels on an instance.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    InstancesSetLabelsRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the number and/or type of accelerator for a stopped instance to
  /// the values specified in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setMachineResources(
    InstancesSetMachineResourcesRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setMachineResources';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the machine type for a stopped instance to the machine type
  /// specified in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setMachineType(
    InstancesSetMachineTypeRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setMachineType';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets metadata for the specified instance to the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setMetadata(
    Metadata request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setMetadata';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the minimum CPU platform that this instance should use.
  ///
  /// This method can only be called on a stopped instance. For more
  /// information, read Specifying a Minimum CPU Platform.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setMinCpuPlatform(
    InstancesSetMinCpuPlatformRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setMinCpuPlatform';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets an instance's scheduling options.
  ///
  /// You can only call this method on a stopped instance, that is, a VM
  /// instance that is in a `TERMINATED` state. See Instance Life Cycle for more
  /// information on the possible instance states. For more information about
  /// setting scheduling options for a VM, see Set VM host maintenance policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setScheduling(
    Scheduling request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setScheduling';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the service account on the instance.
  ///
  /// For more information, read Changing the service account and access scopes
  /// for an instance.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to start.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setServiceAccount(
    InstancesSetServiceAccountRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setServiceAccount';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the Shielded Instance integrity policy for an instance.
  ///
  /// You can only use this method on a running instance. This method supports
  /// PATCH semantics and uses the JSON merge patch format and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name or id of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setShieldedInstanceIntegrityPolicy(
    ShieldedInstanceIntegrityPolicy request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setShieldedInstanceIntegrityPolicy';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets network tags for the specified instance to the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setTags(
    Tags request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/setTags';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Simulates a host maintenance event on a VM.
  ///
  /// For more information, see Simulate a host maintenance event.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> simulateMaintenanceEvent(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/simulateMaintenanceEvent';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Starts an instance that was stopped using the instances().stop method.
  ///
  /// For more information, see Restart an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to start.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> start(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/start';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Starts an instance that was stopped using the instances().stop method.
  ///
  /// For more information, see Restart an instance.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to start.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> startWithEncryptionKey(
    InstancesStartWithEncryptionKeyRequest request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/startWithEncryptionKey';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Stops a running instance, shutting it down cleanly, and allows you to
  /// restart the instance at a later time.
  ///
  /// Stopped instances do not incur VM usage charges while they are stopped.
  /// However, resources that the VM is using, such as persistent disks and
  /// static IP addresses, will continue to be charged until they are deleted.
  /// For more information, see Stopping an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to stop.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> stop(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/stop';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// This method suspends a running instance, saving its state to persistent
  /// storage, and allows you to resume the instance at a later time.
  ///
  /// Suspended instances have no compute costs (cores or RAM), and incur only
  /// storage charges for the saved VM memory and localSSD data. Any charged
  /// resources the virtual machine was using, such as persistent disks and
  /// static IP addresses, will continue to be charged while the instance is
  /// suspended. For more information, see Suspending and resuming an instance.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to suspend.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> suspend(
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/suspend';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an instance only if the necessary resources are available.
  ///
  /// This method can update only a specific set of instance properties. See
  /// Updating a running instance for a list of updatable instance properties.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [minimalAction] - Specifies the action to take when updating an instance
  /// even if the updated properties do not require it. If not specified, then
  /// Compute Engine acts based on the minimum action that the updated
  /// properties require.
  /// Possible string values are:
  /// - "INVALID"
  /// - "NO_EFFECT" : No changes can be made to the instance.
  /// - "REFRESH" : The instance will not restart.
  /// - "RESTART" : The instance will restart.
  ///
  /// [mostDisruptiveAllowedAction] - Specifies the most disruptive action that
  /// can be taken on the instance as part of the update. Compute Engine returns
  /// an error if the instance properties require a more disruptive action as
  /// part of the instance update. Valid options from lowest to highest are
  /// NO_EFFECT, REFRESH, and RESTART.
  /// Possible string values are:
  /// - "INVALID"
  /// - "NO_EFFECT" : No changes can be made to the instance.
  /// - "REFRESH" : The instance will not restart.
  /// - "RESTART" : The instance will restart.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Instance request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? minimalAction,
    core.String? mostDisruptiveAllowedAction,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (minimalAction != null) 'minimalAction': [minimalAction],
      if (mostDisruptiveAllowedAction != null)
        'mostDisruptiveAllowedAction': [mostDisruptiveAllowedAction],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified access config from an instance's network interface
  /// with the data included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [networkInterface] - The name of the network interface where the access
  /// config is attached.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updateAccessConfig(
    AccessConfig request,
    core.String project,
    core.String zone,
    core.String instance,
    core.String networkInterface, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      'networkInterface': [networkInterface],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/updateAccessConfig';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the Display config for a VM instance.
  ///
  /// You can only use this method on a stopped VM instance. This method
  /// supports PATCH semantics and uses the JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name of the instance scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updateDisplayDevice(
    DisplayDevice request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/updateDisplayDevice';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an instance's network interface.
  ///
  /// This method can only update an interface's alias IP range and attached
  /// network. See Modifying alias IP ranges for an existing instance for
  /// instructions on changing alias IP ranges. See Migrating a VM between
  /// networks for instructions on migrating an interface. This method follows
  /// PATCH semantics.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - The instance name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [networkInterface] - The name of the network interface to update.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updateNetworkInterface(
    NetworkInterface request,
    core.String project,
    core.String zone,
    core.String instance,
    core.String networkInterface, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      'networkInterface': [networkInterface],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/updateNetworkInterface';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the Shielded Instance config for an instance.
  ///
  /// You can only use this method on a stopped instance. This method supports
  /// PATCH semantics and uses the JSON merge patch format and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [instance] - Name or id of the instance scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updateShieldedInstanceConfig(
    ShieldedInstanceConfig request,
    core.String project,
    core.String zone,
    core.String instance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/instances/' +
        commons.escapeVariable('$instance') +
        '/updateShieldedInstanceConfig';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class InterconnectAttachmentsResource {
  final commons.ApiRequester _requester;

  InterconnectAttachmentsResource(commons.ApiRequester client)
      : _requester = client;

  /// Retrieves an aggregated list of interconnect attachments.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectAttachmentAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectAttachmentAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/interconnectAttachments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectAttachmentAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified interconnect attachment.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [interconnectAttachment] - Name of the interconnect attachment to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String interconnectAttachment, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments/' +
        commons.escapeVariable('$interconnectAttachment');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified interconnect attachment.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [interconnectAttachment] - Name of the interconnect attachment to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectAttachment].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectAttachment> get(
    core.String project,
    core.String region,
    core.String interconnectAttachment, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments/' +
        commons.escapeVariable('$interconnectAttachment');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectAttachment.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an InterconnectAttachment in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    InterconnectAttachment request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of interconnect attachments contained within the
  /// specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectAttachmentList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectAttachmentList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectAttachmentList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified interconnect attachment with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [interconnectAttachment] - Name of the interconnect attachment to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    InterconnectAttachment request,
    core.String project,
    core.String region,
    core.String interconnectAttachment, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments/' +
        commons.escapeVariable('$interconnectAttachment');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on an InterconnectAttachment.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/interconnectAttachments/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class InterconnectLocationsResource {
  final commons.ApiRequester _requester;

  InterconnectLocationsResource(commons.ApiRequester client)
      : _requester = client;

  /// Returns the details for the specified interconnect location.
  ///
  /// Gets a list of available interconnect locations by making a list()
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [interconnectLocation] - Name of the interconnect location to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectLocation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectLocation> get(
    core.String project,
    core.String interconnectLocation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnectLocations/' +
        commons.escapeVariable('$interconnectLocation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectLocation.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of interconnect locations available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectLocationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectLocationList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnectLocations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectLocationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class InterconnectsResource {
  final commons.ApiRequester _requester;

  InterconnectsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified interconnect.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [interconnect] - Name of the interconnect to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String interconnect, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects/' +
        commons.escapeVariable('$interconnect');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified interconnect.
  ///
  /// Get a list of available interconnects by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [interconnect] - Name of the interconnect to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Interconnect].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Interconnect> get(
    core.String project,
    core.String interconnect, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects/' +
        commons.escapeVariable('$interconnect');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Interconnect.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the interconnectDiagnostics for the specified interconnect.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [interconnect] - Name of the interconnect resource to query.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectsGetDiagnosticsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectsGetDiagnosticsResponse> getDiagnostics(
    core.String project,
    core.String interconnect, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects/' +
        commons.escapeVariable('$interconnect') +
        '/getDiagnostics';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectsGetDiagnosticsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a Interconnect in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Interconnect request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of interconnect available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InterconnectList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InterconnectList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InterconnectList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified interconnect with the data included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [interconnect] - Name of the interconnect to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Interconnect request,
    core.String project,
    core.String interconnect, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects/' +
        commons.escapeVariable('$interconnect');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on an Interconnect.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/interconnects/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class LicenseCodesResource {
  final commons.ApiRequester _requester;

  LicenseCodesResource(commons.ApiRequester client) : _requester = client;

  /// Return a specified license code.
  ///
  /// License codes are mirrored across all projects that have permissions to
  /// read the License Code. *Caution* This resource is intended for use only by
  /// third-party partners who are creating Cloud Marketplace images.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [licenseCode] - Number corresponding to the License code resource to
  /// return.
  /// Value must have pattern `\[0-9\]{0,61}?`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [LicenseCode].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<LicenseCode> get(
    core.String project,
    core.String licenseCode, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenseCodes/' +
        commons.escapeVariable('$licenseCode');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return LicenseCode.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// *Caution* This resource is intended for use only by third-party partners
  /// who are creating Cloud Marketplace images.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenseCodes/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class LicensesResource {
  final commons.ApiRequester _requester;

  LicensesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified license.
  ///
  /// *Caution* This resource is intended for use only by third-party partners
  /// who are creating Cloud Marketplace images.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [license] - Name of the license resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String license, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenses/' +
        commons.escapeVariable('$license');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified License resource.
  ///
  /// *Caution* This resource is intended for use only by third-party partners
  /// who are creating Cloud Marketplace images.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [license] - Name of the License resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [License].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<License> get(
    core.String project,
    core.String license, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenses/' +
        commons.escapeVariable('$license');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return License.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists. *Caution* This resource
  /// is intended for use only by third-party partners who are creating Cloud
  /// Marketplace images.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenses/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Create a License resource in the specified project.
  ///
  /// *Caution* This resource is intended for use only by third-party partners
  /// who are creating Cloud Marketplace images.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    License request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/licenses';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of licenses available in the specified project.
  ///
  /// This method does not get any licenses that belong to other projects,
  /// including licenses attached to publicly-available images, like Debian 9.
  /// If you want to get a list of publicly-available licenses, use this method
  /// to make a request to the respective image project, such as debian-cloud or
  /// windows-cloud. *Caution* This resource is intended for use only by
  /// third-party partners who are creating Cloud Marketplace images.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [LicensesListResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<LicensesListResponse> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/licenses';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return LicensesListResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy. *Caution* This resource is intended for use
  /// only by third-party partners who are creating Cloud Marketplace images.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenses/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// *Caution* This resource is intended for use only by third-party partners
  /// who are creating Cloud Marketplace images.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/licenses/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class MachineImagesResource {
  final commons.ApiRequester _requester;

  MachineImagesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified machine image.
  ///
  /// Deleting a machine image is permanent and cannot be undone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [machineImage] - The name of the machine image to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String machineImage, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages/' +
        commons.escapeVariable('$machineImage');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified machine image.
  ///
  /// Gets a list of available machine images by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [machineImage] - The name of the machine image.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [MachineImage].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<MachineImage> get(
    core.String project,
    core.String machineImage, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages/' +
        commons.escapeVariable('$machineImage');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return MachineImage.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a machine image in the specified project using the data that is
  /// included in the request.
  ///
  /// If you are creating a new machine image to update an existing instance,
  /// your new machine image should use the same network or, if applicable, the
  /// same subnetwork as the original instance.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceInstance] - Required. Source instance that is used to create the
  /// machine image from.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    MachineImage request,
    core.String project, {
    core.String? requestId,
    core.String? sourceInstance,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceInstance != null) 'sourceInstance': [sourceInstance],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of machine images that are contained within the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [MachineImageList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<MachineImageList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return MachineImageList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/machineImages/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class MachineTypesResource {
  final commons.ApiRequester _requester;

  MachineTypesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of machine types.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [MachineTypeAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<MachineTypeAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/machineTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return MachineTypeAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified machine type.
  ///
  /// Gets a list of available machine types by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [machineType] - Name of the machine type to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [MachineType].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<MachineType> get(
    core.String project,
    core.String zone,
    core.String machineType, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/machineTypes/' +
        commons.escapeVariable('$machineType');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return MachineType.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of machine types available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [MachineTypeList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<MachineTypeList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/machineTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return MachineTypeList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class NetworkEdgeSecurityServicesResource {
  final commons.ApiRequester _requester;

  NetworkEdgeSecurityServicesResource(commons.ApiRequester client)
      : _requester = client;

  /// Retrieves the list of all NetworkEdgeSecurityService resources available
  /// to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEdgeSecurityServiceAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEdgeSecurityServiceAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/networkEdgeSecurityServices';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEdgeSecurityServiceAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified service.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [networkEdgeSecurityService] - Name of the network edge security service
  /// to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String networkEdgeSecurityService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEdgeSecurityServices/' +
        commons.escapeVariable('$networkEdgeSecurityService');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets a specified NetworkEdgeSecurityService.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [networkEdgeSecurityService] - Name of the network edge security service
  /// to get.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEdgeSecurityService].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEdgeSecurityService> get(
    core.String project,
    core.String region,
    core.String networkEdgeSecurityService, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEdgeSecurityServices/' +
        commons.escapeVariable('$networkEdgeSecurityService');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEdgeSecurityService.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new service in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NetworkEdgeSecurityService request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEdgeSecurityServices';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [networkEdgeSecurityService] - Name of the network edge security service
  /// to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [paths] - null
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [updateMask] - Indicates fields to be updated as part of this request.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    NetworkEdgeSecurityService request,
    core.String project,
    core.String region,
    core.String networkEdgeSecurityService, {
    core.List<core.String>? paths,
    core.String? requestId,
    core.String? updateMask,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (paths != null) 'paths': paths,
      if (requestId != null) 'requestId': [requestId],
      if (updateMask != null) 'updateMask': [updateMask],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEdgeSecurityServices/' +
        commons.escapeVariable('$networkEdgeSecurityService');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class NetworkEndpointGroupsResource {
  final commons.ApiRequester _requester;

  NetworkEndpointGroupsResource(commons.ApiRequester client)
      : _requester = client;

  /// Retrieves the list of network endpoint groups and sorts them by zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Attach a list of network endpoints to the specified network endpoint
  /// group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group where you
  /// are attaching network endpoints to. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> attachNetworkEndpoints(
    NetworkEndpointGroupsAttachEndpointsRequest request,
    core.String project,
    core.String zone,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/attachNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified network endpoint group.
  ///
  /// The network endpoints in the NEG and the VM instances they belong to are
  /// not terminated when the NEG is deleted. Note that the NEG cannot be
  /// deleted if there are backend services referencing it.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group to delete.
  /// It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Detach a list of network endpoints from the specified network endpoint
  /// group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group where you
  /// are removing network endpoints. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> detachNetworkEndpoints(
    NetworkEndpointGroupsDetachEndpointsRequest request,
    core.String project,
    core.String zone,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/detachNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network endpoint group.
  ///
  /// Gets a list of available network endpoint groups by making a list()
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group. It should
  /// comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroup> get(
    core.String project,
    core.String zone,
    core.String networkEndpointGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroup.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a network endpoint group in the specified project using the
  /// parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where you want to create the network
  /// endpoint group. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NetworkEndpointGroup request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of network endpoint groups that are located in the
  /// specified project and zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the network endpoints in the specified network endpoint group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone where the network endpoint group is located.
  /// It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group from which
  /// you want to generate a list of included network endpoints. It should
  /// comply with RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupsListNetworkEndpoints].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupsListNetworkEndpoints> listNetworkEndpoints(
    NetworkEndpointGroupsListEndpointsRequest request,
    core.String project,
    core.String zone,
    core.String networkEndpointGroup, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup') +
        '/listNetworkEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupsListNetworkEndpoints.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class NetworkFirewallPoliciesResource {
  final commons.ApiRequester _requester;

  NetworkFirewallPoliciesResource(commons.ApiRequester client)
      : _requester = client;

  /// Inserts an association for the specified firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [replaceExistingAssociation] - Indicates whether or not to replace it if
  /// an association of the attachment already exists. This is false by default,
  /// in which case an error will be returned if an association already exists.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addAssociation(
    FirewallPolicyAssociation request,
    core.String project,
    core.String firewallPolicy, {
    core.bool? replaceExistingAssociation,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (replaceExistingAssociation != null)
        'replaceExistingAssociation': ['${replaceExistingAssociation}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts a rule into a firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [maxPriority] - When rule.priority is not specified, auto choose a unused
  /// priority between minPriority and maxPriority\>. This field is exclusive
  /// with rule.priority.
  ///
  /// [minPriority] - When rule.priority is not specified, auto choose a unused
  /// priority between minPriority and maxPriority\>. This field is exclusive
  /// with rule.priority.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addRule(
    FirewallPolicyRule request,
    core.String project,
    core.String firewallPolicy, {
    core.int? maxPriority,
    core.int? minPriority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (maxPriority != null) 'maxPriority': ['${maxPriority}'],
      if (minPriority != null) 'minPriority': ['${minPriority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Copies rules to the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceFirewallPolicy] - The firewall policy from which to copy rules.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> cloneRules(
    core.String project,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? sourceFirewallPolicy,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceFirewallPolicy != null)
        'sourceFirewallPolicy': [sourceFirewallPolicy],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/cloneRules';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to get.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicy> get(
    core.String project,
    core.String firewallPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets an association with the specified name.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried
  /// association belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [name] - The name of the association to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyAssociation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyAssociation> getAssociation(
    core.String project,
    core.String firewallPolicy, {
    core.String? name,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getAssociation';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyAssociation.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried rule
  /// belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyRule> getRule(
    core.String project,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getRule';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new policy in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    FirewallPolicy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the policies that have been configured for the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    FirewallPolicy request,
    core.String project,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches a rule of the specified priority.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to patch.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchRule(
    FirewallPolicyRule request,
    core.String project,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/patchRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes an association for the specified firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [name] - Name for the attachment that will be removed.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeAssociation(
    core.String project,
    core.String firewallPolicy, {
    core.String? name,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to remove from the firewall policy.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeRule(
    core.String project,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class NetworksResource {
  final commons.ApiRequester _requester;

  NetworksResource(commons.ApiRequester client) : _requester = client;

  /// Adds a peering to the specified network.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network resource to add peering to.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addPeering(
    NetworksAddPeeringRequest request,
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/addPeering';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified network.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network.
  ///
  /// Gets a list of available networks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Network].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Network> get(
    core.String project,
    core.String network, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Network.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the effective firewalls on a given network.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworksGetEffectiveFirewallsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworksGetEffectiveFirewallsResponse> getEffectiveFirewalls(
    core.String project,
    core.String network, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/getEffectiveFirewalls';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworksGetEffectiveFirewallsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a network in the specified project using the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Network request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/networks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of networks available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/networks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the peering routes exchanged over peering connection.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [direction] - The direction of the exchanged routes.
  /// Possible string values are:
  /// - "INCOMING" : For routes exported from peer network.
  /// - "OUTGOING" : For routes exported from local network.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [peeringName] - The response will show routes exchanged over the given
  /// peering connection.
  ///
  /// [region] - The region of the request. The response will include all subnet
  /// routes, static routes and dynamic routes in the region.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ExchangedPeeringRoutesList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ExchangedPeeringRoutesList> listPeeringRoutes(
    core.String project,
    core.String network, {
    core.String? direction,
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.String? peeringName,
    core.String? region,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (direction != null) 'direction': [direction],
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (peeringName != null) 'peeringName': [peeringName],
      if (region != null) 'region': [region],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/listPeeringRoutes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ExchangedPeeringRoutesList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified network with the data included in the request.
  ///
  /// Only the following fields can be modified: routingConfig.routingMode.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Network request,
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes a peering from the specified network.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network resource to remove peering from.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removePeering(
    NetworksRemovePeeringRequest request,
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/removePeering';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Switches the network mode from auto subnet mode to custom subnet mode.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network to be updated.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> switchToCustomMode(
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/switchToCustomMode';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified network peering with the data included in the
  /// request.
  ///
  /// You can only modify the NetworkPeering.export_custom_routes field and the
  /// NetworkPeering.import_custom_routes field.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [network] - Name of the network resource which the updated peering is
  /// belonging to.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updatePeering(
    NetworksUpdatePeeringRequest request,
    core.String project,
    core.String network, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/networks/' +
        commons.escapeVariable('$network') +
        '/updatePeering';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class NodeGroupsResource {
  final commons.ApiRequester _requester;

  NodeGroupsResource(commons.ApiRequester client) : _requester = client;

  /// Adds specified number of nodes to the node group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addNodes(
    NodeGroupsAddNodesRequest request,
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup') +
        '/addNodes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves an aggregated list of node groups.
  ///
  /// Note: use nodeGroups.listNodes for more details about each group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeGroupAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeGroupAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/nodeGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeGroupAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified NodeGroup resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes specified nodes from the node group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource whose nodes will be deleted.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteNodes(
    NodeGroupsDeleteNodesRequest request,
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup') +
        '/deleteNodes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified NodeGroup.
  ///
  /// Get a list of available NodeGroups by making a list() request. Note: the
  /// "nodes" field should not be used. Use nodeGroups.listNodes instead.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the node group to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeGroup> get(
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeGroup.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String zone,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a NodeGroup resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [initialNodeCount] - Initial count of nodes in the node group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NodeGroup request,
    core.String project,
    core.String zone,
    core.int initialNodeCount, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      'initialNodeCount': ['${initialNodeCount}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of node groups available to the specified project.
  ///
  /// Note: use nodeGroups.listNodes for more details about each group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeGroupList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists nodes in the node group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource whose nodes you want to list.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeGroupsListNodes].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeGroupsListNodes> listNodes(
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup') +
        '/listNodes';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return NodeGroupsListNodes.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified node group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    NodeGroup request,
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    ZoneSetPolicyRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the node template of the node group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeGroup] - Name of the NodeGroup resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setNodeTemplate(
    NodeGroupsSetNodeTemplateRequest request,
    core.String project,
    core.String zone,
    core.String nodeGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$nodeGroup') +
        '/setNodeTemplate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeGroups/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class NodeTemplatesResource {
  final commons.ApiRequester _requester;

  NodeTemplatesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of node templates.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeTemplateAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeTemplateAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/nodeTemplates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeTemplateAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified NodeTemplate resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeTemplate] - Name of the NodeTemplate resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String nodeTemplate, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates/' +
        commons.escapeVariable('$nodeTemplate');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified node template.
  ///
  /// Gets a list of available node templates by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeTemplate] - Name of the node template to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeTemplate].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeTemplate> get(
    core.String project,
    core.String region,
    core.String nodeTemplate, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates/' +
        commons.escapeVariable('$nodeTemplate');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeTemplate.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a NodeTemplate resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NodeTemplate request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of node templates available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeTemplateList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeTemplateList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeTemplateList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/nodeTemplates/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class NodeTypesResource {
  final commons.ApiRequester _requester;

  NodeTypesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of node types.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeTypeAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeTypeAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/nodeTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeTypeAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified node type.
  ///
  /// Gets a list of available node types by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [nodeType] - Name of the node type to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeType].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeType> get(
    core.String project,
    core.String zone,
    core.String nodeType, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeTypes/' +
        commons.escapeVariable('$nodeType');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeType.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of node types available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NodeTypeList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NodeTypeList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/nodeTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NodeTypeList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class PacketMirroringsResource {
  final commons.ApiRequester _requester;

  PacketMirroringsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of packetMirrorings.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PacketMirroringAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PacketMirroringAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/packetMirrorings';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PacketMirroringAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified PacketMirroring resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [packetMirroring] - Name of the PacketMirroring resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String packetMirroring, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings/' +
        commons.escapeVariable('$packetMirroring');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified PacketMirroring resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [packetMirroring] - Name of the PacketMirroring resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PacketMirroring].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PacketMirroring> get(
    core.String project,
    core.String region,
    core.String packetMirroring, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings/' +
        commons.escapeVariable('$packetMirroring');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PacketMirroring.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a PacketMirroring resource in the specified project and region
  /// using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    PacketMirroring request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of PacketMirroring resources available to the specified
  /// project and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PacketMirroringList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PacketMirroringList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PacketMirroringList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified PacketMirroring resource with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [packetMirroring] - Name of the PacketMirroring resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    PacketMirroring request,
    core.String project,
    core.String region,
    core.String packetMirroring, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings/' +
        commons.escapeVariable('$packetMirroring');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/packetMirrorings/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class ProjectsResource {
  final commons.ApiRequester _requester;

  ProjectsResource(commons.ApiRequester client) : _requester = client;

  /// Disable this project as a shared VPC host project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> disableXpnHost(
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/disableXpnHost';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Disable a service resource (also known as service project) associated with
  /// this host project.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> disableXpnResource(
    ProjectsDisableXpnResourceRequest request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/disableXpnResource';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Enable this project as a shared VPC host project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> enableXpnHost(
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/enableXpnHost';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Enable service resource (a.k.a service project) for a host project, so
  /// that subnets in the host project can be used by instances in the service
  /// project.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> enableXpnResource(
    ProjectsEnableXpnResourceRequest request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/enableXpnResource';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified Project resource.
  ///
  /// To decrease latency for this method, you can optionally omit any unneeded
  /// information from the response by using a field mask. This practice is
  /// especially recommended for unused quota information (the `quotas` field).
  /// To exclude one or more fields, set your request's `fields` query parameter
  /// to only include the fields you need. For example, to only include the `id`
  /// and `selfLink` fields, add the query parameter `?fields=id,selfLink` to
  /// your request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Project].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Project> get(
    core.String project, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' + commons.escapeVariable('$project');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Project.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the shared VPC host project that this project links to.
  ///
  /// May be empty if no link exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Project].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Project> getXpnHost(
    core.String project, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/getXpnHost';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Project.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets service resources (a.k.a service project) associated with this host
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ProjectsGetXpnResources].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ProjectsGetXpnResources> getXpnResources(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/getXpnResources';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ProjectsGetXpnResources.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all shared VPC host projects visible to the user in an organization.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [XpnHostList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<XpnHostList> listXpnHosts(
    ProjectsListXpnHostsRequest request,
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/listXpnHosts';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return XpnHostList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Moves a persistent disk from one zone to another.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> moveDisk(
    DiskMoveRequest request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' + commons.escapeVariable('$project') + '/moveDisk';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Moves an instance and its attached persistent disks from one zone to
  /// another.
  ///
  /// *Note*: Moving VMs or disks by using this method might cause unexpected
  /// behavior. For more information, see the \[known
  /// issue\](/compute/docs/troubleshooting/known-issues#moving_vms_or_disks_using_the_moveinstance_api_or_the_causes_unexpected_behavior).
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> moveInstance(
    InstanceMoveRequest request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/moveInstance';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets metadata common to all instances within the specified project using
  /// the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setCommonInstanceMetadata(
    Metadata request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/setCommonInstanceMetadata';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the default network tier of the project.
  ///
  /// The default network tier is used when an address/forwardingRule/instance
  /// is created without specifying the network tier field.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setDefaultNetworkTier(
    ProjectsSetDefaultNetworkTierRequest request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/setDefaultNetworkTier';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Enables the usage export feature and sets the usage export bucket where
  /// reports are stored.
  ///
  /// If you provide an empty request body using this method, the usage export
  /// feature will be disabled.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setUsageExportBucket(
    UsageExportLocation request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/setUsageExportBucket';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class PublicAdvertisedPrefixesResource {
  final commons.ApiRequester _requester;

  PublicAdvertisedPrefixesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified PublicAdvertisedPrefix
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicAdvertisedPrefix] - Name of the PublicAdvertisedPrefix resource to
  /// delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String publicAdvertisedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicAdvertisedPrefixes/' +
        commons.escapeVariable('$publicAdvertisedPrefix');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified PublicAdvertisedPrefix resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicAdvertisedPrefix] - Name of the PublicAdvertisedPrefix resource to
  /// return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicAdvertisedPrefix].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicAdvertisedPrefix> get(
    core.String project,
    core.String publicAdvertisedPrefix, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicAdvertisedPrefixes/' +
        commons.escapeVariable('$publicAdvertisedPrefix');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicAdvertisedPrefix.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a PublicAdvertisedPrefix in the specified project using the
  /// parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    PublicAdvertisedPrefix request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicAdvertisedPrefixes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the PublicAdvertisedPrefixes for a project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicAdvertisedPrefixList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicAdvertisedPrefixList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicAdvertisedPrefixes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicAdvertisedPrefixList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified Router resource with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [publicAdvertisedPrefix] - Name of the PublicAdvertisedPrefix resource to
  /// patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    PublicAdvertisedPrefix request,
    core.String project,
    core.String publicAdvertisedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/publicAdvertisedPrefixes/' +
        commons.escapeVariable('$publicAdvertisedPrefix');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class PublicDelegatedPrefixesResource {
  final commons.ApiRequester _requester;

  PublicDelegatedPrefixesResource(commons.ApiRequester client)
      : _requester = client;

  /// Lists all PublicDelegatedPrefix resources owned by the specific project
  /// across all scopes.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicDelegatedPrefixAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicDelegatedPrefixAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/publicDelegatedPrefixes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicDelegatedPrefixAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified PublicDelegatedPrefix in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String publicDelegatedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified PublicDelegatedPrefix resource in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicDelegatedPrefix].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicDelegatedPrefix> get(
    core.String project,
    core.String region,
    core.String publicDelegatedPrefix, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicDelegatedPrefix.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a PublicDelegatedPrefix in the specified project in the given
  /// region using the parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    PublicDelegatedPrefix request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/publicDelegatedPrefixes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the PublicDelegatedPrefixes for a project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [PublicDelegatedPrefixList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<PublicDelegatedPrefixList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/publicDelegatedPrefixes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return PublicDelegatedPrefixList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified PublicDelegatedPrefix resource with the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [publicDelegatedPrefix] - Name of the PublicDelegatedPrefix resource to
  /// patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    PublicDelegatedPrefix request,
    core.String project,
    core.String region,
    core.String publicDelegatedPrefix, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/publicDelegatedPrefixes/' +
        commons.escapeVariable('$publicDelegatedPrefix');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionAutoscalersResource {
  final commons.ApiRequester _requester;

  RegionAutoscalersResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified autoscaler.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String autoscaler, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers/' +
        commons.escapeVariable('$autoscaler');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified autoscaler.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Autoscaler].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Autoscaler> get(
    core.String project,
    core.String region,
    core.String autoscaler, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers/' +
        commons.escapeVariable('$autoscaler');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Autoscaler.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Autoscaler request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of autoscalers contained within the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionAutoscalerList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionAutoscalerList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionAutoscalerList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Autoscaler request,
    core.String project,
    core.String region, {
    core.String? autoscaler,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (autoscaler != null) 'autoscaler': [autoscaler],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates an autoscaler in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [autoscaler] - Name of the autoscaler to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Autoscaler request,
    core.String project,
    core.String region, {
    core.String? autoscaler,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (autoscaler != null) 'autoscaler': [autoscaler],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/autoscalers';

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionBackendServicesResource {
  final commons.ApiRequester _requester;

  RegionBackendServicesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified regional BackendService resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [backendService] - Name of the BackendService resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified regional BackendService resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [backendService] - Name of the BackendService resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendService].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendService> get(
    core.String project,
    core.String region,
    core.String backendService, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendService.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the most recent health check results for this regional
  /// BackendService.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - null
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [backendService] - Name of the BackendService resource for which to get
  /// health.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendServiceGroupHealth].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendServiceGroupHealth> getHealth(
    ResourceGroupReference request,
    core.String project,
    core.String region,
    core.String backendService, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$backendService') +
        '/getHealth';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return BackendServiceGroupHealth.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a regional BackendService resource in the specified project using
  /// the data included in the request.
  ///
  /// For more information, see Backend services overview.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    BackendService request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of regional BackendService resources available to the
  /// specified project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [BackendServiceList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<BackendServiceList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return BackendServiceList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified regional BackendService resource with the data
  /// included in the request.
  ///
  /// For more information, see Understanding backend services This method
  /// supports PATCH semantics and uses the JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [backendService] - Name of the BackendService resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    BackendService request,
    core.String project,
    core.String region,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified regional BackendService resource with the data
  /// included in the request.
  ///
  /// For more information, see Backend services overview .
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [backendService] - Name of the BackendService resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    BackendService request,
    core.String project,
    core.String region,
    core.String backendService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/backendServices/' +
        commons.escapeVariable('$backendService');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionCommitmentsResource {
  final commons.ApiRequester _requester;

  RegionCommitmentsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of commitments by region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [CommitmentAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<CommitmentAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/commitments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return CommitmentAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified commitment resource.
  ///
  /// Gets a list of available commitments by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [commitment] - Name of the commitment to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Commitment].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Commitment> get(
    core.String project,
    core.String region,
    core.String commitment, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/commitments/' +
        commons.escapeVariable('$commitment');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Commitment.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a commitment in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Commitment request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/commitments';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of commitments contained within the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [CommitmentList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<CommitmentList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/commitments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return CommitmentList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified commitment with the data included in the request.
  ///
  /// Update is performed only on selected fields included as part of
  /// update-mask. Only the following fields can be modified: auto_renew.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [commitment] - Name of the commitment for which auto renew is being
  /// updated.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [paths] - null
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [updateMask] - update_mask indicates fields to be updated as part of this
  /// request.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Commitment request,
    core.String project,
    core.String region,
    core.String commitment, {
    core.List<core.String>? paths,
    core.String? requestId,
    core.String? updateMask,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (paths != null) 'paths': paths,
      if (requestId != null) 'requestId': [requestId],
      if (updateMask != null) 'updateMask': [updateMask],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/commitments/' +
        commons.escapeVariable('$commitment');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionDiskTypesResource {
  final commons.ApiRequester _requester;

  RegionDiskTypesResource(commons.ApiRequester client) : _requester = client;

  /// Returns the specified regional disk type.
  ///
  /// Gets a list of available disk types by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [diskType] - Name of the disk type to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskType].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskType> get(
    core.String project,
    core.String region,
    core.String diskType, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/diskTypes/' +
        commons.escapeVariable('$diskType');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskType.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of regional disk types available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionDiskTypeList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionDiskTypeList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/diskTypes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionDiskTypeList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionDisksResource {
  final commons.ApiRequester _requester;

  RegionDisksResource(commons.ApiRequester client) : _requester = client;

  /// Adds existing resource policies to a regional disk.
  ///
  /// You can only add one policy which will be applied to this disk for
  /// scheduling snapshot creation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - The disk name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addResourcePolicies(
    RegionDisksAddResourcePoliciesRequest request,
    core.String project,
    core.String region,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/addResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a snapshot of a specified persistent disk.
  ///
  /// For regular snapshot creation, consider using snapshots.insert instead, as
  /// that method supports more features, such as creating snapshots in a
  /// project different from the source disk project.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the regional persistent disk to snapshot.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> createSnapshot(
    Snapshot request,
    core.String project,
    core.String region,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/createSnapshot';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified regional persistent disk.
  ///
  /// Deleting a regional disk removes all the replicas of its data permanently
  /// and is irreversible. However, deleting a disk does not delete any
  /// snapshots previously made from the disk. You must separately delete
  /// snapshots.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the regional persistent disk to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns a specified regional persistent disk.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the regional persistent disk to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Disk].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Disk> get(
    core.String project,
    core.String region,
    core.String disk, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Disk.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a persistent regional disk in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceImage] - Source image to restore onto a disk. This field is
  /// optional.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Disk request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? sourceImage,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceImage != null) 'sourceImage': [sourceImage],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of persistent disks contained within the specified
  /// region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [DiskList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<DiskList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return DiskList.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes resource policies from a regional disk.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - The disk name for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeResourcePolicies(
    RegionDisksRemoveResourcePoliciesRequest request,
    core.String project,
    core.String region,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/removeResourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Resizes the specified regional persistent disk.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - The project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [disk] - Name of the regional persistent disk.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resize(
    RegionDisksResizeRequest request,
    core.String project,
    core.String region,
    core.String disk, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$disk') +
        '/resize';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on the target regional disk.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/disks/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionHealthCheckServicesResource {
  final commons.ApiRequester _requester;

  RegionHealthCheckServicesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified regional HealthCheckService.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheckService] - Name of the HealthCheckService to delete. The name
  /// must be 1-63 characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String healthCheckService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthCheckServices/' +
        commons.escapeVariable('$healthCheckService');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified regional HealthCheckService resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheckService] - Name of the HealthCheckService to update. The name
  /// must be 1-63 characters long, and comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheckService].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheckService> get(
    core.String project,
    core.String region,
    core.String healthCheckService, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthCheckServices/' +
        commons.escapeVariable('$healthCheckService');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheckService.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a regional HealthCheckService resource in the specified project
  /// and region using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    HealthCheckService request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthCheckServices';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the HealthCheckService resources that have been configured for
  /// the specified project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheckServicesList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheckServicesList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthCheckServices';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheckServicesList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified regional HealthCheckService resource with the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheckService] - Name of the HealthCheckService to update. The name
  /// must be 1-63 characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    HealthCheckService request,
    core.String project,
    core.String region,
    core.String healthCheckService, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthCheckServices/' +
        commons.escapeVariable('$healthCheckService');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionHealthChecksResource {
  final commons.ApiRequester _requester;

  RegionHealthChecksResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified HealthCheck resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified HealthCheck resource.
  ///
  /// Gets a list of available health checks by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheck].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheck> get(
    core.String project,
    core.String region,
    core.String healthCheck, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheck.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    HealthCheck request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of HealthCheck resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [HealthCheckList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<HealthCheckList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return HealthCheckList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    HealthCheck request,
    core.String project,
    core.String region,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a HealthCheck resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [healthCheck] - Name of the HealthCheck resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    HealthCheck request,
    core.String project,
    core.String region,
    core.String healthCheck, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/healthChecks/' +
        commons.escapeVariable('$healthCheck');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionInstanceGroupManagersResource {
  final commons.ApiRequester _requester;

  RegionInstanceGroupManagersResource(commons.ApiRequester client)
      : _requester = client;

  /// Flags the specified instances to be immediately removed from the managed
  /// instance group.
  ///
  /// Abandoning an instance does not delete the instance, but it does remove
  /// the instance from any target pools that are applied by the managed
  /// instance group. This method reduces the targetSize of the managed instance
  /// group by the number of instances that you abandon. This operation is
  /// marked as DONE when the action is scheduled even if the instances have not
  /// yet been removed from the group. You must separately verify the status of
  /// the abandoning action with the listmanagedinstances method. If the group
  /// is part of a backend service that has enabled connection draining, it can
  /// take up to 60 seconds after the connection draining duration has elapsed
  /// before the VM instance is removed or deleted. You can specify a maximum of
  /// 1000 instances with this method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> abandonInstances(
    RegionInstanceGroupManagersAbandonInstancesRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/abandonInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Apply updates to selected instances the managed instance group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request, should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group, should
  /// conform to RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> applyUpdatesToInstances(
    RegionInstanceGroupManagersApplyUpdatesRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/applyUpdatesToInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates instances with per-instance configurations in this regional
  /// managed instance group.
  ///
  /// Instances are created using the current instance template. The create
  /// instances operation is marked DONE if the createInstances request is
  /// successful. The underlying actions take additional time. You must
  /// separately verify the status of the creating or actions with the
  /// listmanagedinstances method.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region where the managed instance group is
  /// located. It should conform to RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. The request ID must
  /// be a valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> createInstances(
    RegionInstanceGroupManagersCreateInstancesRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/createInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified managed instance group and all of the instances in
  /// that group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group to delete.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Flags the specified instances in the managed instance group to be
  /// immediately deleted.
  ///
  /// The instances are also removed from any target pools of which they were a
  /// member. This method reduces the targetSize of the managed instance group
  /// by the number of instances that you delete. The deleteInstances operation
  /// is marked DONE if the deleteInstances request is successful. The
  /// underlying actions take additional time. You must separately verify the
  /// status of the deleting action with the listmanagedinstances method. If the
  /// group is part of a backend service that has enabled connection draining,
  /// it can take up to 60 seconds after the connection draining duration has
  /// elapsed before the VM instance is removed or deleted. You can specify a
  /// maximum of 1000 instances with this method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deleteInstances(
    RegionInstanceGroupManagersDeleteInstancesRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/deleteInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes selected per-instance configurations for the managed instance
  /// group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request, should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> deletePerInstanceConfigs(
    RegionInstanceGroupManagerDeleteInstanceConfigReq request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/deletePerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns all of the details about the specified managed instance group.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group to return.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroupManager].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroupManager> get(
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroupManager.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a managed instance group using the information that you specify in
  /// the request.
  ///
  /// After the group is created, instances in the group are created using the
  /// specified instance template. This operation is marked as DONE when the
  /// group is created even if the instances in the group have not yet been
  /// created. You must separately verify the status of the individual instances
  /// with the listmanagedinstances method. A regional managed instance group
  /// can contain up to 2000 instances.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    InstanceGroupManager request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of managed instance groups that are contained within
  /// the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupManagerList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupManagerList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionInstanceGroupManagerList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all errors thrown by actions on instances for a given regional
  /// managed instance group.
  ///
  /// The filter and orderBy query parameters are not supported.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request. This should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It must
  /// be a string that meets the requirements in RFC1035, or an unsigned long
  /// integer: must match regexp pattern:
  /// (?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?)|1-9{0,19}.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupManagersListErrorsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupManagersListErrorsResponse> listErrors(
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listErrors';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionInstanceGroupManagersListErrorsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the instances in the managed instance group and instances that are
  /// scheduled to be created.
  ///
  /// The list includes any current actions that the group has scheduled for its
  /// instances. The orderBy query parameter is not supported. The `pageToken`
  /// query parameter is supported only in the alpha and beta API and only if
  /// the group's `listManagedInstancesResults` field is set to `PAGINATED`.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupManagersListInstancesResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupManagersListInstancesResponse>
      listManagedInstances(
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listManagedInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return RegionInstanceGroupManagersListInstancesResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all of the per-instance configurations defined for the managed
  /// instance group.
  ///
  /// The orderBy query parameter is not supported.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request, should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupManagersListInstanceConfigsResp].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupManagersListInstanceConfigsResp>
      listPerInstanceConfigs(
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/listPerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return RegionInstanceGroupManagersListInstanceConfigsResp.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates a managed instance group using the information that you specify in
  /// the request.
  ///
  /// This operation is marked as DONE when the group is patched even if the
  /// instances in the group are still in the process of being patched. You must
  /// separately verify the status of the individual instances with the
  /// listmanagedinstances method. This method supports PATCH semantics and uses
  /// the JSON merge patch format and processing rules. If you update your group
  /// to specify a new template or instance configuration, it's possible that
  /// your intended specification for each VM in the group is different from the
  /// current state of that VM. To learn how to apply an updated configuration
  /// to the VMs in a MIG, see Updating instances in a MIG.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - The name of the instance group manager.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    InstanceGroupManager request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts or patches per-instance configurations for the managed instance
  /// group.
  ///
  /// perInstanceConfig.name serves as a key used to distinguish whether to
  /// perform insert or patch.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request, should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchPerInstanceConfigs(
    RegionInstanceGroupManagerPatchInstanceConfigReq request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/patchPerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Flags the specified VM instances in the managed instance group to be
  /// immediately recreated.
  ///
  /// Each instance is recreated using the group's current configuration. This
  /// operation is marked as DONE when the flag is set even if the instances
  /// have not yet been recreated. You must separately verify the status of each
  /// instance by checking its currentAction field; for more information, see
  /// Checking the status of managed instances. If the group is part of a
  /// backend service that has enabled connection draining, it can take up to 60
  /// seconds after the connection draining duration has elapsed before the VM
  /// instance is removed or deleted. You can specify a maximum of 1000
  /// instances with this method per request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> recreateInstances(
    RegionInstanceGroupManagersRecreateRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/recreateInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the intended size of the managed instance group.
  ///
  /// If you increase the size, the group creates new instances using the
  /// current instance template. If you decrease the size, the group deletes one
  /// or more instances. The resize operation is marked DONE if the resize
  /// request is successful. The underlying actions take additional time. You
  /// must separately verify the status of the creating or deleting actions with
  /// the listmanagedinstances method. If the group is part of a backend service
  /// that has enabled connection draining, it can take up to 60 seconds after
  /// the connection draining duration has elapsed before the VM instance is
  /// removed or deleted.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group.
  ///
  /// [size] - Number of instances that should exist in this instance group
  /// manager.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resize(
    core.String project,
    core.String region,
    core.String instanceGroupManager,
    core.int size, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'size': ['${size}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/resize';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the instance template to use when creating new instances or
  /// recreating instances in this group.
  ///
  /// Existing instances are not affected.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - The name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setInstanceTemplate(
    RegionInstanceGroupManagersSetTemplateRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/setInstanceTemplate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Modifies the target pools to which all new instances in this group are
  /// assigned.
  ///
  /// Existing instances in the group are not affected.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroupManager] - Name of the managed instance group.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setTargetPools(
    RegionInstanceGroupManagersSetTargetPoolsRequest request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/setTargetPools';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts or updates per-instance configurations for the managed instance
  /// group.
  ///
  /// perInstanceConfig.name serves as a key used to distinguish whether to
  /// perform insert or patch.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request, should conform to
  /// RFC1035.
  ///
  /// [instanceGroupManager] - The name of the managed instance group. It should
  /// conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> updatePerInstanceConfigs(
    RegionInstanceGroupManagerUpdateInstanceConfigReq request,
    core.String project,
    core.String region,
    core.String instanceGroupManager, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroupManagers/' +
        commons.escapeVariable('$instanceGroupManager') +
        '/updatePerInstanceConfigs';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionInstanceGroupsResource {
  final commons.ApiRequester _requester;

  RegionInstanceGroupsResource(commons.ApiRequester client)
      : _requester = client;

  /// Returns the specified instance group resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroup] - Name of the instance group resource to return.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [InstanceGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<InstanceGroup> get(
    core.String project,
    core.String region,
    core.String instanceGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return InstanceGroup.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of instance group resources contained within the
  /// specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionInstanceGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the instances in the specified instance group and displays
  /// information about the named ports.
  ///
  /// Depending on the specified options, this method can list all instances or
  /// only the instances that are running. The orderBy query parameter is not
  /// supported.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroup] - Name of the regional instance group for which we want to
  /// list the instances.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionInstanceGroupsListInstances].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionInstanceGroupsListInstances> listInstances(
    RegionInstanceGroupsListInstancesRequest request,
    core.String project,
    core.String region,
    core.String instanceGroup, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/listInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return RegionInstanceGroupsListInstances.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the named ports for the specified regional instance group.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  ///
  /// [instanceGroup] - The name of the regional instance group where the named
  /// ports are updated.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setNamedPorts(
    RegionInstanceGroupsSetNamedPortsRequest request,
    core.String project,
    core.String region,
    core.String instanceGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instanceGroups/' +
        commons.escapeVariable('$instanceGroup') +
        '/setNamedPorts';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionInstancesResource {
  final commons.ApiRequester _requester;

  RegionInstancesResource(commons.ApiRequester client) : _requester = client;

  /// Creates multiple instances in a given region.
  ///
  /// Count specifies the number of instances to create.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> bulkInsert(
    BulkInsertInstanceResource request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/instances/bulkInsert';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionNetworkEndpointGroupsResource {
  final commons.ApiRequester _requester;

  RegionNetworkEndpointGroupsResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified network endpoint group.
  ///
  /// Note that the NEG cannot be deleted if it is configured as a backend of a
  /// backend service.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region where the network endpoint group is
  /// located. It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group to delete.
  /// It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String networkEndpointGroup, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network endpoint group.
  ///
  /// Gets a list of available network endpoint groups by making a list()
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region where the network endpoint group is
  /// located. It should comply with RFC1035.
  ///
  /// [networkEndpointGroup] - The name of the network endpoint group. It should
  /// comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroup].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroup> get(
    core.String project,
    core.String region,
    core.String networkEndpointGroup, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEndpointGroups/' +
        commons.escapeVariable('$networkEndpointGroup');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroup.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a network endpoint group in the specified project using the
  /// parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region where you want to create the network
  /// endpoint group. It should comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NetworkEndpointGroup request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of regional network endpoint groups available to the
  /// specified project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region where the network endpoint group is
  /// located. It should comply with RFC1035.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NetworkEndpointGroupList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NetworkEndpointGroupList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/networkEndpointGroups';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NetworkEndpointGroupList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionNetworkFirewallPoliciesResource {
  final commons.ApiRequester _requester;

  RegionNetworkFirewallPoliciesResource(commons.ApiRequester client)
      : _requester = client;

  /// Inserts an association for the specified network firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [replaceExistingAssociation] - Indicates whether or not to replace it if
  /// an association already exists. This is false by default, in which case an
  /// error will be returned if an association already exists.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addAssociation(
    FirewallPolicyAssociation request,
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.bool? replaceExistingAssociation,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (replaceExistingAssociation != null)
        'replaceExistingAssociation': ['${replaceExistingAssociation}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Inserts a rule into a network firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [maxPriority] - When rule.priority is not specified, auto choose a unused
  /// priority between minPriority and maxPriority\>. This field is exclusive
  /// with rule.priority.
  ///
  /// [minPriority] - When rule.priority is not specified, auto choose a unused
  /// priority between minPriority and maxPriority\>. This field is exclusive
  /// with rule.priority.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addRule(
    FirewallPolicyRule request,
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.int? maxPriority,
    core.int? minPriority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (maxPriority != null) 'maxPriority': ['${maxPriority}'],
      if (minPriority != null) 'minPriority': ['${minPriority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/addRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Copies rules to the specified network firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [sourceFirewallPolicy] - The firewall policy from which to copy rules.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> cloneRules(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? sourceFirewallPolicy,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (sourceFirewallPolicy != null)
        'sourceFirewallPolicy': [sourceFirewallPolicy],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/cloneRules';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified network firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified network firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to get.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicy> get(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets an association with the specified name.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried
  /// association belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [name] - The name of the association to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyAssociation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyAssociation> getAssociation(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? name,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getAssociation';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyAssociation.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the effective firewalls on a given network.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [network] - Network reference
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a
  /// [RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse>
      getEffectiveFirewalls(
    core.String project,
    core.String region,
    core.String network, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      'network': [network],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/getEffectiveFirewalls';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to which the queried rule
  /// belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to get from the firewall policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyRule> getRule(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/getRule';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new network firewall policy in the specified project and region.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    FirewallPolicy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the network firewall policies that have been configured for the
  /// specified project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [FirewallPolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<FirewallPolicyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return FirewallPolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified network firewall policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    FirewallPolicy request,
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches a rule of the specified priority.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to patch.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchRule(
    FirewallPolicyRule request,
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/patchRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes an association for the specified network firewall policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [name] - Name for the association that will be removed.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeAssociation(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.String? name,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (name != null) 'name': [name],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeAssociation';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a rule of the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [firewallPolicy] - Name of the firewall policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to remove from the firewall policy.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeRule(
    core.String project,
    core.String region,
    core.String firewallPolicy, {
    core.int? priority,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$firewallPolicy') +
        '/removeRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/firewallPolicies/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionNotificationEndpointsResource {
  final commons.ApiRequester _requester;

  RegionNotificationEndpointsResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified NotificationEndpoint in the given region
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [notificationEndpoint] - Name of the NotificationEndpoint resource to
  /// delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String notificationEndpoint, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/notificationEndpoints/' +
        commons.escapeVariable('$notificationEndpoint');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified NotificationEndpoint resource in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [notificationEndpoint] - Name of the NotificationEndpoint resource to
  /// return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NotificationEndpoint].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NotificationEndpoint> get(
    core.String project,
    core.String region,
    core.String notificationEndpoint, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/notificationEndpoints/' +
        commons.escapeVariable('$notificationEndpoint');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NotificationEndpoint.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Create a NotificationEndpoint in the specified project in the given region
  /// using the parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    NotificationEndpoint request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/notificationEndpoints';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the NotificationEndpoints for a project in the given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [NotificationEndpointList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<NotificationEndpointList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/notificationEndpoints';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return NotificationEndpointList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionOperationsResource {
  final commons.ApiRequester _requester;

  RegionOperationsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified region-specific Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<void> delete(
    core.String project,
    core.String region,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/operations/' +
        commons.escapeVariable('$operation');

    await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
      downloadOptions: null,
    );
  }

  /// Retrieves the specified region-specific Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> get(
    core.String project,
    core.String region,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/operations/' +
        commons.escapeVariable('$operation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of Operation resources contained within the specified
  /// region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [OperationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<OperationList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/operations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return OperationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Waits for the specified Operation resource to return as `DONE` or for the
  /// request to approach the 2 minute deadline, and retrieves the specified
  /// Operation resource.
  ///
  /// This method differs from the `GET` method in that it waits for no more
  /// than the default deadline (2 minutes) and then returns the current state
  /// of the operation, which might be `DONE` or still in progress. This method
  /// is called on a best-effort basis. Specifically: - In uncommon cases, when
  /// the server is overloaded, the request might return before the default
  /// deadline is reached, or might return after zero seconds. - If the default
  /// deadline is reached, there is no guarantee that the operation is actually
  /// done when the method returns. Be prepared to retry if the operation is not
  /// `DONE`.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> wait(
    core.String project,
    core.String region,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/operations/' +
        commons.escapeVariable('$operation') +
        '/wait';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionSecurityPoliciesResource {
  final commons.ApiRequester _requester;

  RegionSecurityPoliciesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [securityPolicy] - Name of the security policy to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String securityPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// List all of the ordered rules present in a single specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [securityPolicy] - Name of the security policy to get.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPolicy> get(
    core.String project,
    core.String region,
    core.String securityPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new policy in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SecurityPolicy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/securityPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// List all the policies that have been configured for the specified project
  /// and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPolicyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/securityPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [securityPolicy] - Name of the security policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    SecurityPolicy request,
    core.String project,
    core.String region,
    core.String securityPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionSslCertificatesResource {
  final commons.ApiRequester _requester;

  RegionSslCertificatesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified SslCertificate resource in the region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [sslCertificate] - Name of the SslCertificate resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String sslCertificate, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslCertificates/' +
        commons.escapeVariable('$sslCertificate');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified SslCertificate resource in the specified region.
  ///
  /// Get a list of available SSL certificates by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [sslCertificate] - Name of the SslCertificate resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslCertificate].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslCertificate> get(
    core.String project,
    core.String region,
    core.String sslCertificate, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslCertificates/' +
        commons.escapeVariable('$sslCertificate');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslCertificate.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a SslCertificate resource in the specified project and region
  /// using the data included in the request
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SslCertificate request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslCertificates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of SslCertificate resources available to the specified
  /// project in the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslCertificateList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslCertificateList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslCertificates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslCertificateList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionSslPoliciesResource {
  final commons.ApiRequester _requester;

  RegionSslPoliciesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified SSL policy.
  ///
  /// The SSL policy resource can be deleted only if it is not in use by any
  /// TargetHttpsProxy or TargetSslProxy resources.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [sslPolicy] - Name of the SSL policy to delete. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String sslPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all of the ordered rules present in a single specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [sslPolicy] - Name of the SSL policy to update. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPolicy> get(
    core.String project,
    core.String region,
    core.String sslPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPolicy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new policy in the specified project and region using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SslPolicy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the SSL policies that have been configured for the specified
  /// project and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPoliciesList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPoliciesList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPoliciesList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all features that can be specified in the SSL policy when using
  /// custom profile.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPoliciesListAvailableFeaturesResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPoliciesListAvailableFeaturesResponse> listAvailableFeatures(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies/listAvailableFeatures';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPoliciesListAvailableFeaturesResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified SSL policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [sslPolicy] - Name of the SSL policy to update. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    SslPolicy request,
    core.String project,
    core.String region,
    core.String sslPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionTargetHttpProxiesResource {
  final commons.ApiRequester _requester;

  RegionTargetHttpProxiesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified TargetHttpProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String targetHttpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetHttpProxy resource in the specified region.
  ///
  /// Gets a list of available target HTTP proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpProxy> get(
    core.String project,
    core.String region,
    core.String targetHttpProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetHttpProxy resource in the specified project and region
  /// using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetHttpProxy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetHttpProxy resources available to the specified
  /// project in the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpProxyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the URL map for TargetHttpProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy to set a URL map for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setUrlMap(
    UrlMapReference request,
    core.String project,
    core.String region,
    core.String targetHttpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy') +
        '/setUrlMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionTargetHttpsProxiesResource {
  final commons.ApiRequester _requester;

  RegionTargetHttpsProxiesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified TargetHttpsProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetHttpsProxy resource in the specified region.
  ///
  /// Gets a list of available target HTTP proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpsProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpsProxy> get(
    core.String project,
    core.String region,
    core.String targetHttpsProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpsProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetHttpsProxy resource in the specified project and region
  /// using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetHttpsProxy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetHttpsProxy resources available to the
  /// specified project in the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpsProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpsProxyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpsProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified regional TargetHttpsProxy resource with the data
  /// included in the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    TargetHttpsProxy request,
    core.String project,
    core.String region,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Replaces SslCertificates for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to set an
  /// SslCertificates resource for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSslCertificates(
    RegionTargetHttpsProxiesSetSslCertificatesRequest request,
    core.String project,
    core.String region,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setSslCertificates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the URL map for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy to set a URL map for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setUrlMap(
    UrlMapReference request,
    core.String project,
    core.String region,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setUrlMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionTargetTcpProxiesResource {
  final commons.ApiRequester _requester;

  RegionTargetTcpProxiesResource(commons.ApiRequester client)
      : _requester = client;

  /// Deletes the specified TargetTcpProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String targetTcpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetTcpProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetTcpProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetTcpProxy> get(
    core.String project,
    core.String region,
    core.String targetTcpProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetTcpProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetTcpProxy resource in the specified project and region
  /// using the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetTcpProxy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetTcpProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of TargetTcpProxy resources available to the specified
  /// project in a given region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetTcpProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetTcpProxyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetTcpProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetTcpProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionUrlMapsResource {
  final commons.ApiRequester _requester;

  RegionUrlMapsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified UrlMap resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [urlMap] - Name of the UrlMap resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - begin_interface: MixerMutationRequestBuilder Request ID to
  /// support idempotency.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified UrlMap resource.
  ///
  /// Gets a list of available URL maps by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [urlMap] - Name of the UrlMap resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMap].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMap> get(
    core.String project,
    core.String region,
    core.String urlMap, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UrlMap.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a UrlMap resource in the specified project using the data included
  /// in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - begin_interface: MixerMutationRequestBuilder Request ID to
  /// support idempotency.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    UrlMap request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of UrlMap resources available to the specified project
  /// in the specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMapList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMapList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UrlMapList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified UrlMap resource with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [urlMap] - Name of the UrlMap resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - begin_interface: MixerMutationRequestBuilder Request ID to
  /// support idempotency.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    UrlMap request,
    core.String project,
    core.String region,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified UrlMap resource with the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [urlMap] - Name of the UrlMap resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - begin_interface: MixerMutationRequestBuilder Request ID to
  /// support idempotency.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    UrlMap request,
    core.String project,
    core.String region,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Runs static validation for the UrlMap.
  ///
  /// In particular, the tests of the provided UrlMap will be run. Calling this
  /// method does NOT create the UrlMap.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [urlMap] - Name of the UrlMap resource to be validated as.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMapsValidateResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMapsValidateResponse> validate(
    RegionUrlMapsValidateRequest request,
    core.String project,
    core.String region,
    core.String urlMap, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/urlMaps/' +
        commons.escapeVariable('$urlMap') +
        '/validate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return UrlMapsValidateResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RegionsResource {
  final commons.ApiRequester _requester;

  RegionsResource(commons.ApiRequester client) : _requester = client;

  /// Returns the specified Region resource.
  ///
  /// Gets a list of available regions by making a list() request. To decrease
  /// latency for this method, you can optionally omit any unneeded information
  /// from the response by using a field mask. This practice is especially
  /// recommended for unused quota information (the `quotas` field). To exclude
  /// one or more fields, set your request's `fields` query parameter to only
  /// include the fields you need. For example, to only include the `id` and
  /// `selfLink` fields, add the query parameter `?fields=id,selfLink` to your
  /// request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Region].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Region> get(
    core.String project,
    core.String region, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Region.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of region resources available to the specified project.
  ///
  /// To decrease latency for this method, you can optionally omit any unneeded
  /// information from the response by using a field mask. This practice is
  /// especially recommended for unused quota information (the `items.quotas`
  /// field). To exclude one or more fields, set your request's `fields` query
  /// parameter to only include the fields you need. For example, to only
  /// include the `id` and `selfLink` fields, add the query parameter
  /// `?fields=id,selfLink` to your request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RegionList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RegionList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' + commons.escapeVariable('$project') + '/regions';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RegionList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class ReservationsResource {
  final commons.ApiRequester _requester;

  ReservationsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of reservations.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ReservationAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ReservationAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/reservations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ReservationAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified reservation.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [reservation] - Name of the reservation to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String reservation, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$reservation');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves information about the specified reservation.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [reservation] - Name of the reservation to retrieve.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Reservation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Reservation> get(
    core.String project,
    core.String zone,
    core.String reservation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$reservation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Reservation.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String zone,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new reservation.
  ///
  /// For more information, read Reserving zonal resources.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Reservation request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// A list of all the reservations that have been configured for the specified
  /// project in specified zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ReservationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ReservationList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ReservationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Resizes the reservation (applicable to standalone reservations only).
  ///
  /// For more information, read Modifying reservations.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [reservation] - Name of the reservation to update.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> resize(
    ReservationsResizeRequest request,
    core.String project,
    core.String zone,
    core.String reservation, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$reservation') +
        '/resize';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    ZoneSetPolicyRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - The name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String zone,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Update share settings of the reservation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [reservation] - Name of the reservation to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [paths] - null
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [updateMask] - Update_mask indicates fields to be updated as part of this
  /// request.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Reservation request,
    core.String project,
    core.String zone,
    core.String reservation, {
    core.List<core.String>? paths,
    core.String? requestId,
    core.String? updateMask,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (paths != null) 'paths': paths,
      if (requestId != null) 'requestId': [requestId],
      if (updateMask != null) 'updateMask': [updateMask],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/reservations/' +
        commons.escapeVariable('$reservation');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ResourcePoliciesResource {
  final commons.ApiRequester _requester;

  ResourcePoliciesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of resource policies.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ResourcePolicyAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ResourcePolicyAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/resourcePolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ResourcePolicyAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified resource policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resourcePolicy] - Name of the resource policy to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String resourcePolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies/' +
        commons.escapeVariable('$resourcePolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves all information of the specified resource policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resourcePolicy] - Name of the resource policy to retrieve.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ResourcePolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ResourcePolicy> get(
    core.String project,
    core.String region,
    core.String resourcePolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies/' +
        commons.escapeVariable('$resourcePolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ResourcePolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new resource policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    ResourcePolicy request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// A list all the resource policies that have been configured for the
  /// specified project in specified region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ResourcePolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ResourcePolicyList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ResourcePolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/resourcePolicies/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class RoutersResource {
  final commons.ApiRequester _requester;

  RoutersResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of routers.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RouterAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RouterAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/routers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RouterAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified Router resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String router, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified Router resource.
  ///
  /// Gets a list of available routers by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Router].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Router> get(
    core.String project,
    core.String region,
    core.String router, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Router.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves runtime Nat mapping information of VM endpoints.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to query for Nat Mapping
  /// information of VM endpoints.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VmEndpointNatMappingsList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VmEndpointNatMappingsList> getNatMappingInfo(
    core.String project,
    core.String region,
    core.String router, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router') +
        '/getNatMappingInfo';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VmEndpointNatMappingsList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves runtime information of the specified router.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to query.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RouterStatusResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RouterStatusResponse> getRouterStatus(
    core.String project,
    core.String region,
    core.String router, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router') +
        '/getRouterStatus';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RouterStatusResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a Router resource in the specified project and region using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Router request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of Router resources available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RouterList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RouterList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RouterList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified Router resource with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Router request,
    core.String project,
    core.String region,
    core.String router, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Preview fields auto-generated during router create and update operations.
  ///
  /// Calling this method does NOT create or update the router.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to query.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RoutersPreviewResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RoutersPreviewResponse> preview(
    Router request,
    core.String project,
    core.String region,
    core.String router, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router') +
        '/preview';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return RoutersPreviewResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified Router resource with the data included in the
  /// request.
  ///
  /// This method conforms to PUT semantics, which requests that the state of
  /// the target resource be created or replaced with the state defined by the
  /// representation enclosed in the request message payload.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [router] - Name of the Router resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    Router request,
    core.String project,
    core.String region,
    core.String router, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/routers/' +
        commons.escapeVariable('$router');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class RoutesResource {
  final commons.ApiRequester _requester;

  RoutesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified Route resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [route] - Name of the Route resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String route, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/routes/' +
        commons.escapeVariable('$route');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified Route resource.
  ///
  /// Gets a list of available routes by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [route] - Name of the Route resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Route].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Route> get(
    core.String project,
    core.String route, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/routes/' +
        commons.escapeVariable('$route');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Route.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a Route resource in the specified project using the data included
  /// in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Route request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/routes';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of Route resources available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [RouteList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<RouteList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/routes';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return RouteList.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class SecurityPoliciesResource {
  final commons.ApiRequester _requester;

  SecurityPoliciesResource(commons.ApiRequester client) : _requester = client;

  /// Inserts a rule into a security policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addRule(
    SecurityPolicyRule request,
    core.String project,
    core.String securityPolicy, {
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy') +
        '/addRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of all SecurityPolicy resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPoliciesAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPoliciesAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/securityPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPoliciesAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String securityPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// List all of the ordered rules present in a single specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to get.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPolicy> get(
    core.String project,
    core.String securityPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPolicy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets a rule at the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to which the queried rule
  /// belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to get from the security policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPolicyRule].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPolicyRule> getRule(
    core.String project,
    core.String securityPolicy, {
    core.int? priority,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy') +
        '/getRule';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPolicyRule.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a new policy in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SecurityPolicy request,
    core.String project, {
    core.String? requestId,
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// List all the policies that have been configured for the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SecurityPolicyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPolicyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPolicyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the current list of preconfigured Web Application Firewall (WAF)
  /// expressions.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a
  /// [SecurityPoliciesListPreconfiguredExpressionSetsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SecurityPoliciesListPreconfiguredExpressionSetsResponse>
      listPreconfiguredExpressionSets(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/listPreconfiguredExpressionSets';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SecurityPoliciesListPreconfiguredExpressionSetsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified policy with the data included in the request.
  ///
  /// This cannot be used to be update the rules in the policy. Please use the
  /// per rule methods like addRule, patchRule, and removeRule instead.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    SecurityPolicy request,
    core.String project,
    core.String securityPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches a rule at the specified priority.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to patch.
  ///
  /// [validateOnly] - If true, the request will not be committed.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patchRule(
    SecurityPolicyRule request,
    core.String project,
    core.String securityPolicy, {
    core.int? priority,
    core.bool? validateOnly,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if (validateOnly != null) 'validateOnly': ['${validateOnly}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy') +
        '/patchRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes a rule at the specified priority.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [securityPolicy] - Name of the security policy to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [priority] - The priority of the rule to remove from the security policy.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeRule(
    core.String project,
    core.String securityPolicy, {
    core.int? priority,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (priority != null) 'priority': ['${priority}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$securityPolicy') +
        '/removeRule';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a security policy.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/securityPolicies/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ServiceAttachmentsResource {
  final commons.ApiRequester _requester;

  ServiceAttachmentsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all ServiceAttachment resources, regional and
  /// global, available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ServiceAttachmentAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ServiceAttachmentAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/serviceAttachments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ServiceAttachmentAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified ServiceAttachment in the given scope
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [serviceAttachment] - Name of the ServiceAttachment resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String serviceAttachment, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$serviceAttachment');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified ServiceAttachment resource in the given scope.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [serviceAttachment] - Name of the ServiceAttachment resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ServiceAttachment].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ServiceAttachment> get(
    core.String project,
    core.String region,
    core.String serviceAttachment, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$serviceAttachment');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ServiceAttachment.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a ServiceAttachment in the specified project in the given scope
  /// using the parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    ServiceAttachment request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the ServiceAttachments for a project in the given scope.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region of this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ServiceAttachmentList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ServiceAttachmentList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ServiceAttachmentList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified ServiceAttachment resource with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region scoping this request and should conform to RFC1035.
  ///
  /// [serviceAttachment] - The resource id of the ServiceAttachment to patch.
  /// It should conform to RFC1035 resource name or be a string form on an
  /// unsigned long number.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    ServiceAttachment request,
    core.String project,
    core.String region,
    core.String serviceAttachment, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$serviceAttachment');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/serviceAttachments/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class SnapshotsResource {
  final commons.ApiRequester _requester;

  SnapshotsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified Snapshot resource.
  ///
  /// Keep in mind that deleting a single snapshot might not necessarily delete
  /// all the data on that snapshot. If any data on the snapshot that is marked
  /// for deletion is needed for subsequent snapshots, the data will be moved to
  /// the next corresponding snapshot. For more information, see Deleting
  /// snapshots.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [snapshot] - Name of the Snapshot resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String snapshot, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$snapshot');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified Snapshot resource.
  ///
  /// Gets a list of available snapshots by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [snapshot] - Name of the Snapshot resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Snapshot].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Snapshot> get(
    core.String project,
    core.String snapshot, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$snapshot');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Snapshot.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a snapshot in the specified project using the data included in the
  /// request.
  ///
  /// For regular snapshot creation, consider using this method instead of
  /// disks.createSnapshot, as this method supports more features, such as
  /// creating snapshots in a project different from the source disk project.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Snapshot request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/snapshots';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of Snapshot resources contained within the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SnapshotList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SnapshotList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/snapshots';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SnapshotList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    GlobalSetPolicyRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a snapshot.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    GlobalSetLabelsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9_\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/snapshots/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class SslCertificatesResource {
  final commons.ApiRequester _requester;

  SslCertificatesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all SslCertificate resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslCertificateAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslCertificateAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/sslCertificates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslCertificateAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified SslCertificate resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [sslCertificate] - Name of the SslCertificate resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String sslCertificate, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslCertificates/' +
        commons.escapeVariable('$sslCertificate');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified SslCertificate resource.
  ///
  /// Gets a list of available SSL certificates by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [sslCertificate] - Name of the SslCertificate resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslCertificate].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslCertificate> get(
    core.String project,
    core.String sslCertificate, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslCertificates/' +
        commons.escapeVariable('$sslCertificate');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslCertificate.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a SslCertificate resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SslCertificate request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslCertificates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of SslCertificate resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslCertificateList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslCertificateList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslCertificates';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslCertificateList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class SslPoliciesResource {
  final commons.ApiRequester _requester;

  SslPoliciesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all SslPolicy resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPoliciesAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPoliciesAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/sslPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPoliciesAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified SSL policy.
  ///
  /// The SSL policy resource can be deleted only if it is not in use by any
  /// TargetHttpsProxy or TargetSslProxy resources.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [sslPolicy] - Name of the SSL policy to delete. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String sslPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all of the ordered rules present in a single specified policy.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [sslPolicy] - Name of the SSL policy to update. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPolicy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPolicy> get(
    core.String project,
    core.String sslPolicy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPolicy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified SSL policy resource.
  ///
  /// Gets a list of available SSL policies by making a list() request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    SslPolicy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all the SSL policies that have been configured for the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPoliciesList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPoliciesList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPoliciesList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists all features that can be specified in the SSL policy when using
  /// custom profile.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SslPoliciesListAvailableFeaturesResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SslPoliciesListAvailableFeaturesResponse> listAvailableFeatures(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies/listAvailableFeatures';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SslPoliciesListAvailableFeaturesResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified SSL policy with the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [sslPolicy] - Name of the SSL policy to update. The name must be 1-63
  /// characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    SslPolicy request,
    core.String project,
    core.String sslPolicy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/sslPolicies/' +
        commons.escapeVariable('$sslPolicy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class SubnetworksResource {
  final commons.ApiRequester _requester;

  SubnetworksResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of subnetworks.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SubnetworkAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SubnetworkAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/subnetworks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SubnetworkAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified subnetwork.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [subnetwork] - Name of the Subnetwork resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String subnetwork, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$subnetwork');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Expands the IP CIDR range of the subnetwork to a specified value.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [subnetwork] - Name of the Subnetwork resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> expandIpCidrRange(
    SubnetworksExpandIpCidrRangeRequest request,
    core.String project,
    core.String region,
    core.String subnetwork, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$subnetwork') +
        '/expandIpCidrRange';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified subnetwork.
  ///
  /// Gets a list of available subnetworks list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [subnetwork] - Name of the Subnetwork resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Subnetwork].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Subnetwork> get(
    core.String project,
    core.String region,
    core.String subnetwork, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$subnetwork');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Subnetwork.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the access control policy for a resource.
  ///
  /// May be empty if no such policy or resource exists.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [optionsRequestedPolicyVersion] - Requested IAM Policy version.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> getIamPolicy(
    core.String project,
    core.String region,
    core.String resource, {
    core.int? optionsRequestedPolicyVersion,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (optionsRequestedPolicyVersion != null)
        'optionsRequestedPolicyVersion': ['${optionsRequestedPolicyVersion}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$resource') +
        '/getIamPolicy';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a subnetwork in the specified project using the data included in
  /// the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    Subnetwork request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of subnetworks available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [SubnetworkList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<SubnetworkList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return SubnetworkList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves an aggregated list of all usable subnetworks in the project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UsableSubnetworksAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UsableSubnetworksAggregatedList> listUsable(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/subnetworks/listUsable';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UsableSubnetworksAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified subnetwork with the data included in the request.
  ///
  /// Only certain fields can be updated with a patch request as indicated in
  /// the field descriptions. You must specify the current fingerprint of the
  /// subnetwork resource being patched.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [subnetwork] - Name of the Subnetwork resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [drainTimeoutSeconds] - The drain timeout specifies the upper bound in
  /// seconds on the amount of time allowed to drain connections from the
  /// current ACTIVE subnetwork to the current BACKUP subnetwork. The drain
  /// timeout is only applicable when the following conditions are true: - the
  /// subnetwork being patched has purpose = INTERNAL_HTTPS_LOAD_BALANCER - the
  /// subnetwork being patched has role = BACKUP - the patch request is setting
  /// the role to ACTIVE. Note that after this patch operation the roles of the
  /// ACTIVE and BACKUP subnetworks will be swapped.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    Subnetwork request,
    core.String project,
    core.String region,
    core.String subnetwork, {
    core.int? drainTimeoutSeconds,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (drainTimeoutSeconds != null)
        'drainTimeoutSeconds': ['${drainTimeoutSeconds}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$subnetwork');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the access control policy on the specified resource.
  ///
  /// Replaces any existing policy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Policy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Policy> setIamPolicy(
    RegionSetPolicyRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$resource') +
        '/setIamPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Policy.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Set whether VMs in this subnet can access Google services without
  /// assigning external IP addresses through Private Google Access.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [subnetwork] - Name of the Subnetwork resource.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setPrivateIpGoogleAccess(
    SubnetworksSetPrivateIpGoogleAccessRequest request,
    core.String project,
    core.String region,
    core.String subnetwork, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$subnetwork') +
        '/setPrivateIpGoogleAccess';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/subnetworks/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetGrpcProxiesResource {
  final commons.ApiRequester _requester;

  TargetGrpcProxiesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified TargetGrpcProxy in the given scope
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetGrpcProxy] - Name of the TargetGrpcProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String targetGrpcProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetGrpcProxies/' +
        commons.escapeVariable('$targetGrpcProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetGrpcProxy resource in the given scope.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetGrpcProxy] - Name of the TargetGrpcProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetGrpcProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetGrpcProxy> get(
    core.String project,
    core.String targetGrpcProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetGrpcProxies/' +
        commons.escapeVariable('$targetGrpcProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetGrpcProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetGrpcProxy in the specified project in the given scope
  /// using the parameters that are included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetGrpcProxy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetGrpcProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Lists the TargetGrpcProxies for a project in the given scope.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetGrpcProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetGrpcProxyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetGrpcProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetGrpcProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified TargetGrpcProxy resource with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetGrpcProxy] - Name of the TargetGrpcProxy resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    TargetGrpcProxy request,
    core.String project,
    core.String targetGrpcProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetGrpcProxies/' +
        commons.escapeVariable('$targetGrpcProxy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetHttpProxiesResource {
  final commons.ApiRequester _requester;

  TargetHttpProxiesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all TargetHttpProxy resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpProxyAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpProxyAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/targetHttpProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpProxyAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified TargetHttpProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String targetHttpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetHttpProxy resource.
  ///
  /// Gets a list of available target HTTP proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpProxy> get(
    core.String project,
    core.String targetHttpProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetHttpProxy resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetHttpProxy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetHttpProxy resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpProxyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified TargetHttpProxy resource with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    TargetHttpProxy request,
    core.String project,
    core.String targetHttpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the URL map for TargetHttpProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpProxy] - Name of the TargetHttpProxy to set a URL map for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setUrlMap(
    UrlMapReference request,
    core.String project,
    core.String targetHttpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/targetHttpProxies/' +
        commons.escapeVariable('$targetHttpProxy') +
        '/setUrlMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetHttpsProxiesResource {
  final commons.ApiRequester _requester;

  TargetHttpsProxiesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all TargetHttpsProxy resources, regional and global,
  /// available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpsProxyAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpsProxyAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/targetHttpsProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpsProxyAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified TargetHttpsProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetHttpsProxy resource.
  ///
  /// Gets a list of available target HTTPS proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpsProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpsProxy> get(
    core.String project,
    core.String targetHttpsProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpsProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetHttpsProxy resource in the specified project using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetHttpsProxy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetHttpsProxy resources available to the
  /// specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetHttpsProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetHttpsProxyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetHttpsProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified TargetHttpsProxy resource with the data included in
  /// the request.
  ///
  /// This method supports PATCH semantics and uses JSON merge patch format and
  /// processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    TargetHttpsProxy request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the Certificate Map for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource whose
  /// CertificateMap is to be set. The name must be 1-63 characters long, and
  /// comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setCertificateMap(
    TargetHttpsProxiesSetCertificateMapRequest request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setCertificateMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the QUIC override policy for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to set the QUIC
  /// override policy for. The name should conform to RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setQuicOverride(
    TargetHttpsProxiesSetQuicOverrideRequest request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setQuicOverride';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Replaces SslCertificates for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource to set an
  /// SslCertificates resource for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSslCertificates(
    TargetHttpsProxiesSetSslCertificatesRequest request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setSslCertificates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the SSL policy for TargetHttpsProxy.
  ///
  /// The SSL policy specifies the server-side support for SSL features. This
  /// affects connections between clients and the HTTPS proxy load balancer.
  /// They do not affect the connection between the load balancer and the
  /// backends.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource whose SSL
  /// policy is to be set. The name must be 1-63 characters long, and comply
  /// with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSslPolicy(
    SslPolicyReference request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setSslPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the URL map for TargetHttpsProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetHttpsProxy] - Name of the TargetHttpsProxy resource whose URL map
  /// is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setUrlMap(
    UrlMapReference request,
    core.String project,
    core.String targetHttpsProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/targetHttpsProxies/' +
        commons.escapeVariable('$targetHttpsProxy') +
        '/setUrlMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetInstancesResource {
  final commons.ApiRequester _requester;

  TargetInstancesResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of target instances.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetInstanceAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetInstanceAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/targetInstances';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetInstanceAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified TargetInstance resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetInstance] - Name of the TargetInstance resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String zone,
    core.String targetInstance, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/targetInstances/' +
        commons.escapeVariable('$targetInstance');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetInstance resource.
  ///
  /// Gets a list of available target instances by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetInstance] - Name of the TargetInstance resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetInstance].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetInstance> get(
    core.String project,
    core.String zone,
    core.String targetInstance, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/targetInstances/' +
        commons.escapeVariable('$targetInstance');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetInstance.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetInstance resource in the specified project and zone using
  /// the data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetInstance request,
    core.String project,
    core.String zone, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/targetInstances';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of TargetInstance resources available to the specified
  /// project and zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetInstanceList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetInstanceList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/targetInstances';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetInstanceList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetPoolsResource {
  final commons.ApiRequester _requester;

  TargetPoolsResource(commons.ApiRequester client) : _requester = client;

  /// Adds health check URLs to a target pool.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the target pool to add a health check to.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addHealthCheck(
    TargetPoolsAddHealthCheckRequest request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/addHealthCheck';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Adds an instance to a target pool.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to add instances to.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> addInstance(
    TargetPoolsAddInstanceRequest request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/addInstance';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves an aggregated list of target pools.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetPoolAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetPoolAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/targetPools';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetPoolAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified target pool.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified target pool.
  ///
  /// Gets a list of available target pools by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetPool].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetPool> get(
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetPool.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Gets the most recent health check results for each IP for the instance
  /// that is referenced by the given target pool.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to which the queried
  /// instance belongs.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetPoolInstanceHealth].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetPoolInstanceHealth> getHealth(
    InstanceReference request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/getHealth';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TargetPoolInstanceHealth.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a target pool in the specified project and region using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetPool request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of target pools available to the specified project and
  /// region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetPoolList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetPoolList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetPoolList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes health check URL from a target pool.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the target pool to remove health checks from.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeHealthCheck(
    TargetPoolsRemoveHealthCheckRequest request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/removeHealthCheck';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Removes instance URL from a target pool.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to remove instances from.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> removeInstance(
    TargetPoolsRemoveInstanceRequest request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/removeInstance';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes a backup target pool's configurations.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region scoping this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetPool] - Name of the TargetPool resource to set a backup pool for.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [failoverRatio] - New failoverRatio value for the target pool.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setBackup(
    TargetReference request,
    core.String project,
    core.String region,
    core.String targetPool, {
    core.double? failoverRatio,
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (failoverRatio != null) 'failoverRatio': ['${failoverRatio}'],
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetPools/' +
        commons.escapeVariable('$targetPool') +
        '/setBackup';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetSslProxiesResource {
  final commons.ApiRequester _requester;

  TargetSslProxiesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified TargetSslProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetSslProxy resource.
  ///
  /// Gets a list of available target SSL proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetSslProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetSslProxy> get(
    core.String project,
    core.String targetSslProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetSslProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetSslProxy resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetSslProxy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetSslProxy resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetSslProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetSslProxyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetSslProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the BackendService for TargetSslProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource whose
  /// BackendService resource is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setBackendService(
    TargetSslProxiesSetBackendServiceRequest request,
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy') +
        '/setBackendService';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the Certificate Map for TargetSslProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource whose
  /// CertificateMap is to be set. The name must be 1-63 characters long, and
  /// comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setCertificateMap(
    TargetSslProxiesSetCertificateMapRequest request,
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy') +
        '/setCertificateMap';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the ProxyHeaderType for TargetSslProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource whose ProxyHeader
  /// is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setProxyHeader(
    TargetSslProxiesSetProxyHeaderRequest request,
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy') +
        '/setProxyHeader';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes SslCertificates for TargetSslProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource whose
  /// SslCertificate resource is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSslCertificates(
    TargetSslProxiesSetSslCertificatesRequest request,
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy') +
        '/setSslCertificates';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the SSL policy for TargetSslProxy.
  ///
  /// The SSL policy specifies the server-side support for SSL features. This
  /// affects connections between clients and the SSL proxy load balancer. They
  /// do not affect the connection between the load balancer and the backends.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetSslProxy] - Name of the TargetSslProxy resource whose SSL policy is
  /// to be set. The name must be 1-63 characters long, and comply with RFC1035.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setSslPolicy(
    SslPolicyReference request,
    core.String project,
    core.String targetSslProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetSslProxies/' +
        commons.escapeVariable('$targetSslProxy') +
        '/setSslPolicy';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetTcpProxiesResource {
  final commons.ApiRequester _requester;

  TargetTcpProxiesResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified TargetTcpProxy resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String targetTcpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified TargetTcpProxy resource.
  ///
  /// Gets a list of available target TCP proxies by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetTcpProxy].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetTcpProxy> get(
    core.String project,
    core.String targetTcpProxy, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetTcpProxy.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a TargetTcpProxy resource in the specified project using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetTcpProxy request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of TargetTcpProxy resources available to the specified
  /// project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetTcpProxyList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetTcpProxyList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetTcpProxyList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the BackendService for TargetTcpProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource whose
  /// BackendService resource is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setBackendService(
    TargetTcpProxiesSetBackendServiceRequest request,
    core.String project,
    core.String targetTcpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy') +
        '/setBackendService';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Changes the ProxyHeaderType for TargetTcpProxy.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [targetTcpProxy] - Name of the TargetTcpProxy resource whose ProxyHeader
  /// is to be set.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setProxyHeader(
    TargetTcpProxiesSetProxyHeaderRequest request,
    core.String project,
    core.String targetTcpProxy, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/targetTcpProxies/' +
        commons.escapeVariable('$targetTcpProxy') +
        '/setProxyHeader';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class TargetVpnGatewaysResource {
  final commons.ApiRequester _requester;

  TargetVpnGatewaysResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of target VPN gateways.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetVpnGatewayAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetVpnGatewayAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/targetVpnGateways';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetVpnGatewayAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified target VPN gateway.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetVpnGateway] - Name of the target VPN gateway to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String targetVpnGateway, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetVpnGateways/' +
        commons.escapeVariable('$targetVpnGateway');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified target VPN gateway.
  ///
  /// Gets a list of available target VPN gateways by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [targetVpnGateway] - Name of the target VPN gateway to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetVpnGateway].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetVpnGateway> get(
    core.String project,
    core.String region,
    core.String targetVpnGateway, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetVpnGateways/' +
        commons.escapeVariable('$targetVpnGateway');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetVpnGateway.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a target VPN gateway in the specified project and region using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    TargetVpnGateway request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetVpnGateways';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of target VPN gateways available to the specified project
  /// and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TargetVpnGatewayList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TargetVpnGatewayList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetVpnGateways';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return TargetVpnGatewayList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a TargetVpnGateway.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/targetVpnGateways/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class UrlMapsResource {
  final commons.ApiRequester _requester;

  UrlMapsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves the list of all UrlMap resources, regional and global, available
  /// to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Name of the project scoping this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMapsAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMapsAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/urlMaps';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UrlMapsAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified UrlMap resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified UrlMap resource.
  ///
  /// Gets a list of available URL maps by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMap].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMap> get(
    core.String project,
    core.String urlMap, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UrlMap.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a UrlMap resource in the specified project using the data included
  /// in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    UrlMap request,
    core.String project, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/urlMaps';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Initiates a cache invalidation operation, invalidating the specified path,
  /// scoped to the specified UrlMap.
  ///
  /// For more information, see \[Invalidating cached
  /// content\](/cdn/docs/invalidating-cached-content).
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap scoping this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> invalidateCache(
    CacheInvalidationRule request,
    core.String project,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap') +
        '/invalidateCache';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of UrlMap resources available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMapList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMapList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ =
        'projects/' + commons.escapeVariable('$project') + '/global/urlMaps';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return UrlMapList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Patches the specified UrlMap resource with the data included in the
  /// request.
  ///
  /// This method supports PATCH semantics and uses the JSON merge patch format
  /// and processing rules.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap resource to patch.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> patch(
    UrlMap request,
    core.String project,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'PATCH',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Updates the specified UrlMap resource with the data included in the
  /// request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap resource to update.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> update(
    UrlMap request,
    core.String project,
    core.String urlMap, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap');

    final response_ = await _requester.request(
      url_,
      'PUT',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Runs static validation for the UrlMap.
  ///
  /// In particular, the tests of the provided UrlMap will be run. Calling this
  /// method does NOT create the UrlMap.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [urlMap] - Name of the UrlMap resource to be validated as.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [UrlMapsValidateResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<UrlMapsValidateResponse> validate(
    UrlMapsValidateRequest request,
    core.String project,
    core.String urlMap, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/global/urlMaps/' +
        commons.escapeVariable('$urlMap') +
        '/validate';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return UrlMapsValidateResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class VpnGatewaysResource {
  final commons.ApiRequester _requester;

  VpnGatewaysResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of VPN gateways.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnGatewayAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnGatewayAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/vpnGateways';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnGatewayAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified VPN gateway.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [vpnGateway] - Name of the VPN gateway to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String vpnGateway, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways/' +
        commons.escapeVariable('$vpnGateway');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified VPN gateway.
  ///
  /// Gets a list of available VPN gateways by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [vpnGateway] - Name of the VPN gateway to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnGateway].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnGateway> get(
    core.String project,
    core.String region,
    core.String vpnGateway, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways/' +
        commons.escapeVariable('$vpnGateway');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnGateway.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the status for the specified VPN gateway.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [vpnGateway] - Name of the VPN gateway to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnGatewaysGetStatusResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnGatewaysGetStatusResponse> getStatus(
    core.String project,
    core.String region,
    core.String vpnGateway, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways/' +
        commons.escapeVariable('$vpnGateway') +
        '/getStatus';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnGatewaysGetStatusResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a VPN gateway in the specified project and region using the data
  /// included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    VpnGateway request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of VPN gateways available to the specified project and
  /// region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnGatewayList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnGatewayList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnGatewayList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a VpnGateway.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns permissions that a caller has on the specified resource.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [TestPermissionsResponse].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<TestPermissionsResponse> testIamPermissions(
    TestPermissionsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnGateways/' +
        commons.escapeVariable('$resource') +
        '/testIamPermissions';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return TestPermissionsResponse.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }
}

class VpnTunnelsResource {
  final commons.ApiRequester _requester;

  VpnTunnelsResource(commons.ApiRequester client) : _requester = client;

  /// Retrieves an aggregated list of VPN tunnels.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [includeAllScopes] - Indicates whether every visible scope for each scope
  /// type (zone, region, global) should be included in the response. For new
  /// resource types added after this field, the flag has no effect as new
  /// resource types will always include every visible scope for each scope type
  /// in response. For resource types which predate this field, if this flag is
  /// omitted or false, only scopes of the scope types where the resource type
  /// is expected to be found will be included.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnTunnelAggregatedList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnTunnelAggregatedList> aggregatedList(
    core.String project, {
    core.String? filter,
    core.bool? includeAllScopes,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (includeAllScopes != null) 'includeAllScopes': ['${includeAllScopes}'],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/aggregated/vpnTunnels';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnTunnelAggregatedList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Deletes the specified VpnTunnel resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [vpnTunnel] - Name of the VpnTunnel resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> delete(
    core.String project,
    core.String region,
    core.String vpnTunnel, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnTunnels/' +
        commons.escapeVariable('$vpnTunnel');

    final response_ = await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Returns the specified VpnTunnel resource.
  ///
  /// Gets a list of available VPN tunnels by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [vpnTunnel] - Name of the VpnTunnel resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnTunnel].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnTunnel> get(
    core.String project,
    core.String region,
    core.String vpnTunnel, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnTunnels/' +
        commons.escapeVariable('$vpnTunnel');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnTunnel.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Creates a VpnTunnel resource in the specified project and region using the
  /// data included in the request.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> insert(
    VpnTunnel request,
    core.String project,
    core.String region, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnTunnels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of VpnTunnel resources contained in the specified project
  /// and region.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - Name of the region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [VpnTunnelList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<VpnTunnelList> list(
    core.String project,
    core.String region, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnTunnels';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return VpnTunnelList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Sets the labels on a VpnTunnel.
  ///
  /// To learn more about labels, read the Labeling Resources documentation.
  ///
  /// [request] - The metadata request object.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [region] - The region for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [resource] - Name or id of the resource for this request.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [requestId] - An optional request ID to identify requests. Specify a
  /// unique request ID so that if you must retry your request, the server will
  /// know to ignore the request if it has already been completed. For example,
  /// consider a situation where you make an initial request and the request
  /// times out. If you make the request again with the same request ID, the
  /// server can check if original operation with the same request ID was
  /// received, and if so, will ignore the second request. This prevents clients
  /// from accidentally creating duplicate commitments. The request ID must be a
  /// valid UUID with the exception that zero UUID is not supported (
  /// 00000000-0000-0000-0000-000000000000).
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> setLabels(
    RegionSetLabelsRequest request,
    core.String project,
    core.String region,
    core.String resource, {
    core.String? requestId,
    core.String? $fields,
  }) async {
    final body_ = convert.json.encode(request);
    final queryParams_ = <core.String, core.List<core.String>>{
      if (requestId != null) 'requestId': [requestId],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/regions/' +
        commons.escapeVariable('$region') +
        '/vpnTunnels/' +
        commons.escapeVariable('$resource') +
        '/setLabels';

    final response_ = await _requester.request(
      url_,
      'POST',
      body: body_,
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ZoneOperationsResource {
  final commons.ApiRequester _requester;

  ZoneOperationsResource(commons.ApiRequester client) : _requester = client;

  /// Deletes the specified zone-specific Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to delete.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<void> delete(
    core.String project,
    core.String zone,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/operations/' +
        commons.escapeVariable('$operation');

    await _requester.request(
      url_,
      'DELETE',
      queryParams: queryParams_,
      downloadOptions: null,
    );
  }

  /// Retrieves the specified zone-specific Operations resource.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> get(
    core.String project,
    core.String zone,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/operations/' +
        commons.escapeVariable('$operation');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves a list of Operation resources contained within the specified
  /// zone.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [OperationList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<OperationList> list(
    core.String project,
    core.String zone, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/operations';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return OperationList.fromJson(
        response_ as core.Map<core.String, core.dynamic>);
  }

  /// Waits for the specified Operation resource to return as `DONE` or for the
  /// request to approach the 2 minute deadline, and retrieves the specified
  /// Operation resource.
  ///
  /// This method waits for no more than the 2 minutes and then returns the
  /// current state of the operation, which might be `DONE` or still in
  /// progress. This method is called on a best-effort basis. Specifically: - In
  /// uncommon cases, when the server is overloaded, the request might return
  /// before the default deadline is reached, or might return after zero
  /// seconds. - If the default deadline is reached, there is no guarantee that
  /// the operation is actually done when the method returns. Be prepared to
  /// retry if the operation is not `DONE`.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone for this request.
  /// Value must have pattern `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?`.
  ///
  /// [operation] - Name of the Operations resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Operation].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Operation> wait(
    core.String project,
    core.String zone,
    core.String operation, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone') +
        '/operations/' +
        commons.escapeVariable('$operation') +
        '/wait';

    final response_ = await _requester.request(
      url_,
      'POST',
      queryParams: queryParams_,
    );
    return Operation.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

class ZonesResource {
  final commons.ApiRequester _requester;

  ZonesResource(commons.ApiRequester client) : _requester = client;

  /// Returns the specified Zone resource.
  ///
  /// Gets a list of available zones by making a list() request.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [zone] - Name of the zone resource to return.
  /// Value must have pattern
  /// `\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?|\[1-9\]\[0-9\]{0,19}`.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [Zone].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<Zone> get(
    core.String project,
    core.String zone, {
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' +
        commons.escapeVariable('$project') +
        '/zones/' +
        commons.escapeVariable('$zone');

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return Zone.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }

  /// Retrieves the list of Zone resources available to the specified project.
  ///
  /// Request parameters:
  ///
  /// [project] - Project ID for this request.
  /// Value must have pattern
  /// `(?:(?:\[-a-z0-9\]{1,63}\.)*(?:\[a-z\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?):)?(?:\[0-9\]{1,19}|(?:\[a-z0-9\](?:\[-a-z0-9\]{0,61}\[a-z0-9\])?))`.
  ///
  /// [filter] - A filter expression that filters resources listed in the
  /// response. Most Compute resources support two types of filter expressions:
  /// expressions that support regular expressions and expressions that follow
  /// API improvement proposal AIP-160. If you want to use AIP-160, your
  /// expression must specify the field name, an operator, and the value that
  /// you want to use for filtering. The value must be a string, a number, or a
  /// boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or
  /// `:`. For example, if you are filtering Compute Engine instances, you can
  /// exclude instances named `example-instance` by specifying `name !=
  /// example-instance`. The `:` operator can be used with string fields to
  /// match substrings. For non-string fields it is equivalent to the `=`
  /// operator. The `:*` comparison can be used to test whether a key has been
  /// defined. For example, to find all objects with `owner` label use: ```
  /// labels.owner:* ``` You can also filter nested fields. For example, you
  /// could specify `scheduling.automaticRestart = false` to include instances
  /// only if they are not scheduled for automatic restarts. You can use
  /// filtering on nested fields to filter based on resource labels. To filter
  /// on multiple expressions, provide each separate expression within
  /// parentheses. For example: ``` (scheduling.automaticRestart = true)
  /// (cpuPlatform = "Intel Skylake") ``` By default, each expression is an
  /// `AND` expression. However, you can include `AND` and `OR` expressions
  /// explicitly. For example: ``` (cpuPlatform = "Intel Skylake") OR
  /// (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true)
  /// ``` If you want to use a regular expression, use the `eq` (equal) or `ne`
  /// (not equal) operator against a single un-parenthesized expression with or
  /// without quotes or against multiple parenthesized expressions. Examples:
  /// `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'`
  /// `fieldname eq "double quoted literal"` `(fieldname1 eq literal)
  /// (fieldname2 ne "literal")` The literal value is interpreted as a regular
  /// expression using Google RE2 library syntax. The literal value must match
  /// the entire field. For example, to filter for instances that do not end
  /// with name "instance", you would use `name ne .*instance`.
  ///
  /// [maxResults] - The maximum number of results per page that should be
  /// returned. If the number of available results is larger than `maxResults`,
  /// Compute Engine returns a `nextPageToken` that can be used to get the next
  /// page of results in subsequent list requests. Acceptable values are `0` to
  /// `500`, inclusive. (Default: `500`)
  ///
  /// [orderBy] - Sorts list results by a certain order. By default, results are
  /// returned in alphanumerical order based on the resource name. You can also
  /// sort results in descending order based on the creation timestamp using
  /// `orderBy="creationTimestamp desc"`. This sorts results based on the
  /// `creationTimestamp` field in reverse chronological order (newest result
  /// first). Use this to sort resources like operations so that the newest
  /// operation is returned first. Currently, only sorting by `name` or
  /// `creationTimestamp desc` is supported.
  ///
  /// [pageToken] - Specifies a page token to use. Set `pageToken` to the
  /// `nextPageToken` returned by a previous list request to get the next page
  /// of results.
  ///
  /// [returnPartialSuccess] - Opt-in for partial success behavior which
  /// provides partial results in case of failure. The default value is false.
  ///
  /// [$fields] - Selector specifying which fields to include in a partial
  /// response.
  ///
  /// Completes with a [ZoneList].
  ///
  /// Completes with a [commons.ApiRequestError] if the API endpoint returned an
  /// error.
  ///
  /// If the used [http.Client] completes with an error when making a REST call,
  /// this method will complete with the same error.
  async.Future<ZoneList> list(
    core.String project, {
    core.String? filter,
    core.int? maxResults,
    core.String? orderBy,
    core.String? pageToken,
    core.bool? returnPartialSuccess,
    core.String? $fields,
  }) async {
    final queryParams_ = <core.String, core.List<core.String>>{
      if (filter != null) 'filter': [filter],
      if (maxResults != null) 'maxResults': ['${maxResults}'],
      if (orderBy != null) 'orderBy': [orderBy],
      if (pageToken != null) 'pageToken': [pageToken],
      if (returnPartialSuccess != null)
        'returnPartialSuccess': ['${returnPartialSuccess}'],
      if ($fields != null) 'fields': [$fields],
    };

    final url_ = 'projects/' + commons.escapeVariable('$project') + '/zones';

    final response_ = await _requester.request(
      url_,
      'GET',
      queryParams: queryParams_,
    );
    return ZoneList.fromJson(response_ as core.Map<core.String, core.dynamic>);
  }
}

/// A specification of the type and number of accelerator cards attached to the
/// instance.
class AcceleratorConfig {
  /// The number of the guest accelerator cards exposed to this instance.
  core.int? acceleratorCount;

  /// Full or partial URL of the accelerator type resource to attach to this
  /// instance.
  ///
  /// For example:
  /// projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100
  /// If you are creating an instance template, specify only the accelerator
  /// name. See GPUs on Compute Engine for a full list of accelerator types.
  core.String? acceleratorType;

  AcceleratorConfig({
    this.acceleratorCount,
    this.acceleratorType,
  });

  AcceleratorConfig.fromJson(core.Map json_)
      : this(
          acceleratorCount: json_.containsKey('acceleratorCount')
              ? json_['acceleratorCount'] as core.int
              : null,
          acceleratorType: json_.containsKey('acceleratorType')
              ? json_['acceleratorType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (acceleratorCount != null) 'acceleratorCount': acceleratorCount!,
        if (acceleratorType != null) 'acceleratorType': acceleratorType!,
      };
}

/// Represents an Accelerator Type resource.
///
/// Google Cloud Platform provides graphics processing units (accelerators) that
/// you can add to VM instances to improve or accelerate performance when
/// working with intensive workloads. For more information, read GPUs on Compute
/// Engine.
class AcceleratorType {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this accelerator type.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// An optional textual description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The type of the resource.
  ///
  /// Always compute#acceleratorType for accelerator types.
  ///
  /// Output only.
  core.String? kind;

  /// Maximum number of accelerator cards allowed per instance.
  ///
  /// Output only.
  core.int? maximumCardsPerInstance;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// Server-defined, fully qualified URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The name of the zone where the accelerator type resides, such as
  /// us-central1-a.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? zone;

  AcceleratorType({
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.id,
    this.kind,
    this.maximumCardsPerInstance,
    this.name,
    this.selfLink,
    this.zone,
  });

  AcceleratorType.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          maximumCardsPerInstance: json_.containsKey('maximumCardsPerInstance')
              ? json_['maximumCardsPerInstance'] as core.int
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (maximumCardsPerInstance != null)
          'maximumCardsPerInstance': maximumCardsPerInstance!,
        if (name != null) 'name': name!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (zone != null) 'zone': zone!,
      };
}

class AcceleratorTypeAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AcceleratorTypeAggregatedListWarningData({
    this.key,
    this.value,
  });

  AcceleratorTypeAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AcceleratorTypeAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AcceleratorTypeAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AcceleratorTypeAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AcceleratorTypeAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      AcceleratorTypeAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AcceleratorTypeAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of AcceleratorTypesScopedList resources.
  core.Map<core.String, AcceleratorTypesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#acceleratorTypeAggregatedList for aggregated lists of
  /// accelerator types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  AcceleratorTypeAggregatedListWarning? warning;

  AcceleratorTypeAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  AcceleratorTypeAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    AcceleratorTypesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AcceleratorTypeAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class AcceleratorTypeListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AcceleratorTypeListWarningData({
    this.key,
    this.value,
  });

  AcceleratorTypeListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AcceleratorTypeListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AcceleratorTypeListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AcceleratorTypeListWarning({
    this.code,
    this.data,
    this.message,
  });

  AcceleratorTypeListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AcceleratorTypeListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of accelerator types.
class AcceleratorTypeList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of AcceleratorType resources.
  core.List<AcceleratorType>? items;

  /// Type of resource.
  ///
  /// Always compute#acceleratorTypeList for lists of accelerator types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  AcceleratorTypeListWarning? warning;

  AcceleratorTypeList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  AcceleratorTypeList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => AcceleratorType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? AcceleratorTypeListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class AcceleratorTypesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AcceleratorTypesScopedListWarningData({
    this.key,
    this.value,
  });

  AcceleratorTypesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the accelerator types list is
/// empty.
///
/// Output only.
class AcceleratorTypesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AcceleratorTypesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AcceleratorTypesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AcceleratorTypesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      AcceleratorTypesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AcceleratorTypesScopedList {
  /// A list of accelerator types contained in this scope.
  ///
  /// Output only.
  core.List<AcceleratorType>? acceleratorTypes;

  /// An informational warning that appears when the accelerator types list is
  /// empty.
  ///
  /// Output only.
  AcceleratorTypesScopedListWarning? warning;

  AcceleratorTypesScopedList({
    this.acceleratorTypes,
    this.warning,
  });

  AcceleratorTypesScopedList.fromJson(core.Map json_)
      : this(
          acceleratorTypes: json_.containsKey('acceleratorTypes')
              ? (json_['acceleratorTypes'] as core.List)
                  .map((value) => AcceleratorType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AcceleratorTypesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (acceleratorTypes != null) 'acceleratorTypes': acceleratorTypes!,
        if (warning != null) 'warning': warning!,
      };
}

/// An access configuration attached to an instance's network interface.
///
/// Only one access config per instance is supported.
class AccessConfig {
  /// The first IPv6 address of the external IPv6 range associated with this
  /// instance, prefix length is stored in externalIpv6PrefixLength in
  /// ipv6AccessConfig.
  ///
  /// The field is output only, an IPv6 address from a subnetwork associated
  /// with the instance will be allocated dynamically.
  core.String? externalIpv6;

  /// The prefix length of the external IPv6 range.
  core.int? externalIpv6PrefixLength;

  /// Type of the resource.
  ///
  /// Always compute#accessConfig for access configs.
  ///
  /// Output only.
  core.String? kind;

  /// The name of this access configuration.
  ///
  /// The default and recommended name is External NAT, but you can use any
  /// arbitrary string, such as My external IP or Network Access.
  core.String? name;

  /// An external IP address associated with this instance.
  ///
  /// Specify an unused static external IP address available to the project or
  /// leave this field undefined to use an IP from a shared ephemeral IP address
  /// pool. If you specify a static external IP address, it must live in the
  /// same region as the zone of the instance.
  core.String? natIP;

  /// This signifies the networking tier used for configuring this access
  /// configuration and can only take the following values: PREMIUM, STANDARD.
  ///
  /// If an AccessConfig is specified without a valid external IP address, an
  /// ephemeral IP will be created with this networkTier. If an AccessConfig
  /// with a valid external IP address is specified, it must match that of the
  /// networkTier associated with the Address resource owning that IP.
  /// Possible string values are:
  /// - "FIXED_STANDARD" : Public internet quality with fixed bandwidth.
  /// - "PREMIUM" : High quality, Google-grade network tier, support for all
  /// networking products.
  /// - "STANDARD" : Public internet quality, only limited support for other
  /// networking products.
  /// - "STANDARD_OVERRIDES_FIXED_STANDARD" : (Output only) Temporary tier for
  /// FIXED_STANDARD when fixed standard tier is expired or not configured.
  core.String? networkTier;

  /// The DNS domain name for the public PTR record.
  ///
  /// You can set this field only if the `setPublicPtr` field is enabled in
  /// accessConfig. If this field is unspecified in ipv6AccessConfig, a default
  /// PTR record will be createc for first IP in associated external IPv6 range.
  core.String? publicPtrDomainName;

  /// Specifies whether a public DNS 'PTR' record should be created to map the
  /// external IP address of the instance to a DNS domain name.
  ///
  /// This field is not used in ipv6AccessConfig. A default PTR record will be
  /// created if the VM has external IPv6 range associated.
  core.bool? setPublicPtr;

  /// The type of configuration.
  ///
  /// The default and only option is ONE_TO_ONE_NAT.
  /// Possible string values are:
  /// - "DIRECT_IPV6"
  /// - "ONE_TO_ONE_NAT"
  core.String? type;

  AccessConfig({
    this.externalIpv6,
    this.externalIpv6PrefixLength,
    this.kind,
    this.name,
    this.natIP,
    this.networkTier,
    this.publicPtrDomainName,
    this.setPublicPtr,
    this.type,
  });

  AccessConfig.fromJson(core.Map json_)
      : this(
          externalIpv6: json_.containsKey('externalIpv6')
              ? json_['externalIpv6'] as core.String
              : null,
          externalIpv6PrefixLength:
              json_.containsKey('externalIpv6PrefixLength')
                  ? json_['externalIpv6PrefixLength'] as core.int
                  : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          natIP:
              json_.containsKey('natIP') ? json_['natIP'] as core.String : null,
          networkTier: json_.containsKey('networkTier')
              ? json_['networkTier'] as core.String
              : null,
          publicPtrDomainName: json_.containsKey('publicPtrDomainName')
              ? json_['publicPtrDomainName'] as core.String
              : null,
          setPublicPtr: json_.containsKey('setPublicPtr')
              ? json_['setPublicPtr'] as core.bool
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (externalIpv6 != null) 'externalIpv6': externalIpv6!,
        if (externalIpv6PrefixLength != null)
          'externalIpv6PrefixLength': externalIpv6PrefixLength!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (natIP != null) 'natIP': natIP!,
        if (networkTier != null) 'networkTier': networkTier!,
        if (publicPtrDomainName != null)
          'publicPtrDomainName': publicPtrDomainName!,
        if (setPublicPtr != null) 'setPublicPtr': setPublicPtr!,
        if (type != null) 'type': type!,
      };
}

/// Represents an IP Address resource.
///
/// Google Compute Engine has two IP Address resources: * \[Global (external and
/// internal)\](https://cloud.google.com/compute/docs/reference/rest/v1/globalAddresses)
/// * \[Regional (external and
/// internal)\](https://cloud.google.com/compute/docs/reference/rest/v1/addresses)
/// For more information, see Reserving a static external IP address.
class Address {
  /// The static IP address represented by this resource.
  core.String? address;

  /// The type of address to reserve, either INTERNAL or EXTERNAL.
  ///
  /// If unspecified, defaults to EXTERNAL.
  /// Possible string values are:
  /// - "EXTERNAL" : A publicly visible external IP address.
  /// - "INTERNAL" : A private network IP address, for use with an Instance or
  /// Internal Load Balancer forwarding rule.
  /// - "UNSPECIFIED_TYPE"
  core.String? addressType;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this field when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The IP version that will be used by this address.
  ///
  /// Valid options are IPV4 or IPV6. This can only be specified for a global
  /// address.
  /// Possible string values are:
  /// - "IPV4"
  /// - "IPV6"
  /// - "UNSPECIFIED_VERSION"
  core.String? ipVersion;

  /// Type of the resource.
  ///
  /// Always compute#address for addresses.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase
  /// letter, and all following characters (except for the last character) must
  /// be a dash, lowercase letter, or digit. The last character must be a
  /// lowercase letter or digit.
  core.String? name;

  /// The URL of the network in which to reserve the address.
  ///
  /// This field can only be used with INTERNAL type with the VPC_PEERING
  /// purpose.
  core.String? network;

  /// This signifies the networking tier used for configuring this address and
  /// can only take the following values: PREMIUM or STANDARD.
  ///
  /// Internal IP addresses are always Premium Tier; global external IP
  /// addresses are always Premium Tier; regional external IP addresses can be
  /// either Standard or Premium Tier. If this field is not specified, it is
  /// assumed to be PREMIUM.
  /// Possible string values are:
  /// - "FIXED_STANDARD" : Public internet quality with fixed bandwidth.
  /// - "PREMIUM" : High quality, Google-grade network tier, support for all
  /// networking products.
  /// - "STANDARD" : Public internet quality, only limited support for other
  /// networking products.
  /// - "STANDARD_OVERRIDES_FIXED_STANDARD" : (Output only) Temporary tier for
  /// FIXED_STANDARD when fixed standard tier is expired or not configured.
  core.String? networkTier;

  /// The prefix length if the resource represents an IP range.
  core.int? prefixLength;

  /// The purpose of this resource, which can be one of the following values: -
  /// GCE_ENDPOINT for addresses that are used by VM instances, alias IP ranges,
  /// load balancers, and similar resources.
  ///
  /// - DNS_RESOLVER for a DNS resolver address in a subnetwork for a Cloud DNS
  /// inbound forwarder IP addresses (regional internal IP address in a subnet
  /// of a VPC network) - VPC_PEERING for global internal IP addresses used for
  /// private services access allocated ranges. - NAT_AUTO for the regional
  /// external IP addresses used by Cloud NAT when allocating addresses using
  /// automatic NAT IP address allocation. - IPSEC_INTERCONNECT for addresses
  /// created from a private IP range that are reserved for a VLAN attachment in
  /// an *HA VPN over Cloud Interconnect* configuration. These addresses are
  /// regional resources. - `SHARED_LOADBALANCER_VIP` for an internal IP address
  /// that is assigned to multiple internal forwarding rules. -
  /// `PRIVATE_SERVICE_CONNECT` for a private network address that is used to
  /// configure Private Service Connect. Only global internal addresses can use
  /// this purpose.
  /// Possible string values are:
  /// - "DNS_RESOLVER" : DNS resolver address in the subnetwork.
  /// - "GCE_ENDPOINT" : VM internal/alias IP, Internal LB service IP, etc.
  /// - "IPSEC_INTERCONNECT" : A regional internal IP address range reserved for
  /// the VLAN attachment that is used in HA VPN over Cloud Interconnect. This
  /// regional internal IP address range must not overlap with any IP address
  /// range of subnet/route in the VPC network and its peering networks. After
  /// the VLAN attachment is created with the reserved IP address range, when
  /// creating a new VPN gateway, its interface IP address is allocated from the
  /// associated VLAN attachment’s IP address range.
  /// - "NAT_AUTO" : External IP automatically reserved for Cloud NAT.
  /// - "PRIVATE_SERVICE_CONNECT" : A private network IP address that can be
  /// used to configure Private Service Connect. This purpose can be specified
  /// only for GLOBAL addresses of Type INTERNAL
  /// - "SERVERLESS" : A regional internal IP address range reserved for
  /// Serverless.
  /// - "SHARED_LOADBALANCER_VIP" : A private network IP address that can be
  /// shared by multiple Internal Load Balancer forwarding rules.
  /// - "VPC_PEERING" : IP range for peer networks.
  core.String? purpose;

  /// The URL of the region where a regional address resides.
  ///
  /// For regional addresses, you must specify the region as a path parameter in
  /// the HTTP request URL. *This field is not applicable to global addresses.*
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The status of the address, which can be one of RESERVING, RESERVED, or
  /// IN_USE.
  ///
  /// An address that is RESERVING is currently in the process of being
  /// reserved. A RESERVED address is currently reserved and available to use.
  /// An IN_USE address is currently being used by another resource and is not
  /// available.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "IN_USE" : Address is being used by another resource and is not
  /// available.
  /// - "RESERVED" : Address is reserved and available to use.
  /// - "RESERVING" : Address is being reserved.
  core.String? status;

  /// The URL of the subnetwork in which to reserve the address.
  ///
  /// If an IP address is specified, it must be within the subnetwork's IP
  /// range. This field can only be used with INTERNAL type with a GCE_ENDPOINT
  /// or DNS_RESOLVER purpose.
  core.String? subnetwork;

  /// The URLs of the resources that are using this address.
  ///
  /// Output only.
  core.List<core.String>? users;

  Address({
    this.address,
    this.addressType,
    this.creationTimestamp,
    this.description,
    this.id,
    this.ipVersion,
    this.kind,
    this.name,
    this.network,
    this.networkTier,
    this.prefixLength,
    this.purpose,
    this.region,
    this.selfLink,
    this.status,
    this.subnetwork,
    this.users,
  });

  Address.fromJson(core.Map json_)
      : this(
          address: json_.containsKey('address')
              ? json_['address'] as core.String
              : null,
          addressType: json_.containsKey('addressType')
              ? json_['addressType'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          ipVersion: json_.containsKey('ipVersion')
              ? json_['ipVersion'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          networkTier: json_.containsKey('networkTier')
              ? json_['networkTier'] as core.String
              : null,
          prefixLength: json_.containsKey('prefixLength')
              ? json_['prefixLength'] as core.int
              : null,
          purpose: json_.containsKey('purpose')
              ? json_['purpose'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
          users: json_.containsKey('users')
              ? (json_['users'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (address != null) 'address': address!,
        if (addressType != null) 'addressType': addressType!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (ipVersion != null) 'ipVersion': ipVersion!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (networkTier != null) 'networkTier': networkTier!,
        if (prefixLength != null) 'prefixLength': prefixLength!,
        if (purpose != null) 'purpose': purpose!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
        if (users != null) 'users': users!,
      };
}

class AddressAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AddressAggregatedListWarningData({
    this.key,
    this.value,
  });

  AddressAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AddressAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AddressAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AddressAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AddressAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AddressAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AddressAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of AddressesScopedList resources.
  core.Map<core.String, AddressesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#addressAggregatedList for aggregated lists of addresses.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  AddressAggregatedListWarning? warning;

  AddressAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  AddressAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    AddressesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AddressAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class AddressListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AddressListWarningData({
    this.key,
    this.value,
  });

  AddressListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AddressListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AddressListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AddressListWarning({
    this.code,
    this.data,
    this.message,
  });

  AddressListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AddressListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of addresses.
class AddressList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Address resources.
  core.List<Address>? items;

  /// Type of resource.
  ///
  /// Always compute#addressList for lists of addresses.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  AddressListWarning? warning;

  AddressList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  AddressList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Address.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? AddressListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class AddressesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AddressesScopedListWarningData({
    this.key,
    this.value,
  });

  AddressesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
///
/// Output only.
class AddressesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AddressesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AddressesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AddressesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AddressesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AddressesScopedList {
  /// A list of addresses contained in this scope.
  ///
  /// Output only.
  core.List<Address>? addresses;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  ///
  /// Output only.
  AddressesScopedListWarning? warning;

  AddressesScopedList({
    this.addresses,
    this.warning,
  });

  AddressesScopedList.fromJson(core.Map json_)
      : this(
          addresses: json_.containsKey('addresses')
              ? (json_['addresses'] as core.List)
                  .map((value) => Address.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AddressesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (addresses != null) 'addresses': addresses!,
        if (warning != null) 'warning': warning!,
      };
}

/// Specifies options for controlling advanced machine features.
///
/// Options that would traditionally be configured in a BIOS belong here.
/// Features that require operating system support may have corresponding
/// entries in the GuestOsFeatures of an Image (e.g., whether or not the OS in
/// the Image supports nested virtualization being enabled or disabled).
class AdvancedMachineFeatures {
  /// Whether to enable nested virtualization or not (default is false).
  core.bool? enableNestedVirtualization;

  /// Whether to enable UEFI networking for instance creation.
  core.bool? enableUefiNetworking;

  /// The number of threads per physical core.
  ///
  /// To disable simultaneous multithreading (SMT) set this to 1. If unset, the
  /// maximum number of threads supported per core by the underlying processor
  /// is assumed.
  core.int? threadsPerCore;

  /// The number of physical cores to expose to an instance.
  ///
  /// Multiply by the number of threads per core to compute the total number of
  /// virtual CPUs to expose to the instance. If unset, the number of cores is
  /// inferred from the instance's nominal CPU count and the underlying
  /// platform's SMT width.
  core.int? visibleCoreCount;

  AdvancedMachineFeatures({
    this.enableNestedVirtualization,
    this.enableUefiNetworking,
    this.threadsPerCore,
    this.visibleCoreCount,
  });

  AdvancedMachineFeatures.fromJson(core.Map json_)
      : this(
          enableNestedVirtualization:
              json_.containsKey('enableNestedVirtualization')
                  ? json_['enableNestedVirtualization'] as core.bool
                  : null,
          enableUefiNetworking: json_.containsKey('enableUefiNetworking')
              ? json_['enableUefiNetworking'] as core.bool
              : null,
          threadsPerCore: json_.containsKey('threadsPerCore')
              ? json_['threadsPerCore'] as core.int
              : null,
          visibleCoreCount: json_.containsKey('visibleCoreCount')
              ? json_['visibleCoreCount'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enableNestedVirtualization != null)
          'enableNestedVirtualization': enableNestedVirtualization!,
        if (enableUefiNetworking != null)
          'enableUefiNetworking': enableUefiNetworking!,
        if (threadsPerCore != null) 'threadsPerCore': threadsPerCore!,
        if (visibleCoreCount != null) 'visibleCoreCount': visibleCoreCount!,
      };
}

/// An alias IP range attached to an instance's network interface.
class AliasIpRange {
  /// The IP alias ranges to allocate for this interface.
  ///
  /// This IP CIDR range must belong to the specified subnetwork and cannot
  /// contain IP addresses reserved by system or used by other network
  /// interfaces. This range may be a single IP address (such as 10.2.3.4), a
  /// netmask (such as /24) or a CIDR-formatted string (such as 10.1.2.0/24).
  core.String? ipCidrRange;

  /// The name of a subnetwork secondary IP range from which to allocate an IP
  /// alias range.
  ///
  /// If not specified, the primary range of the subnetwork is used.
  core.String? subnetworkRangeName;

  AliasIpRange({
    this.ipCidrRange,
    this.subnetworkRangeName,
  });

  AliasIpRange.fromJson(core.Map json_)
      : this(
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          subnetworkRangeName: json_.containsKey('subnetworkRangeName')
              ? json_['subnetworkRangeName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (subnetworkRangeName != null)
          'subnetworkRangeName': subnetworkRangeName!,
      };
}

class AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk {
  /// Specifies the size of the disk in base-2 GB.
  core.String? diskSizeGb;

  /// Specifies the disk interface to use for attaching this disk, which is
  /// either SCSI or NVME.
  ///
  /// The default is SCSI. For performance characteristics of SCSI over NVMe,
  /// see Local SSD performance.
  /// Possible string values are:
  /// - "NVME"
  /// - "SCSI"
  core.String? interface;

  AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk({
    this.diskSizeGb,
    this.interface,
  });

  AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.fromJson(
      core.Map json_)
      : this(
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          interface: json_.containsKey('interface')
              ? json_['interface'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (interface != null) 'interface': interface!,
      };
}

/// Properties of the SKU instances being reserved.
///
/// Next ID: 9
class AllocationSpecificSKUAllocationReservedInstanceProperties {
  /// Specifies accelerator type and count.
  core.List<AcceleratorConfig>? guestAccelerators;

  /// Specifies amount of local ssd to reserve with each instance.
  ///
  /// The type of disk is local-ssd.
  core.List<
          AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk>?
      localSsds;

  /// An opaque location hint used to place the allocation close to other
  /// resources.
  ///
  /// This field is for use by internal tools that use the public API.
  core.String? locationHint;

  /// Specifies type of machine (name only) which has fixed number of vCPUs and
  /// fixed amount of memory.
  ///
  /// This also includes specifying custom machine type following
  /// custom-NUMBER_OF_CPUS-AMOUNT_OF_MEMORY pattern.
  core.String? machineType;

  /// Minimum cpu platform the reservation.
  core.String? minCpuPlatform;

  AllocationSpecificSKUAllocationReservedInstanceProperties({
    this.guestAccelerators,
    this.localSsds,
    this.locationHint,
    this.machineType,
    this.minCpuPlatform,
  });

  AllocationSpecificSKUAllocationReservedInstanceProperties.fromJson(
      core.Map json_)
      : this(
          guestAccelerators: json_.containsKey('guestAccelerators')
              ? (json_['guestAccelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          localSsds: json_.containsKey('localSsds')
              ? (json_['localSsds'] as core.List)
                  .map((value) =>
                      AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          locationHint: json_.containsKey('locationHint')
              ? json_['locationHint'] as core.String
              : null,
          machineType: json_.containsKey('machineType')
              ? json_['machineType'] as core.String
              : null,
          minCpuPlatform: json_.containsKey('minCpuPlatform')
              ? json_['minCpuPlatform'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (guestAccelerators != null) 'guestAccelerators': guestAccelerators!,
        if (localSsds != null) 'localSsds': localSsds!,
        if (locationHint != null) 'locationHint': locationHint!,
        if (machineType != null) 'machineType': machineType!,
        if (minCpuPlatform != null) 'minCpuPlatform': minCpuPlatform!,
      };
}

/// This reservation type allows to pre allocate specific instance
/// configuration.
///
/// Next ID: 6
class AllocationSpecificSKUReservation {
  /// Indicates how many instances are actually usable currently.
  ///
  /// Output only.
  core.String? assuredCount;

  /// Specifies the number of resources that are allocated.
  core.String? count;

  /// Indicates how many instances are in use.
  ///
  /// Output only.
  core.String? inUseCount;

  /// The instance properties for the reservation.
  AllocationSpecificSKUAllocationReservedInstanceProperties? instanceProperties;

  AllocationSpecificSKUReservation({
    this.assuredCount,
    this.count,
    this.inUseCount,
    this.instanceProperties,
  });

  AllocationSpecificSKUReservation.fromJson(core.Map json_)
      : this(
          assuredCount: json_.containsKey('assuredCount')
              ? json_['assuredCount'] as core.String
              : null,
          count:
              json_.containsKey('count') ? json_['count'] as core.String : null,
          inUseCount: json_.containsKey('inUseCount')
              ? json_['inUseCount'] as core.String
              : null,
          instanceProperties: json_.containsKey('instanceProperties')
              ? AllocationSpecificSKUAllocationReservedInstanceProperties
                  .fromJson(json_['instanceProperties']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (assuredCount != null) 'assuredCount': assuredCount!,
        if (count != null) 'count': count!,
        if (inUseCount != null) 'inUseCount': inUseCount!,
        if (instanceProperties != null)
          'instanceProperties': instanceProperties!,
      };
}

/// An instance-attached disk resource.
class AttachedDisk {
  /// The architecture of the attached disk.
  ///
  /// Valid values are ARM64 or X86_64.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// Specifies whether the disk will be auto-deleted when the instance is
  /// deleted (but not when the disk is detached from the instance).
  core.bool? autoDelete;

  /// Indicates that this is a boot disk.
  ///
  /// The virtual machine will use the first partition of the disk for its root
  /// filesystem.
  core.bool? boot;

  /// Specifies a unique device name of your choice that is reflected into the
  /// /dev/disk/by-id/google-* tree of a Linux operating system running within
  /// the instance.
  ///
  /// This name can be used to reference the device for mounting, resizing, and
  /// so on, from within the instance. If not specified, the server chooses a
  /// default device name to apply to this disk, in the form persistent-disk-x,
  /// where x is a number assigned by Google Compute Engine. This field is only
  /// applicable for persistent disks.
  core.String? deviceName;

  /// Encrypts or decrypts a disk using a customer-supplied encryption key.
  ///
  /// If you are creating a new disk, this field encrypts the new disk using an
  /// encryption key that you provide. If you are attaching an existing disk
  /// that is already encrypted, this field decrypts the disk using the
  /// customer-supplied encryption key. If you encrypt a disk using a
  /// customer-supplied key, you must provide the same key again when you
  /// attempt to use this resource at a later time. For example, you must
  /// provide the key when you create a snapshot or an image from the disk or
  /// when you attach the disk to a virtual machine instance. If you do not
  /// provide an encryption key, then the disk will be encrypted using an
  /// automatically generated key and you do not need to provide a key to use
  /// the disk later. Instance templates do not store customer-supplied
  /// encryption keys, so you cannot use your own keys to encrypt disks in a
  /// managed instance group.
  CustomerEncryptionKey? diskEncryptionKey;

  /// The size of the disk in GB.
  core.String? diskSizeGb;

  /// \[Input Only\] Whether to force attach the regional disk even if it's
  /// currently attached to another instance.
  ///
  /// If you try to force attach a zonal disk to an instance, you will receive
  /// an error.
  core.bool? forceAttach;

  /// A list of features to enable on the guest operating system.
  ///
  /// Applicable only for bootable images. Read Enabling guest operating system
  /// features to see a list of available options.
  core.List<GuestOsFeature>? guestOsFeatures;

  /// A zero-based index to this disk, where 0 is reserved for the boot disk.
  ///
  /// If you have many disks attached to an instance, each disk would have a
  /// unique index number.
  ///
  /// Output only.
  core.int? index;

  /// \[Input Only\] Specifies the parameters for a new disk that will be
  /// created alongside the new instance.
  ///
  /// Use initialization parameters to create boot disks or local SSDs attached
  /// to the new instance. This property is mutually exclusive with the source
  /// property; you can only define one or the other, but not both.
  AttachedDiskInitializeParams? initializeParams;

  /// Specifies the disk interface to use for attaching this disk, which is
  /// either SCSI or NVME.
  ///
  /// For most machine types, the default is SCSI. Local SSDs can use either
  /// NVME or SCSI. In certain configurations, persistent disks can use NVMe.
  /// For more information, see About persistent disks.
  /// Possible string values are:
  /// - "NVME"
  /// - "SCSI"
  core.String? interface;

  /// Type of the resource.
  ///
  /// Always compute#attachedDisk for attached disks.
  ///
  /// Output only.
  core.String? kind;

  /// Any valid publicly visible licenses.
  ///
  /// Output only.
  core.List<core.String>? licenses;

  /// The mode in which to attach this disk, either READ_WRITE or READ_ONLY.
  ///
  /// If not specified, the default is to attach the disk in READ_WRITE mode.
  /// Possible string values are:
  /// - "READ_ONLY" : Attaches this disk in read-only mode. Multiple virtual
  /// machines can use a disk in read-only mode at a time.
  /// - "READ_WRITE" : *\[Default\]* Attaches this disk in read-write mode. Only
  /// one virtual machine at a time can be attached to a disk in read-write
  /// mode.
  core.String? mode;

  /// shielded vm initial state stored on disk
  ///
  /// Output only.
  InitialStateConfig? shieldedInstanceInitialState;

  /// Specifies a valid partial or full URL to an existing Persistent Disk
  /// resource.
  ///
  /// When creating a new instance, one of initializeParams.sourceImage or
  /// initializeParams.sourceSnapshot or disks.source is required except for
  /// local SSD. If desired, you can also attach existing non-root persistent
  /// disks using this property. This field is only applicable for persistent
  /// disks. Note that for InstanceTemplate, specify the disk name for zonal
  /// disk, and the URL for regional disk.
  core.String? source;

  /// Specifies the type of the disk, either SCRATCH or PERSISTENT.
  ///
  /// If not specified, the default is PERSISTENT.
  /// Possible string values are:
  /// - "PERSISTENT"
  /// - "SCRATCH"
  core.String? type;

  AttachedDisk({
    this.architecture,
    this.autoDelete,
    this.boot,
    this.deviceName,
    this.diskEncryptionKey,
    this.diskSizeGb,
    this.forceAttach,
    this.guestOsFeatures,
    this.index,
    this.initializeParams,
    this.interface,
    this.kind,
    this.licenses,
    this.mode,
    this.shieldedInstanceInitialState,
    this.source,
    this.type,
  });

  AttachedDisk.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          autoDelete: json_.containsKey('autoDelete')
              ? json_['autoDelete'] as core.bool
              : null,
          boot: json_.containsKey('boot') ? json_['boot'] as core.bool : null,
          deviceName: json_.containsKey('deviceName')
              ? json_['deviceName'] as core.String
              : null,
          diskEncryptionKey: json_.containsKey('diskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['diskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          forceAttach: json_.containsKey('forceAttach')
              ? json_['forceAttach'] as core.bool
              : null,
          guestOsFeatures: json_.containsKey('guestOsFeatures')
              ? (json_['guestOsFeatures'] as core.List)
                  .map((value) => GuestOsFeature.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          index: json_.containsKey('index') ? json_['index'] as core.int : null,
          initializeParams: json_.containsKey('initializeParams')
              ? AttachedDiskInitializeParams.fromJson(json_['initializeParams']
                  as core.Map<core.String, core.dynamic>)
              : null,
          interface: json_.containsKey('interface')
              ? json_['interface'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          mode: json_.containsKey('mode') ? json_['mode'] as core.String : null,
          shieldedInstanceInitialState:
              json_.containsKey('shieldedInstanceInitialState')
                  ? InitialStateConfig.fromJson(
                      json_['shieldedInstanceInitialState']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (autoDelete != null) 'autoDelete': autoDelete!,
        if (boot != null) 'boot': boot!,
        if (deviceName != null) 'deviceName': deviceName!,
        if (diskEncryptionKey != null) 'diskEncryptionKey': diskEncryptionKey!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (forceAttach != null) 'forceAttach': forceAttach!,
        if (guestOsFeatures != null) 'guestOsFeatures': guestOsFeatures!,
        if (index != null) 'index': index!,
        if (initializeParams != null) 'initializeParams': initializeParams!,
        if (interface != null) 'interface': interface!,
        if (kind != null) 'kind': kind!,
        if (licenses != null) 'licenses': licenses!,
        if (mode != null) 'mode': mode!,
        if (shieldedInstanceInitialState != null)
          'shieldedInstanceInitialState': shieldedInstanceInitialState!,
        if (source != null) 'source': source!,
        if (type != null) 'type': type!,
      };
}

/// \[Input Only\] Specifies the parameters for a new disk that will be created
/// alongside the new instance.
///
/// Use initialization parameters to create boot disks or local SSDs attached to
/// the new instance. This field is persisted and returned for instanceTemplate
/// and not returned in the context of instance. This property is mutually
/// exclusive with the source property; you can only define one or the other,
/// but not both.
class AttachedDiskInitializeParams {
  /// The architecture of the attached disk.
  ///
  /// Valid values are arm64 or x86_64.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// An optional description.
  ///
  /// Provide this property when creating the disk.
  core.String? description;

  /// Specifies the disk name.
  ///
  /// If not specified, the default is to use the name of the instance. If a
  /// disk with the same name already exists in the given region, the existing
  /// disk is attached to the new instance and the new disk is not created.
  core.String? diskName;

  /// Specifies the size of the disk in base-2 GB.
  ///
  /// The size must be at least 10 GB. If you specify a sourceImage, which is
  /// required for boot disks, the default size is the size of the sourceImage.
  /// If you do not specify a sourceImage, the default disk size is 500 GB.
  core.String? diskSizeGb;

  /// Specifies the disk type to use to create the instance.
  ///
  /// If not specified, the default is pd-standard, specified using the full
  /// URL. For example:
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /diskTypes/pd-standard For a full list of acceptable values, see
  /// Persistent disk types. If you define this field, you can provide either
  /// the full or partial URL. For example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /diskTypes/diskType - projects/project/zones/zone/diskTypes/diskType -
  /// zones/zone/diskTypes/diskType Note that for InstanceTemplate, this is the
  /// name of the disk type, not URL.
  core.String? diskType;

  /// Labels to apply to this disk.
  ///
  /// These can be later modified by the disks.setLabels method. This field is
  /// only applicable for persistent disks.
  core.Map<core.String, core.String>? labels;

  /// A list of publicly visible licenses.
  ///
  /// Reserved for Google's use.
  core.List<core.String>? licenses;

  /// Specifies which action to take on instance update with this disk.
  ///
  /// Default is to use the existing disk.
  /// Possible string values are:
  /// - "RECREATE_DISK" : Always recreate the disk.
  /// - "RECREATE_DISK_IF_SOURCE_CHANGED" : Recreate the disk if source (image,
  /// snapshot) of this disk is different from source of existing disk.
  /// - "USE_EXISTING_DISK" : Use the existing disk, this is the default
  /// behaviour.
  core.String? onUpdateAction;

  /// Indicates how many IOPS to provision for the disk.
  ///
  /// This sets the number of I/O operations per second that the disk can
  /// handle. Values must be between 10,000 and 120,000. For more details, see
  /// the Extreme persistent disk documentation.
  core.String? provisionedIops;

  /// Resource manager tags to be bound to the disk.
  ///
  /// Tag keys and values have the same definition as resource manager tags.
  /// Keys must be in the format `tagKeys/{tag_key_id}`, and values are in the
  /// format `tagValues/456`. The field is ignored (both PUT & PATCH) when
  /// empty.
  core.Map<core.String, core.String>? resourceManagerTags;

  /// Resource policies applied to this disk for automatic snapshot creations.
  ///
  /// Specified using the full or partial URL. For instance template, specify
  /// only the resource policy name.
  core.List<core.String>? resourcePolicies;

  /// The source image to create this disk.
  ///
  /// When creating a new instance, one of initializeParams.sourceImage or
  /// initializeParams.sourceSnapshot or disks.source is required except for
  /// local SSD. To create a disk with one of the public operating system
  /// images, specify the image by its family name. For example, specify
  /// family/debian-9 to use the latest Debian 9 image:
  /// projects/debian-cloud/global/images/family/debian-9 Alternatively, use a
  /// specific version of a public operating system image:
  /// projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD To create a
  /// disk with a custom image that you created, specify the image name in the
  /// following format: global/images/my-custom-image You can also specify a
  /// custom image by its image family, which returns the latest version of the
  /// image in that family. Replace the image name with family/family-name:
  /// global/images/family/my-image-family If the source image is deleted later,
  /// this field will not be set.
  core.String? sourceImage;

  /// The customer-supplied encryption key of the source image.
  ///
  /// Required if the source image is protected by a customer-supplied
  /// encryption key. Instance templates do not store customer-supplied
  /// encryption keys, so you cannot create disks for instances in a managed
  /// instance group if the source images are encrypted with your own keys.
  CustomerEncryptionKey? sourceImageEncryptionKey;

  /// The source snapshot to create this disk.
  ///
  /// When creating a new instance, one of initializeParams.sourceSnapshot or
  /// initializeParams.sourceImage or disks.source is required except for local
  /// SSD. To create a disk with a snapshot that you created, specify the
  /// snapshot name in the following format: global/snapshots/my-backup If the
  /// source snapshot is deleted later, this field will not be set.
  core.String? sourceSnapshot;

  /// The customer-supplied encryption key of the source snapshot.
  CustomerEncryptionKey? sourceSnapshotEncryptionKey;

  AttachedDiskInitializeParams({
    this.architecture,
    this.description,
    this.diskName,
    this.diskSizeGb,
    this.diskType,
    this.labels,
    this.licenses,
    this.onUpdateAction,
    this.provisionedIops,
    this.resourceManagerTags,
    this.resourcePolicies,
    this.sourceImage,
    this.sourceImageEncryptionKey,
    this.sourceSnapshot,
    this.sourceSnapshotEncryptionKey,
  });

  AttachedDiskInitializeParams.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          diskName: json_.containsKey('diskName')
              ? json_['diskName'] as core.String
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          diskType: json_.containsKey('diskType')
              ? json_['diskType'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          onUpdateAction: json_.containsKey('onUpdateAction')
              ? json_['onUpdateAction'] as core.String
              : null,
          provisionedIops: json_.containsKey('provisionedIops')
              ? json_['provisionedIops'] as core.String
              : null,
          resourceManagerTags: json_.containsKey('resourceManagerTags')
              ? (json_['resourceManagerTags']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sourceImage: json_.containsKey('sourceImage')
              ? json_['sourceImage'] as core.String
              : null,
          sourceImageEncryptionKey: json_
                  .containsKey('sourceImageEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['sourceImageEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceSnapshot: json_.containsKey('sourceSnapshot')
              ? json_['sourceSnapshot'] as core.String
              : null,
          sourceSnapshotEncryptionKey:
              json_.containsKey('sourceSnapshotEncryptionKey')
                  ? CustomerEncryptionKey.fromJson(
                      json_['sourceSnapshotEncryptionKey']
                          as core.Map<core.String, core.dynamic>)
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (description != null) 'description': description!,
        if (diskName != null) 'diskName': diskName!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (diskType != null) 'diskType': diskType!,
        if (labels != null) 'labels': labels!,
        if (licenses != null) 'licenses': licenses!,
        if (onUpdateAction != null) 'onUpdateAction': onUpdateAction!,
        if (provisionedIops != null) 'provisionedIops': provisionedIops!,
        if (resourceManagerTags != null)
          'resourceManagerTags': resourceManagerTags!,
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
        if (sourceImage != null) 'sourceImage': sourceImage!,
        if (sourceImageEncryptionKey != null)
          'sourceImageEncryptionKey': sourceImageEncryptionKey!,
        if (sourceSnapshot != null) 'sourceSnapshot': sourceSnapshot!,
        if (sourceSnapshotEncryptionKey != null)
          'sourceSnapshotEncryptionKey': sourceSnapshotEncryptionKey!,
      };
}

/// Specifies the audit configuration for a service.
///
/// The configuration determines which permission types are logged, and what
/// identities, if any, are exempted from logging. An AuditConfig must have one
/// or more AuditLogConfigs. If there are AuditConfigs for both `allServices`
/// and a specific service, the union of the two AuditConfigs is used for that
/// service: the log_types specified in each AuditConfig are enabled, and the
/// exempted_members in each AuditLogConfig are exempted. Example Policy with
/// multiple AuditConfigs: { "audit_configs": \[ { "service": "allServices",
/// "audit_log_configs": \[ { "log_type": "DATA_READ", "exempted_members": \[
/// "user:jose@example.com" \] }, { "log_type": "DATA_WRITE" }, { "log_type":
/// "ADMIN_READ" } \] }, { "service": "sampleservice.googleapis.com",
/// "audit_log_configs": \[ { "log_type": "DATA_READ" }, { "log_type":
/// "DATA_WRITE", "exempted_members": \[ "user:aliya@example.com" \] } \] } \] }
/// For sampleservice, this policy enables DATA_READ, DATA_WRITE and ADMIN_READ
/// logging. It also exempts jose@example.com from DATA_READ logging, and
/// aliya@example.com from DATA_WRITE logging.
class AuditConfig {
  /// The configuration for logging of each type of permission.
  core.List<AuditLogConfig>? auditLogConfigs;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<core.String>? exemptedMembers;

  /// Specifies a service that will be enabled for audit logging.
  ///
  /// For example, `storage.googleapis.com`, `cloudsql.googleapis.com`.
  /// `allServices` is a special value that covers all services.
  core.String? service;

  AuditConfig({
    this.auditLogConfigs,
    this.exemptedMembers,
    this.service,
  });

  AuditConfig.fromJson(core.Map json_)
      : this(
          auditLogConfigs: json_.containsKey('auditLogConfigs')
              ? (json_['auditLogConfigs'] as core.List)
                  .map((value) => AuditLogConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          exemptedMembers: json_.containsKey('exemptedMembers')
              ? (json_['exemptedMembers'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (auditLogConfigs != null) 'auditLogConfigs': auditLogConfigs!,
        if (exemptedMembers != null) 'exemptedMembers': exemptedMembers!,
        if (service != null) 'service': service!,
      };
}

/// Provides the configuration for logging a type of permissions.
///
/// Example: { "audit_log_configs": \[ { "log_type": "DATA_READ",
/// "exempted_members": \[ "user:jose@example.com" \] }, { "log_type":
/// "DATA_WRITE" } \] } This enables 'DATA_READ' and 'DATA_WRITE' logging, while
/// exempting jose@example.com from DATA_READ logging.
class AuditLogConfig {
  /// Specifies the identities that do not cause logging for this type of
  /// permission.
  ///
  /// Follows the same format of Binding.members.
  core.List<core.String>? exemptedMembers;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.bool? ignoreChildExemptions;

  /// The log type that this config enables.
  /// Possible string values are:
  /// - "ADMIN_READ" : Admin reads. Example: CloudIAM getIamPolicy
  /// - "DATA_READ" : Data reads. Example: CloudSQL Users list
  /// - "DATA_WRITE" : Data writes. Example: CloudSQL Users create
  /// - "LOG_TYPE_UNSPECIFIED" : Default case. Should never be this.
  core.String? logType;

  AuditLogConfig({
    this.exemptedMembers,
    this.ignoreChildExemptions,
    this.logType,
  });

  AuditLogConfig.fromJson(core.Map json_)
      : this(
          exemptedMembers: json_.containsKey('exemptedMembers')
              ? (json_['exemptedMembers'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          ignoreChildExemptions: json_.containsKey('ignoreChildExemptions')
              ? json_['ignoreChildExemptions'] as core.bool
              : null,
          logType: json_.containsKey('logType')
              ? json_['logType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (exemptedMembers != null) 'exemptedMembers': exemptedMembers!,
        if (ignoreChildExemptions != null)
          'ignoreChildExemptions': ignoreChildExemptions!,
        if (logType != null) 'logType': logType!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class AuthorizationLoggingOptions {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "ADMIN_READ" : This is deprecated and has no effect. Do not use.
  /// - "ADMIN_WRITE" : This is deprecated and has no effect. Do not use.
  /// - "DATA_READ" : This is deprecated and has no effect. Do not use.
  /// - "DATA_WRITE" : This is deprecated and has no effect. Do not use.
  /// - "PERMISSION_TYPE_UNSPECIFIED" : This is deprecated and has no effect. Do
  /// not use.
  core.String? permissionType;

  AuthorizationLoggingOptions({
    this.permissionType,
  });

  AuthorizationLoggingOptions.fromJson(core.Map json_)
      : this(
          permissionType: json_.containsKey('permissionType')
              ? json_['permissionType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (permissionType != null) 'permissionType': permissionType!,
      };
}

/// Represents an Autoscaler resource.
///
/// Google Compute Engine has two Autoscaler resources: *
/// \[Zonal\](/compute/docs/reference/rest/v1/autoscalers) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionAutoscalers) Use
/// autoscalers to automatically add or delete instances from a managed instance
/// group according to your defined autoscaling policy. For more information,
/// read Autoscaling Groups of Instances. For zonal managed instance groups
/// resource, use the autoscaler resource. For regional managed instance groups,
/// use the regionAutoscalers resource.
class Autoscaler {
  /// The configuration parameters for the autoscaling algorithm.
  ///
  /// You can define one or more signals for an autoscaler: cpuUtilization,
  /// customMetricUtilizations, and loadBalancingUtilization. If none of these
  /// are specified, the default will be to autoscale based on cpuUtilization to
  /// 0.6 or 60%.
  AutoscalingPolicy? autoscalingPolicy;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#autoscaler for autoscalers.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Target recommended MIG size (number of instances) computed by autoscaler.
  ///
  /// Autoscaler calculates the recommended MIG size even when the autoscaling
  /// policy mode is different from ON. This field is empty when autoscaler is
  /// not connected to an existing managed instance group or autoscaler did not
  /// generate its prediction.
  ///
  /// Output only.
  core.int? recommendedSize;

  /// URL of the region where the instance group resides (for autoscalers living
  /// in regional scope).
  ///
  /// Output only.
  core.String? region;

  /// Status information of existing scaling schedules.
  ///
  /// Output only.
  core.Map<core.String, ScalingScheduleStatus>? scalingScheduleStatus;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The status of the autoscaler configuration.
  ///
  /// Current set of possible values: - PENDING: Autoscaler backend hasn't read
  /// new/updated configuration. - DELETING: Configuration is being deleted. -
  /// ACTIVE: Configuration is acknowledged to be effective. Some warnings might
  /// be present in the statusDetails field. - ERROR: Configuration has errors.
  /// Actionable for users. Details are present in the statusDetails field. New
  /// values might be added in the future.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : Configuration is acknowledged to be effective
  /// - "DELETING" : Configuration is being deleted
  /// - "ERROR" : Configuration has errors. Actionable for users.
  /// - "PENDING" : Autoscaler backend hasn't read new/updated configuration
  core.String? status;

  /// Human-readable details about the current state of the autoscaler.
  ///
  /// Read the documentation for Commonly returned status messages for examples
  /// of status messages you might encounter.
  ///
  /// Output only.
  core.List<AutoscalerStatusDetails>? statusDetails;

  /// URL of the managed instance group that this autoscaler will scale.
  ///
  /// This field is required when creating an autoscaler.
  core.String? target;

  /// URL of the zone where the instance group resides (for autoscalers living
  /// in zonal scope).
  ///
  /// Output only.
  core.String? zone;

  Autoscaler({
    this.autoscalingPolicy,
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.recommendedSize,
    this.region,
    this.scalingScheduleStatus,
    this.selfLink,
    this.status,
    this.statusDetails,
    this.target,
    this.zone,
  });

  Autoscaler.fromJson(core.Map json_)
      : this(
          autoscalingPolicy: json_.containsKey('autoscalingPolicy')
              ? AutoscalingPolicy.fromJson(json_['autoscalingPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          recommendedSize: json_.containsKey('recommendedSize')
              ? json_['recommendedSize'] as core.int
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          scalingScheduleStatus: json_.containsKey('scalingScheduleStatus')
              ? (json_['scalingScheduleStatus']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    ScalingScheduleStatus.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          statusDetails: json_.containsKey('statusDetails')
              ? (json_['statusDetails'] as core.List)
                  .map((value) => AutoscalerStatusDetails.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          target: json_.containsKey('target')
              ? json_['target'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoscalingPolicy != null) 'autoscalingPolicy': autoscalingPolicy!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (recommendedSize != null) 'recommendedSize': recommendedSize!,
        if (region != null) 'region': region!,
        if (scalingScheduleStatus != null)
          'scalingScheduleStatus': scalingScheduleStatus!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (statusDetails != null) 'statusDetails': statusDetails!,
        if (target != null) 'target': target!,
        if (zone != null) 'zone': zone!,
      };
}

class AutoscalerAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AutoscalerAggregatedListWarningData({
    this.key,
    this.value,
  });

  AutoscalerAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AutoscalerAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AutoscalerAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AutoscalerAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AutoscalerAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AutoscalerAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AutoscalerAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of AutoscalersScopedList resources.
  core.Map<core.String, AutoscalersScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#autoscalerAggregatedList for aggregated lists of
  /// autoscalers.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// end_interface: MixerListResponseWithEtagBuilder
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  AutoscalerAggregatedListWarning? warning;

  AutoscalerAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  AutoscalerAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    AutoscalersScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AutoscalerAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class AutoscalerListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AutoscalerListWarningData({
    this.key,
    this.value,
  });

  AutoscalerListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class AutoscalerListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AutoscalerListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AutoscalerListWarning({
    this.code,
    this.data,
    this.message,
  });

  AutoscalerListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AutoscalerListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Autoscaler resources.
class AutoscalerList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Autoscaler resources.
  core.List<Autoscaler>? items;

  /// Type of resource.
  ///
  /// Always compute#autoscalerList for lists of autoscalers.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  AutoscalerListWarning? warning;

  AutoscalerList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  AutoscalerList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Autoscaler.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? AutoscalerListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class AutoscalerStatusDetails {
  /// The status message.
  core.String? message;

  /// The type of error, warning, or notice returned.
  ///
  /// Current set of possible values: - ALL_INSTANCES_UNHEALTHY (WARNING): All
  /// instances in the instance group are unhealthy (not in RUNNING state). -
  /// BACKEND_SERVICE_DOES_NOT_EXIST (ERROR): There is no backend service
  /// attached to the instance group. - CAPPED_AT_MAX_NUM_REPLICAS (WARNING):
  /// Autoscaler recommends a size greater than maxNumReplicas. -
  /// CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE (WARNING): The custom metric samples
  /// are not exported often enough to be a credible base for autoscaling. -
  /// CUSTOM_METRIC_INVALID (ERROR): The custom metric that was specified does
  /// not exist or does not have the necessary labels. - MIN_EQUALS_MAX
  /// (WARNING): The minNumReplicas is equal to maxNumReplicas. This means the
  /// autoscaler cannot add or remove instances from the instance group. -
  /// MISSING_CUSTOM_METRIC_DATA_POINTS (WARNING): The autoscaler did not
  /// receive any data from the custom metric configured for autoscaling. -
  /// MISSING_LOAD_BALANCING_DATA_POINTS (WARNING): The autoscaler is configured
  /// to scale based on a load balancing signal but the instance group has not
  /// received any requests from the load balancer. - MODE_OFF (WARNING):
  /// Autoscaling is turned off. The number of instances in the group won't
  /// change automatically. The autoscaling configuration is preserved. -
  /// MODE_ONLY_UP (WARNING): Autoscaling is in the "Autoscale only out" mode.
  /// The autoscaler can add instances but not remove any. -
  /// MORE_THAN_ONE_BACKEND_SERVICE (ERROR): The instance group cannot be
  /// autoscaled because it has more than one backend service attached to it. -
  /// NOT_ENOUGH_QUOTA_AVAILABLE (ERROR): There is insufficient quota for the
  /// necessary resources, such as CPU or number of instances. -
  /// REGION_RESOURCE_STOCKOUT (ERROR): Shown only for regional autoscalers:
  /// there is a resource stockout in the chosen region. -
  /// SCALING_TARGET_DOES_NOT_EXIST (ERROR): The target to be scaled does not
  /// exist. - UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION (ERROR):
  /// Autoscaling does not work with an HTTP/S load balancer that has been
  /// configured for maxRate. - ZONE_RESOURCE_STOCKOUT (ERROR): For zonal
  /// autoscalers: there is a resource stockout in the chosen zone. For regional
  /// autoscalers: in at least one of the zones you're using there is a resource
  /// stockout. New values might be added in the future. Some of the values
  /// might not be available in all API versions.
  /// Possible string values are:
  /// - "ALL_INSTANCES_UNHEALTHY" : All instances in the instance group are
  /// unhealthy (not in RUNNING state).
  /// - "BACKEND_SERVICE_DOES_NOT_EXIST" : There is no backend service attached
  /// to the instance group.
  /// - "CAPPED_AT_MAX_NUM_REPLICAS" : Autoscaler recommends a size greater than
  /// maxNumReplicas.
  /// - "CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE" : The custom metric samples are
  /// not exported often enough to be a credible base for autoscaling.
  /// - "CUSTOM_METRIC_INVALID" : The custom metric that was specified does not
  /// exist or does not have the necessary labels.
  /// - "MIN_EQUALS_MAX" : The minNumReplicas is equal to maxNumReplicas. This
  /// means the autoscaler cannot add or remove instances from the instance
  /// group.
  /// - "MISSING_CUSTOM_METRIC_DATA_POINTS" : The autoscaler did not receive any
  /// data from the custom metric configured for autoscaling.
  /// - "MISSING_LOAD_BALANCING_DATA_POINTS" : The autoscaler is configured to
  /// scale based on a load balancing signal but the instance group has not
  /// received any requests from the load balancer.
  /// - "MODE_OFF" : Autoscaling is turned off. The number of instances in the
  /// group won't change automatically. The autoscaling configuration is
  /// preserved.
  /// - "MODE_ONLY_SCALE_OUT" : Autoscaling is in the "Autoscale only scale out"
  /// mode. Instances in the group will be only added.
  /// - "MODE_ONLY_UP" : Autoscaling is in the "Autoscale only out" mode.
  /// Instances in the group will be only added.
  /// - "MORE_THAN_ONE_BACKEND_SERVICE" : The instance group cannot be
  /// autoscaled because it has more than one backend service attached to it.
  /// - "NOT_ENOUGH_QUOTA_AVAILABLE" : There is insufficient quota for the
  /// necessary resources, such as CPU or number of instances.
  /// - "REGION_RESOURCE_STOCKOUT" : Showed only for regional autoscalers: there
  /// is a resource stockout in the chosen region.
  /// - "SCALING_TARGET_DOES_NOT_EXIST" : The target to be scaled does not
  /// exist.
  /// - "SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX" : For some scaling
  /// schedules minRequiredReplicas is greater than maxNumReplicas. Autoscaler
  /// always recommends at most maxNumReplicas instances.
  /// - "SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN" : For some scaling
  /// schedules minRequiredReplicas is less than minNumReplicas. Autoscaler
  /// always recommends at least minNumReplicas instances.
  /// - "UNKNOWN"
  /// - "UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION" : Autoscaling does
  /// not work with an HTTP/S load balancer that has been configured for
  /// maxRate.
  /// - "ZONE_RESOURCE_STOCKOUT" : For zonal autoscalers: there is a resource
  /// stockout in the chosen zone. For regional autoscalers: in at least one of
  /// the zones you're using there is a resource stockout.
  core.String? type;

  AutoscalerStatusDetails({
    this.message,
    this.type,
  });

  AutoscalerStatusDetails.fromJson(core.Map json_)
      : this(
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (message != null) 'message': message!,
        if (type != null) 'type': type!,
      };
}

class AutoscalersScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  AutoscalersScopedListWarningData({
    this.key,
    this.value,
  });

  AutoscalersScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of autoscalers when the list
/// is empty.
///
/// Output only.
class AutoscalersScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<AutoscalersScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  AutoscalersScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  AutoscalersScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => AutoscalersScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class AutoscalersScopedList {
  /// A list of autoscalers contained in this scope.
  ///
  /// Output only.
  core.List<Autoscaler>? autoscalers;

  /// Informational warning which replaces the list of autoscalers when the list
  /// is empty.
  ///
  /// Output only.
  AutoscalersScopedListWarning? warning;

  AutoscalersScopedList({
    this.autoscalers,
    this.warning,
  });

  AutoscalersScopedList.fromJson(core.Map json_)
      : this(
          autoscalers: json_.containsKey('autoscalers')
              ? (json_['autoscalers'] as core.List)
                  .map((value) => Autoscaler.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? AutoscalersScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoscalers != null) 'autoscalers': autoscalers!,
        if (warning != null) 'warning': warning!,
      };
}

/// Cloud Autoscaler policy.
class AutoscalingPolicy {
  /// The number of seconds that the autoscaler waits before it starts
  /// collecting information from a new instance.
  ///
  /// This prevents the autoscaler from collecting information when the instance
  /// is initializing, during which the collected usage would not be reliable.
  /// The default time autoscaler waits is 60 seconds. Virtual machine
  /// initialization times might vary because of numerous factors. We recommend
  /// that you test how long an instance may take to initialize. To do this,
  /// create an instance and time the startup process.
  core.int? coolDownPeriodSec;

  /// Defines the CPU utilization policy that allows the autoscaler to scale
  /// based on the average CPU utilization of a managed instance group.
  AutoscalingPolicyCpuUtilization? cpuUtilization;

  /// Configuration parameters of autoscaling based on a custom metric.
  core.List<AutoscalingPolicyCustomMetricUtilization>? customMetricUtilizations;

  /// Configuration parameters of autoscaling based on load balancer.
  AutoscalingPolicyLoadBalancingUtilization? loadBalancingUtilization;

  /// The maximum number of instances that the autoscaler can scale out to.
  ///
  /// This is required when creating or updating an autoscaler. The maximum
  /// number of replicas must not be lower than minimal number of replicas.
  core.int? maxNumReplicas;

  /// The minimum number of replicas that the autoscaler can scale in to.
  ///
  /// This cannot be less than 0. If not provided, autoscaler chooses a default
  /// value depending on maximum number of instances allowed.
  core.int? minNumReplicas;

  /// Defines operating mode for this policy.
  /// Possible string values are:
  /// - "OFF" : Do not automatically scale the MIG in or out. The
  /// recommended_size field contains the size of MIG that would be set if the
  /// actuation mode was enabled.
  /// - "ON" : Automatically scale the MIG in and out according to the policy.
  /// - "ONLY_SCALE_OUT" : Automatically create VMs according to the policy, but
  /// do not scale the MIG in.
  /// - "ONLY_UP" : Automatically create VMs according to the policy, but do not
  /// scale the MIG in.
  core.String? mode;
  AutoscalingPolicyScaleInControl? scaleInControl;

  /// Scaling schedules defined for an autoscaler.
  ///
  /// Multiple schedules can be set on an autoscaler, and they can overlap.
  /// During overlapping periods the greatest min_required_replicas of all
  /// scaling schedules is applied. Up to 128 scaling schedules are allowed.
  core.Map<core.String, AutoscalingPolicyScalingSchedule>? scalingSchedules;

  AutoscalingPolicy({
    this.coolDownPeriodSec,
    this.cpuUtilization,
    this.customMetricUtilizations,
    this.loadBalancingUtilization,
    this.maxNumReplicas,
    this.minNumReplicas,
    this.mode,
    this.scaleInControl,
    this.scalingSchedules,
  });

  AutoscalingPolicy.fromJson(core.Map json_)
      : this(
          coolDownPeriodSec: json_.containsKey('coolDownPeriodSec')
              ? json_['coolDownPeriodSec'] as core.int
              : null,
          cpuUtilization: json_.containsKey('cpuUtilization')
              ? AutoscalingPolicyCpuUtilization.fromJson(json_['cpuUtilization']
                  as core.Map<core.String, core.dynamic>)
              : null,
          customMetricUtilizations:
              json_.containsKey('customMetricUtilizations')
                  ? (json_['customMetricUtilizations'] as core.List)
                      .map((value) =>
                          AutoscalingPolicyCustomMetricUtilization.fromJson(
                              value as core.Map<core.String, core.dynamic>))
                      .toList()
                  : null,
          loadBalancingUtilization:
              json_.containsKey('loadBalancingUtilization')
                  ? AutoscalingPolicyLoadBalancingUtilization.fromJson(
                      json_['loadBalancingUtilization']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          maxNumReplicas: json_.containsKey('maxNumReplicas')
              ? json_['maxNumReplicas'] as core.int
              : null,
          minNumReplicas: json_.containsKey('minNumReplicas')
              ? json_['minNumReplicas'] as core.int
              : null,
          mode: json_.containsKey('mode') ? json_['mode'] as core.String : null,
          scaleInControl: json_.containsKey('scaleInControl')
              ? AutoscalingPolicyScaleInControl.fromJson(json_['scaleInControl']
                  as core.Map<core.String, core.dynamic>)
              : null,
          scalingSchedules: json_.containsKey('scalingSchedules')
              ? (json_['scalingSchedules']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    AutoscalingPolicyScalingSchedule.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (coolDownPeriodSec != null) 'coolDownPeriodSec': coolDownPeriodSec!,
        if (cpuUtilization != null) 'cpuUtilization': cpuUtilization!,
        if (customMetricUtilizations != null)
          'customMetricUtilizations': customMetricUtilizations!,
        if (loadBalancingUtilization != null)
          'loadBalancingUtilization': loadBalancingUtilization!,
        if (maxNumReplicas != null) 'maxNumReplicas': maxNumReplicas!,
        if (minNumReplicas != null) 'minNumReplicas': minNumReplicas!,
        if (mode != null) 'mode': mode!,
        if (scaleInControl != null) 'scaleInControl': scaleInControl!,
        if (scalingSchedules != null) 'scalingSchedules': scalingSchedules!,
      };
}

/// CPU utilization policy.
class AutoscalingPolicyCpuUtilization {
  /// Indicates whether predictive autoscaling based on CPU metric is enabled.
  ///
  /// Valid values are: * NONE (default). No predictive method is used. The
  /// autoscaler scales the group to meet current demand based on real-time
  /// metrics. * OPTIMIZE_AVAILABILITY. Predictive autoscaling improves
  /// availability by monitoring daily and weekly load patterns and scaling out
  /// ahead of anticipated demand.
  /// Possible string values are:
  /// - "NONE" : No predictive method is used. The autoscaler scales the group
  /// to meet current demand based on real-time metrics
  /// - "OPTIMIZE_AVAILABILITY" : Predictive autoscaling improves availability
  /// by monitoring daily and weekly load patterns and scaling out ahead of
  /// anticipated demand.
  core.String? predictiveMethod;

  /// The target CPU utilization that the autoscaler maintains.
  ///
  /// Must be a float value in the range (0, 1\]. If not specified, the default
  /// is 0.6. If the CPU level is below the target utilization, the autoscaler
  /// scales in the number of instances until it reaches the minimum number of
  /// instances you specified or until the average CPU of your instances reaches
  /// the target utilization. If the average CPU is above the target
  /// utilization, the autoscaler scales out until it reaches the maximum number
  /// of instances you specified or until the average utilization reaches the
  /// target utilization.
  core.double? utilizationTarget;

  AutoscalingPolicyCpuUtilization({
    this.predictiveMethod,
    this.utilizationTarget,
  });

  AutoscalingPolicyCpuUtilization.fromJson(core.Map json_)
      : this(
          predictiveMethod: json_.containsKey('predictiveMethod')
              ? json_['predictiveMethod'] as core.String
              : null,
          utilizationTarget: json_.containsKey('utilizationTarget')
              ? (json_['utilizationTarget'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (predictiveMethod != null) 'predictiveMethod': predictiveMethod!,
        if (utilizationTarget != null) 'utilizationTarget': utilizationTarget!,
      };
}

/// Custom utilization metric policy.
class AutoscalingPolicyCustomMetricUtilization {
  /// A filter string, compatible with a Stackdriver Monitoring filter string
  /// for TimeSeries.list API call.
  ///
  /// This filter is used to select a specific TimeSeries for the purpose of
  /// autoscaling and to determine whether the metric is exporting per-instance
  /// or per-group data. For the filter to be valid for autoscaling purposes,
  /// the following rules apply: - You can only use the AND operator for joining
  /// selectors. - You can only use direct equality comparison operator (=)
  /// without any functions for each selector. - You can specify the metric in
  /// both the filter string and in the metric field. However, if specified in
  /// both places, the metric must be identical. - The monitored resource type
  /// determines what kind of values are expected for the metric. If it is a
  /// gce_instance, the autoscaler expects the metric to include a separate
  /// TimeSeries for each instance in a group. In such a case, you cannot filter
  /// on resource labels. If the resource type is any other value, the
  /// autoscaler expects this metric to contain values that apply to the entire
  /// autoscaled instance group and resource label filtering can be performed to
  /// point autoscaler at the correct TimeSeries to scale upon. This is called a
  /// *per-group metric* for the purpose of autoscaling. If not specified, the
  /// type defaults to gce_instance. Try to provide a filter that is selective
  /// enough to pick just one TimeSeries for the autoscaled group or for each of
  /// the instances (if you are using gce_instance resource type). If multiple
  /// TimeSeries are returned upon the query execution, the autoscaler will sum
  /// their respective values to obtain its scaling value.
  core.String? filter;

  /// The identifier (type) of the Stackdriver Monitoring metric.
  ///
  /// The metric cannot have negative values. The metric must have a value type
  /// of INT64 or DOUBLE.
  core.String? metric;

  /// If scaling is based on a per-group metric value that represents the total
  /// amount of work to be done or resource usage, set this value to an amount
  /// assigned for a single instance of the scaled group.
  ///
  /// Autoscaler keeps the number of instances proportional to the value of this
  /// metric. The metric itself does not change value due to group resizing. A
  /// good metric to use with the target is for example
  /// pubsub.googleapis.com/subscription/num_undelivered_messages or a custom
  /// metric exporting the total number of requests coming to your instances. A
  /// bad example would be a metric exporting an average or median latency,
  /// since this value can't include a chunk assignable to a single instance, it
  /// could be better used with utilization_target instead.
  core.double? singleInstanceAssignment;

  /// The target value of the metric that autoscaler maintains.
  ///
  /// This must be a positive value. A utilization metric scales number of
  /// virtual machines handling requests to increase or decrease proportionally
  /// to the metric. For example, a good metric to use as a utilization_target
  /// is
  /// https://www.googleapis.com/compute/v1/instance/network/received_bytes_count.
  /// The autoscaler works to keep this value constant for each of the
  /// instances.
  core.double? utilizationTarget;

  /// Defines how target utilization value is expressed for a Stackdriver
  /// Monitoring metric.
  ///
  /// Either GAUGE, DELTA_PER_SECOND, or DELTA_PER_MINUTE.
  /// Possible string values are:
  /// - "DELTA_PER_MINUTE" : Sets the utilization target value for a cumulative
  /// or delta metric, expressed as the rate of growth per minute.
  /// - "DELTA_PER_SECOND" : Sets the utilization target value for a cumulative
  /// or delta metric, expressed as the rate of growth per second.
  /// - "GAUGE" : Sets the utilization target value for a gauge metric. The
  /// autoscaler will collect the average utilization of the virtual machines
  /// from the last couple of minutes, and compare the value to the utilization
  /// target value to perform autoscaling.
  core.String? utilizationTargetType;

  AutoscalingPolicyCustomMetricUtilization({
    this.filter,
    this.metric,
    this.singleInstanceAssignment,
    this.utilizationTarget,
    this.utilizationTargetType,
  });

  AutoscalingPolicyCustomMetricUtilization.fromJson(core.Map json_)
      : this(
          filter: json_.containsKey('filter')
              ? json_['filter'] as core.String
              : null,
          metric: json_.containsKey('metric')
              ? json_['metric'] as core.String
              : null,
          singleInstanceAssignment:
              json_.containsKey('singleInstanceAssignment')
                  ? (json_['singleInstanceAssignment'] as core.num).toDouble()
                  : null,
          utilizationTarget: json_.containsKey('utilizationTarget')
              ? (json_['utilizationTarget'] as core.num).toDouble()
              : null,
          utilizationTargetType: json_.containsKey('utilizationTargetType')
              ? json_['utilizationTargetType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (filter != null) 'filter': filter!,
        if (metric != null) 'metric': metric!,
        if (singleInstanceAssignment != null)
          'singleInstanceAssignment': singleInstanceAssignment!,
        if (utilizationTarget != null) 'utilizationTarget': utilizationTarget!,
        if (utilizationTargetType != null)
          'utilizationTargetType': utilizationTargetType!,
      };
}

/// Configuration parameters of autoscaling based on load balancing.
class AutoscalingPolicyLoadBalancingUtilization {
  /// Fraction of backend capacity utilization (set in HTTP(S) load balancing
  /// configuration) that the autoscaler maintains.
  ///
  /// Must be a positive float value. If not defined, the default is 0.8.
  core.double? utilizationTarget;

  AutoscalingPolicyLoadBalancingUtilization({
    this.utilizationTarget,
  });

  AutoscalingPolicyLoadBalancingUtilization.fromJson(core.Map json_)
      : this(
          utilizationTarget: json_.containsKey('utilizationTarget')
              ? (json_['utilizationTarget'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (utilizationTarget != null) 'utilizationTarget': utilizationTarget!,
      };
}

/// Configuration that allows for slower scale in so that even if Autoscaler
/// recommends an abrupt scale in of a MIG, it will be throttled as specified by
/// the parameters below.
class AutoscalingPolicyScaleInControl {
  /// Maximum allowed number (or %) of VMs that can be deducted from the peak
  /// recommendation during the window autoscaler looks at when computing
  /// recommendations.
  ///
  /// Possibly all these VMs can be deleted at once so user service needs to be
  /// prepared to lose that many VMs in one step.
  FixedOrPercent? maxScaledInReplicas;

  /// How far back autoscaling looks when computing recommendations to include
  /// directives regarding slower scale in, as described above.
  core.int? timeWindowSec;

  AutoscalingPolicyScaleInControl({
    this.maxScaledInReplicas,
    this.timeWindowSec,
  });

  AutoscalingPolicyScaleInControl.fromJson(core.Map json_)
      : this(
          maxScaledInReplicas: json_.containsKey('maxScaledInReplicas')
              ? FixedOrPercent.fromJson(json_['maxScaledInReplicas']
                  as core.Map<core.String, core.dynamic>)
              : null,
          timeWindowSec: json_.containsKey('timeWindowSec')
              ? json_['timeWindowSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maxScaledInReplicas != null)
          'maxScaledInReplicas': maxScaledInReplicas!,
        if (timeWindowSec != null) 'timeWindowSec': timeWindowSec!,
      };
}

/// Scaling based on user-defined schedule.
///
/// The message describes a single scaling schedule. A scaling schedule changes
/// the minimum number of VM instances an autoscaler can recommend, which can
/// trigger scaling out.
class AutoscalingPolicyScalingSchedule {
  /// A description of a scaling schedule.
  core.String? description;

  /// A boolean value that specifies whether a scaling schedule can influence
  /// autoscaler recommendations.
  ///
  /// If set to true, then a scaling schedule has no effect. This field is
  /// optional, and its value is false by default.
  core.bool? disabled;

  /// The duration of time intervals, in seconds, for which this scaling
  /// schedule is to run.
  ///
  /// The minimum allowed value is 300. This field is required.
  core.int? durationSec;

  /// The minimum number of VM instances that the autoscaler will recommend in
  /// time intervals starting according to schedule.
  ///
  /// This field is required.
  core.int? minRequiredReplicas;

  /// The start timestamps of time intervals when this scaling schedule is to
  /// provide a scaling signal.
  ///
  /// This field uses the extended cron format (with an optional year field).
  /// The expression can describe a single timestamp if the optional year is
  /// set, in which case the scaling schedule runs once. The schedule is
  /// interpreted with respect to time_zone. This field is required. Note: These
  /// timestamps only describe when autoscaler starts providing the scaling
  /// signal. The VMs need additional time to become serving.
  core.String? schedule;

  /// The time zone to use when interpreting the schedule.
  ///
  /// The value of this field must be a time zone name from the tz database:
  /// http://en.wikipedia.org/wiki/Tz_database. This field is assigned a default
  /// value of “UTC” if left empty.
  core.String? timeZone;

  AutoscalingPolicyScalingSchedule({
    this.description,
    this.disabled,
    this.durationSec,
    this.minRequiredReplicas,
    this.schedule,
    this.timeZone,
  });

  AutoscalingPolicyScalingSchedule.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          disabled: json_.containsKey('disabled')
              ? json_['disabled'] as core.bool
              : null,
          durationSec: json_.containsKey('durationSec')
              ? json_['durationSec'] as core.int
              : null,
          minRequiredReplicas: json_.containsKey('minRequiredReplicas')
              ? json_['minRequiredReplicas'] as core.int
              : null,
          schedule: json_.containsKey('schedule')
              ? json_['schedule'] as core.String
              : null,
          timeZone: json_.containsKey('timeZone')
              ? json_['timeZone'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (disabled != null) 'disabled': disabled!,
        if (durationSec != null) 'durationSec': durationSec!,
        if (minRequiredReplicas != null)
          'minRequiredReplicas': minRequiredReplicas!,
        if (schedule != null) 'schedule': schedule!,
        if (timeZone != null) 'timeZone': timeZone!,
      };
}

/// Message containing information of one individual backend.
class Backend {
  /// Specifies how to determine whether the backend of a load balancer can
  /// handle additional traffic or is fully loaded.
  ///
  /// For usage guidelines, see Connection balancing mode. Backends must use
  /// compatible balancing modes. For more information, see Supported balancing
  /// modes and target capacity settings and Restrictions and guidance for
  /// instance groups. Note: Currently, if you use the API to configure
  /// incompatible balancing modes, the configuration might be accepted even
  /// though it has no impact and is ignored. Specifically,
  /// Backend.maxUtilization is ignored when Backend.balancingMode is RATE. In
  /// the future, this incompatible combination will be rejected.
  /// Possible string values are:
  /// - "CONNECTION" : Balance based on the number of simultaneous connections.
  /// - "RATE" : Balance based on requests per second (RPS).
  /// - "UTILIZATION" : Balance based on the backend utilization.
  core.String? balancingMode;

  /// A multiplier applied to the backend's target capacity of its balancing
  /// mode.
  ///
  /// The default value is 1, which means the group serves up to 100% of its
  /// configured capacity (depending on balancingMode). A setting of 0 means the
  /// group is completely drained, offering 0% of its available capacity. The
  /// valid ranges are 0.0 and \[0.1,1.0\]. You cannot configure a setting
  /// larger than 0 and smaller than 0.1. You cannot configure a setting of 0
  /// when there is only one backend attached to the backend service.
  core.double? capacityScaler;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// This field designates whether this is a failover backend.
  ///
  /// More than one failover backend can be configured for a given
  /// BackendService.
  core.bool? failover;

  /// The fully-qualified URL of an instance group or network endpoint group
  /// (NEG) resource.
  ///
  /// To determine what types of backends a load balancer supports, see the
  /// [Backend services overview](https://cloud.google.com/load-balancing/docs/backend-service#backends).
  /// You must use the *fully-qualified* URL (starting with
  /// https://www.googleapis.com/) to specify the instance group or NEG. Partial
  /// URLs are not supported.
  core.String? group;

  /// Defines a target maximum number of simultaneous connections.
  ///
  /// For usage guidelines, see Connection balancing mode and Utilization
  /// balancing mode. Not available if the backend's balancingMode is RATE.
  core.int? maxConnections;

  /// Defines a target maximum number of simultaneous connections.
  ///
  /// For usage guidelines, see Connection balancing mode and Utilization
  /// balancing mode. Not available if the backend's balancingMode is RATE.
  core.int? maxConnectionsPerEndpoint;

  /// Defines a target maximum number of simultaneous connections.
  ///
  /// For usage guidelines, see Connection balancing mode and Utilization
  /// balancing mode. Not available if the backend's balancingMode is RATE.
  core.int? maxConnectionsPerInstance;

  /// Defines a maximum number of HTTP requests per second (RPS).
  ///
  /// For usage guidelines, see Rate balancing mode and Utilization balancing
  /// mode. Not available if the backend's balancingMode is CONNECTION.
  core.int? maxRate;

  /// Defines a maximum target for requests per second (RPS).
  ///
  /// For usage guidelines, see Rate balancing mode and Utilization balancing
  /// mode. Not available if the backend's balancingMode is CONNECTION.
  core.double? maxRatePerEndpoint;

  /// Defines a maximum target for requests per second (RPS).
  ///
  /// For usage guidelines, see Rate balancing mode and Utilization balancing
  /// mode. Not available if the backend's balancingMode is CONNECTION.
  core.double? maxRatePerInstance;

  /// Optional parameter to define a target capacity for the UTILIZATION
  /// balancing mode.
  ///
  /// The valid range is \[0.0, 1.0\]. For usage guidelines, see Utilization
  /// balancing mode.
  core.double? maxUtilization;

  Backend({
    this.balancingMode,
    this.capacityScaler,
    this.description,
    this.failover,
    this.group,
    this.maxConnections,
    this.maxConnectionsPerEndpoint,
    this.maxConnectionsPerInstance,
    this.maxRate,
    this.maxRatePerEndpoint,
    this.maxRatePerInstance,
    this.maxUtilization,
  });

  Backend.fromJson(core.Map json_)
      : this(
          balancingMode: json_.containsKey('balancingMode')
              ? json_['balancingMode'] as core.String
              : null,
          capacityScaler: json_.containsKey('capacityScaler')
              ? (json_['capacityScaler'] as core.num).toDouble()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          failover: json_.containsKey('failover')
              ? json_['failover'] as core.bool
              : null,
          group:
              json_.containsKey('group') ? json_['group'] as core.String : null,
          maxConnections: json_.containsKey('maxConnections')
              ? json_['maxConnections'] as core.int
              : null,
          maxConnectionsPerEndpoint:
              json_.containsKey('maxConnectionsPerEndpoint')
                  ? json_['maxConnectionsPerEndpoint'] as core.int
                  : null,
          maxConnectionsPerInstance:
              json_.containsKey('maxConnectionsPerInstance')
                  ? json_['maxConnectionsPerInstance'] as core.int
                  : null,
          maxRate: json_.containsKey('maxRate')
              ? json_['maxRate'] as core.int
              : null,
          maxRatePerEndpoint: json_.containsKey('maxRatePerEndpoint')
              ? (json_['maxRatePerEndpoint'] as core.num).toDouble()
              : null,
          maxRatePerInstance: json_.containsKey('maxRatePerInstance')
              ? (json_['maxRatePerInstance'] as core.num).toDouble()
              : null,
          maxUtilization: json_.containsKey('maxUtilization')
              ? (json_['maxUtilization'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (balancingMode != null) 'balancingMode': balancingMode!,
        if (capacityScaler != null) 'capacityScaler': capacityScaler!,
        if (description != null) 'description': description!,
        if (failover != null) 'failover': failover!,
        if (group != null) 'group': group!,
        if (maxConnections != null) 'maxConnections': maxConnections!,
        if (maxConnectionsPerEndpoint != null)
          'maxConnectionsPerEndpoint': maxConnectionsPerEndpoint!,
        if (maxConnectionsPerInstance != null)
          'maxConnectionsPerInstance': maxConnectionsPerInstance!,
        if (maxRate != null) 'maxRate': maxRate!,
        if (maxRatePerEndpoint != null)
          'maxRatePerEndpoint': maxRatePerEndpoint!,
        if (maxRatePerInstance != null)
          'maxRatePerInstance': maxRatePerInstance!,
        if (maxUtilization != null) 'maxUtilization': maxUtilization!,
      };
}

/// Represents a Cloud Storage Bucket resource.
///
/// This Cloud Storage bucket resource is referenced by a URL map of a load
/// balancer. For more information, read Backend Buckets.
class BackendBucket {
  /// Cloud Storage bucket name.
  core.String? bucketName;

  /// Cloud CDN configuration for this BackendBucket.
  BackendBucketCdnPolicy? cdnPolicy;

  /// Compress text responses using Brotli or gzip compression, based on the
  /// client's Accept-Encoding header.
  /// Possible string values are:
  /// - "AUTOMATIC" : Automatically uses the best compression based on the
  /// Accept-Encoding header sent by the client.
  /// - "DISABLED" : Disables compression. Existing compressed responses cached
  /// by Cloud CDN will not be served to clients.
  core.String? compressionMode;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Headers that the HTTP/S load balancer should add to proxied responses.
  core.List<core.String>? customResponseHeaders;

  /// An optional textual description of the resource; provided by the client
  /// when the resource is created.
  core.String? description;

  /// The resource URL for the edge security policy associated with this backend
  /// bucket.
  ///
  /// Output only.
  core.String? edgeSecurityPolicy;

  /// If true, enable Cloud CDN for this BackendBucket.
  core.bool? enableCdn;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  BackendBucket({
    this.bucketName,
    this.cdnPolicy,
    this.compressionMode,
    this.creationTimestamp,
    this.customResponseHeaders,
    this.description,
    this.edgeSecurityPolicy,
    this.enableCdn,
    this.id,
    this.kind,
    this.name,
    this.selfLink,
  });

  BackendBucket.fromJson(core.Map json_)
      : this(
          bucketName: json_.containsKey('bucketName')
              ? json_['bucketName'] as core.String
              : null,
          cdnPolicy: json_.containsKey('cdnPolicy')
              ? BackendBucketCdnPolicy.fromJson(
                  json_['cdnPolicy'] as core.Map<core.String, core.dynamic>)
              : null,
          compressionMode: json_.containsKey('compressionMode')
              ? json_['compressionMode'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          customResponseHeaders: json_.containsKey('customResponseHeaders')
              ? (json_['customResponseHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          edgeSecurityPolicy: json_.containsKey('edgeSecurityPolicy')
              ? json_['edgeSecurityPolicy'] as core.String
              : null,
          enableCdn: json_.containsKey('enableCdn')
              ? json_['enableCdn'] as core.bool
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bucketName != null) 'bucketName': bucketName!,
        if (cdnPolicy != null) 'cdnPolicy': cdnPolicy!,
        if (compressionMode != null) 'compressionMode': compressionMode!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (customResponseHeaders != null)
          'customResponseHeaders': customResponseHeaders!,
        if (description != null) 'description': description!,
        if (edgeSecurityPolicy != null)
          'edgeSecurityPolicy': edgeSecurityPolicy!,
        if (enableCdn != null) 'enableCdn': enableCdn!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// Message containing Cloud CDN configuration for a backend bucket.
class BackendBucketCdnPolicy {
  /// Bypass the cache when the specified request headers are matched - e.g.
  /// Pragma or Authorization headers.
  ///
  /// Up to 5 headers can be specified. The cache is bypassed for all
  /// cdnPolicy.cacheMode settings.
  core.List<BackendBucketCdnPolicyBypassCacheOnRequestHeader>?
      bypassCacheOnRequestHeaders;

  /// The CacheKeyPolicy for this CdnPolicy.
  BackendBucketCdnPolicyCacheKeyPolicy? cacheKeyPolicy;

  /// Specifies the cache setting for all responses from this backend.
  ///
  /// The possible values are: USE_ORIGIN_HEADERS Requires the origin to set
  /// valid caching headers to cache content. Responses without these headers
  /// will not be cached at Google's edge, and will require a full trip to the
  /// origin on every request, potentially impacting performance and increasing
  /// load on the origin server. FORCE_CACHE_ALL Cache all content, ignoring any
  /// "private", "no-store" or "no-cache" directives in Cache-Control response
  /// headers. Warning: this may result in Cloud CDN caching private, per-user
  /// (user identifiable) content. CACHE_ALL_STATIC Automatically cache static
  /// content, including common image formats, media (video and audio), and web
  /// assets (JavaScript and CSS). Requests and responses that are marked as
  /// uncacheable, as well as dynamic content (including HTML), will not be
  /// cached.
  /// Possible string values are:
  /// - "CACHE_ALL_STATIC" : Automatically cache static content, including
  /// common image formats, media (video and audio), and web assets (JavaScript
  /// and CSS). Requests and responses that are marked as uncacheable, as well
  /// as dynamic content (including HTML), will not be cached.
  /// - "FORCE_CACHE_ALL" : Cache all content, ignoring any "private",
  /// "no-store" or "no-cache" directives in Cache-Control response headers.
  /// Warning: this may result in Cloud CDN caching private, per-user (user
  /// identifiable) content.
  /// - "INVALID_CACHE_MODE"
  /// - "USE_ORIGIN_HEADERS" : Requires the origin to set valid caching headers
  /// to cache content. Responses without these headers will not be cached at
  /// Google's edge, and will require a full trip to the origin on every
  /// request, potentially impacting performance and increasing load on the
  /// origin server.
  core.String? cacheMode;

  /// Specifies a separate client (e.g. browser client) maximum TTL.
  ///
  /// This is used to clamp the max-age (or Expires) value sent to the client.
  /// With FORCE_CACHE_ALL, the lesser of client_ttl and default_ttl is used for
  /// the response max-age directive, along with a "public" directive. For
  /// cacheable content in CACHE_ALL_STATIC mode, client_ttl clamps the max-age
  /// from the origin (if specified), or else sets the response max-age
  /// directive to the lesser of the client_ttl and default_ttl, and also
  /// ensures a "public" cache-control directive is present. If a client TTL is
  /// not specified, a default value (1 hour) will be used. The maximum allowed
  /// value is 31,622,400s (1 year).
  core.int? clientTtl;

  /// Specifies the default TTL for cached content served by this origin for
  /// responses that do not have an existing valid TTL (max-age or s-max-age).
  ///
  /// Setting a TTL of "0" means "always revalidate". The value of defaultTTL
  /// cannot be set to a value greater than that of maxTTL, but can be equal.
  /// When the cacheMode is set to FORCE_CACHE_ALL, the defaultTTL will
  /// overwrite the TTL set in all responses. The maximum allowed value is
  /// 31,622,400s (1 year), noting that infrequently accessed objects may be
  /// evicted from the cache before the defined TTL.
  core.int? defaultTtl;

  /// Specifies the maximum allowed TTL for cached content served by this
  /// origin.
  ///
  /// Cache directives that attempt to set a max-age or s-maxage higher than
  /// this, or an Expires header more than maxTTL seconds in the future will be
  /// capped at the value of maxTTL, as if it were the value of an s-maxage
  /// Cache-Control directive. Headers sent to the client will not be modified.
  /// Setting a TTL of "0" means "always revalidate". The maximum allowed value
  /// is 31,622,400s (1 year), noting that infrequently accessed objects may be
  /// evicted from the cache before the defined TTL.
  core.int? maxTtl;

  /// Negative caching allows per-status code TTLs to be set, in order to apply
  /// fine-grained caching for common errors or redirects.
  ///
  /// This can reduce the load on your origin and improve end-user experience by
  /// reducing response latency. When the cache mode is set to CACHE_ALL_STATIC
  /// or USE_ORIGIN_HEADERS, negative caching applies to responses with the
  /// specified response code that lack any Cache-Control, Expires, or Pragma:
  /// no-cache directives. When the cache mode is set to FORCE_CACHE_ALL,
  /// negative caching applies to all responses with the specified response
  /// code, and override any caching headers. By default, Cloud CDN will apply
  /// the following default TTLs to these status codes: HTTP 300 (Multiple
  /// Choice), 301, 308 (Permanent Redirects): 10m HTTP 404 (Not Found), 410
  /// (Gone), 451 (Unavailable For Legal Reasons): 120s HTTP 405 (Method Not
  /// Found), 421 (Misdirected Request), 501 (Not Implemented): 60s. These
  /// defaults can be overridden in negative_caching_policy.
  core.bool? negativeCaching;

  /// Sets a cache TTL for the specified HTTP status code.
  ///
  /// negative_caching must be enabled to configure negative_caching_policy.
  /// Omitting the policy and leaving negative_caching enabled will use Cloud
  /// CDN's default cache TTLs. Note that when specifying an explicit
  /// negative_caching_policy, you should take care to specify a cache TTL for
  /// all response codes that you wish to cache. Cloud CDN will not apply any
  /// default negative caching when a policy exists.
  core.List<BackendBucketCdnPolicyNegativeCachingPolicy>? negativeCachingPolicy;

  /// If true then Cloud CDN will combine multiple concurrent cache fill
  /// requests into a small number of requests to the origin.
  core.bool? requestCoalescing;

  /// Serve existing content from the cache (if available) when revalidating
  /// content with the origin, or when an error is encountered when refreshing
  /// the cache.
  ///
  /// This setting defines the default "max-stale" duration for any cached
  /// responses that do not specify a max-stale directive. Stale responses that
  /// exceed the TTL configured here will not be served. The default limit
  /// (max-stale) is 86400s (1 day), which will allow stale content to be served
  /// up to this limit beyond the max-age (or s-max-age) of a cached response.
  /// The maximum allowed value is 604800 (1 week). Set this to zero (0) to
  /// disable serve-while-stale.
  core.int? serveWhileStale;

  /// Maximum number of seconds the response to a signed URL request will be
  /// considered fresh.
  ///
  /// After this time period, the response will be revalidated before being
  /// served. Defaults to 1hr (3600s). When serving responses to signed URL
  /// requests, Cloud CDN will internally behave as though all responses from
  /// this backend had a "Cache-Control: public, max-age=\[TTL\]" header,
  /// regardless of any existing Cache-Control header. The actual headers served
  /// in responses will not be altered.
  core.String? signedUrlCacheMaxAgeSec;

  /// Names of the keys for signing request URLs.
  ///
  /// Output only.
  core.List<core.String>? signedUrlKeyNames;

  BackendBucketCdnPolicy({
    this.bypassCacheOnRequestHeaders,
    this.cacheKeyPolicy,
    this.cacheMode,
    this.clientTtl,
    this.defaultTtl,
    this.maxTtl,
    this.negativeCaching,
    this.negativeCachingPolicy,
    this.requestCoalescing,
    this.serveWhileStale,
    this.signedUrlCacheMaxAgeSec,
    this.signedUrlKeyNames,
  });

  BackendBucketCdnPolicy.fromJson(core.Map json_)
      : this(
          bypassCacheOnRequestHeaders: json_
                  .containsKey('bypassCacheOnRequestHeaders')
              ? (json_['bypassCacheOnRequestHeaders'] as core.List)
                  .map((value) =>
                      BackendBucketCdnPolicyBypassCacheOnRequestHeader.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          cacheKeyPolicy: json_.containsKey('cacheKeyPolicy')
              ? BackendBucketCdnPolicyCacheKeyPolicy.fromJson(
                  json_['cacheKeyPolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          cacheMode: json_.containsKey('cacheMode')
              ? json_['cacheMode'] as core.String
              : null,
          clientTtl: json_.containsKey('clientTtl')
              ? json_['clientTtl'] as core.int
              : null,
          defaultTtl: json_.containsKey('defaultTtl')
              ? json_['defaultTtl'] as core.int
              : null,
          maxTtl:
              json_.containsKey('maxTtl') ? json_['maxTtl'] as core.int : null,
          negativeCaching: json_.containsKey('negativeCaching')
              ? json_['negativeCaching'] as core.bool
              : null,
          negativeCachingPolicy: json_.containsKey('negativeCachingPolicy')
              ? (json_['negativeCachingPolicy'] as core.List)
                  .map((value) =>
                      BackendBucketCdnPolicyNegativeCachingPolicy.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          requestCoalescing: json_.containsKey('requestCoalescing')
              ? json_['requestCoalescing'] as core.bool
              : null,
          serveWhileStale: json_.containsKey('serveWhileStale')
              ? json_['serveWhileStale'] as core.int
              : null,
          signedUrlCacheMaxAgeSec: json_.containsKey('signedUrlCacheMaxAgeSec')
              ? json_['signedUrlCacheMaxAgeSec'] as core.String
              : null,
          signedUrlKeyNames: json_.containsKey('signedUrlKeyNames')
              ? (json_['signedUrlKeyNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bypassCacheOnRequestHeaders != null)
          'bypassCacheOnRequestHeaders': bypassCacheOnRequestHeaders!,
        if (cacheKeyPolicy != null) 'cacheKeyPolicy': cacheKeyPolicy!,
        if (cacheMode != null) 'cacheMode': cacheMode!,
        if (clientTtl != null) 'clientTtl': clientTtl!,
        if (defaultTtl != null) 'defaultTtl': defaultTtl!,
        if (maxTtl != null) 'maxTtl': maxTtl!,
        if (negativeCaching != null) 'negativeCaching': negativeCaching!,
        if (negativeCachingPolicy != null)
          'negativeCachingPolicy': negativeCachingPolicy!,
        if (requestCoalescing != null) 'requestCoalescing': requestCoalescing!,
        if (serveWhileStale != null) 'serveWhileStale': serveWhileStale!,
        if (signedUrlCacheMaxAgeSec != null)
          'signedUrlCacheMaxAgeSec': signedUrlCacheMaxAgeSec!,
        if (signedUrlKeyNames != null) 'signedUrlKeyNames': signedUrlKeyNames!,
      };
}

/// Bypass the cache when the specified request headers are present, e.g. Pragma
/// or Authorization headers.
///
/// Values are case insensitive. The presence of such a header overrides the
/// cache_mode setting.
typedef BackendBucketCdnPolicyBypassCacheOnRequestHeader
    = $CdnPolicyBypassCacheOnRequestHeader;

/// Message containing what to include in the cache key for a request for Cloud
/// CDN.
class BackendBucketCdnPolicyCacheKeyPolicy {
  /// Allows HTTP request headers (by name) to be used in the cache key.
  core.List<core.String>? includeHttpHeaders;

  /// Names of query string parameters to include in cache keys.
  ///
  /// Default parameters are always included. '&' and '=' will be percent
  /// encoded and not treated as delimiters.
  core.List<core.String>? queryStringWhitelist;

  BackendBucketCdnPolicyCacheKeyPolicy({
    this.includeHttpHeaders,
    this.queryStringWhitelist,
  });

  BackendBucketCdnPolicyCacheKeyPolicy.fromJson(core.Map json_)
      : this(
          includeHttpHeaders: json_.containsKey('includeHttpHeaders')
              ? (json_['includeHttpHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          queryStringWhitelist: json_.containsKey('queryStringWhitelist')
              ? (json_['queryStringWhitelist'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (includeHttpHeaders != null)
          'includeHttpHeaders': includeHttpHeaders!,
        if (queryStringWhitelist != null)
          'queryStringWhitelist': queryStringWhitelist!,
      };
}

/// Specify CDN TTLs for response error codes.
typedef BackendBucketCdnPolicyNegativeCachingPolicy
    = $CdnPolicyNegativeCachingPolicy;

class BackendBucketListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  BackendBucketListWarningData({
    this.key,
    this.value,
  });

  BackendBucketListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class BackendBucketListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<BackendBucketListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  BackendBucketListWarning({
    this.code,
    this.data,
    this.message,
  });

  BackendBucketListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => BackendBucketListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of BackendBucket resources.
class BackendBucketList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of BackendBucket resources.
  core.List<BackendBucket>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  BackendBucketListWarning? warning;

  BackendBucketList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  BackendBucketList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => BackendBucket.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? BackendBucketListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Backend Service resource.
///
/// A backend service defines how Google Cloud load balancers distribute
/// traffic. The backend service configuration contains a set of values, such as
/// the protocol used to connect to backends, various distribution and session
/// settings, health checks, and timeouts. These settings provide fine-grained
/// control over how your load balancer behaves. Most of the settings have
/// default values that allow for easy configuration if you need to get started
/// quickly. Backend services in Google Compute Engine can be either regionally
/// or globally scoped. *
/// [Global](https://cloud.google.com/compute/docs/reference/rest/v1/backendServices)
/// *
/// [Regional](https://cloud.google.com/compute/docs/reference/rest/v1/regionBackendServices)
/// For more information, see Backend Services.
class BackendService {
  /// Lifetime of cookies in seconds.
  ///
  /// This setting is applicable to external and internal HTTP(S) load balancers
  /// and Traffic Director and requires GENERATED_COOKIE or HTTP_COOKIE session
  /// affinity. If set to 0, the cookie is non-persistent and lasts only until
  /// the end of the browser session (or equivalent). The maximum allowed value
  /// is two weeks (1,209,600). Not supported when the backend service is
  /// referenced by a URL map that is bound to target gRPC proxy that has
  /// validateForProxyless field set to true.
  core.int? affinityCookieTtlSec;

  /// The list of backends that serve this BackendService.
  core.List<Backend>? backends;

  /// Cloud CDN configuration for this BackendService.
  ///
  /// Only available for specified load balancer types.
  BackendServiceCdnPolicy? cdnPolicy;
  CircuitBreakers? circuitBreakers;

  /// Compress text responses using Brotli or gzip compression, based on the
  /// client's Accept-Encoding header.
  /// Possible string values are:
  /// - "AUTOMATIC" : Automatically uses the best compression based on the
  /// Accept-Encoding header sent by the client.
  /// - "DISABLED" : Disables compression. Existing compressed responses cached
  /// by Cloud CDN will not be served to clients.
  core.String? compressionMode;
  ConnectionDraining? connectionDraining;

  /// Connection Tracking configuration for this BackendService.
  ///
  /// Connection tracking policy settings are only available for Network Load
  /// Balancing and Internal TCP/UDP Load Balancing.
  BackendServiceConnectionTrackingPolicy? connectionTrackingPolicy;

  /// Consistent Hash-based load balancing can be used to provide soft session
  /// affinity based on HTTP headers, cookies or other properties.
  ///
  /// This load balancing policy is applicable only for HTTP connections. The
  /// affinity to a particular destination host will be lost when one or more
  /// hosts are added/removed from the destination service. This field specifies
  /// parameters that control consistent hashing. This field is only applicable
  /// when localityLbPolicy is set to MAGLEV or RING_HASH. This field is
  /// applicable to either: - A regional backend service with the
  /// service_protocol set to HTTP, HTTPS, or HTTP2, and load_balancing_scheme
  /// set to INTERNAL_MANAGED. - A global backend service with the
  /// load_balancing_scheme set to INTERNAL_SELF_MANAGED.
  ConsistentHashLoadBalancerSettings? consistentHash;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Headers that the load balancer adds to proxied requests.
  ///
  /// See
  /// [Creating custom headers](https://cloud.google.com/load-balancing/docs/custom-headers).
  core.List<core.String>? customRequestHeaders;

  /// Headers that the load balancer adds to proxied responses.
  ///
  /// See
  /// [Creating custom headers](https://cloud.google.com/load-balancing/docs/custom-headers).
  core.List<core.String>? customResponseHeaders;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The resource URL for the edge security policy associated with this backend
  /// service.
  ///
  /// Output only.
  core.String? edgeSecurityPolicy;

  /// If true, enables Cloud CDN for the backend service of an external HTTP(S)
  /// load balancer.
  core.bool? enableCDN;

  /// Requires at least one backend instance group to be defined as a backup
  /// (failover) backend.
  ///
  /// For load balancers that have configurable failover:
  /// [Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal/failover-overview)
  /// and
  /// [external TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-failover-overview).
  BackendServiceFailoverPolicy? failoverPolicy;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// BackendService. An up-to-date fingerprint must be provided in order to
  /// update the BackendService, otherwise the request will fail with error 412
  /// conditionNotMet. To see the latest fingerprint, make a get() request to
  /// retrieve a BackendService.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The list of URLs to the healthChecks, httpHealthChecks (legacy), or
  /// httpsHealthChecks (legacy) resource for health checking this backend
  /// service.
  ///
  /// Not all backend services support legacy health checks. See Load balancer
  /// guide. Currently, at most one health check can be specified for each
  /// backend service. Backend services with instance group or zonal NEG
  /// backends must have a health check. Backend services with internet or
  /// serverless NEG backends must not have a health check.
  core.List<core.String>? healthChecks;

  /// The configurations for Identity-Aware Proxy on this resource.
  ///
  /// Not available for Internal TCP/UDP Load Balancing and Network Load
  /// Balancing.
  BackendServiceIAP? iap;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#backendService for backend services.
  ///
  /// Output only.
  core.String? kind;

  /// Specifies the load balancer type.
  ///
  /// A backend service created for one type of load balancer cannot be used
  /// with another. For more information, refer to Choosing a load balancer.
  /// Possible string values are:
  /// - "EXTERNAL" : Signifies that this will be used for external HTTP(S), SSL
  /// Proxy, TCP Proxy, or Network Load Balancing
  /// - "EXTERNAL_MANAGED" : Signifies that this will be used for External
  /// Managed HTTP(S) Load Balancing.
  /// - "INTERNAL" : Signifies that this will be used for Internal TCP/UDP Load
  /// Balancing.
  /// - "INTERNAL_MANAGED" : Signifies that this will be used for Internal
  /// HTTP(S) Load Balancing.
  /// - "INTERNAL_SELF_MANAGED" : Signifies that this will be used by Traffic
  /// Director.
  /// - "INVALID_LOAD_BALANCING_SCHEME"
  core.String? loadBalancingScheme;

  /// A list of locality load balancing policies to be used in order of
  /// preference.
  ///
  /// Either the policy or the customPolicy field should be set. Overrides any
  /// value set in the localityLbPolicy field. localityLbPolicies is only
  /// supported when the BackendService is referenced by a URL Map that is
  /// referenced by a target gRPC proxy that has the validateForProxyless field
  /// set to true.
  core.List<BackendServiceLocalityLoadBalancingPolicyConfig>?
      localityLbPolicies;

  /// The load balancing algorithm used within the scope of the locality.
  ///
  /// The possible values are: - ROUND_ROBIN: This is a simple policy in which
  /// each healthy backend is selected in round robin order. This is the
  /// default. - LEAST_REQUEST: An O(1) algorithm which selects two random
  /// healthy hosts and picks the host which has fewer active requests. -
  /// RING_HASH: The ring/modulo hash load balancer implements consistent
  /// hashing to backends. The algorithm has the property that the
  /// addition/removal of a host from a set of N hosts only affects 1/N of the
  /// requests. - RANDOM: The load balancer selects a random healthy host. -
  /// ORIGINAL_DESTINATION: Backend host is selected based on the client
  /// connection metadata, i.e., connections are opened to the same address as
  /// the destination address of the incoming connection before the connection
  /// was redirected to the load balancer. - MAGLEV: used as a drop in
  /// replacement for the ring hash load balancer. Maglev is not as stable as
  /// ring hash but has faster table lookup build times and host selection
  /// times. For more information about Maglev, see
  /// https://ai.google/research/pubs/pub44824 This field is applicable to
  /// either: - A regional backend service with the service_protocol set to
  /// HTTP, HTTPS, or HTTP2, and load_balancing_scheme set to INTERNAL_MANAGED.
  /// - A global backend service with the load_balancing_scheme set to
  /// INTERNAL_SELF_MANAGED. If sessionAffinity is not NONE, and this field is
  /// not set to MAGLEV or RING_HASH, session affinity settings will not take
  /// effect. Only ROUND_ROBIN and RING_HASH are supported when the backend
  /// service is referenced by a URL map that is bound to target gRPC proxy that
  /// has validateForProxyless field set to true.
  /// Possible string values are:
  /// - "INVALID_LB_POLICY"
  /// - "LEAST_REQUEST" : An O(1) algorithm which selects two random healthy
  /// hosts and picks the host which has fewer active requests.
  /// - "MAGLEV" : This algorithm implements consistent hashing to backends.
  /// Maglev can be used as a drop in replacement for the ring hash load
  /// balancer. Maglev is not as stable as ring hash but has faster table lookup
  /// build times and host selection times. For more information about Maglev,
  /// see https://ai.google/research/pubs/pub44824
  /// - "ORIGINAL_DESTINATION" : Backend host is selected based on the client
  /// connection metadata, i.e., connections are opened to the same address as
  /// the destination address of the incoming connection before the connection
  /// was redirected to the load balancer.
  /// - "RANDOM" : The load balancer selects a random healthy host.
  /// - "RING_HASH" : The ring/modulo hash load balancer implements consistent
  /// hashing to backends. The algorithm has the property that the
  /// addition/removal of a host from a set of N hosts only affects 1/N of the
  /// requests.
  /// - "ROUND_ROBIN" : This is a simple policy in which each healthy backend is
  /// selected in round robin order. This is the default.
  core.String? localityLbPolicy;

  /// This field denotes the logging options for the load balancer traffic
  /// served by this backend service.
  ///
  /// If logging is enabled, logs will be exported to Stackdriver.
  BackendServiceLogConfig? logConfig;

  /// Specifies the default maximum duration (timeout) for streams to this
  /// service.
  ///
  /// Duration is computed from the beginning of the stream until the response
  /// has been completely processed, including all retries. A stream that does
  /// not complete in this duration is closed. If not specified, there will be
  /// no timeout limit, i.e. the maximum duration is infinite. This value can be
  /// overridden in the PathMatcher configuration of the UrlMap that references
  /// this backend service. This field is only allowed when the
  /// loadBalancingScheme of the backend service is INTERNAL_SELF_MANAGED.
  Duration? maxStreamDuration;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The URL of the network to which this backend service belongs.
  ///
  /// This field can only be specified when the load balancing scheme is set to
  /// INTERNAL.
  core.String? network;

  /// Settings controlling the eviction of unhealthy hosts from the load
  /// balancing pool for the backend service.
  ///
  /// If not set, this feature is considered disabled. This field is applicable
  /// to either: - A regional backend service with the service_protocol set to
  /// HTTP, HTTPS, or HTTP2, and load_balancing_scheme set to INTERNAL_MANAGED.
  /// - A global backend service with the load_balancing_scheme set to
  /// INTERNAL_SELF_MANAGED. Not supported when the backend service is
  /// referenced by a URL map that is bound to target gRPC proxy that has
  /// validateForProxyless field set to true.
  OutlierDetection? outlierDetection;

  /// Deprecated in favor of portName.
  ///
  /// The TCP port to connect on the backend. The default value is 80. For
  /// Internal TCP/UDP Load Balancing and Network Load Balancing, omit port.
  core.int? port;

  /// A named port on a backend instance group representing the port for
  /// communication to the backend VMs in that group.
  ///
  /// The named port must be
  /// [defined on each backend instance group](https://cloud.google.com/load-balancing/docs/backend-service#named_ports).
  /// This parameter has no meaning if the backends are NEGs. For Internal
  /// TCP/UDP Load Balancing and Network Load Balancing, omit port_name.
  core.String? portName;

  /// The protocol this BackendService uses to communicate with backends.
  ///
  /// Possible values are HTTP, HTTPS, HTTP2, TCP, SSL, UDP or GRPC. depending
  /// on the chosen load balancer or Traffic Director configuration. Refer to
  /// the documentation for the load balancers or for Traffic Director for more
  /// information. Must be set to GRPC when the backend service is referenced by
  /// a URL map that is bound to target gRPC proxy.
  /// Possible string values are:
  /// - "GRPC" : gRPC (available for Traffic Director).
  /// - "HTTP"
  /// - "HTTP2" : HTTP/2 with SSL.
  /// - "HTTPS"
  /// - "SSL" : TCP proxying with SSL.
  /// - "TCP" : TCP proxying or TCP pass-through.
  /// - "UDP" : UDP.
  /// - "UNSPECIFIED" : If a Backend Service has UNSPECIFIED as its protocol, it
  /// can be used with any L3/L4 Forwarding Rules.
  core.String? protocol;

  /// URL of the region where the regional backend service resides.
  ///
  /// This field is not applicable to global backend services. You must specify
  /// this field as part of the HTTP request URL. It is not settable as a field
  /// in the request body.
  ///
  /// Output only.
  core.String? region;

  /// The resource URL for the security policy associated with this backend
  /// service.
  ///
  /// Output only.
  core.String? securityPolicy;

  /// This field specifies the security settings that apply to this backend
  /// service.
  ///
  /// This field is applicable to a global backend service with the
  /// load_balancing_scheme set to INTERNAL_SELF_MANAGED.
  SecuritySettings? securitySettings;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// URLs of networkservices.ServiceBinding resources.
  ///
  /// Can only be set if load balancing scheme is INTERNAL_SELF_MANAGED. If set,
  /// lists of backends and health checks must be both empty.
  core.List<core.String>? serviceBindings;

  /// Type of session affinity to use.
  ///
  /// The default is NONE. Only NONE and HEADER_FIELD are supported when the
  /// backend service is referenced by a URL map that is bound to target gRPC
  /// proxy that has validateForProxyless field set to true. For more details,
  /// see:
  /// [Session Affinity](https://cloud.google.com/load-balancing/docs/backend-service#session_affinity).
  /// Possible string values are:
  /// - "CLIENT_IP" : 2-tuple hash on packet's source and destination IP
  /// addresses. Connections from the same source IP address to the same
  /// destination IP address will be served by the same backend VM while that VM
  /// remains healthy.
  /// - "CLIENT_IP_NO_DESTINATION" : 1-tuple hash only on packet's source IP
  /// address. Connections from the same source IP address will be served by the
  /// same backend VM while that VM remains healthy. This option can only be
  /// used for Internal TCP/UDP Load Balancing.
  /// - "CLIENT_IP_PORT_PROTO" : 5-tuple hash on packet's source and destination
  /// IP addresses, IP protocol, and source and destination ports. Connections
  /// for the same IP protocol from the same source IP address and port to the
  /// same destination IP address and port will be served by the same backend VM
  /// while that VM remains healthy. This option cannot be used for HTTP(S) load
  /// balancing.
  /// - "CLIENT_IP_PROTO" : 3-tuple hash on packet's source and destination IP
  /// addresses, and IP protocol. Connections for the same IP protocol from the
  /// same source IP address to the same destination IP address will be served
  /// by the same backend VM while that VM remains healthy. This option cannot
  /// be used for HTTP(S) load balancing.
  /// - "GENERATED_COOKIE" : Hash based on a cookie generated by the L7
  /// loadbalancer. Only valid for HTTP(S) load balancing.
  /// - "HEADER_FIELD" : The hash is based on a user specified header field.
  /// - "HTTP_COOKIE" : The hash is based on a user provided cookie.
  /// - "NONE" : No session affinity. Connections from the same client IP may go
  /// to any instance in the pool.
  core.String? sessionAffinity;
  Subsetting? subsetting;

  /// The backend service timeout has a different meaning depending on the type
  /// of load balancer.
  ///
  /// For more information see, Backend service settings. The default is 30
  /// seconds. The full range of timeout values allowed goes from 1 through
  /// 2,147,483,647 seconds. This value can be overridden in the PathMatcher
  /// configuration of the UrlMap that references this backend service. Not
  /// supported when the backend service is referenced by a URL map that is
  /// bound to target gRPC proxy that has validateForProxyless field set to
  /// true. Instead, use maxStreamDuration.
  core.int? timeoutSec;

  BackendService({
    this.affinityCookieTtlSec,
    this.backends,
    this.cdnPolicy,
    this.circuitBreakers,
    this.compressionMode,
    this.connectionDraining,
    this.connectionTrackingPolicy,
    this.consistentHash,
    this.creationTimestamp,
    this.customRequestHeaders,
    this.customResponseHeaders,
    this.description,
    this.edgeSecurityPolicy,
    this.enableCDN,
    this.failoverPolicy,
    this.fingerprint,
    this.healthChecks,
    this.iap,
    this.id,
    this.kind,
    this.loadBalancingScheme,
    this.localityLbPolicies,
    this.localityLbPolicy,
    this.logConfig,
    this.maxStreamDuration,
    this.name,
    this.network,
    this.outlierDetection,
    this.port,
    this.portName,
    this.protocol,
    this.region,
    this.securityPolicy,
    this.securitySettings,
    this.selfLink,
    this.serviceBindings,
    this.sessionAffinity,
    this.subsetting,
    this.timeoutSec,
  });

  BackendService.fromJson(core.Map json_)
      : this(
          affinityCookieTtlSec: json_.containsKey('affinityCookieTtlSec')
              ? json_['affinityCookieTtlSec'] as core.int
              : null,
          backends: json_.containsKey('backends')
              ? (json_['backends'] as core.List)
                  .map((value) => Backend.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          cdnPolicy: json_.containsKey('cdnPolicy')
              ? BackendServiceCdnPolicy.fromJson(
                  json_['cdnPolicy'] as core.Map<core.String, core.dynamic>)
              : null,
          circuitBreakers: json_.containsKey('circuitBreakers')
              ? CircuitBreakers.fromJson(json_['circuitBreakers']
                  as core.Map<core.String, core.dynamic>)
              : null,
          compressionMode: json_.containsKey('compressionMode')
              ? json_['compressionMode'] as core.String
              : null,
          connectionDraining: json_.containsKey('connectionDraining')
              ? ConnectionDraining.fromJson(json_['connectionDraining']
                  as core.Map<core.String, core.dynamic>)
              : null,
          connectionTrackingPolicy:
              json_.containsKey('connectionTrackingPolicy')
                  ? BackendServiceConnectionTrackingPolicy.fromJson(
                      json_['connectionTrackingPolicy']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          consistentHash: json_.containsKey('consistentHash')
              ? ConsistentHashLoadBalancerSettings.fromJson(
                  json_['consistentHash']
                      as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          customRequestHeaders: json_.containsKey('customRequestHeaders')
              ? (json_['customRequestHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          customResponseHeaders: json_.containsKey('customResponseHeaders')
              ? (json_['customResponseHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          edgeSecurityPolicy: json_.containsKey('edgeSecurityPolicy')
              ? json_['edgeSecurityPolicy'] as core.String
              : null,
          enableCDN: json_.containsKey('enableCDN')
              ? json_['enableCDN'] as core.bool
              : null,
          failoverPolicy: json_.containsKey('failoverPolicy')
              ? BackendServiceFailoverPolicy.fromJson(json_['failoverPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          iap: json_.containsKey('iap')
              ? BackendServiceIAP.fromJson(
                  json_['iap'] as core.Map<core.String, core.dynamic>)
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          loadBalancingScheme: json_.containsKey('loadBalancingScheme')
              ? json_['loadBalancingScheme'] as core.String
              : null,
          localityLbPolicies: json_.containsKey('localityLbPolicies')
              ? (json_['localityLbPolicies'] as core.List)
                  .map((value) =>
                      BackendServiceLocalityLoadBalancingPolicyConfig.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          localityLbPolicy: json_.containsKey('localityLbPolicy')
              ? json_['localityLbPolicy'] as core.String
              : null,
          logConfig: json_.containsKey('logConfig')
              ? BackendServiceLogConfig.fromJson(
                  json_['logConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          maxStreamDuration: json_.containsKey('maxStreamDuration')
              ? Duration.fromJson(json_['maxStreamDuration']
                  as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          outlierDetection: json_.containsKey('outlierDetection')
              ? OutlierDetection.fromJson(json_['outlierDetection']
                  as core.Map<core.String, core.dynamic>)
              : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          protocol: json_.containsKey('protocol')
              ? json_['protocol'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          securityPolicy: json_.containsKey('securityPolicy')
              ? json_['securityPolicy'] as core.String
              : null,
          securitySettings: json_.containsKey('securitySettings')
              ? SecuritySettings.fromJson(json_['securitySettings']
                  as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          serviceBindings: json_.containsKey('serviceBindings')
              ? (json_['serviceBindings'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sessionAffinity: json_.containsKey('sessionAffinity')
              ? json_['sessionAffinity'] as core.String
              : null,
          subsetting: json_.containsKey('subsetting')
              ? Subsetting.fromJson(
                  json_['subsetting'] as core.Map<core.String, core.dynamic>)
              : null,
          timeoutSec: json_.containsKey('timeoutSec')
              ? json_['timeoutSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (affinityCookieTtlSec != null)
          'affinityCookieTtlSec': affinityCookieTtlSec!,
        if (backends != null) 'backends': backends!,
        if (cdnPolicy != null) 'cdnPolicy': cdnPolicy!,
        if (circuitBreakers != null) 'circuitBreakers': circuitBreakers!,
        if (compressionMode != null) 'compressionMode': compressionMode!,
        if (connectionDraining != null)
          'connectionDraining': connectionDraining!,
        if (connectionTrackingPolicy != null)
          'connectionTrackingPolicy': connectionTrackingPolicy!,
        if (consistentHash != null) 'consistentHash': consistentHash!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (customRequestHeaders != null)
          'customRequestHeaders': customRequestHeaders!,
        if (customResponseHeaders != null)
          'customResponseHeaders': customResponseHeaders!,
        if (description != null) 'description': description!,
        if (edgeSecurityPolicy != null)
          'edgeSecurityPolicy': edgeSecurityPolicy!,
        if (enableCDN != null) 'enableCDN': enableCDN!,
        if (failoverPolicy != null) 'failoverPolicy': failoverPolicy!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (healthChecks != null) 'healthChecks': healthChecks!,
        if (iap != null) 'iap': iap!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (loadBalancingScheme != null)
          'loadBalancingScheme': loadBalancingScheme!,
        if (localityLbPolicies != null)
          'localityLbPolicies': localityLbPolicies!,
        if (localityLbPolicy != null) 'localityLbPolicy': localityLbPolicy!,
        if (logConfig != null) 'logConfig': logConfig!,
        if (maxStreamDuration != null) 'maxStreamDuration': maxStreamDuration!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (outlierDetection != null) 'outlierDetection': outlierDetection!,
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (protocol != null) 'protocol': protocol!,
        if (region != null) 'region': region!,
        if (securityPolicy != null) 'securityPolicy': securityPolicy!,
        if (securitySettings != null) 'securitySettings': securitySettings!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (serviceBindings != null) 'serviceBindings': serviceBindings!,
        if (sessionAffinity != null) 'sessionAffinity': sessionAffinity!,
        if (subsetting != null) 'subsetting': subsetting!,
        if (timeoutSec != null) 'timeoutSec': timeoutSec!,
      };
}

class BackendServiceAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  BackendServiceAggregatedListWarningData({
    this.key,
    this.value,
  });

  BackendServiceAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class BackendServiceAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<BackendServiceAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  BackendServiceAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  BackendServiceAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      BackendServiceAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of BackendServicesScopedList.
class BackendServiceAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of BackendServicesScopedList resources.
  core.Map<core.String, BackendServicesScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  BackendServiceAggregatedListWarning? warning;

  BackendServiceAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  BackendServiceAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    BackendServicesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? BackendServiceAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

/// Message containing Cloud CDN configuration for a backend service.
class BackendServiceCdnPolicy {
  /// Bypass the cache when the specified request headers are matched - e.g.
  /// Pragma or Authorization headers.
  ///
  /// Up to 5 headers can be specified. The cache is bypassed for all
  /// cdnPolicy.cacheMode settings.
  core.List<BackendServiceCdnPolicyBypassCacheOnRequestHeader>?
      bypassCacheOnRequestHeaders;

  /// The CacheKeyPolicy for this CdnPolicy.
  CacheKeyPolicy? cacheKeyPolicy;

  /// Specifies the cache setting for all responses from this backend.
  ///
  /// The possible values are: USE_ORIGIN_HEADERS Requires the origin to set
  /// valid caching headers to cache content. Responses without these headers
  /// will not be cached at Google's edge, and will require a full trip to the
  /// origin on every request, potentially impacting performance and increasing
  /// load on the origin server. FORCE_CACHE_ALL Cache all content, ignoring any
  /// "private", "no-store" or "no-cache" directives in Cache-Control response
  /// headers. Warning: this may result in Cloud CDN caching private, per-user
  /// (user identifiable) content. CACHE_ALL_STATIC Automatically cache static
  /// content, including common image formats, media (video and audio), and web
  /// assets (JavaScript and CSS). Requests and responses that are marked as
  /// uncacheable, as well as dynamic content (including HTML), will not be
  /// cached.
  /// Possible string values are:
  /// - "CACHE_ALL_STATIC" : Automatically cache static content, including
  /// common image formats, media (video and audio), and web assets (JavaScript
  /// and CSS). Requests and responses that are marked as uncacheable, as well
  /// as dynamic content (including HTML), will not be cached.
  /// - "FORCE_CACHE_ALL" : Cache all content, ignoring any "private",
  /// "no-store" or "no-cache" directives in Cache-Control response headers.
  /// Warning: this may result in Cloud CDN caching private, per-user (user
  /// identifiable) content.
  /// - "INVALID_CACHE_MODE"
  /// - "USE_ORIGIN_HEADERS" : Requires the origin to set valid caching headers
  /// to cache content. Responses without these headers will not be cached at
  /// Google's edge, and will require a full trip to the origin on every
  /// request, potentially impacting performance and increasing load on the
  /// origin server.
  core.String? cacheMode;

  /// Specifies a separate client (e.g. browser client) maximum TTL.
  ///
  /// This is used to clamp the max-age (or Expires) value sent to the client.
  /// With FORCE_CACHE_ALL, the lesser of client_ttl and default_ttl is used for
  /// the response max-age directive, along with a "public" directive. For
  /// cacheable content in CACHE_ALL_STATIC mode, client_ttl clamps the max-age
  /// from the origin (if specified), or else sets the response max-age
  /// directive to the lesser of the client_ttl and default_ttl, and also
  /// ensures a "public" cache-control directive is present. If a client TTL is
  /// not specified, a default value (1 hour) will be used. The maximum allowed
  /// value is 31,622,400s (1 year).
  core.int? clientTtl;

  /// Specifies the default TTL for cached content served by this origin for
  /// responses that do not have an existing valid TTL (max-age or s-max-age).
  ///
  /// Setting a TTL of "0" means "always revalidate". The value of defaultTTL
  /// cannot be set to a value greater than that of maxTTL, but can be equal.
  /// When the cacheMode is set to FORCE_CACHE_ALL, the defaultTTL will
  /// overwrite the TTL set in all responses. The maximum allowed value is
  /// 31,622,400s (1 year), noting that infrequently accessed objects may be
  /// evicted from the cache before the defined TTL.
  core.int? defaultTtl;

  /// Specifies the maximum allowed TTL for cached content served by this
  /// origin.
  ///
  /// Cache directives that attempt to set a max-age or s-maxage higher than
  /// this, or an Expires header more than maxTTL seconds in the future will be
  /// capped at the value of maxTTL, as if it were the value of an s-maxage
  /// Cache-Control directive. Headers sent to the client will not be modified.
  /// Setting a TTL of "0" means "always revalidate". The maximum allowed value
  /// is 31,622,400s (1 year), noting that infrequently accessed objects may be
  /// evicted from the cache before the defined TTL.
  core.int? maxTtl;

  /// Negative caching allows per-status code TTLs to be set, in order to apply
  /// fine-grained caching for common errors or redirects.
  ///
  /// This can reduce the load on your origin and improve end-user experience by
  /// reducing response latency. When the cache mode is set to CACHE_ALL_STATIC
  /// or USE_ORIGIN_HEADERS, negative caching applies to responses with the
  /// specified response code that lack any Cache-Control, Expires, or Pragma:
  /// no-cache directives. When the cache mode is set to FORCE_CACHE_ALL,
  /// negative caching applies to all responses with the specified response
  /// code, and override any caching headers. By default, Cloud CDN will apply
  /// the following default TTLs to these status codes: HTTP 300 (Multiple
  /// Choice), 301, 308 (Permanent Redirects): 10m HTTP 404 (Not Found), 410
  /// (Gone), 451 (Unavailable For Legal Reasons): 120s HTTP 405 (Method Not
  /// Found), 421 (Misdirected Request), 501 (Not Implemented): 60s. These
  /// defaults can be overridden in negative_caching_policy.
  core.bool? negativeCaching;

  /// Sets a cache TTL for the specified HTTP status code.
  ///
  /// negative_caching must be enabled to configure negative_caching_policy.
  /// Omitting the policy and leaving negative_caching enabled will use Cloud
  /// CDN's default cache TTLs. Note that when specifying an explicit
  /// negative_caching_policy, you should take care to specify a cache TTL for
  /// all response codes that you wish to cache. Cloud CDN will not apply any
  /// default negative caching when a policy exists.
  core.List<BackendServiceCdnPolicyNegativeCachingPolicy>?
      negativeCachingPolicy;

  /// If true then Cloud CDN will combine multiple concurrent cache fill
  /// requests into a small number of requests to the origin.
  core.bool? requestCoalescing;

  /// Serve existing content from the cache (if available) when revalidating
  /// content with the origin, or when an error is encountered when refreshing
  /// the cache.
  ///
  /// This setting defines the default "max-stale" duration for any cached
  /// responses that do not specify a max-stale directive. Stale responses that
  /// exceed the TTL configured here will not be served. The default limit
  /// (max-stale) is 86400s (1 day), which will allow stale content to be served
  /// up to this limit beyond the max-age (or s-max-age) of a cached response.
  /// The maximum allowed value is 604800 (1 week). Set this to zero (0) to
  /// disable serve-while-stale.
  core.int? serveWhileStale;

  /// Maximum number of seconds the response to a signed URL request will be
  /// considered fresh.
  ///
  /// After this time period, the response will be revalidated before being
  /// served. Defaults to 1hr (3600s). When serving responses to signed URL
  /// requests, Cloud CDN will internally behave as though all responses from
  /// this backend had a "Cache-Control: public, max-age=\[TTL\]" header,
  /// regardless of any existing Cache-Control header. The actual headers served
  /// in responses will not be altered.
  core.String? signedUrlCacheMaxAgeSec;

  /// Names of the keys for signing request URLs.
  ///
  /// Output only.
  core.List<core.String>? signedUrlKeyNames;

  BackendServiceCdnPolicy({
    this.bypassCacheOnRequestHeaders,
    this.cacheKeyPolicy,
    this.cacheMode,
    this.clientTtl,
    this.defaultTtl,
    this.maxTtl,
    this.negativeCaching,
    this.negativeCachingPolicy,
    this.requestCoalescing,
    this.serveWhileStale,
    this.signedUrlCacheMaxAgeSec,
    this.signedUrlKeyNames,
  });

  BackendServiceCdnPolicy.fromJson(core.Map json_)
      : this(
          bypassCacheOnRequestHeaders:
              json_.containsKey('bypassCacheOnRequestHeaders')
                  ? (json_['bypassCacheOnRequestHeaders'] as core.List)
                      .map((value) =>
                          BackendServiceCdnPolicyBypassCacheOnRequestHeader
                              .fromJson(
                                  value as core.Map<core.String, core.dynamic>))
                      .toList()
                  : null,
          cacheKeyPolicy: json_.containsKey('cacheKeyPolicy')
              ? CacheKeyPolicy.fromJson(json_['cacheKeyPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          cacheMode: json_.containsKey('cacheMode')
              ? json_['cacheMode'] as core.String
              : null,
          clientTtl: json_.containsKey('clientTtl')
              ? json_['clientTtl'] as core.int
              : null,
          defaultTtl: json_.containsKey('defaultTtl')
              ? json_['defaultTtl'] as core.int
              : null,
          maxTtl:
              json_.containsKey('maxTtl') ? json_['maxTtl'] as core.int : null,
          negativeCaching: json_.containsKey('negativeCaching')
              ? json_['negativeCaching'] as core.bool
              : null,
          negativeCachingPolicy: json_.containsKey('negativeCachingPolicy')
              ? (json_['negativeCachingPolicy'] as core.List)
                  .map((value) =>
                      BackendServiceCdnPolicyNegativeCachingPolicy.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          requestCoalescing: json_.containsKey('requestCoalescing')
              ? json_['requestCoalescing'] as core.bool
              : null,
          serveWhileStale: json_.containsKey('serveWhileStale')
              ? json_['serveWhileStale'] as core.int
              : null,
          signedUrlCacheMaxAgeSec: json_.containsKey('signedUrlCacheMaxAgeSec')
              ? json_['signedUrlCacheMaxAgeSec'] as core.String
              : null,
          signedUrlKeyNames: json_.containsKey('signedUrlKeyNames')
              ? (json_['signedUrlKeyNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bypassCacheOnRequestHeaders != null)
          'bypassCacheOnRequestHeaders': bypassCacheOnRequestHeaders!,
        if (cacheKeyPolicy != null) 'cacheKeyPolicy': cacheKeyPolicy!,
        if (cacheMode != null) 'cacheMode': cacheMode!,
        if (clientTtl != null) 'clientTtl': clientTtl!,
        if (defaultTtl != null) 'defaultTtl': defaultTtl!,
        if (maxTtl != null) 'maxTtl': maxTtl!,
        if (negativeCaching != null) 'negativeCaching': negativeCaching!,
        if (negativeCachingPolicy != null)
          'negativeCachingPolicy': negativeCachingPolicy!,
        if (requestCoalescing != null) 'requestCoalescing': requestCoalescing!,
        if (serveWhileStale != null) 'serveWhileStale': serveWhileStale!,
        if (signedUrlCacheMaxAgeSec != null)
          'signedUrlCacheMaxAgeSec': signedUrlCacheMaxAgeSec!,
        if (signedUrlKeyNames != null) 'signedUrlKeyNames': signedUrlKeyNames!,
      };
}

/// Bypass the cache when the specified request headers are present, e.g. Pragma
/// or Authorization headers.
///
/// Values are case insensitive. The presence of such a header overrides the
/// cache_mode setting.
typedef BackendServiceCdnPolicyBypassCacheOnRequestHeader
    = $CdnPolicyBypassCacheOnRequestHeader;

/// Specify CDN TTLs for response error codes.
typedef BackendServiceCdnPolicyNegativeCachingPolicy
    = $CdnPolicyNegativeCachingPolicy;

/// Connection Tracking configuration for this BackendService.
class BackendServiceConnectionTrackingPolicy {
  /// Specifies connection persistence when backends are unhealthy.
  ///
  /// The default value is DEFAULT_FOR_PROTOCOL. If set to DEFAULT_FOR_PROTOCOL,
  /// the existing connections persist on unhealthy backends only for
  /// connection-oriented protocols (TCP and SCTP) and only if the Tracking Mode
  /// is PER_CONNECTION (default tracking mode) or the Session Affinity is
  /// configured for 5-tuple. They do not persist for UDP. If set to
  /// NEVER_PERSIST, after a backend becomes unhealthy, the existing connections
  /// on the unhealthy backend are never persisted on the unhealthy backend.
  /// They are always diverted to newly selected healthy backends (unless all
  /// backends are unhealthy). If set to ALWAYS_PERSIST, existing connections
  /// always persist on unhealthy backends regardless of protocol and session
  /// affinity. It is generally not recommended to use this mode overriding the
  /// default. For more details, see
  /// [Connection Persistence for Network Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-backend-service#connection-persistence)
  /// and
  /// [Connection Persistence for Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal#connection-persistence).
  /// Possible string values are:
  /// - "ALWAYS_PERSIST"
  /// - "DEFAULT_FOR_PROTOCOL"
  /// - "NEVER_PERSIST"
  core.String? connectionPersistenceOnUnhealthyBackends;

  /// Enable Strong Session Affinity for Network Load Balancing.
  ///
  /// This option is not available publicly.
  core.bool? enableStrongAffinity;

  /// Specifies how long to keep a Connection Tracking entry while there is no
  /// matching traffic (in seconds).
  ///
  /// For Internal TCP/UDP Load Balancing: - The minimum (default) is 10 minutes
  /// and the maximum is 16 hours. - It can be set only if Connection Tracking
  /// is less than 5-tuple (i.e. Session Affinity is CLIENT_IP_NO_DESTINATION,
  /// CLIENT_IP or CLIENT_IP_PROTO, and Tracking Mode is PER_SESSION). For
  /// Network Load Balancer the default is 60 seconds. This option is not
  /// available publicly.
  core.int? idleTimeoutSec;

  /// Specifies the key used for connection tracking.
  ///
  /// There are two options: - PER_CONNECTION: This is the default mode. The
  /// Connection Tracking is performed as per the Connection Key (default Hash
  /// Method) for the specific protocol. - PER_SESSION: The Connection Tracking
  /// is performed as per the configured Session Affinity. It matches the
  /// configured Session Affinity. For more details, see
  /// [Tracking Mode for Network Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-backend-service#tracking-mode)
  /// and
  /// [Tracking Mode for Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal#tracking-mode).
  /// Possible string values are:
  /// - "INVALID_TRACKING_MODE"
  /// - "PER_CONNECTION"
  /// - "PER_SESSION"
  core.String? trackingMode;

  BackendServiceConnectionTrackingPolicy({
    this.connectionPersistenceOnUnhealthyBackends,
    this.enableStrongAffinity,
    this.idleTimeoutSec,
    this.trackingMode,
  });

  BackendServiceConnectionTrackingPolicy.fromJson(core.Map json_)
      : this(
          connectionPersistenceOnUnhealthyBackends: json_
                  .containsKey('connectionPersistenceOnUnhealthyBackends')
              ? json_['connectionPersistenceOnUnhealthyBackends'] as core.String
              : null,
          enableStrongAffinity: json_.containsKey('enableStrongAffinity')
              ? json_['enableStrongAffinity'] as core.bool
              : null,
          idleTimeoutSec: json_.containsKey('idleTimeoutSec')
              ? json_['idleTimeoutSec'] as core.int
              : null,
          trackingMode: json_.containsKey('trackingMode')
              ? json_['trackingMode'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (connectionPersistenceOnUnhealthyBackends != null)
          'connectionPersistenceOnUnhealthyBackends':
              connectionPersistenceOnUnhealthyBackends!,
        if (enableStrongAffinity != null)
          'enableStrongAffinity': enableStrongAffinity!,
        if (idleTimeoutSec != null) 'idleTimeoutSec': idleTimeoutSec!,
        if (trackingMode != null) 'trackingMode': trackingMode!,
      };
}

/// For load balancers that have configurable failover:
/// [Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal/failover-overview)
/// and
/// [external TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-failover-overview).
///
/// On failover or failback, this field indicates whether connection draining
/// will be honored. Google Cloud has a fixed connection draining timeout of 10
/// minutes. A setting of true terminates existing TCP connections to the active
/// pool during failover and failback, immediately draining traffic. A setting
/// of false allows existing TCP connections to persist, even on VMs no longer
/// in the active pool, for up to the duration of the connection draining
/// timeout (10 minutes).
class BackendServiceFailoverPolicy {
  /// This can be set to true only if the protocol is TCP.
  ///
  /// The default is false.
  core.bool? disableConnectionDrainOnFailover;

  /// If set to true, connections to the load balancer are dropped when all
  /// primary and all backup backend VMs are unhealthy.If set to false,
  /// connections are distributed among all primary VMs when all primary and all
  /// backup backend VMs are unhealthy.
  ///
  /// For load balancers that have configurable failover:
  /// [Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal/failover-overview)
  /// and
  /// [external TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-failover-overview).
  /// The default is false.
  core.bool? dropTrafficIfUnhealthy;

  /// The value of the field must be in the range \[0, 1\].
  ///
  /// If the value is 0, the load balancer performs a failover when the number
  /// of healthy primary VMs equals zero. For all other values, the load
  /// balancer performs a failover when the total number of healthy primary VMs
  /// is less than this ratio. For load balancers that have configurable
  /// failover:
  /// [Internal TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/internal/failover-overview)
  /// and
  /// [external TCP/UDP Load Balancing](https://cloud.google.com/load-balancing/docs/network/networklb-failover-overview).
  core.double? failoverRatio;

  BackendServiceFailoverPolicy({
    this.disableConnectionDrainOnFailover,
    this.dropTrafficIfUnhealthy,
    this.failoverRatio,
  });

  BackendServiceFailoverPolicy.fromJson(core.Map json_)
      : this(
          disableConnectionDrainOnFailover:
              json_.containsKey('disableConnectionDrainOnFailover')
                  ? json_['disableConnectionDrainOnFailover'] as core.bool
                  : null,
          dropTrafficIfUnhealthy: json_.containsKey('dropTrafficIfUnhealthy')
              ? json_['dropTrafficIfUnhealthy'] as core.bool
              : null,
          failoverRatio: json_.containsKey('failoverRatio')
              ? (json_['failoverRatio'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (disableConnectionDrainOnFailover != null)
          'disableConnectionDrainOnFailover': disableConnectionDrainOnFailover!,
        if (dropTrafficIfUnhealthy != null)
          'dropTrafficIfUnhealthy': dropTrafficIfUnhealthy!,
        if (failoverRatio != null) 'failoverRatio': failoverRatio!,
      };
}

class BackendServiceGroupHealth {
  /// Metadata defined as annotations on the network endpoint group.
  core.Map<core.String, core.String>? annotations;

  /// Health state of the backend instances or endpoints in requested instance
  /// or network endpoint group, determined based on configured health checks.
  core.List<HealthStatus>? healthStatus;

  /// Type of resource.
  ///
  /// Always compute#backendServiceGroupHealth for the health of backend
  /// services.
  ///
  /// Output only.
  core.String? kind;

  BackendServiceGroupHealth({
    this.annotations,
    this.healthStatus,
    this.kind,
  });

  BackendServiceGroupHealth.fromJson(core.Map json_)
      : this(
          annotations: json_.containsKey('annotations')
              ? (json_['annotations'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          healthStatus: json_.containsKey('healthStatus')
              ? (json_['healthStatus'] as core.List)
                  .map((value) => HealthStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (annotations != null) 'annotations': annotations!,
        if (healthStatus != null) 'healthStatus': healthStatus!,
        if (kind != null) 'kind': kind!,
      };
}

/// Identity-Aware Proxy
class BackendServiceIAP {
  /// Whether the serving infrastructure will authenticate and authorize all
  /// incoming requests.
  ///
  /// If true, the oauth2ClientId and oauth2ClientSecret fields must be
  /// non-empty.
  core.bool? enabled;

  /// OAuth2 client ID to use for the authentication flow.
  core.String? oauth2ClientId;

  /// OAuth2 client secret to use for the authentication flow.
  ///
  /// For security reasons, this value cannot be retrieved via the API. Instead,
  /// the SHA-256 hash of the value is returned in the oauth2ClientSecretSha256
  /// field. @InputOnly
  core.String? oauth2ClientSecret;

  /// SHA256 hash value for the field oauth2_client_secret above.
  ///
  /// Output only.
  core.String? oauth2ClientSecretSha256;

  BackendServiceIAP({
    this.enabled,
    this.oauth2ClientId,
    this.oauth2ClientSecret,
    this.oauth2ClientSecretSha256,
  });

  BackendServiceIAP.fromJson(core.Map json_)
      : this(
          enabled: json_.containsKey('enabled')
              ? json_['enabled'] as core.bool
              : null,
          oauth2ClientId: json_.containsKey('oauth2ClientId')
              ? json_['oauth2ClientId'] as core.String
              : null,
          oauth2ClientSecret: json_.containsKey('oauth2ClientSecret')
              ? json_['oauth2ClientSecret'] as core.String
              : null,
          oauth2ClientSecretSha256:
              json_.containsKey('oauth2ClientSecretSha256')
                  ? json_['oauth2ClientSecretSha256'] as core.String
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enabled != null) 'enabled': enabled!,
        if (oauth2ClientId != null) 'oauth2ClientId': oauth2ClientId!,
        if (oauth2ClientSecret != null)
          'oauth2ClientSecret': oauth2ClientSecret!,
        if (oauth2ClientSecretSha256 != null)
          'oauth2ClientSecretSha256': oauth2ClientSecretSha256!,
      };
}

class BackendServiceListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  BackendServiceListWarningData({
    this.key,
    this.value,
  });

  BackendServiceListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class BackendServiceListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<BackendServiceListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  BackendServiceListWarning({
    this.code,
    this.data,
    this.message,
  });

  BackendServiceListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => BackendServiceListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of BackendService resources.
class BackendServiceList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of BackendService resources.
  core.List<BackendService>? items;

  /// Type of resource.
  ///
  /// Always compute#backendServiceList for lists of backend services.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  BackendServiceListWarning? warning;

  BackendServiceList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  BackendServiceList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => BackendService.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? BackendServiceListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Container for either a built-in LB policy supported by gRPC or Envoy or a
/// custom one implemented by the end user.
class BackendServiceLocalityLoadBalancingPolicyConfig {
  BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy? customPolicy;
  BackendServiceLocalityLoadBalancingPolicyConfigPolicy? policy;

  BackendServiceLocalityLoadBalancingPolicyConfig({
    this.customPolicy,
    this.policy,
  });

  BackendServiceLocalityLoadBalancingPolicyConfig.fromJson(core.Map json_)
      : this(
          customPolicy: json_.containsKey('customPolicy')
              ? BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                  .fromJson(json_['customPolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          policy: json_.containsKey('policy')
              ? BackendServiceLocalityLoadBalancingPolicyConfigPolicy.fromJson(
                  json_['policy'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (customPolicy != null) 'customPolicy': customPolicy!,
        if (policy != null) 'policy': policy!,
      };
}

/// The configuration for a custom policy implemented by the user and deployed
/// with the client.
class BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy {
  /// An optional, arbitrary JSON object with configuration data, understood by
  /// a locally installed custom policy implementation.
  core.String? data;

  /// Identifies the custom policy.
  ///
  /// The value should match the type the custom implementation is registered
  /// with on the gRPC clients. It should follow protocol buffer message naming
  /// conventions and include the full path (e.g. myorg.CustomLbPolicy). The
  /// maximum length is 256 characters. Note that specifying the same custom
  /// policy more than once for a backend is not a valid configuration and will
  /// be rejected.
  core.String? name;

  BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy({
    this.data,
    this.name,
  });

  BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.fromJson(
      core.Map json_)
      : this(
          data: json_.containsKey('data') ? json_['data'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (data != null) 'data': data!,
        if (name != null) 'name': name!,
      };
}

/// The configuration for a built-in load balancing policy.
class BackendServiceLocalityLoadBalancingPolicyConfigPolicy {
  /// The name of a locality load balancer policy to be used.
  ///
  /// The value should be one of the predefined ones as supported by
  /// localityLbPolicy, although at the moment only ROUND_ROBIN is supported.
  /// This field should only be populated when the customPolicy field is not
  /// used. Note that specifying the same policy more than once for a backend is
  /// not a valid configuration and will be rejected.
  /// Possible string values are:
  /// - "INVALID_LB_POLICY"
  /// - "LEAST_REQUEST" : An O(1) algorithm which selects two random healthy
  /// hosts and picks the host which has fewer active requests.
  /// - "MAGLEV" : This algorithm implements consistent hashing to backends.
  /// Maglev can be used as a drop in replacement for the ring hash load
  /// balancer. Maglev is not as stable as ring hash but has faster table lookup
  /// build times and host selection times. For more information about Maglev,
  /// see https://ai.google/research/pubs/pub44824
  /// - "ORIGINAL_DESTINATION" : Backend host is selected based on the client
  /// connection metadata, i.e., connections are opened to the same address as
  /// the destination address of the incoming connection before the connection
  /// was redirected to the load balancer.
  /// - "RANDOM" : The load balancer selects a random healthy host.
  /// - "RING_HASH" : The ring/modulo hash load balancer implements consistent
  /// hashing to backends. The algorithm has the property that the
  /// addition/removal of a host from a set of N hosts only affects 1/N of the
  /// requests.
  /// - "ROUND_ROBIN" : This is a simple policy in which each healthy backend is
  /// selected in round robin order. This is the default.
  core.String? name;

  BackendServiceLocalityLoadBalancingPolicyConfigPolicy({
    this.name,
  });

  BackendServiceLocalityLoadBalancingPolicyConfigPolicy.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
      };
}

/// The available logging options for the load balancer traffic served by this
/// backend service.
class BackendServiceLogConfig {
  /// Denotes whether to enable logging for the load balancer traffic served by
  /// this backend service.
  ///
  /// The default value is false.
  core.bool? enable;

  /// This field can only be specified if logging is enabled for this backend
  /// service.
  ///
  /// The value of the field must be in \[0, 1\]. This configures the sampling
  /// rate of requests to the load balancer where 1.0 means all logged requests
  /// are reported and 0.0 means no logged requests are reported. The default
  /// value is 1.0.
  core.double? sampleRate;

  BackendServiceLogConfig({
    this.enable,
    this.sampleRate,
  });

  BackendServiceLogConfig.fromJson(core.Map json_)
      : this(
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
          sampleRate: json_.containsKey('sampleRate')
              ? (json_['sampleRate'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enable != null) 'enable': enable!,
        if (sampleRate != null) 'sampleRate': sampleRate!,
      };
}

class BackendServiceReference {
  core.String? backendService;

  BackendServiceReference({
    this.backendService,
  });

  BackendServiceReference.fromJson(core.Map json_)
      : this(
          backendService: json_.containsKey('backendService')
              ? json_['backendService'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backendService != null) 'backendService': backendService!,
      };
}

class BackendServicesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  BackendServicesScopedListWarningData({
    this.key,
    this.value,
  });

  BackendServicesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class BackendServicesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<BackendServicesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  BackendServicesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  BackendServicesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => BackendServicesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class BackendServicesScopedList {
  /// A list of BackendServices contained in this scope.
  core.List<BackendService>? backendServices;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  BackendServicesScopedListWarning? warning;

  BackendServicesScopedList({
    this.backendServices,
    this.warning,
  });

  BackendServicesScopedList.fromJson(core.Map json_)
      : this(
          backendServices: json_.containsKey('backendServices')
              ? (json_['backendServices'] as core.List)
                  .map((value) => BackendService.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? BackendServicesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backendServices != null) 'backendServices': backendServices!,
        if (warning != null) 'warning': warning!,
      };
}

class BfdPacket {
  /// The Authentication Present bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? authenticationPresent;

  /// The Control Plane Independent bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? controlPlaneIndependent;

  /// The demand bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? demand;

  /// The diagnostic code specifies the local system's reason for the last
  /// change in session state.
  ///
  /// This allows remote systems to determine the reason that the previous
  /// session failed, for example. These diagnostic codes are specified in
  /// section 4.1 of RFC5880
  /// Possible string values are:
  /// - "ADMINISTRATIVELY_DOWN"
  /// - "CONCATENATED_PATH_DOWN"
  /// - "CONTROL_DETECTION_TIME_EXPIRED"
  /// - "DIAGNOSTIC_UNSPECIFIED"
  /// - "ECHO_FUNCTION_FAILED"
  /// - "FORWARDING_PLANE_RESET"
  /// - "NEIGHBOR_SIGNALED_SESSION_DOWN"
  /// - "NO_DIAGNOSTIC"
  /// - "PATH_DOWN"
  /// - "REVERSE_CONCATENATED_PATH_DOWN"
  core.String? diagnostic;

  /// The Final bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? final_;

  /// The length of the BFD Control packet in bytes.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? length;

  /// The Required Min Echo RX Interval value in the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? minEchoRxIntervalMs;

  /// The Required Min RX Interval value in the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? minRxIntervalMs;

  /// The Desired Min TX Interval value in the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? minTxIntervalMs;

  /// The detection time multiplier of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? multiplier;

  /// The multipoint bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? multipoint;

  /// The My Discriminator value in the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? myDiscriminator;

  /// The Poll bit of the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.bool? poll;

  /// The current BFD session state as seen by the transmitting system.
  ///
  /// These states are specified in section 4.1 of RFC5880
  /// Possible string values are:
  /// - "ADMIN_DOWN"
  /// - "DOWN"
  /// - "INIT"
  /// - "STATE_UNSPECIFIED"
  /// - "UP"
  core.String? state;

  /// The version number of the BFD protocol, as specified in section 4.1 of
  /// RFC5880.
  core.int? version;

  /// The Your Discriminator value in the BFD packet.
  ///
  /// This is specified in section 4.1 of RFC5880
  core.int? yourDiscriminator;

  BfdPacket({
    this.authenticationPresent,
    this.controlPlaneIndependent,
    this.demand,
    this.diagnostic,
    this.final_,
    this.length,
    this.minEchoRxIntervalMs,
    this.minRxIntervalMs,
    this.minTxIntervalMs,
    this.multiplier,
    this.multipoint,
    this.myDiscriminator,
    this.poll,
    this.state,
    this.version,
    this.yourDiscriminator,
  });

  BfdPacket.fromJson(core.Map json_)
      : this(
          authenticationPresent: json_.containsKey('authenticationPresent')
              ? json_['authenticationPresent'] as core.bool
              : null,
          controlPlaneIndependent: json_.containsKey('controlPlaneIndependent')
              ? json_['controlPlaneIndependent'] as core.bool
              : null,
          demand:
              json_.containsKey('demand') ? json_['demand'] as core.bool : null,
          diagnostic: json_.containsKey('diagnostic')
              ? json_['diagnostic'] as core.String
              : null,
          final_:
              json_.containsKey('final') ? json_['final'] as core.bool : null,
          length:
              json_.containsKey('length') ? json_['length'] as core.int : null,
          minEchoRxIntervalMs: json_.containsKey('minEchoRxIntervalMs')
              ? json_['minEchoRxIntervalMs'] as core.int
              : null,
          minRxIntervalMs: json_.containsKey('minRxIntervalMs')
              ? json_['minRxIntervalMs'] as core.int
              : null,
          minTxIntervalMs: json_.containsKey('minTxIntervalMs')
              ? json_['minTxIntervalMs'] as core.int
              : null,
          multiplier: json_.containsKey('multiplier')
              ? json_['multiplier'] as core.int
              : null,
          multipoint: json_.containsKey('multipoint')
              ? json_['multipoint'] as core.bool
              : null,
          myDiscriminator: json_.containsKey('myDiscriminator')
              ? json_['myDiscriminator'] as core.int
              : null,
          poll: json_.containsKey('poll') ? json_['poll'] as core.bool : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          version: json_.containsKey('version')
              ? json_['version'] as core.int
              : null,
          yourDiscriminator: json_.containsKey('yourDiscriminator')
              ? json_['yourDiscriminator'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (authenticationPresent != null)
          'authenticationPresent': authenticationPresent!,
        if (controlPlaneIndependent != null)
          'controlPlaneIndependent': controlPlaneIndependent!,
        if (demand != null) 'demand': demand!,
        if (diagnostic != null) 'diagnostic': diagnostic!,
        if (final_ != null) 'final': final_!,
        if (length != null) 'length': length!,
        if (minEchoRxIntervalMs != null)
          'minEchoRxIntervalMs': minEchoRxIntervalMs!,
        if (minRxIntervalMs != null) 'minRxIntervalMs': minRxIntervalMs!,
        if (minTxIntervalMs != null) 'minTxIntervalMs': minTxIntervalMs!,
        if (multiplier != null) 'multiplier': multiplier!,
        if (multipoint != null) 'multipoint': multipoint!,
        if (myDiscriminator != null) 'myDiscriminator': myDiscriminator!,
        if (poll != null) 'poll': poll!,
        if (state != null) 'state': state!,
        if (version != null) 'version': version!,
        if (yourDiscriminator != null) 'yourDiscriminator': yourDiscriminator!,
      };
}

/// Next free: 15
class BfdStatus {
  /// The BFD session initialization mode for this BGP peer.
  ///
  /// If set to ACTIVE, the Cloud Router will initiate the BFD session for this
  /// BGP peer. If set to PASSIVE, the Cloud Router will wait for the peer
  /// router to initiate the BFD session for this BGP peer. If set to DISABLED,
  /// BFD is disabled for this BGP peer.
  /// Possible string values are:
  /// - "ACTIVE"
  /// - "DISABLED"
  /// - "PASSIVE"
  core.String? bfdSessionInitializationMode;

  /// Unix timestamp of the most recent config update.
  core.String? configUpdateTimestampMicros;

  /// Control packet counts for the current BFD session.
  BfdStatusPacketCounts? controlPacketCounts;

  /// Inter-packet time interval statistics for control packets.
  core.List<PacketIntervals>? controlPacketIntervals;

  /// The diagnostic code specifies the local system's reason for the last
  /// change in session state.
  ///
  /// This allows remote systems to determine the reason that the previous
  /// session failed, for example. These diagnostic codes are specified in
  /// section 4.1 of RFC5880
  /// Possible string values are:
  /// - "ADMINISTRATIVELY_DOWN"
  /// - "CONCATENATED_PATH_DOWN"
  /// - "CONTROL_DETECTION_TIME_EXPIRED"
  /// - "DIAGNOSTIC_UNSPECIFIED"
  /// - "ECHO_FUNCTION_FAILED"
  /// - "FORWARDING_PLANE_RESET"
  /// - "NEIGHBOR_SIGNALED_SESSION_DOWN"
  /// - "NO_DIAGNOSTIC"
  /// - "PATH_DOWN"
  /// - "REVERSE_CONCATENATED_PATH_DOWN"
  core.String? localDiagnostic;

  /// The current BFD session state as seen by the transmitting system.
  ///
  /// These states are specified in section 4.1 of RFC5880
  /// Possible string values are:
  /// - "ADMIN_DOWN"
  /// - "DOWN"
  /// - "INIT"
  /// - "STATE_UNSPECIFIED"
  /// - "UP"
  core.String? localState;

  /// Negotiated transmit interval for control packets.
  core.int? negotiatedLocalControlTxIntervalMs;

  /// The most recent Rx control packet for this BFD session.
  BfdPacket? rxPacket;

  /// The most recent Tx control packet for this BFD session.
  BfdPacket? txPacket;

  /// Session uptime in milliseconds.
  ///
  /// Value will be 0 if session is not up.
  core.String? uptimeMs;

  BfdStatus({
    this.bfdSessionInitializationMode,
    this.configUpdateTimestampMicros,
    this.controlPacketCounts,
    this.controlPacketIntervals,
    this.localDiagnostic,
    this.localState,
    this.negotiatedLocalControlTxIntervalMs,
    this.rxPacket,
    this.txPacket,
    this.uptimeMs,
  });

  BfdStatus.fromJson(core.Map json_)
      : this(
          bfdSessionInitializationMode:
              json_.containsKey('bfdSessionInitializationMode')
                  ? json_['bfdSessionInitializationMode'] as core.String
                  : null,
          configUpdateTimestampMicros:
              json_.containsKey('configUpdateTimestampMicros')
                  ? json_['configUpdateTimestampMicros'] as core.String
                  : null,
          controlPacketCounts: json_.containsKey('controlPacketCounts')
              ? BfdStatusPacketCounts.fromJson(json_['controlPacketCounts']
                  as core.Map<core.String, core.dynamic>)
              : null,
          controlPacketIntervals: json_.containsKey('controlPacketIntervals')
              ? (json_['controlPacketIntervals'] as core.List)
                  .map((value) => PacketIntervals.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          localDiagnostic: json_.containsKey('localDiagnostic')
              ? json_['localDiagnostic'] as core.String
              : null,
          localState: json_.containsKey('localState')
              ? json_['localState'] as core.String
              : null,
          negotiatedLocalControlTxIntervalMs:
              json_.containsKey('negotiatedLocalControlTxIntervalMs')
                  ? json_['negotiatedLocalControlTxIntervalMs'] as core.int
                  : null,
          rxPacket: json_.containsKey('rxPacket')
              ? BfdPacket.fromJson(
                  json_['rxPacket'] as core.Map<core.String, core.dynamic>)
              : null,
          txPacket: json_.containsKey('txPacket')
              ? BfdPacket.fromJson(
                  json_['txPacket'] as core.Map<core.String, core.dynamic>)
              : null,
          uptimeMs: json_.containsKey('uptimeMs')
              ? json_['uptimeMs'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bfdSessionInitializationMode != null)
          'bfdSessionInitializationMode': bfdSessionInitializationMode!,
        if (configUpdateTimestampMicros != null)
          'configUpdateTimestampMicros': configUpdateTimestampMicros!,
        if (controlPacketCounts != null)
          'controlPacketCounts': controlPacketCounts!,
        if (controlPacketIntervals != null)
          'controlPacketIntervals': controlPacketIntervals!,
        if (localDiagnostic != null) 'localDiagnostic': localDiagnostic!,
        if (localState != null) 'localState': localState!,
        if (negotiatedLocalControlTxIntervalMs != null)
          'negotiatedLocalControlTxIntervalMs':
              negotiatedLocalControlTxIntervalMs!,
        if (rxPacket != null) 'rxPacket': rxPacket!,
        if (txPacket != null) 'txPacket': txPacket!,
        if (uptimeMs != null) 'uptimeMs': uptimeMs!,
      };
}

class BfdStatusPacketCounts {
  /// Number of packets received since the beginning of the current BFD session.
  core.int? numRx;

  /// Number of packets received that were rejected because of errors since the
  /// beginning of the current BFD session.
  core.int? numRxRejected;

  /// Number of packets received that were successfully processed since the
  /// beginning of the current BFD session.
  core.int? numRxSuccessful;

  /// Number of packets transmitted since the beginning of the current BFD
  /// session.
  core.int? numTx;

  BfdStatusPacketCounts({
    this.numRx,
    this.numRxRejected,
    this.numRxSuccessful,
    this.numTx,
  });

  BfdStatusPacketCounts.fromJson(core.Map json_)
      : this(
          numRx: json_.containsKey('numRx') ? json_['numRx'] as core.int : null,
          numRxRejected: json_.containsKey('numRxRejected')
              ? json_['numRxRejected'] as core.int
              : null,
          numRxSuccessful: json_.containsKey('numRxSuccessful')
              ? json_['numRxSuccessful'] as core.int
              : null,
          numTx: json_.containsKey('numTx') ? json_['numTx'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (numRx != null) 'numRx': numRx!,
        if (numRxRejected != null) 'numRxRejected': numRxRejected!,
        if (numRxSuccessful != null) 'numRxSuccessful': numRxSuccessful!,
        if (numTx != null) 'numTx': numTx!,
      };
}

/// Associates `members`, or principals, with a `role`.
class Binding {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? bindingId;

  /// The condition that is associated with this binding.
  ///
  /// If the condition evaluates to `true`, then this binding applies to the
  /// current request. If the condition evaluates to `false`, then this binding
  /// does not apply to the current request. However, a different role binding
  /// might grant the same role to one or more of the principals in this
  /// binding. To learn which resources support conditions in their IAM
  /// policies, see the
  /// [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
  Expr? condition;

  /// Specifies the principals requesting access for a Google Cloud resource.
  ///
  /// `members` can have the following values: * `allUsers`: A special
  /// identifier that represents anyone who is on the internet; with or without
  /// a Google account. * `allAuthenticatedUsers`: A special identifier that
  /// represents anyone who is authenticated with a Google account or a service
  /// account. Does not include identities that come from external identity
  /// providers (IdPs) through identity federation. * `user:{emailid}`: An email
  /// address that represents a specific Google account. For example,
  /// `alice@example.com` . * `serviceAccount:{emailid}`: An email address that
  /// represents a Google service account. For example,
  /// `my-other-app@appspot.gserviceaccount.com`. *
  /// `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An
  /// identifier for a
  /// [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts).
  /// For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. *
  /// `group:{emailid}`: An email address that represents a Google group. For
  /// example, `admins@example.com`. * `deleted:user:{emailid}?uid={uniqueid}`:
  /// An email address (plus unique identifier) representing a user that has
  /// been recently deleted. For example,
  /// `alice@example.com?uid=123456789012345678901`. If the user is recovered,
  /// this value reverts to `user:{emailid}` and the recovered user retains the
  /// role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`:
  /// An email address (plus unique identifier) representing a service account
  /// that has been recently deleted. For example,
  /// `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If
  /// the service account is undeleted, this value reverts to
  /// `serviceAccount:{emailid}` and the undeleted service account retains the
  /// role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email
  /// address (plus unique identifier) representing a Google group that has been
  /// recently deleted. For example,
  /// `admins@example.com?uid=123456789012345678901`. If the group is recovered,
  /// this value reverts to `group:{emailid}` and the recovered group retains
  /// the role in the binding. * `domain:{domain}`: The G Suite domain (primary)
  /// that represents all the users of that domain. For example, `google.com` or
  /// `example.com`.
  core.List<core.String>? members;

  /// Role that is assigned to the list of `members`, or principals.
  ///
  /// For example, `roles/viewer`, `roles/editor`, or `roles/owner`.
  core.String? role;

  Binding({
    this.bindingId,
    this.condition,
    this.members,
    this.role,
  });

  Binding.fromJson(core.Map json_)
      : this(
          bindingId: json_.containsKey('bindingId')
              ? json_['bindingId'] as core.String
              : null,
          condition: json_.containsKey('condition')
              ? Expr.fromJson(
                  json_['condition'] as core.Map<core.String, core.dynamic>)
              : null,
          members: json_.containsKey('members')
              ? (json_['members'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          role: json_.containsKey('role') ? json_['role'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bindingId != null) 'bindingId': bindingId!,
        if (condition != null) 'condition': condition!,
        if (members != null) 'members': members!,
        if (role != null) 'role': role!,
      };
}

/// A transient resource used in compute.instances.bulkInsert and
/// compute.regionInstances.bulkInsert .
///
/// This resource is not persisted anywhere, it is used only for processing the
/// requests.
class BulkInsertInstanceResource {
  /// The maximum number of instances to create.
  core.String? count;

  /// The instance properties defining the VM instances to be created.
  ///
  /// Required if sourceInstanceTemplate is not provided.
  InstanceProperties? instanceProperties;

  /// Policy for chosing target zone.
  ///
  /// For more information, see Create VMs in bulk .
  LocationPolicy? locationPolicy;

  /// The minimum number of instances to create.
  ///
  /// If no min_count is specified then count is used as the default value. If
  /// min_count instances cannot be created, then no instances will be created
  /// and instances already created will be deleted.
  core.String? minCount;

  /// The string pattern used for the names of the VMs.
  ///
  /// Either name_pattern or per_instance_properties must be set. The pattern
  /// must contain one continuous sequence of placeholder hash characters (#)
  /// with each character corresponding to one digit of the generated instance
  /// name. Example: a name_pattern of inst-#### generates instance names such
  /// as inst-0001 and inst-0002. If existing instances in the same project and
  /// zone have names that match the name pattern then the generated instance
  /// numbers start after the biggest existing number. For example, if there
  /// exists an instance with name inst-0050, then instance names generated
  /// using the pattern inst-#### begin with inst-0051. The name pattern
  /// placeholder #...# can contain up to 18 characters.
  core.String? namePattern;

  /// Per-instance properties to be set on individual instances.
  ///
  /// Keys of this map specify requested instance names. Can be empty if
  /// name_pattern is used.
  core.Map<core.String, BulkInsertInstanceResourcePerInstanceProperties>?
      perInstanceProperties;

  /// Specifies the instance template from which to create instances.
  ///
  /// You may combine sourceInstanceTemplate with instanceProperties to override
  /// specific values from an existing instance template. Bulk API follows the
  /// semantics of JSON Merge Patch described by RFC 7396. It can be a full or
  /// partial URL. For example, the following are all valid URLs to an instance
  /// template: - https://www.googleapis.com/compute/v1/projects/project
  /// /global/instanceTemplates/instanceTemplate -
  /// projects/project/global/instanceTemplates/instanceTemplate -
  /// global/instanceTemplates/instanceTemplate This field is optional.
  core.String? sourceInstanceTemplate;

  BulkInsertInstanceResource({
    this.count,
    this.instanceProperties,
    this.locationPolicy,
    this.minCount,
    this.namePattern,
    this.perInstanceProperties,
    this.sourceInstanceTemplate,
  });

  BulkInsertInstanceResource.fromJson(core.Map json_)
      : this(
          count:
              json_.containsKey('count') ? json_['count'] as core.String : null,
          instanceProperties: json_.containsKey('instanceProperties')
              ? InstanceProperties.fromJson(json_['instanceProperties']
                  as core.Map<core.String, core.dynamic>)
              : null,
          locationPolicy: json_.containsKey('locationPolicy')
              ? LocationPolicy.fromJson(json_['locationPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          minCount: json_.containsKey('minCount')
              ? json_['minCount'] as core.String
              : null,
          namePattern: json_.containsKey('namePattern')
              ? json_['namePattern'] as core.String
              : null,
          perInstanceProperties: json_.containsKey('perInstanceProperties')
              ? (json_['perInstanceProperties']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    BulkInsertInstanceResourcePerInstanceProperties.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          sourceInstanceTemplate: json_.containsKey('sourceInstanceTemplate')
              ? json_['sourceInstanceTemplate'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (count != null) 'count': count!,
        if (instanceProperties != null)
          'instanceProperties': instanceProperties!,
        if (locationPolicy != null) 'locationPolicy': locationPolicy!,
        if (minCount != null) 'minCount': minCount!,
        if (namePattern != null) 'namePattern': namePattern!,
        if (perInstanceProperties != null)
          'perInstanceProperties': perInstanceProperties!,
        if (sourceInstanceTemplate != null)
          'sourceInstanceTemplate': sourceInstanceTemplate!,
      };
}

/// Per-instance properties to be set on individual instances.
///
/// To be extended in the future.
class BulkInsertInstanceResourcePerInstanceProperties {
  /// This field is only temporary.
  ///
  /// It will be removed. Do not use it.
  core.String? name;

  BulkInsertInstanceResourcePerInstanceProperties({
    this.name,
  });

  BulkInsertInstanceResourcePerInstanceProperties.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
      };
}

class CacheInvalidationRule {
  /// If set, this invalidation rule will only apply to requests with a Host
  /// header matching host.
  core.String? host;
  core.String? path;

  CacheInvalidationRule({
    this.host,
    this.path,
  });

  CacheInvalidationRule.fromJson(core.Map json_)
      : this(
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          path: json_.containsKey('path') ? json_['path'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (host != null) 'host': host!,
        if (path != null) 'path': path!,
      };
}

/// Message containing what to include in the cache key for a request for Cloud
/// CDN.
class CacheKeyPolicy {
  /// If true, requests to different hosts will be cached separately.
  core.bool? includeHost;

  /// Allows HTTP request headers (by name) to be used in the cache key.
  core.List<core.String>? includeHttpHeaders;

  /// Allows HTTP cookies (by name) to be used in the cache key.
  ///
  /// The name=value pair will be used in the cache key Cloud CDN generates.
  core.List<core.String>? includeNamedCookies;

  /// If true, http and https requests will be cached separately.
  core.bool? includeProtocol;

  /// If true, include query string parameters in the cache key according to
  /// query_string_whitelist and query_string_blacklist.
  ///
  /// If neither is set, the entire query string will be included. If false, the
  /// query string will be excluded from the cache key entirely.
  core.bool? includeQueryString;

  /// Names of query string parameters to exclude in cache keys.
  ///
  /// All other parameters will be included. Either specify
  /// query_string_whitelist or query_string_blacklist, not both. '&' and '='
  /// will be percent encoded and not treated as delimiters.
  core.List<core.String>? queryStringBlacklist;

  /// Names of query string parameters to include in cache keys.
  ///
  /// All other parameters will be excluded. Either specify
  /// query_string_whitelist or query_string_blacklist, not both. '&' and '='
  /// will be percent encoded and not treated as delimiters.
  core.List<core.String>? queryStringWhitelist;

  CacheKeyPolicy({
    this.includeHost,
    this.includeHttpHeaders,
    this.includeNamedCookies,
    this.includeProtocol,
    this.includeQueryString,
    this.queryStringBlacklist,
    this.queryStringWhitelist,
  });

  CacheKeyPolicy.fromJson(core.Map json_)
      : this(
          includeHost: json_.containsKey('includeHost')
              ? json_['includeHost'] as core.bool
              : null,
          includeHttpHeaders: json_.containsKey('includeHttpHeaders')
              ? (json_['includeHttpHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          includeNamedCookies: json_.containsKey('includeNamedCookies')
              ? (json_['includeNamedCookies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          includeProtocol: json_.containsKey('includeProtocol')
              ? json_['includeProtocol'] as core.bool
              : null,
          includeQueryString: json_.containsKey('includeQueryString')
              ? json_['includeQueryString'] as core.bool
              : null,
          queryStringBlacklist: json_.containsKey('queryStringBlacklist')
              ? (json_['queryStringBlacklist'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          queryStringWhitelist: json_.containsKey('queryStringWhitelist')
              ? (json_['queryStringWhitelist'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (includeHost != null) 'includeHost': includeHost!,
        if (includeHttpHeaders != null)
          'includeHttpHeaders': includeHttpHeaders!,
        if (includeNamedCookies != null)
          'includeNamedCookies': includeNamedCookies!,
        if (includeProtocol != null) 'includeProtocol': includeProtocol!,
        if (includeQueryString != null)
          'includeQueryString': includeQueryString!,
        if (queryStringBlacklist != null)
          'queryStringBlacklist': queryStringBlacklist!,
        if (queryStringWhitelist != null)
          'queryStringWhitelist': queryStringWhitelist!,
      };
}

/// Settings controlling the volume of requests, connections and retries to this
/// backend service.
class CircuitBreakers {
  /// The maximum number of connections to the backend service.
  ///
  /// If not specified, there is no limit. Not supported when the backend
  /// service is referenced by a URL map that is bound to target gRPC proxy that
  /// has validateForProxyless field set to true.
  core.int? maxConnections;

  /// The maximum number of pending requests allowed to the backend service.
  ///
  /// If not specified, there is no limit. Not supported when the backend
  /// service is referenced by a URL map that is bound to target gRPC proxy that
  /// has validateForProxyless field set to true.
  core.int? maxPendingRequests;

  /// The maximum number of parallel requests that allowed to the backend
  /// service.
  ///
  /// If not specified, there is no limit.
  core.int? maxRequests;

  /// Maximum requests for a single connection to the backend service.
  ///
  /// This parameter is respected by both the HTTP/1.1 and HTTP/2
  /// implementations. If not specified, there is no limit. Setting this
  /// parameter to 1 will effectively disable keep alive. Not supported when the
  /// backend service is referenced by a URL map that is bound to target gRPC
  /// proxy that has validateForProxyless field set to true.
  core.int? maxRequestsPerConnection;

  /// The maximum number of parallel retries allowed to the backend cluster.
  ///
  /// If not specified, the default is 1. Not supported when the backend service
  /// is referenced by a URL map that is bound to target gRPC proxy that has
  /// validateForProxyless field set to true.
  core.int? maxRetries;

  CircuitBreakers({
    this.maxConnections,
    this.maxPendingRequests,
    this.maxRequests,
    this.maxRequestsPerConnection,
    this.maxRetries,
  });

  CircuitBreakers.fromJson(core.Map json_)
      : this(
          maxConnections: json_.containsKey('maxConnections')
              ? json_['maxConnections'] as core.int
              : null,
          maxPendingRequests: json_.containsKey('maxPendingRequests')
              ? json_['maxPendingRequests'] as core.int
              : null,
          maxRequests: json_.containsKey('maxRequests')
              ? json_['maxRequests'] as core.int
              : null,
          maxRequestsPerConnection:
              json_.containsKey('maxRequestsPerConnection')
                  ? json_['maxRequestsPerConnection'] as core.int
                  : null,
          maxRetries: json_.containsKey('maxRetries')
              ? json_['maxRetries'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maxConnections != null) 'maxConnections': maxConnections!,
        if (maxPendingRequests != null)
          'maxPendingRequests': maxPendingRequests!,
        if (maxRequests != null) 'maxRequests': maxRequests!,
        if (maxRequestsPerConnection != null)
          'maxRequestsPerConnection': maxRequestsPerConnection!,
        if (maxRetries != null) 'maxRetries': maxRetries!,
      };
}

/// Represents a regional Commitment resource.
///
/// Creating a commitment resource means that you are purchasing a committed use
/// contract with an explicit start and end time. You can create commitments
/// based on vCPUs and memory usage and receive discounted rates. For full
/// details, read Signing Up for Committed Use Discounts.
class Commitment {
  /// Specifies whether to enable automatic renewal for the commitment.
  ///
  /// The default value is false if not specified. The field can be updated
  /// until the day of the commitment expiration at 12:00am PST. If the field is
  /// set to true, the commitment will be automatically renewed for either one
  /// or three years according to the terms of the existing commitment.
  core.bool? autoRenew;

  /// The category of the commitment.
  ///
  /// Category MACHINE specifies commitments composed of machine resources such
  /// as VCPU or MEMORY, listed in resources. Category LICENSE specifies
  /// commitments composed of software licenses, listed in licenseResources.
  /// Note that only MACHINE commitments should have a Type specified.
  /// Possible string values are:
  /// - "CATEGORY_UNSPECIFIED"
  /// - "LICENSE"
  /// - "MACHINE"
  core.String? category;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Commitment end time in RFC3339 text format.
  ///
  /// Output only.
  core.String? endTimestamp;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#commitment for commitments.
  ///
  /// Output only.
  core.String? kind;

  /// The license specification required as part of a license commitment.
  LicenseResourceCommitment? licenseResource;

  /// List of source commitments to be merged into a new commitment.
  core.List<core.String>? mergeSourceCommitments;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The plan for this commitment, which determines duration and discount rate.
  ///
  /// The currently supported plans are TWELVE_MONTH (1 year), and
  /// THIRTY_SIX_MONTH (3 years).
  /// Possible string values are:
  /// - "INVALID"
  /// - "THIRTY_SIX_MONTH"
  /// - "TWELVE_MONTH"
  core.String? plan;

  /// URL of the region where this commitment may be used.
  ///
  /// Output only.
  core.String? region;

  /// List of reservations in this commitment.
  core.List<Reservation>? reservations;

  /// A list of commitment amounts for particular resources.
  ///
  /// Note that VCPU and MEMORY resource commitments must occur together.
  core.List<ResourceCommitment>? resources;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Source commitment to be splitted into a new commitment.
  core.String? splitSourceCommitment;

  /// Commitment start time in RFC3339 text format.
  ///
  /// Output only.
  core.String? startTimestamp;

  /// Status of the commitment with regards to eventual expiration (each
  /// commitment has an end date defined).
  ///
  /// One of the following values: NOT_YET_ACTIVE, ACTIVE, EXPIRED.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE"
  /// - "CANCELLED"
  /// - "CREATING"
  /// - "EXPIRED"
  /// - "NOT_YET_ACTIVE"
  core.String? status;

  /// An optional, human-readable explanation of the status.
  ///
  /// Output only.
  core.String? statusMessage;

  /// The type of commitment, which affects the discount rate and the eligible
  /// resources.
  ///
  /// Type MEMORY_OPTIMIZED specifies a commitment that will only apply to
  /// memory optimized machines. Type ACCELERATOR_OPTIMIZED specifies a
  /// commitment that will only apply to accelerator optimized machines.
  /// Possible string values are:
  /// - "ACCELERATOR_OPTIMIZED"
  /// - "COMPUTE_OPTIMIZED"
  /// - "COMPUTE_OPTIMIZED_C2D"
  /// - "GENERAL_PURPOSE"
  /// - "GENERAL_PURPOSE_E2"
  /// - "GENERAL_PURPOSE_N2"
  /// - "GENERAL_PURPOSE_N2D"
  /// - "GENERAL_PURPOSE_T2D"
  /// - "MEMORY_OPTIMIZED"
  /// - "MEMORY_OPTIMIZED_M3"
  /// - "TYPE_UNSPECIFIED"
  core.String? type;

  Commitment({
    this.autoRenew,
    this.category,
    this.creationTimestamp,
    this.description,
    this.endTimestamp,
    this.id,
    this.kind,
    this.licenseResource,
    this.mergeSourceCommitments,
    this.name,
    this.plan,
    this.region,
    this.reservations,
    this.resources,
    this.selfLink,
    this.splitSourceCommitment,
    this.startTimestamp,
    this.status,
    this.statusMessage,
    this.type,
  });

  Commitment.fromJson(core.Map json_)
      : this(
          autoRenew: json_.containsKey('autoRenew')
              ? json_['autoRenew'] as core.bool
              : null,
          category: json_.containsKey('category')
              ? json_['category'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          endTimestamp: json_.containsKey('endTimestamp')
              ? json_['endTimestamp'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          licenseResource: json_.containsKey('licenseResource')
              ? LicenseResourceCommitment.fromJson(json_['licenseResource']
                  as core.Map<core.String, core.dynamic>)
              : null,
          mergeSourceCommitments: json_.containsKey('mergeSourceCommitments')
              ? (json_['mergeSourceCommitments'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          plan: json_.containsKey('plan') ? json_['plan'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          reservations: json_.containsKey('reservations')
              ? (json_['reservations'] as core.List)
                  .map((value) => Reservation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          resources: json_.containsKey('resources')
              ? (json_['resources'] as core.List)
                  .map((value) => ResourceCommitment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          splitSourceCommitment: json_.containsKey('splitSourceCommitment')
              ? json_['splitSourceCommitment'] as core.String
              : null,
          startTimestamp: json_.containsKey('startTimestamp')
              ? json_['startTimestamp'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          statusMessage: json_.containsKey('statusMessage')
              ? json_['statusMessage'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoRenew != null) 'autoRenew': autoRenew!,
        if (category != null) 'category': category!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (endTimestamp != null) 'endTimestamp': endTimestamp!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (licenseResource != null) 'licenseResource': licenseResource!,
        if (mergeSourceCommitments != null)
          'mergeSourceCommitments': mergeSourceCommitments!,
        if (name != null) 'name': name!,
        if (plan != null) 'plan': plan!,
        if (region != null) 'region': region!,
        if (reservations != null) 'reservations': reservations!,
        if (resources != null) 'resources': resources!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (splitSourceCommitment != null)
          'splitSourceCommitment': splitSourceCommitment!,
        if (startTimestamp != null) 'startTimestamp': startTimestamp!,
        if (status != null) 'status': status!,
        if (statusMessage != null) 'statusMessage': statusMessage!,
        if (type != null) 'type': type!,
      };
}

class CommitmentAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  CommitmentAggregatedListWarningData({
    this.key,
    this.value,
  });

  CommitmentAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class CommitmentAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<CommitmentAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  CommitmentAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  CommitmentAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => CommitmentAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class CommitmentAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of CommitmentsScopedList resources.
  core.Map<core.String, CommitmentsScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#commitmentAggregatedList for aggregated lists of
  /// commitments.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  CommitmentAggregatedListWarning? warning;

  CommitmentAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  CommitmentAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    CommitmentsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? CommitmentAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class CommitmentListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  CommitmentListWarningData({
    this.key,
    this.value,
  });

  CommitmentListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class CommitmentListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<CommitmentListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  CommitmentListWarning({
    this.code,
    this.data,
    this.message,
  });

  CommitmentListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => CommitmentListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Commitment resources.
class CommitmentList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Commitment resources.
  core.List<Commitment>? items;

  /// Type of resource.
  ///
  /// Always compute#commitmentList for lists of commitments.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  CommitmentListWarning? warning;

  CommitmentList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  CommitmentList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Commitment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? CommitmentListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class CommitmentsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  CommitmentsScopedListWarningData({
    this.key,
    this.value,
  });

  CommitmentsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of commitments when the list
/// is empty.
///
/// Output only.
class CommitmentsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<CommitmentsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  CommitmentsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  CommitmentsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => CommitmentsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class CommitmentsScopedList {
  /// A list of commitments contained in this scope.
  ///
  /// Output only.
  core.List<Commitment>? commitments;

  /// Informational warning which replaces the list of commitments when the list
  /// is empty.
  ///
  /// Output only.
  CommitmentsScopedListWarning? warning;

  CommitmentsScopedList({
    this.commitments,
    this.warning,
  });

  CommitmentsScopedList.fromJson(core.Map json_)
      : this(
          commitments: json_.containsKey('commitments')
              ? (json_['commitments'] as core.List)
                  .map((value) => Commitment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? CommitmentsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (commitments != null) 'commitments': commitments!,
        if (warning != null) 'warning': warning!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class Condition {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "APPROVER" : This is deprecated and has no effect. Do not use.
  /// - "ATTRIBUTION" : This is deprecated and has no effect. Do not use.
  /// - "AUTHORITY" : This is deprecated and has no effect. Do not use.
  /// - "CREDENTIALS_TYPE" : This is deprecated and has no effect. Do not use.
  /// - "CREDS_ASSERTION" : This is deprecated and has no effect. Do not use.
  /// - "JUSTIFICATION_TYPE" : This is deprecated and has no effect. Do not use.
  /// - "NO_ATTR" : This is deprecated and has no effect. Do not use.
  /// - "SECURITY_REALM" : This is deprecated and has no effect. Do not use.
  core.String? iam;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "DISCHARGED" : This is deprecated and has no effect. Do not use.
  /// - "EQUALS" : This is deprecated and has no effect. Do not use.
  /// - "IN" : This is deprecated and has no effect. Do not use.
  /// - "NOT_EQUALS" : This is deprecated and has no effect. Do not use.
  /// - "NOT_IN" : This is deprecated and has no effect. Do not use.
  /// - "NO_OP" : This is deprecated and has no effect. Do not use.
  core.String? op;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? svc;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "IP" : This is deprecated and has no effect. Do not use.
  /// - "NAME" : This is deprecated and has no effect. Do not use.
  /// - "NO_ATTR" : This is deprecated and has no effect. Do not use.
  /// - "REGION" : This is deprecated and has no effect. Do not use.
  /// - "SERVICE" : This is deprecated and has no effect. Do not use.
  core.String? sys;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<core.String>? values;

  Condition({
    this.iam,
    this.op,
    this.svc,
    this.sys,
    this.values,
  });

  Condition.fromJson(core.Map json_)
      : this(
          iam: json_.containsKey('iam') ? json_['iam'] as core.String : null,
          op: json_.containsKey('op') ? json_['op'] as core.String : null,
          svc: json_.containsKey('svc') ? json_['svc'] as core.String : null,
          sys: json_.containsKey('sys') ? json_['sys'] as core.String : null,
          values: json_.containsKey('values')
              ? (json_['values'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (iam != null) 'iam': iam!,
        if (op != null) 'op': op!,
        if (svc != null) 'svc': svc!,
        if (sys != null) 'sys': sys!,
        if (values != null) 'values': values!,
      };
}

/// A set of Confidential Instance options.
class ConfidentialInstanceConfig {
  /// Defines whether the instance should have confidential compute enabled.
  core.bool? enableConfidentialCompute;

  ConfidentialInstanceConfig({
    this.enableConfidentialCompute,
  });

  ConfidentialInstanceConfig.fromJson(core.Map json_)
      : this(
          enableConfidentialCompute:
              json_.containsKey('enableConfidentialCompute')
                  ? json_['enableConfidentialCompute'] as core.bool
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enableConfidentialCompute != null)
          'enableConfidentialCompute': enableConfidentialCompute!,
      };
}

/// Message containing connection draining configuration.
class ConnectionDraining {
  /// Configures a duration timeout for existing requests on a removed backend
  /// instance.
  ///
  /// For supported load balancers and protocols, as described in Enabling
  /// connection draining.
  core.int? drainingTimeoutSec;

  ConnectionDraining({
    this.drainingTimeoutSec,
  });

  ConnectionDraining.fromJson(core.Map json_)
      : this(
          drainingTimeoutSec: json_.containsKey('drainingTimeoutSec')
              ? json_['drainingTimeoutSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (drainingTimeoutSec != null)
          'drainingTimeoutSec': drainingTimeoutSec!,
      };
}

/// This message defines settings for a consistent hash style load balancer.
class ConsistentHashLoadBalancerSettings {
  /// Hash is based on HTTP Cookie.
  ///
  /// This field describes a HTTP cookie that will be used as the hash key for
  /// the consistent hash load balancer. If the cookie is not present, it will
  /// be generated. This field is applicable if the sessionAffinity is set to
  /// HTTP_COOKIE. Not supported when the backend service is referenced by a URL
  /// map that is bound to target gRPC proxy that has validateForProxyless field
  /// set to true.
  ConsistentHashLoadBalancerSettingsHttpCookie? httpCookie;

  /// The hash based on the value of the specified header field.
  ///
  /// This field is applicable if the sessionAffinity is set to HEADER_FIELD.
  core.String? httpHeaderName;

  /// The minimum number of virtual nodes to use for the hash ring.
  ///
  /// Defaults to 1024. Larger ring sizes result in more granular load
  /// distributions. If the number of hosts in the load balancing pool is larger
  /// than the ring size, each host will be assigned a single virtual node.
  core.String? minimumRingSize;

  ConsistentHashLoadBalancerSettings({
    this.httpCookie,
    this.httpHeaderName,
    this.minimumRingSize,
  });

  ConsistentHashLoadBalancerSettings.fromJson(core.Map json_)
      : this(
          httpCookie: json_.containsKey('httpCookie')
              ? ConsistentHashLoadBalancerSettingsHttpCookie.fromJson(
                  json_['httpCookie'] as core.Map<core.String, core.dynamic>)
              : null,
          httpHeaderName: json_.containsKey('httpHeaderName')
              ? json_['httpHeaderName'] as core.String
              : null,
          minimumRingSize: json_.containsKey('minimumRingSize')
              ? json_['minimumRingSize'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (httpCookie != null) 'httpCookie': httpCookie!,
        if (httpHeaderName != null) 'httpHeaderName': httpHeaderName!,
        if (minimumRingSize != null) 'minimumRingSize': minimumRingSize!,
      };
}

/// The information about the HTTP Cookie on which the hash function is based
/// for load balancing policies that use a consistent hash.
class ConsistentHashLoadBalancerSettingsHttpCookie {
  /// Name of the cookie.
  core.String? name;

  /// Path to set for the cookie.
  core.String? path;

  /// Lifetime of the cookie.
  Duration? ttl;

  ConsistentHashLoadBalancerSettingsHttpCookie({
    this.name,
    this.path,
    this.ttl,
  });

  ConsistentHashLoadBalancerSettingsHttpCookie.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          path: json_.containsKey('path') ? json_['path'] as core.String : null,
          ttl: json_.containsKey('ttl')
              ? Duration.fromJson(
                  json_['ttl'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (path != null) 'path': path!,
        if (ttl != null) 'ttl': ttl!,
      };
}

/// The specification for allowing client-side cross-origin requests.
///
/// For more information about the W3C recommendation for cross-origin resource
/// sharing (CORS), see Fetch API Living Standard.
class CorsPolicy {
  /// In response to a preflight request, setting this to true indicates that
  /// the actual request can include user credentials.
  ///
  /// This field translates to the Access-Control-Allow-Credentials header.
  /// Default is false.
  core.bool? allowCredentials;

  /// Specifies the content for the Access-Control-Allow-Headers header.
  core.List<core.String>? allowHeaders;

  /// Specifies the content for the Access-Control-Allow-Methods header.
  core.List<core.String>? allowMethods;

  /// Specifies a regular expression that matches allowed origins.
  ///
  /// For more information about the regular expression syntax, see Syntax. An
  /// origin is allowed if it matches either an item in allowOrigins or an item
  /// in allowOriginRegexes.
  core.List<core.String>? allowOriginRegexes;

  /// Specifies the list of origins that is allowed to do CORS requests.
  ///
  /// An origin is allowed if it matches either an item in allowOrigins or an
  /// item in allowOriginRegexes.
  core.List<core.String>? allowOrigins;

  /// If true, the setting specifies the CORS policy is disabled.
  ///
  /// The default value of false, which indicates that the CORS policy is in
  /// effect.
  core.bool? disabled;

  /// Specifies the content for the Access-Control-Expose-Headers header.
  core.List<core.String>? exposeHeaders;

  /// Specifies how long results of a preflight request can be cached in
  /// seconds.
  ///
  /// This field translates to the Access-Control-Max-Age header.
  core.int? maxAge;

  CorsPolicy({
    this.allowCredentials,
    this.allowHeaders,
    this.allowMethods,
    this.allowOriginRegexes,
    this.allowOrigins,
    this.disabled,
    this.exposeHeaders,
    this.maxAge,
  });

  CorsPolicy.fromJson(core.Map json_)
      : this(
          allowCredentials: json_.containsKey('allowCredentials')
              ? json_['allowCredentials'] as core.bool
              : null,
          allowHeaders: json_.containsKey('allowHeaders')
              ? (json_['allowHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          allowMethods: json_.containsKey('allowMethods')
              ? (json_['allowMethods'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          allowOriginRegexes: json_.containsKey('allowOriginRegexes')
              ? (json_['allowOriginRegexes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          allowOrigins: json_.containsKey('allowOrigins')
              ? (json_['allowOrigins'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          disabled: json_.containsKey('disabled')
              ? json_['disabled'] as core.bool
              : null,
          exposeHeaders: json_.containsKey('exposeHeaders')
              ? (json_['exposeHeaders'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          maxAge:
              json_.containsKey('maxAge') ? json_['maxAge'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (allowCredentials != null) 'allowCredentials': allowCredentials!,
        if (allowHeaders != null) 'allowHeaders': allowHeaders!,
        if (allowMethods != null) 'allowMethods': allowMethods!,
        if (allowOriginRegexes != null)
          'allowOriginRegexes': allowOriginRegexes!,
        if (allowOrigins != null) 'allowOrigins': allowOrigins!,
        if (disabled != null) 'disabled': disabled!,
        if (exposeHeaders != null) 'exposeHeaders': exposeHeaders!,
        if (maxAge != null) 'maxAge': maxAge!,
      };
}

class CustomerEncryptionKey {
  /// The name of the encryption key that is stored in Google Cloud KMS.
  ///
  /// For example: "kmsKeyName":
  /// "projects/kms_project_id/locations/region/keyRings/
  /// key_region/cryptoKeys/key
  core.String? kmsKeyName;

  /// The service account being used for the encryption request for the given
  /// KMS key.
  ///
  /// If absent, the Compute Engine default service account is used. For
  /// example: "kmsKeyServiceAccount": "name@project_id.iam.gserviceaccount.com/
  core.String? kmsKeyServiceAccount;

  /// Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648
  /// base64 to either encrypt or decrypt this resource.
  ///
  /// You can provide either the rawKey or the rsaEncryptedKey. For example:
  /// "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0="
  core.String? rawKey;

  /// Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit
  /// customer-supplied encryption key to either encrypt or decrypt this
  /// resource.
  ///
  /// You can provide either the rawKey or the rsaEncryptedKey. For example:
  /// "rsaEncryptedKey":
  /// "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH
  /// z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD
  /// D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe=="
  /// The key must meet the following requirements before you can provide it to
  /// Compute Engine: 1. The key is wrapped using a RSA public key certificate
  /// provided by Google. 2. After being wrapped, the key must be encoded in RFC
  /// 4648 base64 encoding. Gets the RSA public key certificate provided by
  /// Google at:
  /// https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem
  core.String? rsaEncryptedKey;

  /// The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied
  /// encryption key that protects this resource.
  ///
  /// Output only.
  core.String? sha256;

  CustomerEncryptionKey({
    this.kmsKeyName,
    this.kmsKeyServiceAccount,
    this.rawKey,
    this.rsaEncryptedKey,
    this.sha256,
  });

  CustomerEncryptionKey.fromJson(core.Map json_)
      : this(
          kmsKeyName: json_.containsKey('kmsKeyName')
              ? json_['kmsKeyName'] as core.String
              : null,
          kmsKeyServiceAccount: json_.containsKey('kmsKeyServiceAccount')
              ? json_['kmsKeyServiceAccount'] as core.String
              : null,
          rawKey: json_.containsKey('rawKey')
              ? json_['rawKey'] as core.String
              : null,
          rsaEncryptedKey: json_.containsKey('rsaEncryptedKey')
              ? json_['rsaEncryptedKey'] as core.String
              : null,
          sha256: json_.containsKey('sha256')
              ? json_['sha256'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (kmsKeyName != null) 'kmsKeyName': kmsKeyName!,
        if (kmsKeyServiceAccount != null)
          'kmsKeyServiceAccount': kmsKeyServiceAccount!,
        if (rawKey != null) 'rawKey': rawKey!,
        if (rsaEncryptedKey != null) 'rsaEncryptedKey': rsaEncryptedKey!,
        if (sha256 != null) 'sha256': sha256!,
      };
}

class CustomerEncryptionKeyProtectedDisk {
  /// Decrypts data associated with the disk with a customer-supplied encryption
  /// key.
  CustomerEncryptionKey? diskEncryptionKey;

  /// Specifies a valid partial or full URL to an existing Persistent Disk
  /// resource.
  ///
  /// This field is only applicable for persistent disks. For example: "source":
  /// "/compute/v1/projects/project_id/zones/zone/disks/ disk_name
  core.String? source;

  CustomerEncryptionKeyProtectedDisk({
    this.diskEncryptionKey,
    this.source,
  });

  CustomerEncryptionKeyProtectedDisk.fromJson(core.Map json_)
      : this(
          diskEncryptionKey: json_.containsKey('diskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['diskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskEncryptionKey != null) 'diskEncryptionKey': diskEncryptionKey!,
        if (source != null) 'source': source!,
      };
}

/// Deprecation status for a public resource.
class DeprecationStatus {
  /// An optional RFC3339 timestamp on or after which the state of this resource
  /// is intended to change to DELETED.
  ///
  /// This is only informational and the status will not change unless the
  /// client explicitly changes it.
  core.String? deleted;

  /// An optional RFC3339 timestamp on or after which the state of this resource
  /// is intended to change to DEPRECATED.
  ///
  /// This is only informational and the status will not change unless the
  /// client explicitly changes it.
  core.String? deprecated;

  /// An optional RFC3339 timestamp on or after which the state of this resource
  /// is intended to change to OBSOLETE.
  ///
  /// This is only informational and the status will not change unless the
  /// client explicitly changes it.
  core.String? obsolete;

  /// The URL of the suggested replacement for a deprecated resource.
  ///
  /// The suggested replacement resource must be the same kind of resource as
  /// the deprecated resource.
  core.String? replacement;

  /// The deprecation state of this resource.
  ///
  /// This can be ACTIVE, DEPRECATED, OBSOLETE, or DELETED. Operations which
  /// communicate the end of life date for an image, can use ACTIVE. Operations
  /// which create a new resource using a DEPRECATED resource will return
  /// successfully, but with a warning indicating the deprecated resource and
  /// recommending its replacement. Operations which use OBSOLETE or DELETED
  /// resources will be rejected and result in an error.
  /// Possible string values are:
  /// - "ACTIVE"
  /// - "DELETED"
  /// - "DEPRECATED"
  /// - "OBSOLETE"
  core.String? state;

  DeprecationStatus({
    this.deleted,
    this.deprecated,
    this.obsolete,
    this.replacement,
    this.state,
  });

  DeprecationStatus.fromJson(core.Map json_)
      : this(
          deleted: json_.containsKey('deleted')
              ? json_['deleted'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? json_['deprecated'] as core.String
              : null,
          obsolete: json_.containsKey('obsolete')
              ? json_['obsolete'] as core.String
              : null,
          replacement: json_.containsKey('replacement')
              ? json_['replacement'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (deleted != null) 'deleted': deleted!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (obsolete != null) 'obsolete': obsolete!,
        if (replacement != null) 'replacement': replacement!,
        if (state != null) 'state': state!,
      };
}

/// Represents a Persistent Disk resource.
///
/// Google Compute Engine has two Disk resources: *
/// \[Zonal\](/compute/docs/reference/rest/v1/disks) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionDisks) Persistent disks
/// are required for running your VM instances. Create both boot and non-boot
/// (data) persistent disks. For more information, read Persistent Disks. For
/// more storage options, read Storage options. The disks resource represents a
/// zonal persistent disk. For more information, read Zonal persistent disks.
/// The regionDisks resource represents a regional persistent disk. For more
/// information, read Regional resources.
class Disk {
  /// The architecture of the disk.
  ///
  /// Valid values are ARM64 or X86_64.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Encrypts the disk using a customer-supplied encryption key or a
  /// customer-managed encryption key.
  ///
  /// Encryption keys do not protect access to metadata of the disk. After you
  /// encrypt a disk with a customer-supplied key, you must provide the same key
  /// if you use the disk later. For example, to create a disk snapshot, to
  /// create a disk image, to create a machine image, or to attach the disk to a
  /// virtual machine. After you encrypt a disk with a customer-managed key, the
  /// diskEncryptionKey.kmsKeyName is set to a key *version* name once the disk
  /// is created. The disk is encrypted with this version of the key. In the
  /// response, diskEncryptionKey.kmsKeyName appears in the following format:
  /// "diskEncryptionKey.kmsKeyName":
  /// "projects/kms_project_id/locations/region/keyRings/
  /// key_region/cryptoKeys/key /cryptoKeysVersions/version If you do not
  /// provide an encryption key when creating the disk, then the disk is
  /// encrypted using an automatically generated key and you don't need to
  /// provide a key to use the disk later.
  CustomerEncryptionKey? diskEncryptionKey;

  /// A list of features to enable on the guest operating system.
  ///
  /// Applicable only for bootable images. Read Enabling guest operating system
  /// features to see a list of available options.
  core.List<GuestOsFeature>? guestOsFeatures;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#disk for disks.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this disk, which is
  /// essentially a hash of the labels set used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve a disk.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels to apply to this disk.
  ///
  /// These can be later modified by the setLabels method.
  core.Map<core.String, core.String>? labels;

  /// Last attach timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastAttachTimestamp;

  /// Last detach timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastDetachTimestamp;

  /// Integer license codes indicating which licenses are attached to this disk.
  core.List<core.String>? licenseCodes;

  /// A list of publicly visible licenses.
  ///
  /// Reserved for Google's use.
  core.List<core.String>? licenses;

  /// An opaque location hint used to place the disk close to other resources.
  ///
  /// This field is for use by internal tools that use the public API.
  core.String? locationHint;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Internal use only.
  core.String? options;

  /// Input only.
  ///
  /// \[Input Only\] Additional params passed with the request, but not
  /// persisted as part of resource payload.
  DiskParams? params;

  /// Physical block size of the persistent disk, in bytes.
  ///
  /// If not present in a request, a default value is used. The currently
  /// supported size is 4096, other sizes may be added in the future. If an
  /// unsupported value is requested, the error message will list the supported
  /// values for the caller's project.
  core.String? physicalBlockSizeBytes;

  /// Indicates how many IOPS to provision for the disk.
  ///
  /// This sets the number of I/O operations per second that the disk can
  /// handle. Values must be between 10,000 and 120,000. For more details, see
  /// the Extreme persistent disk documentation.
  core.String? provisionedIops;

  /// URL of the region where the disk resides.
  ///
  /// Only applicable for regional resources. You must specify this field as
  /// part of the HTTP request URL. It is not settable as a field in the request
  /// body.
  ///
  /// Output only.
  core.String? region;

  /// URLs of the zones where the disk should be replicated to.
  ///
  /// Only applicable for regional resources.
  core.List<core.String>? replicaZones;

  /// Resource policies applied to this disk for automatic snapshot creations.
  core.List<core.String>? resourcePolicies;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined fully-qualified URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Size, in GB, of the persistent disk.
  ///
  /// You can specify this field when creating a persistent disk using the
  /// sourceImage, sourceSnapshot, or sourceDisk parameter, or specify it alone
  /// to create an empty persistent disk. If you specify this field along with a
  /// source, the value of sizeGb must not be less than the size of the source.
  /// Acceptable values are 1 to 65536, inclusive.
  core.String? sizeGb;

  /// The source disk used to create this disk.
  ///
  /// You can provide this as a partial or full URL to the resource. For
  /// example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /disks/disk -
  /// https://www.googleapis.com/compute/v1/projects/project/regions/region
  /// /disks/disk - projects/project/zones/zone/disks/disk -
  /// projects/project/regions/region/disks/disk - zones/zone/disks/disk -
  /// regions/region/disks/disk
  core.String? sourceDisk;

  /// The unique ID of the disk used to create this disk.
  ///
  /// This value identifies the exact disk that was used to create this
  /// persistent disk. For example, if you created the persistent disk from a
  /// disk that was later deleted and recreated under the same name, the source
  /// disk ID would identify the exact version of the disk that was used.
  ///
  /// Output only.
  core.String? sourceDiskId;

  /// The source image used to create this disk.
  ///
  /// If the source image is deleted, this field will not be set. To create a
  /// disk with one of the public operating system images, specify the image by
  /// its family name. For example, specify family/debian-9 to use the latest
  /// Debian 9 image: projects/debian-cloud/global/images/family/debian-9
  /// Alternatively, use a specific version of a public operating system image:
  /// projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD To create a
  /// disk with a custom image that you created, specify the image name in the
  /// following format: global/images/my-custom-image You can also specify a
  /// custom image by its image family, which returns the latest version of the
  /// image in that family. Replace the image name with family/family-name:
  /// global/images/family/my-image-family
  core.String? sourceImage;

  /// The customer-supplied encryption key of the source image.
  ///
  /// Required if the source image is protected by a customer-supplied
  /// encryption key.
  CustomerEncryptionKey? sourceImageEncryptionKey;

  /// The ID value of the image used to create this disk.
  ///
  /// This value identifies the exact image that was used to create this
  /// persistent disk. For example, if you created the persistent disk from an
  /// image that was later deleted and recreated under the same name, the source
  /// image ID would identify the exact version of the image that was used.
  ///
  /// Output only.
  core.String? sourceImageId;

  /// The source snapshot used to create this disk.
  ///
  /// You can provide this as a partial or full URL to the resource. For
  /// example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project
  /// /global/snapshots/snapshot - projects/project/global/snapshots/snapshot -
  /// global/snapshots/snapshot
  core.String? sourceSnapshot;

  /// The customer-supplied encryption key of the source snapshot.
  ///
  /// Required if the source snapshot is protected by a customer-supplied
  /// encryption key.
  CustomerEncryptionKey? sourceSnapshotEncryptionKey;

  /// The unique ID of the snapshot used to create this disk.
  ///
  /// This value identifies the exact snapshot that was used to create this
  /// persistent disk. For example, if you created the persistent disk from a
  /// snapshot that was later deleted and recreated under the same name, the
  /// source snapshot ID would identify the exact version of the snapshot that
  /// was used.
  ///
  /// Output only.
  core.String? sourceSnapshotId;

  /// The full Google Cloud Storage URI where the disk image is stored.
  ///
  /// This file must be a gzip-compressed tarball whose name ends in .tar.gz or
  /// virtual machine disk whose name ends in vmdk. Valid URIs may start with
  /// gs:// or https://storage.googleapis.com/. This flag is not optimized for
  /// creating multiple disks from a source storage object. To create many disks
  /// from a source storage object, use gcloud compute images import instead.
  core.String? sourceStorageObject;

  /// The status of disk creation.
  ///
  /// - CREATING: Disk is provisioning. - RESTORING: Source data is being copied
  /// into the disk. - FAILED: Disk creation failed. - READY: Disk is ready for
  /// use. - DELETING: Disk is deleting.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING" : Disk is provisioning
  /// - "DELETING" : Disk is deleting.
  /// - "FAILED" : Disk creation failed.
  /// - "READY" : Disk is ready for use.
  /// - "RESTORING" : Source data is being copied into the disk.
  core.String? status;

  /// URL of the disk type resource describing which disk type to use to create
  /// the disk.
  ///
  /// Provide this when creating the disk. For example: projects/project
  /// /zones/zone/diskTypes/pd-ssd . See Persistent disk types.
  core.String? type;

  /// Links to the users of the disk (attached instances) in form:
  /// projects/project/zones/zone/instances/instance
  ///
  /// Output only.
  core.List<core.String>? users;

  /// URL of the zone where the disk resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? zone;

  Disk({
    this.architecture,
    this.creationTimestamp,
    this.description,
    this.diskEncryptionKey,
    this.guestOsFeatures,
    this.id,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.lastAttachTimestamp,
    this.lastDetachTimestamp,
    this.licenseCodes,
    this.licenses,
    this.locationHint,
    this.name,
    this.options,
    this.params,
    this.physicalBlockSizeBytes,
    this.provisionedIops,
    this.region,
    this.replicaZones,
    this.resourcePolicies,
    this.satisfiesPzs,
    this.selfLink,
    this.sizeGb,
    this.sourceDisk,
    this.sourceDiskId,
    this.sourceImage,
    this.sourceImageEncryptionKey,
    this.sourceImageId,
    this.sourceSnapshot,
    this.sourceSnapshotEncryptionKey,
    this.sourceSnapshotId,
    this.sourceStorageObject,
    this.status,
    this.type,
    this.users,
    this.zone,
  });

  Disk.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          diskEncryptionKey: json_.containsKey('diskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['diskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          guestOsFeatures: json_.containsKey('guestOsFeatures')
              ? (json_['guestOsFeatures'] as core.List)
                  .map((value) => GuestOsFeature.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          lastAttachTimestamp: json_.containsKey('lastAttachTimestamp')
              ? json_['lastAttachTimestamp'] as core.String
              : null,
          lastDetachTimestamp: json_.containsKey('lastDetachTimestamp')
              ? json_['lastDetachTimestamp'] as core.String
              : null,
          licenseCodes: json_.containsKey('licenseCodes')
              ? (json_['licenseCodes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          locationHint: json_.containsKey('locationHint')
              ? json_['locationHint'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          options: json_.containsKey('options')
              ? json_['options'] as core.String
              : null,
          params: json_.containsKey('params')
              ? DiskParams.fromJson(
                  json_['params'] as core.Map<core.String, core.dynamic>)
              : null,
          physicalBlockSizeBytes: json_.containsKey('physicalBlockSizeBytes')
              ? json_['physicalBlockSizeBytes'] as core.String
              : null,
          provisionedIops: json_.containsKey('provisionedIops')
              ? json_['provisionedIops'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          replicaZones: json_.containsKey('replicaZones')
              ? (json_['replicaZones'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sizeGb: json_.containsKey('sizeGb')
              ? json_['sizeGb'] as core.String
              : null,
          sourceDisk: json_.containsKey('sourceDisk')
              ? json_['sourceDisk'] as core.String
              : null,
          sourceDiskId: json_.containsKey('sourceDiskId')
              ? json_['sourceDiskId'] as core.String
              : null,
          sourceImage: json_.containsKey('sourceImage')
              ? json_['sourceImage'] as core.String
              : null,
          sourceImageEncryptionKey: json_
                  .containsKey('sourceImageEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['sourceImageEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceImageId: json_.containsKey('sourceImageId')
              ? json_['sourceImageId'] as core.String
              : null,
          sourceSnapshot: json_.containsKey('sourceSnapshot')
              ? json_['sourceSnapshot'] as core.String
              : null,
          sourceSnapshotEncryptionKey:
              json_.containsKey('sourceSnapshotEncryptionKey')
                  ? CustomerEncryptionKey.fromJson(
                      json_['sourceSnapshotEncryptionKey']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          sourceSnapshotId: json_.containsKey('sourceSnapshotId')
              ? json_['sourceSnapshotId'] as core.String
              : null,
          sourceStorageObject: json_.containsKey('sourceStorageObject')
              ? json_['sourceStorageObject'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
          users: json_.containsKey('users')
              ? (json_['users'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (diskEncryptionKey != null) 'diskEncryptionKey': diskEncryptionKey!,
        if (guestOsFeatures != null) 'guestOsFeatures': guestOsFeatures!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (lastAttachTimestamp != null)
          'lastAttachTimestamp': lastAttachTimestamp!,
        if (lastDetachTimestamp != null)
          'lastDetachTimestamp': lastDetachTimestamp!,
        if (licenseCodes != null) 'licenseCodes': licenseCodes!,
        if (licenses != null) 'licenses': licenses!,
        if (locationHint != null) 'locationHint': locationHint!,
        if (name != null) 'name': name!,
        if (options != null) 'options': options!,
        if (params != null) 'params': params!,
        if (physicalBlockSizeBytes != null)
          'physicalBlockSizeBytes': physicalBlockSizeBytes!,
        if (provisionedIops != null) 'provisionedIops': provisionedIops!,
        if (region != null) 'region': region!,
        if (replicaZones != null) 'replicaZones': replicaZones!,
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sizeGb != null) 'sizeGb': sizeGb!,
        if (sourceDisk != null) 'sourceDisk': sourceDisk!,
        if (sourceDiskId != null) 'sourceDiskId': sourceDiskId!,
        if (sourceImage != null) 'sourceImage': sourceImage!,
        if (sourceImageEncryptionKey != null)
          'sourceImageEncryptionKey': sourceImageEncryptionKey!,
        if (sourceImageId != null) 'sourceImageId': sourceImageId!,
        if (sourceSnapshot != null) 'sourceSnapshot': sourceSnapshot!,
        if (sourceSnapshotEncryptionKey != null)
          'sourceSnapshotEncryptionKey': sourceSnapshotEncryptionKey!,
        if (sourceSnapshotId != null) 'sourceSnapshotId': sourceSnapshotId!,
        if (sourceStorageObject != null)
          'sourceStorageObject': sourceStorageObject!,
        if (status != null) 'status': status!,
        if (type != null) 'type': type!,
        if (users != null) 'users': users!,
        if (zone != null) 'zone': zone!,
      };
}

class DiskAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DiskAggregatedListWarningData({
    this.key,
    this.value,
  });

  DiskAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class DiskAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DiskAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DiskAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  DiskAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DiskAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class DiskAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of DisksScopedList resources.
  core.Map<core.String, DisksScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#diskAggregatedList for aggregated lists of persistent
  /// disks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  DiskAggregatedListWarning? warning;

  DiskAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  DiskAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    DisksScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? DiskAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

/// A specification of the desired way to instantiate a disk in the instance
/// template when its created from a source instance.
class DiskInstantiationConfig {
  /// Specifies whether the disk will be auto-deleted when the instance is
  /// deleted (but not when the disk is detached from the instance).
  core.bool? autoDelete;

  /// The custom source image to be used to restore this disk when instantiating
  /// this instance template.
  core.String? customImage;

  /// Specifies the device name of the disk to which the configurations apply
  /// to.
  core.String? deviceName;

  /// Specifies whether to include the disk and what image to use.
  ///
  /// Possible values are: - source-image: to use the same image that was used
  /// to create the source instance's corresponding disk. Applicable to the boot
  /// disk and additional read-write disks. - source-image-family: to use the
  /// same image family that was used to create the source instance's
  /// corresponding disk. Applicable to the boot disk and additional read-write
  /// disks. - custom-image: to use a user-provided image url for disk creation.
  /// Applicable to the boot disk and additional read-write disks. -
  /// attach-read-only: to attach a read-only disk. Applicable to read-only
  /// disks. - do-not-include: to exclude a disk from the template. Applicable
  /// to additional read-write disks, local SSDs, and read-only disks.
  /// Possible string values are:
  /// - "ATTACH_READ_ONLY" : Attach the existing disk in read-only mode. The
  /// request will fail if the disk was attached in read-write mode on the
  /// source instance. Applicable to: read-only disks.
  /// - "BLANK" : Create a blank disk. The disk will be created unformatted.
  /// Applicable to: additional read-write disks, local SSDs.
  /// - "CUSTOM_IMAGE" : Use the custom image specified in the custom_image
  /// field. Applicable to: boot disk, additional read-write disks.
  /// - "DEFAULT" : Use the default instantiation option for the corresponding
  /// type of disk. For boot disk and any other R/W disks, new custom images
  /// will be created from each disk. For read-only disks, they will be attached
  /// in read-only mode. Local SSD disks will be created as blank volumes.
  /// - "DO_NOT_INCLUDE" : Do not include the disk in the instance template.
  /// Applicable to: additional read-write disks, local SSDs, read-only disks.
  /// - "SOURCE_IMAGE" : Use the same source image used for creation of the
  /// source instance's corresponding disk. The request will fail if the source
  /// VM's disk was created from a snapshot. Applicable to: boot disk,
  /// additional read-write disks.
  /// - "SOURCE_IMAGE_FAMILY" : Use the same source image family used for
  /// creation of the source instance's corresponding disk. The request will
  /// fail if the source image of the source disk does not belong to any image
  /// family. Applicable to: boot disk, additional read-write disks.
  core.String? instantiateFrom;

  DiskInstantiationConfig({
    this.autoDelete,
    this.customImage,
    this.deviceName,
    this.instantiateFrom,
  });

  DiskInstantiationConfig.fromJson(core.Map json_)
      : this(
          autoDelete: json_.containsKey('autoDelete')
              ? json_['autoDelete'] as core.bool
              : null,
          customImage: json_.containsKey('customImage')
              ? json_['customImage'] as core.String
              : null,
          deviceName: json_.containsKey('deviceName')
              ? json_['deviceName'] as core.String
              : null,
          instantiateFrom: json_.containsKey('instantiateFrom')
              ? json_['instantiateFrom'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoDelete != null) 'autoDelete': autoDelete!,
        if (customImage != null) 'customImage': customImage!,
        if (deviceName != null) 'deviceName': deviceName!,
        if (instantiateFrom != null) 'instantiateFrom': instantiateFrom!,
      };
}

class DiskListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DiskListWarningData({
    this.key,
    this.value,
  });

  DiskListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class DiskListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DiskListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DiskListWarning({
    this.code,
    this.data,
    this.message,
  });

  DiskListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DiskListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of Disk resources.
class DiskList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Disk resources.
  core.List<Disk>? items;

  /// Type of resource.
  ///
  /// Always compute#diskList for lists of disks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  DiskListWarning? warning;

  DiskList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  DiskList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Disk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? DiskListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class DiskMoveRequest {
  /// The URL of the destination zone to move the disk.
  ///
  /// This can be a full or partial URL. For example, the following are all
  /// valid URLs to a zone: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone -
  /// projects/project/zones/zone - zones/zone
  core.String? destinationZone;

  /// The URL of the target disk to move.
  ///
  /// This can be a full or partial URL. For example, the following are all
  /// valid URLs to a disk: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /disks/disk - projects/project/zones/zone/disks/disk -
  /// zones/zone/disks/disk
  core.String? targetDisk;

  DiskMoveRequest({
    this.destinationZone,
    this.targetDisk,
  });

  DiskMoveRequest.fromJson(core.Map json_)
      : this(
          destinationZone: json_.containsKey('destinationZone')
              ? json_['destinationZone'] as core.String
              : null,
          targetDisk: json_.containsKey('targetDisk')
              ? json_['targetDisk'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (destinationZone != null) 'destinationZone': destinationZone!,
        if (targetDisk != null) 'targetDisk': targetDisk!,
      };
}

/// Additional disk params.
class DiskParams {
  /// Resource manager tags to be bound to the disk.
  ///
  /// Tag keys and values have the same definition as resource manager tags.
  /// Keys must be in the format `tagKeys/{tag_key_id}`, and values are in the
  /// format `tagValues/456`. The field is ignored (both PUT & PATCH) when
  /// empty.
  core.Map<core.String, core.String>? resourceManagerTags;

  DiskParams({
    this.resourceManagerTags,
  });

  DiskParams.fromJson(core.Map json_)
      : this(
          resourceManagerTags: json_.containsKey('resourceManagerTags')
              ? (json_['resourceManagerTags']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourceManagerTags != null)
          'resourceManagerTags': resourceManagerTags!,
      };
}

/// Represents a Disk Type resource.
///
/// Google Compute Engine has two Disk Type resources: *
/// \[Regional\](/compute/docs/reference/rest/v1/regionDiskTypes) *
/// \[Zonal\](/compute/docs/reference/rest/v1/diskTypes) You can choose from a
/// variety of disk types based on your needs. For more information, read
/// Storage options. The diskTypes resource represents disk types for a zonal
/// persistent disk. For more information, read Zonal persistent disks. The
/// regionDiskTypes resource represents disk types for a regional persistent
/// disk. For more information, read Regional persistent disks.
class DiskType {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Server-defined default disk size in GB.
  ///
  /// Output only.
  core.String? defaultDiskSizeGb;

  /// The deprecation status associated with this disk type.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// An optional description of this resource.
  ///
  /// Output only.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#diskType for disk types.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// URL of the region where the disk type resides.
  ///
  /// Only applicable for regional resources. You must specify this field as
  /// part of the HTTP request URL. It is not settable as a field in the request
  /// body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// An optional textual description of the valid disk size, such as
  /// "10GB-10TB".
  ///
  /// Output only.
  core.String? validDiskSize;

  /// URL of the zone where the disk type resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? zone;

  DiskType({
    this.creationTimestamp,
    this.defaultDiskSizeGb,
    this.deprecated,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.region,
    this.selfLink,
    this.validDiskSize,
    this.zone,
  });

  DiskType.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          defaultDiskSizeGb: json_.containsKey('defaultDiskSizeGb')
              ? json_['defaultDiskSizeGb'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          validDiskSize: json_.containsKey('validDiskSize')
              ? json_['validDiskSize'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (defaultDiskSizeGb != null) 'defaultDiskSizeGb': defaultDiskSizeGb!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (validDiskSize != null) 'validDiskSize': validDiskSize!,
        if (zone != null) 'zone': zone!,
      };
}

class DiskTypeAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DiskTypeAggregatedListWarningData({
    this.key,
    this.value,
  });

  DiskTypeAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class DiskTypeAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DiskTypeAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DiskTypeAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  DiskTypeAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DiskTypeAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class DiskTypeAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of DiskTypesScopedList resources.
  core.Map<core.String, DiskTypesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#diskTypeAggregatedList.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  DiskTypeAggregatedListWarning? warning;

  DiskTypeAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  DiskTypeAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    DiskTypesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? DiskTypeAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class DiskTypeListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DiskTypeListWarningData({
    this.key,
    this.value,
  });

  DiskTypeListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class DiskTypeListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DiskTypeListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DiskTypeListWarning({
    this.code,
    this.data,
    this.message,
  });

  DiskTypeListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DiskTypeListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of disk types.
class DiskTypeList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of DiskType resources.
  core.List<DiskType>? items;

  /// Type of resource.
  ///
  /// Always compute#diskTypeList for disk types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  DiskTypeListWarning? warning;

  DiskTypeList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  DiskTypeList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => DiskType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? DiskTypeListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class DiskTypesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DiskTypesScopedListWarningData({
    this.key,
    this.value,
  });

  DiskTypesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of disk types when the list is
/// empty.
///
/// Output only.
class DiskTypesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DiskTypesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DiskTypesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  DiskTypesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DiskTypesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class DiskTypesScopedList {
  /// A list of disk types contained in this scope.
  ///
  /// Output only.
  core.List<DiskType>? diskTypes;

  /// Informational warning which replaces the list of disk types when the list
  /// is empty.
  ///
  /// Output only.
  DiskTypesScopedListWarning? warning;

  DiskTypesScopedList({
    this.diskTypes,
    this.warning,
  });

  DiskTypesScopedList.fromJson(core.Map json_)
      : this(
          diskTypes: json_.containsKey('diskTypes')
              ? (json_['diskTypes'] as core.List)
                  .map((value) => DiskType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? DiskTypesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskTypes != null) 'diskTypes': diskTypes!,
        if (warning != null) 'warning': warning!,
      };
}

class DisksAddResourcePoliciesRequest {
  /// Full or relative path to the resource policy to be added to this disk.
  ///
  /// You can only specify one resource policy.
  core.List<core.String>? resourcePolicies;

  DisksAddResourcePoliciesRequest({
    this.resourcePolicies,
  });

  DisksAddResourcePoliciesRequest.fromJson(core.Map json_)
      : this(
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
      };
}

typedef DisksRemoveResourcePoliciesRequest
    = $DisksRemoveResourcePoliciesRequest;

class DisksResizeRequest {
  /// The new size of the persistent disk, which is specified in GB.
  core.String? sizeGb;

  DisksResizeRequest({
    this.sizeGb,
  });

  DisksResizeRequest.fromJson(core.Map json_)
      : this(
          sizeGb: json_.containsKey('sizeGb')
              ? json_['sizeGb'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sizeGb != null) 'sizeGb': sizeGb!,
      };
}

class DisksScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  DisksScopedListWarningData({
    this.key,
    this.value,
  });

  DisksScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of disks when the list is
/// empty.
///
/// Output only.
class DisksScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<DisksScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  DisksScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  DisksScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => DisksScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class DisksScopedList {
  /// A list of disks contained in this scope.
  ///
  /// Output only.
  core.List<Disk>? disks;

  /// Informational warning which replaces the list of disks when the list is
  /// empty.
  ///
  /// Output only.
  DisksScopedListWarning? warning;

  DisksScopedList({
    this.disks,
    this.warning,
  });

  DisksScopedList.fromJson(core.Map json_)
      : this(
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => Disk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? DisksScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (disks != null) 'disks': disks!,
        if (warning != null) 'warning': warning!,
      };
}

/// A set of Display Device options
class DisplayDevice {
  /// Defines whether the instance has Display enabled.
  core.bool? enableDisplay;

  DisplayDevice({
    this.enableDisplay,
  });

  DisplayDevice.fromJson(core.Map json_)
      : this(
          enableDisplay: json_.containsKey('enableDisplay')
              ? json_['enableDisplay'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enableDisplay != null) 'enableDisplay': enableDisplay!,
      };
}

class DistributionPolicy {
  /// The distribution shape to which the group converges either proactively or
  /// on resize events (depending on the value set in
  /// updatePolicy.instanceRedistributionType).
  /// Possible string values are:
  /// - "ANY" : The group picks zones for creating VM instances to fulfill the
  /// requested number of VMs within present resource constraints and to
  /// maximize utilization of unused zonal reservations. Recommended for batch
  /// workloads that do not require high availability.
  /// - "BALANCED" : The group prioritizes acquisition of resources, scheduling
  /// VMs in zones where resources are available while distributing VMs as
  /// evenly as possible across selected zones to minimize the impact of zonal
  /// failure. Recommended for highly available serving workloads.
  /// - "EVEN" : The group schedules VM instance creation and deletion to
  /// achieve and maintain an even number of managed instances across the
  /// selected zones. The distribution is even when the number of managed
  /// instances does not differ by more than 1 between any two zones.
  /// Recommended for highly available serving workloads.
  core.String? targetShape;

  /// Zones where the regional managed instance group will create and manage its
  /// instances.
  core.List<DistributionPolicyZoneConfiguration>? zones;

  DistributionPolicy({
    this.targetShape,
    this.zones,
  });

  DistributionPolicy.fromJson(core.Map json_)
      : this(
          targetShape: json_.containsKey('targetShape')
              ? json_['targetShape'] as core.String
              : null,
          zones: json_.containsKey('zones')
              ? (json_['zones'] as core.List)
                  .map((value) => DistributionPolicyZoneConfiguration.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetShape != null) 'targetShape': targetShape!,
        if (zones != null) 'zones': zones!,
      };
}

class DistributionPolicyZoneConfiguration {
  /// The URL of the zone.
  ///
  /// The zone must exist in the region where the managed instance group is
  /// located.
  core.String? zone;

  DistributionPolicyZoneConfiguration({
    this.zone,
  });

  DistributionPolicyZoneConfiguration.fromJson(core.Map json_)
      : this(
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (zone != null) 'zone': zone!,
      };
}

/// A Duration represents a fixed-length span of time represented as a count of
/// seconds and fractions of seconds at nanosecond resolution.
///
/// It is independent of any calendar and concepts like "day" or "month". Range
/// is approximately 10,000 years.
class Duration {
  /// Span of time that's a fraction of a second at nanosecond resolution.
  ///
  /// Durations less than one second are represented with a 0 `seconds` field
  /// and a positive `nanos` field. Must be from 0 to 999,999,999 inclusive.
  core.int? nanos;

  /// Span of time at a resolution of a second.
  ///
  /// Must be from 0 to 315,576,000,000 inclusive. Note: these bounds are
  /// computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year *
  /// 10000 years
  core.String? seconds;

  Duration({
    this.nanos,
    this.seconds,
  });

  Duration.fromJson(core.Map json_)
      : this(
          nanos: json_.containsKey('nanos') ? json_['nanos'] as core.int : null,
          seconds: json_.containsKey('seconds')
              ? json_['seconds'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nanos != null) 'nanos': nanos!,
        if (seconds != null) 'seconds': seconds!,
      };
}

/// Describes the cause of the error with structured details.
///
/// Example of an error when contacting the "pubsub.googleapis.com" API when it
/// is not enabled: { "reason": "API_DISABLED" "domain": "googleapis.com"
/// "metadata": { "resource": "projects/123", "service": "pubsub.googleapis.com"
/// } } This response indicates that the pubsub.googleapis.com API is not
/// enabled. Example of an error that is returned when attempting to create a
/// Spanner instance in a region that is out of stock: { "reason": "STOCKOUT"
/// "domain": "spanner.googleapis.com", "metadata": { "availableRegions":
/// "us-central1,us-east2" } }
class ErrorInfo {
  /// The logical grouping to which the "reason" belongs.
  ///
  /// The error domain is typically the registered service name of the tool or
  /// product that generates the error. Example: "pubsub.googleapis.com". If the
  /// error is generated by some common infrastructure, the error domain must be
  /// a globally unique value that identifies the infrastructure. For Google API
  /// infrastructure, the error domain is "googleapis.com".
  core.String? domain;

  /// Additional structured details about this error.
  ///
  /// Keys should match /\[a-zA-Z0-9-_\]/ and be limited to 64 characters in
  /// length. When identifying the current value of an exceeded limit, the units
  /// should be contained in the key, not the value. For example, rather than
  /// {"instanceLimit": "100/request"}, should be returned as,
  /// {"instanceLimitPerRequest": "100"}, if the client exceeds the number of
  /// instances that can be created in a single (batch) request.
  core.Map<core.String, core.String>? metadatas;

  /// The reason of the error.
  ///
  /// This is a constant value that identifies the proximate cause of the error.
  /// Error reasons are unique within a particular domain of errors. This should
  /// be at most 63 characters and match /\[A-Z0-9_\]+/.
  core.String? reason;

  ErrorInfo({
    this.domain,
    this.metadatas,
    this.reason,
  });

  ErrorInfo.fromJson(core.Map json_)
      : this(
          domain: json_.containsKey('domain')
              ? json_['domain'] as core.String
              : null,
          metadatas: json_.containsKey('metadatas')
              ? (json_['metadatas'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          reason: json_.containsKey('reason')
              ? json_['reason'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (domain != null) 'domain': domain!,
        if (metadatas != null) 'metadatas': metadatas!,
        if (reason != null) 'reason': reason!,
      };
}

class ExchangedPeeringRoute {
  /// The destination range of the route.
  core.String? destRange;

  /// True if the peering route has been imported from a peer.
  ///
  /// The actual import happens if the field networkPeering.importCustomRoutes
  /// is true for this network, and networkPeering.exportCustomRoutes is true
  /// for the peer network, and the import does not result in a route conflict.
  core.bool? imported;

  /// The region of peering route next hop, only applies to dynamic routes.
  core.String? nextHopRegion;

  /// The priority of the peering route.
  core.int? priority;

  /// The type of the peering route.
  /// Possible string values are:
  /// - "DYNAMIC_PEERING_ROUTE" : For routes exported from local network.
  /// - "STATIC_PEERING_ROUTE" : The peering route.
  /// - "SUBNET_PEERING_ROUTE" : The peering route corresponding to subnetwork
  /// range.
  core.String? type;

  ExchangedPeeringRoute({
    this.destRange,
    this.imported,
    this.nextHopRegion,
    this.priority,
    this.type,
  });

  ExchangedPeeringRoute.fromJson(core.Map json_)
      : this(
          destRange: json_.containsKey('destRange')
              ? json_['destRange'] as core.String
              : null,
          imported: json_.containsKey('imported')
              ? json_['imported'] as core.bool
              : null,
          nextHopRegion: json_.containsKey('nextHopRegion')
              ? json_['nextHopRegion'] as core.String
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (destRange != null) 'destRange': destRange!,
        if (imported != null) 'imported': imported!,
        if (nextHopRegion != null) 'nextHopRegion': nextHopRegion!,
        if (priority != null) 'priority': priority!,
        if (type != null) 'type': type!,
      };
}

class ExchangedPeeringRoutesListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ExchangedPeeringRoutesListWarningData({
    this.key,
    this.value,
  });

  ExchangedPeeringRoutesListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ExchangedPeeringRoutesListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ExchangedPeeringRoutesListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ExchangedPeeringRoutesListWarning({
    this.code,
    this.data,
    this.message,
  });

  ExchangedPeeringRoutesListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ExchangedPeeringRoutesListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ExchangedPeeringRoutesList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ExchangedPeeringRoute resources.
  core.List<ExchangedPeeringRoute>? items;

  /// Type of resource.
  ///
  /// Always compute#exchangedPeeringRoutesList for exchanged peering routes
  /// lists.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ExchangedPeeringRoutesListWarning? warning;

  ExchangedPeeringRoutesList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ExchangedPeeringRoutesList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => ExchangedPeeringRoute.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ExchangedPeeringRoutesListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a textual expression in the Common Expression Language (CEL)
/// syntax.
///
/// CEL is a C-like expression language. The syntax and semantics of CEL are
/// documented at https://github.com/google/cel-spec. Example (Comparison):
/// title: "Summary size limit" description: "Determines if a summary is less
/// than 100 chars" expression: "document.summary.size() \< 100" Example
/// (Equality): title: "Requestor is owner" description: "Determines if
/// requestor is the document owner" expression: "document.owner ==
/// request.auth.claims.email" Example (Logic): title: "Public documents"
/// description: "Determine whether the document should be publicly visible"
/// expression: "document.type != 'private' && document.type != 'internal'"
/// Example (Data Manipulation): title: "Notification string" description:
/// "Create a notification string with a timestamp." expression: "'New message
/// received at ' + string(document.create_time)" The exact variables and
/// functions that may be referenced within an expression are determined by the
/// service that evaluates it. See the service documentation for additional
/// information.
typedef Expr = $Expr;

/// Represents an external VPN gateway.
///
/// External VPN gateway is the on-premises VPN gateway(s) or another cloud
/// provider's VPN gateway that connects to your Google Cloud VPN gateway. To
/// create a highly available VPN from Google Cloud Platform to your VPN gateway
/// or another cloud provider's VPN gateway, you must create a external VPN
/// gateway resource with information about the other gateway. For more
/// information about using external VPN gateways, see Creating an HA VPN
/// gateway and tunnel pair to a peer VPN.
class ExternalVpnGateway {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of interfaces for this external VPN gateway.
  ///
  /// If your peer-side gateway is an on-premises gateway and non-AWS cloud
  /// providers' gateway, at most two interfaces can be provided for an external
  /// VPN gateway. If your peer side is an AWS virtual private gateway, four
  /// interfaces should be provided for an external VPN gateway.
  core.List<ExternalVpnGatewayInterface>? interfaces;

  /// Type of the resource.
  ///
  /// Always compute#externalVpnGateway for externalVpnGateways.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this ExternalVpnGateway,
  /// which is essentially a hash of the labels set used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve an ExternalVpnGateway.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels for this resource.
  ///
  /// These can only be added or modified by the setLabels method. Each label
  /// key/value pair must comply with RFC1035. Label values may be empty.
  core.Map<core.String, core.String>? labels;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Indicates the user-supplied redundancy type of this external VPN gateway.
  /// Possible string values are:
  /// - "FOUR_IPS_REDUNDANCY" : The external VPN gateway has four public IP
  /// addresses; at the time of writing this API, the AWS virtual private
  /// gateway is an example which has four public IP addresses for high
  /// availability connections; there should be two VPN connections in the AWS
  /// virtual private gateway , each AWS VPN connection has two public IP
  /// addresses; please make sure to put two public IP addresses from one AWS
  /// VPN connection into interfaces 0 and 1 of this external VPN gateway, and
  /// put the other two public IP addresses from another AWS VPN connection into
  /// interfaces 2 and 3 of this external VPN gateway. When displaying highly
  /// available configuration status for the VPN tunnels connected to
  /// FOUR_IPS_REDUNDANCY external VPN gateway, Google will always detect
  /// whether interfaces 0 and 1 are connected on one interface of HA Cloud VPN
  /// gateway, and detect whether interfaces 2 and 3 are connected to another
  /// interface of the HA Cloud VPN gateway.
  /// - "SINGLE_IP_INTERNALLY_REDUNDANT" : The external VPN gateway has only one
  /// public IP address which internally provide redundancy or failover.
  /// - "TWO_IPS_REDUNDANCY" : The external VPN gateway has two public IP
  /// addresses which are redundant with each other, the following two types of
  /// setup on your on-premises side would have this type of redundancy: (1) Two
  /// separate on-premises gateways, each with one public IP address, the two
  /// on-premises gateways are redundant with each other. (2) A single
  /// on-premise gateway with two public IP addresses that are redundant with
  /// eatch other.
  core.String? redundancyType;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  ExternalVpnGateway({
    this.creationTimestamp,
    this.description,
    this.id,
    this.interfaces,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.name,
    this.redundancyType,
    this.selfLink,
  });

  ExternalVpnGateway.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          interfaces: json_.containsKey('interfaces')
              ? (json_['interfaces'] as core.List)
                  .map((value) => ExternalVpnGatewayInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          redundancyType: json_.containsKey('redundancyType')
              ? json_['redundancyType'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (interfaces != null) 'interfaces': interfaces!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (name != null) 'name': name!,
        if (redundancyType != null) 'redundancyType': redundancyType!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// The interface for the external VPN gateway.
class ExternalVpnGatewayInterface {
  /// The numeric ID of this interface.
  ///
  /// The allowed input values for this id for different redundancy types of
  /// external VPN gateway: - SINGLE_IP_INTERNALLY_REDUNDANT - 0 -
  /// TWO_IPS_REDUNDANCY - 0, 1 - FOUR_IPS_REDUNDANCY - 0, 1, 2, 3
  core.int? id;

  /// IP address of the interface in the external VPN gateway.
  ///
  /// Only IPv4 is supported. This IP address can be either from your on-premise
  /// gateway or another Cloud provider's VPN gateway, it cannot be an IP
  /// address from Google Compute Engine.
  core.String? ipAddress;

  ExternalVpnGatewayInterface({
    this.id,
    this.ipAddress,
  });

  ExternalVpnGatewayInterface.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.int : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
      };
}

class ExternalVpnGatewayListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ExternalVpnGatewayListWarningData({
    this.key,
    this.value,
  });

  ExternalVpnGatewayListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ExternalVpnGatewayListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ExternalVpnGatewayListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ExternalVpnGatewayListWarning({
    this.code,
    this.data,
    this.message,
  });

  ExternalVpnGatewayListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ExternalVpnGatewayListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Response to the list request, and contains a list of externalVpnGateways.
class ExternalVpnGatewayList {
  core.String? etag;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ExternalVpnGateway resources.
  core.List<ExternalVpnGateway>? items;

  /// Type of resource.
  ///
  /// Always compute#externalVpnGatewayList for lists of externalVpnGateways.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ExternalVpnGatewayListWarning? warning;

  ExternalVpnGatewayList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ExternalVpnGatewayList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => ExternalVpnGateway.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ExternalVpnGatewayListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class FileContentBuffer {
  /// The raw content in the secure keys file.
  core.String? content;
  core.List<core.int> get contentAsBytes => convert.base64.decode(content!);

  set contentAsBytes(core.List<core.int> bytes_) {
    content =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The file type of source file.
  /// Possible string values are:
  /// - "BIN"
  /// - "UNDEFINED"
  /// - "X509"
  core.String? fileType;

  FileContentBuffer({
    this.content,
    this.fileType,
  });

  FileContentBuffer.fromJson(core.Map json_)
      : this(
          content: json_.containsKey('content')
              ? json_['content'] as core.String
              : null,
          fileType: json_.containsKey('fileType')
              ? json_['fileType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (content != null) 'content': content!,
        if (fileType != null) 'fileType': fileType!,
      };
}

class FirewallAllowed {
  /// The IP protocol to which this rule applies.
  ///
  /// The protocol type is required when creating a firewall rule. This value
  /// can either be one of the following well known protocol strings (tcp, udp,
  /// icmp, esp, ah, ipip, sctp) or the IP protocol number.
  core.String? IPProtocol;

  /// An optional list of ports to which this rule applies.
  ///
  /// This field is only applicable for the UDP or TCP protocol. Each entry must
  /// be either an integer or a range. If not specified, this rule applies to
  /// connections through any port. Example inputs include: \["22"\],
  /// \["80","443"\], and \["12345-12349"\].
  core.List<core.String>? ports;

  FirewallAllowed({
    this.IPProtocol,
    this.ports,
  });

  FirewallAllowed.fromJson(core.Map json_)
      : this(
          IPProtocol: json_.containsKey('IPProtocol')
              ? json_['IPProtocol'] as core.String
              : null,
          ports: json_.containsKey('ports')
              ? (json_['ports'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (IPProtocol != null) 'IPProtocol': IPProtocol!,
        if (ports != null) 'ports': ports!,
      };
}

class FirewallDenied {
  /// The IP protocol to which this rule applies.
  ///
  /// The protocol type is required when creating a firewall rule. This value
  /// can either be one of the following well known protocol strings (tcp, udp,
  /// icmp, esp, ah, ipip, sctp) or the IP protocol number.
  core.String? IPProtocol;

  /// An optional list of ports to which this rule applies.
  ///
  /// This field is only applicable for the UDP or TCP protocol. Each entry must
  /// be either an integer or a range. If not specified, this rule applies to
  /// connections through any port. Example inputs include: \["22"\],
  /// \["80","443"\], and \["12345-12349"\].
  core.List<core.String>? ports;

  FirewallDenied({
    this.IPProtocol,
    this.ports,
  });

  FirewallDenied.fromJson(core.Map json_)
      : this(
          IPProtocol: json_.containsKey('IPProtocol')
              ? json_['IPProtocol'] as core.String
              : null,
          ports: json_.containsKey('ports')
              ? (json_['ports'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (IPProtocol != null) 'IPProtocol': IPProtocol!,
        if (ports != null) 'ports': ports!,
      };
}

/// Represents a Firewall Rule resource.
///
/// Firewall rules allow or deny ingress traffic to, and egress traffic from
/// your instances. For more information, read Firewall rules.
class Firewall {
  /// The list of ALLOW rules specified by this firewall.
  ///
  /// Each rule specifies a protocol and port-range tuple that describes a
  /// permitted connection.
  core.List<FirewallAllowed>? allowed;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The list of DENY rules specified by this firewall.
  ///
  /// Each rule specifies a protocol and port-range tuple that describes a
  /// denied connection.
  core.List<FirewallDenied>? denied;

  /// An optional description of this resource.
  ///
  /// Provide this field when you create the resource.
  core.String? description;

  /// If destination ranges are specified, the firewall rule applies only to
  /// traffic that has destination IP address in these ranges.
  ///
  /// These ranges must be expressed in CIDR format. Both IPv4 and IPv6 are
  /// supported.
  core.List<core.String>? destinationRanges;

  /// Direction of traffic to which this firewall applies, either `INGRESS` or
  /// `EGRESS`.
  ///
  /// The default is `INGRESS`. For `EGRESS` traffic, you cannot specify the
  /// sourceTags fields.
  /// Possible string values are:
  /// - "EGRESS" : Indicates that firewall should apply to outgoing traffic.
  /// - "INGRESS" : Indicates that firewall should apply to incoming traffic.
  core.String? direction;

  /// Denotes whether the firewall rule is disabled.
  ///
  /// When set to true, the firewall rule is not enforced and the network
  /// behaves as if it did not exist. If this is unspecified, the firewall rule
  /// will be enabled.
  core.bool? disabled;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#firewall for firewall rules.
  ///
  /// Output only.
  core.String? kind;

  /// This field denotes the logging options for a particular firewall rule.
  ///
  /// If logging is enabled, logs will be exported to Cloud Logging.
  FirewallLogConfig? logConfig;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a
  /// lowercase letter, and all following characters (except for the last
  /// character) must be a dash, lowercase letter, or digit. The last character
  /// must be a lowercase letter or digit.
  core.String? name;

  /// URL of the network resource for this firewall rule.
  ///
  /// If not specified when creating a firewall rule, the default network is
  /// used: global/networks/default If you choose to specify this field, you can
  /// specify the network as a full or partial URL. For example, the following
  /// are all valid URLs: -
  /// https://www.googleapis.com/compute/v1/projects/myproject/global/networks/my-network
  /// - projects/myproject/global/networks/my-network - global/networks/default
  core.String? network;

  /// Priority for this rule.
  ///
  /// This is an integer between `0` and `65535`, both inclusive. The default
  /// value is `1000`. Relative priorities determine which rule takes effect if
  /// multiple rules apply. Lower values indicate higher priority. For example,
  /// a rule with priority `0` has higher precedence than a rule with priority
  /// `1`. DENY rules take precedence over ALLOW rules if they have equal
  /// priority. Note that VPC networks have implied rules with a priority of
  /// `65535`. To avoid conflicts with the implied rules, use a priority number
  /// less than `65535`.
  core.int? priority;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// If source ranges are specified, the firewall rule applies only to traffic
  /// that has a source IP address in these ranges.
  ///
  /// These ranges must be expressed in CIDR format. One or both of sourceRanges
  /// and sourceTags may be set. If both fields are set, the rule applies to
  /// traffic that has a source IP address within sourceRanges OR a source IP
  /// from a resource with a matching tag listed in the sourceTags field. The
  /// connection does not need to match both fields for the rule to apply. Both
  /// IPv4 and IPv6 are supported.
  core.List<core.String>? sourceRanges;

  /// If source service accounts are specified, the firewall rules apply only to
  /// traffic originating from an instance with a service account in this list.
  ///
  /// Source service accounts cannot be used to control traffic to an instance's
  /// external IP address because service accounts are associated with an
  /// instance, not an IP address. sourceRanges can be set at the same time as
  /// sourceServiceAccounts. If both are set, the firewall applies to traffic
  /// that has a source IP address within the sourceRanges OR a source IP that
  /// belongs to an instance with service account listed in
  /// sourceServiceAccount. The connection does not need to match both fields
  /// for the firewall to apply. sourceServiceAccounts cannot be used at the
  /// same time as sourceTags or targetTags.
  core.List<core.String>? sourceServiceAccounts;

  /// If source tags are specified, the firewall rule applies only to traffic
  /// with source IPs that match the primary network interfaces of VM instances
  /// that have the tag and are in the same VPC network.
  ///
  /// Source tags cannot be used to control traffic to an instance's external IP
  /// address, it only applies to traffic between instances in the same virtual
  /// network. Because tags are associated with instances, not IP addresses. One
  /// or both of sourceRanges and sourceTags may be set. If both fields are set,
  /// the firewall applies to traffic that has a source IP address within
  /// sourceRanges OR a source IP from a resource with a matching tag listed in
  /// the sourceTags field. The connection does not need to match both fields
  /// for the firewall to apply.
  core.List<core.String>? sourceTags;

  /// A list of service accounts indicating sets of instances located in the
  /// network that may make network connections as specified in allowed\[\].
  ///
  /// targetServiceAccounts cannot be used at the same time as targetTags or
  /// sourceTags. If neither targetServiceAccounts nor targetTags are specified,
  /// the firewall rule applies to all instances on the specified network.
  core.List<core.String>? targetServiceAccounts;

  /// A list of tags that controls which instances the firewall rule applies to.
  ///
  /// If targetTags are specified, then the firewall rule applies only to
  /// instances in the VPC network that have one of those tags. If no targetTags
  /// are specified, the firewall rule applies to all instances on the specified
  /// network.
  core.List<core.String>? targetTags;

  Firewall({
    this.allowed,
    this.creationTimestamp,
    this.denied,
    this.description,
    this.destinationRanges,
    this.direction,
    this.disabled,
    this.id,
    this.kind,
    this.logConfig,
    this.name,
    this.network,
    this.priority,
    this.selfLink,
    this.sourceRanges,
    this.sourceServiceAccounts,
    this.sourceTags,
    this.targetServiceAccounts,
    this.targetTags,
  });

  Firewall.fromJson(core.Map json_)
      : this(
          allowed: json_.containsKey('allowed')
              ? (json_['allowed'] as core.List)
                  .map((value) => FirewallAllowed.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          denied: json_.containsKey('denied')
              ? (json_['denied'] as core.List)
                  .map((value) => FirewallDenied.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          destinationRanges: json_.containsKey('destinationRanges')
              ? (json_['destinationRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          direction: json_.containsKey('direction')
              ? json_['direction'] as core.String
              : null,
          disabled: json_.containsKey('disabled')
              ? json_['disabled'] as core.bool
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          logConfig: json_.containsKey('logConfig')
              ? FirewallLogConfig.fromJson(
                  json_['logConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sourceRanges: json_.containsKey('sourceRanges')
              ? (json_['sourceRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sourceServiceAccounts: json_.containsKey('sourceServiceAccounts')
              ? (json_['sourceServiceAccounts'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sourceTags: json_.containsKey('sourceTags')
              ? (json_['sourceTags'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          targetServiceAccounts: json_.containsKey('targetServiceAccounts')
              ? (json_['targetServiceAccounts'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          targetTags: json_.containsKey('targetTags')
              ? (json_['targetTags'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (allowed != null) 'allowed': allowed!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (denied != null) 'denied': denied!,
        if (description != null) 'description': description!,
        if (destinationRanges != null) 'destinationRanges': destinationRanges!,
        if (direction != null) 'direction': direction!,
        if (disabled != null) 'disabled': disabled!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (logConfig != null) 'logConfig': logConfig!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (priority != null) 'priority': priority!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sourceRanges != null) 'sourceRanges': sourceRanges!,
        if (sourceServiceAccounts != null)
          'sourceServiceAccounts': sourceServiceAccounts!,
        if (sourceTags != null) 'sourceTags': sourceTags!,
        if (targetServiceAccounts != null)
          'targetServiceAccounts': targetServiceAccounts!,
        if (targetTags != null) 'targetTags': targetTags!,
      };
}

class FirewallListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  FirewallListWarningData({
    this.key,
    this.value,
  });

  FirewallListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class FirewallListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<FirewallListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  FirewallListWarning({
    this.code,
    this.data,
    this.message,
  });

  FirewallListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => FirewallListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of firewalls.
class FirewallList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Firewall resources.
  core.List<Firewall>? items;

  /// Type of resource.
  ///
  /// Always compute#firewallList for lists of firewalls.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  FirewallListWarning? warning;

  FirewallList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  FirewallList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Firewall.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? FirewallListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// The available logging options for a firewall rule.
class FirewallLogConfig {
  /// This field denotes whether to enable logging for a particular firewall
  /// rule.
  core.bool? enable;

  /// This field can only be specified for a particular firewall rule if logging
  /// is enabled for that rule.
  ///
  /// This field denotes whether to include or exclude metadata for firewall
  /// logs.
  /// Possible string values are:
  /// - "EXCLUDE_ALL_METADATA"
  /// - "INCLUDE_ALL_METADATA"
  core.String? metadata;

  FirewallLogConfig({
    this.enable,
    this.metadata,
  });

  FirewallLogConfig.fromJson(core.Map json_)
      : this(
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
          metadata: json_.containsKey('metadata')
              ? json_['metadata'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enable != null) 'enable': enable!,
        if (metadata != null) 'metadata': metadata!,
      };
}

class FirewallPoliciesListAssociationsResponse {
  /// A list of associations.
  core.List<FirewallPolicyAssociation>? associations;

  /// Type of firewallPolicy associations.
  ///
  /// Always compute#FirewallPoliciesListAssociations for lists of
  /// firewallPolicy associations.
  ///
  /// Output only.
  core.String? kind;

  FirewallPoliciesListAssociationsResponse({
    this.associations,
    this.kind,
  });

  FirewallPoliciesListAssociationsResponse.fromJson(core.Map json_)
      : this(
          associations: json_.containsKey('associations')
              ? (json_['associations'] as core.List)
                  .map((value) => FirewallPolicyAssociation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (associations != null) 'associations': associations!,
        if (kind != null) 'kind': kind!,
      };
}

/// Represents a Firewall Policy resource.
class FirewallPolicy {
  /// A list of associations that belong to this firewall policy.
  core.List<FirewallPolicyAssociation>? associations;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Deprecated, please use short name instead.
  ///
  /// User-provided name of the Organization firewall policy. The name should be
  /// unique in the organization in which the firewall policy is created. This
  /// field is not applicable to network firewall policies. This name must be
  /// set on creation and cannot be changed. The name must be 1-63 characters
  /// long, and comply with RFC1035. Specifically, the name must be 1-63
  /// characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? displayName;

  /// Specifies a fingerprint for this resource, which is essentially a hash of
  /// the metadata's contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update metadata. You must always provide an
  /// up-to-date fingerprint hash in order to update or change metadata,
  /// otherwise the request will fail with error 412 conditionNotMet. To see the
  /// latest fingerprint, make get() request to the firewall policy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#firewallPolicyfor firewall policies
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// For Organization Firewall Policies it's a \[Output Only\] numeric ID
  /// allocated by GCP which uniquely identifies the Organization Firewall
  /// Policy.
  core.String? name;

  /// The parent of the firewall policy.
  ///
  /// This field is not applicable to network firewall policies.
  ///
  /// Output only.
  core.String? parent;

  /// URL of the region where the regional firewall policy resides.
  ///
  /// This field is not applicable to global firewall policies. You must specify
  /// this field as part of the HTTP request URL. It is not settable as a field
  /// in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Total count of all firewall policy rule tuples.
  ///
  /// A firewall policy can not exceed a set number of tuples.
  ///
  /// Output only.
  core.int? ruleTupleCount;

  /// A list of rules that belong to this policy.
  ///
  /// There must always be a default rule (rule with priority 2147483647 and
  /// match "*"). If no rules are provided when creating a firewall policy, a
  /// default rule with action "allow" will be added.
  core.List<FirewallPolicyRule>? rules;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Server-defined URL for this resource with the resource id.
  ///
  /// Output only.
  core.String? selfLinkWithId;

  /// User-provided name of the Organization firewall policy.
  ///
  /// The name should be unique in the organization in which the firewall policy
  /// is created. This field is not applicable to network firewall policies.
  /// This name must be set on creation and cannot be changed. The name must be
  /// 1-63 characters long, and comply with RFC1035. Specifically, the name must
  /// be 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? shortName;

  FirewallPolicy({
    this.associations,
    this.creationTimestamp,
    this.description,
    this.displayName,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.parent,
    this.region,
    this.ruleTupleCount,
    this.rules,
    this.selfLink,
    this.selfLinkWithId,
    this.shortName,
  });

  FirewallPolicy.fromJson(core.Map json_)
      : this(
          associations: json_.containsKey('associations')
              ? (json_['associations'] as core.List)
                  .map((value) => FirewallPolicyAssociation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          displayName: json_.containsKey('displayName')
              ? json_['displayName'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          parent: json_.containsKey('parent')
              ? json_['parent'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          ruleTupleCount: json_.containsKey('ruleTupleCount')
              ? json_['ruleTupleCount'] as core.int
              : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => FirewallPolicyRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          selfLinkWithId: json_.containsKey('selfLinkWithId')
              ? json_['selfLinkWithId'] as core.String
              : null,
          shortName: json_.containsKey('shortName')
              ? json_['shortName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (associations != null) 'associations': associations!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (displayName != null) 'displayName': displayName!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (parent != null) 'parent': parent!,
        if (region != null) 'region': region!,
        if (ruleTupleCount != null) 'ruleTupleCount': ruleTupleCount!,
        if (rules != null) 'rules': rules!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (selfLinkWithId != null) 'selfLinkWithId': selfLinkWithId!,
        if (shortName != null) 'shortName': shortName!,
      };
}

class FirewallPolicyAssociation {
  /// The target that the firewall policy is attached to.
  core.String? attachmentTarget;

  /// Deprecated, please use short name instead.
  ///
  /// The display name of the firewall policy of the association.
  ///
  /// Output only.
  core.String? displayName;

  /// The firewall policy ID of the association.
  ///
  /// Output only.
  core.String? firewallPolicyId;

  /// The name for an association.
  core.String? name;

  /// The short name of the firewall policy of the association.
  ///
  /// Output only.
  core.String? shortName;

  FirewallPolicyAssociation({
    this.attachmentTarget,
    this.displayName,
    this.firewallPolicyId,
    this.name,
    this.shortName,
  });

  FirewallPolicyAssociation.fromJson(core.Map json_)
      : this(
          attachmentTarget: json_.containsKey('attachmentTarget')
              ? json_['attachmentTarget'] as core.String
              : null,
          displayName: json_.containsKey('displayName')
              ? json_['displayName'] as core.String
              : null,
          firewallPolicyId: json_.containsKey('firewallPolicyId')
              ? json_['firewallPolicyId'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          shortName: json_.containsKey('shortName')
              ? json_['shortName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (attachmentTarget != null) 'attachmentTarget': attachmentTarget!,
        if (displayName != null) 'displayName': displayName!,
        if (firewallPolicyId != null) 'firewallPolicyId': firewallPolicyId!,
        if (name != null) 'name': name!,
        if (shortName != null) 'shortName': shortName!,
      };
}

class FirewallPolicyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  FirewallPolicyListWarningData({
    this.key,
    this.value,
  });

  FirewallPolicyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class FirewallPolicyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<FirewallPolicyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  FirewallPolicyListWarning({
    this.code,
    this.data,
    this.message,
  });

  FirewallPolicyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => FirewallPolicyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class FirewallPolicyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of FirewallPolicy resources.
  core.List<FirewallPolicy>? items;

  /// Type of resource.
  ///
  /// Always compute#firewallPolicyList for listsof FirewallPolicies
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Informational warning message.
  ///
  /// Output only.
  FirewallPolicyListWarning? warning;

  FirewallPolicyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.warning,
  });

  FirewallPolicyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => FirewallPolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? FirewallPolicyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a rule that describes one or more match conditions along with the
/// action to be taken when traffic matches this condition (allow or deny).
class FirewallPolicyRule {
  /// The Action to perform when the client connection triggers the rule.
  ///
  /// Can currently be either "allow" or "deny()" where valid values for status
  /// are 403, 404, and 502.
  core.String? action;

  /// An optional description for this resource.
  core.String? description;

  /// The direction in which this rule applies.
  /// Possible string values are:
  /// - "EGRESS"
  /// - "INGRESS"
  core.String? direction;

  /// Denotes whether the firewall policy rule is disabled.
  ///
  /// When set to true, the firewall policy rule is not enforced and traffic
  /// behaves as if it did not exist. If this is unspecified, the firewall
  /// policy rule will be enabled.
  core.bool? disabled;

  /// Denotes whether to enable logging for a particular rule.
  ///
  /// If logging is enabled, logs will be exported to the configured export
  /// destination in Stackdriver. Logs may be exported to BigQuery or Pub/Sub.
  /// Note: you cannot enable logging on "goto_next" rules.
  core.bool? enableLogging;

  /// Type of the resource.
  ///
  /// Always compute#firewallPolicyRule for firewall policy rules
  ///
  /// Output only.
  core.String? kind;

  /// A match condition that incoming traffic is evaluated against.
  ///
  /// If it evaluates to true, the corresponding 'action' is enforced.
  FirewallPolicyRuleMatcher? match;

  /// An integer indicating the priority of a rule in the list.
  ///
  /// The priority must be a positive value between 0 and 2147483647. Rules are
  /// evaluated from highest to lowest priority where 0 is the highest priority
  /// and 2147483647 is the lowest prority.
  core.int? priority;

  /// An optional name for the rule.
  ///
  /// This field is not a unique identifier and can be updated.
  core.String? ruleName;

  /// Calculation of the complexity of a single firewall policy rule.
  ///
  /// Output only.
  core.int? ruleTupleCount;

  /// A list of network resource URLs to which this rule applies.
  ///
  /// This field allows you to control which network's VMs get this rule. If
  /// this field is left blank, all VMs within the organization will receive the
  /// rule.
  core.List<core.String>? targetResources;

  /// A list of secure tags that controls which instances the firewall rule
  /// applies to.
  ///
  /// If targetSecureTag are specified, then the firewall rule applies only to
  /// instances in the VPC network that have one of those EFFECTIVE secure tags,
  /// if all the target_secure_tag are in INEFFECTIVE state, then this rule will
  /// be ignored. targetSecureTag may not be set at the same time as
  /// targetServiceAccounts. If neither targetServiceAccounts nor
  /// targetSecureTag are specified, the firewall rule applies to all instances
  /// on the specified network. Maximum number of target label tags allowed is
  /// 256.
  core.List<FirewallPolicyRuleSecureTag>? targetSecureTags;

  /// A list of service accounts indicating the sets of instances that are
  /// applied with this rule.
  core.List<core.String>? targetServiceAccounts;

  FirewallPolicyRule({
    this.action,
    this.description,
    this.direction,
    this.disabled,
    this.enableLogging,
    this.kind,
    this.match,
    this.priority,
    this.ruleName,
    this.ruleTupleCount,
    this.targetResources,
    this.targetSecureTags,
    this.targetServiceAccounts,
  });

  FirewallPolicyRule.fromJson(core.Map json_)
      : this(
          action: json_.containsKey('action')
              ? json_['action'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          direction: json_.containsKey('direction')
              ? json_['direction'] as core.String
              : null,
          disabled: json_.containsKey('disabled')
              ? json_['disabled'] as core.bool
              : null,
          enableLogging: json_.containsKey('enableLogging')
              ? json_['enableLogging'] as core.bool
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          match: json_.containsKey('match')
              ? FirewallPolicyRuleMatcher.fromJson(
                  json_['match'] as core.Map<core.String, core.dynamic>)
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          ruleName: json_.containsKey('ruleName')
              ? json_['ruleName'] as core.String
              : null,
          ruleTupleCount: json_.containsKey('ruleTupleCount')
              ? json_['ruleTupleCount'] as core.int
              : null,
          targetResources: json_.containsKey('targetResources')
              ? (json_['targetResources'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          targetSecureTags: json_.containsKey('targetSecureTags')
              ? (json_['targetSecureTags'] as core.List)
                  .map((value) => FirewallPolicyRuleSecureTag.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          targetServiceAccounts: json_.containsKey('targetServiceAccounts')
              ? (json_['targetServiceAccounts'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (action != null) 'action': action!,
        if (description != null) 'description': description!,
        if (direction != null) 'direction': direction!,
        if (disabled != null) 'disabled': disabled!,
        if (enableLogging != null) 'enableLogging': enableLogging!,
        if (kind != null) 'kind': kind!,
        if (match != null) 'match': match!,
        if (priority != null) 'priority': priority!,
        if (ruleName != null) 'ruleName': ruleName!,
        if (ruleTupleCount != null) 'ruleTupleCount': ruleTupleCount!,
        if (targetResources != null) 'targetResources': targetResources!,
        if (targetSecureTags != null) 'targetSecureTags': targetSecureTags!,
        if (targetServiceAccounts != null)
          'targetServiceAccounts': targetServiceAccounts!,
      };
}

/// Represents a match condition that incoming traffic is evaluated against.
///
/// Exactly one field must be specified.
class FirewallPolicyRuleMatcher {
  /// CIDR IP address range.
  ///
  /// Maximum number of destination CIDR IP ranges allowed is 5000.
  core.List<core.String>? destIpRanges;

  /// Pairs of IP protocols and ports that the rule should match.
  core.List<FirewallPolicyRuleMatcherLayer4Config>? layer4Configs;

  /// CIDR IP address range.
  ///
  /// Maximum number of source CIDR IP ranges allowed is 5000.
  core.List<core.String>? srcIpRanges;

  /// List of secure tag values, which should be matched at the source of the
  /// traffic.
  ///
  /// For INGRESS rule, if all the srcSecureTag are INEFFECTIVE, and there is no
  /// srcIpRange, this rule will be ignored. Maximum number of source tag values
  /// allowed is 256.
  core.List<FirewallPolicyRuleSecureTag>? srcSecureTags;

  FirewallPolicyRuleMatcher({
    this.destIpRanges,
    this.layer4Configs,
    this.srcIpRanges,
    this.srcSecureTags,
  });

  FirewallPolicyRuleMatcher.fromJson(core.Map json_)
      : this(
          destIpRanges: json_.containsKey('destIpRanges')
              ? (json_['destIpRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          layer4Configs: json_.containsKey('layer4Configs')
              ? (json_['layer4Configs'] as core.List)
                  .map((value) =>
                      FirewallPolicyRuleMatcherLayer4Config.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          srcIpRanges: json_.containsKey('srcIpRanges')
              ? (json_['srcIpRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          srcSecureTags: json_.containsKey('srcSecureTags')
              ? (json_['srcSecureTags'] as core.List)
                  .map((value) => FirewallPolicyRuleSecureTag.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (destIpRanges != null) 'destIpRanges': destIpRanges!,
        if (layer4Configs != null) 'layer4Configs': layer4Configs!,
        if (srcIpRanges != null) 'srcIpRanges': srcIpRanges!,
        if (srcSecureTags != null) 'srcSecureTags': srcSecureTags!,
      };
}

class FirewallPolicyRuleMatcherLayer4Config {
  /// The IP protocol to which this rule applies.
  ///
  /// The protocol type is required when creating a firewall rule. This value
  /// can either be one of the following well known protocol strings (tcp, udp,
  /// icmp, esp, ah, ipip, sctp), or the IP protocol number.
  core.String? ipProtocol;

  /// An optional list of ports to which this rule applies.
  ///
  /// This field is only applicable for UDP or TCP protocol. Each entry must be
  /// either an integer or a range. If not specified, this rule applies to
  /// connections through any port. Example inputs include: \["22"\],
  /// \["80","443"\], and \["12345-12349"\].
  core.List<core.String>? ports;

  FirewallPolicyRuleMatcherLayer4Config({
    this.ipProtocol,
    this.ports,
  });

  FirewallPolicyRuleMatcherLayer4Config.fromJson(core.Map json_)
      : this(
          ipProtocol: json_.containsKey('ipProtocol')
              ? json_['ipProtocol'] as core.String
              : null,
          ports: json_.containsKey('ports')
              ? (json_['ports'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipProtocol != null) 'ipProtocol': ipProtocol!,
        if (ports != null) 'ports': ports!,
      };
}

class FirewallPolicyRuleSecureTag {
  /// Name of the secure tag, created with TagManager's TagValue API.
  core.String? name;

  /// State of the secure tag, either `EFFECTIVE` or `INEFFECTIVE`.
  ///
  /// A secure tag is `INEFFECTIVE` when it is deleted or its network is
  /// deleted.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "EFFECTIVE"
  /// - "INEFFECTIVE"
  core.String? state;

  FirewallPolicyRuleSecureTag({
    this.name,
    this.state,
  });

  FirewallPolicyRuleSecureTag.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (state != null) 'state': state!,
      };
}

/// Encapsulates numeric value that can be either absolute or relative.
class FixedOrPercent {
  /// Absolute value of VM instances calculated based on the specific mode.
  ///
  /// - If the value is fixed, then the calculated value is equal to the fixed
  /// value. - If the value is a percent, then the calculated value is
  /// percent/100 * targetSize. For example, the calculated value of a 80% of a
  /// managed instance group with 150 instances would be (80/100 * 150) = 120 VM
  /// instances. If there is a remainder, the number is rounded.
  ///
  /// Output only.
  core.int? calculated;

  /// Specifies a fixed number of VM instances.
  ///
  /// This must be a positive integer.
  core.int? fixed;

  /// Specifies a percentage of instances between 0 to 100%, inclusive.
  ///
  /// For example, specify 80 for 80%.
  core.int? percent;

  FixedOrPercent({
    this.calculated,
    this.fixed,
    this.percent,
  });

  FixedOrPercent.fromJson(core.Map json_)
      : this(
          calculated: json_.containsKey('calculated')
              ? json_['calculated'] as core.int
              : null,
          fixed: json_.containsKey('fixed') ? json_['fixed'] as core.int : null,
          percent: json_.containsKey('percent')
              ? json_['percent'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (calculated != null) 'calculated': calculated!,
        if (fixed != null) 'fixed': fixed!,
        if (percent != null) 'percent': percent!,
      };
}

/// Represents a Forwarding Rule resource.
///
/// Forwarding rule resources in Google Cloud can be either regional or global
/// in scope: *
/// [Global](https://cloud.google.com/compute/docs/reference/rest/v1/globalForwardingRules)
/// *
/// [Regional](https://cloud.google.com/compute/docs/reference/rest/v1/forwardingRules)
/// A forwarding rule and its corresponding IP address represent the frontend
/// configuration of a Google Cloud Platform load balancer. Forwarding rules can
/// also reference target instances and Cloud VPN Classic gateways
/// (targetVpnGateway). For more information, read Forwarding rule concepts and
/// Using protocol forwarding.
class ForwardingRule {
  /// IP address for which this forwarding rule accepts traffic.
  ///
  /// When a client sends traffic to this IP address, the forwarding rule
  /// directs the traffic to the referenced target or backendService. While
  /// creating a forwarding rule, specifying an IPAddress is required under the
  /// following circumstances: - When the target is set to targetGrpcProxy and
  /// validateForProxyless is set to true, the IPAddress should be set to
  /// 0.0.0.0. - When the target is a Private Service Connect Google APIs
  /// bundle, you must specify an IPAddress. Otherwise, you can optionally
  /// specify an IP address that references an existing static (reserved) IP
  /// address resource. When omitted, Google Cloud assigns an ephemeral IP
  /// address. Use one of the following formats to specify an IP address while
  /// creating a forwarding rule: * IP address number, as in `100.1.2.3` * Full
  /// resource URL, as in
  /// https://www.googleapis.com/compute/v1/projects/project_id/regions/region
  /// /addresses/address-name * Partial URL or by name, as in: -
  /// projects/project_id/regions/region/addresses/address-name -
  /// regions/region/addresses/address-name - global/addresses/address-name -
  /// address-name The forwarding rule's target or backendService, and in most
  /// cases, also the loadBalancingScheme, determine the type of IP address that
  /// you can use. For detailed information, see
  /// [IP address specifications](https://cloud.google.com/load-balancing/docs/forwarding-rule-concepts#ip_address_specifications).
  /// When reading an IPAddress, the API always returns the IP address number.
  core.String? IPAddress;

  /// The IP protocol to which this rule applies.
  ///
  /// For protocol forwarding, valid options are TCP, UDP, ESP, AH, SCTP, ICMP
  /// and L3_DEFAULT. The valid IP protocols are different for different load
  /// balancing products as described in
  /// [Load balancing features](https://cloud.google.com/load-balancing/docs/features#protocols_from_the_load_balancer_to_the_backends).
  /// Possible string values are:
  /// - "AH"
  /// - "ESP"
  /// - "ICMP"
  /// - "L3_DEFAULT"
  /// - "SCTP"
  /// - "TCP"
  /// - "UDP"
  core.String? IPProtocol;

  /// This field is used along with the backend_service field for Internal
  /// TCP/UDP Load Balancing or Network Load Balancing, or with the target field
  /// for internal and external TargetInstance.
  ///
  /// You can only use one of ports and port_range, or allPorts. The three are
  /// mutually exclusive. For TCP, UDP and SCTP traffic, packets addressed to
  /// any ports will be forwarded to the target or backendService.
  core.bool? allPorts;

  /// This field is used along with the backend_service field for internal load
  /// balancing or with the target field for internal TargetInstance.
  ///
  /// If the field is set to TRUE, clients can access ILB from all regions.
  /// Otherwise only allows access from clients in the same region as the
  /// internal load balancer.
  core.bool? allowGlobalAccess;

  /// Identifies the backend service to which the forwarding rule sends traffic.
  ///
  /// Required for Internal TCP/UDP Load Balancing and Network Load Balancing;
  /// must be omitted for all other load balancer types.
  core.String? backendService;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// ForwardingRule. Include the fingerprint in patch request to ensure that
  /// you do not overwrite changes that were applied from another concurrent
  /// request. To see the latest fingerprint, make a get() request to retrieve a
  /// ForwardingRule.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The IP Version that will be used by this forwarding rule.
  ///
  /// Valid options are IPV4 or IPV6.
  /// Possible string values are:
  /// - "IPV4"
  /// - "IPV6"
  /// - "UNSPECIFIED_VERSION"
  core.String? ipVersion;

  /// Indicates whether or not this load balancer can be used as a collector for
  /// packet mirroring.
  ///
  /// To prevent mirroring loops, instances behind this load balancer will not
  /// have their traffic mirrored even if a PacketMirroring rule applies to
  /// them. This can only be set to true for load balancers that have their
  /// loadBalancingScheme set to INTERNAL.
  core.bool? isMirroringCollector;

  /// Type of the resource.
  ///
  /// Always compute#forwardingRule for Forwarding Rule resources.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this resource, which is
  /// essentially a hash of the labels set used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve a ForwardingRule.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels for this resource.
  ///
  /// These can only be added or modified by the setLabels method. Each label
  /// key/value pair must comply with RFC1035. Label values may be empty.
  core.Map<core.String, core.String>? labels;

  /// Specifies the forwarding rule type.
  ///
  /// For more information about forwarding rules, refer to Forwarding rule
  /// concepts.
  /// Possible string values are:
  /// - "EXTERNAL"
  /// - "EXTERNAL_MANAGED"
  /// - "INTERNAL"
  /// - "INTERNAL_MANAGED"
  /// - "INTERNAL_SELF_MANAGED"
  /// - "INVALID"
  core.String? loadBalancingScheme;

  /// Opaque filter criteria used by load balancer to restrict routing
  /// configuration to a limited set of xDS compliant clients.
  ///
  /// In their xDS requests to load balancer, xDS clients present node metadata.
  /// When there is a match, the relevant configuration is made available to
  /// those proxies. Otherwise, all the resources (e.g. TargetHttpProxy, UrlMap)
  /// referenced by the ForwardingRule are not visible to those proxies. For
  /// each metadataFilter in this list, if its filterMatchCriteria is set to
  /// MATCH_ANY, at least one of the filterLabels must match the corresponding
  /// label provided in the metadata. If its filterMatchCriteria is set to
  /// MATCH_ALL, then all of its filterLabels must match with corresponding
  /// labels provided in the metadata. If multiple metadataFilters are
  /// specified, all of them need to be satisfied in order to be considered a
  /// match. metadataFilters specified here will be applifed before those
  /// specified in the UrlMap that this ForwardingRule references.
  /// metadataFilters only applies to Loadbalancers that have their
  /// loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  core.List<MetadataFilter>? metadataFilters;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash. For Private Service Connect forwarding rules that forward traffic to
  /// Google APIs, the forwarding rule name must be a 1-20 characters string
  /// with lowercase letters and numbers and must start with a letter.
  core.String? name;

  /// This field is not used for external load balancing.
  ///
  /// For Internal TCP/UDP Load Balancing, this field identifies the network
  /// that the load balanced IP should belong to for this Forwarding Rule. If
  /// this field is not specified, the default network will be used. For Private
  /// Service Connect forwarding rules that forward traffic to Google APIs, a
  /// network must be provided.
  core.String? network;

  /// This signifies the networking tier used for configuring this load balancer
  /// and can only take the following values: PREMIUM, STANDARD.
  ///
  /// For regional ForwardingRule, the valid values are PREMIUM and STANDARD.
  /// For GlobalForwardingRule, the valid value is PREMIUM. If this field is not
  /// specified, it is assumed to be PREMIUM. If IPAddress is specified, this
  /// value must be equal to the networkTier of the Address.
  /// Possible string values are:
  /// - "FIXED_STANDARD" : Public internet quality with fixed bandwidth.
  /// - "PREMIUM" : High quality, Google-grade network tier, support for all
  /// networking products.
  /// - "STANDARD" : Public internet quality, only limited support for other
  /// networking products.
  /// - "STANDARD_OVERRIDES_FIXED_STANDARD" : (Output only) Temporary tier for
  /// FIXED_STANDARD when fixed standard tier is expired or not configured.
  core.String? networkTier;

  /// This is used in PSC consumer ForwardingRule to control whether it should
  /// try to auto-generate a DNS zone or not.
  ///
  /// Non-PSC forwarding rules do not use this field.
  core.bool? noAutomateDnsZone;

  /// This field can be used only if: - Load balancing scheme is one of
  /// EXTERNAL, INTERNAL_SELF_MANAGED or INTERNAL_MANAGED - IPProtocol is one of
  /// TCP, UDP, or SCTP.
  ///
  /// Packets addressed to ports in the specified range will be forwarded to
  /// target or backend_service. You can only use one of ports, port_range, or
  /// allPorts. The three are mutually exclusive. Forwarding rules with the same
  /// \[IPAddress, IPProtocol\] pair must have disjoint ports. Some types of
  /// forwarding target have constraints on the acceptable ports. For more
  /// information, see
  /// [Port specifications](https://cloud.google.com/load-balancing/docs/forwarding-rule-concepts#port_specifications).
  /// @pattern: \\d+(?:-\\d+)?
  core.String? portRange;

  /// The ports field is only supported when the forwarding rule references a
  /// backend_service directly.
  ///
  /// Only packets addressed to the \[specified list of
  /// ports\]((https://cloud.google.com/load-balancing/docs/forwarding-rule-concepts#port_specifications))
  /// are forwarded to backends. You can only use one of ports and port_range,
  /// or allPorts. The three are mutually exclusive. You can specify a list of
  /// up to five ports, which can be non-contiguous. Forwarding rules with the
  /// same \[IPAddress, IPProtocol\] pair must have disjoint ports. @pattern:
  /// \\d+(?:-\\d+)?
  core.List<core.String>? ports;

  /// The PSC connection id of the PSC Forwarding Rule.
  ///
  /// Output only.
  core.String? pscConnectionId;

  ///
  /// Possible string values are:
  /// - "ACCEPTED" : The connection has been accepted by the producer.
  /// - "CLOSED" : The connection has been closed by the producer and will not
  /// serve traffic going forward.
  /// - "NEEDS_ATTENTION" : The connection has been accepted by the producer,
  /// but the producer needs to take further action before the forwarding rule
  /// can serve traffic.
  /// - "PENDING" : The connection is pending acceptance by the producer.
  /// - "REJECTED" : The connection has been rejected by the producer.
  /// - "STATUS_UNSPECIFIED"
  core.String? pscConnectionStatus;

  /// URL of the region where the regional forwarding rule resides.
  ///
  /// This field is not applicable to global forwarding rules. You must specify
  /// this field as part of the HTTP request URL. It is not settable as a field
  /// in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Service Directory resources to register this forwarding rule with.
  ///
  /// Currently, only supports a single Service Directory resource.
  core.List<ForwardingRuleServiceDirectoryRegistration>?
      serviceDirectoryRegistrations;

  /// An optional prefix to the service name for this Forwarding Rule.
  ///
  /// If specified, the prefix is the first label of the fully qualified service
  /// name. The label must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the label must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash. This field is only used for internal load balancing.
  core.String? serviceLabel;

  /// The internal fully qualified service name for this Forwarding Rule.
  ///
  /// This field is only used for internal load balancing.
  ///
  /// Output only.
  core.String? serviceName;

  /// This field identifies the subnetwork that the load balanced IP should
  /// belong to for this Forwarding Rule, used in internal load balancing and
  /// network load balancing with IPv6.
  ///
  /// If the network specified is in auto subnet mode, this field is optional.
  /// However, a subnetwork must be specified if the network is in custom subnet
  /// mode or when creating external forwarding rule with IPv6.
  core.String? subnetwork;
  core.String? target;

  ForwardingRule({
    this.IPAddress,
    this.IPProtocol,
    this.allPorts,
    this.allowGlobalAccess,
    this.backendService,
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.ipVersion,
    this.isMirroringCollector,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.loadBalancingScheme,
    this.metadataFilters,
    this.name,
    this.network,
    this.networkTier,
    this.noAutomateDnsZone,
    this.portRange,
    this.ports,
    this.pscConnectionId,
    this.pscConnectionStatus,
    this.region,
    this.selfLink,
    this.serviceDirectoryRegistrations,
    this.serviceLabel,
    this.serviceName,
    this.subnetwork,
    this.target,
  });

  ForwardingRule.fromJson(core.Map json_)
      : this(
          IPAddress: json_.containsKey('IPAddress')
              ? json_['IPAddress'] as core.String
              : null,
          IPProtocol: json_.containsKey('IPProtocol')
              ? json_['IPProtocol'] as core.String
              : null,
          allPorts: json_.containsKey('allPorts')
              ? json_['allPorts'] as core.bool
              : null,
          allowGlobalAccess: json_.containsKey('allowGlobalAccess')
              ? json_['allowGlobalAccess'] as core.bool
              : null,
          backendService: json_.containsKey('backendService')
              ? json_['backendService'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          ipVersion: json_.containsKey('ipVersion')
              ? json_['ipVersion'] as core.String
              : null,
          isMirroringCollector: json_.containsKey('isMirroringCollector')
              ? json_['isMirroringCollector'] as core.bool
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          loadBalancingScheme: json_.containsKey('loadBalancingScheme')
              ? json_['loadBalancingScheme'] as core.String
              : null,
          metadataFilters: json_.containsKey('metadataFilters')
              ? (json_['metadataFilters'] as core.List)
                  .map((value) => MetadataFilter.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          networkTier: json_.containsKey('networkTier')
              ? json_['networkTier'] as core.String
              : null,
          noAutomateDnsZone: json_.containsKey('noAutomateDnsZone')
              ? json_['noAutomateDnsZone'] as core.bool
              : null,
          portRange: json_.containsKey('portRange')
              ? json_['portRange'] as core.String
              : null,
          ports: json_.containsKey('ports')
              ? (json_['ports'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          pscConnectionId: json_.containsKey('pscConnectionId')
              ? json_['pscConnectionId'] as core.String
              : null,
          pscConnectionStatus: json_.containsKey('pscConnectionStatus')
              ? json_['pscConnectionStatus'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          serviceDirectoryRegistrations:
              json_.containsKey('serviceDirectoryRegistrations')
                  ? (json_['serviceDirectoryRegistrations'] as core.List)
                      .map((value) =>
                          ForwardingRuleServiceDirectoryRegistration.fromJson(
                              value as core.Map<core.String, core.dynamic>))
                      .toList()
                  : null,
          serviceLabel: json_.containsKey('serviceLabel')
              ? json_['serviceLabel'] as core.String
              : null,
          serviceName: json_.containsKey('serviceName')
              ? json_['serviceName'] as core.String
              : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
          target: json_.containsKey('target')
              ? json_['target'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (IPAddress != null) 'IPAddress': IPAddress!,
        if (IPProtocol != null) 'IPProtocol': IPProtocol!,
        if (allPorts != null) 'allPorts': allPorts!,
        if (allowGlobalAccess != null) 'allowGlobalAccess': allowGlobalAccess!,
        if (backendService != null) 'backendService': backendService!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (ipVersion != null) 'ipVersion': ipVersion!,
        if (isMirroringCollector != null)
          'isMirroringCollector': isMirroringCollector!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (loadBalancingScheme != null)
          'loadBalancingScheme': loadBalancingScheme!,
        if (metadataFilters != null) 'metadataFilters': metadataFilters!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (networkTier != null) 'networkTier': networkTier!,
        if (noAutomateDnsZone != null) 'noAutomateDnsZone': noAutomateDnsZone!,
        if (portRange != null) 'portRange': portRange!,
        if (ports != null) 'ports': ports!,
        if (pscConnectionId != null) 'pscConnectionId': pscConnectionId!,
        if (pscConnectionStatus != null)
          'pscConnectionStatus': pscConnectionStatus!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (serviceDirectoryRegistrations != null)
          'serviceDirectoryRegistrations': serviceDirectoryRegistrations!,
        if (serviceLabel != null) 'serviceLabel': serviceLabel!,
        if (serviceName != null) 'serviceName': serviceName!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
        if (target != null) 'target': target!,
      };
}

class ForwardingRuleAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ForwardingRuleAggregatedListWarningData({
    this.key,
    this.value,
  });

  ForwardingRuleAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ForwardingRuleAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ForwardingRuleAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ForwardingRuleAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ForwardingRuleAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ForwardingRuleAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ForwardingRuleAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ForwardingRulesScopedList resources.
  core.Map<core.String, ForwardingRulesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#forwardingRuleAggregatedList for lists of forwarding rules.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  ForwardingRuleAggregatedListWarning? warning;

  ForwardingRuleAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  ForwardingRuleAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    ForwardingRulesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ForwardingRuleAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class ForwardingRuleListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ForwardingRuleListWarningData({
    this.key,
    this.value,
  });

  ForwardingRuleListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ForwardingRuleListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ForwardingRuleListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ForwardingRuleListWarning({
    this.code,
    this.data,
    this.message,
  });

  ForwardingRuleListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ForwardingRuleListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of ForwardingRule resources.
class ForwardingRuleList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ForwardingRule resources.
  core.List<ForwardingRule>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ForwardingRuleListWarning? warning;

  ForwardingRuleList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ForwardingRuleList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => ForwardingRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ForwardingRuleListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class ForwardingRuleReference {
  core.String? forwardingRule;

  ForwardingRuleReference({
    this.forwardingRule,
  });

  ForwardingRuleReference.fromJson(core.Map json_)
      : this(
          forwardingRule: json_.containsKey('forwardingRule')
              ? json_['forwardingRule'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (forwardingRule != null) 'forwardingRule': forwardingRule!,
      };
}

/// Describes the auto-registration of the Forwarding Rule to Service Directory.
///
/// The region and project of the Service Directory resource generated from this
/// registration will be the same as this Forwarding Rule.
class ForwardingRuleServiceDirectoryRegistration {
  /// Service Directory namespace to register the forwarding rule under.
  core.String? namespace;

  /// Service Directory service to register the forwarding rule under.
  core.String? service;

  /// Service Directory region to register this global forwarding rule under.
  ///
  /// Default to "us-central1". Only used for PSC for Google APIs. All PSC for
  /// Google APIs Forwarding Rules on the same network should use the same
  /// Service Directory region.
  ///
  /// Optional.
  core.String? serviceDirectoryRegion;

  ForwardingRuleServiceDirectoryRegistration({
    this.namespace,
    this.service,
    this.serviceDirectoryRegion,
  });

  ForwardingRuleServiceDirectoryRegistration.fromJson(core.Map json_)
      : this(
          namespace: json_.containsKey('namespace')
              ? json_['namespace'] as core.String
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          serviceDirectoryRegion: json_.containsKey('serviceDirectoryRegion')
              ? json_['serviceDirectoryRegion'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (namespace != null) 'namespace': namespace!,
        if (service != null) 'service': service!,
        if (serviceDirectoryRegion != null)
          'serviceDirectoryRegion': serviceDirectoryRegion!,
      };
}

class ForwardingRulesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ForwardingRulesScopedListWarningData({
    this.key,
    this.value,
  });

  ForwardingRulesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of forwarding rules when the
/// list is empty.
class ForwardingRulesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ForwardingRulesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ForwardingRulesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ForwardingRulesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ForwardingRulesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ForwardingRulesScopedList {
  /// A list of forwarding rules contained in this scope.
  core.List<ForwardingRule>? forwardingRules;

  /// Informational warning which replaces the list of forwarding rules when the
  /// list is empty.
  ForwardingRulesScopedListWarning? warning;

  ForwardingRulesScopedList({
    this.forwardingRules,
    this.warning,
  });

  ForwardingRulesScopedList.fromJson(core.Map json_)
      : this(
          forwardingRules: json_.containsKey('forwardingRules')
              ? (json_['forwardingRules'] as core.List)
                  .map((value) => ForwardingRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ForwardingRulesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (forwardingRules != null) 'forwardingRules': forwardingRules!,
        if (warning != null) 'warning': warning!,
      };
}

class GRPCHealthCheck {
  /// The gRPC service name for the health check.
  ///
  /// This field is optional. The value of grpc_service_name has the following
  /// meanings by convention: - Empty service_name means the overall status of
  /// all services at the backend. - Non-empty service_name means the health of
  /// that gRPC service, as defined by the owner of the service. The
  /// grpc_service_name can only be ASCII.
  core.String? grpcServiceName;

  /// The port number for the health check request.
  ///
  /// Must be specified if port_name and port_specification are not set or if
  /// port_specification is USE_FIXED_PORT. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence. The
  /// port_name should conform to RFC1035.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, gRPC health check follows behavior specified
  /// in port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  GRPCHealthCheck({
    this.grpcServiceName,
    this.port,
    this.portName,
    this.portSpecification,
  });

  GRPCHealthCheck.fromJson(core.Map json_)
      : this(
          grpcServiceName: json_.containsKey('grpcServiceName')
              ? json_['grpcServiceName'] as core.String
              : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (grpcServiceName != null) 'grpcServiceName': grpcServiceName!,
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
      };
}

class GlobalNetworkEndpointGroupsAttachEndpointsRequest {
  /// The list of network endpoints to be attached.
  core.List<NetworkEndpoint>? networkEndpoints;

  GlobalNetworkEndpointGroupsAttachEndpointsRequest({
    this.networkEndpoints,
  });

  GlobalNetworkEndpointGroupsAttachEndpointsRequest.fromJson(core.Map json_)
      : this(
          networkEndpoints: json_.containsKey('networkEndpoints')
              ? (json_['networkEndpoints'] as core.List)
                  .map((value) => NetworkEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEndpoints != null) 'networkEndpoints': networkEndpoints!,
      };
}

class GlobalNetworkEndpointGroupsDetachEndpointsRequest {
  /// The list of network endpoints to be detached.
  core.List<NetworkEndpoint>? networkEndpoints;

  GlobalNetworkEndpointGroupsDetachEndpointsRequest({
    this.networkEndpoints,
  });

  GlobalNetworkEndpointGroupsDetachEndpointsRequest.fromJson(core.Map json_)
      : this(
          networkEndpoints: json_.containsKey('networkEndpoints')
              ? (json_['networkEndpoints'] as core.List)
                  .map((value) => NetworkEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEndpoints != null) 'networkEndpoints': networkEndpoints!,
      };
}

class GlobalOrganizationSetPolicyRequest {
  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify bindings.
  core.List<Binding>? bindings;

  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify the etag.
  core.String? etag;
  core.List<core.int> get etagAsBytes => convert.base64.decode(etag!);

  set etagAsBytes(core.List<core.int> bytes_) {
    etag =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// REQUIRED: The complete policy to be applied to the 'resource'.
  ///
  /// The size of the policy is limited to a few 10s of KB. An empty policy is
  /// in general a valid policy but certain services (like Projects) might
  /// reject them.
  Policy? policy;

  GlobalOrganizationSetPolicyRequest({
    this.bindings,
    this.etag,
    this.policy,
  });

  GlobalOrganizationSetPolicyRequest.fromJson(core.Map json_)
      : this(
          bindings: json_.containsKey('bindings')
              ? (json_['bindings'] as core.List)
                  .map((value) => Binding.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          policy: json_.containsKey('policy')
              ? Policy.fromJson(
                  json_['policy'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bindings != null) 'bindings': bindings!,
        if (etag != null) 'etag': etag!,
        if (policy != null) 'policy': policy!,
      };
}

class GlobalSetLabelsRequest {
  /// The fingerprint of the previous set of labels for this resource, used to
  /// detect conflicts.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash when updating or changing labels, otherwise
  /// the request will fail with error 412 conditionNotMet. Make a get() request
  /// to the resource to get the latest fingerprint.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// A list of labels to apply for this resource.
  ///
  /// Each label must comply with the requirements for labels. For example,
  /// "webserver-frontend": "images". A label value can also be empty (e.g.
  /// "my-label": "").
  core.Map<core.String, core.String>? labels;

  GlobalSetLabelsRequest({
    this.labelFingerprint,
    this.labels,
  });

  GlobalSetLabelsRequest.fromJson(core.Map json_)
      : this(
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
      };
}

class GlobalSetPolicyRequest {
  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify bindings.
  core.List<Binding>? bindings;

  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify the etag.
  core.String? etag;
  core.List<core.int> get etagAsBytes => convert.base64.decode(etag!);

  set etagAsBytes(core.List<core.int> bytes_) {
    etag =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// REQUIRED: The complete policy to be applied to the 'resource'.
  ///
  /// The size of the policy is limited to a few 10s of KB. An empty policy is
  /// in general a valid policy but certain services (like Projects) might
  /// reject them.
  Policy? policy;

  GlobalSetPolicyRequest({
    this.bindings,
    this.etag,
    this.policy,
  });

  GlobalSetPolicyRequest.fromJson(core.Map json_)
      : this(
          bindings: json_.containsKey('bindings')
              ? (json_['bindings'] as core.List)
                  .map((value) => Binding.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          policy: json_.containsKey('policy')
              ? Policy.fromJson(
                  json_['policy'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bindings != null) 'bindings': bindings!,
        if (etag != null) 'etag': etag!,
        if (policy != null) 'policy': policy!,
      };
}

/// A guest attributes entry.
class GuestAttributes {
  /// Type of the resource.
  ///
  /// Always compute#guestAttributes for guest attributes entry.
  ///
  /// Output only.
  core.String? kind;

  /// The path to be queried.
  ///
  /// This can be the default namespace ('') or a nested namespace ('\/') or a
  /// specified key ('\/\').
  core.String? queryPath;

  /// The value of the requested queried path.
  ///
  /// Output only.
  GuestAttributesValue? queryValue;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The key to search for.
  core.String? variableKey;

  /// The value found for the requested key.
  ///
  /// Output only.
  core.String? variableValue;

  GuestAttributes({
    this.kind,
    this.queryPath,
    this.queryValue,
    this.selfLink,
    this.variableKey,
    this.variableValue,
  });

  GuestAttributes.fromJson(core.Map json_)
      : this(
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          queryPath: json_.containsKey('queryPath')
              ? json_['queryPath'] as core.String
              : null,
          queryValue: json_.containsKey('queryValue')
              ? GuestAttributesValue.fromJson(
                  json_['queryValue'] as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          variableKey: json_.containsKey('variableKey')
              ? json_['variableKey'] as core.String
              : null,
          variableValue: json_.containsKey('variableValue')
              ? json_['variableValue'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (kind != null) 'kind': kind!,
        if (queryPath != null) 'queryPath': queryPath!,
        if (queryValue != null) 'queryValue': queryValue!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (variableKey != null) 'variableKey': variableKey!,
        if (variableValue != null) 'variableValue': variableValue!,
      };
}

/// A guest attributes namespace/key/value entry.
class GuestAttributesEntry {
  /// Key for the guest attribute entry.
  core.String? key;

  /// Namespace for the guest attribute entry.
  core.String? namespace;

  /// Value for the guest attribute entry.
  core.String? value;

  GuestAttributesEntry({
    this.key,
    this.namespace,
    this.value,
  });

  GuestAttributesEntry.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          namespace: json_.containsKey('namespace')
              ? json_['namespace'] as core.String
              : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (namespace != null) 'namespace': namespace!,
        if (value != null) 'value': value!,
      };
}

/// Array of guest attribute namespace/key/value tuples.
class GuestAttributesValue {
  core.List<GuestAttributesEntry>? items;

  GuestAttributesValue({
    this.items,
  });

  GuestAttributesValue.fromJson(core.Map json_)
      : this(
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => GuestAttributesEntry.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (items != null) 'items': items!,
      };
}

/// Guest OS features.
class GuestOsFeature {
  /// The ID of a supported feature.
  ///
  /// To add multiple values, use commas to separate values. Set to one or more
  /// of the following values: - VIRTIO_SCSI_MULTIQUEUE - WINDOWS -
  /// MULTI_IP_SUBNET - UEFI_COMPATIBLE - GVNIC - SEV_CAPABLE -
  /// SUSPEND_RESUME_COMPATIBLE - SEV_SNP_CAPABLE For more information, see
  /// Enabling guest operating system features.
  /// Possible string values are:
  /// - "FEATURE_TYPE_UNSPECIFIED"
  /// - "GVNIC"
  /// - "MULTI_IP_SUBNET"
  /// - "SECURE_BOOT"
  /// - "SEV_CAPABLE"
  /// - "UEFI_COMPATIBLE"
  /// - "VIRTIO_SCSI_MULTIQUEUE"
  /// - "WINDOWS"
  core.String? type;

  GuestOsFeature({
    this.type,
  });

  GuestOsFeature.fromJson(core.Map json_)
      : this(
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (type != null) 'type': type!,
      };
}

class HTTP2HealthCheck {
  /// The value of the host header in the HTTP/2 health check request.
  ///
  /// If left empty (default value), the IP on behalf of which this health check
  /// is performed will be used.
  core.String? host;

  /// The TCP port number for the health check request.
  ///
  /// The default value is 443. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, HTTP2 health check follows behavior specified
  /// in port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// The request path of the HTTP/2 health check request.
  ///
  /// The default value is /.
  core.String? requestPath;

  /// The string to match anywhere in the first 1024 bytes of the response body.
  ///
  /// If left empty (the default value), the status code determines health. The
  /// response data can only be ASCII.
  core.String? response;

  HTTP2HealthCheck({
    this.host,
    this.port,
    this.portName,
    this.portSpecification,
    this.proxyHeader,
    this.requestPath,
    this.response,
  });

  HTTP2HealthCheck.fromJson(core.Map json_)
      : this(
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          requestPath: json_.containsKey('requestPath')
              ? json_['requestPath'] as core.String
              : null,
          response: json_.containsKey('response')
              ? json_['response'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (host != null) 'host': host!,
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (requestPath != null) 'requestPath': requestPath!,
        if (response != null) 'response': response!,
      };
}

class HTTPHealthCheck {
  /// The value of the host header in the HTTP health check request.
  ///
  /// If left empty (default value), the IP on behalf of which this health check
  /// is performed will be used.
  core.String? host;

  /// The TCP port number for the health check request.
  ///
  /// The default value is 80. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, HTTP health check follows behavior specified
  /// in port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// The request path of the HTTP health check request.
  ///
  /// The default value is /.
  core.String? requestPath;

  /// The string to match anywhere in the first 1024 bytes of the response body.
  ///
  /// If left empty (the default value), the status code determines health. The
  /// response data can only be ASCII.
  core.String? response;

  HTTPHealthCheck({
    this.host,
    this.port,
    this.portName,
    this.portSpecification,
    this.proxyHeader,
    this.requestPath,
    this.response,
  });

  HTTPHealthCheck.fromJson(core.Map json_)
      : this(
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          requestPath: json_.containsKey('requestPath')
              ? json_['requestPath'] as core.String
              : null,
          response: json_.containsKey('response')
              ? json_['response'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (host != null) 'host': host!,
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (requestPath != null) 'requestPath': requestPath!,
        if (response != null) 'response': response!,
      };
}

class HTTPSHealthCheck {
  /// The value of the host header in the HTTPS health check request.
  ///
  /// If left empty (default value), the IP on behalf of which this health check
  /// is performed will be used.
  core.String? host;

  /// The TCP port number for the health check request.
  ///
  /// The default value is 443. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, HTTPS health check follows behavior specified
  /// in port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// The request path of the HTTPS health check request.
  ///
  /// The default value is /.
  core.String? requestPath;

  /// The string to match anywhere in the first 1024 bytes of the response body.
  ///
  /// If left empty (the default value), the status code determines health. The
  /// response data can only be ASCII.
  core.String? response;

  HTTPSHealthCheck({
    this.host,
    this.port,
    this.portName,
    this.portSpecification,
    this.proxyHeader,
    this.requestPath,
    this.response,
  });

  HTTPSHealthCheck.fromJson(core.Map json_)
      : this(
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          requestPath: json_.containsKey('requestPath')
              ? json_['requestPath'] as core.String
              : null,
          response: json_.containsKey('response')
              ? json_['response'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (host != null) 'host': host!,
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (requestPath != null) 'requestPath': requestPath!,
        if (response != null) 'response': response!,
      };
}

/// Represents a Health Check resource.
///
/// Google Compute Engine has two Health Check resources: *
/// \[Global\](/compute/docs/reference/rest/v1/healthChecks) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionHealthChecks) Internal
/// HTTP(S) load balancers must use regional health checks
/// (`compute.v1.regionHealthChecks`). Traffic Director must use global health
/// checks (`compute.v1.HealthChecks`). Internal TCP/UDP load balancers can use
/// either regional or global health checks (`compute.v1.regionHealthChecks` or
/// `compute.v1.HealthChecks`). External HTTP(S), TCP proxy, and SSL proxy load
/// balancers as well as managed instance group auto-healing must use global
/// health checks (`compute.v1.HealthChecks`). Backend service-based network
/// load balancers must use regional health checks
/// (`compute.v1.regionHealthChecks`). Target pool-based network load balancers
/// must use legacy HTTP health checks (`compute.v1.httpHealthChecks`). For more
/// information, see Health checks overview.
class HealthCheck {
  /// How often (in seconds) to send a health check.
  ///
  /// The default value is 5 seconds.
  core.int? checkIntervalSec;

  /// Creation timestamp in 3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;
  GRPCHealthCheck? grpcHealthCheck;

  /// A so-far unhealthy instance will be marked healthy after this many
  /// consecutive successes.
  ///
  /// The default value is 2.
  core.int? healthyThreshold;
  HTTP2HealthCheck? http2HealthCheck;
  HTTPHealthCheck? httpHealthCheck;
  HTTPSHealthCheck? httpsHealthCheck;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  core.String? kind;

  /// Configure logging on this health check.
  HealthCheckLogConfig? logConfig;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. For example, a name that is 1-63
  /// characters long, matches the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?`, and otherwise complies with RFC1035. This
  /// regular expression describes a name where the first character is a
  /// lowercase letter, and all following characters are a dash, lowercase
  /// letter, or digit, except the last character, which isn't a dash.
  core.String? name;

  /// Region where the health check resides.
  ///
  /// Not applicable to global health checks.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;
  SSLHealthCheck? sslHealthCheck;
  TCPHealthCheck? tcpHealthCheck;

  /// How long (in seconds) to wait before claiming failure.
  ///
  /// The default value is 5 seconds. It is invalid for timeoutSec to have
  /// greater value than checkIntervalSec.
  core.int? timeoutSec;

  /// Specifies the type of the healthCheck, either TCP, SSL, HTTP, HTTPS, HTTP2
  /// or GRPC.
  ///
  /// Exactly one of the protocol-specific health check fields must be
  /// specified, which must match type field.
  /// Possible string values are:
  /// - "GRPC"
  /// - "HTTP"
  /// - "HTTP2"
  /// - "HTTPS"
  /// - "INVALID"
  /// - "SSL"
  /// - "TCP"
  core.String? type;

  /// A so-far healthy instance will be marked unhealthy after this many
  /// consecutive failures.
  ///
  /// The default value is 2.
  core.int? unhealthyThreshold;

  HealthCheck({
    this.checkIntervalSec,
    this.creationTimestamp,
    this.description,
    this.grpcHealthCheck,
    this.healthyThreshold,
    this.http2HealthCheck,
    this.httpHealthCheck,
    this.httpsHealthCheck,
    this.id,
    this.kind,
    this.logConfig,
    this.name,
    this.region,
    this.selfLink,
    this.sslHealthCheck,
    this.tcpHealthCheck,
    this.timeoutSec,
    this.type,
    this.unhealthyThreshold,
  });

  HealthCheck.fromJson(core.Map json_)
      : this(
          checkIntervalSec: json_.containsKey('checkIntervalSec')
              ? json_['checkIntervalSec'] as core.int
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          grpcHealthCheck: json_.containsKey('grpcHealthCheck')
              ? GRPCHealthCheck.fromJson(json_['grpcHealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          healthyThreshold: json_.containsKey('healthyThreshold')
              ? json_['healthyThreshold'] as core.int
              : null,
          http2HealthCheck: json_.containsKey('http2HealthCheck')
              ? HTTP2HealthCheck.fromJson(json_['http2HealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          httpHealthCheck: json_.containsKey('httpHealthCheck')
              ? HTTPHealthCheck.fromJson(json_['httpHealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          httpsHealthCheck: json_.containsKey('httpsHealthCheck')
              ? HTTPSHealthCheck.fromJson(json_['httpsHealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          logConfig: json_.containsKey('logConfig')
              ? HealthCheckLogConfig.fromJson(
                  json_['logConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sslHealthCheck: json_.containsKey('sslHealthCheck')
              ? SSLHealthCheck.fromJson(json_['sslHealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          tcpHealthCheck: json_.containsKey('tcpHealthCheck')
              ? TCPHealthCheck.fromJson(json_['tcpHealthCheck']
                  as core.Map<core.String, core.dynamic>)
              : null,
          timeoutSec: json_.containsKey('timeoutSec')
              ? json_['timeoutSec'] as core.int
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
          unhealthyThreshold: json_.containsKey('unhealthyThreshold')
              ? json_['unhealthyThreshold'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (checkIntervalSec != null) 'checkIntervalSec': checkIntervalSec!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (grpcHealthCheck != null) 'grpcHealthCheck': grpcHealthCheck!,
        if (healthyThreshold != null) 'healthyThreshold': healthyThreshold!,
        if (http2HealthCheck != null) 'http2HealthCheck': http2HealthCheck!,
        if (httpHealthCheck != null) 'httpHealthCheck': httpHealthCheck!,
        if (httpsHealthCheck != null) 'httpsHealthCheck': httpsHealthCheck!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (logConfig != null) 'logConfig': logConfig!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sslHealthCheck != null) 'sslHealthCheck': sslHealthCheck!,
        if (tcpHealthCheck != null) 'tcpHealthCheck': tcpHealthCheck!,
        if (timeoutSec != null) 'timeoutSec': timeoutSec!,
        if (type != null) 'type': type!,
        if (unhealthyThreshold != null)
          'unhealthyThreshold': unhealthyThreshold!,
      };
}

class HealthCheckListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HealthCheckListWarningData({
    this.key,
    this.value,
  });

  HealthCheckListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class HealthCheckListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HealthCheckListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HealthCheckListWarning({
    this.code,
    this.data,
    this.message,
  });

  HealthCheckListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => HealthCheckListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of HealthCheck resources.
class HealthCheckList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of HealthCheck resources.
  core.List<HealthCheck>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  HealthCheckListWarning? warning;

  HealthCheckList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  HealthCheckList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => HealthCheck.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? HealthCheckListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Configuration of logging on a health check.
///
/// If logging is enabled, logs will be exported to Stackdriver.
class HealthCheckLogConfig {
  /// Indicates whether or not to export logs.
  ///
  /// This is false by default, which means no health check logging will be
  /// done.
  core.bool? enable;

  HealthCheckLogConfig({
    this.enable,
  });

  HealthCheckLogConfig.fromJson(core.Map json_)
      : this(
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enable != null) 'enable': enable!,
      };
}

/// A full or valid partial URL to a health check.
///
/// For example, the following are valid URLs: -
/// https://www.googleapis.com/compute/beta/projects/project-id/global/httpHealthChecks/health-check
/// - projects/project-id/global/httpHealthChecks/health-check -
/// global/httpHealthChecks/health-check
class HealthCheckReference {
  core.String? healthCheck;

  HealthCheckReference({
    this.healthCheck,
  });

  HealthCheckReference.fromJson(core.Map json_)
      : this(
          healthCheck: json_.containsKey('healthCheck')
              ? json_['healthCheck'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthCheck != null) 'healthCheck': healthCheck!,
      };
}

/// Represents a Health-Check as a Service resource.
class HealthCheckService {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// HealthCheckService. An up-to-date fingerprint must be provided in order to
  /// patch/update the HealthCheckService; Otherwise, the request will fail with
  /// error 412 conditionNotMet. To see the latest fingerprint, make a get()
  /// request to retrieve the HealthCheckService.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// A list of URLs to the HealthCheck resources.
  ///
  /// Must have at least one HealthCheck, and not more than 10. HealthCheck
  /// resources must have portSpecification=USE_SERVING_PORT or
  /// portSpecification=USE_FIXED_PORT. For regional HealthCheckService, the
  /// HealthCheck must be regional and in the same region. For global
  /// HealthCheckService, HealthCheck must be global. Mix of regional and global
  /// HealthChecks is not supported. Multiple regional HealthChecks must belong
  /// to the same region. Regional HealthChecks must belong to the same region
  /// as zones of NEGs.
  core.List<core.String>? healthChecks;

  /// Policy for how the results from multiple health checks for the same
  /// endpoint are aggregated.
  ///
  /// Defaults to NO_AGGREGATION if unspecified. - NO_AGGREGATION. An
  /// EndpointHealth message is returned for each pair in the health check
  /// service. - AND. If any health check of an endpoint reports UNHEALTHY, then
  /// UNHEALTHY is the HealthState of the endpoint. If all health checks report
  /// HEALTHY, the HealthState of the endpoint is HEALTHY. .
  ///
  /// Optional.
  /// Possible string values are:
  /// - "AND" : If any backend's health check reports UNHEALTHY, then UNHEALTHY
  /// is the HealthState of the entire health check service. If all backend's
  /// are healthy, the HealthState of the health check service is HEALTHY.
  /// - "NO_AGGREGATION" : An EndpointHealth message is returned for each
  /// backend in the health check service.
  core.String? healthStatusAggregationPolicy;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#healthCheckServicefor health check services.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// A list of URLs to the NetworkEndpointGroup resources.
  ///
  /// Must not have more than 100. For regional HealthCheckService, NEGs must be
  /// in zones in the region of the HealthCheckService.
  core.List<core.String>? networkEndpointGroups;

  /// A list of URLs to the NotificationEndpoint resources.
  ///
  /// Must not have more than 10. A list of endpoints for receiving
  /// notifications of change in health status. For regional HealthCheckService,
  /// NotificationEndpoint must be regional and in the same region. For global
  /// HealthCheckService, NotificationEndpoint must be global.
  core.List<core.String>? notificationEndpoints;

  /// URL of the region where the health check service resides.
  ///
  /// This field is not applicable to global health check services. You must
  /// specify this field as part of the HTTP request URL. It is not settable as
  /// a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  HealthCheckService({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.healthChecks,
    this.healthStatusAggregationPolicy,
    this.id,
    this.kind,
    this.name,
    this.networkEndpointGroups,
    this.notificationEndpoints,
    this.region,
    this.selfLink,
  });

  HealthCheckService.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          healthStatusAggregationPolicy:
              json_.containsKey('healthStatusAggregationPolicy')
                  ? json_['healthStatusAggregationPolicy'] as core.String
                  : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          networkEndpointGroups: json_.containsKey('networkEndpointGroups')
              ? (json_['networkEndpointGroups'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          notificationEndpoints: json_.containsKey('notificationEndpoints')
              ? (json_['notificationEndpoints'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (healthChecks != null) 'healthChecks': healthChecks!,
        if (healthStatusAggregationPolicy != null)
          'healthStatusAggregationPolicy': healthStatusAggregationPolicy!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (networkEndpointGroups != null)
          'networkEndpointGroups': networkEndpointGroups!,
        if (notificationEndpoints != null)
          'notificationEndpoints': notificationEndpoints!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// A full or valid partial URL to a health check service.
///
/// For example, the following are valid URLs: -
/// https://www.googleapis.com/compute/beta/projects/project-id/regions/us-west1/healthCheckServices/health-check-service
/// -
/// projects/project-id/regions/us-west1/healthCheckServices/health-check-service
/// - regions/us-west1/healthCheckServices/health-check-service
class HealthCheckServiceReference {
  core.String? healthCheckService;

  HealthCheckServiceReference({
    this.healthCheckService,
  });

  HealthCheckServiceReference.fromJson(core.Map json_)
      : this(
          healthCheckService: json_.containsKey('healthCheckService')
              ? json_['healthCheckService'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthCheckService != null)
          'healthCheckService': healthCheckService!,
      };
}

class HealthCheckServicesListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HealthCheckServicesListWarningData({
    this.key,
    this.value,
  });

  HealthCheckServicesListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class HealthCheckServicesListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HealthCheckServicesListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HealthCheckServicesListWarning({
    this.code,
    this.data,
    this.message,
  });

  HealthCheckServicesListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => HealthCheckServicesListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class HealthCheckServicesList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of HealthCheckService resources.
  core.List<HealthCheckService>? items;

  /// Type of the resource.
  ///
  /// Always compute#healthCheckServicesList for lists of HealthCheckServices.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  HealthCheckServicesListWarning? warning;

  HealthCheckServicesList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  HealthCheckServicesList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => HealthCheckService.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? HealthCheckServicesListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class HealthChecksAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HealthChecksAggregatedListWarningData({
    this.key,
    this.value,
  });

  HealthChecksAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class HealthChecksAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HealthChecksAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HealthChecksAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  HealthChecksAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      HealthChecksAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class HealthChecksAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of HealthChecksScopedList resources.
  core.Map<core.String, HealthChecksScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  HealthChecksAggregatedListWarning? warning;

  HealthChecksAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  HealthChecksAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    HealthChecksScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? HealthChecksAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class HealthChecksScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HealthChecksScopedListWarningData({
    this.key,
    this.value,
  });

  HealthChecksScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class HealthChecksScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HealthChecksScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HealthChecksScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  HealthChecksScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => HealthChecksScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class HealthChecksScopedList {
  /// A list of HealthChecks contained in this scope.
  core.List<HealthCheck>? healthChecks;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  HealthChecksScopedListWarning? warning;

  HealthChecksScopedList({
    this.healthChecks,
    this.warning,
  });

  HealthChecksScopedList.fromJson(core.Map json_)
      : this(
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => HealthCheck.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? HealthChecksScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthChecks != null) 'healthChecks': healthChecks!,
        if (warning != null) 'warning': warning!,
      };
}

class HealthStatus {
  /// Metadata defined as annotations for network endpoint.
  core.Map<core.String, core.String>? annotations;

  /// URL of the forwarding rule associated with the health status of the
  /// instance.
  core.String? forwardingRule;

  /// A forwarding rule IP address assigned to this instance.
  core.String? forwardingRuleIp;

  /// Health state of the instance.
  /// Possible string values are:
  /// - "HEALTHY"
  /// - "UNHEALTHY"
  core.String? healthState;

  /// URL of the instance resource.
  core.String? instance;

  /// For target pool based Network Load Balancing, it indicates the forwarding
  /// rule's IP address assigned to this instance.
  ///
  /// For other types of load balancing, the field indicates VM internal ip.
  core.String? ipAddress;

  /// The named port of the instance group, not necessarily the port that is
  /// health-checked.
  core.int? port;
  core.String? weight;

  ///
  /// Possible string values are:
  /// - "INVALID_WEIGHT" : The response to a Health Check probe had the HTTP
  /// response header field X-Load-Balancing-Endpoint-Weight, but its content
  /// was invalid (i.e., not a non-negative single-precision floating-point
  /// number in decimal string representation).
  /// - "MISSING_WEIGHT" : The response to a Health Check probe did not have the
  /// HTTP response header field X-Load-Balancing-Endpoint-Weight.
  /// - "UNAVAILABLE_WEIGHT" : This is the value when the accompanied health
  /// status is either TIMEOUT (i.e.,the Health Check probe was not able to get
  /// a response in time) or UNKNOWN. For the latter, it should be typically
  /// because there has not been sufficient time to parse and report the weight
  /// for a new backend (which is with 0.0.0.0 ip address). However, it can be
  /// also due to an outage case for which the health status is explicitly reset
  /// to UNKNOWN.
  /// - "WEIGHT_NONE" : This is the default value when WeightReportMode is
  /// DISABLE, and is also the initial value when WeightReportMode has just
  /// updated to ENABLE or DRY_RUN and there has not been sufficient time to
  /// parse and report the backend weight.
  core.String? weightError;

  HealthStatus({
    this.annotations,
    this.forwardingRule,
    this.forwardingRuleIp,
    this.healthState,
    this.instance,
    this.ipAddress,
    this.port,
    this.weight,
    this.weightError,
  });

  HealthStatus.fromJson(core.Map json_)
      : this(
          annotations: json_.containsKey('annotations')
              ? (json_['annotations'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          forwardingRule: json_.containsKey('forwardingRule')
              ? json_['forwardingRule'] as core.String
              : null,
          forwardingRuleIp: json_.containsKey('forwardingRuleIp')
              ? json_['forwardingRuleIp'] as core.String
              : null,
          healthState: json_.containsKey('healthState')
              ? json_['healthState'] as core.String
              : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          weight: json_.containsKey('weight')
              ? json_['weight'] as core.String
              : null,
          weightError: json_.containsKey('weightError')
              ? json_['weightError'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (annotations != null) 'annotations': annotations!,
        if (forwardingRule != null) 'forwardingRule': forwardingRule!,
        if (forwardingRuleIp != null) 'forwardingRuleIp': forwardingRuleIp!,
        if (healthState != null) 'healthState': healthState!,
        if (instance != null) 'instance': instance!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
        if (port != null) 'port': port!,
        if (weight != null) 'weight': weight!,
        if (weightError != null) 'weightError': weightError!,
      };
}

class HealthStatusForNetworkEndpoint {
  /// URL of the backend service associated with the health state of the network
  /// endpoint.
  BackendServiceReference? backendService;

  /// URL of the forwarding rule associated with the health state of the network
  /// endpoint.
  ForwardingRuleReference? forwardingRule;

  /// URL of the health check associated with the health state of the network
  /// endpoint.
  HealthCheckReference? healthCheck;

  /// URL of the health check service associated with the health state of the
  /// network endpoint.
  HealthCheckServiceReference? healthCheckService;

  /// Health state of the network endpoint determined based on the health checks
  /// configured.
  /// Possible string values are:
  /// - "DRAINING"
  /// - "HEALTHY"
  /// - "UNHEALTHY"
  /// - "UNKNOWN"
  core.String? healthState;

  HealthStatusForNetworkEndpoint({
    this.backendService,
    this.forwardingRule,
    this.healthCheck,
    this.healthCheckService,
    this.healthState,
  });

  HealthStatusForNetworkEndpoint.fromJson(core.Map json_)
      : this(
          backendService: json_.containsKey('backendService')
              ? BackendServiceReference.fromJson(json_['backendService']
                  as core.Map<core.String, core.dynamic>)
              : null,
          forwardingRule: json_.containsKey('forwardingRule')
              ? ForwardingRuleReference.fromJson(json_['forwardingRule']
                  as core.Map<core.String, core.dynamic>)
              : null,
          healthCheck: json_.containsKey('healthCheck')
              ? HealthCheckReference.fromJson(
                  json_['healthCheck'] as core.Map<core.String, core.dynamic>)
              : null,
          healthCheckService: json_.containsKey('healthCheckService')
              ? HealthCheckServiceReference.fromJson(json_['healthCheckService']
                  as core.Map<core.String, core.dynamic>)
              : null,
          healthState: json_.containsKey('healthState')
              ? json_['healthState'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backendService != null) 'backendService': backendService!,
        if (forwardingRule != null) 'forwardingRule': forwardingRule!,
        if (healthCheck != null) 'healthCheck': healthCheck!,
        if (healthCheckService != null)
          'healthCheckService': healthCheckService!,
        if (healthState != null) 'healthState': healthState!,
      };
}

/// Provides links to documentation or for performing an out of band action.
///
/// For example, if a quota check failed with an error indicating the calling
/// project hasn't enabled the accessed service, this can contain a URL pointing
/// directly to the right place in the developer console to flip the bit.
class Help {
  /// URL(s) pointing to additional information on handling the current error.
  core.List<HelpLink>? links;

  Help({
    this.links,
  });

  Help.fromJson(core.Map json_)
      : this(
          links: json_.containsKey('links')
              ? (json_['links'] as core.List)
                  .map((value) => HelpLink.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (links != null) 'links': links!,
      };
}

/// Describes a URL link.
class HelpLink {
  /// Describes what the link offers.
  core.String? description;

  /// The URL of the link.
  core.String? url;

  HelpLink({
    this.description,
    this.url,
  });

  HelpLink.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          url: json_.containsKey('url') ? json_['url'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (url != null) 'url': url!,
      };
}

/// UrlMaps A host-matching rule for a URL.
///
/// If matched, will use the named PathMatcher to select the BackendService.
class HostRule {
  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The list of host patterns to match.
  ///
  /// They must be valid hostnames with optional port numbers in the format
  /// host:port. * matches any string of (\[a-z0-9-.\]*). In that case, * must
  /// be the first character, and if followed by anything, the immediate
  /// following character must be either - or .. * based matching is not
  /// supported when the URL map is bound to a target gRPC proxy that has the
  /// validateForProxyless field set to true.
  core.List<core.String>? hosts;

  /// The name of the PathMatcher to use to match the path portion of the URL if
  /// the hostRule matches the URL's host portion.
  core.String? pathMatcher;

  HostRule({
    this.description,
    this.hosts,
    this.pathMatcher,
  });

  HostRule.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          hosts: json_.containsKey('hosts')
              ? (json_['hosts'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          pathMatcher: json_.containsKey('pathMatcher')
              ? json_['pathMatcher'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (hosts != null) 'hosts': hosts!,
        if (pathMatcher != null) 'pathMatcher': pathMatcher!,
      };
}

/// Specification for how requests are aborted as part of fault injection.
class HttpFaultAbort {
  /// The HTTP status code used to abort the request.
  ///
  /// The value must be from 200 to 599 inclusive. For gRPC protocol, the gRPC
  /// status code is mapped to HTTP status code according to this mapping table.
  /// HTTP status 200 is mapped to gRPC status UNKNOWN. Injecting an OK status
  /// is currently not supported by Traffic Director.
  core.int? httpStatus;

  /// The percentage of traffic for connections, operations, or requests that is
  /// aborted as part of fault injection.
  ///
  /// The value must be from 0.0 to 100.0 inclusive.
  core.double? percentage;

  HttpFaultAbort({
    this.httpStatus,
    this.percentage,
  });

  HttpFaultAbort.fromJson(core.Map json_)
      : this(
          httpStatus: json_.containsKey('httpStatus')
              ? json_['httpStatus'] as core.int
              : null,
          percentage: json_.containsKey('percentage')
              ? (json_['percentage'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (httpStatus != null) 'httpStatus': httpStatus!,
        if (percentage != null) 'percentage': percentage!,
      };
}

/// Specifies the delay introduced by the load balancer before forwarding the
/// request to the backend service as part of fault injection.
class HttpFaultDelay {
  /// Specifies the value of the fixed delay interval.
  Duration? fixedDelay;

  /// The percentage of traffic for connections, operations, or requests for
  /// which a delay is introduced as part of fault injection.
  ///
  /// The value must be from 0.0 to 100.0 inclusive.
  core.double? percentage;

  HttpFaultDelay({
    this.fixedDelay,
    this.percentage,
  });

  HttpFaultDelay.fromJson(core.Map json_)
      : this(
          fixedDelay: json_.containsKey('fixedDelay')
              ? Duration.fromJson(
                  json_['fixedDelay'] as core.Map<core.String, core.dynamic>)
              : null,
          percentage: json_.containsKey('percentage')
              ? (json_['percentage'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fixedDelay != null) 'fixedDelay': fixedDelay!,
        if (percentage != null) 'percentage': percentage!,
      };
}

/// The specification for fault injection introduced into traffic to test the
/// resiliency of clients to backend service failure.
///
/// As part of fault injection, when clients send requests to a backend service,
/// delays can be introduced by the load balancer on a percentage of requests
/// before sending those request to the backend service. Similarly requests from
/// clients can be aborted by the load balancer for a percentage of requests.
class HttpFaultInjection {
  /// The specification for how client requests are aborted as part of fault
  /// injection.
  HttpFaultAbort? abort;

  /// The specification for how client requests are delayed as part of fault
  /// injection, before being sent to a backend service.
  HttpFaultDelay? delay;

  HttpFaultInjection({
    this.abort,
    this.delay,
  });

  HttpFaultInjection.fromJson(core.Map json_)
      : this(
          abort: json_.containsKey('abort')
              ? HttpFaultAbort.fromJson(
                  json_['abort'] as core.Map<core.String, core.dynamic>)
              : null,
          delay: json_.containsKey('delay')
              ? HttpFaultDelay.fromJson(
                  json_['delay'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (abort != null) 'abort': abort!,
        if (delay != null) 'delay': delay!,
      };
}

/// The request and response header transformations that take effect before the
/// request is passed along to the selected backendService.
class HttpHeaderAction {
  /// Headers to add to a matching request before forwarding the request to the
  /// backendService.
  core.List<HttpHeaderOption>? requestHeadersToAdd;

  /// A list of header names for headers that need to be removed from the
  /// request before forwarding the request to the backendService.
  core.List<core.String>? requestHeadersToRemove;

  /// Headers to add the response before sending the response back to the
  /// client.
  core.List<HttpHeaderOption>? responseHeadersToAdd;

  /// A list of header names for headers that need to be removed from the
  /// response before sending the response back to the client.
  core.List<core.String>? responseHeadersToRemove;

  HttpHeaderAction({
    this.requestHeadersToAdd,
    this.requestHeadersToRemove,
    this.responseHeadersToAdd,
    this.responseHeadersToRemove,
  });

  HttpHeaderAction.fromJson(core.Map json_)
      : this(
          requestHeadersToAdd: json_.containsKey('requestHeadersToAdd')
              ? (json_['requestHeadersToAdd'] as core.List)
                  .map((value) => HttpHeaderOption.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          requestHeadersToRemove: json_.containsKey('requestHeadersToRemove')
              ? (json_['requestHeadersToRemove'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          responseHeadersToAdd: json_.containsKey('responseHeadersToAdd')
              ? (json_['responseHeadersToAdd'] as core.List)
                  .map((value) => HttpHeaderOption.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          responseHeadersToRemove: json_.containsKey('responseHeadersToRemove')
              ? (json_['responseHeadersToRemove'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (requestHeadersToAdd != null)
          'requestHeadersToAdd': requestHeadersToAdd!,
        if (requestHeadersToRemove != null)
          'requestHeadersToRemove': requestHeadersToRemove!,
        if (responseHeadersToAdd != null)
          'responseHeadersToAdd': responseHeadersToAdd!,
        if (responseHeadersToRemove != null)
          'responseHeadersToRemove': responseHeadersToRemove!,
      };
}

/// matchRule criteria for request header matches.
class HttpHeaderMatch {
  /// The value should exactly match contents of exactMatch.
  ///
  /// Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch
  /// or rangeMatch must be set.
  core.String? exactMatch;

  /// The name of the HTTP header to match.
  ///
  /// For matching against the HTTP request's authority, use a headerMatch with
  /// the header name ":authority". For matching a request's method, use the
  /// headerName ":method". When the URL map is bound to a target gRPC proxy
  /// that has the validateForProxyless field set to true, only non-binary
  /// user-specified custom metadata and the `content-type` header are
  /// supported. The following transport-level headers cannot be used in header
  /// matching rules: `:authority`, `:method`, `:path`, `:scheme`, `user-agent`,
  /// `accept-encoding`, `content-encoding`, `grpc-accept-encoding`,
  /// `grpc-encoding`, `grpc-previous-rpc-attempts`, `grpc-tags-bin`,
  /// `grpc-timeout` and `grpc-trace-bin`.
  core.String? headerName;

  /// If set to false, the headerMatch is considered a match if the preceding
  /// match criteria are met.
  ///
  /// If set to true, the headerMatch is considered a match if the preceding
  /// match criteria are NOT met. The default setting is false.
  core.bool? invertMatch;

  /// The value of the header must start with the contents of prefixMatch.
  ///
  /// Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch
  /// or rangeMatch must be set.
  core.String? prefixMatch;

  /// A header with the contents of headerName must exist.
  ///
  /// The match takes place whether or not the request's header has a value.
  /// Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch
  /// or rangeMatch must be set.
  core.bool? presentMatch;

  /// The header value must be an integer and its value must be in the range
  /// specified in rangeMatch.
  ///
  /// If the header does not contain an integer, number or is empty, the match
  /// fails. For example for a range \[-5, 0\] - -3 will match. - 0 will not
  /// match. - 0.25 will not match. - -3someString will not match. Only one of
  /// exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch or
  /// rangeMatch must be set. rangeMatch is not supported for load balancers
  /// that have loadBalancingScheme set to EXTERNAL.
  Int64RangeMatch? rangeMatch;

  /// The value of the header must match the regular expression specified in
  /// regexMatch.
  ///
  /// For more information about regular expression syntax, see Syntax. For
  /// matching against a port specified in the HTTP request, use a headerMatch
  /// with headerName set to PORT and a regular expression that satisfies the
  /// RFC2616 Host header's port specifier. Only one of exactMatch, prefixMatch,
  /// suffixMatch, regexMatch, presentMatch or rangeMatch must be set.
  /// regexMatch only applies to load balancers that have loadBalancingScheme
  /// set to INTERNAL_SELF_MANAGED.
  core.String? regexMatch;

  /// The value of the header must end with the contents of suffixMatch.
  ///
  /// Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch
  /// or rangeMatch must be set.
  core.String? suffixMatch;

  HttpHeaderMatch({
    this.exactMatch,
    this.headerName,
    this.invertMatch,
    this.prefixMatch,
    this.presentMatch,
    this.rangeMatch,
    this.regexMatch,
    this.suffixMatch,
  });

  HttpHeaderMatch.fromJson(core.Map json_)
      : this(
          exactMatch: json_.containsKey('exactMatch')
              ? json_['exactMatch'] as core.String
              : null,
          headerName: json_.containsKey('headerName')
              ? json_['headerName'] as core.String
              : null,
          invertMatch: json_.containsKey('invertMatch')
              ? json_['invertMatch'] as core.bool
              : null,
          prefixMatch: json_.containsKey('prefixMatch')
              ? json_['prefixMatch'] as core.String
              : null,
          presentMatch: json_.containsKey('presentMatch')
              ? json_['presentMatch'] as core.bool
              : null,
          rangeMatch: json_.containsKey('rangeMatch')
              ? Int64RangeMatch.fromJson(
                  json_['rangeMatch'] as core.Map<core.String, core.dynamic>)
              : null,
          regexMatch: json_.containsKey('regexMatch')
              ? json_['regexMatch'] as core.String
              : null,
          suffixMatch: json_.containsKey('suffixMatch')
              ? json_['suffixMatch'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (exactMatch != null) 'exactMatch': exactMatch!,
        if (headerName != null) 'headerName': headerName!,
        if (invertMatch != null) 'invertMatch': invertMatch!,
        if (prefixMatch != null) 'prefixMatch': prefixMatch!,
        if (presentMatch != null) 'presentMatch': presentMatch!,
        if (rangeMatch != null) 'rangeMatch': rangeMatch!,
        if (regexMatch != null) 'regexMatch': regexMatch!,
        if (suffixMatch != null) 'suffixMatch': suffixMatch!,
      };
}

/// Specification determining how headers are added to requests or responses.
class HttpHeaderOption {
  /// The name of the header.
  core.String? headerName;

  /// The value of the header to add.
  core.String? headerValue;

  /// If false, headerValue is appended to any values that already exist for the
  /// header.
  ///
  /// If true, headerValue is set for the header, discarding any values that
  /// were set for that header. The default value is false.
  core.bool? replace;

  HttpHeaderOption({
    this.headerName,
    this.headerValue,
    this.replace,
  });

  HttpHeaderOption.fromJson(core.Map json_)
      : this(
          headerName: json_.containsKey('headerName')
              ? json_['headerName'] as core.String
              : null,
          headerValue: json_.containsKey('headerValue')
              ? json_['headerValue'] as core.String
              : null,
          replace: json_.containsKey('replace')
              ? json_['replace'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (headerName != null) 'headerName': headerName!,
        if (headerValue != null) 'headerValue': headerValue!,
        if (replace != null) 'replace': replace!,
      };
}

/// Represents a legacy HTTP Health Check resource.
///
/// Legacy HTTP health checks are now only required by target pool-based network
/// load balancers. For all other load balancers, including backend
/// service-based network load balancers, and for managed instance group
/// auto-healing, you must use modern (non-legacy) health checks. For more
/// information, see Health checks overview .
class HttpHealthCheck {
  /// How often (in seconds) to send a health check.
  ///
  /// The default value is 5 seconds.
  core.int? checkIntervalSec;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// A so-far unhealthy instance will be marked healthy after this many
  /// consecutive successes.
  ///
  /// The default value is 2.
  core.int? healthyThreshold;

  /// The value of the host header in the HTTP health check request.
  ///
  /// If left empty (default value), the public IP on behalf of which this
  /// health check is performed will be used.
  core.String? host;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#httpHealthCheck for HTTP health checks.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The TCP port number for the HTTP health check request.
  ///
  /// The default value is 80.
  core.int? port;

  /// The request path of the HTTP health check request.
  ///
  /// The default value is /. This field does not support query parameters.
  core.String? requestPath;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// How long (in seconds) to wait before claiming failure.
  ///
  /// The default value is 5 seconds. It is invalid for timeoutSec to have
  /// greater value than checkIntervalSec.
  core.int? timeoutSec;

  /// A so-far healthy instance will be marked unhealthy after this many
  /// consecutive failures.
  ///
  /// The default value is 2.
  core.int? unhealthyThreshold;

  HttpHealthCheck({
    this.checkIntervalSec,
    this.creationTimestamp,
    this.description,
    this.healthyThreshold,
    this.host,
    this.id,
    this.kind,
    this.name,
    this.port,
    this.requestPath,
    this.selfLink,
    this.timeoutSec,
    this.unhealthyThreshold,
  });

  HttpHealthCheck.fromJson(core.Map json_)
      : this(
          checkIntervalSec: json_.containsKey('checkIntervalSec')
              ? json_['checkIntervalSec'] as core.int
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          healthyThreshold: json_.containsKey('healthyThreshold')
              ? json_['healthyThreshold'] as core.int
              : null,
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          requestPath: json_.containsKey('requestPath')
              ? json_['requestPath'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          timeoutSec: json_.containsKey('timeoutSec')
              ? json_['timeoutSec'] as core.int
              : null,
          unhealthyThreshold: json_.containsKey('unhealthyThreshold')
              ? json_['unhealthyThreshold'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (checkIntervalSec != null) 'checkIntervalSec': checkIntervalSec!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (healthyThreshold != null) 'healthyThreshold': healthyThreshold!,
        if (host != null) 'host': host!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (port != null) 'port': port!,
        if (requestPath != null) 'requestPath': requestPath!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (timeoutSec != null) 'timeoutSec': timeoutSec!,
        if (unhealthyThreshold != null)
          'unhealthyThreshold': unhealthyThreshold!,
      };
}

class HttpHealthCheckListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HttpHealthCheckListWarningData({
    this.key,
    this.value,
  });

  HttpHealthCheckListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class HttpHealthCheckListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HttpHealthCheckListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HttpHealthCheckListWarning({
    this.code,
    this.data,
    this.message,
  });

  HttpHealthCheckListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => HttpHealthCheckListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of HttpHealthCheck resources.
class HttpHealthCheckList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of HttpHealthCheck resources.
  core.List<HttpHealthCheck>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  HttpHealthCheckListWarning? warning;

  HttpHealthCheckList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  HttpHealthCheckList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => HttpHealthCheck.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? HttpHealthCheckListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// HttpRouteRuleMatch criteria for a request's query parameter.
class HttpQueryParameterMatch {
  /// The queryParameterMatch matches if the value of the parameter exactly
  /// matches the contents of exactMatch.
  ///
  /// Only one of presentMatch, exactMatch, or regexMatch must be set.
  core.String? exactMatch;

  /// The name of the query parameter to match.
  ///
  /// The query parameter must exist in the request, in the absence of which the
  /// request match fails.
  core.String? name;

  /// Specifies that the queryParameterMatch matches if the request contains the
  /// query parameter, irrespective of whether the parameter has a value or not.
  ///
  /// Only one of presentMatch, exactMatch, or regexMatch must be set.
  core.bool? presentMatch;

  /// The queryParameterMatch matches if the value of the parameter matches the
  /// regular expression specified by regexMatch.
  ///
  /// For more information about regular expression syntax, see Syntax. Only one
  /// of presentMatch, exactMatch, or regexMatch must be set. regexMatch only
  /// applies when the loadBalancingScheme is set to INTERNAL_SELF_MANAGED.
  core.String? regexMatch;

  HttpQueryParameterMatch({
    this.exactMatch,
    this.name,
    this.presentMatch,
    this.regexMatch,
  });

  HttpQueryParameterMatch.fromJson(core.Map json_)
      : this(
          exactMatch: json_.containsKey('exactMatch')
              ? json_['exactMatch'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          presentMatch: json_.containsKey('presentMatch')
              ? json_['presentMatch'] as core.bool
              : null,
          regexMatch: json_.containsKey('regexMatch')
              ? json_['regexMatch'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (exactMatch != null) 'exactMatch': exactMatch!,
        if (name != null) 'name': name!,
        if (presentMatch != null) 'presentMatch': presentMatch!,
        if (regexMatch != null) 'regexMatch': regexMatch!,
      };
}

/// Specifies settings for an HTTP redirect.
class HttpRedirectAction {
  /// The host that is used in the redirect response instead of the one that was
  /// supplied in the request.
  ///
  /// The value must be from 1 to 255 characters.
  core.String? hostRedirect;

  /// If set to true, the URL scheme in the redirected request is set to HTTPS.
  ///
  /// If set to false, the URL scheme of the redirected request remains the same
  /// as that of the request. This must only be set for URL maps used in
  /// TargetHttpProxys. Setting this true for TargetHttpsProxy is not permitted.
  /// The default is set to false.
  core.bool? httpsRedirect;

  /// The path that is used in the redirect response instead of the one that was
  /// supplied in the request.
  ///
  /// pathRedirect cannot be supplied together with prefixRedirect. Supply one
  /// alone or neither. If neither is supplied, the path of the original request
  /// is used for the redirect. The value must be from 1 to 1024 characters.
  core.String? pathRedirect;

  /// The prefix that replaces the prefixMatch specified in the
  /// HttpRouteRuleMatch, retaining the remaining portion of the URL before
  /// redirecting the request.
  ///
  /// prefixRedirect cannot be supplied together with pathRedirect. Supply one
  /// alone or neither. If neither is supplied, the path of the original request
  /// is used for the redirect. The value must be from 1 to 1024 characters.
  core.String? prefixRedirect;

  /// The HTTP Status code to use for this RedirectAction.
  ///
  /// Supported values are: - MOVED_PERMANENTLY_DEFAULT, which is the default
  /// value and corresponds to 301. - FOUND, which corresponds to 302. -
  /// SEE_OTHER which corresponds to 303. - TEMPORARY_REDIRECT, which
  /// corresponds to 307. In this case, the request method is retained. -
  /// PERMANENT_REDIRECT, which corresponds to 308. In this case, the request
  /// method is retained.
  /// Possible string values are:
  /// - "FOUND" : Http Status Code 302 - Found.
  /// - "MOVED_PERMANENTLY_DEFAULT" : Http Status Code 301 - Moved Permanently.
  /// - "PERMANENT_REDIRECT" : Http Status Code 308 - Permanent Redirect
  /// maintaining HTTP method.
  /// - "SEE_OTHER" : Http Status Code 303 - See Other.
  /// - "TEMPORARY_REDIRECT" : Http Status Code 307 - Temporary Redirect
  /// maintaining HTTP method.
  core.String? redirectResponseCode;

  /// If set to true, any accompanying query portion of the original URL is
  /// removed before redirecting the request.
  ///
  /// If set to false, the query portion of the original URL is retained. The
  /// default is set to false.
  core.bool? stripQuery;

  HttpRedirectAction({
    this.hostRedirect,
    this.httpsRedirect,
    this.pathRedirect,
    this.prefixRedirect,
    this.redirectResponseCode,
    this.stripQuery,
  });

  HttpRedirectAction.fromJson(core.Map json_)
      : this(
          hostRedirect: json_.containsKey('hostRedirect')
              ? json_['hostRedirect'] as core.String
              : null,
          httpsRedirect: json_.containsKey('httpsRedirect')
              ? json_['httpsRedirect'] as core.bool
              : null,
          pathRedirect: json_.containsKey('pathRedirect')
              ? json_['pathRedirect'] as core.String
              : null,
          prefixRedirect: json_.containsKey('prefixRedirect')
              ? json_['prefixRedirect'] as core.String
              : null,
          redirectResponseCode: json_.containsKey('redirectResponseCode')
              ? json_['redirectResponseCode'] as core.String
              : null,
          stripQuery: json_.containsKey('stripQuery')
              ? json_['stripQuery'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (hostRedirect != null) 'hostRedirect': hostRedirect!,
        if (httpsRedirect != null) 'httpsRedirect': httpsRedirect!,
        if (pathRedirect != null) 'pathRedirect': pathRedirect!,
        if (prefixRedirect != null) 'prefixRedirect': prefixRedirect!,
        if (redirectResponseCode != null)
          'redirectResponseCode': redirectResponseCode!,
        if (stripQuery != null) 'stripQuery': stripQuery!,
      };
}

/// The retry policy associates with HttpRouteRule
class HttpRetryPolicy {
  /// Specifies the allowed number retries.
  ///
  /// This number must be \> 0. If not specified, defaults to 1.
  core.int? numRetries;

  /// Specifies a non-zero timeout per retry attempt.
  ///
  /// If not specified, will use the timeout set in the HttpRouteAction field.
  /// If timeout in the HttpRouteAction field is not set, this field uses the
  /// largest timeout among all backend services associated with the route. Not
  /// supported when the URL map is bound to a target gRPC proxy that has the
  /// validateForProxyless field set to true.
  Duration? perTryTimeout;

  /// Specifies one or more conditions when this retry policy applies.
  ///
  /// Valid values are: - 5xx: retry is attempted if the instance or endpoint
  /// responds with any 5xx response code, or if the instance or endpoint does
  /// not respond at all. For example, disconnects, reset, read timeout,
  /// connection failure, and refused streams. - gateway-error: Similar to 5xx,
  /// but only applies to response codes 502, 503 or 504. - connect-failure: a
  /// retry is attempted on failures connecting to the instance or endpoint. For
  /// example, connection timeouts. - retriable-4xx: a retry is attempted if the
  /// instance or endpoint responds with a 4xx response code. The only error
  /// that you can retry is error code 409. - refused-stream: a retry is
  /// attempted if the instance or endpoint resets the stream with a
  /// REFUSED_STREAM error code. This reset type indicates that it is safe to
  /// retry. - cancelled: a retry is attempted if the gRPC status code in the
  /// response header is set to cancelled. - deadline-exceeded: a retry is
  /// attempted if the gRPC status code in the response header is set to
  /// deadline-exceeded. - internal: a retry is attempted if the gRPC status
  /// code in the response header is set to internal. - resource-exhausted: a
  /// retry is attempted if the gRPC status code in the response header is set
  /// to resource-exhausted. - unavailable: a retry is attempted if the gRPC
  /// status code in the response header is set to unavailable. Only the
  /// following codes are supported when the URL map is bound to target gRPC
  /// proxy that has validateForProxyless field set to true. - cancelled -
  /// deadline-exceeded - internal - resource-exhausted - unavailable
  core.List<core.String>? retryConditions;

  HttpRetryPolicy({
    this.numRetries,
    this.perTryTimeout,
    this.retryConditions,
  });

  HttpRetryPolicy.fromJson(core.Map json_)
      : this(
          numRetries: json_.containsKey('numRetries')
              ? json_['numRetries'] as core.int
              : null,
          perTryTimeout: json_.containsKey('perTryTimeout')
              ? Duration.fromJson(
                  json_['perTryTimeout'] as core.Map<core.String, core.dynamic>)
              : null,
          retryConditions: json_.containsKey('retryConditions')
              ? (json_['retryConditions'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (numRetries != null) 'numRetries': numRetries!,
        if (perTryTimeout != null) 'perTryTimeout': perTryTimeout!,
        if (retryConditions != null) 'retryConditions': retryConditions!,
      };
}

class HttpRouteAction {
  /// The specification for allowing client-side cross-origin requests.
  ///
  /// For more information about the W3C recommendation for cross-origin
  /// resource sharing (CORS), see Fetch API Living Standard. Not supported when
  /// the URL map is bound to a target gRPC proxy.
  CorsPolicy? corsPolicy;

  /// The specification for fault injection introduced into traffic to test the
  /// resiliency of clients to backend service failure.
  ///
  /// As part of fault injection, when clients send requests to a backend
  /// service, delays can be introduced by a load balancer on a percentage of
  /// requests before sending those requests to the backend service. Similarly
  /// requests from clients can be aborted by the load balancer for a percentage
  /// of requests. timeout and retry_policy is ignored by clients that are
  /// configured with a fault_injection_policy if: 1. The traffic is generated
  /// by fault injection AND 2. The fault injection is not a delay fault
  /// injection. Fault injection is not supported with the global external
  /// HTTP(S) load balancer (classic). To see which load balancers support fault
  /// injection, see Load balancing: Routing and traffic management features.
  HttpFaultInjection? faultInjectionPolicy;

  /// Specifies the maximum duration (timeout) for streams on the selected
  /// route.
  ///
  /// Unlike the timeout field where the timeout duration starts from the time
  /// the request has been fully processed (known as *end-of-stream*), the
  /// duration in this field is computed from the beginning of the stream until
  /// the response has been processed, including all retries. A stream that does
  /// not complete in this duration is closed. If not specified, this field uses
  /// the maximum maxStreamDuration value among all backend services associated
  /// with the route. This field is only allowed if the Url map is used with
  /// backend services with loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  Duration? maxStreamDuration;

  /// Specifies the policy on how requests intended for the route's backends are
  /// shadowed to a separate mirrored backend service.
  ///
  /// The load balancer does not wait for responses from the shadow service.
  /// Before sending traffic to the shadow service, the host / authority header
  /// is suffixed with -shadow. Not supported when the URL map is bound to a
  /// target gRPC proxy that has the validateForProxyless field set to true.
  RequestMirrorPolicy? requestMirrorPolicy;

  /// Specifies the retry policy associated with this route.
  HttpRetryPolicy? retryPolicy;

  /// Specifies the timeout for the selected route.
  ///
  /// Timeout is computed from the time the request has been fully processed
  /// (known as *end-of-stream*) up until the response has been processed.
  /// Timeout includes all retries. If not specified, this field uses the
  /// largest timeout among all backend services associated with the route. Not
  /// supported when the URL map is bound to a target gRPC proxy that has
  /// validateForProxyless field set to true.
  Duration? timeout;

  /// The spec to modify the URL of the request, before forwarding the request
  /// to the matched service.
  ///
  /// urlRewrite is the only action supported in UrlMaps for external HTTP(S)
  /// load balancers. Not supported when the URL map is bound to a target gRPC
  /// proxy that has the validateForProxyless field set to true.
  UrlRewrite? urlRewrite;

  /// A list of weighted backend services to send traffic to when a route match
  /// occurs.
  ///
  /// The weights determine the fraction of traffic that flows to their
  /// corresponding backend service. If all traffic needs to go to a single
  /// backend service, there must be one weightedBackendService with weight set
  /// to a non-zero number. After a backend service is identified and before
  /// forwarding the request to the backend service, advanced routing actions
  /// such as URL rewrites and header transformations are applied depending on
  /// additional settings specified in this HttpRouteAction.
  core.List<WeightedBackendService>? weightedBackendServices;

  HttpRouteAction({
    this.corsPolicy,
    this.faultInjectionPolicy,
    this.maxStreamDuration,
    this.requestMirrorPolicy,
    this.retryPolicy,
    this.timeout,
    this.urlRewrite,
    this.weightedBackendServices,
  });

  HttpRouteAction.fromJson(core.Map json_)
      : this(
          corsPolicy: json_.containsKey('corsPolicy')
              ? CorsPolicy.fromJson(
                  json_['corsPolicy'] as core.Map<core.String, core.dynamic>)
              : null,
          faultInjectionPolicy: json_.containsKey('faultInjectionPolicy')
              ? HttpFaultInjection.fromJson(json_['faultInjectionPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          maxStreamDuration: json_.containsKey('maxStreamDuration')
              ? Duration.fromJson(json_['maxStreamDuration']
                  as core.Map<core.String, core.dynamic>)
              : null,
          requestMirrorPolicy: json_.containsKey('requestMirrorPolicy')
              ? RequestMirrorPolicy.fromJson(json_['requestMirrorPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          retryPolicy: json_.containsKey('retryPolicy')
              ? HttpRetryPolicy.fromJson(
                  json_['retryPolicy'] as core.Map<core.String, core.dynamic>)
              : null,
          timeout: json_.containsKey('timeout')
              ? Duration.fromJson(
                  json_['timeout'] as core.Map<core.String, core.dynamic>)
              : null,
          urlRewrite: json_.containsKey('urlRewrite')
              ? UrlRewrite.fromJson(
                  json_['urlRewrite'] as core.Map<core.String, core.dynamic>)
              : null,
          weightedBackendServices: json_.containsKey('weightedBackendServices')
              ? (json_['weightedBackendServices'] as core.List)
                  .map((value) => WeightedBackendService.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (corsPolicy != null) 'corsPolicy': corsPolicy!,
        if (faultInjectionPolicy != null)
          'faultInjectionPolicy': faultInjectionPolicy!,
        if (maxStreamDuration != null) 'maxStreamDuration': maxStreamDuration!,
        if (requestMirrorPolicy != null)
          'requestMirrorPolicy': requestMirrorPolicy!,
        if (retryPolicy != null) 'retryPolicy': retryPolicy!,
        if (timeout != null) 'timeout': timeout!,
        if (urlRewrite != null) 'urlRewrite': urlRewrite!,
        if (weightedBackendServices != null)
          'weightedBackendServices': weightedBackendServices!,
      };
}

/// The HttpRouteRule setting specifies how to match an HTTP request and the
/// corresponding routing action that load balancing proxies perform.
class HttpRouteRule {
  /// The short description conveying the intent of this routeRule.
  ///
  /// The description can have a maximum length of 1024 characters.
  core.String? description;

  /// Specifies changes to request and response headers that need to take effect
  /// for the selected backendService.
  ///
  /// The headerAction value specified here is applied before the matching
  /// pathMatchers\[\].headerAction and after
  /// pathMatchers\[\].routeRules\[\].routeAction.weightedBackendService.backendServiceWeightAction\[\].headerAction
  /// HeaderAction is not supported for load balancers that have their
  /// loadBalancingScheme set to EXTERNAL. Not supported when the URL map is
  /// bound to a target gRPC proxy that has validateForProxyless field set to
  /// true.
  HttpHeaderAction? headerAction;

  /// The list of criteria for matching attributes of a request to this
  /// routeRule.
  ///
  /// This list has OR semantics: the request matches this routeRule when any of
  /// the matchRules are satisfied. However predicates within a given matchRule
  /// have AND semantics. All predicates within a matchRule must match for the
  /// request to match the rule.
  core.List<HttpRouteRuleMatch>? matchRules;

  /// For routeRules within a given pathMatcher, priority determines the order
  /// in which a load balancer interprets routeRules.
  ///
  /// RouteRules are evaluated in order of priority, from the lowest to highest
  /// number. The priority of a rule decreases as its number increases (1, 2, 3,
  /// N+1). The first rule that matches the request is applied. You cannot
  /// configure two or more routeRules with the same priority. Priority for each
  /// rule must be set to a number from 0 to 2147483647 inclusive. Priority
  /// numbers can have gaps, which enable you to add or remove rules in the
  /// future without affecting the rest of the rules. For example, 1, 2, 3, 4,
  /// 5, 9, 12, 16 is a valid series of priority numbers to which you could add
  /// rules numbered from 6 to 8, 10 to 11, and 13 to 15 in the future without
  /// any impact on existing rules.
  core.int? priority;

  /// In response to a matching matchRule, the load balancer performs advanced
  /// routing actions, such as URL rewrites and header transformations, before
  /// forwarding the request to the selected backend.
  ///
  /// If routeAction specifies any weightedBackendServices, service must not be
  /// set. Conversely if service is set, routeAction cannot contain any
  /// weightedBackendServices. Only one of urlRedirect, service or
  /// routeAction.weightedBackendService must be set. URL maps for Classic
  /// external HTTP(S) load balancers only support the urlRewrite action within
  /// a route rule's routeAction.
  HttpRouteAction? routeAction;

  /// The full or partial URL of the backend service resource to which traffic
  /// is directed if this rule is matched.
  ///
  /// If routeAction is also specified, advanced routing actions, such as URL
  /// rewrites, take effect before sending the request to the backend. However,
  /// if service is specified, routeAction cannot contain any
  /// weightedBackendServices. Conversely, if routeAction specifies any
  /// weightedBackendServices, service must not be specified. Only one of
  /// urlRedirect, service or routeAction.weightedBackendService must be set.
  core.String? service;

  /// When this rule is matched, the request is redirected to a URL specified by
  /// urlRedirect.
  ///
  /// If urlRedirect is specified, service or routeAction must not be set. Not
  /// supported when the URL map is bound to a target gRPC proxy.
  HttpRedirectAction? urlRedirect;

  HttpRouteRule({
    this.description,
    this.headerAction,
    this.matchRules,
    this.priority,
    this.routeAction,
    this.service,
    this.urlRedirect,
  });

  HttpRouteRule.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          headerAction: json_.containsKey('headerAction')
              ? HttpHeaderAction.fromJson(
                  json_['headerAction'] as core.Map<core.String, core.dynamic>)
              : null,
          matchRules: json_.containsKey('matchRules')
              ? (json_['matchRules'] as core.List)
                  .map((value) => HttpRouteRuleMatch.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          routeAction: json_.containsKey('routeAction')
              ? HttpRouteAction.fromJson(
                  json_['routeAction'] as core.Map<core.String, core.dynamic>)
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          urlRedirect: json_.containsKey('urlRedirect')
              ? HttpRedirectAction.fromJson(
                  json_['urlRedirect'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (headerAction != null) 'headerAction': headerAction!,
        if (matchRules != null) 'matchRules': matchRules!,
        if (priority != null) 'priority': priority!,
        if (routeAction != null) 'routeAction': routeAction!,
        if (service != null) 'service': service!,
        if (urlRedirect != null) 'urlRedirect': urlRedirect!,
      };
}

/// HttpRouteRuleMatch specifies a set of criteria for matching requests to an
/// HttpRouteRule.
///
/// All specified criteria must be satisfied for a match to occur.
class HttpRouteRuleMatch {
  /// For satisfying the matchRule condition, the path of the request must
  /// exactly match the value specified in fullPathMatch after removing any
  /// query parameters and anchor that may be part of the original URL.
  ///
  /// fullPathMatch must be from 1 to 1024 characters. Only one of prefixMatch,
  /// fullPathMatch or regexMatch must be specified.
  core.String? fullPathMatch;

  /// Specifies a list of header match criteria, all of which must match
  /// corresponding headers in the request.
  core.List<HttpHeaderMatch>? headerMatches;

  /// Specifies that prefixMatch and fullPathMatch matches are case sensitive.
  ///
  /// The default value is false. ignoreCase must not be used with regexMatch.
  /// Not supported when the URL map is bound to a target gRPC proxy.
  core.bool? ignoreCase;

  /// Opaque filter criteria used by the load balancer to restrict routing
  /// configuration to a limited set of xDS compliant clients.
  ///
  /// In their xDS requests to the load balancer, xDS clients present node
  /// metadata. When there is a match, the relevant routing configuration is
  /// made available to those proxies. For each metadataFilter in this list, if
  /// its filterMatchCriteria is set to MATCH_ANY, at least one of the
  /// filterLabels must match the corresponding label provided in the metadata.
  /// If its filterMatchCriteria is set to MATCH_ALL, then all of its
  /// filterLabels must match with corresponding labels provided in the
  /// metadata. If multiple metadata filters are specified, all of them need to
  /// be satisfied in order to be considered a match. metadataFilters specified
  /// here is applied after those specified in ForwardingRule that refers to the
  /// UrlMap this HttpRouteRuleMatch belongs to. metadataFilters only applies to
  /// load balancers that have loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  /// Not supported when the URL map is bound to a target gRPC proxy that has
  /// validateForProxyless field set to true.
  core.List<MetadataFilter>? metadataFilters;

  /// For satisfying the matchRule condition, the request's path must begin with
  /// the specified prefixMatch.
  ///
  /// prefixMatch must begin with a /. The value must be from 1 to 1024
  /// characters. Only one of prefixMatch, fullPathMatch or regexMatch must be
  /// specified.
  core.String? prefixMatch;

  /// Specifies a list of query parameter match criteria, all of which must
  /// match corresponding query parameters in the request.
  ///
  /// Not supported when the URL map is bound to a target gRPC proxy.
  core.List<HttpQueryParameterMatch>? queryParameterMatches;

  /// For satisfying the matchRule condition, the path of the request must
  /// satisfy the regular expression specified in regexMatch after removing any
  /// query parameters and anchor supplied with the original URL.
  ///
  /// For more information about regular expression syntax, see Syntax. Only one
  /// of prefixMatch, fullPathMatch or regexMatch must be specified. regexMatch
  /// only applies to load balancers that have loadBalancingScheme set to
  /// INTERNAL_SELF_MANAGED.
  core.String? regexMatch;

  HttpRouteRuleMatch({
    this.fullPathMatch,
    this.headerMatches,
    this.ignoreCase,
    this.metadataFilters,
    this.prefixMatch,
    this.queryParameterMatches,
    this.regexMatch,
  });

  HttpRouteRuleMatch.fromJson(core.Map json_)
      : this(
          fullPathMatch: json_.containsKey('fullPathMatch')
              ? json_['fullPathMatch'] as core.String
              : null,
          headerMatches: json_.containsKey('headerMatches')
              ? (json_['headerMatches'] as core.List)
                  .map((value) => HttpHeaderMatch.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          ignoreCase: json_.containsKey('ignoreCase')
              ? json_['ignoreCase'] as core.bool
              : null,
          metadataFilters: json_.containsKey('metadataFilters')
              ? (json_['metadataFilters'] as core.List)
                  .map((value) => MetadataFilter.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          prefixMatch: json_.containsKey('prefixMatch')
              ? json_['prefixMatch'] as core.String
              : null,
          queryParameterMatches: json_.containsKey('queryParameterMatches')
              ? (json_['queryParameterMatches'] as core.List)
                  .map((value) => HttpQueryParameterMatch.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          regexMatch: json_.containsKey('regexMatch')
              ? json_['regexMatch'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fullPathMatch != null) 'fullPathMatch': fullPathMatch!,
        if (headerMatches != null) 'headerMatches': headerMatches!,
        if (ignoreCase != null) 'ignoreCase': ignoreCase!,
        if (metadataFilters != null) 'metadataFilters': metadataFilters!,
        if (prefixMatch != null) 'prefixMatch': prefixMatch!,
        if (queryParameterMatches != null)
          'queryParameterMatches': queryParameterMatches!,
        if (regexMatch != null) 'regexMatch': regexMatch!,
      };
}

/// Represents a legacy HTTPS Health Check resource.
///
/// Legacy HTTPS health checks have been deprecated. If you are using a target
/// pool-based network load balancer, you must use a legacy HTTP (not HTTPS)
/// health check. For all other load balancers, including backend service-based
/// network load balancers, and for managed instance group auto-healing, you
/// must use modern (non-legacy) health checks. For more information, see Health
/// checks overview .
class HttpsHealthCheck {
  /// How often (in seconds) to send a health check.
  ///
  /// The default value is 5 seconds.
  core.int? checkIntervalSec;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// A so-far unhealthy instance will be marked healthy after this many
  /// consecutive successes.
  ///
  /// The default value is 2.
  core.int? healthyThreshold;

  /// The value of the host header in the HTTPS health check request.
  ///
  /// If left empty (default value), the public IP on behalf of which this
  /// health check is performed will be used.
  core.String? host;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The TCP port number for the HTTPS health check request.
  ///
  /// The default value is 443.
  core.int? port;

  /// The request path of the HTTPS health check request.
  ///
  /// The default value is "/".
  core.String? requestPath;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// How long (in seconds) to wait before claiming failure.
  ///
  /// The default value is 5 seconds. It is invalid for timeoutSec to have a
  /// greater value than checkIntervalSec.
  core.int? timeoutSec;

  /// A so-far healthy instance will be marked unhealthy after this many
  /// consecutive failures.
  ///
  /// The default value is 2.
  core.int? unhealthyThreshold;

  HttpsHealthCheck({
    this.checkIntervalSec,
    this.creationTimestamp,
    this.description,
    this.healthyThreshold,
    this.host,
    this.id,
    this.kind,
    this.name,
    this.port,
    this.requestPath,
    this.selfLink,
    this.timeoutSec,
    this.unhealthyThreshold,
  });

  HttpsHealthCheck.fromJson(core.Map json_)
      : this(
          checkIntervalSec: json_.containsKey('checkIntervalSec')
              ? json_['checkIntervalSec'] as core.int
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          healthyThreshold: json_.containsKey('healthyThreshold')
              ? json_['healthyThreshold'] as core.int
              : null,
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          requestPath: json_.containsKey('requestPath')
              ? json_['requestPath'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          timeoutSec: json_.containsKey('timeoutSec')
              ? json_['timeoutSec'] as core.int
              : null,
          unhealthyThreshold: json_.containsKey('unhealthyThreshold')
              ? json_['unhealthyThreshold'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (checkIntervalSec != null) 'checkIntervalSec': checkIntervalSec!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (healthyThreshold != null) 'healthyThreshold': healthyThreshold!,
        if (host != null) 'host': host!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (port != null) 'port': port!,
        if (requestPath != null) 'requestPath': requestPath!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (timeoutSec != null) 'timeoutSec': timeoutSec!,
        if (unhealthyThreshold != null)
          'unhealthyThreshold': unhealthyThreshold!,
      };
}

class HttpsHealthCheckListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  HttpsHealthCheckListWarningData({
    this.key,
    this.value,
  });

  HttpsHealthCheckListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class HttpsHealthCheckListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<HttpsHealthCheckListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  HttpsHealthCheckListWarning({
    this.code,
    this.data,
    this.message,
  });

  HttpsHealthCheckListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => HttpsHealthCheckListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of HttpsHealthCheck resources.
class HttpsHealthCheckList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of HttpsHealthCheck resources.
  core.List<HttpsHealthCheck>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  HttpsHealthCheckListWarning? warning;

  HttpsHealthCheckList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  HttpsHealthCheckList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => HttpsHealthCheck.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? HttpsHealthCheckListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// The parameters of the raw disk image.
class ImageRawDisk {
  /// The format used to encode and transmit the block device, which should be
  /// TAR.
  ///
  /// This is just a container and transmission format and not a runtime format.
  /// Provided by the client when the disk image is created.
  /// Possible string values are:
  /// - "TAR"
  core.String? containerType;

  /// This field is deprecated.
  ///
  /// An optional SHA1 checksum of the disk image before unpackaging provided by
  /// the client when the disk image is created.
  ///
  /// Deprecated.
  core.String? sha1Checksum;

  /// The full Google Cloud Storage URL where the raw disk image archive is
  /// stored.
  ///
  /// The following are valid formats for the URL: -
  /// https://storage.googleapis.com/bucket_name/image_archive_name -
  /// https://storage.googleapis.com/bucket_name/folder_name/ image_archive_name
  /// In order to create an image, you must provide the full or partial URL of
  /// one of the following: - The rawDisk.source URL - The sourceDisk URL - The
  /// sourceImage URL - The sourceSnapshot URL
  core.String? source;

  ImageRawDisk({
    this.containerType,
    this.sha1Checksum,
    this.source,
  });

  ImageRawDisk.fromJson(core.Map json_)
      : this(
          containerType: json_.containsKey('containerType')
              ? json_['containerType'] as core.String
              : null,
          sha1Checksum: json_.containsKey('sha1Checksum')
              ? json_['sha1Checksum'] as core.String
              : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (containerType != null) 'containerType': containerType!,
        if (sha1Checksum != null) 'sha1Checksum': sha1Checksum!,
        if (source != null) 'source': source!,
      };
}

/// Represents an Image resource.
///
/// You can use images to create boot disks for your VM instances. For more
/// information, read Images.
class Image {
  /// The architecture of the image.
  ///
  /// Valid values are ARM64 or X86_64.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// Size of the image tar.gz archive stored in Google Cloud Storage (in
  /// bytes).
  core.String? archiveSizeBytes;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this image.
  DeprecationStatus? deprecated;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Size of the image when restored onto a persistent disk (in GB).
  core.String? diskSizeGb;

  /// The name of the image family to which this image belongs.
  ///
  /// You can create disks by specifying an image family instead of a specific
  /// image name. The image family always returns its latest image that is not
  /// deprecated. The name of the image family must comply with RFC1035.
  core.String? family;

  /// A list of features to enable on the guest operating system.
  ///
  /// Applicable only for bootable images. To see a list of available options,
  /// see the guestOSfeatures\[\].type parameter.
  core.List<GuestOsFeature>? guestOsFeatures;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Encrypts the image using a customer-supplied encryption key.
  ///
  /// After you encrypt an image with a customer-supplied key, you must provide
  /// the same key if you use the image later (e.g. to create a disk from the
  /// image). Customer-supplied encryption keys do not protect access to
  /// metadata of the disk. If you do not provide an encryption key when
  /// creating the image, then the disk will be encrypted using an automatically
  /// generated key and you do not need to provide a key to use the image later.
  CustomerEncryptionKey? imageEncryptionKey;

  /// Type of the resource.
  ///
  /// Always compute#image for images.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this image, which is
  /// essentially a hash of the labels used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve an image.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels to apply to this image.
  ///
  /// These can be later modified by the setLabels method.
  core.Map<core.String, core.String>? labels;

  /// Integer license codes indicating which licenses are attached to this
  /// image.
  core.List<core.String>? licenseCodes;

  /// Any applicable license URI.
  core.List<core.String>? licenses;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// The parameters of the raw disk image.
  ImageRawDisk? rawDisk;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Set the secure boot keys of shielded instance.
  InitialStateConfig? shieldedInstanceInitialState;

  /// URL of the source disk used to create this image.
  ///
  /// For example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /disks/disk - projects/project/zones/zone/disks/disk -
  /// zones/zone/disks/disk In order to create an image, you must provide the
  /// full or partial URL of one of the following: - The rawDisk.source URL -
  /// The sourceDisk URL - The sourceImage URL - The sourceSnapshot URL
  core.String? sourceDisk;

  /// The customer-supplied encryption key of the source disk.
  ///
  /// Required if the source disk is protected by a customer-supplied encryption
  /// key.
  CustomerEncryptionKey? sourceDiskEncryptionKey;

  /// The ID value of the disk used to create this image.
  ///
  /// This value may be used to determine whether the image was taken from the
  /// current or a previous instance of a given disk name.
  ///
  /// Output only.
  core.String? sourceDiskId;

  /// URL of the source image used to create this image.
  ///
  /// The following are valid formats for the URL: -
  /// https://www.googleapis.com/compute/v1/projects/project_id/global/
  /// images/image_name - projects/project_id/global/images/image_name In order
  /// to create an image, you must provide the full or partial URL of one of the
  /// following: - The rawDisk.source URL - The sourceDisk URL - The sourceImage
  /// URL - The sourceSnapshot URL
  core.String? sourceImage;

  /// The customer-supplied encryption key of the source image.
  ///
  /// Required if the source image is protected by a customer-supplied
  /// encryption key.
  CustomerEncryptionKey? sourceImageEncryptionKey;

  /// The ID value of the image used to create this image.
  ///
  /// This value may be used to determine whether the image was taken from the
  /// current or a previous instance of a given image name.
  ///
  /// Output only.
  core.String? sourceImageId;

  /// URL of the source snapshot used to create this image.
  ///
  /// The following are valid formats for the URL: -
  /// https://www.googleapis.com/compute/v1/projects/project_id/global/
  /// snapshots/snapshot_name -
  /// projects/project_id/global/snapshots/snapshot_name In order to create an
  /// image, you must provide the full or partial URL of one of the following: -
  /// The rawDisk.source URL - The sourceDisk URL - The sourceImage URL - The
  /// sourceSnapshot URL
  core.String? sourceSnapshot;

  /// The customer-supplied encryption key of the source snapshot.
  ///
  /// Required if the source snapshot is protected by a customer-supplied
  /// encryption key.
  CustomerEncryptionKey? sourceSnapshotEncryptionKey;

  /// The ID value of the snapshot used to create this image.
  ///
  /// This value may be used to determine whether the snapshot was taken from
  /// the current or a previous instance of a given snapshot name.
  ///
  /// Output only.
  core.String? sourceSnapshotId;

  /// The type of the image used to create this disk.
  ///
  /// The default and only valid value is RAW.
  /// Possible string values are:
  /// - "RAW"
  core.String? sourceType;

  /// The status of the image.
  ///
  /// An image can be used to create other resources, such as instances, only
  /// after the image has been successfully created and the status is set to
  /// READY. Possible values are FAILED, PENDING, or READY.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DELETING" : Image is deleting.
  /// - "FAILED" : Image creation failed due to an error.
  /// - "PENDING" : Image hasn't been created as yet.
  /// - "READY" : Image has been successfully created.
  core.String? status;

  /// Cloud Storage bucket storage location of the image (regional or
  /// multi-regional).
  core.List<core.String>? storageLocations;

  Image({
    this.architecture,
    this.archiveSizeBytes,
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.diskSizeGb,
    this.family,
    this.guestOsFeatures,
    this.id,
    this.imageEncryptionKey,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.licenseCodes,
    this.licenses,
    this.name,
    this.rawDisk,
    this.satisfiesPzs,
    this.selfLink,
    this.shieldedInstanceInitialState,
    this.sourceDisk,
    this.sourceDiskEncryptionKey,
    this.sourceDiskId,
    this.sourceImage,
    this.sourceImageEncryptionKey,
    this.sourceImageId,
    this.sourceSnapshot,
    this.sourceSnapshotEncryptionKey,
    this.sourceSnapshotId,
    this.sourceType,
    this.status,
    this.storageLocations,
  });

  Image.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          archiveSizeBytes: json_.containsKey('archiveSizeBytes')
              ? json_['archiveSizeBytes'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          family: json_.containsKey('family')
              ? json_['family'] as core.String
              : null,
          guestOsFeatures: json_.containsKey('guestOsFeatures')
              ? (json_['guestOsFeatures'] as core.List)
                  .map((value) => GuestOsFeature.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          imageEncryptionKey: json_.containsKey('imageEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['imageEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          licenseCodes: json_.containsKey('licenseCodes')
              ? (json_['licenseCodes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          rawDisk: json_.containsKey('rawDisk')
              ? ImageRawDisk.fromJson(
                  json_['rawDisk'] as core.Map<core.String, core.dynamic>)
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          shieldedInstanceInitialState:
              json_.containsKey('shieldedInstanceInitialState')
                  ? InitialStateConfig.fromJson(
                      json_['shieldedInstanceInitialState']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          sourceDisk: json_.containsKey('sourceDisk')
              ? json_['sourceDisk'] as core.String
              : null,
          sourceDiskEncryptionKey: json_.containsKey('sourceDiskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['sourceDiskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceDiskId: json_.containsKey('sourceDiskId')
              ? json_['sourceDiskId'] as core.String
              : null,
          sourceImage: json_.containsKey('sourceImage')
              ? json_['sourceImage'] as core.String
              : null,
          sourceImageEncryptionKey: json_
                  .containsKey('sourceImageEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['sourceImageEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceImageId: json_.containsKey('sourceImageId')
              ? json_['sourceImageId'] as core.String
              : null,
          sourceSnapshot: json_.containsKey('sourceSnapshot')
              ? json_['sourceSnapshot'] as core.String
              : null,
          sourceSnapshotEncryptionKey:
              json_.containsKey('sourceSnapshotEncryptionKey')
                  ? CustomerEncryptionKey.fromJson(
                      json_['sourceSnapshotEncryptionKey']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          sourceSnapshotId: json_.containsKey('sourceSnapshotId')
              ? json_['sourceSnapshotId'] as core.String
              : null,
          sourceType: json_.containsKey('sourceType')
              ? json_['sourceType'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          storageLocations: json_.containsKey('storageLocations')
              ? (json_['storageLocations'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (archiveSizeBytes != null) 'archiveSizeBytes': archiveSizeBytes!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (family != null) 'family': family!,
        if (guestOsFeatures != null) 'guestOsFeatures': guestOsFeatures!,
        if (id != null) 'id': id!,
        if (imageEncryptionKey != null)
          'imageEncryptionKey': imageEncryptionKey!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (licenseCodes != null) 'licenseCodes': licenseCodes!,
        if (licenses != null) 'licenses': licenses!,
        if (name != null) 'name': name!,
        if (rawDisk != null) 'rawDisk': rawDisk!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (shieldedInstanceInitialState != null)
          'shieldedInstanceInitialState': shieldedInstanceInitialState!,
        if (sourceDisk != null) 'sourceDisk': sourceDisk!,
        if (sourceDiskEncryptionKey != null)
          'sourceDiskEncryptionKey': sourceDiskEncryptionKey!,
        if (sourceDiskId != null) 'sourceDiskId': sourceDiskId!,
        if (sourceImage != null) 'sourceImage': sourceImage!,
        if (sourceImageEncryptionKey != null)
          'sourceImageEncryptionKey': sourceImageEncryptionKey!,
        if (sourceImageId != null) 'sourceImageId': sourceImageId!,
        if (sourceSnapshot != null) 'sourceSnapshot': sourceSnapshot!,
        if (sourceSnapshotEncryptionKey != null)
          'sourceSnapshotEncryptionKey': sourceSnapshotEncryptionKey!,
        if (sourceSnapshotId != null) 'sourceSnapshotId': sourceSnapshotId!,
        if (sourceType != null) 'sourceType': sourceType!,
        if (status != null) 'status': status!,
        if (storageLocations != null) 'storageLocations': storageLocations!,
      };
}

class ImageFamilyView {
  /// The latest image that is part of the specified image family in the
  /// requested location, and that is not deprecated.
  Image? image;

  ImageFamilyView({
    this.image,
  });

  ImageFamilyView.fromJson(core.Map json_)
      : this(
          image: json_.containsKey('image')
              ? Image.fromJson(
                  json_['image'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (image != null) 'image': image!,
      };
}

class ImageListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ImageListWarningData({
    this.key,
    this.value,
  });

  ImageListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ImageListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ImageListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ImageListWarning({
    this.code,
    this.data,
    this.message,
  });

  ImageListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ImageListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of images.
class ImageList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Image resources.
  core.List<Image>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ImageListWarning? warning;

  ImageList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ImageList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Image.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ImageListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Initial State for shielded instance, these are public keys which are safe to
/// store in public
class InitialStateConfig {
  /// The Key Database (db).
  core.List<FileContentBuffer>? dbs;

  /// The forbidden key database (dbx).
  core.List<FileContentBuffer>? dbxs;

  /// The Key Exchange Key (KEK).
  core.List<FileContentBuffer>? keks;

  /// The Platform Key (PK).
  FileContentBuffer? pk;

  InitialStateConfig({
    this.dbs,
    this.dbxs,
    this.keks,
    this.pk,
  });

  InitialStateConfig.fromJson(core.Map json_)
      : this(
          dbs: json_.containsKey('dbs')
              ? (json_['dbs'] as core.List)
                  .map((value) => FileContentBuffer.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          dbxs: json_.containsKey('dbxs')
              ? (json_['dbxs'] as core.List)
                  .map((value) => FileContentBuffer.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          keks: json_.containsKey('keks')
              ? (json_['keks'] as core.List)
                  .map((value) => FileContentBuffer.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          pk: json_.containsKey('pk')
              ? FileContentBuffer.fromJson(
                  json_['pk'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (dbs != null) 'dbs': dbs!,
        if (dbxs != null) 'dbxs': dbxs!,
        if (keks != null) 'keks': keks!,
        if (pk != null) 'pk': pk!,
      };
}

/// Represents an Instance resource.
///
/// An instance is a virtual machine that is hosted on Google Cloud Platform.
/// For more information, read Virtual Machine Instances.
class Instance {
  /// Controls for advanced machine-related behavior features.
  AdvancedMachineFeatures? advancedMachineFeatures;

  /// Allows this instance to send and receive packets with non-matching
  /// destination or source IPs.
  ///
  /// This is required if you plan to use this instance to forward routes. For
  /// more information, see Enabling IP Forwarding .
  core.bool? canIpForward;
  ConfidentialInstanceConfig? confidentialInstanceConfig;

  /// The CPU platform used by this instance.
  ///
  /// Output only.
  core.String? cpuPlatform;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Whether the resource should be protected against deletion.
  core.bool? deletionProtection;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Array of disks associated with this instance.
  ///
  /// Persistent disks must be created before you can assign them.
  core.List<AttachedDisk>? disks;

  /// Enables display device for the instance.
  DisplayDevice? displayDevice;

  /// Specifies a fingerprint for this resource, which is essentially a hash of
  /// the instance's contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update the instance. You must always provide an
  /// up-to-date fingerprint hash in order to update the instance. To see the
  /// latest fingerprint, make get() request to the instance.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// A list of the type and count of accelerator cards attached to the
  /// instance.
  core.List<AcceleratorConfig>? guestAccelerators;

  /// Specifies the hostname of the instance.
  ///
  /// The specified hostname must be RFC1035 compliant. If hostname is not
  /// specified, the default hostname is
  /// \[INSTANCE_NAME\].c.\[PROJECT_ID\].internal when using the global DNS, and
  /// \[INSTANCE_NAME\].\[ZONE\].c.\[PROJECT_ID\].internal when using zonal DNS.
  core.String? hostname;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// KeyRevocationActionType of the instance.
  ///
  /// Supported options are "STOP" and "NONE". The default value is "NONE" if it
  /// is not specified.
  /// Possible string values are:
  /// - "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED" : Default value. This value is
  /// unused.
  /// - "NONE" : Indicates user chose no operation.
  /// - "STOP" : Indicates user chose to opt for VM shutdown on key revocation.
  core.String? keyRevocationActionType;

  /// Type of the resource.
  ///
  /// Always compute#instance for instances.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for this request, which is essentially a hash of the label's
  /// contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels. To see
  /// the latest fingerprint, make get() request to the instance.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels to apply to this instance.
  ///
  /// These can be later modified by the setLabels method.
  core.Map<core.String, core.String>? labels;

  /// Last start timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastStartTimestamp;

  /// Last stop timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastStopTimestamp;

  /// Last suspended timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastSuspendedTimestamp;

  /// Full or partial URL of the machine type resource to use for this instance,
  /// in the format: zones/zone/machineTypes/machine-type.
  ///
  /// This is provided by the client when the instance is created. For example,
  /// the following is a valid partial url to a predefined machine type:
  /// zones/us-central1-f/machineTypes/n1-standard-1 To create a custom machine
  /// type, provide a URL to a machine type in the following format, where CPUS
  /// is 1 or an even number up to 32 (2, 4, 6, ... 24, etc), and MEMORY is the
  /// total memory for this instance. Memory must be a multiple of 256 MB and
  /// must be supplied in MB (e.g. 5 GB of memory is 5120 MB):
  /// zones/zone/machineTypes/custom-CPUS-MEMORY For example:
  /// zones/us-central1-f/machineTypes/custom-4-5120 For a full list of
  /// restrictions, read the Specifications for custom machine types.
  core.String? machineType;

  /// The metadata key/value pairs assigned to this instance.
  ///
  /// This includes custom metadata and predefined keys.
  Metadata? metadata;

  /// Specifies a minimum CPU platform for the VM instance.
  ///
  /// Applicable values are the friendly names of CPU platforms, such as
  /// minCpuPlatform: "Intel Haswell" or minCpuPlatform: "Intel Sandy Bridge".
  core.String? minCpuPlatform;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The resource name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// An array of network configurations for this instance.
  ///
  /// These specify how interfaces are configured to interact with other network
  /// services, such as connecting to the internet. Multiple interfaces are
  /// supported per instance.
  core.List<NetworkInterface>? networkInterfaces;
  NetworkPerformanceConfig? networkPerformanceConfig;

  /// Input only.
  ///
  /// \[Input Only\] Additional params passed with the request, but not
  /// persisted as part of resource payload.
  InstanceParams? params;

  /// The private IPv6 google access type for the VM.
  ///
  /// If not specified, use INHERIT_FROM_SUBNETWORK as default.
  /// Possible string values are:
  /// - "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE" : Bidirectional private IPv6
  /// access to/from Google services. If specified, the subnetwork who is
  /// attached to the instance's default network interface will be assigned an
  /// internal IPv6 prefix if it doesn't have before.
  /// - "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE" : Outbound private IPv6 access
  /// from VMs in this subnet to Google services. If specified, the subnetwork
  /// who is attached to the instance's default network interface will be
  /// assigned an internal IPv6 prefix if it doesn't have before.
  /// - "INHERIT_FROM_SUBNETWORK" : Each network interface inherits
  /// PrivateIpv6GoogleAccess from its subnetwork.
  core.String? privateIpv6GoogleAccess;

  /// Specifies the reservations that this instance can consume from.
  ReservationAffinity? reservationAffinity;

  /// Resource policies applied to this instance.
  core.List<core.String>? resourcePolicies;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Sets the scheduling options for this instance.
  Scheduling? scheduling;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// A list of service accounts, with their specified scopes, authorized for
  /// this instance.
  ///
  /// Only one service account per VM instance is supported. Service accounts
  /// generate access tokens that can be accessed through the metadata server
  /// and used to authenticate applications on the instance. See Service
  /// Accounts for more information.
  core.List<ServiceAccount>? serviceAccounts;
  ShieldedInstanceConfig? shieldedInstanceConfig;
  ShieldedInstanceIntegrityPolicy? shieldedInstanceIntegrityPolicy;

  /// Source machine image
  core.String? sourceMachineImage;

  /// Source machine image encryption key when creating an instance from a
  /// machine image.
  CustomerEncryptionKey? sourceMachineImageEncryptionKey;

  /// Whether a VM has been restricted for start because Compute Engine has
  /// detected suspicious activity.
  ///
  /// Output only.
  core.bool? startRestricted;

  /// The status of the instance.
  ///
  /// One of the following values: PROVISIONING, STAGING, RUNNING, STOPPING,
  /// SUSPENDING, SUSPENDED, REPAIRING, and TERMINATED. For more information
  /// about the status of the instance, see Instance life cycle.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DEPROVISIONING" : The Nanny is halted and we are performing tear down
  /// tasks like network deprogramming, releasing quota, IP, tearing down disks
  /// etc.
  /// - "PROVISIONING" : Resources are being allocated for the instance.
  /// - "REPAIRING" : The instance is in repair.
  /// - "RUNNING" : The instance is running.
  /// - "STAGING" : All required resources have been allocated and the instance
  /// is being started.
  /// - "STOPPED" : The instance has stopped successfully.
  /// - "STOPPING" : The instance is currently stopping (either being deleted or
  /// killed).
  /// - "SUSPENDED" : The instance has suspended.
  /// - "SUSPENDING" : The instance is suspending.
  /// - "TERMINATED" : The instance has stopped (either by explicit action or
  /// underlying failure).
  core.String? status;

  /// An optional, human-readable explanation of the status.
  ///
  /// Output only.
  core.String? statusMessage;

  /// Tags to apply to this instance.
  ///
  /// Tags are used to identify valid sources or targets for network firewalls
  /// and are specified by the client during instance creation. The tags can be
  /// later modified by the setTags method. Each tag within the list must comply
  /// with RFC1035. Multiple tags can be specified via the 'tags.items' field.
  Tags? tags;

  /// URL of the zone where the instance resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? zone;

  Instance({
    this.advancedMachineFeatures,
    this.canIpForward,
    this.confidentialInstanceConfig,
    this.cpuPlatform,
    this.creationTimestamp,
    this.deletionProtection,
    this.description,
    this.disks,
    this.displayDevice,
    this.fingerprint,
    this.guestAccelerators,
    this.hostname,
    this.id,
    this.keyRevocationActionType,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.lastStartTimestamp,
    this.lastStopTimestamp,
    this.lastSuspendedTimestamp,
    this.machineType,
    this.metadata,
    this.minCpuPlatform,
    this.name,
    this.networkInterfaces,
    this.networkPerformanceConfig,
    this.params,
    this.privateIpv6GoogleAccess,
    this.reservationAffinity,
    this.resourcePolicies,
    this.satisfiesPzs,
    this.scheduling,
    this.selfLink,
    this.serviceAccounts,
    this.shieldedInstanceConfig,
    this.shieldedInstanceIntegrityPolicy,
    this.sourceMachineImage,
    this.sourceMachineImageEncryptionKey,
    this.startRestricted,
    this.status,
    this.statusMessage,
    this.tags,
    this.zone,
  });

  Instance.fromJson(core.Map json_)
      : this(
          advancedMachineFeatures: json_.containsKey('advancedMachineFeatures')
              ? AdvancedMachineFeatures.fromJson(
                  json_['advancedMachineFeatures']
                      as core.Map<core.String, core.dynamic>)
              : null,
          canIpForward: json_.containsKey('canIpForward')
              ? json_['canIpForward'] as core.bool
              : null,
          confidentialInstanceConfig:
              json_.containsKey('confidentialInstanceConfig')
                  ? ConfidentialInstanceConfig.fromJson(
                      json_['confidentialInstanceConfig']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          cpuPlatform: json_.containsKey('cpuPlatform')
              ? json_['cpuPlatform'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deletionProtection: json_.containsKey('deletionProtection')
              ? json_['deletionProtection'] as core.bool
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => AttachedDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          displayDevice: json_.containsKey('displayDevice')
              ? DisplayDevice.fromJson(
                  json_['displayDevice'] as core.Map<core.String, core.dynamic>)
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          guestAccelerators: json_.containsKey('guestAccelerators')
              ? (json_['guestAccelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          hostname: json_.containsKey('hostname')
              ? json_['hostname'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          keyRevocationActionType: json_.containsKey('keyRevocationActionType')
              ? json_['keyRevocationActionType'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          lastStartTimestamp: json_.containsKey('lastStartTimestamp')
              ? json_['lastStartTimestamp'] as core.String
              : null,
          lastStopTimestamp: json_.containsKey('lastStopTimestamp')
              ? json_['lastStopTimestamp'] as core.String
              : null,
          lastSuspendedTimestamp: json_.containsKey('lastSuspendedTimestamp')
              ? json_['lastSuspendedTimestamp'] as core.String
              : null,
          machineType: json_.containsKey('machineType')
              ? json_['machineType'] as core.String
              : null,
          metadata: json_.containsKey('metadata')
              ? Metadata.fromJson(
                  json_['metadata'] as core.Map<core.String, core.dynamic>)
              : null,
          minCpuPlatform: json_.containsKey('minCpuPlatform')
              ? json_['minCpuPlatform'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          networkInterfaces: json_.containsKey('networkInterfaces')
              ? (json_['networkInterfaces'] as core.List)
                  .map((value) => NetworkInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          networkPerformanceConfig:
              json_.containsKey('networkPerformanceConfig')
                  ? NetworkPerformanceConfig.fromJson(
                      json_['networkPerformanceConfig']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          params: json_.containsKey('params')
              ? InstanceParams.fromJson(
                  json_['params'] as core.Map<core.String, core.dynamic>)
              : null,
          privateIpv6GoogleAccess: json_.containsKey('privateIpv6GoogleAccess')
              ? json_['privateIpv6GoogleAccess'] as core.String
              : null,
          reservationAffinity: json_.containsKey('reservationAffinity')
              ? ReservationAffinity.fromJson(json_['reservationAffinity']
                  as core.Map<core.String, core.dynamic>)
              : null,
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          scheduling: json_.containsKey('scheduling')
              ? Scheduling.fromJson(
                  json_['scheduling'] as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          serviceAccounts: json_.containsKey('serviceAccounts')
              ? (json_['serviceAccounts'] as core.List)
                  .map((value) => ServiceAccount.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          shieldedInstanceConfig: json_.containsKey('shieldedInstanceConfig')
              ? ShieldedInstanceConfig.fromJson(json_['shieldedInstanceConfig']
                  as core.Map<core.String, core.dynamic>)
              : null,
          shieldedInstanceIntegrityPolicy:
              json_.containsKey('shieldedInstanceIntegrityPolicy')
                  ? ShieldedInstanceIntegrityPolicy.fromJson(
                      json_['shieldedInstanceIntegrityPolicy']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          sourceMachineImage: json_.containsKey('sourceMachineImage')
              ? json_['sourceMachineImage'] as core.String
              : null,
          sourceMachineImageEncryptionKey:
              json_.containsKey('sourceMachineImageEncryptionKey')
                  ? CustomerEncryptionKey.fromJson(
                      json_['sourceMachineImageEncryptionKey']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          startRestricted: json_.containsKey('startRestricted')
              ? json_['startRestricted'] as core.bool
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          statusMessage: json_.containsKey('statusMessage')
              ? json_['statusMessage'] as core.String
              : null,
          tags: json_.containsKey('tags')
              ? Tags.fromJson(
                  json_['tags'] as core.Map<core.String, core.dynamic>)
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (advancedMachineFeatures != null)
          'advancedMachineFeatures': advancedMachineFeatures!,
        if (canIpForward != null) 'canIpForward': canIpForward!,
        if (confidentialInstanceConfig != null)
          'confidentialInstanceConfig': confidentialInstanceConfig!,
        if (cpuPlatform != null) 'cpuPlatform': cpuPlatform!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deletionProtection != null)
          'deletionProtection': deletionProtection!,
        if (description != null) 'description': description!,
        if (disks != null) 'disks': disks!,
        if (displayDevice != null) 'displayDevice': displayDevice!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (guestAccelerators != null) 'guestAccelerators': guestAccelerators!,
        if (hostname != null) 'hostname': hostname!,
        if (id != null) 'id': id!,
        if (keyRevocationActionType != null)
          'keyRevocationActionType': keyRevocationActionType!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (lastStartTimestamp != null)
          'lastStartTimestamp': lastStartTimestamp!,
        if (lastStopTimestamp != null) 'lastStopTimestamp': lastStopTimestamp!,
        if (lastSuspendedTimestamp != null)
          'lastSuspendedTimestamp': lastSuspendedTimestamp!,
        if (machineType != null) 'machineType': machineType!,
        if (metadata != null) 'metadata': metadata!,
        if (minCpuPlatform != null) 'minCpuPlatform': minCpuPlatform!,
        if (name != null) 'name': name!,
        if (networkInterfaces != null) 'networkInterfaces': networkInterfaces!,
        if (networkPerformanceConfig != null)
          'networkPerformanceConfig': networkPerformanceConfig!,
        if (params != null) 'params': params!,
        if (privateIpv6GoogleAccess != null)
          'privateIpv6GoogleAccess': privateIpv6GoogleAccess!,
        if (reservationAffinity != null)
          'reservationAffinity': reservationAffinity!,
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (scheduling != null) 'scheduling': scheduling!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (serviceAccounts != null) 'serviceAccounts': serviceAccounts!,
        if (shieldedInstanceConfig != null)
          'shieldedInstanceConfig': shieldedInstanceConfig!,
        if (shieldedInstanceIntegrityPolicy != null)
          'shieldedInstanceIntegrityPolicy': shieldedInstanceIntegrityPolicy!,
        if (sourceMachineImage != null)
          'sourceMachineImage': sourceMachineImage!,
        if (sourceMachineImageEncryptionKey != null)
          'sourceMachineImageEncryptionKey': sourceMachineImageEncryptionKey!,
        if (startRestricted != null) 'startRestricted': startRestricted!,
        if (status != null) 'status': status!,
        if (statusMessage != null) 'statusMessage': statusMessage!,
        if (tags != null) 'tags': tags!,
        if (zone != null) 'zone': zone!,
      };
}

class InstanceAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceAggregatedListWarningData({
    this.key,
    this.value,
  });

  InstanceAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// An object that contains a list of instances scoped by zone.
  core.Map<core.String, InstancesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#instanceAggregatedList for aggregated lists of Instance
  /// resources.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceAggregatedListWarning? warning;

  InstanceAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  InstanceAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    InstancesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstanceAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceConsumptionData {
  /// Resources consumed by the instance.
  InstanceConsumptionInfo? consumptionInfo;

  /// Server-defined URL for the instance.
  core.String? instance;

  InstanceConsumptionData({
    this.consumptionInfo,
    this.instance,
  });

  InstanceConsumptionData.fromJson(core.Map json_)
      : this(
          consumptionInfo: json_.containsKey('consumptionInfo')
              ? InstanceConsumptionInfo.fromJson(json_['consumptionInfo']
                  as core.Map<core.String, core.dynamic>)
              : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (consumptionInfo != null) 'consumptionInfo': consumptionInfo!,
        if (instance != null) 'instance': instance!,
      };
}

class InstanceConsumptionInfo {
  /// The number of virtual CPUs that are available to the instance.
  core.int? guestCpus;

  /// The amount of local SSD storage available to the instance, defined in GiB.
  core.int? localSsdGb;

  /// The amount of physical memory available to the instance, defined in MiB.
  core.int? memoryMb;

  /// The minimal guaranteed number of virtual CPUs that are reserved.
  core.int? minNodeCpus;

  InstanceConsumptionInfo({
    this.guestCpus,
    this.localSsdGb,
    this.memoryMb,
    this.minNodeCpus,
  });

  InstanceConsumptionInfo.fromJson(core.Map json_)
      : this(
          guestCpus: json_.containsKey('guestCpus')
              ? json_['guestCpus'] as core.int
              : null,
          localSsdGb: json_.containsKey('localSsdGb')
              ? json_['localSsdGb'] as core.int
              : null,
          memoryMb: json_.containsKey('memoryMb')
              ? json_['memoryMb'] as core.int
              : null,
          minNodeCpus: json_.containsKey('minNodeCpus')
              ? json_['minNodeCpus'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (guestCpus != null) 'guestCpus': guestCpus!,
        if (localSsdGb != null) 'localSsdGb': localSsdGb!,
        if (memoryMb != null) 'memoryMb': memoryMb!,
        if (minNodeCpus != null) 'minNodeCpus': minNodeCpus!,
      };
}

/// Represents an Instance Group resource.
///
/// Instance Groups can be used to configure a target for load balancing.
/// Instance groups can either be managed or unmanaged. To create managed
/// instance groups, use the instanceGroupManager or regionInstanceGroupManager
/// resource instead. Use zonal unmanaged instance groups if you need to apply
/// load balancing to groups of heterogeneous instances or if you need to manage
/// the instances yourself. You cannot create regional unmanaged instance
/// groups. For more information, read Instance groups.
class InstanceGroup {
  /// The creation timestamp for this instance group in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The fingerprint of the named ports.
  ///
  /// The system uses this fingerprint to detect conflicts when multiple users
  /// change the named ports concurrently.
  ///
  /// Output only.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// A unique identifier for this instance group, generated by the server.
  ///
  /// Output only.
  core.String? id;

  /// The resource type, which is always compute#instanceGroup for instance
  /// groups.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the instance group.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  core.String? name;

  ///  Assigns a name to a port number.
  ///
  /// For example: {name: "http", port: 80} This allows the system to reference
  /// ports by the assigned name instead of a port number. Named ports can also
  /// contain multiple ports. For example: \[{name: "app1", port: 8080}, {name:
  /// "app1", port: 8081}, {name: "app2", port: 8082}\] Named ports apply to all
  /// instances in this instance group.
  core.List<NamedPort>? namedPorts;

  /// The URL of the network to which all instances in the instance group
  /// belong.
  ///
  /// If your instance has multiple network interfaces, then the network and
  /// subnetwork fields only refer to the network and subnet used by your
  /// primary interface (nic0).
  ///
  /// Output only.
  core.String? network;

  /// The URL of the region where the instance group is located (for regional
  /// resources).
  ///
  /// Output only.
  core.String? region;

  /// The URL for this instance group.
  ///
  /// The server generates this URL.
  ///
  /// Output only.
  core.String? selfLink;

  /// The total number of instances in the instance group.
  ///
  /// Output only.
  core.int? size;

  /// The URL of the subnetwork to which all instances in the instance group
  /// belong.
  ///
  /// If your instance has multiple network interfaces, then the network and
  /// subnetwork fields only refer to the network and subnet used by your
  /// primary interface (nic0).
  ///
  /// Output only.
  core.String? subnetwork;

  /// The URL of the zone where the instance group is located (for zonal
  /// resources).
  ///
  /// Output only.
  core.String? zone;

  InstanceGroup({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.namedPorts,
    this.network,
    this.region,
    this.selfLink,
    this.size,
    this.subnetwork,
    this.zone,
  });

  InstanceGroup.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          namedPorts: json_.containsKey('namedPorts')
              ? (json_['namedPorts'] as core.List)
                  .map((value) => NamedPort.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          size: json_.containsKey('size') ? json_['size'] as core.int : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (namedPorts != null) 'namedPorts': namedPorts!,
        if (network != null) 'network': network!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (size != null) 'size': size!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
        if (zone != null) 'zone': zone!,
      };
}

class InstanceGroupAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupAggregatedListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InstanceGroupAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroupsScopedList resources.
  core.Map<core.String, InstanceGroupsScopedList>? items;

  /// The resource type, which is always compute#instanceGroupAggregatedList for
  /// aggregated lists of instance groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupAggregatedListWarning? warning;

  InstanceGroupAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  InstanceGroupAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    InstanceGroupsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceGroupListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of InstanceGroup resources.
class InstanceGroupList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroup resources.
  core.List<InstanceGroup>? items;

  /// The resource type, which is always compute#instanceGroupList for instance
  /// group lists.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupListWarning? warning;

  InstanceGroupList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceGroupList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Managed Instance Group resource.
///
/// An instance group is a collection of VM instances that you can manage as a
/// single entity. For more information, read Instance groups. For zonal Managed
/// Instance Group, use the instanceGroupManagers resource. For regional Managed
/// Instance Group, use the regionInstanceGroupManagers resource.
class InstanceGroupManager {
  /// The autohealing policy for this managed instance group.
  ///
  /// You can specify only one value.
  core.List<InstanceGroupManagerAutoHealingPolicy>? autoHealingPolicies;

  /// The base instance name to use for instances in this group.
  ///
  /// The value must be 1-58 characters long. Instances are named by appending a
  /// hyphen and a random four-character string to the base instance name. The
  /// base instance name must comply with RFC1035.
  core.String? baseInstanceName;

  /// The creation timestamp for this managed instance group in RFC3339 text
  /// format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The list of instance actions and the number of instances in this managed
  /// instance group that are scheduled for each of those actions.
  ///
  /// Output only.
  InstanceGroupManagerActionsSummary? currentActions;

  /// An optional description of this resource.
  core.String? description;

  /// Policy specifying the intended distribution of managed instances across
  /// zones in a regional managed instance group.
  DistributionPolicy? distributionPolicy;

  /// Fingerprint of this resource.
  ///
  /// This field may be used in optimistic locking. It will be ignored when
  /// inserting an InstanceGroupManager. An up-to-date fingerprint must be
  /// provided in order to update the InstanceGroupManager, otherwise the
  /// request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve an InstanceGroupManager.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// A unique identifier for this resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// The URL of the Instance Group resource.
  ///
  /// Output only.
  core.String? instanceGroup;

  /// The URL of the instance template that is specified for this managed
  /// instance group.
  ///
  /// The group uses this template to create all new instances in the managed
  /// instance group. The templates for existing instances in the group do not
  /// change unless you run recreateInstances, run applyUpdatesToInstances, or
  /// set the group's updatePolicy.type to PROACTIVE.
  core.String? instanceTemplate;

  /// The resource type, which is always compute#instanceGroupManager for
  /// managed instance groups.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the managed instance group.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  core.String? name;

  /// Named ports configured for the Instance Groups complementary to this
  /// Instance Group Manager.
  core.List<NamedPort>? namedPorts;

  /// The URL of the region where the managed instance group resides (for
  /// regional resources).
  ///
  /// Output only.
  core.String? region;

  /// The URL for this managed instance group.
  ///
  /// The server defines this URL.
  ///
  /// Output only.
  core.String? selfLink;

  /// Stateful configuration for this Instanced Group Manager
  StatefulPolicy? statefulPolicy;

  /// The status of this managed instance group.
  ///
  /// Output only.
  InstanceGroupManagerStatus? status;

  /// The URLs for all TargetPool resources to which instances in the
  /// instanceGroup field are added.
  ///
  /// The target pools automatically apply to all of the instances in the
  /// managed instance group.
  core.List<core.String>? targetPools;

  /// The target number of running instances for this managed instance group.
  ///
  /// You can reduce this number by using the instanceGroupManager
  /// deleteInstances or abandonInstances methods. Resizing the group also
  /// changes this number.
  core.int? targetSize;

  /// The update policy for this managed instance group.
  InstanceGroupManagerUpdatePolicy? updatePolicy;

  /// Specifies the instance templates used by this managed instance group to
  /// create instances.
  ///
  /// Each version is defined by an instanceTemplate and a name. Every version
  /// can appear at most once per instance group. This field overrides the
  /// top-level instanceTemplate field. Read more about the relationships
  /// between these fields. Exactly one version must leave the targetSize field
  /// unset. That version will be applied to all remaining instances. For more
  /// information, read about canary updates.
  core.List<InstanceGroupManagerVersion>? versions;

  /// The URL of a zone where the managed instance group is located (for zonal
  /// resources).
  ///
  /// Output only.
  core.String? zone;

  InstanceGroupManager({
    this.autoHealingPolicies,
    this.baseInstanceName,
    this.creationTimestamp,
    this.currentActions,
    this.description,
    this.distributionPolicy,
    this.fingerprint,
    this.id,
    this.instanceGroup,
    this.instanceTemplate,
    this.kind,
    this.name,
    this.namedPorts,
    this.region,
    this.selfLink,
    this.statefulPolicy,
    this.status,
    this.targetPools,
    this.targetSize,
    this.updatePolicy,
    this.versions,
    this.zone,
  });

  InstanceGroupManager.fromJson(core.Map json_)
      : this(
          autoHealingPolicies: json_.containsKey('autoHealingPolicies')
              ? (json_['autoHealingPolicies'] as core.List)
                  .map((value) =>
                      InstanceGroupManagerAutoHealingPolicy.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          baseInstanceName: json_.containsKey('baseInstanceName')
              ? json_['baseInstanceName'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          currentActions: json_.containsKey('currentActions')
              ? InstanceGroupManagerActionsSummary.fromJson(
                  json_['currentActions']
                      as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          distributionPolicy: json_.containsKey('distributionPolicy')
              ? DistributionPolicy.fromJson(json_['distributionPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instanceGroup: json_.containsKey('instanceGroup')
              ? json_['instanceGroup'] as core.String
              : null,
          instanceTemplate: json_.containsKey('instanceTemplate')
              ? json_['instanceTemplate'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          namedPorts: json_.containsKey('namedPorts')
              ? (json_['namedPorts'] as core.List)
                  .map((value) => NamedPort.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          statefulPolicy: json_.containsKey('statefulPolicy')
              ? StatefulPolicy.fromJson(json_['statefulPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          status: json_.containsKey('status')
              ? InstanceGroupManagerStatus.fromJson(
                  json_['status'] as core.Map<core.String, core.dynamic>)
              : null,
          targetPools: json_.containsKey('targetPools')
              ? (json_['targetPools'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          targetSize: json_.containsKey('targetSize')
              ? json_['targetSize'] as core.int
              : null,
          updatePolicy: json_.containsKey('updatePolicy')
              ? InstanceGroupManagerUpdatePolicy.fromJson(
                  json_['updatePolicy'] as core.Map<core.String, core.dynamic>)
              : null,
          versions: json_.containsKey('versions')
              ? (json_['versions'] as core.List)
                  .map((value) => InstanceGroupManagerVersion.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoHealingPolicies != null)
          'autoHealingPolicies': autoHealingPolicies!,
        if (baseInstanceName != null) 'baseInstanceName': baseInstanceName!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (currentActions != null) 'currentActions': currentActions!,
        if (description != null) 'description': description!,
        if (distributionPolicy != null)
          'distributionPolicy': distributionPolicy!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (instanceGroup != null) 'instanceGroup': instanceGroup!,
        if (instanceTemplate != null) 'instanceTemplate': instanceTemplate!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (namedPorts != null) 'namedPorts': namedPorts!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (statefulPolicy != null) 'statefulPolicy': statefulPolicy!,
        if (status != null) 'status': status!,
        if (targetPools != null) 'targetPools': targetPools!,
        if (targetSize != null) 'targetSize': targetSize!,
        if (updatePolicy != null) 'updatePolicy': updatePolicy!,
        if (versions != null) 'versions': versions!,
        if (zone != null) 'zone': zone!,
      };
}

class InstanceGroupManagerActionsSummary {
  /// The total number of instances in the managed instance group that are
  /// scheduled to be abandoned.
  ///
  /// Abandoning an instance removes it from the managed instance group without
  /// deleting it.
  ///
  /// Output only.
  core.int? abandoning;

  /// The number of instances in the managed instance group that are scheduled
  /// to be created or are currently being created.
  ///
  /// If the group fails to create any of these instances, it tries again until
  /// it creates the instance successfully. If you have disabled creation
  /// retries, this field will not be populated; instead, the
  /// creatingWithoutRetries field will be populated.
  ///
  /// Output only.
  core.int? creating;

  /// The number of instances that the managed instance group will attempt to
  /// create.
  ///
  /// The group attempts to create each instance only once. If the group fails
  /// to create any of these instances, it decreases the group's targetSize
  /// value accordingly.
  ///
  /// Output only.
  core.int? creatingWithoutRetries;

  /// The number of instances in the managed instance group that are scheduled
  /// to be deleted or are currently being deleted.
  ///
  /// Output only.
  core.int? deleting;

  /// The number of instances in the managed instance group that are running and
  /// have no scheduled actions.
  ///
  /// Output only.
  core.int? none;

  /// The number of instances in the managed instance group that are scheduled
  /// to be recreated or are currently being being recreated.
  ///
  /// Recreating an instance deletes the existing root persistent disk and
  /// creates a new disk from the image that is defined in the instance
  /// template.
  ///
  /// Output only.
  core.int? recreating;

  /// The number of instances in the managed instance group that are being
  /// reconfigured with properties that do not require a restart or a recreate
  /// action.
  ///
  /// For example, setting or removing target pools for the instance.
  ///
  /// Output only.
  core.int? refreshing;

  /// The number of instances in the managed instance group that are scheduled
  /// to be restarted or are currently being restarted.
  ///
  /// Output only.
  core.int? restarting;

  /// The number of instances in the managed instance group that are scheduled
  /// to be resumed or are currently being resumed.
  ///
  /// Output only.
  core.int? resuming;

  /// The number of instances in the managed instance group that are scheduled
  /// to be started or are currently being started.
  ///
  /// Output only.
  core.int? starting;

  /// The number of instances in the managed instance group that are scheduled
  /// to be stopped or are currently being stopped.
  ///
  /// Output only.
  core.int? stopping;

  /// The number of instances in the managed instance group that are scheduled
  /// to be suspended or are currently being suspended.
  ///
  /// Output only.
  core.int? suspending;

  /// The number of instances in the managed instance group that are being
  /// verified.
  ///
  /// See the managedInstances\[\].currentAction property in the
  /// listManagedInstances method documentation.
  ///
  /// Output only.
  core.int? verifying;

  InstanceGroupManagerActionsSummary({
    this.abandoning,
    this.creating,
    this.creatingWithoutRetries,
    this.deleting,
    this.none,
    this.recreating,
    this.refreshing,
    this.restarting,
    this.resuming,
    this.starting,
    this.stopping,
    this.suspending,
    this.verifying,
  });

  InstanceGroupManagerActionsSummary.fromJson(core.Map json_)
      : this(
          abandoning: json_.containsKey('abandoning')
              ? json_['abandoning'] as core.int
              : null,
          creating: json_.containsKey('creating')
              ? json_['creating'] as core.int
              : null,
          creatingWithoutRetries: json_.containsKey('creatingWithoutRetries')
              ? json_['creatingWithoutRetries'] as core.int
              : null,
          deleting: json_.containsKey('deleting')
              ? json_['deleting'] as core.int
              : null,
          none: json_.containsKey('none') ? json_['none'] as core.int : null,
          recreating: json_.containsKey('recreating')
              ? json_['recreating'] as core.int
              : null,
          refreshing: json_.containsKey('refreshing')
              ? json_['refreshing'] as core.int
              : null,
          restarting: json_.containsKey('restarting')
              ? json_['restarting'] as core.int
              : null,
          resuming: json_.containsKey('resuming')
              ? json_['resuming'] as core.int
              : null,
          starting: json_.containsKey('starting')
              ? json_['starting'] as core.int
              : null,
          stopping: json_.containsKey('stopping')
              ? json_['stopping'] as core.int
              : null,
          suspending: json_.containsKey('suspending')
              ? json_['suspending'] as core.int
              : null,
          verifying: json_.containsKey('verifying')
              ? json_['verifying'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (abandoning != null) 'abandoning': abandoning!,
        if (creating != null) 'creating': creating!,
        if (creatingWithoutRetries != null)
          'creatingWithoutRetries': creatingWithoutRetries!,
        if (deleting != null) 'deleting': deleting!,
        if (none != null) 'none': none!,
        if (recreating != null) 'recreating': recreating!,
        if (refreshing != null) 'refreshing': refreshing!,
        if (restarting != null) 'restarting': restarting!,
        if (resuming != null) 'resuming': resuming!,
        if (starting != null) 'starting': starting!,
        if (stopping != null) 'stopping': stopping!,
        if (suspending != null) 'suspending': suspending!,
        if (verifying != null) 'verifying': verifying!,
      };
}

class InstanceGroupManagerAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupManagerAggregatedListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupManagerAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupManagerAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupManagerAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupManagerAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupManagerAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InstanceGroupManagerAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupManagerAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroupManagersScopedList resources.
  core.Map<core.String, InstanceGroupManagersScopedList>? items;

  /// The resource type, which is always
  /// compute#instanceGroupManagerAggregatedList for an aggregated list of
  /// managed instance groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupManagerAggregatedListWarning? warning;

  InstanceGroupManagerAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  InstanceGroupManagerAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    InstanceGroupManagersScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupManagerAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupManagerAutoHealingPolicy {
  /// The URL for the health check that signals autohealing.
  core.String? healthCheck;

  /// The number of seconds that the managed instance group waits before it
  /// applies autohealing policies to new instances or recently recreated
  /// instances.
  ///
  /// This initial delay allows instances to initialize and run their startup
  /// scripts before the instance group determines that they are UNHEALTHY. This
  /// prevents the managed instance group from recreating its instances
  /// prematurely. This value must be from range \[0, 3600\].
  core.int? initialDelaySec;

  InstanceGroupManagerAutoHealingPolicy({
    this.healthCheck,
    this.initialDelaySec,
  });

  InstanceGroupManagerAutoHealingPolicy.fromJson(core.Map json_)
      : this(
          healthCheck: json_.containsKey('healthCheck')
              ? json_['healthCheck'] as core.String
              : null,
          initialDelaySec: json_.containsKey('initialDelaySec')
              ? json_['initialDelaySec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthCheck != null) 'healthCheck': healthCheck!,
        if (initialDelaySec != null) 'initialDelaySec': initialDelaySec!,
      };
}

class InstanceGroupManagerListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupManagerListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupManagerListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupManagerListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupManagerListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupManagerListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupManagerListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceGroupManagerListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of managed instance groups.
///
/// Output only.
class InstanceGroupManagerList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroupManager resources.
  core.List<InstanceGroupManager>? items;

  /// The resource type, which is always compute#instanceGroupManagerList for a
  /// list of managed instance groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupManagerListWarning? warning;

  InstanceGroupManagerList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceGroupManagerList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceGroupManager.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupManagerListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupManagerStatus {
  /// The URL of the Autoscaler that targets this instance group manager.
  ///
  /// Output only.
  core.String? autoscaler;

  /// A bit indicating whether the managed instance group is in a stable state.
  ///
  /// A stable state means that: none of the instances in the managed instance
  /// group is currently undergoing any type of change (for example, creation,
  /// restart, or deletion); no future changes are scheduled for instances in
  /// the managed instance group; and the managed instance group itself is not
  /// being modified.
  ///
  /// Output only.
  core.bool? isStable;

  /// Stateful status of the given Instance Group Manager.
  ///
  /// Output only.
  InstanceGroupManagerStatusStateful? stateful;

  /// A status of consistency of Instances' versions with their target version
  /// specified by version field on Instance Group Manager.
  ///
  /// Output only.
  InstanceGroupManagerStatusVersionTarget? versionTarget;

  InstanceGroupManagerStatus({
    this.autoscaler,
    this.isStable,
    this.stateful,
    this.versionTarget,
  });

  InstanceGroupManagerStatus.fromJson(core.Map json_)
      : this(
          autoscaler: json_.containsKey('autoscaler')
              ? json_['autoscaler'] as core.String
              : null,
          isStable: json_.containsKey('isStable')
              ? json_['isStable'] as core.bool
              : null,
          stateful: json_.containsKey('stateful')
              ? InstanceGroupManagerStatusStateful.fromJson(
                  json_['stateful'] as core.Map<core.String, core.dynamic>)
              : null,
          versionTarget: json_.containsKey('versionTarget')
              ? InstanceGroupManagerStatusVersionTarget.fromJson(
                  json_['versionTarget'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoscaler != null) 'autoscaler': autoscaler!,
        if (isStable != null) 'isStable': isStable!,
        if (stateful != null) 'stateful': stateful!,
        if (versionTarget != null) 'versionTarget': versionTarget!,
      };
}

class InstanceGroupManagerStatusStateful {
  /// A bit indicating whether the managed instance group has stateful
  /// configuration, that is, if you have configured any items in a stateful
  /// policy or in per-instance configs.
  ///
  /// The group might report that it has no stateful configuration even when
  /// there is still some preserved state on a managed instance, for example, if
  /// you have deleted all PICs but not yet applied those deletions.
  ///
  /// Output only.
  core.bool? hasStatefulConfig;

  /// Status of per-instance configurations on the instance.
  ///
  /// Output only.
  InstanceGroupManagerStatusStatefulPerInstanceConfigs? perInstanceConfigs;

  InstanceGroupManagerStatusStateful({
    this.hasStatefulConfig,
    this.perInstanceConfigs,
  });

  InstanceGroupManagerStatusStateful.fromJson(core.Map json_)
      : this(
          hasStatefulConfig: json_.containsKey('hasStatefulConfig')
              ? json_['hasStatefulConfig'] as core.bool
              : null,
          perInstanceConfigs: json_.containsKey('perInstanceConfigs')
              ? InstanceGroupManagerStatusStatefulPerInstanceConfigs.fromJson(
                  json_['perInstanceConfigs']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (hasStatefulConfig != null) 'hasStatefulConfig': hasStatefulConfig!,
        if (perInstanceConfigs != null)
          'perInstanceConfigs': perInstanceConfigs!,
      };
}

class InstanceGroupManagerStatusStatefulPerInstanceConfigs {
  /// A bit indicating if all of the group's per-instance configurations (listed
  /// in the output of a listPerInstanceConfigs API call) have status EFFECTIVE
  /// or there are no per-instance-configs.
  core.bool? allEffective;

  InstanceGroupManagerStatusStatefulPerInstanceConfigs({
    this.allEffective,
  });

  InstanceGroupManagerStatusStatefulPerInstanceConfigs.fromJson(core.Map json_)
      : this(
          allEffective: json_.containsKey('allEffective')
              ? json_['allEffective'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (allEffective != null) 'allEffective': allEffective!,
      };
}

class InstanceGroupManagerStatusVersionTarget {
  /// A bit indicating whether version target has been reached in this managed
  /// instance group, i.e. all instances are in their target version.
  ///
  /// Instances' target version are specified by version field on Instance Group
  /// Manager.
  ///
  /// Output only.
  core.bool? isReached;

  InstanceGroupManagerStatusVersionTarget({
    this.isReached,
  });

  InstanceGroupManagerStatusVersionTarget.fromJson(core.Map json_)
      : this(
          isReached: json_.containsKey('isReached')
              ? json_['isReached'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (isReached != null) 'isReached': isReached!,
      };
}

class InstanceGroupManagerUpdatePolicy {
  /// The instance redistribution policy for regional managed instance groups.
  ///
  /// Valid values are: - PROACTIVE (default): The group attempts to maintain an
  /// even distribution of VM instances across zones in the region. - NONE: For
  /// non-autoscaled groups, proactive redistribution is disabled.
  /// Possible string values are:
  /// - "NONE" : No action is being proactively performed in order to bring this
  /// IGM to its target instance distribution.
  /// - "PROACTIVE" : This IGM will actively converge to its target instance
  /// distribution.
  core.String? instanceRedistributionType;

  /// The maximum number of instances that can be created above the specified
  /// targetSize during the update process.
  ///
  /// This value can be either a fixed number or, if the group has 10 or more
  /// instances, a percentage. If you set a percentage, the number of instances
  /// is rounded if necessary. The default value for maxSurge is a fixed value
  /// equal to the number of zones in which the managed instance group operates.
  /// At least one of either maxSurge or maxUnavailable must be greater than 0.
  /// Learn more about maxSurge.
  FixedOrPercent? maxSurge;

  /// The maximum number of instances that can be unavailable during the update
  /// process.
  ///
  /// An instance is considered available if all of the following conditions are
  /// satisfied: - The instance's status is RUNNING. - If there is a health
  /// check on the instance group, the instance's health check status must be
  /// HEALTHY at least once. If there is no health check on the group, then the
  /// instance only needs to have a status of RUNNING to be considered
  /// available. This value can be either a fixed number or, if the group has 10
  /// or more instances, a percentage. If you set a percentage, the number of
  /// instances is rounded if necessary. The default value for maxUnavailable is
  /// a fixed value equal to the number of zones in which the managed instance
  /// group operates. At least one of either maxSurge or maxUnavailable must be
  /// greater than 0. Learn more about maxUnavailable.
  FixedOrPercent? maxUnavailable;

  /// Minimal action to be taken on an instance.
  ///
  /// Use this option to minimize disruption as much as possible or to apply a
  /// more disruptive action than is necessary. - To limit disruption as much as
  /// possible, set the minimal action to REFRESH. If your update requires a
  /// more disruptive action, Compute Engine performs the necessary action to
  /// execute the update. - To apply a more disruptive action than is strictly
  /// necessary, set the minimal action to RESTART or REPLACE. For example,
  /// Compute Engine does not need to restart a VM to change its metadata. But
  /// if your application reads instance metadata only when a VM is restarted,
  /// you can set the minimal action to RESTART in order to pick up metadata
  /// changes.
  /// Possible string values are:
  /// - "NONE" : Do not perform any action.
  /// - "REFRESH" : Updates applied in runtime, instances will not be disrupted.
  /// - "REPLACE" : Old instances will be deleted. New instances will be created
  /// from the target template.
  /// - "RESTART" : Every instance will be restarted.
  core.String? minimalAction;

  /// Most disruptive action that is allowed to be taken on an instance.
  ///
  /// You can specify either NONE to forbid any actions, REFRESH to allow
  /// actions that do not need instance restart, RESTART to allow actions that
  /// can be applied without instance replacing or REPLACE to allow all possible
  /// actions. If the Updater determines that the minimal update action needed
  /// is more disruptive than most disruptive allowed action you specify it will
  /// not perform the update at all.
  /// Possible string values are:
  /// - "NONE" : Do not perform any action.
  /// - "REFRESH" : Updates applied in runtime, instances will not be disrupted.
  /// - "REPLACE" : Old instances will be deleted. New instances will be created
  /// from the target template.
  /// - "RESTART" : Every instance will be restarted.
  core.String? mostDisruptiveAllowedAction;

  /// What action should be used to replace instances.
  ///
  /// See minimal_action.REPLACE
  /// Possible string values are:
  /// - "RECREATE" : Instances will be recreated (with the same name)
  /// - "SUBSTITUTE" : Default option: instances will be deleted and created
  /// (with a new name)
  core.String? replacementMethod;

  /// The type of update process.
  ///
  /// You can specify either PROACTIVE so that the instance group manager
  /// proactively executes actions in order to bring instances to their target
  /// versions or OPPORTUNISTIC so that no action is proactively executed but
  /// the update will be performed as part of other actions (for example,
  /// resizes or recreateInstances calls).
  /// Possible string values are:
  /// - "OPPORTUNISTIC" : No action is being proactively performed in order to
  /// bring this IGM to its target version distribution (regardless of whether
  /// this distribution is expressed using instanceTemplate or versions field).
  /// - "PROACTIVE" : This IGM will actively converge to its target version
  /// distribution (regardless of whether this distribution is expressed using
  /// instanceTemplate or versions field).
  core.String? type;

  InstanceGroupManagerUpdatePolicy({
    this.instanceRedistributionType,
    this.maxSurge,
    this.maxUnavailable,
    this.minimalAction,
    this.mostDisruptiveAllowedAction,
    this.replacementMethod,
    this.type,
  });

  InstanceGroupManagerUpdatePolicy.fromJson(core.Map json_)
      : this(
          instanceRedistributionType:
              json_.containsKey('instanceRedistributionType')
                  ? json_['instanceRedistributionType'] as core.String
                  : null,
          maxSurge: json_.containsKey('maxSurge')
              ? FixedOrPercent.fromJson(
                  json_['maxSurge'] as core.Map<core.String, core.dynamic>)
              : null,
          maxUnavailable: json_.containsKey('maxUnavailable')
              ? FixedOrPercent.fromJson(json_['maxUnavailable']
                  as core.Map<core.String, core.dynamic>)
              : null,
          minimalAction: json_.containsKey('minimalAction')
              ? json_['minimalAction'] as core.String
              : null,
          mostDisruptiveAllowedAction:
              json_.containsKey('mostDisruptiveAllowedAction')
                  ? json_['mostDisruptiveAllowedAction'] as core.String
                  : null,
          replacementMethod: json_.containsKey('replacementMethod')
              ? json_['replacementMethod'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceRedistributionType != null)
          'instanceRedistributionType': instanceRedistributionType!,
        if (maxSurge != null) 'maxSurge': maxSurge!,
        if (maxUnavailable != null) 'maxUnavailable': maxUnavailable!,
        if (minimalAction != null) 'minimalAction': minimalAction!,
        if (mostDisruptiveAllowedAction != null)
          'mostDisruptiveAllowedAction': mostDisruptiveAllowedAction!,
        if (replacementMethod != null) 'replacementMethod': replacementMethod!,
        if (type != null) 'type': type!,
      };
}

class InstanceGroupManagerVersion {
  /// The URL of the instance template that is specified for this managed
  /// instance group.
  ///
  /// The group uses this template to create new instances in the managed
  /// instance group until the `targetSize` for this version is reached. The
  /// templates for existing instances in the group do not change unless you run
  /// recreateInstances, run applyUpdatesToInstances, or set the group's
  /// updatePolicy.type to PROACTIVE; in those cases, existing instances are
  /// updated until the `targetSize` for this version is reached.
  core.String? instanceTemplate;

  /// Name of the version.
  ///
  /// Unique among all versions in the scope of this managed instance group.
  core.String? name;

  /// Specifies the intended number of instances to be created from the
  /// instanceTemplate.
  ///
  /// The final number of instances created from the template will be equal to:
  /// - If expressed as a fixed number, the minimum of either targetSize.fixed
  /// or instanceGroupManager.targetSize is used. - if expressed as a percent,
  /// the targetSize would be (targetSize.percent/100 *
  /// InstanceGroupManager.targetSize) If there is a remainder, the number is
  /// rounded. If unset, this version will update any remaining instances not
  /// updated by another version. Read Starting a canary update for more
  /// information.
  FixedOrPercent? targetSize;

  InstanceGroupManagerVersion({
    this.instanceTemplate,
    this.name,
    this.targetSize,
  });

  InstanceGroupManagerVersion.fromJson(core.Map json_)
      : this(
          instanceTemplate: json_.containsKey('instanceTemplate')
              ? json_['instanceTemplate'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          targetSize: json_.containsKey('targetSize')
              ? FixedOrPercent.fromJson(
                  json_['targetSize'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceTemplate != null) 'instanceTemplate': instanceTemplate!,
        if (name != null) 'name': name!,
        if (targetSize != null) 'targetSize': targetSize!,
      };
}

typedef InstanceGroupManagersAbandonInstancesRequest
    = $InstanceGroupManagersAbandonInstancesRequest;

/// InstanceGroupManagers.applyUpdatesToInstances
typedef InstanceGroupManagersApplyUpdatesRequest
    = $InstanceGroupManagersApplyUpdatesRequest;

/// InstanceGroupManagers.createInstances
class InstanceGroupManagersCreateInstancesRequest {
  /// List of specifications of per-instance configs.
  ///
  /// Required.
  core.List<PerInstanceConfig>? instances;

  InstanceGroupManagersCreateInstancesRequest({
    this.instances,
  });

  InstanceGroupManagersCreateInstancesRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

typedef InstanceGroupManagersDeleteInstancesRequest
    = $InstanceGroupManagersDeleteInstancesRequest;

/// InstanceGroupManagers.deletePerInstanceConfigs
typedef InstanceGroupManagersDeletePerInstanceConfigsReq = $Req;

class InstanceGroupManagersListErrorsResponse {
  /// The list of errors of the managed instance group.
  ///
  /// Output only.
  core.List<InstanceManagedByIgmError>? items;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  InstanceGroupManagersListErrorsResponse({
    this.items,
    this.nextPageToken,
  });

  InstanceGroupManagersListErrorsResponse.fromJson(core.Map json_)
      : this(
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceManagedByIgmError.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (items != null) 'items': items!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
      };
}

class InstanceGroupManagersListManagedInstancesResponse {
  /// The list of instances in the managed instance group.
  ///
  /// Output only.
  core.List<ManagedInstance>? managedInstances;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  InstanceGroupManagersListManagedInstancesResponse({
    this.managedInstances,
    this.nextPageToken,
  });

  InstanceGroupManagersListManagedInstancesResponse.fromJson(core.Map json_)
      : this(
          managedInstances: json_.containsKey('managedInstances')
              ? (json_['managedInstances'] as core.List)
                  .map((value) => ManagedInstance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (managedInstances != null) 'managedInstances': managedInstances!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
      };
}

class InstanceGroupManagersListPerInstanceConfigsRespWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupManagersListPerInstanceConfigsRespWarningData({
    this.key,
    this.value,
  });

  InstanceGroupManagersListPerInstanceConfigsRespWarningData.fromJson(
      core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupManagersListPerInstanceConfigsRespWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupManagersListPerInstanceConfigsRespWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupManagersListPerInstanceConfigsRespWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupManagersListPerInstanceConfigsRespWarning.fromJson(
      core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InstanceGroupManagersListPerInstanceConfigsRespWarningData
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupManagersListPerInstanceConfigsResp {
  /// The list of PerInstanceConfig.
  ///
  /// Output only.
  core.List<PerInstanceConfig>? items;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupManagersListPerInstanceConfigsRespWarning? warning;

  InstanceGroupManagersListPerInstanceConfigsResp({
    this.items,
    this.nextPageToken,
    this.warning,
  });

  InstanceGroupManagersListPerInstanceConfigsResp.fromJson(core.Map json_)
      : this(
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupManagersListPerInstanceConfigsRespWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (items != null) 'items': items!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (warning != null) 'warning': warning!,
      };
}

/// InstanceGroupManagers.patchPerInstanceConfigs
class InstanceGroupManagersPatchPerInstanceConfigsReq {
  /// The list of per-instance configurations to insert or patch on this managed
  /// instance group.
  core.List<PerInstanceConfig>? perInstanceConfigs;

  InstanceGroupManagersPatchPerInstanceConfigsReq({
    this.perInstanceConfigs,
  });

  InstanceGroupManagersPatchPerInstanceConfigsReq.fromJson(core.Map json_)
      : this(
          perInstanceConfigs: json_.containsKey('perInstanceConfigs')
              ? (json_['perInstanceConfigs'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (perInstanceConfigs != null)
          'perInstanceConfigs': perInstanceConfigs!,
      };
}

typedef InstanceGroupManagersRecreateInstancesRequest = $Request05;

class InstanceGroupManagersScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupManagersScopedListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupManagersScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// The warning that replaces the list of managed instance groups when the list
/// is empty.
///
/// Output only.
class InstanceGroupManagersScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupManagersScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupManagersScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupManagersScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InstanceGroupManagersScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupManagersScopedList {
  /// The list of managed instance groups that are contained in the specified
  /// project and zone.
  ///
  /// Output only.
  core.List<InstanceGroupManager>? instanceGroupManagers;

  /// The warning that replaces the list of managed instance groups when the
  /// list is empty.
  ///
  /// Output only.
  InstanceGroupManagersScopedListWarning? warning;

  InstanceGroupManagersScopedList({
    this.instanceGroupManagers,
    this.warning,
  });

  InstanceGroupManagersScopedList.fromJson(core.Map json_)
      : this(
          instanceGroupManagers: json_.containsKey('instanceGroupManagers')
              ? (json_['instanceGroupManagers'] as core.List)
                  .map((value) => InstanceGroupManager.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupManagersScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceGroupManagers != null)
          'instanceGroupManagers': instanceGroupManagers!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupManagersSetInstanceTemplateRequest {
  /// The URL of the instance template that is specified for this managed
  /// instance group.
  ///
  /// The group uses this template to create all new instances in the managed
  /// instance group. The templates for existing instances in the group do not
  /// change unless you run recreateInstances, run applyUpdatesToInstances, or
  /// set the group's updatePolicy.type to PROACTIVE.
  core.String? instanceTemplate;

  InstanceGroupManagersSetInstanceTemplateRequest({
    this.instanceTemplate,
  });

  InstanceGroupManagersSetInstanceTemplateRequest.fromJson(core.Map json_)
      : this(
          instanceTemplate: json_.containsKey('instanceTemplate')
              ? json_['instanceTemplate'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceTemplate != null) 'instanceTemplate': instanceTemplate!,
      };
}

class InstanceGroupManagersSetTargetPoolsRequest {
  /// The fingerprint of the target pools information.
  ///
  /// Use this optional property to prevent conflicts when multiple users change
  /// the target pools settings concurrently. Obtain the fingerprint with the
  /// instanceGroupManagers.get method. Then, include the fingerprint in your
  /// request to ensure that you do not overwrite changes that were applied from
  /// another concurrent request.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The list of target pool URLs that instances in this managed instance group
  /// belong to.
  ///
  /// The managed instance group applies these target pools to all of the
  /// instances in the group. Existing instances and new instances in the group
  /// all receive these target pool settings.
  core.List<core.String>? targetPools;

  InstanceGroupManagersSetTargetPoolsRequest({
    this.fingerprint,
    this.targetPools,
  });

  InstanceGroupManagersSetTargetPoolsRequest.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          targetPools: json_.containsKey('targetPools')
              ? (json_['targetPools'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (targetPools != null) 'targetPools': targetPools!,
      };
}

/// InstanceGroupManagers.updatePerInstanceConfigs
class InstanceGroupManagersUpdatePerInstanceConfigsReq {
  /// The list of per-instance configurations to insert or patch on this managed
  /// instance group.
  core.List<PerInstanceConfig>? perInstanceConfigs;

  InstanceGroupManagersUpdatePerInstanceConfigsReq({
    this.perInstanceConfigs,
  });

  InstanceGroupManagersUpdatePerInstanceConfigsReq.fromJson(core.Map json_)
      : this(
          perInstanceConfigs: json_.containsKey('perInstanceConfigs')
              ? (json_['perInstanceConfigs'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (perInstanceConfigs != null)
          'perInstanceConfigs': perInstanceConfigs!,
      };
}

class InstanceGroupsAddInstancesRequest {
  /// The list of instances to add to the instance group.
  core.List<InstanceReference>? instances;

  InstanceGroupsAddInstancesRequest({
    this.instances,
  });

  InstanceGroupsAddInstancesRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => InstanceReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

class InstanceGroupsListInstancesWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupsListInstancesWarningData({
    this.key,
    this.value,
  });

  InstanceGroupsListInstancesWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceGroupsListInstancesWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupsListInstancesWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupsListInstancesWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupsListInstancesWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InstanceGroupsListInstancesWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupsListInstances {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceWithNamedPorts resources.
  core.List<InstanceWithNamedPorts>? items;

  /// The resource type, which is always compute#instanceGroupsListInstances for
  /// the list of instances in the specified instance group.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceGroupsListInstancesWarning? warning;

  InstanceGroupsListInstances({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceGroupsListInstances.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceWithNamedPorts.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupsListInstancesWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupsListInstancesRequest {
  /// A filter for the state of the instances in the instance group.
  ///
  /// Valid options are ALL or RUNNING. If you do not specify this parameter the
  /// list includes all instances regardless of their state.
  /// Possible string values are:
  /// - "ALL" : Includes all instances in the generated list regardless of their
  /// state.
  /// - "RUNNING" : Includes instances in the generated list only if they have a
  /// RUNNING state.
  core.String? instanceState;

  InstanceGroupsListInstancesRequest({
    this.instanceState,
  });

  InstanceGroupsListInstancesRequest.fromJson(core.Map json_)
      : this(
          instanceState: json_.containsKey('instanceState')
              ? json_['instanceState'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceState != null) 'instanceState': instanceState!,
      };
}

class InstanceGroupsRemoveInstancesRequest {
  /// The list of instances to remove from the instance group.
  core.List<InstanceReference>? instances;

  InstanceGroupsRemoveInstancesRequest({
    this.instances,
  });

  InstanceGroupsRemoveInstancesRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => InstanceReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

class InstanceGroupsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceGroupsScopedListWarningData({
    this.key,
    this.value,
  });

  InstanceGroupsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that replaces the list of instance groups when the
/// list is empty.
///
/// Output only.
class InstanceGroupsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceGroupsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceGroupsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceGroupsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceGroupsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstanceGroupsScopedList {
  /// The list of instance groups that are contained in this scope.
  ///
  /// Output only.
  core.List<InstanceGroup>? instanceGroups;

  /// An informational warning that replaces the list of instance groups when
  /// the list is empty.
  ///
  /// Output only.
  InstanceGroupsScopedListWarning? warning;

  InstanceGroupsScopedList({
    this.instanceGroups,
    this.warning,
  });

  InstanceGroupsScopedList.fromJson(core.Map json_)
      : this(
          instanceGroups: json_.containsKey('instanceGroups')
              ? (json_['instanceGroups'] as core.List)
                  .map((value) => InstanceGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstanceGroupsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceGroups != null) 'instanceGroups': instanceGroups!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceGroupsSetNamedPortsRequest {
  /// The fingerprint of the named ports information for this instance group.
  ///
  /// Use this optional property to prevent conflicts when multiple users change
  /// the named ports settings concurrently. Obtain the fingerprint with the
  /// instanceGroups.get method. Then, include the fingerprint in your request
  /// to ensure that you do not overwrite changes that were applied from another
  /// concurrent request. A request with an incorrect fingerprint will fail with
  /// error 412 conditionNotMet.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The list of named ports to set for this instance group.
  core.List<NamedPort>? namedPorts;

  InstanceGroupsSetNamedPortsRequest({
    this.fingerprint,
    this.namedPorts,
  });

  InstanceGroupsSetNamedPortsRequest.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          namedPorts: json_.containsKey('namedPorts')
              ? (json_['namedPorts'] as core.List)
                  .map((value) => NamedPort.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (namedPorts != null) 'namedPorts': namedPorts!,
      };
}

class InstanceListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceListWarningData({
    this.key,
    this.value,
  });

  InstanceListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of instances.
class InstanceList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Instance resources.
  core.List<Instance>? items;

  /// Type of resource.
  ///
  /// Always compute#instanceList for lists of Instance resources.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceListWarning? warning;

  InstanceList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Instance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceListReferrersWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceListReferrersWarningData({
    this.key,
    this.value,
  });

  InstanceListReferrersWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceListReferrersWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceListReferrersWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceListReferrersWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceListReferrersWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceListReferrersWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of instance referrers.
class InstanceListReferrers {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Reference resources.
  core.List<Reference>? items;

  /// Type of resource.
  ///
  /// Always compute#instanceListReferrers for lists of Instance referrers.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceListReferrersWarning? warning;

  InstanceListReferrers({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceListReferrers.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Reference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceListReferrersWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceManagedByIgmError {
  /// Contents of the error.
  ///
  /// Output only.
  InstanceManagedByIgmErrorManagedInstanceError? error;

  /// Details of the instance action that triggered this error.
  ///
  /// May be null, if the error was not caused by an action on an instance. This
  /// field is optional.
  ///
  /// Output only.
  InstanceManagedByIgmErrorInstanceActionDetails? instanceActionDetails;

  /// The time that this error occurred.
  ///
  /// This value is in RFC3339 text format.
  ///
  /// Output only.
  core.String? timestamp;

  InstanceManagedByIgmError({
    this.error,
    this.instanceActionDetails,
    this.timestamp,
  });

  InstanceManagedByIgmError.fromJson(core.Map json_)
      : this(
          error: json_.containsKey('error')
              ? InstanceManagedByIgmErrorManagedInstanceError.fromJson(
                  json_['error'] as core.Map<core.String, core.dynamic>)
              : null,
          instanceActionDetails: json_.containsKey('instanceActionDetails')
              ? InstanceManagedByIgmErrorInstanceActionDetails.fromJson(
                  json_['instanceActionDetails']
                      as core.Map<core.String, core.dynamic>)
              : null,
          timestamp: json_.containsKey('timestamp')
              ? json_['timestamp'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (error != null) 'error': error!,
        if (instanceActionDetails != null)
          'instanceActionDetails': instanceActionDetails!,
        if (timestamp != null) 'timestamp': timestamp!,
      };
}

class InstanceManagedByIgmErrorInstanceActionDetails {
  /// Action that managed instance group was executing on the instance when the
  /// error occurred.
  ///
  /// Possible values:
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ABANDONING" : The managed instance group is abandoning this instance.
  /// The instance will be removed from the instance group and from any target
  /// pools that are associated with this group.
  /// - "CREATING" : The managed instance group is creating this instance. If
  /// the group fails to create this instance, it will try again until it is
  /// successful.
  /// - "CREATING_WITHOUT_RETRIES" : The managed instance group is attempting to
  /// create this instance only once. If the group fails to create this
  /// instance, it does not try again and the group's targetSize value is
  /// decreased.
  /// - "DELETING" : The managed instance group is permanently deleting this
  /// instance.
  /// - "NONE" : The managed instance group has not scheduled any actions for
  /// this instance.
  /// - "RECREATING" : The managed instance group is recreating this instance.
  /// - "REFRESHING" : The managed instance group is applying configuration
  /// changes to the instance without stopping it. For example, the group can
  /// update the target pool list for an instance without stopping that
  /// instance.
  /// - "RESTARTING" : The managed instance group is restarting this instance.
  /// - "RESUMING" : The managed instance group is resuming this instance.
  /// - "STARTING" : The managed instance group is starting this instance.
  /// - "STOPPING" : The managed instance group is stopping this instance.
  /// - "SUSPENDING" : The managed instance group is suspending this instance.
  /// - "VERIFYING" : The managed instance group is verifying this already
  /// created instance. Verification happens every time the instance is
  /// (re)created or restarted and consists of: 1. Waiting until health check
  /// specified as part of this managed instance group's autohealing policy
  /// reports HEALTHY. Note: Applies only if autohealing policy has a health
  /// check specified 2. Waiting for addition verification steps performed as
  /// post-instance creation (subject to future extensions).
  core.String? action;

  /// The URL of the instance.
  ///
  /// The URL can be set even if the instance has not yet been created.
  ///
  /// Output only.
  core.String? instance;

  /// Version this instance was created from, or was being created from, but the
  /// creation failed.
  ///
  /// Corresponds to one of the versions that were set on the Instance Group
  /// Manager resource at the time this instance was being created.
  ///
  /// Output only.
  ManagedInstanceVersion? version;

  InstanceManagedByIgmErrorInstanceActionDetails({
    this.action,
    this.instance,
    this.version,
  });

  InstanceManagedByIgmErrorInstanceActionDetails.fromJson(core.Map json_)
      : this(
          action: json_.containsKey('action')
              ? json_['action'] as core.String
              : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          version: json_.containsKey('version')
              ? ManagedInstanceVersion.fromJson(
                  json_['version'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (action != null) 'action': action!,
        if (instance != null) 'instance': instance!,
        if (version != null) 'version': version!,
      };
}

class InstanceManagedByIgmErrorManagedInstanceError {
  /// Error code.
  ///
  /// Output only.
  core.String? code;

  /// Error message.
  ///
  /// Output only.
  core.String? message;

  InstanceManagedByIgmErrorManagedInstanceError({
    this.code,
    this.message,
  });

  InstanceManagedByIgmErrorManagedInstanceError.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (message != null) 'message': message!,
      };
}

class InstanceMoveRequest {
  /// The URL of the destination zone to move the instance.
  ///
  /// This can be a full or partial URL. For example, the following are all
  /// valid URLs to a zone: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone -
  /// projects/project/zones/zone - zones/zone
  core.String? destinationZone;

  /// The URL of the target instance to move.
  ///
  /// This can be a full or partial URL. For example, the following are all
  /// valid URLs to an instance: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /instances/instance - projects/project/zones/zone/instances/instance -
  /// zones/zone/instances/instance
  core.String? targetInstance;

  InstanceMoveRequest({
    this.destinationZone,
    this.targetInstance,
  });

  InstanceMoveRequest.fromJson(core.Map json_)
      : this(
          destinationZone: json_.containsKey('destinationZone')
              ? json_['destinationZone'] as core.String
              : null,
          targetInstance: json_.containsKey('targetInstance')
              ? json_['targetInstance'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (destinationZone != null) 'destinationZone': destinationZone!,
        if (targetInstance != null) 'targetInstance': targetInstance!,
      };
}

/// Additional instance params.
class InstanceParams {
  /// Resource manager tags to be bound to the instance.
  ///
  /// Tag keys and values have the same definition as resource manager tags.
  /// Keys must be in the format `tagKeys/{tag_key_id}`, and values are in the
  /// format `tagValues/456`. The field is ignored (both PUT & PATCH) when
  /// empty.
  core.Map<core.String, core.String>? resourceManagerTags;

  InstanceParams({
    this.resourceManagerTags,
  });

  InstanceParams.fromJson(core.Map json_)
      : this(
          resourceManagerTags: json_.containsKey('resourceManagerTags')
              ? (json_['resourceManagerTags']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourceManagerTags != null)
          'resourceManagerTags': resourceManagerTags!,
      };
}

class InstanceProperties {
  /// Controls for advanced machine-related behavior features.
  ///
  /// Note that for MachineImage, this is not supported yet.
  AdvancedMachineFeatures? advancedMachineFeatures;

  /// Enables instances created based on these properties to send packets with
  /// source IP addresses other than their own and receive packets with
  /// destination IP addresses other than their own.
  ///
  /// If these instances will be used as an IP gateway or it will be set as the
  /// next-hop in a Route resource, specify true. If unsure, leave this set to
  /// false. See the Enable IP forwarding documentation for more information.
  core.bool? canIpForward;

  /// Specifies the Confidential Instance options.
  ///
  /// Note that for MachineImage, this is not supported yet.
  ConfidentialInstanceConfig? confidentialInstanceConfig;

  /// An optional text description for the instances that are created from these
  /// properties.
  core.String? description;

  /// An array of disks that are associated with the instances that are created
  /// from these properties.
  core.List<AttachedDisk>? disks;

  /// A list of guest accelerator cards' type and count to use for instances
  /// created from these properties.
  core.List<AcceleratorConfig>? guestAccelerators;

  /// KeyRevocationActionType of the instance.
  ///
  /// Supported options are "STOP" and "NONE". The default value is "NONE" if it
  /// is not specified.
  /// Possible string values are:
  /// - "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED" : Default value. This value is
  /// unused.
  /// - "NONE" : Indicates user chose no operation.
  /// - "STOP" : Indicates user chose to opt for VM shutdown on key revocation.
  core.String? keyRevocationActionType;

  /// Labels to apply to instances that are created from these properties.
  core.Map<core.String, core.String>? labels;

  /// The machine type to use for instances that are created from these
  /// properties.
  core.String? machineType;

  /// The metadata key/value pairs to assign to instances that are created from
  /// these properties.
  ///
  /// These pairs can consist of custom metadata or predefined keys. See Project
  /// and instance metadata for more information.
  Metadata? metadata;

  /// Minimum cpu/platform to be used by instances.
  ///
  /// The instance may be scheduled on the specified or newer cpu/platform.
  /// Applicable values are the friendly names of CPU platforms, such as
  /// minCpuPlatform: "Intel Haswell" or minCpuPlatform: "Intel Sandy Bridge".
  /// For more information, read Specifying a Minimum CPU Platform.
  core.String? minCpuPlatform;

  /// An array of network access configurations for this interface.
  core.List<NetworkInterface>? networkInterfaces;

  /// Note that for MachineImage, this is not supported yet.
  NetworkPerformanceConfig? networkPerformanceConfig;

  /// The private IPv6 google access type for VMs.
  ///
  /// If not specified, use INHERIT_FROM_SUBNETWORK as default. Note that for
  /// MachineImage, this is not supported yet.
  /// Possible string values are:
  /// - "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE" : Bidirectional private IPv6
  /// access to/from Google services. If specified, the subnetwork who is
  /// attached to the instance's default network interface will be assigned an
  /// internal IPv6 prefix if it doesn't have before.
  /// - "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE" : Outbound private IPv6 access
  /// from VMs in this subnet to Google services. If specified, the subnetwork
  /// who is attached to the instance's default network interface will be
  /// assigned an internal IPv6 prefix if it doesn't have before.
  /// - "INHERIT_FROM_SUBNETWORK" : Each network interface inherits
  /// PrivateIpv6GoogleAccess from its subnetwork.
  core.String? privateIpv6GoogleAccess;

  /// Specifies the reservations that instances can consume from.
  ///
  /// Note that for MachineImage, this is not supported yet.
  ReservationAffinity? reservationAffinity;

  /// Resource manager tags to be bound to the instance.
  ///
  /// Tag keys and values have the same definition as resource manager tags.
  /// Keys must be in the format `tagKeys/{tag_key_id}`, and values are in the
  /// format `tagValues/456`. The field is ignored (both PUT & PATCH) when
  /// empty.
  core.Map<core.String, core.String>? resourceManagerTags;

  /// Resource policies (names, not URLs) applied to instances created from
  /// these properties.
  ///
  /// Note that for MachineImage, this is not supported yet.
  core.List<core.String>? resourcePolicies;

  /// Specifies the scheduling options for the instances that are created from
  /// these properties.
  Scheduling? scheduling;

  /// A list of service accounts with specified scopes.
  ///
  /// Access tokens for these service accounts are available to the instances
  /// that are created from these properties. Use metadata queries to obtain the
  /// access tokens for these instances.
  core.List<ServiceAccount>? serviceAccounts;

  /// Note that for MachineImage, this is not supported yet.
  ShieldedInstanceConfig? shieldedInstanceConfig;

  /// A list of tags to apply to the instances that are created from these
  /// properties.
  ///
  /// The tags identify valid sources or targets for network firewalls. The
  /// setTags method can modify this list of tags. Each tag within the list must
  /// comply with RFC1035.
  Tags? tags;

  InstanceProperties({
    this.advancedMachineFeatures,
    this.canIpForward,
    this.confidentialInstanceConfig,
    this.description,
    this.disks,
    this.guestAccelerators,
    this.keyRevocationActionType,
    this.labels,
    this.machineType,
    this.metadata,
    this.minCpuPlatform,
    this.networkInterfaces,
    this.networkPerformanceConfig,
    this.privateIpv6GoogleAccess,
    this.reservationAffinity,
    this.resourceManagerTags,
    this.resourcePolicies,
    this.scheduling,
    this.serviceAccounts,
    this.shieldedInstanceConfig,
    this.tags,
  });

  InstanceProperties.fromJson(core.Map json_)
      : this(
          advancedMachineFeatures: json_.containsKey('advancedMachineFeatures')
              ? AdvancedMachineFeatures.fromJson(
                  json_['advancedMachineFeatures']
                      as core.Map<core.String, core.dynamic>)
              : null,
          canIpForward: json_.containsKey('canIpForward')
              ? json_['canIpForward'] as core.bool
              : null,
          confidentialInstanceConfig:
              json_.containsKey('confidentialInstanceConfig')
                  ? ConfidentialInstanceConfig.fromJson(
                      json_['confidentialInstanceConfig']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => AttachedDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          guestAccelerators: json_.containsKey('guestAccelerators')
              ? (json_['guestAccelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          keyRevocationActionType: json_.containsKey('keyRevocationActionType')
              ? json_['keyRevocationActionType'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          machineType: json_.containsKey('machineType')
              ? json_['machineType'] as core.String
              : null,
          metadata: json_.containsKey('metadata')
              ? Metadata.fromJson(
                  json_['metadata'] as core.Map<core.String, core.dynamic>)
              : null,
          minCpuPlatform: json_.containsKey('minCpuPlatform')
              ? json_['minCpuPlatform'] as core.String
              : null,
          networkInterfaces: json_.containsKey('networkInterfaces')
              ? (json_['networkInterfaces'] as core.List)
                  .map((value) => NetworkInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          networkPerformanceConfig:
              json_.containsKey('networkPerformanceConfig')
                  ? NetworkPerformanceConfig.fromJson(
                      json_['networkPerformanceConfig']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          privateIpv6GoogleAccess: json_.containsKey('privateIpv6GoogleAccess')
              ? json_['privateIpv6GoogleAccess'] as core.String
              : null,
          reservationAffinity: json_.containsKey('reservationAffinity')
              ? ReservationAffinity.fromJson(json_['reservationAffinity']
                  as core.Map<core.String, core.dynamic>)
              : null,
          resourceManagerTags: json_.containsKey('resourceManagerTags')
              ? (json_['resourceManagerTags']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          scheduling: json_.containsKey('scheduling')
              ? Scheduling.fromJson(
                  json_['scheduling'] as core.Map<core.String, core.dynamic>)
              : null,
          serviceAccounts: json_.containsKey('serviceAccounts')
              ? (json_['serviceAccounts'] as core.List)
                  .map((value) => ServiceAccount.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          shieldedInstanceConfig: json_.containsKey('shieldedInstanceConfig')
              ? ShieldedInstanceConfig.fromJson(json_['shieldedInstanceConfig']
                  as core.Map<core.String, core.dynamic>)
              : null,
          tags: json_.containsKey('tags')
              ? Tags.fromJson(
                  json_['tags'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (advancedMachineFeatures != null)
          'advancedMachineFeatures': advancedMachineFeatures!,
        if (canIpForward != null) 'canIpForward': canIpForward!,
        if (confidentialInstanceConfig != null)
          'confidentialInstanceConfig': confidentialInstanceConfig!,
        if (description != null) 'description': description!,
        if (disks != null) 'disks': disks!,
        if (guestAccelerators != null) 'guestAccelerators': guestAccelerators!,
        if (keyRevocationActionType != null)
          'keyRevocationActionType': keyRevocationActionType!,
        if (labels != null) 'labels': labels!,
        if (machineType != null) 'machineType': machineType!,
        if (metadata != null) 'metadata': metadata!,
        if (minCpuPlatform != null) 'minCpuPlatform': minCpuPlatform!,
        if (networkInterfaces != null) 'networkInterfaces': networkInterfaces!,
        if (networkPerformanceConfig != null)
          'networkPerformanceConfig': networkPerformanceConfig!,
        if (privateIpv6GoogleAccess != null)
          'privateIpv6GoogleAccess': privateIpv6GoogleAccess!,
        if (reservationAffinity != null)
          'reservationAffinity': reservationAffinity!,
        if (resourceManagerTags != null)
          'resourceManagerTags': resourceManagerTags!,
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
        if (scheduling != null) 'scheduling': scheduling!,
        if (serviceAccounts != null) 'serviceAccounts': serviceAccounts!,
        if (shieldedInstanceConfig != null)
          'shieldedInstanceConfig': shieldedInstanceConfig!,
        if (tags != null) 'tags': tags!,
      };
}

class InstanceReference {
  /// The URL for a specific instance.
  ///
  /// @required compute.instancegroups.addInstances/removeInstances
  core.String? instance;

  InstanceReference({
    this.instance,
  });

  InstanceReference.fromJson(core.Map json_)
      : this(
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instance != null) 'instance': instance!,
      };
}

/// Represents an Instance Template resource.
///
/// You can use instance templates to create VM instances and managed instance
/// groups. For more information, read Instance Templates.
class InstanceTemplate {
  /// The creation timestamp for this instance template in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// A unique identifier for this instance template.
  ///
  /// The server defines this identifier.
  ///
  /// Output only.
  core.String? id;

  /// The resource type, which is always compute#instanceTemplate for instance
  /// templates.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// The instance properties for this instance template.
  InstanceProperties? properties;

  /// The URL for this instance template.
  ///
  /// The server defines this URL.
  ///
  /// Output only.
  core.String? selfLink;

  /// The source instance used to create the template.
  ///
  /// You can provide this as a partial or full URL to the resource. For
  /// example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /instances/instance - projects/project/zones/zone/instances/instance
  core.String? sourceInstance;

  /// The source instance params to use to create this instance template.
  SourceInstanceParams? sourceInstanceParams;

  InstanceTemplate({
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.properties,
    this.selfLink,
    this.sourceInstance,
    this.sourceInstanceParams,
  });

  InstanceTemplate.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          properties: json_.containsKey('properties')
              ? InstanceProperties.fromJson(
                  json_['properties'] as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sourceInstance: json_.containsKey('sourceInstance')
              ? json_['sourceInstance'] as core.String
              : null,
          sourceInstanceParams: json_.containsKey('sourceInstanceParams')
              ? SourceInstanceParams.fromJson(json_['sourceInstanceParams']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (properties != null) 'properties': properties!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sourceInstance != null) 'sourceInstance': sourceInstance!,
        if (sourceInstanceParams != null)
          'sourceInstanceParams': sourceInstanceParams!,
      };
}

class InstanceTemplateListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstanceTemplateListWarningData({
    this.key,
    this.value,
  });

  InstanceTemplateListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InstanceTemplateListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstanceTemplateListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstanceTemplateListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstanceTemplateListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstanceTemplateListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of instance templates.
class InstanceTemplateList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceTemplate resources.
  core.List<InstanceTemplate>? items;

  /// The resource type, which is always compute#instanceTemplatesListResponse
  /// for instance template lists.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InstanceTemplateListWarning? warning;

  InstanceTemplateList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InstanceTemplateList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceTemplate.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InstanceTemplateListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class InstanceWithNamedPorts {
  /// The URL of the instance.
  ///
  /// Output only.
  core.String? instance;

  /// The named ports that belong to this instance group.
  ///
  /// Output only.
  core.List<NamedPort>? namedPorts;

  /// The status of the instance.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DEPROVISIONING" : The Nanny is halted and we are performing tear down
  /// tasks like network deprogramming, releasing quota, IP, tearing down disks
  /// etc.
  /// - "PROVISIONING" : Resources are being allocated for the instance.
  /// - "REPAIRING" : The instance is in repair.
  /// - "RUNNING" : The instance is running.
  /// - "STAGING" : All required resources have been allocated and the instance
  /// is being started.
  /// - "STOPPED" : The instance has stopped successfully.
  /// - "STOPPING" : The instance is currently stopping (either being deleted or
  /// killed).
  /// - "SUSPENDED" : The instance has suspended.
  /// - "SUSPENDING" : The instance is suspending.
  /// - "TERMINATED" : The instance has stopped (either by explicit action or
  /// underlying failure).
  core.String? status;

  InstanceWithNamedPorts({
    this.instance,
    this.namedPorts,
    this.status,
  });

  InstanceWithNamedPorts.fromJson(core.Map json_)
      : this(
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          namedPorts: json_.containsKey('namedPorts')
              ? (json_['namedPorts'] as core.List)
                  .map((value) => NamedPort.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instance != null) 'instance': instance!,
        if (namedPorts != null) 'namedPorts': namedPorts!,
        if (status != null) 'status': status!,
      };
}

class InstancesAddResourcePoliciesRequest {
  /// Resource policies to be added to this instance.
  core.List<core.String>? resourcePolicies;

  InstancesAddResourcePoliciesRequest({
    this.resourcePolicies,
  });

  InstancesAddResourcePoliciesRequest.fromJson(core.Map json_)
      : this(
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
      };
}

class InstancesGetEffectiveFirewallsResponse {
  /// Effective firewalls from firewall policies.
  core.List<InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>?
      firewallPolicys;

  /// Effective firewalls on the instance.
  core.List<Firewall>? firewalls;

  InstancesGetEffectiveFirewallsResponse({
    this.firewallPolicys,
    this.firewalls,
  });

  InstancesGetEffectiveFirewallsResponse.fromJson(core.Map json_)
      : this(
          firewallPolicys: json_.containsKey('firewallPolicys')
              ? (json_['firewallPolicys'] as core.List)
                  .map((value) =>
                      InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          firewalls: json_.containsKey('firewalls')
              ? (json_['firewalls'] as core.List)
                  .map((value) => Firewall.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (firewallPolicys != null) 'firewallPolicys': firewallPolicys!,
        if (firewalls != null) 'firewalls': firewalls!,
      };
}

class InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy {
  /// Deprecated, please use short name instead.
  ///
  /// The display name of the firewall policy.
  ///
  /// Output only.
  core.String? displayName;

  /// The name of the firewall policy.
  ///
  /// Output only.
  core.String? name;

  /// The rules that apply to the network.
  core.List<FirewallPolicyRule>? rules;

  /// The short name of the firewall policy.
  ///
  /// Output only.
  core.String? shortName;

  /// The type of the firewall policy.
  ///
  /// Can be one of HIERARCHY, NETWORK, NETWORK_REGIONAL.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "HIERARCHY"
  /// - "NETWORK"
  /// - "NETWORK_REGIONAL"
  /// - "UNSPECIFIED"
  core.String? type;

  InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy({
    this.displayName,
    this.name,
    this.rules,
    this.shortName,
    this.type,
  });

  InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromJson(
      core.Map json_)
      : this(
          displayName: json_.containsKey('displayName')
              ? json_['displayName'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => FirewallPolicyRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          shortName: json_.containsKey('shortName')
              ? json_['shortName'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (displayName != null) 'displayName': displayName!,
        if (name != null) 'name': name!,
        if (rules != null) 'rules': rules!,
        if (shortName != null) 'shortName': shortName!,
        if (type != null) 'type': type!,
      };
}

class InstancesRemoveResourcePoliciesRequest {
  /// Resource policies to be removed from this instance.
  core.List<core.String>? resourcePolicies;

  InstancesRemoveResourcePoliciesRequest({
    this.resourcePolicies,
  });

  InstancesRemoveResourcePoliciesRequest.fromJson(core.Map json_)
      : this(
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
      };
}

class InstancesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InstancesScopedListWarningData({
    this.key,
    this.value,
  });

  InstancesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of instances when the list is
/// empty.
///
/// Output only.
class InstancesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InstancesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InstancesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InstancesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InstancesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InstancesScopedList {
  /// A list of instances contained in this scope.
  ///
  /// Output only.
  core.List<Instance>? instances;

  /// Informational warning which replaces the list of instances when the list
  /// is empty.
  ///
  /// Output only.
  InstancesScopedListWarning? warning;

  InstancesScopedList({
    this.instances,
    this.warning,
  });

  InstancesScopedList.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => Instance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InstancesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
        if (warning != null) 'warning': warning!,
      };
}

class InstancesSetLabelsRequest {
  /// Fingerprint of the previous set of labels for this resource, used to
  /// prevent conflicts.
  ///
  /// Provide the latest fingerprint value when making a request to add or
  /// change labels.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  core.Map<core.String, core.String>? labels;

  InstancesSetLabelsRequest({
    this.labelFingerprint,
    this.labels,
  });

  InstancesSetLabelsRequest.fromJson(core.Map json_)
      : this(
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
      };
}

class InstancesSetMachineResourcesRequest {
  /// A list of the type and count of accelerator cards attached to the
  /// instance.
  core.List<AcceleratorConfig>? guestAccelerators;

  InstancesSetMachineResourcesRequest({
    this.guestAccelerators,
  });

  InstancesSetMachineResourcesRequest.fromJson(core.Map json_)
      : this(
          guestAccelerators: json_.containsKey('guestAccelerators')
              ? (json_['guestAccelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (guestAccelerators != null) 'guestAccelerators': guestAccelerators!,
      };
}

class InstancesSetMachineTypeRequest {
  /// Full or partial URL of the machine type resource.
  ///
  /// See Machine Types for a full list of machine types. For example:
  /// zones/us-central1-f/machineTypes/n1-standard-1
  core.String? machineType;

  InstancesSetMachineTypeRequest({
    this.machineType,
  });

  InstancesSetMachineTypeRequest.fromJson(core.Map json_)
      : this(
          machineType: json_.containsKey('machineType')
              ? json_['machineType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (machineType != null) 'machineType': machineType!,
      };
}

class InstancesSetMinCpuPlatformRequest {
  /// Minimum cpu/platform this instance should be started at.
  core.String? minCpuPlatform;

  InstancesSetMinCpuPlatformRequest({
    this.minCpuPlatform,
  });

  InstancesSetMinCpuPlatformRequest.fromJson(core.Map json_)
      : this(
          minCpuPlatform: json_.containsKey('minCpuPlatform')
              ? json_['minCpuPlatform'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (minCpuPlatform != null) 'minCpuPlatform': minCpuPlatform!,
      };
}

typedef InstancesSetServiceAccountRequest = $Shared02;

class InstancesStartWithEncryptionKeyRequest {
  /// Array of disks associated with this instance that are protected with a
  /// customer-supplied encryption key.
  ///
  /// In order to start the instance, the disk url and its corresponding key
  /// must be provided. If the disk is not protected with a customer-supplied
  /// encryption key it should not be specified.
  core.List<CustomerEncryptionKeyProtectedDisk>? disks;

  InstancesStartWithEncryptionKeyRequest({
    this.disks,
  });

  InstancesStartWithEncryptionKeyRequest.fromJson(core.Map json_)
      : this(
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => CustomerEncryptionKeyProtectedDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (disks != null) 'disks': disks!,
      };
}

/// HttpRouteRuleMatch criteria for field values that must stay within the
/// specified integer range.
class Int64RangeMatch {
  /// The end of the range (exclusive) in signed long integer format.
  core.String? rangeEnd;

  /// The start of the range (inclusive) in signed long integer format.
  core.String? rangeStart;

  Int64RangeMatch({
    this.rangeEnd,
    this.rangeStart,
  });

  Int64RangeMatch.fromJson(core.Map json_)
      : this(
          rangeEnd: json_.containsKey('rangeEnd')
              ? json_['rangeEnd'] as core.String
              : null,
          rangeStart: json_.containsKey('rangeStart')
              ? json_['rangeStart'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (rangeEnd != null) 'rangeEnd': rangeEnd!,
        if (rangeStart != null) 'rangeStart': rangeStart!,
      };
}

/// Represents an Interconnect resource.
///
/// An Interconnect resource is a dedicated connection between the GCP network
/// and your on-premises network. For more information, read the Dedicated
/// Interconnect Overview.
class Interconnect {
  /// Administrative status of the interconnect.
  ///
  /// When this is set to true, the Interconnect is functional and can carry
  /// traffic. When set to false, no packets can be carried over the
  /// interconnect and no BGP routes are exchanged over it. By default, the
  /// status is set to true.
  core.bool? adminEnabled;

  /// A list of CircuitInfo objects, that describe the individual circuits in
  /// this LAG.
  ///
  /// Output only.
  core.List<InterconnectCircuitInfo>? circuitInfos;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Customer name, to put in the Letter of Authorization as the party
  /// authorized to request a crossconnect.
  core.String? customerName;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// A list of outages expected for this Interconnect.
  ///
  /// Output only.
  core.List<InterconnectOutageNotification>? expectedOutages;

  /// IP address configured on the Google side of the Interconnect link.
  ///
  /// This can be used only for ping tests.
  ///
  /// Output only.
  core.String? googleIpAddress;

  /// Google reference ID to be used when raising support tickets with Google or
  /// otherwise to debug backend connectivity issues.
  ///
  /// Output only.
  core.String? googleReferenceId;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of the URLs of all InterconnectAttachments configured to use this
  /// Interconnect.
  ///
  /// Output only.
  core.List<core.String>? interconnectAttachments;

  /// Type of interconnect, which can take one of the following values: -
  /// PARTNER: A partner-managed interconnection shared between customers though
  /// a partner.
  ///
  /// - DEDICATED: A dedicated physical interconnection with the customer. Note
  /// that a value IT_PRIVATE has been deprecated in favor of DEDICATED.
  /// Possible string values are:
  /// - "DEDICATED" : A dedicated physical interconnection with the customer.
  /// - "IT_PRIVATE" : \[Deprecated\] A private, physical interconnection with
  /// the customer.
  /// - "PARTNER" : A partner-managed interconnection shared between customers
  /// via partner.
  core.String? interconnectType;

  /// Type of the resource.
  ///
  /// Always compute#interconnect for interconnects.
  ///
  /// Output only.
  core.String? kind;

  /// Type of link requested, which can take one of the following values: -
  /// LINK_TYPE_ETHERNET_10G_LR: A 10G Ethernet with LR optics -
  /// LINK_TYPE_ETHERNET_100G_LR: A 100G Ethernet with LR optics.
  ///
  /// Note that this field indicates the speed of each of the links in the
  /// bundle, not the speed of the entire bundle.
  /// Possible string values are:
  /// - "LINK_TYPE_ETHERNET_100G_LR" : 100G Ethernet, LR Optics.
  /// - "LINK_TYPE_ETHERNET_10G_LR" : 10G Ethernet, LR Optics. \[(rate_bps) =
  /// 10000000000\];
  core.String? linkType;

  /// URL of the InterconnectLocation object that represents where this
  /// connection is to be provisioned.
  core.String? location;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Email address to contact the customer NOC for operations and maintenance
  /// notifications regarding this Interconnect.
  ///
  /// If specified, this will be used for notifications in addition to all other
  /// forms described, such as Stackdriver logs alerting and Cloud
  /// Notifications.
  core.String? nocContactEmail;

  /// The current status of this Interconnect's functionality, which can take
  /// one of the following values: - OS_ACTIVE: A valid Interconnect, which is
  /// turned up and is ready to use.
  ///
  /// Attachments may be provisioned on this Interconnect. - OS_UNPROVISIONED:
  /// An Interconnect that has not completed turnup. No attachments may be
  /// provisioned on this Interconnect. - OS_UNDER_MAINTENANCE: An Interconnect
  /// that is undergoing internal maintenance. No attachments may be provisioned
  /// or updated on this Interconnect.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "OS_ACTIVE" : The interconnect is valid, turned up, and ready to use.
  /// Attachments may be provisioned on this interconnect.
  /// - "OS_UNPROVISIONED" : The interconnect has not completed turnup. No
  /// attachments may be provisioned on this interconnect.
  core.String? operationalStatus;

  /// IP address configured on the customer side of the Interconnect link.
  ///
  /// The customer should configure this IP address during turnup when prompted
  /// by Google NOC. This can be used only for ping tests.
  ///
  /// Output only.
  core.String? peerIpAddress;

  /// Number of links actually provisioned in this interconnect.
  ///
  /// Output only.
  core.int? provisionedLinkCount;

  /// Target number of physical links in the link bundle, as requested by the
  /// customer.
  core.int? requestedLinkCount;

  /// Set to true if the resource satisfies the zone separation organization
  /// policy constraints and false otherwise.
  ///
  /// Defaults to false if the field is not present.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The current state of Interconnect functionality, which can take one of the
  /// following values: - ACTIVE: The Interconnect is valid, turned up and ready
  /// to use.
  ///
  /// Attachments may be provisioned on this Interconnect. - UNPROVISIONED: The
  /// Interconnect has not completed turnup. No attachments may be provisioned
  /// on this Interconnect. - UNDER_MAINTENANCE: The Interconnect is undergoing
  /// internal maintenance. No attachments may be provisioned or updated on this
  /// Interconnect.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : The interconnect is valid, turned up, and ready to use.
  /// Attachments may be provisioned on this interconnect.
  /// - "UNPROVISIONED" : The interconnect has not completed turnup. No
  /// attachments may be provisioned on this interconnect.
  core.String? state;

  Interconnect({
    this.adminEnabled,
    this.circuitInfos,
    this.creationTimestamp,
    this.customerName,
    this.description,
    this.expectedOutages,
    this.googleIpAddress,
    this.googleReferenceId,
    this.id,
    this.interconnectAttachments,
    this.interconnectType,
    this.kind,
    this.linkType,
    this.location,
    this.name,
    this.nocContactEmail,
    this.operationalStatus,
    this.peerIpAddress,
    this.provisionedLinkCount,
    this.requestedLinkCount,
    this.satisfiesPzs,
    this.selfLink,
    this.state,
  });

  Interconnect.fromJson(core.Map json_)
      : this(
          adminEnabled: json_.containsKey('adminEnabled')
              ? json_['adminEnabled'] as core.bool
              : null,
          circuitInfos: json_.containsKey('circuitInfos')
              ? (json_['circuitInfos'] as core.List)
                  .map((value) => InterconnectCircuitInfo.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          customerName: json_.containsKey('customerName')
              ? json_['customerName'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          expectedOutages: json_.containsKey('expectedOutages')
              ? (json_['expectedOutages'] as core.List)
                  .map((value) => InterconnectOutageNotification.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          googleIpAddress: json_.containsKey('googleIpAddress')
              ? json_['googleIpAddress'] as core.String
              : null,
          googleReferenceId: json_.containsKey('googleReferenceId')
              ? json_['googleReferenceId'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          interconnectAttachments: json_.containsKey('interconnectAttachments')
              ? (json_['interconnectAttachments'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          interconnectType: json_.containsKey('interconnectType')
              ? json_['interconnectType'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          linkType: json_.containsKey('linkType')
              ? json_['linkType'] as core.String
              : null,
          location: json_.containsKey('location')
              ? json_['location'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          nocContactEmail: json_.containsKey('nocContactEmail')
              ? json_['nocContactEmail'] as core.String
              : null,
          operationalStatus: json_.containsKey('operationalStatus')
              ? json_['operationalStatus'] as core.String
              : null,
          peerIpAddress: json_.containsKey('peerIpAddress')
              ? json_['peerIpAddress'] as core.String
              : null,
          provisionedLinkCount: json_.containsKey('provisionedLinkCount')
              ? json_['provisionedLinkCount'] as core.int
              : null,
          requestedLinkCount: json_.containsKey('requestedLinkCount')
              ? json_['requestedLinkCount'] as core.int
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (adminEnabled != null) 'adminEnabled': adminEnabled!,
        if (circuitInfos != null) 'circuitInfos': circuitInfos!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (customerName != null) 'customerName': customerName!,
        if (description != null) 'description': description!,
        if (expectedOutages != null) 'expectedOutages': expectedOutages!,
        if (googleIpAddress != null) 'googleIpAddress': googleIpAddress!,
        if (googleReferenceId != null) 'googleReferenceId': googleReferenceId!,
        if (id != null) 'id': id!,
        if (interconnectAttachments != null)
          'interconnectAttachments': interconnectAttachments!,
        if (interconnectType != null) 'interconnectType': interconnectType!,
        if (kind != null) 'kind': kind!,
        if (linkType != null) 'linkType': linkType!,
        if (location != null) 'location': location!,
        if (name != null) 'name': name!,
        if (nocContactEmail != null) 'nocContactEmail': nocContactEmail!,
        if (operationalStatus != null) 'operationalStatus': operationalStatus!,
        if (peerIpAddress != null) 'peerIpAddress': peerIpAddress!,
        if (provisionedLinkCount != null)
          'provisionedLinkCount': provisionedLinkCount!,
        if (requestedLinkCount != null)
          'requestedLinkCount': requestedLinkCount!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (state != null) 'state': state!,
      };
}

/// Represents an Interconnect Attachment (VLAN) resource.
///
/// You can use Interconnect attachments (VLANS) to connect your Virtual Private
/// Cloud networks to your on-premises networks through an Interconnect. For
/// more information, read Creating VLAN Attachments.
class InterconnectAttachment {
  /// Determines whether this Attachment will carry packets.
  ///
  /// Not present for PARTNER_PROVIDER.
  core.bool? adminEnabled;

  /// Provisioned bandwidth capacity for the interconnect attachment.
  ///
  /// For attachments of type DEDICATED, the user can set the bandwidth. For
  /// attachments of type PARTNER, the Google Partner that is operating the
  /// interconnect must set the bandwidth. Output only for PARTNER type, mutable
  /// for PARTNER_PROVIDER and DEDICATED, and can take one of the following
  /// values: - BPS_50M: 50 Mbit/s - BPS_100M: 100 Mbit/s - BPS_200M: 200 Mbit/s
  /// - BPS_300M: 300 Mbit/s - BPS_400M: 400 Mbit/s - BPS_500M: 500 Mbit/s -
  /// BPS_1G: 1 Gbit/s - BPS_2G: 2 Gbit/s - BPS_5G: 5 Gbit/s - BPS_10G: 10
  /// Gbit/s - BPS_20G: 20 Gbit/s - BPS_50G: 50 Gbit/s
  /// Possible string values are:
  /// - "BPS_100M" : 100 Mbit/s
  /// - "BPS_10G" : 10 Gbit/s
  /// - "BPS_1G" : 1 Gbit/s
  /// - "BPS_200M" : 200 Mbit/s
  /// - "BPS_20G" : 20 Gbit/s
  /// - "BPS_2G" : 2 Gbit/s
  /// - "BPS_300M" : 300 Mbit/s
  /// - "BPS_400M" : 400 Mbit/s
  /// - "BPS_500M" : 500 Mbit/s
  /// - "BPS_50G" : 50 Gbit/s
  /// - "BPS_50M" : 50 Mbit/s
  /// - "BPS_5G" : 5 Gbit/s
  core.String? bandwidth;

  /// This field is not available.
  core.List<core.String>? candidateIpv6Subnets;

  /// Up to 16 candidate prefixes that can be used to restrict the allocation of
  /// cloudRouterIpAddress and customerRouterIpAddress for this attachment.
  ///
  /// All prefixes must be within link-local address space (169.254.0.0/16) and
  /// must be /29 or shorter (/28, /27, etc). Google will attempt to select an
  /// unused /29 from the supplied candidate prefix(es). The request will fail
  /// if all possible /29s are in use on Google's edge. If not supplied, Google
  /// will randomly select an unused /29 from all of link-local space.
  core.List<core.String>? candidateSubnets;

  /// IPv4 address + prefix length to be configured on Cloud Router Interface
  /// for this interconnect attachment.
  ///
  /// Output only.
  core.String? cloudRouterIpAddress;

  /// IPv6 address + prefix length to be configured on Cloud Router Interface
  /// for this interconnect attachment.
  ///
  /// Output only.
  core.String? cloudRouterIpv6Address;

  /// This field is not available.
  core.String? cloudRouterIpv6InterfaceId;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// IPv4 address + prefix length to be configured on the customer router
  /// subinterface for this interconnect attachment.
  ///
  /// Output only.
  core.String? customerRouterIpAddress;

  /// IPv6 address + prefix length to be configured on the customer router
  /// subinterface for this interconnect attachment.
  ///
  /// Output only.
  core.String? customerRouterIpv6Address;

  /// This field is not available.
  core.String? customerRouterIpv6InterfaceId;

  /// Dataplane version for this InterconnectAttachment.
  ///
  /// This field is only present for Dataplane version 2 and higher. Absence of
  /// this field in the API output indicates that the Dataplane is version 1.
  ///
  /// Output only.
  core.int? dataplaneVersion;

  /// An optional description of this resource.
  core.String? description;

  /// Desired availability domain for the attachment.
  ///
  /// Only available for type PARTNER, at creation time, and can take one of the
  /// following values: - AVAILABILITY_DOMAIN_ANY - AVAILABILITY_DOMAIN_1 -
  /// AVAILABILITY_DOMAIN_2 For improved reliability, customers should configure
  /// a pair of attachments, one per availability domain. The selected
  /// availability domain will be provided to the Partner via the pairing key,
  /// so that the provisioned circuit will lie in the specified domain. If not
  /// specified, the value will default to AVAILABILITY_DOMAIN_ANY.
  /// Possible string values are:
  /// - "AVAILABILITY_DOMAIN_1"
  /// - "AVAILABILITY_DOMAIN_2"
  /// - "AVAILABILITY_DOMAIN_ANY"
  core.String? edgeAvailabilityDomain;

  /// Indicates the user-supplied encryption option of this VLAN attachment
  /// (interconnectAttachment).
  ///
  /// Can only be specified at attachment creation for PARTNER or DEDICATED
  /// attachments. Possible values are: - NONE - This is the default value,
  /// which means that the VLAN attachment carries unencrypted traffic. VMs are
  /// able to send traffic to, or receive traffic from, such a VLAN attachment.
  /// - IPSEC - The VLAN attachment carries only encrypted traffic that is
  /// encrypted by an IPsec device, such as an HA VPN gateway or third-party
  /// IPsec VPN. VMs cannot directly send traffic to, or receive traffic from,
  /// such a VLAN attachment. To use *HA VPN over Cloud Interconnect*, the VLAN
  /// attachment must be created with this option.
  /// Possible string values are:
  /// - "IPSEC" : The interconnect attachment will carry only encrypted traffic
  /// that is encrypted by an IPsec device such as HA VPN gateway; VMs cannot
  /// directly send traffic to or receive traffic from such an interconnect
  /// attachment. To use HA VPN over Cloud Interconnect, the interconnect
  /// attachment must be created with this option.
  /// - "NONE" : This is the default value, which means the Interconnect
  /// Attachment will carry unencrypted traffic. VMs will be able to send
  /// traffic to or receive traffic from such interconnect attachment.
  core.String? encryption;

  /// Google reference ID, to be used when raising support tickets with Google
  /// or otherwise to debug backend connectivity issues.
  ///
  /// \[Deprecated\] This field is not used.
  ///
  /// Output only.
  core.String? googleReferenceId;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// URL of the underlying Interconnect object that this attachment's traffic
  /// will traverse through.
  core.String? interconnect;

  /// A list of URLs of addresses that have been reserved for the VLAN
  /// attachment.
  ///
  /// Used only for the VLAN attachment that has the encryption option as IPSEC.
  /// The addresses must be regional internal IP address ranges. When creating
  /// an HA VPN gateway over the VLAN attachment, if the attachment is
  /// configured to use a regional internal IP address, then the VPN gateway's
  /// IP address is allocated from the IP address range specified here. For
  /// example, if the HA VPN gateway's interface 0 is paired to this VLAN
  /// attachment, then a regional internal IP address for the VPN gateway
  /// interface 0 will be allocated from the IP address specified for this VLAN
  /// attachment. If this field is not specified when creating the VLAN
  /// attachment, then later on when creating an HA VPN gateway on this VLAN
  /// attachment, the HA VPN gateway's IP address is allocated from the regional
  /// external IP address pool. Not currently available publicly.
  core.List<core.String>? ipsecInternalAddresses;

  /// Type of the resource.
  ///
  /// Always compute#interconnectAttachment for interconnect attachments.
  ///
  /// Output only.
  core.String? kind;

  /// Maximum Transmission Unit (MTU), in bytes, of packets passing through this
  /// interconnect attachment.
  ///
  /// Only 1440 and 1500 are allowed. If not specified, the value will default
  /// to 1440.
  core.int? mtu;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The current status of whether or not this interconnect attachment is
  /// functional, which can take one of the following values: - OS_ACTIVE: The
  /// attachment has been turned up and is ready to use.
  ///
  /// - OS_UNPROVISIONED: The attachment is not ready to use yet, because turnup
  /// is not complete.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "OS_ACTIVE" : Indicates that attachment has been turned up and is ready
  /// to use.
  /// - "OS_UNPROVISIONED" : Indicates that attachment is not ready to use yet,
  /// because turnup is not complete.
  core.String? operationalStatus;

  /// \[Output only for type PARTNER.
  ///
  /// Input only for PARTNER_PROVIDER. Not present for DEDICATED\]. The opaque
  /// identifier of an PARTNER attachment used to initiate provisioning with a
  /// selected partner. Of the form "XXXXX/region/domain"
  core.String? pairingKey;

  /// Optional BGP ASN for the router supplied by a Layer 3 Partner if they
  /// configured BGP on behalf of the customer.
  ///
  /// Output only for PARTNER type, input only for PARTNER_PROVIDER, not
  /// available for DEDICATED.
  core.String? partnerAsn;

  /// Informational metadata about Partner attachments from Partners to display
  /// to customers.
  ///
  /// Output only for for PARTNER type, mutable for PARTNER_PROVIDER, not
  /// available for DEDICATED.
  InterconnectAttachmentPartnerMetadata? partnerMetadata;

  /// Information specific to an InterconnectAttachment.
  ///
  /// This property is populated if the interconnect that this is attached to is
  /// of type DEDICATED.
  ///
  /// Output only.
  InterconnectAttachmentPrivateInfo? privateInterconnectInfo;

  /// URL of the region where the regional interconnect attachment resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// URL of the Cloud Router to be used for dynamic routing.
  ///
  /// This router must be in the same region as this InterconnectAttachment. The
  /// InterconnectAttachment will automatically connect the Interconnect to the
  /// network & region within which the Cloud Router is configured.
  core.String? router;

  /// Set to true if the resource satisfies the zone separation organization
  /// policy constraints and false otherwise.
  ///
  /// Defaults to false if the field is not present.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The stack type for this interconnect attachment to identify whether the
  /// IPv6 feature is enabled or not.
  ///
  /// If not specified, IPV4_ONLY will be used. This field can be both set at
  /// interconnect attachments creation and update interconnect attachment
  /// operations.
  /// Possible string values are:
  /// - "IPV4_IPV6" : The interconnect attachment can have both IPv4 and IPv6
  /// addresses.
  /// - "IPV4_ONLY" : The interconnect attachment will only be assigned IPv4
  /// addresses.
  core.String? stackType;

  /// The current state of this attachment's functionality.
  ///
  /// Enum values ACTIVE and UNPROVISIONED are shared by DEDICATED/PRIVATE,
  /// PARTNER, and PARTNER_PROVIDER interconnect attachments, while enum values
  /// PENDING_PARTNER, PARTNER_REQUEST_RECEIVED, and PENDING_CUSTOMER are used
  /// for only PARTNER and PARTNER_PROVIDER interconnect attachments. This state
  /// can take one of the following values: - ACTIVE: The attachment has been
  /// turned up and is ready to use. - UNPROVISIONED: The attachment is not
  /// ready to use yet, because turnup is not complete. - PENDING_PARTNER: A
  /// newly-created PARTNER attachment that has not yet been configured on the
  /// Partner side. - PARTNER_REQUEST_RECEIVED: A PARTNER attachment is in the
  /// process of provisioning after a PARTNER_PROVIDER attachment was created
  /// that references it. - PENDING_CUSTOMER: A PARTNER or PARTNER_PROVIDER
  /// attachment that is waiting for a customer to activate it. - DEFUNCT: The
  /// attachment was deleted externally and is no longer functional. This could
  /// be because the associated Interconnect was removed, or because the other
  /// side of a Partner attachment was deleted.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : Indicates that attachment has been turned up and is ready to
  /// use.
  /// - "DEFUNCT" : The attachment was deleted externally and is no longer
  /// functional. This could be because the associated Interconnect was wiped
  /// out, or because the other side of a Partner attachment was deleted.
  /// - "PARTNER_REQUEST_RECEIVED" : A PARTNER attachment is in the process of
  /// provisioning after a PARTNER_PROVIDER attachment was created that
  /// references it.
  /// - "PENDING_CUSTOMER" : PARTNER or PARTNER_PROVIDER attachment that is
  /// waiting for the customer to activate.
  /// - "PENDING_PARTNER" : A newly created PARTNER attachment that has not yet
  /// been configured on the Partner side.
  /// - "STATE_UNSPECIFIED"
  /// - "UNPROVISIONED" : Indicates that attachment is not ready to use yet,
  /// because turnup is not complete.
  core.String? state;

  /// The type of interconnect attachment this is, which can take one of the
  /// following values: - DEDICATED: an attachment to a Dedicated Interconnect.
  ///
  /// - PARTNER: an attachment to a Partner Interconnect, created by the
  /// customer. - PARTNER_PROVIDER: an attachment to a Partner Interconnect,
  /// created by the partner.
  /// Possible string values are:
  /// - "DEDICATED" : Attachment to a dedicated interconnect.
  /// - "PARTNER" : Attachment to a partner interconnect, created by the
  /// customer.
  /// - "PARTNER_PROVIDER" : Attachment to a partner interconnect, created by
  /// the partner.
  core.String? type;

  /// The IEEE 802.1Q VLAN tag for this attachment, in the range 2-4094.
  ///
  /// Only specified at creation time.
  core.int? vlanTag8021q;

  InterconnectAttachment({
    this.adminEnabled,
    this.bandwidth,
    this.candidateIpv6Subnets,
    this.candidateSubnets,
    this.cloudRouterIpAddress,
    this.cloudRouterIpv6Address,
    this.cloudRouterIpv6InterfaceId,
    this.creationTimestamp,
    this.customerRouterIpAddress,
    this.customerRouterIpv6Address,
    this.customerRouterIpv6InterfaceId,
    this.dataplaneVersion,
    this.description,
    this.edgeAvailabilityDomain,
    this.encryption,
    this.googleReferenceId,
    this.id,
    this.interconnect,
    this.ipsecInternalAddresses,
    this.kind,
    this.mtu,
    this.name,
    this.operationalStatus,
    this.pairingKey,
    this.partnerAsn,
    this.partnerMetadata,
    this.privateInterconnectInfo,
    this.region,
    this.router,
    this.satisfiesPzs,
    this.selfLink,
    this.stackType,
    this.state,
    this.type,
    this.vlanTag8021q,
  });

  InterconnectAttachment.fromJson(core.Map json_)
      : this(
          adminEnabled: json_.containsKey('adminEnabled')
              ? json_['adminEnabled'] as core.bool
              : null,
          bandwidth: json_.containsKey('bandwidth')
              ? json_['bandwidth'] as core.String
              : null,
          candidateIpv6Subnets: json_.containsKey('candidateIpv6Subnets')
              ? (json_['candidateIpv6Subnets'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          candidateSubnets: json_.containsKey('candidateSubnets')
              ? (json_['candidateSubnets'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          cloudRouterIpAddress: json_.containsKey('cloudRouterIpAddress')
              ? json_['cloudRouterIpAddress'] as core.String
              : null,
          cloudRouterIpv6Address: json_.containsKey('cloudRouterIpv6Address')
              ? json_['cloudRouterIpv6Address'] as core.String
              : null,
          cloudRouterIpv6InterfaceId:
              json_.containsKey('cloudRouterIpv6InterfaceId')
                  ? json_['cloudRouterIpv6InterfaceId'] as core.String
                  : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          customerRouterIpAddress: json_.containsKey('customerRouterIpAddress')
              ? json_['customerRouterIpAddress'] as core.String
              : null,
          customerRouterIpv6Address:
              json_.containsKey('customerRouterIpv6Address')
                  ? json_['customerRouterIpv6Address'] as core.String
                  : null,
          customerRouterIpv6InterfaceId:
              json_.containsKey('customerRouterIpv6InterfaceId')
                  ? json_['customerRouterIpv6InterfaceId'] as core.String
                  : null,
          dataplaneVersion: json_.containsKey('dataplaneVersion')
              ? json_['dataplaneVersion'] as core.int
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          edgeAvailabilityDomain: json_.containsKey('edgeAvailabilityDomain')
              ? json_['edgeAvailabilityDomain'] as core.String
              : null,
          encryption: json_.containsKey('encryption')
              ? json_['encryption'] as core.String
              : null,
          googleReferenceId: json_.containsKey('googleReferenceId')
              ? json_['googleReferenceId'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          interconnect: json_.containsKey('interconnect')
              ? json_['interconnect'] as core.String
              : null,
          ipsecInternalAddresses: json_.containsKey('ipsecInternalAddresses')
              ? (json_['ipsecInternalAddresses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          mtu: json_.containsKey('mtu') ? json_['mtu'] as core.int : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          operationalStatus: json_.containsKey('operationalStatus')
              ? json_['operationalStatus'] as core.String
              : null,
          pairingKey: json_.containsKey('pairingKey')
              ? json_['pairingKey'] as core.String
              : null,
          partnerAsn: json_.containsKey('partnerAsn')
              ? json_['partnerAsn'] as core.String
              : null,
          partnerMetadata: json_.containsKey('partnerMetadata')
              ? InterconnectAttachmentPartnerMetadata.fromJson(
                  json_['partnerMetadata']
                      as core.Map<core.String, core.dynamic>)
              : null,
          privateInterconnectInfo: json_.containsKey('privateInterconnectInfo')
              ? InterconnectAttachmentPrivateInfo.fromJson(
                  json_['privateInterconnectInfo']
                      as core.Map<core.String, core.dynamic>)
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          router: json_.containsKey('router')
              ? json_['router'] as core.String
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
          vlanTag8021q: json_.containsKey('vlanTag8021q')
              ? json_['vlanTag8021q'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (adminEnabled != null) 'adminEnabled': adminEnabled!,
        if (bandwidth != null) 'bandwidth': bandwidth!,
        if (candidateIpv6Subnets != null)
          'candidateIpv6Subnets': candidateIpv6Subnets!,
        if (candidateSubnets != null) 'candidateSubnets': candidateSubnets!,
        if (cloudRouterIpAddress != null)
          'cloudRouterIpAddress': cloudRouterIpAddress!,
        if (cloudRouterIpv6Address != null)
          'cloudRouterIpv6Address': cloudRouterIpv6Address!,
        if (cloudRouterIpv6InterfaceId != null)
          'cloudRouterIpv6InterfaceId': cloudRouterIpv6InterfaceId!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (customerRouterIpAddress != null)
          'customerRouterIpAddress': customerRouterIpAddress!,
        if (customerRouterIpv6Address != null)
          'customerRouterIpv6Address': customerRouterIpv6Address!,
        if (customerRouterIpv6InterfaceId != null)
          'customerRouterIpv6InterfaceId': customerRouterIpv6InterfaceId!,
        if (dataplaneVersion != null) 'dataplaneVersion': dataplaneVersion!,
        if (description != null) 'description': description!,
        if (edgeAvailabilityDomain != null)
          'edgeAvailabilityDomain': edgeAvailabilityDomain!,
        if (encryption != null) 'encryption': encryption!,
        if (googleReferenceId != null) 'googleReferenceId': googleReferenceId!,
        if (id != null) 'id': id!,
        if (interconnect != null) 'interconnect': interconnect!,
        if (ipsecInternalAddresses != null)
          'ipsecInternalAddresses': ipsecInternalAddresses!,
        if (kind != null) 'kind': kind!,
        if (mtu != null) 'mtu': mtu!,
        if (name != null) 'name': name!,
        if (operationalStatus != null) 'operationalStatus': operationalStatus!,
        if (pairingKey != null) 'pairingKey': pairingKey!,
        if (partnerAsn != null) 'partnerAsn': partnerAsn!,
        if (partnerMetadata != null) 'partnerMetadata': partnerMetadata!,
        if (privateInterconnectInfo != null)
          'privateInterconnectInfo': privateInterconnectInfo!,
        if (region != null) 'region': region!,
        if (router != null) 'router': router!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (stackType != null) 'stackType': stackType!,
        if (state != null) 'state': state!,
        if (type != null) 'type': type!,
        if (vlanTag8021q != null) 'vlanTag8021q': vlanTag8021q!,
      };
}

class InterconnectAttachmentAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InterconnectAttachmentAggregatedListWarningData({
    this.key,
    this.value,
  });

  InterconnectAttachmentAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InterconnectAttachmentAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InterconnectAttachmentAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InterconnectAttachmentAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InterconnectAttachmentAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InterconnectAttachmentAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InterconnectAttachmentAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InterconnectAttachmentsScopedList resources.
  core.Map<core.String, InterconnectAttachmentsScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#interconnectAttachmentAggregatedList for aggregated lists
  /// of interconnect attachments.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  InterconnectAttachmentAggregatedListWarning? warning;

  InterconnectAttachmentAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  InterconnectAttachmentAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    InterconnectAttachmentsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InterconnectAttachmentAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class InterconnectAttachmentListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InterconnectAttachmentListWarningData({
    this.key,
    this.value,
  });

  InterconnectAttachmentListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InterconnectAttachmentListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InterconnectAttachmentListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InterconnectAttachmentListWarning({
    this.code,
    this.data,
    this.message,
  });

  InterconnectAttachmentListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InterconnectAttachmentListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Response to the list request, and contains a list of interconnect
/// attachments.
class InterconnectAttachmentList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InterconnectAttachment resources.
  core.List<InterconnectAttachment>? items;

  /// Type of resource.
  ///
  /// Always compute#interconnectAttachmentList for lists of interconnect
  /// attachments.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InterconnectAttachmentListWarning? warning;

  InterconnectAttachmentList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InterconnectAttachmentList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InterconnectAttachment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InterconnectAttachmentListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Informational metadata about Partner attachments from Partners to display to
/// customers.
///
/// These fields are propagated from PARTNER_PROVIDER attachments to their
/// corresponding PARTNER attachments.
class InterconnectAttachmentPartnerMetadata {
  /// Plain text name of the Interconnect this attachment is connected to, as
  /// displayed in the Partner's portal.
  ///
  /// For instance "Chicago 1". This value may be validated to match approved
  /// Partner values.
  core.String? interconnectName;

  /// Plain text name of the Partner providing this attachment.
  ///
  /// This value may be validated to match approved Partner values.
  core.String? partnerName;

  /// URL of the Partner's portal for this Attachment.
  ///
  /// Partners may customise this to be a deep link to the specific resource on
  /// the Partner portal. This value may be validated to match approved Partner
  /// values.
  core.String? portalUrl;

  InterconnectAttachmentPartnerMetadata({
    this.interconnectName,
    this.partnerName,
    this.portalUrl,
  });

  InterconnectAttachmentPartnerMetadata.fromJson(core.Map json_)
      : this(
          interconnectName: json_.containsKey('interconnectName')
              ? json_['interconnectName'] as core.String
              : null,
          partnerName: json_.containsKey('partnerName')
              ? json_['partnerName'] as core.String
              : null,
          portalUrl: json_.containsKey('portalUrl')
              ? json_['portalUrl'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (interconnectName != null) 'interconnectName': interconnectName!,
        if (partnerName != null) 'partnerName': partnerName!,
        if (portalUrl != null) 'portalUrl': portalUrl!,
      };
}

/// Information for an interconnect attachment when this belongs to an
/// interconnect of type DEDICATED.
class InterconnectAttachmentPrivateInfo {
  /// 802.1q encapsulation tag to be used for traffic between Google and the
  /// customer, going to and from this network and region.
  ///
  /// Output only.
  core.int? tag8021q;

  InterconnectAttachmentPrivateInfo({
    this.tag8021q,
  });

  InterconnectAttachmentPrivateInfo.fromJson(core.Map json_)
      : this(
          tag8021q: json_.containsKey('tag8021q')
              ? json_['tag8021q'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (tag8021q != null) 'tag8021q': tag8021q!,
      };
}

class InterconnectAttachmentsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InterconnectAttachmentsScopedListWarningData({
    this.key,
    this.value,
  });

  InterconnectAttachmentsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
class InterconnectAttachmentsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InterconnectAttachmentsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InterconnectAttachmentsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  InterconnectAttachmentsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      InterconnectAttachmentsScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class InterconnectAttachmentsScopedList {
  /// A list of interconnect attachments contained in this scope.
  core.List<InterconnectAttachment>? interconnectAttachments;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  InterconnectAttachmentsScopedListWarning? warning;

  InterconnectAttachmentsScopedList({
    this.interconnectAttachments,
    this.warning,
  });

  InterconnectAttachmentsScopedList.fromJson(core.Map json_)
      : this(
          interconnectAttachments: json_.containsKey('interconnectAttachments')
              ? (json_['interconnectAttachments'] as core.List)
                  .map((value) => InterconnectAttachment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? InterconnectAttachmentsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (interconnectAttachments != null)
          'interconnectAttachments': interconnectAttachments!,
        if (warning != null) 'warning': warning!,
      };
}

/// Describes a single physical circuit between the Customer and Google.
///
/// CircuitInfo objects are created by Google, so all fields are output only.
class InterconnectCircuitInfo {
  /// Customer-side demarc ID for this circuit.
  core.String? customerDemarcId;

  /// Google-assigned unique ID for this circuit.
  ///
  /// Assigned at circuit turn-up.
  core.String? googleCircuitId;

  /// Google-side demarc ID for this circuit.
  ///
  /// Assigned at circuit turn-up and provided by Google to the customer in the
  /// LOA.
  core.String? googleDemarcId;

  InterconnectCircuitInfo({
    this.customerDemarcId,
    this.googleCircuitId,
    this.googleDemarcId,
  });

  InterconnectCircuitInfo.fromJson(core.Map json_)
      : this(
          customerDemarcId: json_.containsKey('customerDemarcId')
              ? json_['customerDemarcId'] as core.String
              : null,
          googleCircuitId: json_.containsKey('googleCircuitId')
              ? json_['googleCircuitId'] as core.String
              : null,
          googleDemarcId: json_.containsKey('googleDemarcId')
              ? json_['googleDemarcId'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (customerDemarcId != null) 'customerDemarcId': customerDemarcId!,
        if (googleCircuitId != null) 'googleCircuitId': googleCircuitId!,
        if (googleDemarcId != null) 'googleDemarcId': googleDemarcId!,
      };
}

/// Diagnostics information about interconnect, contains detailed and current
/// technical information about Google's side of the connection.
class InterconnectDiagnostics {
  /// A list of InterconnectDiagnostics.ARPEntry objects, describing individual
  /// neighbors currently seen by the Google router in the ARP cache for the
  /// Interconnect.
  ///
  /// This will be empty when the Interconnect is not bundled.
  core.List<InterconnectDiagnosticsARPEntry>? arpCaches;

  /// A list of InterconnectDiagnostics.LinkStatus objects, describing the
  /// status for each link on the Interconnect.
  core.List<InterconnectDiagnosticsLinkStatus>? links;

  /// The MAC address of the Interconnect's bundle interface.
  core.String? macAddress;

  InterconnectDiagnostics({
    this.arpCaches,
    this.links,
    this.macAddress,
  });

  InterconnectDiagnostics.fromJson(core.Map json_)
      : this(
          arpCaches: json_.containsKey('arpCaches')
              ? (json_['arpCaches'] as core.List)
                  .map((value) => InterconnectDiagnosticsARPEntry.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          links: json_.containsKey('links')
              ? (json_['links'] as core.List)
                  .map((value) => InterconnectDiagnosticsLinkStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          macAddress: json_.containsKey('macAddress')
              ? json_['macAddress'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (arpCaches != null) 'arpCaches': arpCaches!,
        if (links != null) 'links': links!,
        if (macAddress != null) 'macAddress': macAddress!,
      };
}

/// Describing the ARP neighbor entries seen on this link
class InterconnectDiagnosticsARPEntry {
  /// The IP address of this ARP neighbor.
  core.String? ipAddress;

  /// The MAC address of this ARP neighbor.
  core.String? macAddress;

  InterconnectDiagnosticsARPEntry({
    this.ipAddress,
    this.macAddress,
  });

  InterconnectDiagnosticsARPEntry.fromJson(core.Map json_)
      : this(
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
          macAddress: json_.containsKey('macAddress')
              ? json_['macAddress'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipAddress != null) 'ipAddress': ipAddress!,
        if (macAddress != null) 'macAddress': macAddress!,
      };
}

class InterconnectDiagnosticsLinkLACPStatus {
  /// System ID of the port on Google's side of the LACP exchange.
  core.String? googleSystemId;

  /// System ID of the port on the neighbor's side of the LACP exchange.
  core.String? neighborSystemId;

  /// The state of a LACP link, which can take one of the following values: -
  /// ACTIVE: The link is configured and active within the bundle.
  ///
  /// - DETACHED: The link is not configured within the bundle. This means that
  /// the rest of the object should be empty.
  /// Possible string values are:
  /// - "ACTIVE" : The link is configured and active within the bundle.
  /// - "DETACHED" : The link is not configured within the bundle, this means
  /// the rest of the object should be empty.
  core.String? state;

  InterconnectDiagnosticsLinkLACPStatus({
    this.googleSystemId,
    this.neighborSystemId,
    this.state,
  });

  InterconnectDiagnosticsLinkLACPStatus.fromJson(core.Map json_)
      : this(
          googleSystemId: json_.containsKey('googleSystemId')
              ? json_['googleSystemId'] as core.String
              : null,
          neighborSystemId: json_.containsKey('neighborSystemId')
              ? json_['neighborSystemId'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (googleSystemId != null) 'googleSystemId': googleSystemId!,
        if (neighborSystemId != null) 'neighborSystemId': neighborSystemId!,
        if (state != null) 'state': state!,
      };
}

class InterconnectDiagnosticsLinkOpticalPower {
  /// The status of the current value when compared to the warning and alarm
  /// levels for the receiving or transmitting transceiver.
  ///
  /// Possible states include: - OK: The value has not crossed a warning
  /// threshold. - LOW_WARNING: The value has crossed below the low warning
  /// threshold. - HIGH_WARNING: The value has crossed above the high warning
  /// threshold. - LOW_ALARM: The value has crossed below the low alarm
  /// threshold. - HIGH_ALARM: The value has crossed above the high alarm
  /// threshold.
  /// Possible string values are:
  /// - "HIGH_ALARM" : The value has crossed above the high alarm threshold.
  /// - "HIGH_WARNING" : The value of the current optical power has crossed
  /// above the high warning threshold.
  /// - "LOW_ALARM" : The value of the current optical power has crossed below
  /// the low alarm threshold.
  /// - "LOW_WARNING" : The value of the current optical power has crossed below
  /// the low warning threshold.
  /// - "OK" : The value of the current optical power has not crossed a warning
  /// threshold.
  core.String? state;

  /// Value of the current receiving or transmitting optical power, read in dBm.
  ///
  /// Take a known good optical value, give it a 10% margin and trigger warnings
  /// relative to that value. In general, a -7dBm warning and a -11dBm alarm are
  /// good optical value estimates for most links.
  core.double? value;

  InterconnectDiagnosticsLinkOpticalPower({
    this.state,
    this.value,
  });

  InterconnectDiagnosticsLinkOpticalPower.fromJson(core.Map json_)
      : this(
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          value: json_.containsKey('value')
              ? (json_['value'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (state != null) 'state': state!,
        if (value != null) 'value': value!,
      };
}

class InterconnectDiagnosticsLinkStatus {
  /// A list of InterconnectDiagnostics.ARPEntry objects, describing the ARP
  /// neighbor entries seen on this link.
  ///
  /// This will be empty if the link is bundled
  core.List<InterconnectDiagnosticsARPEntry>? arpCaches;

  /// The unique ID for this link assigned during turn up by Google.
  core.String? circuitId;

  /// The Demarc address assigned by Google and provided in the LoA.
  core.String? googleDemarc;
  InterconnectDiagnosticsLinkLACPStatus? lacpStatus;

  /// An InterconnectDiagnostics.LinkOpticalPower object, describing the current
  /// value and status of the received light level.
  InterconnectDiagnosticsLinkOpticalPower? receivingOpticalPower;

  /// An InterconnectDiagnostics.LinkOpticalPower object, describing the current
  /// value and status of the transmitted light level.
  InterconnectDiagnosticsLinkOpticalPower? transmittingOpticalPower;

  InterconnectDiagnosticsLinkStatus({
    this.arpCaches,
    this.circuitId,
    this.googleDemarc,
    this.lacpStatus,
    this.receivingOpticalPower,
    this.transmittingOpticalPower,
  });

  InterconnectDiagnosticsLinkStatus.fromJson(core.Map json_)
      : this(
          arpCaches: json_.containsKey('arpCaches')
              ? (json_['arpCaches'] as core.List)
                  .map((value) => InterconnectDiagnosticsARPEntry.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          circuitId: json_.containsKey('circuitId')
              ? json_['circuitId'] as core.String
              : null,
          googleDemarc: json_.containsKey('googleDemarc')
              ? json_['googleDemarc'] as core.String
              : null,
          lacpStatus: json_.containsKey('lacpStatus')
              ? InterconnectDiagnosticsLinkLACPStatus.fromJson(
                  json_['lacpStatus'] as core.Map<core.String, core.dynamic>)
              : null,
          receivingOpticalPower: json_.containsKey('receivingOpticalPower')
              ? InterconnectDiagnosticsLinkOpticalPower.fromJson(
                  json_['receivingOpticalPower']
                      as core.Map<core.String, core.dynamic>)
              : null,
          transmittingOpticalPower:
              json_.containsKey('transmittingOpticalPower')
                  ? InterconnectDiagnosticsLinkOpticalPower.fromJson(
                      json_['transmittingOpticalPower']
                          as core.Map<core.String, core.dynamic>)
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (arpCaches != null) 'arpCaches': arpCaches!,
        if (circuitId != null) 'circuitId': circuitId!,
        if (googleDemarc != null) 'googleDemarc': googleDemarc!,
        if (lacpStatus != null) 'lacpStatus': lacpStatus!,
        if (receivingOpticalPower != null)
          'receivingOpticalPower': receivingOpticalPower!,
        if (transmittingOpticalPower != null)
          'transmittingOpticalPower': transmittingOpticalPower!,
      };
}

class InterconnectListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InterconnectListWarningData({
    this.key,
    this.value,
  });

  InterconnectListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InterconnectListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InterconnectListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InterconnectListWarning({
    this.code,
    this.data,
    this.message,
  });

  InterconnectListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InterconnectListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Response to the list request, and contains a list of interconnects.
class InterconnectList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Interconnect resources.
  core.List<Interconnect>? items;

  /// Type of resource.
  ///
  /// Always compute#interconnectList for lists of interconnects.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InterconnectListWarning? warning;

  InterconnectList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InterconnectList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Interconnect.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InterconnectListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents an Interconnect Attachment (VLAN) Location resource.
///
/// You can use this resource to find location details about an Interconnect
/// attachment (VLAN). For more information about interconnect attachments, read
/// Creating VLAN Attachments.
class InterconnectLocation {
  /// The postal address of the Point of Presence, each line in the address is
  /// separated by a newline character.
  ///
  /// Output only.
  core.String? address;

  /// Availability zone for this InterconnectLocation.
  ///
  /// Within a metropolitan area (metro), maintenance will not be simultaneously
  /// scheduled in more than one availability zone. Example: "zone1" or "zone2".
  ///
  /// Output only.
  core.String? availabilityZone;

  /// Metropolitan area designator that indicates which city an interconnect is
  /// located.
  ///
  /// For example: "Chicago, IL", "Amsterdam, Netherlands".
  ///
  /// Output only.
  core.String? city;

  /// Continent for this location, which can take one of the following values: -
  /// AFRICA - ASIA_PAC - EUROPE - NORTH_AMERICA - SOUTH_AMERICA
  ///
  /// Output only.
  /// Possible string values are:
  /// - "AFRICA"
  /// - "ASIA_PAC"
  /// - "C_AFRICA"
  /// - "C_ASIA_PAC"
  /// - "C_EUROPE"
  /// - "C_NORTH_AMERICA"
  /// - "C_SOUTH_AMERICA"
  /// - "EUROPE"
  /// - "NORTH_AMERICA"
  /// - "SOUTH_AMERICA"
  core.String? continent;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The name of the provider for this facility (e.g., EQUINIX).
  ///
  /// Output only.
  core.String? facilityProvider;

  /// A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).
  ///
  /// Output only.
  core.String? facilityProviderFacilityId;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#interconnectLocation for interconnect locations.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// The peeringdb identifier for this facility (corresponding with a netfac
  /// type in peeringdb).
  ///
  /// Output only.
  core.String? peeringdbFacilityId;

  /// A list of InterconnectLocation.RegionInfo objects, that describe
  /// parameters pertaining to the relation between this InterconnectLocation
  /// and various Google Cloud regions.
  ///
  /// Output only.
  core.List<InterconnectLocationRegionInfo>? regionInfos;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The status of this InterconnectLocation, which can take one of the
  /// following values: - CLOSED: The InterconnectLocation is closed and is
  /// unavailable for provisioning new Interconnects.
  ///
  /// - AVAILABLE: The InterconnectLocation is available for provisioning new
  /// Interconnects.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "AVAILABLE" : The InterconnectLocation is available for provisioning new
  /// Interconnects.
  /// - "CLOSED" : The InterconnectLocation is closed for provisioning new
  /// Interconnects.
  core.String? status;

  /// Set to true for locations that support physical zone separation.
  ///
  /// Defaults to false if the field is not present.
  ///
  /// Output only.
  core.bool? supportsPzs;

  InterconnectLocation({
    this.address,
    this.availabilityZone,
    this.city,
    this.continent,
    this.creationTimestamp,
    this.description,
    this.facilityProvider,
    this.facilityProviderFacilityId,
    this.id,
    this.kind,
    this.name,
    this.peeringdbFacilityId,
    this.regionInfos,
    this.selfLink,
    this.status,
    this.supportsPzs,
  });

  InterconnectLocation.fromJson(core.Map json_)
      : this(
          address: json_.containsKey('address')
              ? json_['address'] as core.String
              : null,
          availabilityZone: json_.containsKey('availabilityZone')
              ? json_['availabilityZone'] as core.String
              : null,
          city: json_.containsKey('city') ? json_['city'] as core.String : null,
          continent: json_.containsKey('continent')
              ? json_['continent'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          facilityProvider: json_.containsKey('facilityProvider')
              ? json_['facilityProvider'] as core.String
              : null,
          facilityProviderFacilityId:
              json_.containsKey('facilityProviderFacilityId')
                  ? json_['facilityProviderFacilityId'] as core.String
                  : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          peeringdbFacilityId: json_.containsKey('peeringdbFacilityId')
              ? json_['peeringdbFacilityId'] as core.String
              : null,
          regionInfos: json_.containsKey('regionInfos')
              ? (json_['regionInfos'] as core.List)
                  .map((value) => InterconnectLocationRegionInfo.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          supportsPzs: json_.containsKey('supportsPzs')
              ? json_['supportsPzs'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (address != null) 'address': address!,
        if (availabilityZone != null) 'availabilityZone': availabilityZone!,
        if (city != null) 'city': city!,
        if (continent != null) 'continent': continent!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (facilityProvider != null) 'facilityProvider': facilityProvider!,
        if (facilityProviderFacilityId != null)
          'facilityProviderFacilityId': facilityProviderFacilityId!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (peeringdbFacilityId != null)
          'peeringdbFacilityId': peeringdbFacilityId!,
        if (regionInfos != null) 'regionInfos': regionInfos!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (supportsPzs != null) 'supportsPzs': supportsPzs!,
      };
}

class InterconnectLocationListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  InterconnectLocationListWarningData({
    this.key,
    this.value,
  });

  InterconnectLocationListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class InterconnectLocationListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<InterconnectLocationListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  InterconnectLocationListWarning({
    this.code,
    this.data,
    this.message,
  });

  InterconnectLocationListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => InterconnectLocationListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Response to the list request, and contains a list of interconnect locations.
class InterconnectLocationList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InterconnectLocation resources.
  core.List<InterconnectLocation>? items;

  /// Type of resource.
  ///
  /// Always compute#interconnectLocationList for lists of interconnect
  /// locations.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  InterconnectLocationListWarning? warning;

  InterconnectLocationList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  InterconnectLocationList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InterconnectLocation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? InterconnectLocationListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Information about any potential InterconnectAttachments between an
/// Interconnect at a specific InterconnectLocation, and a specific Cloud
/// Region.
class InterconnectLocationRegionInfo {
  /// Expected round-trip time in milliseconds, from this InterconnectLocation
  /// to a VM in this region.
  core.String? expectedRttMs;

  /// Identifies the network presence of this location.
  /// Possible string values are:
  /// - "GLOBAL" : This region is not in any common network presence with this
  /// InterconnectLocation.
  /// - "LOCAL_REGION" : This region shares the same regional network presence
  /// as this InterconnectLocation.
  /// - "LP_GLOBAL" : \[Deprecated\] This region is not in any common network
  /// presence with this InterconnectLocation.
  /// - "LP_LOCAL_REGION" : \[Deprecated\] This region shares the same regional
  /// network presence as this InterconnectLocation.
  core.String? locationPresence;

  /// URL for the region of this location.
  core.String? region;

  InterconnectLocationRegionInfo({
    this.expectedRttMs,
    this.locationPresence,
    this.region,
  });

  InterconnectLocationRegionInfo.fromJson(core.Map json_)
      : this(
          expectedRttMs: json_.containsKey('expectedRttMs')
              ? json_['expectedRttMs'] as core.String
              : null,
          locationPresence: json_.containsKey('locationPresence')
              ? json_['locationPresence'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (expectedRttMs != null) 'expectedRttMs': expectedRttMs!,
        if (locationPresence != null) 'locationPresence': locationPresence!,
        if (region != null) 'region': region!,
      };
}

/// Description of a planned outage on this Interconnect.
class InterconnectOutageNotification {
  /// If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs
  /// that will be affected.
  core.List<core.String>? affectedCircuits;

  /// A description about the purpose of the outage.
  core.String? description;

  /// Scheduled end time for the outage (milliseconds since Unix epoch).
  core.String? endTime;

  /// Form this outage is expected to take, which can take one of the following
  /// values: - OUTAGE: The Interconnect may be completely out of service for
  /// some or all of the specified window.
  ///
  /// - PARTIAL_OUTAGE: Some circuits comprising the Interconnect as a whole
  /// should remain up, but with reduced bandwidth. Note that the versions of
  /// this enum prefixed with "IT_" have been deprecated in favor of the
  /// unprefixed values.
  /// Possible string values are:
  /// - "IT_OUTAGE" : \[Deprecated\] The Interconnect may be completely out of
  /// service for some or all of the specified window.
  /// - "IT_PARTIAL_OUTAGE" : \[Deprecated\] Some circuits comprising the
  /// Interconnect will be out of service during the expected window. The
  /// interconnect as a whole should remain up, albeit with reduced bandwidth.
  /// - "OUTAGE" : The Interconnect may be completely out of service for some or
  /// all of the specified window.
  /// - "PARTIAL_OUTAGE" : Some circuits comprising the Interconnect will be out
  /// of service during the expected window. The interconnect as a whole should
  /// remain up, albeit with reduced bandwidth.
  core.String? issueType;

  /// Unique identifier for this outage notification.
  core.String? name;

  /// The party that generated this notification, which can take the following
  /// value: - GOOGLE: this notification as generated by Google.
  ///
  /// Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
  /// Possible string values are:
  /// - "GOOGLE" : This notification was generated by Google.
  /// - "NSRC_GOOGLE" : \[Deprecated\] This notification was generated by
  /// Google.
  core.String? source;

  /// Scheduled start time for the outage (milliseconds since Unix epoch).
  core.String? startTime;

  /// State of this notification, which can take one of the following values: -
  /// ACTIVE: This outage notification is active.
  ///
  /// The event could be in the past, present, or future. See start_time and
  /// end_time for scheduling. - CANCELLED: The outage associated with this
  /// notification was cancelled before the outage was due to start. -
  /// COMPLETED: The outage associated with this notification is complete. Note
  /// that the versions of this enum prefixed with "NS_" have been deprecated in
  /// favor of the unprefixed values.
  /// Possible string values are:
  /// - "ACTIVE" : This outage notification is active. The event could be in the
  /// future, present, or past. See start_time and end_time for scheduling.
  /// - "CANCELLED" : The outage associated with this notification was cancelled
  /// before the outage was due to start.
  /// - "COMPLETED" : The outage associated with this notification is complete.
  /// - "NS_ACTIVE" : \[Deprecated\] This outage notification is active. The
  /// event could be in the future, present, or past. See start_time and
  /// end_time for scheduling.
  /// - "NS_CANCELED" : \[Deprecated\] The outage associated with this
  /// notification was canceled before the outage was due to start.
  core.String? state;

  InterconnectOutageNotification({
    this.affectedCircuits,
    this.description,
    this.endTime,
    this.issueType,
    this.name,
    this.source,
    this.startTime,
    this.state,
  });

  InterconnectOutageNotification.fromJson(core.Map json_)
      : this(
          affectedCircuits: json_.containsKey('affectedCircuits')
              ? (json_['affectedCircuits'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          endTime: json_.containsKey('endTime')
              ? json_['endTime'] as core.String
              : null,
          issueType: json_.containsKey('issueType')
              ? json_['issueType'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (affectedCircuits != null) 'affectedCircuits': affectedCircuits!,
        if (description != null) 'description': description!,
        if (endTime != null) 'endTime': endTime!,
        if (issueType != null) 'issueType': issueType!,
        if (name != null) 'name': name!,
        if (source != null) 'source': source!,
        if (startTime != null) 'startTime': startTime!,
        if (state != null) 'state': state!,
      };
}

/// Response for the InterconnectsGetDiagnosticsRequest.
class InterconnectsGetDiagnosticsResponse {
  InterconnectDiagnostics? result;

  InterconnectsGetDiagnosticsResponse({
    this.result,
  });

  InterconnectsGetDiagnosticsResponse.fromJson(core.Map json_)
      : this(
          result: json_.containsKey('result')
              ? InterconnectDiagnostics.fromJson(
                  json_['result'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (result != null) 'result': result!,
      };
}

/// Represents a License resource.
///
/// A License represents billing and aggregate usage data for public and
/// marketplace images. *Caution* This resource is intended for use only by
/// third-party partners who are creating Cloud Marketplace images.
class License {
  /// This field no longer reflects whether a license charges a usage fee.
  ///
  /// Output only. Deprecated.
  core.bool? chargesUseFee;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional textual description of the resource; provided by the client
  /// when the resource is created.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#license for licenses.
  ///
  /// Output only.
  core.String? kind;

  /// The unique code used to attach this license to images, snapshots, and
  /// disks.
  ///
  /// Output only.
  core.String? licenseCode;

  /// Name of the resource.
  ///
  /// The name must be 1-63 characters long and comply with RFC1035.
  core.String? name;
  LicenseResourceRequirements? resourceRequirements;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// If false, licenses will not be copied from the source resource when
  /// creating an image from a disk, disk from snapshot, or snapshot from disk.
  core.bool? transferable;

  License({
    this.chargesUseFee,
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.licenseCode,
    this.name,
    this.resourceRequirements,
    this.selfLink,
    this.transferable,
  });

  License.fromJson(core.Map json_)
      : this(
          chargesUseFee: json_.containsKey('chargesUseFee')
              ? json_['chargesUseFee'] as core.bool
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          licenseCode: json_.containsKey('licenseCode')
              ? json_['licenseCode'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          resourceRequirements: json_.containsKey('resourceRequirements')
              ? LicenseResourceRequirements.fromJson(
                  json_['resourceRequirements']
                      as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          transferable: json_.containsKey('transferable')
              ? json_['transferable'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (chargesUseFee != null) 'chargesUseFee': chargesUseFee!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (licenseCode != null) 'licenseCode': licenseCode!,
        if (name != null) 'name': name!,
        if (resourceRequirements != null)
          'resourceRequirements': resourceRequirements!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (transferable != null) 'transferable': transferable!,
      };
}

/// Represents a License Code resource.
///
/// A License Code is a unique identifier used to represent a license resource.
/// *Caution* This resource is intended for use only by third-party partners who
/// are creating Cloud Marketplace images.
class LicenseCode {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// Description of this License Code.
  ///
  /// Output only.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#licenseCode for licenses.
  ///
  /// Output only.
  core.String? kind;

  /// URL and description aliases of Licenses with the same License Code.
  ///
  /// Output only.
  core.List<LicenseCodeLicenseAlias>? licenseAlias;

  /// Name of the resource.
  ///
  /// The name is 1-20 characters long and must be a valid 64 bit integer.
  ///
  /// Output only.
  core.String? name;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Current state of this License Code.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DISABLED" : Machines are not allowed to attach boot disks with this
  /// License Code. Requests to create new resources with this license will be
  /// rejected.
  /// - "ENABLED" : Use is allowed for anyone with USE_READ_ONLY access to this
  /// License Code.
  /// - "RESTRICTED" : Use of this license is limited to a project whitelist.
  /// - "STATE_UNSPECIFIED"
  /// - "TERMINATED" : Reserved state.
  core.String? state;

  /// If true, the license will remain attached when creating images or
  /// snapshots from disks.
  ///
  /// Otherwise, the license is not transferred.
  ///
  /// Output only.
  core.bool? transferable;

  LicenseCode({
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.licenseAlias,
    this.name,
    this.selfLink,
    this.state,
    this.transferable,
  });

  LicenseCode.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          licenseAlias: json_.containsKey('licenseAlias')
              ? (json_['licenseAlias'] as core.List)
                  .map((value) => LicenseCodeLicenseAlias.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          transferable: json_.containsKey('transferable')
              ? json_['transferable'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (licenseAlias != null) 'licenseAlias': licenseAlias!,
        if (name != null) 'name': name!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (state != null) 'state': state!,
        if (transferable != null) 'transferable': transferable!,
      };
}

class LicenseCodeLicenseAlias {
  /// Description of this License Code.
  ///
  /// Output only.
  core.String? description;

  /// URL of license corresponding to this License Code.
  ///
  /// Output only.
  core.String? selfLink;

  LicenseCodeLicenseAlias({
    this.description,
    this.selfLink,
  });

  LicenseCodeLicenseAlias.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// Commitment for a particular license resource.
class LicenseResourceCommitment {
  /// The number of licenses purchased.
  core.String? amount;

  /// Specifies the core range of the instance for which this license applies.
  core.String? coresPerLicense;

  /// Any applicable license URI.
  core.String? license;

  LicenseResourceCommitment({
    this.amount,
    this.coresPerLicense,
    this.license,
  });

  LicenseResourceCommitment.fromJson(core.Map json_)
      : this(
          amount: json_.containsKey('amount')
              ? json_['amount'] as core.String
              : null,
          coresPerLicense: json_.containsKey('coresPerLicense')
              ? json_['coresPerLicense'] as core.String
              : null,
          license: json_.containsKey('license')
              ? json_['license'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (amount != null) 'amount': amount!,
        if (coresPerLicense != null) 'coresPerLicense': coresPerLicense!,
        if (license != null) 'license': license!,
      };
}

class LicenseResourceRequirements {
  /// Minimum number of guest cpus required to use the Instance.
  ///
  /// Enforced at Instance creation and Instance start.
  core.int? minGuestCpuCount;

  /// Minimum memory required to use the Instance.
  ///
  /// Enforced at Instance creation and Instance start.
  core.int? minMemoryMb;

  LicenseResourceRequirements({
    this.minGuestCpuCount,
    this.minMemoryMb,
  });

  LicenseResourceRequirements.fromJson(core.Map json_)
      : this(
          minGuestCpuCount: json_.containsKey('minGuestCpuCount')
              ? json_['minGuestCpuCount'] as core.int
              : null,
          minMemoryMb: json_.containsKey('minMemoryMb')
              ? json_['minMemoryMb'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (minGuestCpuCount != null) 'minGuestCpuCount': minGuestCpuCount!,
        if (minMemoryMb != null) 'minMemoryMb': minMemoryMb!,
      };
}

class LicensesListResponseWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  LicensesListResponseWarningData({
    this.key,
    this.value,
  });

  LicensesListResponseWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class LicensesListResponseWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<LicensesListResponseWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  LicensesListResponseWarning({
    this.code,
    this.data,
    this.message,
  });

  LicensesListResponseWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => LicensesListResponseWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class LicensesListResponse {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of License resources.
  core.List<License>? items;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  LicensesListResponseWarning? warning;

  LicensesListResponse({
    this.id,
    this.items,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  LicensesListResponse.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => License.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? LicensesListResponseWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class LocalDisk {
  /// Specifies the number of such disks.
  core.int? diskCount;

  /// Specifies the size of the disk in base-2 GB.
  core.int? diskSizeGb;

  /// Specifies the desired disk type on the node.
  ///
  /// This disk type must be a local storage type (e.g.: local-ssd). Note that
  /// for nodeTemplates, this should be the name of the disk type and not its
  /// URL.
  core.String? diskType;

  LocalDisk({
    this.diskCount,
    this.diskSizeGb,
    this.diskType,
  });

  LocalDisk.fromJson(core.Map json_)
      : this(
          diskCount: json_.containsKey('diskCount')
              ? json_['diskCount'] as core.int
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.int
              : null,
          diskType: json_.containsKey('diskType')
              ? json_['diskType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskCount != null) 'diskCount': diskCount!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (diskType != null) 'diskType': diskType!,
      };
}

/// Provides a localized error message that is safe to return to the user which
/// can be attached to an RPC error.
class LocalizedMessage {
  /// The locale used following the specification defined at
  /// https://www.rfc-editor.org/rfc/bcp/bcp47.txt.
  ///
  /// Examples are: "en-US", "fr-CH", "es-MX"
  core.String? locale;

  /// The localized error message in the above locale.
  core.String? message;

  LocalizedMessage({
    this.locale,
    this.message,
  });

  LocalizedMessage.fromJson(core.Map json_)
      : this(
          locale: json_.containsKey('locale')
              ? json_['locale'] as core.String
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (locale != null) 'locale': locale!,
        if (message != null) 'message': message!,
      };
}

/// Configuration for location policy among multiple possible locations (e.g.
/// preferences for zone selection among zones in a single region).
class LocationPolicy {
  /// Location configurations mapped by location name.
  ///
  /// Currently only zone names are supported and must be represented as valid
  /// internal URLs, such as zones/us-central1-a.
  core.Map<core.String, LocationPolicyLocation>? locations;

  /// Strategy for distributing VMs across zones in a region.
  /// Possible string values are:
  /// - "ANY" : GCE picks zones for creating VM instances to fulfill the
  /// requested number of VMs within present resource constraints and to
  /// maximize utilization of unused zonal reservations. Recommended for batch
  /// workloads that do not require high availability.
  /// - "ANY_SINGLE_ZONE" : GCE always selects a single zone for all the VMs,
  /// optimizing for resource quotas, available reservations and general
  /// capacity. Recommended for batch workloads that cannot tollerate
  /// distribution over multiple zones. This the default shape in Bulk Insert
  /// and Capacity Advisor APIs.
  /// - "BALANCED" : GCE prioritizes acquisition of resources, scheduling VMs in
  /// zones where resources are available while distributing VMs as evenly as
  /// possible across allowed zones to minimize the impact of zonal failure.
  /// Recommended for highly available serving workloads.
  core.String? targetShape;

  LocationPolicy({
    this.locations,
    this.targetShape,
  });

  LocationPolicy.fromJson(core.Map json_)
      : this(
          locations: json_.containsKey('locations')
              ? (json_['locations'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    LocationPolicyLocation.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          targetShape: json_.containsKey('targetShape')
              ? json_['targetShape'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (locations != null) 'locations': locations!,
        if (targetShape != null) 'targetShape': targetShape!,
      };
}

class LocationPolicyLocation {
  /// Constraints that the caller requires on the result distribution in this
  /// zone.
  LocationPolicyLocationConstraints? constraints;

  /// Preference for a given location.
  ///
  /// Set to either ALLOW or DENY.
  /// Possible string values are:
  /// - "ALLOW" : Location is allowed for use.
  /// - "DENY" : Location is prohibited.
  /// - "PREFERENCE_UNSPECIFIED" : Default value, unused.
  core.String? preference;

  LocationPolicyLocation({
    this.constraints,
    this.preference,
  });

  LocationPolicyLocation.fromJson(core.Map json_)
      : this(
          constraints: json_.containsKey('constraints')
              ? LocationPolicyLocationConstraints.fromJson(
                  json_['constraints'] as core.Map<core.String, core.dynamic>)
              : null,
          preference: json_.containsKey('preference')
              ? json_['preference'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (constraints != null) 'constraints': constraints!,
        if (preference != null) 'preference': preference!,
      };
}

/// Per-zone constraints on location policy for this zone.
class LocationPolicyLocationConstraints {
  /// Maximum number of items that are allowed to be placed in this zone.
  ///
  /// The value must be non-negative.
  core.int? maxCount;

  LocationPolicyLocationConstraints({
    this.maxCount,
  });

  LocationPolicyLocationConstraints.fromJson(core.Map json_)
      : this(
          maxCount: json_.containsKey('maxCount')
              ? json_['maxCount'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maxCount != null) 'maxCount': maxCount!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class LogConfig {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  LogConfigCloudAuditOptions? cloudAudit;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  LogConfigCounterOptions? counter;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  LogConfigDataAccessOptions? dataAccess;

  LogConfig({
    this.cloudAudit,
    this.counter,
    this.dataAccess,
  });

  LogConfig.fromJson(core.Map json_)
      : this(
          cloudAudit: json_.containsKey('cloudAudit')
              ? LogConfigCloudAuditOptions.fromJson(
                  json_['cloudAudit'] as core.Map<core.String, core.dynamic>)
              : null,
          counter: json_.containsKey('counter')
              ? LogConfigCounterOptions.fromJson(
                  json_['counter'] as core.Map<core.String, core.dynamic>)
              : null,
          dataAccess: json_.containsKey('dataAccess')
              ? LogConfigDataAccessOptions.fromJson(
                  json_['dataAccess'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (cloudAudit != null) 'cloudAudit': cloudAudit!,
        if (counter != null) 'counter': counter!,
        if (dataAccess != null) 'dataAccess': dataAccess!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class LogConfigCloudAuditOptions {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  AuthorizationLoggingOptions? authorizationLoggingOptions;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "ADMIN_ACTIVITY" : This is deprecated and has no effect. Do not use.
  /// - "DATA_ACCESS" : This is deprecated and has no effect. Do not use.
  /// - "UNSPECIFIED_LOG_NAME" : This is deprecated and has no effect. Do not
  /// use.
  core.String? logName;

  LogConfigCloudAuditOptions({
    this.authorizationLoggingOptions,
    this.logName,
  });

  LogConfigCloudAuditOptions.fromJson(core.Map json_)
      : this(
          authorizationLoggingOptions:
              json_.containsKey('authorizationLoggingOptions')
                  ? AuthorizationLoggingOptions.fromJson(
                      json_['authorizationLoggingOptions']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          logName: json_.containsKey('logName')
              ? json_['logName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (authorizationLoggingOptions != null)
          'authorizationLoggingOptions': authorizationLoggingOptions!,
        if (logName != null) 'logName': logName!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class LogConfigCounterOptions {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<LogConfigCounterOptionsCustomField>? customFields;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? field;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? metric;

  LogConfigCounterOptions({
    this.customFields,
    this.field,
    this.metric,
  });

  LogConfigCounterOptions.fromJson(core.Map json_)
      : this(
          customFields: json_.containsKey('customFields')
              ? (json_['customFields'] as core.List)
                  .map((value) => LogConfigCounterOptionsCustomField.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          field:
              json_.containsKey('field') ? json_['field'] as core.String : null,
          metric: json_.containsKey('metric')
              ? json_['metric'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (customFields != null) 'customFields': customFields!,
        if (field != null) 'field': field!,
        if (metric != null) 'metric': metric!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class LogConfigCounterOptionsCustomField {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? name;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? value;

  LogConfigCounterOptionsCustomField({
    this.name,
    this.value,
  });

  LogConfigCounterOptionsCustomField.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (value != null) 'value': value!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class LogConfigDataAccessOptions {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "LOG_FAIL_CLOSED" : This is deprecated and has no effect. Do not use.
  /// - "LOG_MODE_UNSPECIFIED" : This is deprecated and has no effect. Do not
  /// use.
  core.String? logMode;

  LogConfigDataAccessOptions({
    this.logMode,
  });

  LogConfigDataAccessOptions.fromJson(core.Map json_)
      : this(
          logMode: json_.containsKey('logMode')
              ? json_['logMode'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (logMode != null) 'logMode': logMode!,
      };
}

/// Represents a machine image resource.
///
/// A machine image is a Compute Engine resource that stores all the
/// configuration, metadata, permissions, and data from one or more disks
/// required to create a Virtual machine (VM) instance. For more information,
/// see Machine images.
class MachineImage {
  /// The creation timestamp for this machine image in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// \[Input Only\] Whether to attempt an application consistent machine image
  /// by informing the OS to prepare for the snapshot process.
  core.bool? guestFlush;

  /// A unique identifier for this machine image.
  ///
  /// The server defines this identifier.
  ///
  /// Output only.
  core.String? id;

  /// Properties of source instance
  ///
  /// Output only.
  InstanceProperties? instanceProperties;

  /// The resource type, which is always compute#machineImage for machine image.
  ///
  /// Output only.
  core.String? kind;

  /// Encrypts the machine image using a customer-supplied encryption key.
  ///
  /// After you encrypt a machine image using a customer-supplied key, you must
  /// provide the same key if you use the machine image later. For example, you
  /// must provide the encryption key when you create an instance from the
  /// encrypted machine image in a future request. Customer-supplied encryption
  /// keys do not protect access to metadata of the machine image. If you do not
  /// provide an encryption key when creating the machine image, then the
  /// machine image will be encrypted using an automatically generated key and
  /// you do not need to provide a key to use the machine image later.
  CustomerEncryptionKey? machineImageEncryptionKey;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// An array of Machine Image specific properties for disks attached to the
  /// source instance
  core.List<SavedDisk>? savedDisks;

  /// The URL for this machine image.
  ///
  /// The server defines this URL.
  ///
  /// Output only.
  core.String? selfLink;

  /// \[Input Only\] The customer-supplied encryption key of the disks attached
  /// to the source instance.
  ///
  /// Required if the source disk is protected by a customer-supplied encryption
  /// key.
  core.List<SourceDiskEncryptionKey>? sourceDiskEncryptionKeys;

  /// The source instance used to create the machine image.
  ///
  /// You can provide this as a partial or full URL to the resource. For
  /// example, the following are valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /instances/instance - projects/project/zones/zone/instances/instance
  core.String? sourceInstance;

  /// DEPRECATED: Please use instance_properties instead for source instance
  /// related properties.
  ///
  /// New properties will not be added to this field.
  ///
  /// Output only.
  SourceInstanceProperties? sourceInstanceProperties;

  /// The status of the machine image.
  ///
  /// One of the following values: INVALID, CREATING, READY, DELETING, and
  /// UPLOADING.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING"
  /// - "DELETING"
  /// - "INVALID"
  /// - "READY"
  /// - "UPLOADING"
  core.String? status;

  /// The regional or multi-regional Cloud Storage bucket location where the
  /// machine image is stored.
  core.List<core.String>? storageLocations;

  /// Total size of the storage used by the machine image.
  ///
  /// Output only.
  core.String? totalStorageBytes;

  MachineImage({
    this.creationTimestamp,
    this.description,
    this.guestFlush,
    this.id,
    this.instanceProperties,
    this.kind,
    this.machineImageEncryptionKey,
    this.name,
    this.satisfiesPzs,
    this.savedDisks,
    this.selfLink,
    this.sourceDiskEncryptionKeys,
    this.sourceInstance,
    this.sourceInstanceProperties,
    this.status,
    this.storageLocations,
    this.totalStorageBytes,
  });

  MachineImage.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          guestFlush: json_.containsKey('guestFlush')
              ? json_['guestFlush'] as core.bool
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instanceProperties: json_.containsKey('instanceProperties')
              ? InstanceProperties.fromJson(json_['instanceProperties']
                  as core.Map<core.String, core.dynamic>)
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          machineImageEncryptionKey:
              json_.containsKey('machineImageEncryptionKey')
                  ? CustomerEncryptionKey.fromJson(
                      json_['machineImageEncryptionKey']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          savedDisks: json_.containsKey('savedDisks')
              ? (json_['savedDisks'] as core.List)
                  .map((value) => SavedDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sourceDiskEncryptionKeys:
              json_.containsKey('sourceDiskEncryptionKeys')
                  ? (json_['sourceDiskEncryptionKeys'] as core.List)
                      .map((value) => SourceDiskEncryptionKey.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                      .toList()
                  : null,
          sourceInstance: json_.containsKey('sourceInstance')
              ? json_['sourceInstance'] as core.String
              : null,
          sourceInstanceProperties:
              json_.containsKey('sourceInstanceProperties')
                  ? SourceInstanceProperties.fromJson(
                      json_['sourceInstanceProperties']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          storageLocations: json_.containsKey('storageLocations')
              ? (json_['storageLocations'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          totalStorageBytes: json_.containsKey('totalStorageBytes')
              ? json_['totalStorageBytes'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (guestFlush != null) 'guestFlush': guestFlush!,
        if (id != null) 'id': id!,
        if (instanceProperties != null)
          'instanceProperties': instanceProperties!,
        if (kind != null) 'kind': kind!,
        if (machineImageEncryptionKey != null)
          'machineImageEncryptionKey': machineImageEncryptionKey!,
        if (name != null) 'name': name!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (savedDisks != null) 'savedDisks': savedDisks!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sourceDiskEncryptionKeys != null)
          'sourceDiskEncryptionKeys': sourceDiskEncryptionKeys!,
        if (sourceInstance != null) 'sourceInstance': sourceInstance!,
        if (sourceInstanceProperties != null)
          'sourceInstanceProperties': sourceInstanceProperties!,
        if (status != null) 'status': status!,
        if (storageLocations != null) 'storageLocations': storageLocations!,
        if (totalStorageBytes != null) 'totalStorageBytes': totalStorageBytes!,
      };
}

class MachineImageListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  MachineImageListWarningData({
    this.key,
    this.value,
  });

  MachineImageListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class MachineImageListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<MachineImageListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  MachineImageListWarning({
    this.code,
    this.data,
    this.message,
  });

  MachineImageListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => MachineImageListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of machine images.
class MachineImageList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of MachineImage resources.
  core.List<MachineImage>? items;

  /// The resource type, which is always compute#machineImagesListResponse for
  /// machine image lists.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  MachineImageListWarning? warning;

  MachineImageList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  MachineImageList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => MachineImage.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? MachineImageListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class MachineTypeAccelerators {
  /// Number of accelerator cards exposed to the guest.
  core.int? guestAcceleratorCount;

  /// The accelerator type resource name, not a full URL, e.g.
  /// 'nvidia-tesla-k80'.
  core.String? guestAcceleratorType;

  MachineTypeAccelerators({
    this.guestAcceleratorCount,
    this.guestAcceleratorType,
  });

  MachineTypeAccelerators.fromJson(core.Map json_)
      : this(
          guestAcceleratorCount: json_.containsKey('guestAcceleratorCount')
              ? json_['guestAcceleratorCount'] as core.int
              : null,
          guestAcceleratorType: json_.containsKey('guestAcceleratorType')
              ? json_['guestAcceleratorType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (guestAcceleratorCount != null)
          'guestAcceleratorCount': guestAcceleratorCount!,
        if (guestAcceleratorType != null)
          'guestAcceleratorType': guestAcceleratorType!,
      };
}

class MachineTypeScratchDisks {
  /// Size of the scratch disk, defined in GB.
  core.int? diskGb;

  MachineTypeScratchDisks({
    this.diskGb,
  });

  MachineTypeScratchDisks.fromJson(core.Map json_)
      : this(
          diskGb:
              json_.containsKey('diskGb') ? json_['diskGb'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskGb != null) 'diskGb': diskGb!,
      };
}

/// Represents a Machine Type resource.
///
/// You can use specific machine types for your VM instances based on
/// performance and pricing requirements. For more information, read Machine
/// Types.
class MachineType {
  /// A list of accelerator configurations assigned to this machine type.
  ///
  /// Output only.
  core.List<MachineTypeAccelerators>? accelerators;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this machine type.
  ///
  /// Only applicable if the machine type is unavailable.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// An optional textual description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The number of virtual CPUs that are available to the instance.
  ///
  /// Output only.
  core.int? guestCpus;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// This property is deprecated and will never be populated with any relevant
  /// values.
  ///
  /// Deprecated.
  core.int? imageSpaceGb;

  /// Whether this machine type has a shared CPU.
  ///
  /// See Shared-core machine types for more information.
  ///
  /// Output only.
  core.bool? isSharedCpu;

  /// The type of the resource.
  ///
  /// Always compute#machineType for machine types.
  ///
  /// Output only.
  core.String? kind;

  /// Maximum persistent disks allowed.
  ///
  /// Output only.
  core.int? maximumPersistentDisks;

  /// Maximum total persistent disks size (GB) allowed.
  ///
  /// Output only.
  core.String? maximumPersistentDisksSizeGb;

  /// The amount of physical memory available to the instance, defined in MB.
  ///
  /// Output only.
  core.int? memoryMb;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// A list of extended scratch disks assigned to the instance.
  ///
  /// Output only.
  core.List<MachineTypeScratchDisks>? scratchDisks;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The name of the zone where the machine type resides, such as
  /// us-central1-a.
  ///
  /// Output only.
  core.String? zone;

  MachineType({
    this.accelerators,
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.guestCpus,
    this.id,
    this.imageSpaceGb,
    this.isSharedCpu,
    this.kind,
    this.maximumPersistentDisks,
    this.maximumPersistentDisksSizeGb,
    this.memoryMb,
    this.name,
    this.scratchDisks,
    this.selfLink,
    this.zone,
  });

  MachineType.fromJson(core.Map json_)
      : this(
          accelerators: json_.containsKey('accelerators')
              ? (json_['accelerators'] as core.List)
                  .map((value) => MachineTypeAccelerators.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          guestCpus: json_.containsKey('guestCpus')
              ? json_['guestCpus'] as core.int
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          imageSpaceGb: json_.containsKey('imageSpaceGb')
              ? json_['imageSpaceGb'] as core.int
              : null,
          isSharedCpu: json_.containsKey('isSharedCpu')
              ? json_['isSharedCpu'] as core.bool
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          maximumPersistentDisks: json_.containsKey('maximumPersistentDisks')
              ? json_['maximumPersistentDisks'] as core.int
              : null,
          maximumPersistentDisksSizeGb:
              json_.containsKey('maximumPersistentDisksSizeGb')
                  ? json_['maximumPersistentDisksSizeGb'] as core.String
                  : null,
          memoryMb: json_.containsKey('memoryMb')
              ? json_['memoryMb'] as core.int
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          scratchDisks: json_.containsKey('scratchDisks')
              ? (json_['scratchDisks'] as core.List)
                  .map((value) => MachineTypeScratchDisks.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (accelerators != null) 'accelerators': accelerators!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (guestCpus != null) 'guestCpus': guestCpus!,
        if (id != null) 'id': id!,
        if (imageSpaceGb != null) 'imageSpaceGb': imageSpaceGb!,
        if (isSharedCpu != null) 'isSharedCpu': isSharedCpu!,
        if (kind != null) 'kind': kind!,
        if (maximumPersistentDisks != null)
          'maximumPersistentDisks': maximumPersistentDisks!,
        if (maximumPersistentDisksSizeGb != null)
          'maximumPersistentDisksSizeGb': maximumPersistentDisksSizeGb!,
        if (memoryMb != null) 'memoryMb': memoryMb!,
        if (name != null) 'name': name!,
        if (scratchDisks != null) 'scratchDisks': scratchDisks!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (zone != null) 'zone': zone!,
      };
}

class MachineTypeAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  MachineTypeAggregatedListWarningData({
    this.key,
    this.value,
  });

  MachineTypeAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class MachineTypeAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<MachineTypeAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  MachineTypeAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  MachineTypeAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => MachineTypeAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class MachineTypeAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of MachineTypesScopedList resources.
  core.Map<core.String, MachineTypesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#machineTypeAggregatedList for aggregated lists of machine
  /// types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  MachineTypeAggregatedListWarning? warning;

  MachineTypeAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  MachineTypeAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    MachineTypesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? MachineTypeAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class MachineTypeListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  MachineTypeListWarningData({
    this.key,
    this.value,
  });

  MachineTypeListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class MachineTypeListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<MachineTypeListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  MachineTypeListWarning({
    this.code,
    this.data,
    this.message,
  });

  MachineTypeListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => MachineTypeListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of machine types.
class MachineTypeList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of MachineType resources.
  core.List<MachineType>? items;

  /// Type of resource.
  ///
  /// Always compute#machineTypeList for lists of machine types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  MachineTypeListWarning? warning;

  MachineTypeList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  MachineTypeList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => MachineType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? MachineTypeListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class MachineTypesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  MachineTypesScopedListWarningData({
    this.key,
    this.value,
  });

  MachineTypesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the machine types list is empty.
///
/// Output only.
class MachineTypesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<MachineTypesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  MachineTypesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  MachineTypesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => MachineTypesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class MachineTypesScopedList {
  /// A list of machine types contained in this scope.
  ///
  /// Output only.
  core.List<MachineType>? machineTypes;

  /// An informational warning that appears when the machine types list is
  /// empty.
  ///
  /// Output only.
  MachineTypesScopedListWarning? warning;

  MachineTypesScopedList({
    this.machineTypes,
    this.warning,
  });

  MachineTypesScopedList.fromJson(core.Map json_)
      : this(
          machineTypes: json_.containsKey('machineTypes')
              ? (json_['machineTypes'] as core.List)
                  .map((value) => MachineType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? MachineTypesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (machineTypes != null) 'machineTypes': machineTypes!,
        if (warning != null) 'warning': warning!,
      };
}

/// A Managed Instance resource.
class ManagedInstance {
  /// The current action that the managed instance group has scheduled for the
  /// instance.
  ///
  /// Possible values: - NONE The instance is running, and the managed instance
  /// group does not have any scheduled actions for this instance. - CREATING
  /// The managed instance group is creating this instance. If the group fails
  /// to create this instance, it will try again until it is successful. -
  /// CREATING_WITHOUT_RETRIES The managed instance group is attempting to
  /// create this instance only once. If the group fails to create this
  /// instance, it does not try again and the group's targetSize value is
  /// decreased instead. - RECREATING The managed instance group is recreating
  /// this instance. - DELETING The managed instance group is permanently
  /// deleting this instance. - ABANDONING The managed instance group is
  /// abandoning this instance. The instance will be removed from the instance
  /// group and from any target pools that are associated with this group. -
  /// RESTARTING The managed instance group is restarting the instance. -
  /// REFRESHING The managed instance group is applying configuration changes to
  /// the instance without stopping it. For example, the group can update the
  /// target pool list for an instance without stopping that instance. -
  /// VERIFYING The managed instance group has created the instance and it is in
  /// the process of being verified.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ABANDONING" : The managed instance group is abandoning this instance.
  /// The instance will be removed from the instance group and from any target
  /// pools that are associated with this group.
  /// - "CREATING" : The managed instance group is creating this instance. If
  /// the group fails to create this instance, it will try again until it is
  /// successful.
  /// - "CREATING_WITHOUT_RETRIES" : The managed instance group is attempting to
  /// create this instance only once. If the group fails to create this
  /// instance, it does not try again and the group's targetSize value is
  /// decreased.
  /// - "DELETING" : The managed instance group is permanently deleting this
  /// instance.
  /// - "NONE" : The managed instance group has not scheduled any actions for
  /// this instance.
  /// - "RECREATING" : The managed instance group is recreating this instance.
  /// - "REFRESHING" : The managed instance group is applying configuration
  /// changes to the instance without stopping it. For example, the group can
  /// update the target pool list for an instance without stopping that
  /// instance.
  /// - "RESTARTING" : The managed instance group is restarting this instance.
  /// - "RESUMING" : The managed instance group is resuming this instance.
  /// - "STARTING" : The managed instance group is starting this instance.
  /// - "STOPPING" : The managed instance group is stopping this instance.
  /// - "SUSPENDING" : The managed instance group is suspending this instance.
  /// - "VERIFYING" : The managed instance group is verifying this already
  /// created instance. Verification happens every time the instance is
  /// (re)created or restarted and consists of: 1. Waiting until health check
  /// specified as part of this managed instance group's autohealing policy
  /// reports HEALTHY. Note: Applies only if autohealing policy has a health
  /// check specified 2. Waiting for addition verification steps performed as
  /// post-instance creation (subject to future extensions).
  core.String? currentAction;

  /// The unique identifier for this resource.
  ///
  /// This field is empty when instance does not exist.
  ///
  /// Output only.
  core.String? id;

  /// The URL of the instance.
  ///
  /// The URL can exist even if the instance has not yet been created.
  ///
  /// Output only.
  core.String? instance;

  /// Health state of the instance per health-check.
  ///
  /// Output only.
  core.List<ManagedInstanceInstanceHealth>? instanceHealth;

  /// The status of the instance.
  ///
  /// This field is empty when the instance does not exist.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DEPROVISIONING" : The Nanny is halted and we are performing tear down
  /// tasks like network deprogramming, releasing quota, IP, tearing down disks
  /// etc.
  /// - "PROVISIONING" : Resources are being allocated for the instance.
  /// - "REPAIRING" : The instance is in repair.
  /// - "RUNNING" : The instance is running.
  /// - "STAGING" : All required resources have been allocated and the instance
  /// is being started.
  /// - "STOPPED" : The instance has stopped successfully.
  /// - "STOPPING" : The instance is currently stopping (either being deleted or
  /// killed).
  /// - "SUSPENDED" : The instance has suspended.
  /// - "SUSPENDING" : The instance is suspending.
  /// - "TERMINATED" : The instance has stopped (either by explicit action or
  /// underlying failure).
  core.String? instanceStatus;

  /// Information about the last attempt to create or delete the instance.
  ///
  /// Output only.
  ManagedInstanceLastAttempt? lastAttempt;

  /// Preserved state applied from per-instance config for this instance.
  ///
  /// Output only.
  PreservedState? preservedStateFromConfig;

  /// Preserved state generated based on stateful policy for this instance.
  ///
  /// Output only.
  PreservedState? preservedStateFromPolicy;

  /// Intended version of this instance.
  ///
  /// Output only.
  ManagedInstanceVersion? version;

  ManagedInstance({
    this.currentAction,
    this.id,
    this.instance,
    this.instanceHealth,
    this.instanceStatus,
    this.lastAttempt,
    this.preservedStateFromConfig,
    this.preservedStateFromPolicy,
    this.version,
  });

  ManagedInstance.fromJson(core.Map json_)
      : this(
          currentAction: json_.containsKey('currentAction')
              ? json_['currentAction'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          instanceHealth: json_.containsKey('instanceHealth')
              ? (json_['instanceHealth'] as core.List)
                  .map((value) => ManagedInstanceInstanceHealth.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          instanceStatus: json_.containsKey('instanceStatus')
              ? json_['instanceStatus'] as core.String
              : null,
          lastAttempt: json_.containsKey('lastAttempt')
              ? ManagedInstanceLastAttempt.fromJson(
                  json_['lastAttempt'] as core.Map<core.String, core.dynamic>)
              : null,
          preservedStateFromConfig:
              json_.containsKey('preservedStateFromConfig')
                  ? PreservedState.fromJson(json_['preservedStateFromConfig']
                      as core.Map<core.String, core.dynamic>)
                  : null,
          preservedStateFromPolicy:
              json_.containsKey('preservedStateFromPolicy')
                  ? PreservedState.fromJson(json_['preservedStateFromPolicy']
                      as core.Map<core.String, core.dynamic>)
                  : null,
          version: json_.containsKey('version')
              ? ManagedInstanceVersion.fromJson(
                  json_['version'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (currentAction != null) 'currentAction': currentAction!,
        if (id != null) 'id': id!,
        if (instance != null) 'instance': instance!,
        if (instanceHealth != null) 'instanceHealth': instanceHealth!,
        if (instanceStatus != null) 'instanceStatus': instanceStatus!,
        if (lastAttempt != null) 'lastAttempt': lastAttempt!,
        if (preservedStateFromConfig != null)
          'preservedStateFromConfig': preservedStateFromConfig!,
        if (preservedStateFromPolicy != null)
          'preservedStateFromPolicy': preservedStateFromPolicy!,
        if (version != null) 'version': version!,
      };
}

class ManagedInstanceInstanceHealth {
  /// The current detailed instance health state.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DRAINING" : The instance is being drained. The existing connections to
  /// the instance have time to complete, but the new ones are being refused.
  /// - "HEALTHY" : The instance is reachable i.e. a connection to the
  /// application health checking endpoint can be established, and conforms to
  /// the requirements defined by the health check.
  /// - "TIMEOUT" : The instance is unreachable i.e. a connection to the
  /// application health checking endpoint cannot be established, or the server
  /// does not respond within the specified timeout.
  /// - "UNHEALTHY" : The instance is reachable, but does not conform to the
  /// requirements defined by the health check.
  /// - "UNKNOWN" : The health checking system is aware of the instance but its
  /// health is not known at the moment.
  core.String? detailedHealthState;

  /// The URL for the health check that verifies whether the instance is
  /// healthy.
  ///
  /// Output only.
  core.String? healthCheck;

  ManagedInstanceInstanceHealth({
    this.detailedHealthState,
    this.healthCheck,
  });

  ManagedInstanceInstanceHealth.fromJson(core.Map json_)
      : this(
          detailedHealthState: json_.containsKey('detailedHealthState')
              ? json_['detailedHealthState'] as core.String
              : null,
          healthCheck: json_.containsKey('healthCheck')
              ? json_['healthCheck'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (detailedHealthState != null)
          'detailedHealthState': detailedHealthState!,
        if (healthCheck != null) 'healthCheck': healthCheck!,
      };
}

class ManagedInstanceLastAttemptErrorsErrorsErrorDetails {
  ErrorInfo? errorInfo;
  Help? help;
  LocalizedMessage? localizedMessage;

  ManagedInstanceLastAttemptErrorsErrorsErrorDetails({
    this.errorInfo,
    this.help,
    this.localizedMessage,
  });

  ManagedInstanceLastAttemptErrorsErrorsErrorDetails.fromJson(core.Map json_)
      : this(
          errorInfo: json_.containsKey('errorInfo')
              ? ErrorInfo.fromJson(
                  json_['errorInfo'] as core.Map<core.String, core.dynamic>)
              : null,
          help: json_.containsKey('help')
              ? Help.fromJson(
                  json_['help'] as core.Map<core.String, core.dynamic>)
              : null,
          localizedMessage: json_.containsKey('localizedMessage')
              ? LocalizedMessage.fromJson(json_['localizedMessage']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (errorInfo != null) 'errorInfo': errorInfo!,
        if (help != null) 'help': help!,
        if (localizedMessage != null) 'localizedMessage': localizedMessage!,
      };
}

class ManagedInstanceLastAttemptErrorsErrors {
  /// The error type identifier for this error.
  ///
  /// Output only.
  core.String? code;

  /// An optional list of messages that contain the error details.
  ///
  /// There is a set of defined message types to use for providing details.The
  /// syntax depends on the error code. For example, QuotaExceededInfo will have
  /// details when the error code is QUOTA_EXCEEDED.
  ///
  /// Output only.
  core.List<ManagedInstanceLastAttemptErrorsErrorsErrorDetails>? errorDetails;

  /// Indicates the field in the request that caused the error.
  ///
  /// This property is optional.
  ///
  /// Output only.
  core.String? location;

  /// An optional, human-readable error message.
  ///
  /// Output only.
  core.String? message;

  ManagedInstanceLastAttemptErrorsErrors({
    this.code,
    this.errorDetails,
    this.location,
    this.message,
  });

  ManagedInstanceLastAttemptErrorsErrors.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          errorDetails: json_.containsKey('errorDetails')
              ? (json_['errorDetails'] as core.List)
                  .map((value) =>
                      ManagedInstanceLastAttemptErrorsErrorsErrorDetails
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          location: json_.containsKey('location')
              ? json_['location'] as core.String
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (errorDetails != null) 'errorDetails': errorDetails!,
        if (location != null) 'location': location!,
        if (message != null) 'message': message!,
      };
}

/// Encountered errors during the last attempt to create or delete the instance.
///
/// Output only.
class ManagedInstanceLastAttemptErrors {
  /// The array of errors encountered while processing this operation.
  ///
  /// Output only.
  core.List<ManagedInstanceLastAttemptErrorsErrors>? errors;

  ManagedInstanceLastAttemptErrors({
    this.errors,
  });

  ManagedInstanceLastAttemptErrors.fromJson(core.Map json_)
      : this(
          errors: json_.containsKey('errors')
              ? (json_['errors'] as core.List)
                  .map((value) =>
                      ManagedInstanceLastAttemptErrorsErrors.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (errors != null) 'errors': errors!,
      };
}

class ManagedInstanceLastAttempt {
  /// Encountered errors during the last attempt to create or delete the
  /// instance.
  ///
  /// Output only.
  ManagedInstanceLastAttemptErrors? errors;

  ManagedInstanceLastAttempt({
    this.errors,
  });

  ManagedInstanceLastAttempt.fromJson(core.Map json_)
      : this(
          errors: json_.containsKey('errors')
              ? ManagedInstanceLastAttemptErrors.fromJson(
                  json_['errors'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (errors != null) 'errors': errors!,
      };
}

class ManagedInstanceVersion {
  /// The intended template of the instance.
  ///
  /// This field is empty when current_action is one of { DELETING, ABANDONING
  /// }.
  ///
  /// Output only.
  core.String? instanceTemplate;

  /// Name of the version.
  ///
  /// Output only.
  core.String? name;

  ManagedInstanceVersion({
    this.instanceTemplate,
    this.name,
  });

  ManagedInstanceVersion.fromJson(core.Map json_)
      : this(
          instanceTemplate: json_.containsKey('instanceTemplate')
              ? json_['instanceTemplate'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceTemplate != null) 'instanceTemplate': instanceTemplate!,
        if (name != null) 'name': name!,
      };
}

/// Metadata
class MetadataItems {
  /// Key for the metadata entry.
  ///
  /// Keys must conform to the following regexp: \[a-zA-Z0-9-_\]+, and be less
  /// than 128 bytes in length. This is reflected as part of a URL in the
  /// metadata server. Additionally, to avoid ambiguity, keys must not conflict
  /// with any other metadata keys for the project.
  core.String? key;

  /// Value for the metadata entry.
  ///
  /// These are free-form strings, and only have meaning as interpreted by the
  /// image running in the instance. The only restriction placed on values is
  /// that their size must be less than or equal to 262144 bytes (256 KiB).
  core.String? value;

  MetadataItems({
    this.key,
    this.value,
  });

  MetadataItems.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// A metadata key/value entry.
class Metadata {
  /// Specifies a fingerprint for this request, which is essentially a hash of
  /// the metadata's contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update metadata. You must always provide an
  /// up-to-date fingerprint hash in order to update or change metadata,
  /// otherwise the request will fail with error 412 conditionNotMet. To see the
  /// latest fingerprint, make a get() request to retrieve the resource.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Array of key/value pairs.
  ///
  /// The total size of all keys and values must be less than 512 KB.
  core.List<MetadataItems>? items;

  /// Type of the resource.
  ///
  /// Always compute#metadata for metadata.
  ///
  /// Output only.
  core.String? kind;

  Metadata({
    this.fingerprint,
    this.items,
    this.kind,
  });

  Metadata.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => MetadataItems.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
      };
}

/// Opaque filter criteria used by load balancers to restrict routing
/// configuration to a limited set of load balancing proxies.
///
/// Proxies and sidecars involved in load balancing would typically present
/// metadata to the load balancers that need to match criteria specified here.
/// If a match takes place, the relevant configuration is made available to
/// those proxies. For each metadataFilter in this list, if its
/// filterMatchCriteria is set to MATCH_ANY, at least one of the filterLabels
/// must match the corresponding label provided in the metadata. If its
/// filterMatchCriteria is set to MATCH_ALL, then all of its filterLabels must
/// match with corresponding labels provided in the metadata. An example for
/// using metadataFilters would be: if load balancing involves Envoys, they
/// receive routing configuration when values in metadataFilters match values
/// supplied in of their XDS requests to loadbalancers.
class MetadataFilter {
  /// The list of label value pairs that must match labels in the provided
  /// metadata based on filterMatchCriteria This list must not be empty and can
  /// have at the most 64 entries.
  core.List<MetadataFilterLabelMatch>? filterLabels;

  /// Specifies how individual filter label matches within the list of
  /// filterLabels and contributes toward the overall metadataFilter match.
  ///
  /// Supported values are: - MATCH_ANY: at least one of the filterLabels must
  /// have a matching label in the provided metadata. - MATCH_ALL: all
  /// filterLabels must have matching labels in the provided metadata.
  /// Possible string values are:
  /// - "MATCH_ALL" : Specifies that all filterLabels must match for the
  /// metadataFilter to be considered a match.
  /// - "MATCH_ANY" : Specifies that any filterLabel must match for the
  /// metadataFilter to be considered a match.
  /// - "NOT_SET" : Indicates that the match criteria was not set. A
  /// metadataFilter must never be created with this value.
  core.String? filterMatchCriteria;

  MetadataFilter({
    this.filterLabels,
    this.filterMatchCriteria,
  });

  MetadataFilter.fromJson(core.Map json_)
      : this(
          filterLabels: json_.containsKey('filterLabels')
              ? (json_['filterLabels'] as core.List)
                  .map((value) => MetadataFilterLabelMatch.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          filterMatchCriteria: json_.containsKey('filterMatchCriteria')
              ? json_['filterMatchCriteria'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (filterLabels != null) 'filterLabels': filterLabels!,
        if (filterMatchCriteria != null)
          'filterMatchCriteria': filterMatchCriteria!,
      };
}

/// MetadataFilter label name value pairs that are expected to match
/// corresponding labels presented as metadata to the load balancer.
class MetadataFilterLabelMatch {
  /// Name of metadata label.
  ///
  /// The name can have a maximum length of 1024 characters and must be at least
  /// 1 character long.
  core.String? name;

  /// The value of the label must match the specified value.
  ///
  /// value can have a maximum length of 1024 characters.
  core.String? value;

  MetadataFilterLabelMatch({
    this.name,
    this.value,
  });

  MetadataFilterLabelMatch.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (value != null) 'value': value!,
      };
}

/// The named port.
///
/// For example: \<"http", 80\>.
class NamedPort {
  /// The name for this named port.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  core.String? name;

  /// The port number, which can be a value between 1 and 65535.
  core.int? port;

  NamedPort({
    this.name,
    this.port,
  });

  NamedPort.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (port != null) 'port': port!,
      };
}

/// Represents a VPC Network resource.
///
/// Networks connect resources to each other and to the internet. For more
/// information, read Virtual Private Cloud (VPC) Network.
class Network {
  /// Deprecated in favor of subnet mode networks.
  ///
  /// The range of internal addresses that are legal on this network. This range
  /// is a CIDR specification, for example: 192.168.0.0/16. Provided by the
  /// client when the network is created.
  core.String? IPv4Range;

  /// Must be set to create a VPC network.
  ///
  /// If not set, a legacy network is created. When set to true, the VPC network
  /// is created in auto mode. When set to false, the VPC network is created in
  /// custom mode. An auto mode VPC network starts with one subnet per region.
  /// Each subnet has a predetermined range as described in Auto mode VPC
  /// network IP ranges. For custom mode VPC networks, you can add subnets using
  /// the subnetworks insert method.
  core.bool? autoCreateSubnetworks;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this field when you create the resource.
  core.String? description;

  /// Enable ULA internal ipv6 on this network.
  ///
  /// Enabling this feature will assign a /48 from google defined ULA prefix
  /// fd20::/20. .
  core.bool? enableUlaInternalIpv6;

  /// URL of the firewall policy the network is associated with.
  ///
  /// Output only.
  core.String? firewallPolicy;

  /// The gateway address for default routing out of the network, selected by
  /// GCP.
  ///
  /// Output only.
  core.String? gatewayIPv4;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// When enabling ula internal ipv6, caller optionally can specify the /48
  /// range they want from the google defined ULA prefix fd20::/20.
  ///
  /// The input must be a valid /48 ULA IPv6 address and must be within the
  /// fd20::/20. Operation will fail if the speficied /48 is already in used by
  /// another resource. If the field is not speficied, then a /48 range will be
  /// randomly allocated from fd20::/20 and returned via this field. .
  core.String? internalIpv6Range;

  /// Type of the resource.
  ///
  /// Always compute#network for networks.
  ///
  /// Output only.
  core.String? kind;

  /// Maximum Transmission Unit in bytes.
  ///
  /// The minimum value for this field is 1300 and the maximum value is 8896.
  /// The suggested value is 1500, which is the default MTU used on the
  /// Internet, or 8896 if you want to use Jumbo frames. If unspecified, the
  /// value defaults to 1460.
  core.int? mtu;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase
  /// letter, and all following characters (except for the last character) must
  /// be a dash, lowercase letter, or digit. The last character must be a
  /// lowercase letter or digit.
  core.String? name;

  /// The network firewall policy enforcement order.
  ///
  /// Can be either AFTER_CLASSIC_FIREWALL or BEFORE_CLASSIC_FIREWALL. Defaults
  /// to AFTER_CLASSIC_FIREWALL if the field is not specified.
  /// Possible string values are:
  /// - "AFTER_CLASSIC_FIREWALL"
  /// - "BEFORE_CLASSIC_FIREWALL"
  core.String? networkFirewallPolicyEnforcementOrder;

  /// A list of network peerings for the resource.
  ///
  /// Output only.
  core.List<NetworkPeering>? peerings;

  /// The network-level routing configuration for this network.
  ///
  /// Used by Cloud Router to determine what type of network-wide routing
  /// behavior to enforce.
  NetworkRoutingConfig? routingConfig;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Server-defined URL for this resource with the resource id.
  ///
  /// Output only.
  core.String? selfLinkWithId;

  /// Server-defined fully-qualified URLs for all subnetworks in this VPC
  /// network.
  ///
  /// Output only.
  core.List<core.String>? subnetworks;

  Network({
    this.IPv4Range,
    this.autoCreateSubnetworks,
    this.creationTimestamp,
    this.description,
    this.enableUlaInternalIpv6,
    this.firewallPolicy,
    this.gatewayIPv4,
    this.id,
    this.internalIpv6Range,
    this.kind,
    this.mtu,
    this.name,
    this.networkFirewallPolicyEnforcementOrder,
    this.peerings,
    this.routingConfig,
    this.selfLink,
    this.selfLinkWithId,
    this.subnetworks,
  });

  Network.fromJson(core.Map json_)
      : this(
          IPv4Range: json_.containsKey('IPv4Range')
              ? json_['IPv4Range'] as core.String
              : null,
          autoCreateSubnetworks: json_.containsKey('autoCreateSubnetworks')
              ? json_['autoCreateSubnetworks'] as core.bool
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          enableUlaInternalIpv6: json_.containsKey('enableUlaInternalIpv6')
              ? json_['enableUlaInternalIpv6'] as core.bool
              : null,
          firewallPolicy: json_.containsKey('firewallPolicy')
              ? json_['firewallPolicy'] as core.String
              : null,
          gatewayIPv4: json_.containsKey('gatewayIPv4')
              ? json_['gatewayIPv4'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          internalIpv6Range: json_.containsKey('internalIpv6Range')
              ? json_['internalIpv6Range'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          mtu: json_.containsKey('mtu') ? json_['mtu'] as core.int : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          networkFirewallPolicyEnforcementOrder: json_
                  .containsKey('networkFirewallPolicyEnforcementOrder')
              ? json_['networkFirewallPolicyEnforcementOrder'] as core.String
              : null,
          peerings: json_.containsKey('peerings')
              ? (json_['peerings'] as core.List)
                  .map((value) => NetworkPeering.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          routingConfig: json_.containsKey('routingConfig')
              ? NetworkRoutingConfig.fromJson(
                  json_['routingConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          selfLinkWithId: json_.containsKey('selfLinkWithId')
              ? json_['selfLinkWithId'] as core.String
              : null,
          subnetworks: json_.containsKey('subnetworks')
              ? (json_['subnetworks'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (IPv4Range != null) 'IPv4Range': IPv4Range!,
        if (autoCreateSubnetworks != null)
          'autoCreateSubnetworks': autoCreateSubnetworks!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (enableUlaInternalIpv6 != null)
          'enableUlaInternalIpv6': enableUlaInternalIpv6!,
        if (firewallPolicy != null) 'firewallPolicy': firewallPolicy!,
        if (gatewayIPv4 != null) 'gatewayIPv4': gatewayIPv4!,
        if (id != null) 'id': id!,
        if (internalIpv6Range != null) 'internalIpv6Range': internalIpv6Range!,
        if (kind != null) 'kind': kind!,
        if (mtu != null) 'mtu': mtu!,
        if (name != null) 'name': name!,
        if (networkFirewallPolicyEnforcementOrder != null)
          'networkFirewallPolicyEnforcementOrder':
              networkFirewallPolicyEnforcementOrder!,
        if (peerings != null) 'peerings': peerings!,
        if (routingConfig != null) 'routingConfig': routingConfig!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (selfLinkWithId != null) 'selfLinkWithId': selfLinkWithId!,
        if (subnetworks != null) 'subnetworks': subnetworks!,
      };
}

/// Represents a Google Cloud Armor network edge security service resource.
class NetworkEdgeSecurityService {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// NetworkEdgeSecurityService. An up-to-date fingerprint must be provided in
  /// order to update the NetworkEdgeSecurityService, otherwise the request will
  /// fail with error 412 conditionNotMet. To see the latest fingerprint, make a
  /// get() request to retrieve a NetworkEdgeSecurityService.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#networkEdgeSecurityService for NetworkEdgeSecurityServices
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the region where the resource resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// The resource URL for the network edge security service associated with
  /// this network edge security service.
  core.String? securityPolicy;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Server-defined URL for this resource with the resource id.
  ///
  /// Output only.
  core.String? selfLinkWithId;

  NetworkEdgeSecurityService({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.region,
    this.securityPolicy,
    this.selfLink,
    this.selfLinkWithId,
  });

  NetworkEdgeSecurityService.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          securityPolicy: json_.containsKey('securityPolicy')
              ? json_['securityPolicy'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          selfLinkWithId: json_.containsKey('selfLinkWithId')
              ? json_['selfLinkWithId'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (securityPolicy != null) 'securityPolicy': securityPolicy!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (selfLinkWithId != null) 'selfLinkWithId': selfLinkWithId!,
      };
}

class NetworkEdgeSecurityServiceAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEdgeSecurityServiceAggregatedListWarningData({
    this.key,
    this.value,
  });

  NetworkEdgeSecurityServiceAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NetworkEdgeSecurityServiceAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEdgeSecurityServiceAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEdgeSecurityServiceAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEdgeSecurityServiceAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NetworkEdgeSecurityServiceAggregatedListWarningData
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEdgeSecurityServiceAggregatedList {
  core.String? etag;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NetworkEdgeSecurityServicesScopedList resources.
  core.Map<core.String, NetworkEdgeSecurityServicesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#networkEdgeSecurityServiceAggregatedList for lists of
  /// Network Edge Security Services.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  NetworkEdgeSecurityServiceAggregatedListWarning? warning;

  NetworkEdgeSecurityServiceAggregatedList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  NetworkEdgeSecurityServiceAggregatedList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    NetworkEdgeSecurityServicesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NetworkEdgeSecurityServiceAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class NetworkEdgeSecurityServicesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEdgeSecurityServicesScopedListWarningData({
    this.key,
    this.value,
  });

  NetworkEdgeSecurityServicesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of security policies when the
/// list is empty.
class NetworkEdgeSecurityServicesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEdgeSecurityServicesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEdgeSecurityServicesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEdgeSecurityServicesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NetworkEdgeSecurityServicesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEdgeSecurityServicesScopedList {
  /// A list of NetworkEdgeSecurityServices contained in this scope.
  core.List<NetworkEdgeSecurityService>? networkEdgeSecurityServices;

  /// Informational warning which replaces the list of security policies when
  /// the list is empty.
  NetworkEdgeSecurityServicesScopedListWarning? warning;

  NetworkEdgeSecurityServicesScopedList({
    this.networkEdgeSecurityServices,
    this.warning,
  });

  NetworkEdgeSecurityServicesScopedList.fromJson(core.Map json_)
      : this(
          networkEdgeSecurityServices:
              json_.containsKey('networkEdgeSecurityServices')
                  ? (json_['networkEdgeSecurityServices'] as core.List)
                      .map((value) => NetworkEdgeSecurityService.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                      .toList()
                  : null,
          warning: json_.containsKey('warning')
              ? NetworkEdgeSecurityServicesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEdgeSecurityServices != null)
          'networkEdgeSecurityServices': networkEdgeSecurityServices!,
        if (warning != null) 'warning': warning!,
      };
}

/// The network endpoint.
class NetworkEndpoint {
  /// Metadata defined as annotations on the network endpoint.
  core.Map<core.String, core.String>? annotations;

  /// Optional fully qualified domain name of network endpoint.
  ///
  /// This can only be specified when NetworkEndpointGroup.network_endpoint_type
  /// is NON_GCP_FQDN_PORT.
  core.String? fqdn;

  /// The name for a specific VM instance that the IP address belongs to.
  ///
  /// This is required for network endpoints of type GCE_VM_IP_PORT. The
  /// instance must be in the same zone of network endpoint group. The name must
  /// be 1-63 characters long, and comply with RFC1035.
  core.String? instance;

  /// Optional IPv4 address of network endpoint.
  ///
  /// The IP address must belong to a VM in Compute Engine (either the primary
  /// IP or as part of an aliased IP range). If the IP address is not specified,
  /// then the primary IP address for the VM instance in the network that the
  /// network endpoint group belongs to will be used.
  core.String? ipAddress;

  /// Optional port number of network endpoint.
  ///
  /// If not specified, the defaultPort for the network endpoint group will be
  /// used.
  core.int? port;

  NetworkEndpoint({
    this.annotations,
    this.fqdn,
    this.instance,
    this.ipAddress,
    this.port,
  });

  NetworkEndpoint.fromJson(core.Map json_)
      : this(
          annotations: json_.containsKey('annotations')
              ? (json_['annotations'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          fqdn: json_.containsKey('fqdn') ? json_['fqdn'] as core.String : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (annotations != null) 'annotations': annotations!,
        if (fqdn != null) 'fqdn': fqdn!,
        if (instance != null) 'instance': instance!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
        if (port != null) 'port': port!,
      };
}

/// Represents a collection of network endpoints.
///
/// A network endpoint group (NEG) defines how a set of endpoints should be
/// reached, whether they are reachable, and where they are located. For more
/// information about using NEGs, see Setting up external HTTP(S) Load Balancing
/// with internet NEGs, Setting up zonal NEGs, or Setting up external HTTP(S)
/// Load Balancing with serverless NEGs.
class NetworkEndpointGroup {
  /// Metadata defined as annotations on the network endpoint group.
  core.Map<core.String, core.String>? annotations;

  /// Only valid when networkEndpointType is "SERVERLESS".
  ///
  /// Only one of cloudRun, appEngine or cloudFunction may be set.
  NetworkEndpointGroupAppEngine? appEngine;

  /// Only valid when networkEndpointType is "SERVERLESS".
  ///
  /// Only one of cloudRun, appEngine or cloudFunction may be set.
  NetworkEndpointGroupCloudFunction? cloudFunction;

  /// Only valid when networkEndpointType is "SERVERLESS".
  ///
  /// Only one of cloudRun, appEngine or cloudFunction may be set.
  NetworkEndpointGroupCloudRun? cloudRun;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The default port used if the port number is not specified in the network
  /// endpoint.
  core.int? defaultPort;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#networkEndpointGroup for network endpoint group.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// The URL of the network to which all network endpoints in the NEG belong.
  ///
  /// Uses "default" project network if unspecified.
  core.String? network;

  /// Type of network endpoints in this network endpoint group.
  ///
  /// Can be one of GCE_VM_IP, GCE_VM_IP_PORT, NON_GCP_PRIVATE_IP_PORT,
  /// INTERNET_FQDN_PORT, INTERNET_IP_PORT, SERVERLESS, PRIVATE_SERVICE_CONNECT.
  /// Possible string values are:
  /// - "GCE_VM_IP" : The network endpoint is represented by an IP address.
  /// - "GCE_VM_IP_PORT" : The network endpoint is represented by IP address and
  /// port pair.
  /// - "INTERNET_FQDN_PORT" : The network endpoint is represented by fully
  /// qualified domain name and port.
  /// - "INTERNET_IP_PORT" : The network endpoint is represented by an internet
  /// IP address and port.
  /// - "NON_GCP_PRIVATE_IP_PORT" : The network endpoint is represented by an IP
  /// address and port. The endpoint belongs to a VM or pod running in a
  /// customer's on-premises.
  /// - "PRIVATE_SERVICE_CONNECT" : The network endpoint is either public Google
  /// APIs or services exposed by other GCP Project with a Service Attachment.
  /// The connection is set up by private service connect
  /// - "SERVERLESS" : The network endpoint is handled by specified serverless
  /// infrastructure.
  core.String? networkEndpointType;

  /// The target service url used to set up private service connection to a
  /// Google API or a PSC Producer Service Attachment.
  ///
  /// An example value is: "asia-northeast3-cloudkms.googleapis.com"
  core.String? pscTargetService;

  /// The URL of the region where the network endpoint group is located.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Number of network endpoints in the network endpoint group.
  ///
  /// Output only.
  core.int? size;

  /// Optional URL of the subnetwork to which all network endpoints in the NEG
  /// belong.
  core.String? subnetwork;

  /// The URL of the zone where the network endpoint group is located.
  ///
  /// Output only.
  core.String? zone;

  NetworkEndpointGroup({
    this.annotations,
    this.appEngine,
    this.cloudFunction,
    this.cloudRun,
    this.creationTimestamp,
    this.defaultPort,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.network,
    this.networkEndpointType,
    this.pscTargetService,
    this.region,
    this.selfLink,
    this.size,
    this.subnetwork,
    this.zone,
  });

  NetworkEndpointGroup.fromJson(core.Map json_)
      : this(
          annotations: json_.containsKey('annotations')
              ? (json_['annotations'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          appEngine: json_.containsKey('appEngine')
              ? NetworkEndpointGroupAppEngine.fromJson(
                  json_['appEngine'] as core.Map<core.String, core.dynamic>)
              : null,
          cloudFunction: json_.containsKey('cloudFunction')
              ? NetworkEndpointGroupCloudFunction.fromJson(
                  json_['cloudFunction'] as core.Map<core.String, core.dynamic>)
              : null,
          cloudRun: json_.containsKey('cloudRun')
              ? NetworkEndpointGroupCloudRun.fromJson(
                  json_['cloudRun'] as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          defaultPort: json_.containsKey('defaultPort')
              ? json_['defaultPort'] as core.int
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          networkEndpointType: json_.containsKey('networkEndpointType')
              ? json_['networkEndpointType'] as core.String
              : null,
          pscTargetService: json_.containsKey('pscTargetService')
              ? json_['pscTargetService'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          size: json_.containsKey('size') ? json_['size'] as core.int : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (annotations != null) 'annotations': annotations!,
        if (appEngine != null) 'appEngine': appEngine!,
        if (cloudFunction != null) 'cloudFunction': cloudFunction!,
        if (cloudRun != null) 'cloudRun': cloudRun!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (defaultPort != null) 'defaultPort': defaultPort!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (networkEndpointType != null)
          'networkEndpointType': networkEndpointType!,
        if (pscTargetService != null) 'pscTargetService': pscTargetService!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (size != null) 'size': size!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
        if (zone != null) 'zone': zone!,
      };
}

class NetworkEndpointGroupAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEndpointGroupAggregatedListWarningData({
    this.key,
    this.value,
  });

  NetworkEndpointGroupAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NetworkEndpointGroupAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEndpointGroupAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEndpointGroupAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEndpointGroupAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NetworkEndpointGroupAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEndpointGroupAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NetworkEndpointGroupsScopedList resources.
  core.Map<core.String, NetworkEndpointGroupsScopedList>? items;

  /// The resource type, which is always
  /// compute#networkEndpointGroupAggregatedList for aggregated lists of network
  /// endpoint groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  NetworkEndpointGroupAggregatedListWarning? warning;

  NetworkEndpointGroupAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  NetworkEndpointGroupAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    NetworkEndpointGroupsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NetworkEndpointGroupAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

/// Configuration for an App Engine network endpoint group (NEG).
///
/// The service is optional, may be provided explicitly or in the URL mask. The
/// version is optional and can only be provided explicitly or in the URL mask
/// when service is present. Note: App Engine service must be in the same
/// project and located in the same region as the Serverless NEG.
class NetworkEndpointGroupAppEngine {
  /// Optional serving service.
  ///
  /// The service name is case-sensitive and must be 1-63 characters long.
  /// Example value: "default", "my-service".
  core.String? service;

  /// A template to parse service and version fields from a request URL.
  ///
  /// URL mask allows for routing to multiple App Engine services without having
  /// to create multiple Network Endpoint Groups and backend services. For
  /// example, the request URLs "foo1-dot-appname.appspot.com/v1" and
  /// "foo1-dot-appname.appspot.com/v2" can be backed by the same Serverless NEG
  /// with URL mask "\<service\>-dot-appname.appspot.com/\<version\>". The URL
  /// mask will parse them to { service = "foo1", version = "v1" } and { service
  /// = "foo1", version = "v2" } respectively.
  core.String? urlMask;

  /// Optional serving version.
  ///
  /// The version name is case-sensitive and must be 1-100 characters long.
  /// Example value: "v1", "v2".
  core.String? version;

  NetworkEndpointGroupAppEngine({
    this.service,
    this.urlMask,
    this.version,
  });

  NetworkEndpointGroupAppEngine.fromJson(core.Map json_)
      : this(
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          urlMask: json_.containsKey('urlMask')
              ? json_['urlMask'] as core.String
              : null,
          version: json_.containsKey('version')
              ? json_['version'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (service != null) 'service': service!,
        if (urlMask != null) 'urlMask': urlMask!,
        if (version != null) 'version': version!,
      };
}

/// Configuration for a Cloud Function network endpoint group (NEG).
///
/// The function must be provided explicitly or in the URL mask. Note: Cloud
/// Function must be in the same project and located in the same region as the
/// Serverless NEG.
class NetworkEndpointGroupCloudFunction {
  /// A user-defined name of the Cloud Function.
  ///
  /// The function name is case-sensitive and must be 1-63 characters long.
  /// Example value: "func1".
  core.String? function;

  /// A template to parse function field from a request URL.
  ///
  /// URL mask allows for routing to multiple Cloud Functions without having to
  /// create multiple Network Endpoint Groups and backend services. For example,
  /// request URLs " mydomain.com/function1" and "mydomain.com/function2" can be
  /// backed by the same Serverless NEG with URL mask "/\<function\>". The URL
  /// mask will parse them to { function = "function1" } and { function =
  /// "function2" } respectively.
  core.String? urlMask;

  NetworkEndpointGroupCloudFunction({
    this.function,
    this.urlMask,
  });

  NetworkEndpointGroupCloudFunction.fromJson(core.Map json_)
      : this(
          function: json_.containsKey('function')
              ? json_['function'] as core.String
              : null,
          urlMask: json_.containsKey('urlMask')
              ? json_['urlMask'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (function != null) 'function': function!,
        if (urlMask != null) 'urlMask': urlMask!,
      };
}

/// Configuration for a Cloud Run network endpoint group (NEG).
///
/// The service must be provided explicitly or in the URL mask. The tag is
/// optional, may be provided explicitly or in the URL mask. Note: Cloud Run
/// service must be in the same project and located in the same region as the
/// Serverless NEG.
class NetworkEndpointGroupCloudRun {
  /// Cloud Run service is the main resource of Cloud Run.
  ///
  /// The service must be 1-63 characters long, and comply with RFC1035. Example
  /// value: "run-service".
  core.String? service;

  /// Optional Cloud Run tag represents the "named-revision" to provide
  /// additional fine-grained traffic routing information.
  ///
  /// The tag must be 1-63 characters long, and comply with RFC1035. Example
  /// value: "revision-0010".
  core.String? tag;

  /// A template to parse \<service\> and \<tag\> fields from a request URL.
  ///
  /// URL mask allows for routing to multiple Run services without having to
  /// create multiple network endpoint groups and backend services. For example,
  /// request URLs "foo1.domain.com/bar1" and "foo1.domain.com/bar2" can be
  /// backed by the same Serverless Network Endpoint Group (NEG) with URL mask
  /// "\<tag\>.domain.com/\<service\>". The URL mask will parse them to {
  /// service="bar1", tag="foo1" } and { service="bar2", tag="foo2" }
  /// respectively.
  core.String? urlMask;

  NetworkEndpointGroupCloudRun({
    this.service,
    this.tag,
    this.urlMask,
  });

  NetworkEndpointGroupCloudRun.fromJson(core.Map json_)
      : this(
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          tag: json_.containsKey('tag') ? json_['tag'] as core.String : null,
          urlMask: json_.containsKey('urlMask')
              ? json_['urlMask'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (service != null) 'service': service!,
        if (tag != null) 'tag': tag!,
        if (urlMask != null) 'urlMask': urlMask!,
      };
}

class NetworkEndpointGroupListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEndpointGroupListWarningData({
    this.key,
    this.value,
  });

  NetworkEndpointGroupListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NetworkEndpointGroupListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEndpointGroupListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEndpointGroupListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEndpointGroupListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NetworkEndpointGroupListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEndpointGroupList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NetworkEndpointGroup resources.
  core.List<NetworkEndpointGroup>? items;

  /// The resource type, which is always compute#networkEndpointGroupList for
  /// network endpoint group lists.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NetworkEndpointGroupListWarning? warning;

  NetworkEndpointGroupList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NetworkEndpointGroupList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NetworkEndpointGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NetworkEndpointGroupListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class NetworkEndpointGroupsAttachEndpointsRequest {
  /// The list of network endpoints to be attached.
  core.List<NetworkEndpoint>? networkEndpoints;

  NetworkEndpointGroupsAttachEndpointsRequest({
    this.networkEndpoints,
  });

  NetworkEndpointGroupsAttachEndpointsRequest.fromJson(core.Map json_)
      : this(
          networkEndpoints: json_.containsKey('networkEndpoints')
              ? (json_['networkEndpoints'] as core.List)
                  .map((value) => NetworkEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEndpoints != null) 'networkEndpoints': networkEndpoints!,
      };
}

class NetworkEndpointGroupsDetachEndpointsRequest {
  /// The list of network endpoints to be detached.
  core.List<NetworkEndpoint>? networkEndpoints;

  NetworkEndpointGroupsDetachEndpointsRequest({
    this.networkEndpoints,
  });

  NetworkEndpointGroupsDetachEndpointsRequest.fromJson(core.Map json_)
      : this(
          networkEndpoints: json_.containsKey('networkEndpoints')
              ? (json_['networkEndpoints'] as core.List)
                  .map((value) => NetworkEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEndpoints != null) 'networkEndpoints': networkEndpoints!,
      };
}

class NetworkEndpointGroupsListEndpointsRequest {
  /// Optional query parameter for showing the health status of each network
  /// endpoint.
  ///
  /// Valid options are SKIP or SHOW. If you don't specify this parameter, the
  /// health status of network endpoints will not be provided.
  /// Possible string values are:
  /// - "SHOW" : Show the health status for each network endpoint. Impacts
  /// latency of the call.
  /// - "SKIP" : Health status for network endpoints will not be provided.
  core.String? healthStatus;

  NetworkEndpointGroupsListEndpointsRequest({
    this.healthStatus,
  });

  NetworkEndpointGroupsListEndpointsRequest.fromJson(core.Map json_)
      : this(
          healthStatus: json_.containsKey('healthStatus')
              ? json_['healthStatus'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthStatus != null) 'healthStatus': healthStatus!,
      };
}

class NetworkEndpointGroupsListNetworkEndpointsWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEndpointGroupsListNetworkEndpointsWarningData({
    this.key,
    this.value,
  });

  NetworkEndpointGroupsListNetworkEndpointsWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NetworkEndpointGroupsListNetworkEndpointsWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEndpointGroupsListNetworkEndpointsWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEndpointGroupsListNetworkEndpointsWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEndpointGroupsListNetworkEndpointsWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NetworkEndpointGroupsListNetworkEndpointsWarningData
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEndpointGroupsListNetworkEndpoints {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NetworkEndpointWithHealthStatus resources.
  core.List<NetworkEndpointWithHealthStatus>? items;

  /// The resource type, which is always
  /// compute#networkEndpointGroupsListNetworkEndpoints for the list of network
  /// endpoints in the specified network endpoint group.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Informational warning message.
  ///
  /// Output only.
  NetworkEndpointGroupsListNetworkEndpointsWarning? warning;

  NetworkEndpointGroupsListNetworkEndpoints({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.warning,
  });

  NetworkEndpointGroupsListNetworkEndpoints.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NetworkEndpointWithHealthStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NetworkEndpointGroupsListNetworkEndpointsWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (warning != null) 'warning': warning!,
      };
}

class NetworkEndpointGroupsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkEndpointGroupsScopedListWarningData({
    this.key,
    this.value,
  });

  NetworkEndpointGroupsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that replaces the list of network endpoint groups
/// when the list is empty.
///
/// Output only.
class NetworkEndpointGroupsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkEndpointGroupsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkEndpointGroupsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkEndpointGroupsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NetworkEndpointGroupsScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NetworkEndpointGroupsScopedList {
  /// The list of network endpoint groups that are contained in this scope.
  ///
  /// Output only.
  core.List<NetworkEndpointGroup>? networkEndpointGroups;

  /// An informational warning that replaces the list of network endpoint groups
  /// when the list is empty.
  ///
  /// Output only.
  NetworkEndpointGroupsScopedListWarning? warning;

  NetworkEndpointGroupsScopedList({
    this.networkEndpointGroups,
    this.warning,
  });

  NetworkEndpointGroupsScopedList.fromJson(core.Map json_)
      : this(
          networkEndpointGroups: json_.containsKey('networkEndpointGroups')
              ? (json_['networkEndpointGroups'] as core.List)
                  .map((value) => NetworkEndpointGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NetworkEndpointGroupsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkEndpointGroups != null)
          'networkEndpointGroups': networkEndpointGroups!,
        if (warning != null) 'warning': warning!,
      };
}

class NetworkEndpointWithHealthStatus {
  /// The health status of network endpoint;
  ///
  /// Output only.
  core.List<HealthStatusForNetworkEndpoint>? healths;

  /// The network endpoint;
  ///
  /// Output only.
  NetworkEndpoint? networkEndpoint;

  NetworkEndpointWithHealthStatus({
    this.healths,
    this.networkEndpoint,
  });

  NetworkEndpointWithHealthStatus.fromJson(core.Map json_)
      : this(
          healths: json_.containsKey('healths')
              ? (json_['healths'] as core.List)
                  .map((value) => HealthStatusForNetworkEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          networkEndpoint: json_.containsKey('networkEndpoint')
              ? NetworkEndpoint.fromJson(json_['networkEndpoint']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healths != null) 'healths': healths!,
        if (networkEndpoint != null) 'networkEndpoint': networkEndpoint!,
      };
}

/// A network interface resource attached to an instance.
class NetworkInterface {
  /// An array of configurations for this interface.
  ///
  /// Currently, only one access config, ONE_TO_ONE_NAT, is supported. If there
  /// are no accessConfigs specified, then this instance will have no external
  /// internet access.
  core.List<AccessConfig>? accessConfigs;

  /// An array of alias IP ranges for this network interface.
  ///
  /// You can only specify this field for network interfaces in VPC networks.
  core.List<AliasIpRange>? aliasIpRanges;

  /// Fingerprint hash of contents stored in this network interface.
  ///
  /// This field will be ignored when inserting an Instance or adding a
  /// NetworkInterface. An up-to-date fingerprint must be provided in order to
  /// update the NetworkInterface. The request will fail with error 400 Bad
  /// Request if the fingerprint is not provided, or 412 Precondition Failed if
  /// the fingerprint is out of date.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The prefix length of the primary internal IPv6 range.
  core.int? internalIpv6PrefixLength;

  /// An array of IPv6 access configurations for this interface.
  ///
  /// Currently, only one IPv6 access config, DIRECT_IPV6, is supported. If
  /// there is no ipv6AccessConfig specified, then this instance will have no
  /// external IPv6 Internet access.
  core.List<AccessConfig>? ipv6AccessConfigs;

  /// One of EXTERNAL, INTERNAL to indicate whether the IP can be accessed from
  /// the Internet.
  ///
  /// This field is always inherited from its subnetwork. Valid only if
  /// stackType is IPV4_IPV6.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "EXTERNAL" : This network interface can have external IPv6.
  /// - "INTERNAL" : This network interface can have internal IPv6.
  core.String? ipv6AccessType;

  /// An IPv6 internal network address for this network interface.
  core.String? ipv6Address;

  /// Type of the resource.
  ///
  /// Always compute#networkInterface for network interfaces.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the network interface, which is generated by the server.
  ///
  /// For a VM, the network interface uses the nicN naming format. Where N is a
  /// value between 0 and 7. The default interface value is nic0.
  ///
  /// Output only.
  core.String? name;

  /// URL of the VPC network resource for this instance.
  ///
  /// When creating an instance, if neither the network nor the subnetwork is
  /// specified, the default network global/networks/default is used. If the
  /// selected project doesn't have the default network, you must specify a
  /// network or subnet. If the network is not specified but the subnetwork is
  /// specified, the network is inferred. If you specify this property, you can
  /// specify the network as a full or partial URL. For example, the following
  /// are all valid URLs: -
  /// https://www.googleapis.com/compute/v1/projects/project/global/networks/
  /// network - projects/project/global/networks/network -
  /// global/networks/default
  core.String? network;

  /// An IPv4 internal IP address to assign to the instance for this network
  /// interface.
  ///
  /// If not specified by the user, an unused internal IP is assigned by the
  /// system.
  core.String? networkIP;

  /// The type of vNIC to be used on this interface.
  ///
  /// This may be gVNIC or VirtioNet.
  /// Possible string values are:
  /// - "GVNIC" : GVNIC
  /// - "UNSPECIFIED_NIC_TYPE" : No type specified.
  /// - "VIRTIO_NET" : VIRTIO
  core.String? nicType;

  /// The networking queue count that's specified by users for the network
  /// interface.
  ///
  /// Both Rx and Tx queues will be set to this number. It'll be empty if not
  /// specified by the users.
  core.int? queueCount;

  /// The stack type for this network interface to identify whether the IPv6
  /// feature is enabled or not.
  ///
  /// If not specified, IPV4_ONLY will be used. This field can be both set at
  /// instance creation and update network interface operations.
  /// Possible string values are:
  /// - "IPV4_IPV6" : The network interface can have both IPv4 and IPv6
  /// addresses.
  /// - "IPV4_ONLY" : The network interface will be assigned IPv4 address.
  core.String? stackType;

  /// The URL of the Subnetwork resource for this instance.
  ///
  /// If the network resource is in legacy mode, do not specify this field. If
  /// the network is in auto subnet mode, specifying the subnetwork is optional.
  /// If the network is in custom subnet mode, specifying the subnetwork is
  /// required. If you specify this field, you can specify the subnetwork as a
  /// full or partial URL. For example, the following are all valid URLs: -
  /// https://www.googleapis.com/compute/v1/projects/project/regions/region
  /// /subnetworks/subnetwork - regions/region/subnetworks/subnetwork
  core.String? subnetwork;

  NetworkInterface({
    this.accessConfigs,
    this.aliasIpRanges,
    this.fingerprint,
    this.internalIpv6PrefixLength,
    this.ipv6AccessConfigs,
    this.ipv6AccessType,
    this.ipv6Address,
    this.kind,
    this.name,
    this.network,
    this.networkIP,
    this.nicType,
    this.queueCount,
    this.stackType,
    this.subnetwork,
  });

  NetworkInterface.fromJson(core.Map json_)
      : this(
          accessConfigs: json_.containsKey('accessConfigs')
              ? (json_['accessConfigs'] as core.List)
                  .map((value) => AccessConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          aliasIpRanges: json_.containsKey('aliasIpRanges')
              ? (json_['aliasIpRanges'] as core.List)
                  .map((value) => AliasIpRange.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          internalIpv6PrefixLength:
              json_.containsKey('internalIpv6PrefixLength')
                  ? json_['internalIpv6PrefixLength'] as core.int
                  : null,
          ipv6AccessConfigs: json_.containsKey('ipv6AccessConfigs')
              ? (json_['ipv6AccessConfigs'] as core.List)
                  .map((value) => AccessConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          ipv6AccessType: json_.containsKey('ipv6AccessType')
              ? json_['ipv6AccessType'] as core.String
              : null,
          ipv6Address: json_.containsKey('ipv6Address')
              ? json_['ipv6Address'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          networkIP: json_.containsKey('networkIP')
              ? json_['networkIP'] as core.String
              : null,
          nicType: json_.containsKey('nicType')
              ? json_['nicType'] as core.String
              : null,
          queueCount: json_.containsKey('queueCount')
              ? json_['queueCount'] as core.int
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (accessConfigs != null) 'accessConfigs': accessConfigs!,
        if (aliasIpRanges != null) 'aliasIpRanges': aliasIpRanges!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (internalIpv6PrefixLength != null)
          'internalIpv6PrefixLength': internalIpv6PrefixLength!,
        if (ipv6AccessConfigs != null) 'ipv6AccessConfigs': ipv6AccessConfigs!,
        if (ipv6AccessType != null) 'ipv6AccessType': ipv6AccessType!,
        if (ipv6Address != null) 'ipv6Address': ipv6Address!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (networkIP != null) 'networkIP': networkIP!,
        if (nicType != null) 'nicType': nicType!,
        if (queueCount != null) 'queueCount': queueCount!,
        if (stackType != null) 'stackType': stackType!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
      };
}

class NetworkListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NetworkListWarningData({
    this.key,
    this.value,
  });

  NetworkListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NetworkListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NetworkListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NetworkListWarning({
    this.code,
    this.data,
    this.message,
  });

  NetworkListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NetworkListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of networks.
class NetworkList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Network resources.
  core.List<Network>? items;

  /// Type of resource.
  ///
  /// Always compute#networkList for lists of networks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NetworkListWarning? warning;

  NetworkList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NetworkList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Network.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NetworkListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// A network peering attached to a network resource.
///
/// The message includes the peering name, peer network, peering state, and a
/// flag indicating whether Google Compute Engine should automatically create
/// routes for the peering.
class NetworkPeering {
  /// This field will be deprecated soon.
  ///
  /// Use the exchange_subnet_routes field instead. Indicates whether full mesh
  /// connectivity is created and managed automatically between peered networks.
  /// Currently this field should always be true since Google Compute Engine
  /// will automatically create and manage subnetwork routes between two
  /// networks when peering state is ACTIVE.
  core.bool? autoCreateRoutes;

  /// Indicates whether full mesh connectivity is created and managed
  /// automatically between peered networks.
  ///
  /// Currently this field should always be true since Google Compute Engine
  /// will automatically create and manage subnetwork routes between two
  /// networks when peering state is ACTIVE.
  core.bool? exchangeSubnetRoutes;

  /// Whether to export the custom routes to peer network.
  ///
  /// The default value is false.
  core.bool? exportCustomRoutes;

  /// Whether subnet routes with public IP range are exported.
  ///
  /// The default value is true, all subnet routes are exported. IPv4
  /// special-use ranges are always exported to peers and are not controlled by
  /// this field.
  core.bool? exportSubnetRoutesWithPublicIp;

  /// Whether to import the custom routes from peer network.
  ///
  /// The default value is false.
  core.bool? importCustomRoutes;

  /// Whether subnet routes with public IP range are imported.
  ///
  /// The default value is false. IPv4 special-use ranges are always imported
  /// from peers and are not controlled by this field.
  core.bool? importSubnetRoutesWithPublicIp;

  /// Name of this peering.
  ///
  /// Provided by the client when the peering is created. The name must comply
  /// with RFC1035. Specifically, the name must be 1-63 characters long and
  /// match regular expression `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character
  /// must be a lowercase letter, and all the following characters must be a
  /// dash, lowercase letter, or digit, except the last character, which cannot
  /// be a dash.
  core.String? name;

  /// The URL of the peer network.
  ///
  /// It can be either full URL or partial URL. The peer network may belong to a
  /// different project. If the partial URL does not contain project, it is
  /// assumed that the peer network is in the same project as the current
  /// network.
  core.String? network;

  /// Maximum Transmission Unit in bytes.
  core.int? peerMtu;

  /// Which IP version(s) of traffic and routes are allowed to be imported or
  /// exported between peer networks.
  ///
  /// The default value is IPV4_ONLY.
  /// Possible string values are:
  /// - "IPV4_IPV6" : This Peering will allow IPv4 traffic and routes to be
  /// exchanged. Additionally if the matching peering is IPV4_IPV6, IPv6 traffic
  /// and routes will be exchanged as well.
  /// - "IPV4_ONLY" : This Peering will only allow IPv4 traffic and routes to be
  /// exchanged, even if the matching peering is IPV4_IPV6.
  core.String? stackType;

  /// State for the peering, either `ACTIVE` or `INACTIVE`.
  ///
  /// The peering is `ACTIVE` when there's a matching configuration in the peer
  /// network.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : Matching configuration exists on the peer.
  /// - "INACTIVE" : There is no matching configuration on the peer, including
  /// the case when peer does not exist.
  core.String? state;

  /// Details about the current state of the peering.
  ///
  /// Output only.
  core.String? stateDetails;

  NetworkPeering({
    this.autoCreateRoutes,
    this.exchangeSubnetRoutes,
    this.exportCustomRoutes,
    this.exportSubnetRoutesWithPublicIp,
    this.importCustomRoutes,
    this.importSubnetRoutesWithPublicIp,
    this.name,
    this.network,
    this.peerMtu,
    this.stackType,
    this.state,
    this.stateDetails,
  });

  NetworkPeering.fromJson(core.Map json_)
      : this(
          autoCreateRoutes: json_.containsKey('autoCreateRoutes')
              ? json_['autoCreateRoutes'] as core.bool
              : null,
          exchangeSubnetRoutes: json_.containsKey('exchangeSubnetRoutes')
              ? json_['exchangeSubnetRoutes'] as core.bool
              : null,
          exportCustomRoutes: json_.containsKey('exportCustomRoutes')
              ? json_['exportCustomRoutes'] as core.bool
              : null,
          exportSubnetRoutesWithPublicIp:
              json_.containsKey('exportSubnetRoutesWithPublicIp')
                  ? json_['exportSubnetRoutesWithPublicIp'] as core.bool
                  : null,
          importCustomRoutes: json_.containsKey('importCustomRoutes')
              ? json_['importCustomRoutes'] as core.bool
              : null,
          importSubnetRoutesWithPublicIp:
              json_.containsKey('importSubnetRoutesWithPublicIp')
                  ? json_['importSubnetRoutesWithPublicIp'] as core.bool
                  : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          peerMtu: json_.containsKey('peerMtu')
              ? json_['peerMtu'] as core.int
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          stateDetails: json_.containsKey('stateDetails')
              ? json_['stateDetails'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoCreateRoutes != null) 'autoCreateRoutes': autoCreateRoutes!,
        if (exchangeSubnetRoutes != null)
          'exchangeSubnetRoutes': exchangeSubnetRoutes!,
        if (exportCustomRoutes != null)
          'exportCustomRoutes': exportCustomRoutes!,
        if (exportSubnetRoutesWithPublicIp != null)
          'exportSubnetRoutesWithPublicIp': exportSubnetRoutesWithPublicIp!,
        if (importCustomRoutes != null)
          'importCustomRoutes': importCustomRoutes!,
        if (importSubnetRoutesWithPublicIp != null)
          'importSubnetRoutesWithPublicIp': importSubnetRoutesWithPublicIp!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (peerMtu != null) 'peerMtu': peerMtu!,
        if (stackType != null) 'stackType': stackType!,
        if (state != null) 'state': state!,
        if (stateDetails != null) 'stateDetails': stateDetails!,
      };
}

class NetworkPerformanceConfig {
  ///
  /// Possible string values are:
  /// - "DEFAULT"
  /// - "TIER_1"
  core.String? totalEgressBandwidthTier;

  NetworkPerformanceConfig({
    this.totalEgressBandwidthTier,
  });

  NetworkPerformanceConfig.fromJson(core.Map json_)
      : this(
          totalEgressBandwidthTier:
              json_.containsKey('totalEgressBandwidthTier')
                  ? json_['totalEgressBandwidthTier'] as core.String
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (totalEgressBandwidthTier != null)
          'totalEgressBandwidthTier': totalEgressBandwidthTier!,
      };
}

/// A routing configuration attached to a network resource.
///
/// The message includes the list of routers associated with the network, and a
/// flag indicating the type of routing behavior to enforce network-wide.
class NetworkRoutingConfig {
  /// The network-wide routing mode to use.
  ///
  /// If set to REGIONAL, this network's Cloud Routers will only advertise
  /// routes with subnets of this network in the same region as the router. If
  /// set to GLOBAL, this network's Cloud Routers will advertise routes with all
  /// subnets of this network, across regions.
  /// Possible string values are:
  /// - "GLOBAL"
  /// - "REGIONAL"
  core.String? routingMode;

  NetworkRoutingConfig({
    this.routingMode,
  });

  NetworkRoutingConfig.fromJson(core.Map json_)
      : this(
          routingMode: json_.containsKey('routingMode')
              ? json_['routingMode'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (routingMode != null) 'routingMode': routingMode!,
      };
}

class NetworksAddPeeringRequest {
  /// This field will be deprecated soon.
  ///
  /// Use exchange_subnet_routes in network_peering instead. Indicates whether
  /// full mesh connectivity is created and managed automatically between peered
  /// networks. Currently this field should always be true since Google Compute
  /// Engine will automatically create and manage subnetwork routes between two
  /// networks when peering state is ACTIVE.
  core.bool? autoCreateRoutes;

  /// Name of the peering, which should conform to RFC1035.
  core.String? name;

  /// Network peering parameters.
  ///
  /// In order to specify route policies for peering using import and export
  /// custom routes, you must specify all peering related parameters (name, peer
  /// network, exchange_subnet_routes) in the network_peering field. The
  /// corresponding fields in NetworksAddPeeringRequest will be deprecated soon.
  NetworkPeering? networkPeering;

  /// URL of the peer network.
  ///
  /// It can be either full URL or partial URL. The peer network may belong to a
  /// different project. If the partial URL does not contain project, it is
  /// assumed that the peer network is in the same project as the current
  /// network.
  core.String? peerNetwork;

  NetworksAddPeeringRequest({
    this.autoCreateRoutes,
    this.name,
    this.networkPeering,
    this.peerNetwork,
  });

  NetworksAddPeeringRequest.fromJson(core.Map json_)
      : this(
          autoCreateRoutes: json_.containsKey('autoCreateRoutes')
              ? json_['autoCreateRoutes'] as core.bool
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          networkPeering: json_.containsKey('networkPeering')
              ? NetworkPeering.fromJson(json_['networkPeering']
                  as core.Map<core.String, core.dynamic>)
              : null,
          peerNetwork: json_.containsKey('peerNetwork')
              ? json_['peerNetwork'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoCreateRoutes != null) 'autoCreateRoutes': autoCreateRoutes!,
        if (name != null) 'name': name!,
        if (networkPeering != null) 'networkPeering': networkPeering!,
        if (peerNetwork != null) 'peerNetwork': peerNetwork!,
      };
}

class NetworksGetEffectiveFirewallsResponse {
  /// Effective firewalls from firewall policy.
  core.List<NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy>?
      firewallPolicys;

  /// Effective firewalls on the network.
  core.List<Firewall>? firewalls;

  NetworksGetEffectiveFirewallsResponse({
    this.firewallPolicys,
    this.firewalls,
  });

  NetworksGetEffectiveFirewallsResponse.fromJson(core.Map json_)
      : this(
          firewallPolicys: json_.containsKey('firewallPolicys')
              ? (json_['firewallPolicys'] as core.List)
                  .map((value) =>
                      NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          firewalls: json_.containsKey('firewalls')
              ? (json_['firewalls'] as core.List)
                  .map((value) => Firewall.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (firewallPolicys != null) 'firewallPolicys': firewallPolicys!,
        if (firewalls != null) 'firewalls': firewalls!,
      };
}

class NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy {
  /// Deprecated, please use short name instead.
  ///
  /// The display name of the firewall policy.
  ///
  /// Output only.
  core.String? displayName;

  /// The name of the firewall policy.
  ///
  /// Output only.
  core.String? name;

  /// The rules that apply to the network.
  core.List<FirewallPolicyRule>? rules;

  /// The short name of the firewall policy.
  ///
  /// Output only.
  core.String? shortName;

  /// The type of the firewall policy.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "HIERARCHY"
  /// - "NETWORK"
  /// - "UNSPECIFIED"
  core.String? type;

  NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy({
    this.displayName,
    this.name,
    this.rules,
    this.shortName,
    this.type,
  });

  NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromJson(
      core.Map json_)
      : this(
          displayName: json_.containsKey('displayName')
              ? json_['displayName'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => FirewallPolicyRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          shortName: json_.containsKey('shortName')
              ? json_['shortName'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (displayName != null) 'displayName': displayName!,
        if (name != null) 'name': name!,
        if (rules != null) 'rules': rules!,
        if (shortName != null) 'shortName': shortName!,
        if (type != null) 'type': type!,
      };
}

class NetworksRemovePeeringRequest {
  /// Name of the peering, which should conform to RFC1035.
  core.String? name;

  NetworksRemovePeeringRequest({
    this.name,
  });

  NetworksRemovePeeringRequest.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
      };
}

class NetworksUpdatePeeringRequest {
  NetworkPeering? networkPeering;

  NetworksUpdatePeeringRequest({
    this.networkPeering,
  });

  NetworksUpdatePeeringRequest.fromJson(core.Map json_)
      : this(
          networkPeering: json_.containsKey('networkPeering')
              ? NetworkPeering.fromJson(json_['networkPeering']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkPeering != null) 'networkPeering': networkPeering!,
      };
}

/// Represents a sole-tenant Node Group resource.
///
/// A sole-tenant node is a physical server that is dedicated to hosting VM
/// instances only for your specific project. Use sole-tenant nodes to keep your
/// instances physically separated from instances in other projects, or to group
/// your instances together on the same host hardware. For more information,
/// read Sole-tenant nodes.
class NodeGroup {
  /// Specifies how autoscaling should behave.
  NodeGroupAutoscalingPolicy? autoscalingPolicy;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The type of the resource.
  ///
  /// Always compute#nodeGroup for node group.
  ///
  /// Output only.
  core.String? kind;

  /// An opaque location hint used to place the Node close to other resources.
  ///
  /// This field is for use by internal tools that use the public API. The
  /// location hint here on the NodeGroup overrides any location_hint present in
  /// the NodeTemplate.
  core.String? locationHint;

  /// Specifies how to handle instances when a node in the group undergoes
  /// maintenance.
  ///
  /// Set to one of: DEFAULT, RESTART_IN_PLACE, or MIGRATE_WITHIN_NODE_GROUP.
  /// The default value is DEFAULT. For more information, see Maintenance
  /// policies.
  /// Possible string values are:
  /// - "DEFAULT" : Allow the node and corresponding instances to retain default
  /// maintenance behavior.
  /// - "MAINTENANCE_POLICY_UNSPECIFIED"
  /// - "MIGRATE_WITHIN_NODE_GROUP" : When maintenance must be done on a node,
  /// the instances on that node will be moved to other nodes in the group.
  /// Instances with onHostMaintenance = MIGRATE will live migrate to their
  /// destinations while instances with onHostMaintenance = TERMINATE will
  /// terminate and then restart on their destination nodes if automaticRestart
  /// = true.
  /// - "RESTART_IN_PLACE" : Instances in this group will restart on the same
  /// node when maintenance has completed. Instances must have onHostMaintenance
  /// = TERMINATE, and they will only restart if automaticRestart = true.
  core.String? maintenancePolicy;
  NodeGroupMaintenanceWindow? maintenanceWindow;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The resource name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// URL of the node template to create the node group from.
  core.String? nodeTemplate;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Share-settings for the node group
  ShareSettings? shareSettings;

  /// The total number of nodes in the node group.
  ///
  /// Output only.
  core.int? size;

  ///
  /// Possible string values are:
  /// - "CREATING"
  /// - "DELETING"
  /// - "INVALID"
  /// - "READY"
  core.String? status;

  /// The name of the zone where the node group resides, such as us-central1-a.
  ///
  /// Output only.
  core.String? zone;

  NodeGroup({
    this.autoscalingPolicy,
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.locationHint,
    this.maintenancePolicy,
    this.maintenanceWindow,
    this.name,
    this.nodeTemplate,
    this.selfLink,
    this.shareSettings,
    this.size,
    this.status,
    this.zone,
  });

  NodeGroup.fromJson(core.Map json_)
      : this(
          autoscalingPolicy: json_.containsKey('autoscalingPolicy')
              ? NodeGroupAutoscalingPolicy.fromJson(json_['autoscalingPolicy']
                  as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          locationHint: json_.containsKey('locationHint')
              ? json_['locationHint'] as core.String
              : null,
          maintenancePolicy: json_.containsKey('maintenancePolicy')
              ? json_['maintenancePolicy'] as core.String
              : null,
          maintenanceWindow: json_.containsKey('maintenanceWindow')
              ? NodeGroupMaintenanceWindow.fromJson(json_['maintenanceWindow']
                  as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          nodeTemplate: json_.containsKey('nodeTemplate')
              ? json_['nodeTemplate'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          shareSettings: json_.containsKey('shareSettings')
              ? ShareSettings.fromJson(
                  json_['shareSettings'] as core.Map<core.String, core.dynamic>)
              : null,
          size: json_.containsKey('size') ? json_['size'] as core.int : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoscalingPolicy != null) 'autoscalingPolicy': autoscalingPolicy!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (locationHint != null) 'locationHint': locationHint!,
        if (maintenancePolicy != null) 'maintenancePolicy': maintenancePolicy!,
        if (maintenanceWindow != null) 'maintenanceWindow': maintenanceWindow!,
        if (name != null) 'name': name!,
        if (nodeTemplate != null) 'nodeTemplate': nodeTemplate!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (shareSettings != null) 'shareSettings': shareSettings!,
        if (size != null) 'size': size!,
        if (status != null) 'status': status!,
        if (zone != null) 'zone': zone!,
      };
}

class NodeGroupAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeGroupAggregatedListWarningData({
    this.key,
    this.value,
  });

  NodeGroupAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeGroupAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeGroupAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeGroupAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeGroupAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeGroupAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeGroupAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeGroupsScopedList resources.
  core.Map<core.String, NodeGroupsScopedList>? items;

  /// Type of resource.Always compute#nodeGroupAggregatedList for aggregated
  /// lists of node groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  NodeGroupAggregatedListWarning? warning;

  NodeGroupAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  NodeGroupAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    NodeGroupsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeGroupAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeGroupAutoscalingPolicy {
  /// The maximum number of nodes that the group should have.
  ///
  /// Must be set if autoscaling is enabled. Maximum value allowed is 100.
  core.int? maxNodes;

  /// The minimum number of nodes that the group should have.
  core.int? minNodes;

  /// The autoscaling mode.
  ///
  /// Set to one of: ON, OFF, or ONLY_SCALE_OUT. For more information, see
  /// Autoscaler modes.
  /// Possible string values are:
  /// - "MODE_UNSPECIFIED"
  /// - "OFF" : Autoscaling is disabled.
  /// - "ON" : Autocaling is fully enabled.
  /// - "ONLY_SCALE_OUT" : Autoscaling will only scale out and will not remove
  /// nodes.
  core.String? mode;

  NodeGroupAutoscalingPolicy({
    this.maxNodes,
    this.minNodes,
    this.mode,
  });

  NodeGroupAutoscalingPolicy.fromJson(core.Map json_)
      : this(
          maxNodes: json_.containsKey('maxNodes')
              ? json_['maxNodes'] as core.int
              : null,
          minNodes: json_.containsKey('minNodes')
              ? json_['minNodes'] as core.int
              : null,
          mode: json_.containsKey('mode') ? json_['mode'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maxNodes != null) 'maxNodes': maxNodes!,
        if (minNodes != null) 'minNodes': minNodes!,
        if (mode != null) 'mode': mode!,
      };
}

class NodeGroupListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeGroupListWarningData({
    this.key,
    this.value,
  });

  NodeGroupListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeGroupListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeGroupListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeGroupListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeGroupListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeGroupListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of nodeGroups.
class NodeGroupList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeGroup resources.
  core.List<NodeGroup>? items;

  /// Type of resource.Always compute#nodeGroupList for lists of node groups.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NodeGroupListWarning? warning;

  NodeGroupList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NodeGroupList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NodeGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NodeGroupListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Time window specified for daily maintenance operations.
///
/// GCE's internal maintenance will be performed within this window.
class NodeGroupMaintenanceWindow {
  /// A predetermined duration for the window, automatically chosen to be the
  /// smallest possible in the given scenario.
  ///
  /// Output only.
  Duration? maintenanceDuration;

  /// Start time of the window.
  ///
  /// This must be in UTC format that resolves to one of 00:00, 04:00, 08:00,
  /// 12:00, 16:00, or 20:00. For example, both 13:00-5 and 08:00 are valid.
  core.String? startTime;

  NodeGroupMaintenanceWindow({
    this.maintenanceDuration,
    this.startTime,
  });

  NodeGroupMaintenanceWindow.fromJson(core.Map json_)
      : this(
          maintenanceDuration: json_.containsKey('maintenanceDuration')
              ? Duration.fromJson(json_['maintenanceDuration']
                  as core.Map<core.String, core.dynamic>)
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maintenanceDuration != null)
          'maintenanceDuration': maintenanceDuration!,
        if (startTime != null) 'startTime': startTime!,
      };
}

class NodeGroupNode {
  /// Accelerators for this node.
  core.List<AcceleratorConfig>? accelerators;

  /// Node resources that are reserved by all instances.
  InstanceConsumptionInfo? consumedResources;

  /// CPU overcommit.
  /// Possible string values are:
  /// - "CPU_OVERCOMMIT_TYPE_UNSPECIFIED"
  /// - "ENABLED"
  /// - "NONE"
  core.String? cpuOvercommitType;

  /// Local disk configurations.
  core.List<LocalDisk>? disks;

  /// Instance data that shows consumed resources on the node.
  core.List<InstanceConsumptionData>? instanceConsumptionData;

  /// Instances scheduled on this node.
  core.List<core.String>? instances;

  /// The name of the node.
  core.String? name;

  /// The type of this node.
  core.String? nodeType;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Binding properties for the physical server.
  ServerBinding? serverBinding;

  /// Server ID associated with this node.
  core.String? serverId;

  ///
  /// Possible string values are:
  /// - "CREATING"
  /// - "DELETING"
  /// - "INVALID"
  /// - "READY"
  /// - "REPAIRING"
  core.String? status;

  /// Total amount of available resources on the node.
  InstanceConsumptionInfo? totalResources;

  NodeGroupNode({
    this.accelerators,
    this.consumedResources,
    this.cpuOvercommitType,
    this.disks,
    this.instanceConsumptionData,
    this.instances,
    this.name,
    this.nodeType,
    this.satisfiesPzs,
    this.serverBinding,
    this.serverId,
    this.status,
    this.totalResources,
  });

  NodeGroupNode.fromJson(core.Map json_)
      : this(
          accelerators: json_.containsKey('accelerators')
              ? (json_['accelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          consumedResources: json_.containsKey('consumedResources')
              ? InstanceConsumptionInfo.fromJson(json_['consumedResources']
                  as core.Map<core.String, core.dynamic>)
              : null,
          cpuOvercommitType: json_.containsKey('cpuOvercommitType')
              ? json_['cpuOvercommitType'] as core.String
              : null,
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => LocalDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          instanceConsumptionData: json_.containsKey('instanceConsumptionData')
              ? (json_['instanceConsumptionData'] as core.List)
                  .map((value) => InstanceConsumptionData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          nodeType: json_.containsKey('nodeType')
              ? json_['nodeType'] as core.String
              : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          serverBinding: json_.containsKey('serverBinding')
              ? ServerBinding.fromJson(
                  json_['serverBinding'] as core.Map<core.String, core.dynamic>)
              : null,
          serverId: json_.containsKey('serverId')
              ? json_['serverId'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          totalResources: json_.containsKey('totalResources')
              ? InstanceConsumptionInfo.fromJson(json_['totalResources']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (accelerators != null) 'accelerators': accelerators!,
        if (consumedResources != null) 'consumedResources': consumedResources!,
        if (cpuOvercommitType != null) 'cpuOvercommitType': cpuOvercommitType!,
        if (disks != null) 'disks': disks!,
        if (instanceConsumptionData != null)
          'instanceConsumptionData': instanceConsumptionData!,
        if (instances != null) 'instances': instances!,
        if (name != null) 'name': name!,
        if (nodeType != null) 'nodeType': nodeType!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (serverBinding != null) 'serverBinding': serverBinding!,
        if (serverId != null) 'serverId': serverId!,
        if (status != null) 'status': status!,
        if (totalResources != null) 'totalResources': totalResources!,
      };
}

class NodeGroupsAddNodesRequest {
  /// Count of additional nodes to be added to the node group.
  core.int? additionalNodeCount;

  NodeGroupsAddNodesRequest({
    this.additionalNodeCount,
  });

  NodeGroupsAddNodesRequest.fromJson(core.Map json_)
      : this(
          additionalNodeCount: json_.containsKey('additionalNodeCount')
              ? json_['additionalNodeCount'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (additionalNodeCount != null)
          'additionalNodeCount': additionalNodeCount!,
      };
}

class NodeGroupsDeleteNodesRequest {
  /// Names of the nodes to delete.
  core.List<core.String>? nodes;

  NodeGroupsDeleteNodesRequest({
    this.nodes,
  });

  NodeGroupsDeleteNodesRequest.fromJson(core.Map json_)
      : this(
          nodes: json_.containsKey('nodes')
              ? (json_['nodes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nodes != null) 'nodes': nodes!,
      };
}

class NodeGroupsListNodesWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeGroupsListNodesWarningData({
    this.key,
    this.value,
  });

  NodeGroupsListNodesWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeGroupsListNodesWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeGroupsListNodesWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeGroupsListNodesWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeGroupsListNodesWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeGroupsListNodesWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeGroupsListNodes {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Node resources.
  core.List<NodeGroupNode>? items;

  /// The resource type, which is always compute.nodeGroupsListNodes for the
  /// list of nodes in the specified node group.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NodeGroupsListNodesWarning? warning;

  NodeGroupsListNodes({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NodeGroupsListNodes.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NodeGroupNode.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NodeGroupsListNodesWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeGroupsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeGroupsScopedListWarningData({
    this.key,
    this.value,
  });

  NodeGroupsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the nodeGroup list is empty.
///
/// Output only.
class NodeGroupsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeGroupsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeGroupsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeGroupsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeGroupsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeGroupsScopedList {
  /// A list of node groups contained in this scope.
  ///
  /// Output only.
  core.List<NodeGroup>? nodeGroups;

  /// An informational warning that appears when the nodeGroup list is empty.
  ///
  /// Output only.
  NodeGroupsScopedListWarning? warning;

  NodeGroupsScopedList({
    this.nodeGroups,
    this.warning,
  });

  NodeGroupsScopedList.fromJson(core.Map json_)
      : this(
          nodeGroups: json_.containsKey('nodeGroups')
              ? (json_['nodeGroups'] as core.List)
                  .map((value) => NodeGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeGroupsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nodeGroups != null) 'nodeGroups': nodeGroups!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeGroupsSetNodeTemplateRequest {
  /// Full or partial URL of the node template resource to be updated for this
  /// node group.
  core.String? nodeTemplate;

  NodeGroupsSetNodeTemplateRequest({
    this.nodeTemplate,
  });

  NodeGroupsSetNodeTemplateRequest.fromJson(core.Map json_)
      : this(
          nodeTemplate: json_.containsKey('nodeTemplate')
              ? json_['nodeTemplate'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nodeTemplate != null) 'nodeTemplate': nodeTemplate!,
      };
}

/// Represent a sole-tenant Node Template resource.
///
/// You can use a template to define properties for nodes in a node group. For
/// more information, read Creating node groups and instances.
class NodeTemplate {
  core.List<AcceleratorConfig>? accelerators;

  /// CPU overcommit.
  /// Possible string values are:
  /// - "CPU_OVERCOMMIT_TYPE_UNSPECIFIED"
  /// - "ENABLED"
  /// - "NONE"
  core.String? cpuOvercommitType;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;
  core.List<LocalDisk>? disks;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The type of the resource.
  ///
  /// Always compute#nodeTemplate for node templates.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The resource name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Labels to use for node affinity, which will be used in instance
  /// scheduling.
  core.Map<core.String, core.String>? nodeAffinityLabels;

  /// The node type to use for nodes group that are created from this template.
  core.String? nodeType;

  /// The flexible properties of the desired node type.
  ///
  /// Node groups that use this node template will create nodes of a type that
  /// matches these properties. This field is mutually exclusive with the
  /// node_type property; you can only define one or the other, but not both.
  NodeTemplateNodeTypeFlexibility? nodeTypeFlexibility;

  /// The name of the region where the node template resides, such as
  /// us-central1.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Sets the binding properties for the physical server.
  ///
  /// Valid values include: - *\[Default\]* RESTART_NODE_ON_ANY_SERVER: Restarts
  /// VMs on any available physical server - RESTART_NODE_ON_MINIMAL_SERVER:
  /// Restarts VMs on the same physical server whenever possible See Sole-tenant
  /// node options for more information.
  ServerBinding? serverBinding;

  /// The status of the node template.
  ///
  /// One of the following values: CREATING, READY, and DELETING.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING" : Resources are being allocated.
  /// - "DELETING" : The node template is currently being deleted.
  /// - "INVALID" : Invalid status.
  /// - "READY" : The node template is ready.
  core.String? status;

  /// An optional, human-readable explanation of the status.
  ///
  /// Output only.
  core.String? statusMessage;

  NodeTemplate({
    this.accelerators,
    this.cpuOvercommitType,
    this.creationTimestamp,
    this.description,
    this.disks,
    this.id,
    this.kind,
    this.name,
    this.nodeAffinityLabels,
    this.nodeType,
    this.nodeTypeFlexibility,
    this.region,
    this.selfLink,
    this.serverBinding,
    this.status,
    this.statusMessage,
  });

  NodeTemplate.fromJson(core.Map json_)
      : this(
          accelerators: json_.containsKey('accelerators')
              ? (json_['accelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          cpuOvercommitType: json_.containsKey('cpuOvercommitType')
              ? json_['cpuOvercommitType'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => LocalDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          nodeAffinityLabels: json_.containsKey('nodeAffinityLabels')
              ? (json_['nodeAffinityLabels']
                      as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          nodeType: json_.containsKey('nodeType')
              ? json_['nodeType'] as core.String
              : null,
          nodeTypeFlexibility: json_.containsKey('nodeTypeFlexibility')
              ? NodeTemplateNodeTypeFlexibility.fromJson(
                  json_['nodeTypeFlexibility']
                      as core.Map<core.String, core.dynamic>)
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          serverBinding: json_.containsKey('serverBinding')
              ? ServerBinding.fromJson(
                  json_['serverBinding'] as core.Map<core.String, core.dynamic>)
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          statusMessage: json_.containsKey('statusMessage')
              ? json_['statusMessage'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (accelerators != null) 'accelerators': accelerators!,
        if (cpuOvercommitType != null) 'cpuOvercommitType': cpuOvercommitType!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (disks != null) 'disks': disks!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (nodeAffinityLabels != null)
          'nodeAffinityLabels': nodeAffinityLabels!,
        if (nodeType != null) 'nodeType': nodeType!,
        if (nodeTypeFlexibility != null)
          'nodeTypeFlexibility': nodeTypeFlexibility!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (serverBinding != null) 'serverBinding': serverBinding!,
        if (status != null) 'status': status!,
        if (statusMessage != null) 'statusMessage': statusMessage!,
      };
}

class NodeTemplateAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTemplateAggregatedListWarningData({
    this.key,
    this.value,
  });

  NodeTemplateAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeTemplateAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTemplateAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTemplateAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTemplateAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      NodeTemplateAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeTemplateAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeTemplatesScopedList resources.
  core.Map<core.String, NodeTemplatesScopedList>? items;

  /// Type of resource.Always compute#nodeTemplateAggregatedList for aggregated
  /// lists of node templates.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  NodeTemplateAggregatedListWarning? warning;

  NodeTemplateAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  NodeTemplateAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    NodeTemplatesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeTemplateAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeTemplateListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTemplateListWarningData({
    this.key,
    this.value,
  });

  NodeTemplateListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeTemplateListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTemplateListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTemplateListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTemplateListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeTemplateListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of node templates.
class NodeTemplateList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeTemplate resources.
  core.List<NodeTemplate>? items;

  /// Type of resource.Always compute#nodeTemplateList for lists of node
  /// templates.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NodeTemplateListWarning? warning;

  NodeTemplateList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NodeTemplateList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NodeTemplate.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NodeTemplateListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeTemplateNodeTypeFlexibility {
  core.String? cpus;
  core.String? localSsd;
  core.String? memory;

  NodeTemplateNodeTypeFlexibility({
    this.cpus,
    this.localSsd,
    this.memory,
  });

  NodeTemplateNodeTypeFlexibility.fromJson(core.Map json_)
      : this(
          cpus: json_.containsKey('cpus') ? json_['cpus'] as core.String : null,
          localSsd: json_.containsKey('localSsd')
              ? json_['localSsd'] as core.String
              : null,
          memory: json_.containsKey('memory')
              ? json_['memory'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (cpus != null) 'cpus': cpus!,
        if (localSsd != null) 'localSsd': localSsd!,
        if (memory != null) 'memory': memory!,
      };
}

class NodeTemplatesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTemplatesScopedListWarningData({
    this.key,
    this.value,
  });

  NodeTemplatesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the node templates list is empty.
///
/// Output only.
class NodeTemplatesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTemplatesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTemplatesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTemplatesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeTemplatesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeTemplatesScopedList {
  /// A list of node templates contained in this scope.
  ///
  /// Output only.
  core.List<NodeTemplate>? nodeTemplates;

  /// An informational warning that appears when the node templates list is
  /// empty.
  ///
  /// Output only.
  NodeTemplatesScopedListWarning? warning;

  NodeTemplatesScopedList({
    this.nodeTemplates,
    this.warning,
  });

  NodeTemplatesScopedList.fromJson(core.Map json_)
      : this(
          nodeTemplates: json_.containsKey('nodeTemplates')
              ? (json_['nodeTemplates'] as core.List)
                  .map((value) => NodeTemplate.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeTemplatesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nodeTemplates != null) 'nodeTemplates': nodeTemplates!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represent a sole-tenant Node Type resource.
///
/// Each node within a node group must have a node type. A node type specifies
/// the total amount of cores and memory for that node. Currently, the only
/// available node type is n1-node-96-624 node type that has 96 vCPUs and 624 GB
/// of memory, available in multiple zones. For more information read Node
/// types.
class NodeType {
  /// The CPU platform used by this node type.
  ///
  /// Output only.
  core.String? cpuPlatform;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this node type.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// An optional textual description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The number of virtual CPUs that are available to the node type.
  ///
  /// Output only.
  core.int? guestCpus;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The type of the resource.
  ///
  /// Always compute#nodeType for node types.
  ///
  /// Output only.
  core.String? kind;

  /// Local SSD available to the node type, defined in GB.
  ///
  /// Output only.
  core.int? localSsdGb;

  /// The amount of physical memory available to the node type, defined in MB.
  ///
  /// Output only.
  core.int? memoryMb;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The name of the zone where the node type resides, such as us-central1-a.
  ///
  /// Output only.
  core.String? zone;

  NodeType({
    this.cpuPlatform,
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.guestCpus,
    this.id,
    this.kind,
    this.localSsdGb,
    this.memoryMb,
    this.name,
    this.selfLink,
    this.zone,
  });

  NodeType.fromJson(core.Map json_)
      : this(
          cpuPlatform: json_.containsKey('cpuPlatform')
              ? json_['cpuPlatform'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          guestCpus: json_.containsKey('guestCpus')
              ? json_['guestCpus'] as core.int
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          localSsdGb: json_.containsKey('localSsdGb')
              ? json_['localSsdGb'] as core.int
              : null,
          memoryMb: json_.containsKey('memoryMb')
              ? json_['memoryMb'] as core.int
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (cpuPlatform != null) 'cpuPlatform': cpuPlatform!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (guestCpus != null) 'guestCpus': guestCpus!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (localSsdGb != null) 'localSsdGb': localSsdGb!,
        if (memoryMb != null) 'memoryMb': memoryMb!,
        if (name != null) 'name': name!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (zone != null) 'zone': zone!,
      };
}

class NodeTypeAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTypeAggregatedListWarningData({
    this.key,
    this.value,
  });

  NodeTypeAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeTypeAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTypeAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTypeAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTypeAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeTypeAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeTypeAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeTypesScopedList resources.
  core.Map<core.String, NodeTypesScopedList>? items;

  /// Type of resource.Always compute#nodeTypeAggregatedList for aggregated
  /// lists of node types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  NodeTypeAggregatedListWarning? warning;

  NodeTypeAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  NodeTypeAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    NodeTypesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeTypeAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeTypeListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTypeListWarningData({
    this.key,
    this.value,
  });

  NodeTypeListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NodeTypeListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTypeListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTypeListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTypeListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeTypeListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of node types.
class NodeTypeList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NodeType resources.
  core.List<NodeType>? items;

  /// Type of resource.Always compute#nodeTypeList for lists of node types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NodeTypeListWarning? warning;

  NodeTypeList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NodeTypeList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NodeType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NodeTypeListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class NodeTypesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NodeTypesScopedListWarningData({
    this.key,
    this.value,
  });

  NodeTypesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the node types list is empty.
///
/// Output only.
class NodeTypesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NodeTypesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NodeTypesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  NodeTypesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NodeTypesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NodeTypesScopedList {
  /// A list of node types contained in this scope.
  ///
  /// Output only.
  core.List<NodeType>? nodeTypes;

  /// An informational warning that appears when the node types list is empty.
  ///
  /// Output only.
  NodeTypesScopedListWarning? warning;

  NodeTypesScopedList({
    this.nodeTypes,
    this.warning,
  });

  NodeTypesScopedList.fromJson(core.Map json_)
      : this(
          nodeTypes: json_.containsKey('nodeTypes')
              ? (json_['nodeTypes'] as core.List)
                  .map((value) => NodeType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? NodeTypesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (nodeTypes != null) 'nodeTypes': nodeTypes!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a notification endpoint.
///
/// A notification endpoint resource defines an endpoint to receive
/// notifications when there are status changes detected by the associated
/// health check service. For more information, see Health checks overview.
class NotificationEndpoint {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Settings of the gRPC notification endpoint including the endpoint URL and
  /// the retry duration.
  NotificationEndpointGrpcSettings? grpcSettings;

  /// A unique identifier for this resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#notificationEndpoint for notification endpoints.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the region where the notification endpoint resides.
  ///
  /// This field applies only to the regional resource. You must specify this
  /// field as part of the HTTP request URL. It is not settable as a field in
  /// the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  NotificationEndpoint({
    this.creationTimestamp,
    this.description,
    this.grpcSettings,
    this.id,
    this.kind,
    this.name,
    this.region,
    this.selfLink,
  });

  NotificationEndpoint.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          grpcSettings: json_.containsKey('grpcSettings')
              ? NotificationEndpointGrpcSettings.fromJson(
                  json_['grpcSettings'] as core.Map<core.String, core.dynamic>)
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (grpcSettings != null) 'grpcSettings': grpcSettings!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// Represents a gRPC setting that describes one gRPC notification endpoint and
/// the retry duration attempting to send notification to this endpoint.
class NotificationEndpointGrpcSettings {
  /// If specified, this field is used to set the authority header by the sender
  /// of notifications.
  ///
  /// See https://tools.ietf.org/html/rfc7540#section-8.1.2.3
  ///
  /// Optional.
  core.String? authority;

  /// Endpoint to which gRPC notifications are sent.
  ///
  /// This must be a valid gRPCLB DNS name.
  core.String? endpoint;

  /// If specified, this field is used to populate the "name" field in gRPC
  /// requests.
  ///
  /// Optional.
  core.String? payloadName;

  /// This field is used to configure how often to send a full update of all
  /// non-healthy backends.
  ///
  /// If unspecified, full updates are not sent. If specified, must be in the
  /// range between 600 seconds to 3600 seconds. Nanos are disallowed.
  ///
  /// Optional.
  Duration? resendInterval;

  /// How much time (in seconds) is spent attempting notification retries until
  /// a successful response is received.
  ///
  /// Default is 30s. Limit is 20m (1200s). Must be a positive number.
  core.int? retryDurationSec;

  NotificationEndpointGrpcSettings({
    this.authority,
    this.endpoint,
    this.payloadName,
    this.resendInterval,
    this.retryDurationSec,
  });

  NotificationEndpointGrpcSettings.fromJson(core.Map json_)
      : this(
          authority: json_.containsKey('authority')
              ? json_['authority'] as core.String
              : null,
          endpoint: json_.containsKey('endpoint')
              ? json_['endpoint'] as core.String
              : null,
          payloadName: json_.containsKey('payloadName')
              ? json_['payloadName'] as core.String
              : null,
          resendInterval: json_.containsKey('resendInterval')
              ? Duration.fromJson(json_['resendInterval']
                  as core.Map<core.String, core.dynamic>)
              : null,
          retryDurationSec: json_.containsKey('retryDurationSec')
              ? json_['retryDurationSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (authority != null) 'authority': authority!,
        if (endpoint != null) 'endpoint': endpoint!,
        if (payloadName != null) 'payloadName': payloadName!,
        if (resendInterval != null) 'resendInterval': resendInterval!,
        if (retryDurationSec != null) 'retryDurationSec': retryDurationSec!,
      };
}

class NotificationEndpointListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  NotificationEndpointListWarningData({
    this.key,
    this.value,
  });

  NotificationEndpointListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class NotificationEndpointListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<NotificationEndpointListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  NotificationEndpointListWarning({
    this.code,
    this.data,
    this.message,
  });

  NotificationEndpointListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => NotificationEndpointListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class NotificationEndpointList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of NotificationEndpoint resources.
  core.List<NotificationEndpoint>? items;

  /// Type of the resource.
  ///
  /// Always compute#notificationEndpoint for notification endpoints.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  NotificationEndpointListWarning? warning;

  NotificationEndpointList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  NotificationEndpointList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => NotificationEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? NotificationEndpointListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class OperationErrorErrorsErrorDetails {
  ErrorInfo? errorInfo;
  Help? help;
  LocalizedMessage? localizedMessage;

  OperationErrorErrorsErrorDetails({
    this.errorInfo,
    this.help,
    this.localizedMessage,
  });

  OperationErrorErrorsErrorDetails.fromJson(core.Map json_)
      : this(
          errorInfo: json_.containsKey('errorInfo')
              ? ErrorInfo.fromJson(
                  json_['errorInfo'] as core.Map<core.String, core.dynamic>)
              : null,
          help: json_.containsKey('help')
              ? Help.fromJson(
                  json_['help'] as core.Map<core.String, core.dynamic>)
              : null,
          localizedMessage: json_.containsKey('localizedMessage')
              ? LocalizedMessage.fromJson(json_['localizedMessage']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (errorInfo != null) 'errorInfo': errorInfo!,
        if (help != null) 'help': help!,
        if (localizedMessage != null) 'localizedMessage': localizedMessage!,
      };
}

class OperationErrorErrors {
  /// The error type identifier for this error.
  ///
  /// Output only.
  core.String? code;

  /// An optional list of messages that contain the error details.
  ///
  /// There is a set of defined message types to use for providing details.The
  /// syntax depends on the error code. For example, QuotaExceededInfo will have
  /// details when the error code is QUOTA_EXCEEDED.
  ///
  /// Output only.
  core.List<OperationErrorErrorsErrorDetails>? errorDetails;

  /// Indicates the field in the request that caused the error.
  ///
  /// This property is optional.
  ///
  /// Output only.
  core.String? location;

  /// An optional, human-readable error message.
  ///
  /// Output only.
  core.String? message;

  OperationErrorErrors({
    this.code,
    this.errorDetails,
    this.location,
    this.message,
  });

  OperationErrorErrors.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          errorDetails: json_.containsKey('errorDetails')
              ? (json_['errorDetails'] as core.List)
                  .map((value) => OperationErrorErrorsErrorDetails.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          location: json_.containsKey('location')
              ? json_['location'] as core.String
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (errorDetails != null) 'errorDetails': errorDetails!,
        if (location != null) 'location': location!,
        if (message != null) 'message': message!,
      };
}

/// If errors are generated during processing of the operation, this field will
/// be populated.
///
/// Output only.
class OperationError {
  /// The array of errors encountered while processing this operation.
  ///
  /// Output only.
  core.List<OperationErrorErrors>? errors;

  OperationError({
    this.errors,
  });

  OperationError.fromJson(core.Map json_)
      : this(
          errors: json_.containsKey('errors')
              ? (json_['errors'] as core.List)
                  .map((value) => OperationErrorErrors.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (errors != null) 'errors': errors!,
      };
}

class OperationWarningsData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  OperationWarningsData({
    this.key,
    this.value,
  });

  OperationWarningsData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

class OperationWarnings {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<OperationWarningsData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  OperationWarnings({
    this.code,
    this.data,
    this.message,
  });

  OperationWarnings.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => OperationWarningsData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Represents an Operation resource.
///
/// Google Compute Engine has three Operation resources: *
/// \[Global\](/compute/docs/reference/rest/v1/globalOperations) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionOperations) *
/// \[Zonal\](/compute/docs/reference/rest/v1/zoneOperations) You can use an
/// operation resource to manage asynchronous API requests. For more
/// information, read Handling API responses. Operations can be global, regional
/// or zonal. - For global operations, use the `globalOperations` resource. -
/// For regional operations, use the `regionOperations` resource. - For zonal
/// operations, use the `zonalOperations` resource. For more information, read
/// Global, Regional, and Zonal Resources.
class Operation {
  /// The value of `requestId` if you provided it in the request.
  ///
  /// Not present otherwise.
  ///
  /// Output only.
  core.String? clientOperationId;

  /// This field is deprecated.
  ///
  /// Deprecated.
  core.String? creationTimestamp;

  /// A textual description of the operation, which is set when the operation is
  /// created.
  ///
  /// Output only.
  core.String? description;

  /// The time that this operation was completed.
  ///
  /// This value is in RFC3339 text format.
  ///
  /// Output only.
  core.String? endTime;

  /// If errors are generated during processing of the operation, this field
  /// will be populated.
  ///
  /// Output only.
  OperationError? error;

  /// If the operation fails, this field contains the HTTP error message that
  /// was returned, such as `NOT FOUND`.
  ///
  /// Output only.
  core.String? httpErrorMessage;

  /// If the operation fails, this field contains the HTTP error status code
  /// that was returned.
  ///
  /// For example, a `404` means the resource was not found.
  ///
  /// Output only.
  core.int? httpErrorStatusCode;

  /// The unique identifier for the operation.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The time that this operation was requested.
  ///
  /// This value is in RFC3339 text format.
  ///
  /// Output only.
  core.String? insertTime;

  /// Type of the resource.
  ///
  /// Always `compute#operation` for Operation resources.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the operation.
  ///
  /// Output only.
  core.String? name;

  /// An ID that represents a group of operations, such as when a group of
  /// operations results from a `bulkInsert` API request.
  ///
  /// Output only.
  core.String? operationGroupId;

  /// The type of operation, such as `insert`, `update`, or `delete`, and so on.
  ///
  /// Output only.
  core.String? operationType;

  /// An optional progress indicator that ranges from 0 to 100.
  ///
  /// There is no requirement that this be linear or support any granularity of
  /// operations. This should not be used to guess when the operation will be
  /// complete. This number should monotonically increase as the operation
  /// progresses.
  ///
  /// Output only.
  core.int? progress;

  /// The URL of the region where the operation resides.
  ///
  /// Only applicable when performing regional operations.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The time that this operation was started by the server.
  ///
  /// This value is in RFC3339 text format.
  ///
  /// Output only.
  core.String? startTime;

  /// The status of the operation, which can be one of the following: `PENDING`,
  /// `RUNNING`, or `DONE`.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DONE"
  /// - "PENDING"
  /// - "RUNNING"
  core.String? status;

  /// An optional textual description of the current status of the operation.
  ///
  /// Output only.
  core.String? statusMessage;

  /// The unique target ID, which identifies a specific incarnation of the
  /// target resource.
  ///
  /// Output only.
  core.String? targetId;

  /// The URL of the resource that the operation modifies.
  ///
  /// For operations related to creating a snapshot, this points to the
  /// persistent disk that the snapshot was created from.
  ///
  /// Output only.
  core.String? targetLink;

  /// User who requested the operation, for example: `user@example.com`.
  ///
  /// Output only.
  core.String? user;

  /// If warning messages are generated during processing of the operation, this
  /// field will be populated.
  ///
  /// Output only.
  core.List<OperationWarnings>? warnings;

  /// The URL of the zone where the operation resides.
  ///
  /// Only applicable when performing per-zone operations.
  ///
  /// Output only.
  core.String? zone;

  Operation({
    this.clientOperationId,
    this.creationTimestamp,
    this.description,
    this.endTime,
    this.error,
    this.httpErrorMessage,
    this.httpErrorStatusCode,
    this.id,
    this.insertTime,
    this.kind,
    this.name,
    this.operationGroupId,
    this.operationType,
    this.progress,
    this.region,
    this.selfLink,
    this.startTime,
    this.status,
    this.statusMessage,
    this.targetId,
    this.targetLink,
    this.user,
    this.warnings,
    this.zone,
  });

  Operation.fromJson(core.Map json_)
      : this(
          clientOperationId: json_.containsKey('clientOperationId')
              ? json_['clientOperationId'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          endTime: json_.containsKey('endTime')
              ? json_['endTime'] as core.String
              : null,
          error: json_.containsKey('error')
              ? OperationError.fromJson(
                  json_['error'] as core.Map<core.String, core.dynamic>)
              : null,
          httpErrorMessage: json_.containsKey('httpErrorMessage')
              ? json_['httpErrorMessage'] as core.String
              : null,
          httpErrorStatusCode: json_.containsKey('httpErrorStatusCode')
              ? json_['httpErrorStatusCode'] as core.int
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          insertTime: json_.containsKey('insertTime')
              ? json_['insertTime'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          operationGroupId: json_.containsKey('operationGroupId')
              ? json_['operationGroupId'] as core.String
              : null,
          operationType: json_.containsKey('operationType')
              ? json_['operationType'] as core.String
              : null,
          progress: json_.containsKey('progress')
              ? json_['progress'] as core.int
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          statusMessage: json_.containsKey('statusMessage')
              ? json_['statusMessage'] as core.String
              : null,
          targetId: json_.containsKey('targetId')
              ? json_['targetId'] as core.String
              : null,
          targetLink: json_.containsKey('targetLink')
              ? json_['targetLink'] as core.String
              : null,
          user: json_.containsKey('user') ? json_['user'] as core.String : null,
          warnings: json_.containsKey('warnings')
              ? (json_['warnings'] as core.List)
                  .map((value) => OperationWarnings.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (clientOperationId != null) 'clientOperationId': clientOperationId!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (endTime != null) 'endTime': endTime!,
        if (error != null) 'error': error!,
        if (httpErrorMessage != null) 'httpErrorMessage': httpErrorMessage!,
        if (httpErrorStatusCode != null)
          'httpErrorStatusCode': httpErrorStatusCode!,
        if (id != null) 'id': id!,
        if (insertTime != null) 'insertTime': insertTime!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (operationGroupId != null) 'operationGroupId': operationGroupId!,
        if (operationType != null) 'operationType': operationType!,
        if (progress != null) 'progress': progress!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (startTime != null) 'startTime': startTime!,
        if (status != null) 'status': status!,
        if (statusMessage != null) 'statusMessage': statusMessage!,
        if (targetId != null) 'targetId': targetId!,
        if (targetLink != null) 'targetLink': targetLink!,
        if (user != null) 'user': user!,
        if (warnings != null) 'warnings': warnings!,
        if (zone != null) 'zone': zone!,
      };
}

class OperationAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  OperationAggregatedListWarningData({
    this.key,
    this.value,
  });

  OperationAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class OperationAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<OperationAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  OperationAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  OperationAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => OperationAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class OperationAggregatedList {
  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A map of scoped operation lists.
  ///
  /// Output only.
  core.Map<core.String, OperationsScopedList>? items;

  /// Type of resource.
  ///
  /// Always `compute#operationAggregatedList` for aggregated lists of
  /// operations.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than `maxResults`, use the
  /// `nextPageToken` as a value for the query parameter `pageToken` in the next
  /// list request. Subsequent list requests will have their own `nextPageToken`
  /// to continue paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  OperationAggregatedListWarning? warning;

  OperationAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  OperationAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    OperationsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? OperationAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class OperationListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  OperationListWarningData({
    this.key,
    this.value,
  });

  OperationListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class OperationListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<OperationListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  OperationListWarning({
    this.code,
    this.data,
    this.message,
  });

  OperationListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => OperationListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Operation resources.
class OperationList {
  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Operation resources.
  ///
  /// Output only.
  core.List<Operation>? items;

  /// Type of resource.
  ///
  /// Always `compute#operations` for Operations resource.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than `maxResults`, use the
  /// `nextPageToken` as a value for the query parameter `pageToken` in the next
  /// list request. Subsequent list requests will have their own `nextPageToken`
  /// to continue paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  OperationListWarning? warning;

  OperationList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  OperationList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Operation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? OperationListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class OperationsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  OperationsScopedListWarningData({
    this.key,
    this.value,
  });

  OperationsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of operations when the list is
/// empty.
///
/// Output only.
class OperationsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<OperationsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  OperationsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  OperationsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => OperationsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class OperationsScopedList {
  /// A list of operations contained in this scope.
  ///
  /// Output only.
  core.List<Operation>? operations;

  /// Informational warning which replaces the list of operations when the list
  /// is empty.
  ///
  /// Output only.
  OperationsScopedListWarning? warning;

  OperationsScopedList({
    this.operations,
    this.warning,
  });

  OperationsScopedList.fromJson(core.Map json_)
      : this(
          operations: json_.containsKey('operations')
              ? (json_['operations'] as core.List)
                  .map((value) => Operation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? OperationsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (operations != null) 'operations': operations!,
        if (warning != null) 'warning': warning!,
      };
}

/// Settings controlling the eviction of unhealthy hosts from the load balancing
/// pool for the backend service.
class OutlierDetection {
  /// The base time that a host is ejected for.
  ///
  /// The real ejection time is equal to the base ejection time multiplied by
  /// the number of times the host has been ejected. Defaults to 30000ms or 30s.
  Duration? baseEjectionTime;

  /// Number of errors before a host is ejected from the connection pool.
  ///
  /// When the backend host is accessed over HTTP, a 5xx return code qualifies
  /// as an error. Defaults to 5.
  core.int? consecutiveErrors;

  /// The number of consecutive gateway failures (502, 503, 504 status or
  /// connection errors that are mapped to one of those status codes) before a
  /// consecutive gateway failure ejection occurs.
  ///
  /// Defaults to 3.
  core.int? consecutiveGatewayFailure;

  /// The percentage chance that a host will be actually ejected when an outlier
  /// status is detected through consecutive 5xx.
  ///
  /// This setting can be used to disable ejection or to ramp it up slowly.
  /// Defaults to 0.
  core.int? enforcingConsecutiveErrors;

  /// The percentage chance that a host will be actually ejected when an outlier
  /// status is detected through consecutive gateway failures.
  ///
  /// This setting can be used to disable ejection or to ramp it up slowly.
  /// Defaults to 100.
  core.int? enforcingConsecutiveGatewayFailure;

  /// The percentage chance that a host will be actually ejected when an outlier
  /// status is detected through success rate statistics.
  ///
  /// This setting can be used to disable ejection or to ramp it up slowly.
  /// Defaults to 100.
  core.int? enforcingSuccessRate;

  /// Time interval between ejection analysis sweeps.
  ///
  /// This can result in both new ejections as well as hosts being returned to
  /// service. Defaults to 1 second.
  Duration? interval;

  /// Maximum percentage of hosts in the load balancing pool for the backend
  /// service that can be ejected.
  ///
  /// Defaults to 50%.
  core.int? maxEjectionPercent;

  /// The number of hosts in a cluster that must have enough request volume to
  /// detect success rate outliers.
  ///
  /// If the number of hosts is less than this setting, outlier detection via
  /// success rate statistics is not performed for any host in the cluster.
  /// Defaults to 5.
  core.int? successRateMinimumHosts;

  /// The minimum number of total requests that must be collected in one
  /// interval (as defined by the interval duration above) to include this host
  /// in success rate based outlier detection.
  ///
  /// If the volume is lower than this setting, outlier detection via success
  /// rate statistics is not performed for that host. Defaults to 100.
  core.int? successRateRequestVolume;

  /// This factor is used to determine the ejection threshold for success rate
  /// outlier ejection.
  ///
  /// The ejection threshold is the difference between the mean success rate,
  /// and the product of this factor and the standard deviation of the mean
  /// success rate: mean - (stdev * success_rate_stdev_factor). This factor is
  /// divided by a thousand to get a double. That is, if the desired factor is
  /// 1.9, the runtime value should be 1900. Defaults to 1900.
  core.int? successRateStdevFactor;

  OutlierDetection({
    this.baseEjectionTime,
    this.consecutiveErrors,
    this.consecutiveGatewayFailure,
    this.enforcingConsecutiveErrors,
    this.enforcingConsecutiveGatewayFailure,
    this.enforcingSuccessRate,
    this.interval,
    this.maxEjectionPercent,
    this.successRateMinimumHosts,
    this.successRateRequestVolume,
    this.successRateStdevFactor,
  });

  OutlierDetection.fromJson(core.Map json_)
      : this(
          baseEjectionTime: json_.containsKey('baseEjectionTime')
              ? Duration.fromJson(json_['baseEjectionTime']
                  as core.Map<core.String, core.dynamic>)
              : null,
          consecutiveErrors: json_.containsKey('consecutiveErrors')
              ? json_['consecutiveErrors'] as core.int
              : null,
          consecutiveGatewayFailure:
              json_.containsKey('consecutiveGatewayFailure')
                  ? json_['consecutiveGatewayFailure'] as core.int
                  : null,
          enforcingConsecutiveErrors:
              json_.containsKey('enforcingConsecutiveErrors')
                  ? json_['enforcingConsecutiveErrors'] as core.int
                  : null,
          enforcingConsecutiveGatewayFailure:
              json_.containsKey('enforcingConsecutiveGatewayFailure')
                  ? json_['enforcingConsecutiveGatewayFailure'] as core.int
                  : null,
          enforcingSuccessRate: json_.containsKey('enforcingSuccessRate')
              ? json_['enforcingSuccessRate'] as core.int
              : null,
          interval: json_.containsKey('interval')
              ? Duration.fromJson(
                  json_['interval'] as core.Map<core.String, core.dynamic>)
              : null,
          maxEjectionPercent: json_.containsKey('maxEjectionPercent')
              ? json_['maxEjectionPercent'] as core.int
              : null,
          successRateMinimumHosts: json_.containsKey('successRateMinimumHosts')
              ? json_['successRateMinimumHosts'] as core.int
              : null,
          successRateRequestVolume:
              json_.containsKey('successRateRequestVolume')
                  ? json_['successRateRequestVolume'] as core.int
                  : null,
          successRateStdevFactor: json_.containsKey('successRateStdevFactor')
              ? json_['successRateStdevFactor'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (baseEjectionTime != null) 'baseEjectionTime': baseEjectionTime!,
        if (consecutiveErrors != null) 'consecutiveErrors': consecutiveErrors!,
        if (consecutiveGatewayFailure != null)
          'consecutiveGatewayFailure': consecutiveGatewayFailure!,
        if (enforcingConsecutiveErrors != null)
          'enforcingConsecutiveErrors': enforcingConsecutiveErrors!,
        if (enforcingConsecutiveGatewayFailure != null)
          'enforcingConsecutiveGatewayFailure':
              enforcingConsecutiveGatewayFailure!,
        if (enforcingSuccessRate != null)
          'enforcingSuccessRate': enforcingSuccessRate!,
        if (interval != null) 'interval': interval!,
        if (maxEjectionPercent != null)
          'maxEjectionPercent': maxEjectionPercent!,
        if (successRateMinimumHosts != null)
          'successRateMinimumHosts': successRateMinimumHosts!,
        if (successRateRequestVolume != null)
          'successRateRequestVolume': successRateRequestVolume!,
        if (successRateStdevFactor != null)
          'successRateStdevFactor': successRateStdevFactor!,
      };
}

/// Next free: 7
class PacketIntervals {
  /// Average observed inter-packet interval in milliseconds.
  core.String? avgMs;

  /// From how long ago in the past these intervals were observed.
  /// Possible string values are:
  /// - "DURATION_UNSPECIFIED"
  /// - "HOUR"
  /// - "MAX" : From BfdSession object creation time.
  /// - "MINUTE"
  core.String? duration;

  /// Maximum observed inter-packet interval in milliseconds.
  core.String? maxMs;

  /// Minimum observed inter-packet interval in milliseconds.
  core.String? minMs;

  /// Number of inter-packet intervals from which these statistics were derived.
  core.String? numIntervals;

  /// The type of packets for which inter-packet intervals were computed.
  /// Possible string values are:
  /// - "LOOPBACK" : Only applies to Echo packets. This shows the intervals
  /// between sending and receiving the same packet.
  /// - "RECEIVE" : Intervals between received packets.
  /// - "TRANSMIT" : Intervals between transmitted packets.
  /// - "TYPE_UNSPECIFIED"
  core.String? type;

  PacketIntervals({
    this.avgMs,
    this.duration,
    this.maxMs,
    this.minMs,
    this.numIntervals,
    this.type,
  });

  PacketIntervals.fromJson(core.Map json_)
      : this(
          avgMs:
              json_.containsKey('avgMs') ? json_['avgMs'] as core.String : null,
          duration: json_.containsKey('duration')
              ? json_['duration'] as core.String
              : null,
          maxMs:
              json_.containsKey('maxMs') ? json_['maxMs'] as core.String : null,
          minMs:
              json_.containsKey('minMs') ? json_['minMs'] as core.String : null,
          numIntervals: json_.containsKey('numIntervals')
              ? json_['numIntervals'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (avgMs != null) 'avgMs': avgMs!,
        if (duration != null) 'duration': duration!,
        if (maxMs != null) 'maxMs': maxMs!,
        if (minMs != null) 'minMs': minMs!,
        if (numIntervals != null) 'numIntervals': numIntervals!,
        if (type != null) 'type': type!,
      };
}

/// Represents a Packet Mirroring resource.
///
/// Packet Mirroring clones the traffic of specified instances in your Virtual
/// Private Cloud (VPC) network and forwards it to a collector destination, such
/// as an instance group of an internal TCP/UDP load balancer, for analysis or
/// examination. For more information about setting up Packet Mirroring, see
/// Using Packet Mirroring.
class PacketMirroring {
  /// The Forwarding Rule resource of type loadBalancingScheme=INTERNAL that
  /// will be used as collector for mirrored traffic.
  ///
  /// The specified forwarding rule must have isMirroringCollector set to true.
  PacketMirroringForwardingRuleInfo? collectorIlb;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Indicates whether or not this packet mirroring takes effect.
  ///
  /// If set to FALSE, this packet mirroring policy will not be enforced on the
  /// network. The default is TRUE.
  /// Possible string values are:
  /// - "FALSE"
  /// - "TRUE"
  core.String? enable;

  /// Filter for mirrored traffic.
  ///
  /// If unspecified, all traffic is mirrored.
  PacketMirroringFilter? filter;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#packetMirroring for packet mirrorings.
  ///
  /// Output only.
  core.String? kind;

  /// PacketMirroring mirroredResourceInfos.
  ///
  /// MirroredResourceInfo specifies a set of mirrored VM instances, subnetworks
  /// and/or tags for which traffic from/to all VM instances will be mirrored.
  PacketMirroringMirroredResourceInfo? mirroredResources;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Specifies the mirrored VPC network.
  ///
  /// Only packets in this network will be mirrored. All mirrored VMs should
  /// have a NIC in the given network. All mirrored subnetworks should belong to
  /// the given network.
  PacketMirroringNetworkInfo? network;

  /// The priority of applying this configuration.
  ///
  /// Priority is used to break ties in cases where there is more than one
  /// matching rule. In the case of two rules that apply for a given Instance,
  /// the one with the lowest-numbered priority value wins. Default value is
  /// 1000. Valid range is 0 through 65535.
  core.int? priority;

  /// URI of the region where the packetMirroring resides.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  PacketMirroring({
    this.collectorIlb,
    this.creationTimestamp,
    this.description,
    this.enable,
    this.filter,
    this.id,
    this.kind,
    this.mirroredResources,
    this.name,
    this.network,
    this.priority,
    this.region,
    this.selfLink,
  });

  PacketMirroring.fromJson(core.Map json_)
      : this(
          collectorIlb: json_.containsKey('collectorIlb')
              ? PacketMirroringForwardingRuleInfo.fromJson(
                  json_['collectorIlb'] as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          enable: json_.containsKey('enable')
              ? json_['enable'] as core.String
              : null,
          filter: json_.containsKey('filter')
              ? PacketMirroringFilter.fromJson(
                  json_['filter'] as core.Map<core.String, core.dynamic>)
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          mirroredResources: json_.containsKey('mirroredResources')
              ? PacketMirroringMirroredResourceInfo.fromJson(
                  json_['mirroredResources']
                      as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? PacketMirroringNetworkInfo.fromJson(
                  json_['network'] as core.Map<core.String, core.dynamic>)
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (collectorIlb != null) 'collectorIlb': collectorIlb!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (enable != null) 'enable': enable!,
        if (filter != null) 'filter': filter!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (mirroredResources != null) 'mirroredResources': mirroredResources!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (priority != null) 'priority': priority!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

class PacketMirroringAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PacketMirroringAggregatedListWarningData({
    this.key,
    this.value,
  });

  PacketMirroringAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class PacketMirroringAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PacketMirroringAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PacketMirroringAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  PacketMirroringAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      PacketMirroringAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of packetMirrorings.
class PacketMirroringAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of PacketMirroring resources.
  core.Map<core.String, PacketMirroringsScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  PacketMirroringAggregatedListWarning? warning;

  PacketMirroringAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  PacketMirroringAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    PacketMirroringsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? PacketMirroringAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class PacketMirroringFilter {
  /// Protocols that apply as filter on mirrored traffic.
  ///
  /// If no protocols are specified, all traffic that matches the specified CIDR
  /// ranges is mirrored. If neither cidrRanges nor IPProtocols is specified,
  /// all traffic is mirrored.
  core.List<core.String>? IPProtocols;

  /// IP CIDR ranges that apply as filter on the source (ingress) or destination
  /// (egress) IP in the IP header.
  ///
  /// Only IPv4 is supported. If no ranges are specified, all traffic that
  /// matches the specified IPProtocols is mirrored. If neither cidrRanges nor
  /// IPProtocols is specified, all traffic is mirrored.
  core.List<core.String>? cidrRanges;

  /// Direction of traffic to mirror, either INGRESS, EGRESS, or BOTH.
  ///
  /// The default is BOTH.
  /// Possible string values are:
  /// - "BOTH" : Default, both directions are mirrored.
  /// - "EGRESS" : Only egress traffic is mirrored.
  /// - "INGRESS" : Only ingress traffic is mirrored.
  core.String? direction;

  PacketMirroringFilter({
    this.IPProtocols,
    this.cidrRanges,
    this.direction,
  });

  PacketMirroringFilter.fromJson(core.Map json_)
      : this(
          IPProtocols: json_.containsKey('IPProtocols')
              ? (json_['IPProtocols'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          cidrRanges: json_.containsKey('cidrRanges')
              ? (json_['cidrRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          direction: json_.containsKey('direction')
              ? json_['direction'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (IPProtocols != null) 'IPProtocols': IPProtocols!,
        if (cidrRanges != null) 'cidrRanges': cidrRanges!,
        if (direction != null) 'direction': direction!,
      };
}

class PacketMirroringForwardingRuleInfo {
  /// Unique identifier for the forwarding rule; defined by the server.
  ///
  /// Output only.
  core.String? canonicalUrl;

  /// Resource URL to the forwarding rule representing the ILB configured as
  /// destination of the mirrored traffic.
  core.String? url;

  PacketMirroringForwardingRuleInfo({
    this.canonicalUrl,
    this.url,
  });

  PacketMirroringForwardingRuleInfo.fromJson(core.Map json_)
      : this(
          canonicalUrl: json_.containsKey('canonicalUrl')
              ? json_['canonicalUrl'] as core.String
              : null,
          url: json_.containsKey('url') ? json_['url'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (canonicalUrl != null) 'canonicalUrl': canonicalUrl!,
        if (url != null) 'url': url!,
      };
}

class PacketMirroringListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PacketMirroringListWarningData({
    this.key,
    this.value,
  });

  PacketMirroringListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class PacketMirroringListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PacketMirroringListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PacketMirroringListWarning({
    this.code,
    this.data,
    this.message,
  });

  PacketMirroringListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => PacketMirroringListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of PacketMirroring resources.
class PacketMirroringList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of PacketMirroring resources.
  core.List<PacketMirroring>? items;

  /// Type of resource.
  ///
  /// Always compute#packetMirroring for packetMirrorings.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  PacketMirroringListWarning? warning;

  PacketMirroringList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  PacketMirroringList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => PacketMirroring.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? PacketMirroringListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class PacketMirroringMirroredResourceInfo {
  /// A set of virtual machine instances that are being mirrored.
  ///
  /// They must live in zones contained in the same region as this
  /// packetMirroring. Note that this config will apply only to those network
  /// interfaces of the Instances that belong to the network specified in this
  /// packetMirroring. You may specify a maximum of 50 Instances.
  core.List<PacketMirroringMirroredResourceInfoInstanceInfo>? instances;

  /// A set of subnetworks for which traffic from/to all VM instances will be
  /// mirrored.
  ///
  /// They must live in the same region as this packetMirroring. You may specify
  /// a maximum of 5 subnetworks.
  core.List<PacketMirroringMirroredResourceInfoSubnetInfo>? subnetworks;

  /// A set of mirrored tags.
  ///
  /// Traffic from/to all VM instances that have one or more of these tags will
  /// be mirrored.
  core.List<core.String>? tags;

  PacketMirroringMirroredResourceInfo({
    this.instances,
    this.subnetworks,
    this.tags,
  });

  PacketMirroringMirroredResourceInfo.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) =>
                      PacketMirroringMirroredResourceInfoInstanceInfo.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          subnetworks: json_.containsKey('subnetworks')
              ? (json_['subnetworks'] as core.List)
                  .map((value) =>
                      PacketMirroringMirroredResourceInfoSubnetInfo.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          tags: json_.containsKey('tags')
              ? (json_['tags'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
        if (subnetworks != null) 'subnetworks': subnetworks!,
        if (tags != null) 'tags': tags!,
      };
}

class PacketMirroringMirroredResourceInfoInstanceInfo {
  /// Unique identifier for the instance; defined by the server.
  ///
  /// Output only.
  core.String? canonicalUrl;

  /// Resource URL to the virtual machine instance which is being mirrored.
  core.String? url;

  PacketMirroringMirroredResourceInfoInstanceInfo({
    this.canonicalUrl,
    this.url,
  });

  PacketMirroringMirroredResourceInfoInstanceInfo.fromJson(core.Map json_)
      : this(
          canonicalUrl: json_.containsKey('canonicalUrl')
              ? json_['canonicalUrl'] as core.String
              : null,
          url: json_.containsKey('url') ? json_['url'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (canonicalUrl != null) 'canonicalUrl': canonicalUrl!,
        if (url != null) 'url': url!,
      };
}

class PacketMirroringMirroredResourceInfoSubnetInfo {
  /// Unique identifier for the subnetwork; defined by the server.
  ///
  /// Output only.
  core.String? canonicalUrl;

  /// Resource URL to the subnetwork for which traffic from/to all VM instances
  /// will be mirrored.
  core.String? url;

  PacketMirroringMirroredResourceInfoSubnetInfo({
    this.canonicalUrl,
    this.url,
  });

  PacketMirroringMirroredResourceInfoSubnetInfo.fromJson(core.Map json_)
      : this(
          canonicalUrl: json_.containsKey('canonicalUrl')
              ? json_['canonicalUrl'] as core.String
              : null,
          url: json_.containsKey('url') ? json_['url'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (canonicalUrl != null) 'canonicalUrl': canonicalUrl!,
        if (url != null) 'url': url!,
      };
}

class PacketMirroringNetworkInfo {
  /// Unique identifier for the network; defined by the server.
  ///
  /// Output only.
  core.String? canonicalUrl;

  /// URL of the network resource.
  core.String? url;

  PacketMirroringNetworkInfo({
    this.canonicalUrl,
    this.url,
  });

  PacketMirroringNetworkInfo.fromJson(core.Map json_)
      : this(
          canonicalUrl: json_.containsKey('canonicalUrl')
              ? json_['canonicalUrl'] as core.String
              : null,
          url: json_.containsKey('url') ? json_['url'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (canonicalUrl != null) 'canonicalUrl': canonicalUrl!,
        if (url != null) 'url': url!,
      };
}

class PacketMirroringsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PacketMirroringsScopedListWarningData({
    this.key,
    this.value,
  });

  PacketMirroringsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of packetMirrorings when the
/// list is empty.
class PacketMirroringsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PacketMirroringsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PacketMirroringsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  PacketMirroringsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      PacketMirroringsScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class PacketMirroringsScopedList {
  /// A list of packetMirrorings contained in this scope.
  core.List<PacketMirroring>? packetMirrorings;

  /// Informational warning which replaces the list of packetMirrorings when the
  /// list is empty.
  PacketMirroringsScopedListWarning? warning;

  PacketMirroringsScopedList({
    this.packetMirrorings,
    this.warning,
  });

  PacketMirroringsScopedList.fromJson(core.Map json_)
      : this(
          packetMirrorings: json_.containsKey('packetMirrorings')
              ? (json_['packetMirrorings'] as core.List)
                  .map((value) => PacketMirroring.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? PacketMirroringsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (packetMirrorings != null) 'packetMirrorings': packetMirrorings!,
        if (warning != null) 'warning': warning!,
      };
}

/// A matcher for the path portion of the URL.
///
/// The BackendService from the longest-matched rule will serve the URL. If no
/// rule was matched, the default service is used.
class PathMatcher {
  /// defaultRouteAction takes effect when none of the pathRules or routeRules
  /// match.
  ///
  /// The load balancer performs advanced routing actions, such as URL rewrites
  /// and header transformations, before forwarding the request to the selected
  /// backend. If defaultRouteAction specifies any weightedBackendServices,
  /// defaultService must not be set. Conversely if defaultService is set,
  /// defaultRouteAction cannot contain any weightedBackendServices. Only one of
  /// defaultRouteAction or defaultUrlRedirect must be set. URL maps for Classic
  /// external HTTP(S) load balancers only support the urlRewrite action within
  /// a path matcher's defaultRouteAction.
  HttpRouteAction? defaultRouteAction;

  /// The full or partial URL to the BackendService resource.
  ///
  /// This URL is used if none of the pathRules or routeRules defined by this
  /// PathMatcher are matched. For example, the following are all valid URLs to
  /// a BackendService resource: -
  /// https://www.googleapis.com/compute/v1/projects/project
  /// /global/backendServices/backendService -
  /// compute/v1/projects/project/global/backendServices/backendService -
  /// global/backendServices/backendService If defaultRouteAction is also
  /// specified, advanced routing actions, such as URL rewrites, take effect
  /// before sending the request to the backend. However, if defaultService is
  /// specified, defaultRouteAction cannot contain any weightedBackendServices.
  /// Conversely, if defaultRouteAction specifies any weightedBackendServices,
  /// defaultService must not be specified. Only one of defaultService,
  /// defaultUrlRedirect , or defaultRouteAction.weightedBackendService must be
  /// set. Authorization requires one or more of the following Google IAM
  /// permissions on the specified resource default_service: -
  /// compute.backendBuckets.use - compute.backendServices.use
  core.String? defaultService;

  /// When none of the specified pathRules or routeRules match, the request is
  /// redirected to a URL specified by defaultUrlRedirect.
  ///
  /// If defaultUrlRedirect is specified, defaultService or defaultRouteAction
  /// must not be set. Not supported when the URL map is bound to a target gRPC
  /// proxy.
  HttpRedirectAction? defaultUrlRedirect;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Specifies changes to request and response headers that need to take effect
  /// for the selected backend service.
  ///
  /// HeaderAction specified here are applied after the matching HttpRouteRule
  /// HeaderAction and before the HeaderAction in the UrlMap HeaderAction is not
  /// supported for load balancers that have their loadBalancingScheme set to
  /// EXTERNAL. Not supported when the URL map is bound to a target gRPC proxy
  /// that has validateForProxyless field set to true.
  HttpHeaderAction? headerAction;

  /// The name to which this PathMatcher is referred by the HostRule.
  core.String? name;

  /// The list of path rules.
  ///
  /// Use this list instead of routeRules when routing based on simple path
  /// matching is all that's required. The order by which path rules are
  /// specified does not matter. Matches are always done on the
  /// longest-path-first basis. For example: a pathRule with a path /a/b/c / *
  /// will match before /a/b / * irrespective of the order in which those paths
  /// appear in this list. Within a given pathMatcher, only one of pathRules or
  /// routeRules must be set.
  core.List<PathRule>? pathRules;

  /// The list of HTTP route rules.
  ///
  /// Use this list instead of pathRules when advanced route matching and
  /// routing actions are desired. routeRules are evaluated in order of
  /// priority, from the lowest to highest number. Within a given pathMatcher,
  /// you can set only one of pathRules or routeRules.
  core.List<HttpRouteRule>? routeRules;

  PathMatcher({
    this.defaultRouteAction,
    this.defaultService,
    this.defaultUrlRedirect,
    this.description,
    this.headerAction,
    this.name,
    this.pathRules,
    this.routeRules,
  });

  PathMatcher.fromJson(core.Map json_)
      : this(
          defaultRouteAction: json_.containsKey('defaultRouteAction')
              ? HttpRouteAction.fromJson(json_['defaultRouteAction']
                  as core.Map<core.String, core.dynamic>)
              : null,
          defaultService: json_.containsKey('defaultService')
              ? json_['defaultService'] as core.String
              : null,
          defaultUrlRedirect: json_.containsKey('defaultUrlRedirect')
              ? HttpRedirectAction.fromJson(json_['defaultUrlRedirect']
                  as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          headerAction: json_.containsKey('headerAction')
              ? HttpHeaderAction.fromJson(
                  json_['headerAction'] as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          pathRules: json_.containsKey('pathRules')
              ? (json_['pathRules'] as core.List)
                  .map((value) => PathRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          routeRules: json_.containsKey('routeRules')
              ? (json_['routeRules'] as core.List)
                  .map((value) => HttpRouteRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (defaultRouteAction != null)
          'defaultRouteAction': defaultRouteAction!,
        if (defaultService != null) 'defaultService': defaultService!,
        if (defaultUrlRedirect != null)
          'defaultUrlRedirect': defaultUrlRedirect!,
        if (description != null) 'description': description!,
        if (headerAction != null) 'headerAction': headerAction!,
        if (name != null) 'name': name!,
        if (pathRules != null) 'pathRules': pathRules!,
        if (routeRules != null) 'routeRules': routeRules!,
      };
}

/// A path-matching rule for a URL.
///
/// If matched, will use the specified BackendService to handle the traffic
/// arriving at this URL.
class PathRule {
  /// The list of path patterns to match.
  ///
  /// Each must start with / and the only place a * is allowed is at the end
  /// following a /. The string fed to the path matcher does not include any
  /// text after the first ? or #, and those chars are not allowed here.
  core.List<core.String>? paths;

  /// In response to a matching path, the load balancer performs advanced
  /// routing actions, such as URL rewrites and header transformations, before
  /// forwarding the request to the selected backend.
  ///
  /// If routeAction specifies any weightedBackendServices, service must not be
  /// set. Conversely if service is set, routeAction cannot contain any
  /// weightedBackendServices. Only one of routeAction or urlRedirect must be
  /// set. URL maps for Classic external HTTP(S) load balancers only support the
  /// urlRewrite action within a path rule's routeAction.
  HttpRouteAction? routeAction;

  /// The full or partial URL of the backend service resource to which traffic
  /// is directed if this rule is matched.
  ///
  /// If routeAction is also specified, advanced routing actions, such as URL
  /// rewrites, take effect before sending the request to the backend. However,
  /// if service is specified, routeAction cannot contain any
  /// weightedBackendServices. Conversely, if routeAction specifies any
  /// weightedBackendServices, service must not be specified. Only one of
  /// urlRedirect, service or routeAction.weightedBackendService must be set.
  core.String? service;

  /// When a path pattern is matched, the request is redirected to a URL
  /// specified by urlRedirect.
  ///
  /// If urlRedirect is specified, service or routeAction must not be set. Not
  /// supported when the URL map is bound to a target gRPC proxy.
  HttpRedirectAction? urlRedirect;

  PathRule({
    this.paths,
    this.routeAction,
    this.service,
    this.urlRedirect,
  });

  PathRule.fromJson(core.Map json_)
      : this(
          paths: json_.containsKey('paths')
              ? (json_['paths'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          routeAction: json_.containsKey('routeAction')
              ? HttpRouteAction.fromJson(
                  json_['routeAction'] as core.Map<core.String, core.dynamic>)
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          urlRedirect: json_.containsKey('urlRedirect')
              ? HttpRedirectAction.fromJson(
                  json_['urlRedirect'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (paths != null) 'paths': paths!,
        if (routeAction != null) 'routeAction': routeAction!,
        if (service != null) 'service': service!,
        if (urlRedirect != null) 'urlRedirect': urlRedirect!,
      };
}

class PerInstanceConfig {
  /// Fingerprint of this per-instance config.
  ///
  /// This field can be used in optimistic locking. It is ignored when inserting
  /// a per-instance config. An up-to-date fingerprint must be provided in order
  /// to update an existing per-instance configuration or the field needs to be
  /// unset.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The name of a per-instance configuration and its corresponding instance.
  ///
  /// Serves as a merge key during UpdatePerInstanceConfigs operations, that is,
  /// if a per-instance configuration with the same name exists then it will be
  /// updated, otherwise a new one will be created for the VM instance with the
  /// same name. An attempt to create a per-instance configconfiguration for a
  /// VM instance that either doesn't exist or is not part of the group will
  /// result in an error.
  core.String? name;

  /// The intended preserved state for the given instance.
  ///
  /// Does not contain preserved state generated from a stateful policy.
  PreservedState? preservedState;

  /// The status of applying this per-instance configuration on the
  /// corresponding managed instance.
  /// Possible string values are:
  /// - "APPLYING" : The per-instance configuration is being applied to the
  /// instance, but is not yet effective, possibly waiting for the instance to,
  /// for example, REFRESH.
  /// - "DELETING" : The per-instance configuration deletion is being applied on
  /// the instance, possibly waiting for the instance to, for example, REFRESH.
  /// - "EFFECTIVE" : The per-instance configuration is effective on the
  /// instance, meaning that all disks, ips and metadata specified in this
  /// configuration are attached or set on the instance.
  /// - "NONE" : *\[Default\]* The default status, when no per-instance
  /// configuration exists.
  /// - "UNAPPLIED" : The per-instance configuration is set on an instance but
  /// not been applied yet.
  /// - "UNAPPLIED_DELETION" : The per-instance configuration has been deleted,
  /// but the deletion is not yet applied.
  core.String? status;

  PerInstanceConfig({
    this.fingerprint,
    this.name,
    this.preservedState,
    this.status,
  });

  PerInstanceConfig.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          preservedState: json_.containsKey('preservedState')
              ? PreservedState.fromJson(json_['preservedState']
                  as core.Map<core.String, core.dynamic>)
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (name != null) 'name': name!,
        if (preservedState != null) 'preservedState': preservedState!,
        if (status != null) 'status': status!,
      };
}

/// An Identity and Access Management (IAM) policy, which specifies access
/// controls for Google Cloud resources.
///
/// A `Policy` is a collection of `bindings`. A `binding` binds one or more
/// `members`, or principals, to a single `role`. Principals can be user
/// accounts, service accounts, Google groups, and domains (such as G Suite). A
/// `role` is a named list of permissions; each `role` can be an IAM predefined
/// role or a user-created custom role. For some types of Google Cloud
/// resources, a `binding` can also specify a `condition`, which is a logical
/// expression that allows access to a resource only if the expression evaluates
/// to `true`. A condition can add constraints based on attributes of the
/// request, the resource, or both. To learn which resources support conditions
/// in their IAM policies, see the
/// [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
/// **JSON example:** { "bindings": \[ { "role":
/// "roles/resourcemanager.organizationAdmin", "members": \[
/// "user:mike@example.com", "group:admins@example.com", "domain:google.com",
/// "serviceAccount:my-project-id@appspot.gserviceaccount.com" \] }, { "role":
/// "roles/resourcemanager.organizationViewer", "members": \[
/// "user:eve@example.com" \], "condition": { "title": "expirable access",
/// "description": "Does not grant access after Sep 2020", "expression":
/// "request.time \< timestamp('2020-10-01T00:00:00.000Z')", } } \], "etag":
/// "BwWWja0YfJA=", "version": 3 } **YAML example:** bindings: - members: -
/// user:mike@example.com - group:admins@example.com - domain:google.com -
/// serviceAccount:my-project-id@appspot.gserviceaccount.com role:
/// roles/resourcemanager.organizationAdmin - members: - user:eve@example.com
/// role: roles/resourcemanager.organizationViewer condition: title: expirable
/// access description: Does not grant access after Sep 2020 expression:
/// request.time \< timestamp('2020-10-01T00:00:00.000Z') etag: BwWWja0YfJA=
/// version: 3 For a description of IAM and its features, see the
/// [IAM documentation](https://cloud.google.com/iam/docs/).
class Policy {
  /// Specifies cloud audit logging configuration for this policy.
  core.List<AuditConfig>? auditConfigs;

  /// Associates a list of `members`, or principals, with a `role`.
  ///
  /// Optionally, may specify a `condition` that determines how and when the
  /// `bindings` are applied. Each of the `bindings` must contain at least one
  /// principal. The `bindings` in a `Policy` can refer to up to 1,500
  /// principals; up to 250 of these principals can be Google groups. Each
  /// occurrence of a principal counts towards these limits. For example, if the
  /// `bindings` grant 50 different roles to `user:alice@example.com`, and not
  /// to any other principal, then you can add another 1,450 principals to the
  /// `bindings` in the `Policy`.
  core.List<Binding>? bindings;

  /// `etag` is used for optimistic concurrency control as a way to help prevent
  /// simultaneous updates of a policy from overwriting each other.
  ///
  /// It is strongly suggested that systems make use of the `etag` in the
  /// read-modify-write cycle to perform policy updates in order to avoid race
  /// conditions: An `etag` is returned in the response to `getIamPolicy`, and
  /// systems are expected to put that etag in the request to `setIamPolicy` to
  /// ensure that their change will be applied to the same version of the
  /// policy. **Important:** If you use IAM Conditions, you must include the
  /// `etag` field whenever you call `setIamPolicy`. If you omit this field,
  /// then IAM allows you to overwrite a version `3` policy with a version `1`
  /// policy, and all of the conditions in the version `3` policy are lost.
  core.String? etag;
  core.List<core.int> get etagAsBytes => convert.base64.decode(etag!);

  set etagAsBytes(core.List<core.int> bytes_) {
    etag =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<Rule>? rules;

  /// Specifies the format of the policy.
  ///
  /// Valid values are `0`, `1`, and `3`. Requests that specify an invalid value
  /// are rejected. Any operation that affects conditional role bindings must
  /// specify version `3`. This requirement applies to the following operations:
  /// * Getting a policy that includes a conditional role binding * Adding a
  /// conditional role binding to a policy * Changing a conditional role binding
  /// in a policy * Removing any role binding, with or without a condition, from
  /// a policy that includes conditions **Important:** If you use IAM
  /// Conditions, you must include the `etag` field whenever you call
  /// `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a
  /// version `3` policy with a version `1` policy, and all of the conditions in
  /// the version `3` policy are lost. If a policy does not include any
  /// conditions, operations on that policy may specify any valid version or
  /// leave the field unset. To learn which resources support conditions in
  /// their IAM policies, see the
  /// [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
  core.int? version;

  Policy({
    this.auditConfigs,
    this.bindings,
    this.etag,
    this.rules,
    this.version,
  });

  Policy.fromJson(core.Map json_)
      : this(
          auditConfigs: json_.containsKey('auditConfigs')
              ? (json_['auditConfigs'] as core.List)
                  .map((value) => AuditConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          bindings: json_.containsKey('bindings')
              ? (json_['bindings'] as core.List)
                  .map((value) => Binding.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => Rule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          version: json_.containsKey('version')
              ? json_['version'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (auditConfigs != null) 'auditConfigs': auditConfigs!,
        if (bindings != null) 'bindings': bindings!,
        if (etag != null) 'etag': etag!,
        if (rules != null) 'rules': rules!,
        if (version != null) 'version': version!,
      };
}

class PreconfiguredWafSet {
  /// List of entities that are currently supported for WAF rules.
  core.List<WafExpressionSet>? expressionSets;

  PreconfiguredWafSet({
    this.expressionSets,
  });

  PreconfiguredWafSet.fromJson(core.Map json_)
      : this(
          expressionSets: json_.containsKey('expressionSets')
              ? (json_['expressionSets'] as core.List)
                  .map((value) => WafExpressionSet.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (expressionSets != null) 'expressionSets': expressionSets!,
      };
}

/// Preserved state for a given instance.
class PreservedState {
  /// Preserved disks defined for this instance.
  ///
  /// This map is keyed with the device names of the disks.
  core.Map<core.String, PreservedStatePreservedDisk>? disks;

  /// Preserved metadata defined for this instance.
  core.Map<core.String, core.String>? metadata;

  PreservedState({
    this.disks,
    this.metadata,
  });

  PreservedState.fromJson(core.Map json_)
      : this(
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    PreservedStatePreservedDisk.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          metadata: json_.containsKey('metadata')
              ? (json_['metadata'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (disks != null) 'disks': disks!,
        if (metadata != null) 'metadata': metadata!,
      };
}

class PreservedStatePreservedDisk {
  /// These stateful disks will never be deleted during autohealing, update,
  /// instance recreate operations.
  ///
  /// This flag is used to configure if the disk should be deleted after it is
  /// no longer used by the group, e.g. when the given instance or the whole MIG
  /// is deleted. Note: disks attached in READ_ONLY mode cannot be auto-deleted.
  /// Possible string values are:
  /// - "NEVER"
  /// - "ON_PERMANENT_INSTANCE_DELETION"
  core.String? autoDelete;

  /// The mode in which to attach this disk, either READ_WRITE or READ_ONLY.
  ///
  /// If not specified, the default is to attach the disk in READ_WRITE mode.
  /// Possible string values are:
  /// - "READ_ONLY" : Attaches this disk in read-only mode. Multiple VM
  /// instances can use a disk in READ_ONLY mode at a time.
  /// - "READ_WRITE" : *\[Default\]* Attaches this disk in READ_WRITE mode. Only
  /// one VM instance at a time can be attached to a disk in READ_WRITE mode.
  core.String? mode;

  /// The URL of the disk resource that is stateful and should be attached to
  /// the VM instance.
  core.String? source;

  PreservedStatePreservedDisk({
    this.autoDelete,
    this.mode,
    this.source,
  });

  PreservedStatePreservedDisk.fromJson(core.Map json_)
      : this(
          autoDelete: json_.containsKey('autoDelete')
              ? json_['autoDelete'] as core.String
              : null,
          mode: json_.containsKey('mode') ? json_['mode'] as core.String : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoDelete != null) 'autoDelete': autoDelete!,
        if (mode != null) 'mode': mode!,
        if (source != null) 'source': source!,
      };
}

/// Represents a Project resource.
///
/// A project is used to organize resources in a Google Cloud Platform
/// environment. For more information, read about the Resource Hierarchy.
class Project {
  /// Metadata key/value pairs available to all instances contained in this
  /// project.
  ///
  /// See Custom metadata for more information.
  Metadata? commonInstanceMetadata;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// This signifies the default network tier used for configuring resources of
  /// the project and can only take the following values: PREMIUM, STANDARD.
  ///
  /// Initially the default network tier is PREMIUM.
  /// Possible string values are:
  /// - "FIXED_STANDARD" : Public internet quality with fixed bandwidth.
  /// - "PREMIUM" : High quality, Google-grade network tier, support for all
  /// networking products.
  /// - "STANDARD" : Public internet quality, only limited support for other
  /// networking products.
  /// - "STANDARD_OVERRIDES_FIXED_STANDARD" : (Output only) Temporary tier for
  /// FIXED_STANDARD when fixed standard tier is expired or not configured.
  core.String? defaultNetworkTier;

  /// Default service account used by VMs running in this project.
  ///
  /// Output only.
  core.String? defaultServiceAccount;

  /// An optional textual description of the resource.
  core.String? description;

  /// Restricted features enabled for use on this project.
  core.List<core.String>? enabledFeatures;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server. This is *not* the project ID,
  /// and is just a unique ID used by Compute Engine to identify resources.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#project for projects.
  ///
  /// Output only.
  core.String? kind;

  /// The project ID.
  ///
  /// For example: my-example-project. Use the project ID to make requests to
  /// Compute Engine.
  core.String? name;

  /// Quotas assigned to this project.
  ///
  /// Output only.
  core.List<Quota>? quotas;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The naming prefix for daily usage reports and the Google Cloud Storage
  /// bucket where they are stored.
  UsageExportLocation? usageExportLocation;

  /// The role this project has in a shared VPC configuration.
  ///
  /// Currently, only projects with the host role, which is specified by the
  /// value HOST, are differentiated.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "HOST"
  /// - "UNSPECIFIED_XPN_PROJECT_STATUS"
  core.String? xpnProjectStatus;

  Project({
    this.commonInstanceMetadata,
    this.creationTimestamp,
    this.defaultNetworkTier,
    this.defaultServiceAccount,
    this.description,
    this.enabledFeatures,
    this.id,
    this.kind,
    this.name,
    this.quotas,
    this.selfLink,
    this.usageExportLocation,
    this.xpnProjectStatus,
  });

  Project.fromJson(core.Map json_)
      : this(
          commonInstanceMetadata: json_.containsKey('commonInstanceMetadata')
              ? Metadata.fromJson(json_['commonInstanceMetadata']
                  as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          defaultNetworkTier: json_.containsKey('defaultNetworkTier')
              ? json_['defaultNetworkTier'] as core.String
              : null,
          defaultServiceAccount: json_.containsKey('defaultServiceAccount')
              ? json_['defaultServiceAccount'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          enabledFeatures: json_.containsKey('enabledFeatures')
              ? (json_['enabledFeatures'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          quotas: json_.containsKey('quotas')
              ? (json_['quotas'] as core.List)
                  .map((value) => Quota.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          usageExportLocation: json_.containsKey('usageExportLocation')
              ? UsageExportLocation.fromJson(json_['usageExportLocation']
                  as core.Map<core.String, core.dynamic>)
              : null,
          xpnProjectStatus: json_.containsKey('xpnProjectStatus')
              ? json_['xpnProjectStatus'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (commonInstanceMetadata != null)
          'commonInstanceMetadata': commonInstanceMetadata!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (defaultNetworkTier != null)
          'defaultNetworkTier': defaultNetworkTier!,
        if (defaultServiceAccount != null)
          'defaultServiceAccount': defaultServiceAccount!,
        if (description != null) 'description': description!,
        if (enabledFeatures != null) 'enabledFeatures': enabledFeatures!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (quotas != null) 'quotas': quotas!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (usageExportLocation != null)
          'usageExportLocation': usageExportLocation!,
        if (xpnProjectStatus != null) 'xpnProjectStatus': xpnProjectStatus!,
      };
}

class ProjectsDisableXpnResourceRequest {
  /// Service resource (a.k.a service project) ID.
  XpnResourceId? xpnResource;

  ProjectsDisableXpnResourceRequest({
    this.xpnResource,
  });

  ProjectsDisableXpnResourceRequest.fromJson(core.Map json_)
      : this(
          xpnResource: json_.containsKey('xpnResource')
              ? XpnResourceId.fromJson(
                  json_['xpnResource'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (xpnResource != null) 'xpnResource': xpnResource!,
      };
}

class ProjectsEnableXpnResourceRequest {
  /// Service resource (a.k.a service project) ID.
  XpnResourceId? xpnResource;

  ProjectsEnableXpnResourceRequest({
    this.xpnResource,
  });

  ProjectsEnableXpnResourceRequest.fromJson(core.Map json_)
      : this(
          xpnResource: json_.containsKey('xpnResource')
              ? XpnResourceId.fromJson(
                  json_['xpnResource'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (xpnResource != null) 'xpnResource': xpnResource!,
      };
}

class ProjectsGetXpnResources {
  /// Type of resource.
  ///
  /// Always compute#projectsGetXpnResources for lists of service resources
  /// (a.k.a service projects)
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Service resources (a.k.a service projects) attached to this project as
  /// their shared VPC host.
  core.List<XpnResourceId>? resources;

  ProjectsGetXpnResources({
    this.kind,
    this.nextPageToken,
    this.resources,
  });

  ProjectsGetXpnResources.fromJson(core.Map json_)
      : this(
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          resources: json_.containsKey('resources')
              ? (json_['resources'] as core.List)
                  .map((value) => XpnResourceId.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (resources != null) 'resources': resources!,
      };
}

class ProjectsListXpnHostsRequest {
  /// Optional organization ID managed by Cloud Resource Manager, for which to
  /// list shared VPC host projects.
  ///
  /// If not specified, the organization will be inferred from the project.
  core.String? organization;

  ProjectsListXpnHostsRequest({
    this.organization,
  });

  ProjectsListXpnHostsRequest.fromJson(core.Map json_)
      : this(
          organization: json_.containsKey('organization')
              ? json_['organization'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (organization != null) 'organization': organization!,
      };
}

class ProjectsSetDefaultNetworkTierRequest {
  /// Default network tier to be set.
  /// Possible string values are:
  /// - "FIXED_STANDARD" : Public internet quality with fixed bandwidth.
  /// - "PREMIUM" : High quality, Google-grade network tier, support for all
  /// networking products.
  /// - "STANDARD" : Public internet quality, only limited support for other
  /// networking products.
  /// - "STANDARD_OVERRIDES_FIXED_STANDARD" : (Output only) Temporary tier for
  /// FIXED_STANDARD when fixed standard tier is expired or not configured.
  core.String? networkTier;

  ProjectsSetDefaultNetworkTierRequest({
    this.networkTier,
  });

  ProjectsSetDefaultNetworkTierRequest.fromJson(core.Map json_)
      : this(
          networkTier: json_.containsKey('networkTier')
              ? json_['networkTier'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (networkTier != null) 'networkTier': networkTier!,
      };
}

/// A public advertised prefix represents an aggregated IP prefix or netblock
/// which customers bring to cloud.
///
/// The IP prefix is a single unit of route advertisement and is announced
/// globally to the internet.
class PublicAdvertisedPrefix {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The IPv4 address to be used for reverse DNS verification.
  core.String? dnsVerificationIp;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a new
  /// PublicAdvertisedPrefix. An up-to-date fingerprint must be provided in
  /// order to update the PublicAdvertisedPrefix, otherwise the request will
  /// fail with error 412 conditionNotMet. To see the latest fingerprint, make a
  /// get() request to retrieve a PublicAdvertisedPrefix.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// The IPv4 address range, in CIDR format, represented by this public
  /// advertised prefix.
  core.String? ipCidrRange;

  /// Type of the resource.
  ///
  /// Always compute#publicAdvertisedPrefix for public advertised prefixes.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The list of public delegated prefixes that exist for this public
  /// advertised prefix.
  ///
  /// Output only.
  core.List<PublicAdvertisedPrefixPublicDelegatedPrefix>?
      publicDelegatedPrefixs;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The shared secret to be used for reverse DNS verification.
  ///
  /// Output only.
  core.String? sharedSecret;

  /// The status of the public advertised prefix.
  ///
  /// Possible values include: - `INITIAL`: RPKI validation is complete. -
  /// `PTR_CONFIGURED`: User has configured the PTR. - `VALIDATED`: Reverse DNS
  /// lookup is successful. - `REVERSE_DNS_LOOKUP_FAILED`: Reverse DNS lookup
  /// failed. - `PREFIX_CONFIGURATION_IN_PROGRESS`: The prefix is being
  /// configured. - `PREFIX_CONFIGURATION_COMPLETE`: The prefix is fully
  /// configured. - `PREFIX_REMOVAL_IN_PROGRESS`: The prefix is being removed.
  /// Possible string values are:
  /// - "INITIAL" : RPKI validation is complete.
  /// - "PREFIX_CONFIGURATION_COMPLETE" : The prefix is fully configured.
  /// - "PREFIX_CONFIGURATION_IN_PROGRESS" : The prefix is being configured.
  /// - "PREFIX_REMOVAL_IN_PROGRESS" : The prefix is being removed.
  /// - "PTR_CONFIGURED" : User has configured the PTR.
  /// - "REVERSE_DNS_LOOKUP_FAILED" : Reverse DNS lookup failed.
  /// - "VALIDATED" : Reverse DNS lookup is successful.
  core.String? status;

  PublicAdvertisedPrefix({
    this.creationTimestamp,
    this.description,
    this.dnsVerificationIp,
    this.fingerprint,
    this.id,
    this.ipCidrRange,
    this.kind,
    this.name,
    this.publicDelegatedPrefixs,
    this.selfLink,
    this.sharedSecret,
    this.status,
  });

  PublicAdvertisedPrefix.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          dnsVerificationIp: json_.containsKey('dnsVerificationIp')
              ? json_['dnsVerificationIp'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          publicDelegatedPrefixs: json_.containsKey('publicDelegatedPrefixs')
              ? (json_['publicDelegatedPrefixs'] as core.List)
                  .map((value) =>
                      PublicAdvertisedPrefixPublicDelegatedPrefix.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sharedSecret: json_.containsKey('sharedSecret')
              ? json_['sharedSecret'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (dnsVerificationIp != null) 'dnsVerificationIp': dnsVerificationIp!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (publicDelegatedPrefixs != null)
          'publicDelegatedPrefixs': publicDelegatedPrefixs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sharedSecret != null) 'sharedSecret': sharedSecret!,
        if (status != null) 'status': status!,
      };
}

class PublicAdvertisedPrefixListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PublicAdvertisedPrefixListWarningData({
    this.key,
    this.value,
  });

  PublicAdvertisedPrefixListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class PublicAdvertisedPrefixListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PublicAdvertisedPrefixListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PublicAdvertisedPrefixListWarning({
    this.code,
    this.data,
    this.message,
  });

  PublicAdvertisedPrefixListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      PublicAdvertisedPrefixListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class PublicAdvertisedPrefixList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of PublicAdvertisedPrefix resources.
  core.List<PublicAdvertisedPrefix>? items;

  /// Type of the resource.
  ///
  /// Always compute#publicAdvertisedPrefix for public advertised prefixes.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  PublicAdvertisedPrefixListWarning? warning;

  PublicAdvertisedPrefixList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  PublicAdvertisedPrefixList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => PublicAdvertisedPrefix.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? PublicAdvertisedPrefixListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a CIDR range which can be used to assign addresses.
class PublicAdvertisedPrefixPublicDelegatedPrefix {
  /// The IP address range of the public delegated prefix
  core.String? ipRange;

  /// The name of the public delegated prefix
  core.String? name;

  /// The project number of the public delegated prefix
  core.String? project;

  /// The region of the public delegated prefix if it is regional.
  ///
  /// If absent, the prefix is global.
  core.String? region;

  /// The status of the public delegated prefix.
  ///
  /// Possible values are: INITIALIZING: The public delegated prefix is being
  /// initialized and addresses cannot be created yet. ANNOUNCED: The public
  /// delegated prefix is active.
  core.String? status;

  PublicAdvertisedPrefixPublicDelegatedPrefix({
    this.ipRange,
    this.name,
    this.project,
    this.region,
    this.status,
  });

  PublicAdvertisedPrefixPublicDelegatedPrefix.fromJson(core.Map json_)
      : this(
          ipRange: json_.containsKey('ipRange')
              ? json_['ipRange'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          project: json_.containsKey('project')
              ? json_['project'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipRange != null) 'ipRange': ipRange!,
        if (name != null) 'name': name!,
        if (project != null) 'project': project!,
        if (region != null) 'region': region!,
        if (status != null) 'status': status!,
      };
}

/// A PublicDelegatedPrefix resource represents an IP block within a
/// PublicAdvertisedPrefix that is configured within a single cloud scope
/// (global or region).
///
/// IPs in the block can be allocated to resources within that scope. Public
/// delegated prefixes may be further broken up into smaller IP blocks in the
/// same scope as the parent block.
class PublicDelegatedPrefix {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a new
  /// PublicDelegatedPrefix. An up-to-date fingerprint must be provided in order
  /// to update the PublicDelegatedPrefix, otherwise the request will fail with
  /// error 412 conditionNotMet. To see the latest fingerprint, make a get()
  /// request to retrieve a PublicDelegatedPrefix.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// The IPv4 address range, in CIDR format, represented by this public
  /// delegated prefix.
  core.String? ipCidrRange;

  /// If true, the prefix will be live migrated.
  core.bool? isLiveMigration;

  /// Type of the resource.
  ///
  /// Always compute#publicDelegatedPrefix for public delegated prefixes.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The URL of parent prefix.
  ///
  /// Either PublicAdvertisedPrefix or PublicDelegatedPrefix.
  core.String? parentPrefix;

  /// The list of sub public delegated prefixes that exist for this public
  /// delegated prefix.
  core.List<PublicDelegatedPrefixPublicDelegatedSubPrefix>?
      publicDelegatedSubPrefixs;

  /// URL of the region where the public delegated prefix resides.
  ///
  /// This field applies only to the region resource. You must specify this
  /// field as part of the HTTP request URL. It is not settable as a field in
  /// the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The status of the public delegated prefix, which can be one of following
  /// values: - `INITIALIZING` The public delegated prefix is being initialized
  /// and addresses cannot be created yet.
  ///
  /// - `READY_TO_ANNOUNCE` The public delegated prefix is a live migration
  /// prefix and is active. - `ANNOUNCED` The public delegated prefix is active.
  /// - `DELETING` The public delegated prefix is being deprovsioned.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ANNOUNCED" : The public delegated prefix is active.
  /// - "DELETING" : The public delegated prefix is being deprovsioned.
  /// - "INITIALIZING" : The public delegated prefix is being initialized and
  /// addresses cannot be created yet.
  /// - "READY_TO_ANNOUNCE" : The public delegated prefix is currently withdrawn
  /// but ready to be announced.
  core.String? status;

  PublicDelegatedPrefix({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.ipCidrRange,
    this.isLiveMigration,
    this.kind,
    this.name,
    this.parentPrefix,
    this.publicDelegatedSubPrefixs,
    this.region,
    this.selfLink,
    this.status,
  });

  PublicDelegatedPrefix.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          isLiveMigration: json_.containsKey('isLiveMigration')
              ? json_['isLiveMigration'] as core.bool
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          parentPrefix: json_.containsKey('parentPrefix')
              ? json_['parentPrefix'] as core.String
              : null,
          publicDelegatedSubPrefixs: json_
                  .containsKey('publicDelegatedSubPrefixs')
              ? (json_['publicDelegatedSubPrefixs'] as core.List)
                  .map((value) =>
                      PublicDelegatedPrefixPublicDelegatedSubPrefix.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (isLiveMigration != null) 'isLiveMigration': isLiveMigration!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (parentPrefix != null) 'parentPrefix': parentPrefix!,
        if (publicDelegatedSubPrefixs != null)
          'publicDelegatedSubPrefixs': publicDelegatedSubPrefixs!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
      };
}

class PublicDelegatedPrefixAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PublicDelegatedPrefixAggregatedListWarningData({
    this.key,
    this.value,
  });

  PublicDelegatedPrefixAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class PublicDelegatedPrefixAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PublicDelegatedPrefixAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PublicDelegatedPrefixAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  PublicDelegatedPrefixAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      PublicDelegatedPrefixAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class PublicDelegatedPrefixAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of PublicDelegatedPrefixesScopedList resources.
  core.Map<core.String, PublicDelegatedPrefixesScopedList>? items;

  /// Type of the resource.
  ///
  /// Always compute#publicDelegatedPrefixAggregatedList for aggregated lists of
  /// public delegated prefixes.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  PublicDelegatedPrefixAggregatedListWarning? warning;

  PublicDelegatedPrefixAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  PublicDelegatedPrefixAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    PublicDelegatedPrefixesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? PublicDelegatedPrefixAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class PublicDelegatedPrefixListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PublicDelegatedPrefixListWarningData({
    this.key,
    this.value,
  });

  PublicDelegatedPrefixListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class PublicDelegatedPrefixListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PublicDelegatedPrefixListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PublicDelegatedPrefixListWarning({
    this.code,
    this.data,
    this.message,
  });

  PublicDelegatedPrefixListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => PublicDelegatedPrefixListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class PublicDelegatedPrefixList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of PublicDelegatedPrefix resources.
  core.List<PublicDelegatedPrefix>? items;

  /// Type of the resource.
  ///
  /// Always compute#publicDelegatedPrefixList for public delegated prefixes.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  PublicDelegatedPrefixListWarning? warning;

  PublicDelegatedPrefixList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  PublicDelegatedPrefixList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => PublicDelegatedPrefix.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? PublicDelegatedPrefixListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a sub PublicDelegatedPrefix.
class PublicDelegatedPrefixPublicDelegatedSubPrefix {
  /// Name of the project scoping this PublicDelegatedSubPrefix.
  core.String? delegateeProject;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The IPv4 address range, in CIDR format, represented by this sub public
  /// delegated prefix.
  core.String? ipCidrRange;

  /// Whether the sub prefix is delegated to create Address resources in the
  /// delegatee project.
  core.bool? isAddress;

  /// The name of the sub public delegated prefix.
  core.String? name;

  /// The region of the sub public delegated prefix if it is regional.
  ///
  /// If absent, the sub prefix is global.
  ///
  /// Output only.
  core.String? region;

  /// The status of the sub public delegated prefix.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE"
  /// - "INACTIVE"
  core.String? status;

  PublicDelegatedPrefixPublicDelegatedSubPrefix({
    this.delegateeProject,
    this.description,
    this.ipCidrRange,
    this.isAddress,
    this.name,
    this.region,
    this.status,
  });

  PublicDelegatedPrefixPublicDelegatedSubPrefix.fromJson(core.Map json_)
      : this(
          delegateeProject: json_.containsKey('delegateeProject')
              ? json_['delegateeProject'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          isAddress: json_.containsKey('isAddress')
              ? json_['isAddress'] as core.bool
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (delegateeProject != null) 'delegateeProject': delegateeProject!,
        if (description != null) 'description': description!,
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (isAddress != null) 'isAddress': isAddress!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (status != null) 'status': status!,
      };
}

class PublicDelegatedPrefixesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  PublicDelegatedPrefixesScopedListWarningData({
    this.key,
    this.value,
  });

  PublicDelegatedPrefixesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of public delegated prefixes
/// when the list is empty.
///
/// Output only.
class PublicDelegatedPrefixesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<PublicDelegatedPrefixesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  PublicDelegatedPrefixesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  PublicDelegatedPrefixesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      PublicDelegatedPrefixesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class PublicDelegatedPrefixesScopedList {
  /// A list of PublicDelegatedPrefixes contained in this scope.
  ///
  /// Output only.
  core.List<PublicDelegatedPrefix>? publicDelegatedPrefixes;

  /// Informational warning which replaces the list of public delegated prefixes
  /// when the list is empty.
  ///
  /// Output only.
  PublicDelegatedPrefixesScopedListWarning? warning;

  PublicDelegatedPrefixesScopedList({
    this.publicDelegatedPrefixes,
    this.warning,
  });

  PublicDelegatedPrefixesScopedList.fromJson(core.Map json_)
      : this(
          publicDelegatedPrefixes: json_.containsKey('publicDelegatedPrefixes')
              ? (json_['publicDelegatedPrefixes'] as core.List)
                  .map((value) => PublicDelegatedPrefix.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? PublicDelegatedPrefixesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (publicDelegatedPrefixes != null)
          'publicDelegatedPrefixes': publicDelegatedPrefixes!,
        if (warning != null) 'warning': warning!,
      };
}

/// A quotas entry.
class Quota {
  /// Quota limit for this metric.
  ///
  /// Output only.
  core.double? limit;

  /// Name of the quota metric.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "A2_CPUS"
  /// - "AFFINITY_GROUPS"
  /// - "AUTOSCALERS"
  /// - "BACKEND_BUCKETS"
  /// - "BACKEND_SERVICES"
  /// - "C2D_CPUS"
  /// - "C2_CPUS"
  /// - "C3_CPUS"
  /// - "COMMITMENTS"
  /// - "COMMITTED_A2_CPUS"
  /// - "COMMITTED_C2D_CPUS"
  /// - "COMMITTED_C2_CPUS"
  /// - "COMMITTED_C3_CPUS"
  /// - "COMMITTED_CPUS"
  /// - "COMMITTED_E2_CPUS"
  /// - "COMMITTED_LICENSES"
  /// - "COMMITTED_LOCAL_SSD_TOTAL_GB"
  /// - "COMMITTED_M3_CPUS"
  /// - "COMMITTED_MEMORY_OPTIMIZED_CPUS"
  /// - "COMMITTED_N2A_CPUS"
  /// - "COMMITTED_N2D_CPUS"
  /// - "COMMITTED_N2_CPUS"
  /// - "COMMITTED_NVIDIA_A100_80GB_GPUS"
  /// - "COMMITTED_NVIDIA_A100_GPUS"
  /// - "COMMITTED_NVIDIA_K80_GPUS"
  /// - "COMMITTED_NVIDIA_P100_GPUS"
  /// - "COMMITTED_NVIDIA_P4_GPUS"
  /// - "COMMITTED_NVIDIA_T4_GPUS"
  /// - "COMMITTED_NVIDIA_V100_GPUS"
  /// - "COMMITTED_T2A_CPUS"
  /// - "COMMITTED_T2D_CPUS"
  /// - "CPUS" : Guest CPUs
  /// - "CPUS_ALL_REGIONS"
  /// - "DISKS_TOTAL_GB"
  /// - "E2_CPUS"
  /// - "EXTERNAL_MANAGED_FORWARDING_RULES"
  /// - "EXTERNAL_NETWORK_LB_FORWARDING_RULES"
  /// - "EXTERNAL_PROTOCOL_FORWARDING_RULES"
  /// - "EXTERNAL_VPN_GATEWAYS"
  /// - "FIREWALLS"
  /// - "FORWARDING_RULES"
  /// - "GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES"
  /// - "GLOBAL_INTERNAL_ADDRESSES"
  /// - "GPUS_ALL_REGIONS"
  /// - "HEALTH_CHECKS"
  /// - "IMAGES"
  /// - "INSTANCES"
  /// - "INSTANCE_GROUPS"
  /// - "INSTANCE_GROUP_MANAGERS"
  /// - "INSTANCE_TEMPLATES"
  /// - "INTERCONNECTS"
  /// - "INTERCONNECT_ATTACHMENTS_PER_REGION"
  /// - "INTERCONNECT_ATTACHMENTS_TOTAL_MBPS"
  /// - "INTERCONNECT_TOTAL_GBPS"
  /// - "INTERNAL_ADDRESSES"
  /// - "INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES"
  /// - "IN_PLACE_SNAPSHOTS"
  /// - "IN_USE_ADDRESSES"
  /// - "IN_USE_BACKUP_SCHEDULES"
  /// - "IN_USE_SNAPSHOT_SCHEDULES"
  /// - "LOCAL_SSD_TOTAL_GB"
  /// - "M1_CPUS"
  /// - "M2_CPUS"
  /// - "M3_CPUS"
  /// - "MACHINE_IMAGES"
  /// - "N2A_CPUS"
  /// - "N2D_CPUS"
  /// - "N2_CPUS"
  /// - "NETWORKS"
  /// - "NETWORK_ENDPOINT_GROUPS"
  /// - "NETWORK_FIREWALL_POLICIES"
  /// - "NODE_GROUPS"
  /// - "NODE_TEMPLATES"
  /// - "NVIDIA_A100_80GB_GPUS"
  /// - "NVIDIA_A100_GPUS"
  /// - "NVIDIA_K80_GPUS"
  /// - "NVIDIA_P100_GPUS"
  /// - "NVIDIA_P100_VWS_GPUS"
  /// - "NVIDIA_P4_GPUS"
  /// - "NVIDIA_P4_VWS_GPUS"
  /// - "NVIDIA_T4_GPUS"
  /// - "NVIDIA_T4_VWS_GPUS"
  /// - "NVIDIA_V100_GPUS"
  /// - "PACKET_MIRRORINGS"
  /// - "PD_EXTREME_TOTAL_PROVISIONED_IOPS"
  /// - "PREEMPTIBLE_CPUS"
  /// - "PREEMPTIBLE_LOCAL_SSD_GB"
  /// - "PREEMPTIBLE_NVIDIA_A100_80GB_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_A100_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_K80_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_P100_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_P100_VWS_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_P4_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_P4_VWS_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_T4_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_T4_VWS_GPUS"
  /// - "PREEMPTIBLE_NVIDIA_V100_GPUS"
  /// - "PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK"
  /// - "PSC_INTERNAL_LB_FORWARDING_RULES"
  /// - "PUBLIC_ADVERTISED_PREFIXES"
  /// - "PUBLIC_DELEGATED_PREFIXES"
  /// - "REGIONAL_AUTOSCALERS"
  /// - "REGIONAL_INSTANCE_GROUP_MANAGERS"
  /// - "RESERVATIONS"
  /// - "RESOURCE_POLICIES"
  /// - "ROUTERS"
  /// - "ROUTES"
  /// - "SECURITY_POLICIES"
  /// - "SECURITY_POLICIES_PER_REGION"
  /// - "SECURITY_POLICY_CEVAL_RULES"
  /// - "SECURITY_POLICY_RULES"
  /// - "SECURITY_POLICY_RULES_PER_REGION"
  /// - "SERVICE_ATTACHMENTS"
  /// - "SNAPSHOTS" : The total number of snapshots allowed for a single
  /// project.
  /// - "SSD_TOTAL_GB"
  /// - "SSL_CERTIFICATES"
  /// - "STATIC_ADDRESSES"
  /// - "STATIC_BYOIP_ADDRESSES"
  /// - "SUBNETWORKS"
  /// - "T2A_CPUS"
  /// - "T2D_CPUS"
  /// - "TARGET_HTTPS_PROXIES"
  /// - "TARGET_HTTP_PROXIES"
  /// - "TARGET_INSTANCES"
  /// - "TARGET_POOLS"
  /// - "TARGET_SSL_PROXIES"
  /// - "TARGET_TCP_PROXIES"
  /// - "TARGET_VPN_GATEWAYS"
  /// - "URL_MAPS"
  /// - "VPN_GATEWAYS"
  /// - "VPN_TUNNELS"
  /// - "XPN_SERVICE_PROJECTS"
  core.String? metric;

  /// Owning resource.
  ///
  /// This is the resource on which this quota is applied.
  ///
  /// Output only.
  core.String? owner;

  /// Current usage of this metric.
  ///
  /// Output only.
  core.double? usage;

  Quota({
    this.limit,
    this.metric,
    this.owner,
    this.usage,
  });

  Quota.fromJson(core.Map json_)
      : this(
          limit: json_.containsKey('limit')
              ? (json_['limit'] as core.num).toDouble()
              : null,
          metric: json_.containsKey('metric')
              ? json_['metric'] as core.String
              : null,
          owner:
              json_.containsKey('owner') ? json_['owner'] as core.String : null,
          usage: json_.containsKey('usage')
              ? (json_['usage'] as core.num).toDouble()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (limit != null) 'limit': limit!,
        if (metric != null) 'metric': metric!,
        if (owner != null) 'owner': owner!,
        if (usage != null) 'usage': usage!,
      };
}

/// Represents a reference to a resource.
class Reference {
  /// Type of the resource.
  ///
  /// Always compute#reference for references.
  ///
  /// Output only.
  core.String? kind;

  /// A description of the reference type with no implied semantics.
  ///
  /// Possible values include: 1. MEMBER_OF
  core.String? referenceType;

  /// URL of the resource which refers to the target.
  core.String? referrer;

  /// URL of the resource to which this reference points.
  core.String? target;

  Reference({
    this.kind,
    this.referenceType,
    this.referrer,
    this.target,
  });

  Reference.fromJson(core.Map json_)
      : this(
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          referenceType: json_.containsKey('referenceType')
              ? json_['referenceType'] as core.String
              : null,
          referrer: json_.containsKey('referrer')
              ? json_['referrer'] as core.String
              : null,
          target: json_.containsKey('target')
              ? json_['target'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (kind != null) 'kind': kind!,
        if (referenceType != null) 'referenceType': referenceType!,
        if (referrer != null) 'referrer': referrer!,
        if (target != null) 'target': target!,
      };
}

/// Represents a Region resource.
///
/// A region is a geographical area where a resource is located. For more
/// information, read Regions and Zones.
class Region {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this region.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// Textual description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#region for regions.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// Quotas assigned to this region.
  ///
  /// Output only.
  core.List<Quota>? quotas;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Status of the region, either UP or DOWN.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DOWN"
  /// - "UP"
  core.String? status;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? supportsPzs;

  /// A list of zones available in this region, in the form of resource URLs.
  ///
  /// Output only.
  core.List<core.String>? zones;

  Region({
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.quotas,
    this.selfLink,
    this.status,
    this.supportsPzs,
    this.zones,
  });

  Region.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          quotas: json_.containsKey('quotas')
              ? (json_['quotas'] as core.List)
                  .map((value) => Quota.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          supportsPzs: json_.containsKey('supportsPzs')
              ? json_['supportsPzs'] as core.bool
              : null,
          zones: json_.containsKey('zones')
              ? (json_['zones'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (quotas != null) 'quotas': quotas!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (supportsPzs != null) 'supportsPzs': supportsPzs!,
        if (zones != null) 'zones': zones!,
      };
}

class RegionAutoscalerListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionAutoscalerListWarningData({
    this.key,
    this.value,
  });

  RegionAutoscalerListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionAutoscalerListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionAutoscalerListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionAutoscalerListWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionAutoscalerListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RegionAutoscalerListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of autoscalers.
class RegionAutoscalerList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Autoscaler resources.
  core.List<Autoscaler>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionAutoscalerListWarning? warning;

  RegionAutoscalerList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionAutoscalerList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Autoscaler.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionAutoscalerListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class RegionDiskTypeListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionDiskTypeListWarningData({
    this.key,
    this.value,
  });

  RegionDiskTypeListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionDiskTypeListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionDiskTypeListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionDiskTypeListWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionDiskTypeListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RegionDiskTypeListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class RegionDiskTypeList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of DiskType resources.
  core.List<DiskType>? items;

  /// Type of resource.
  ///
  /// Always compute#regionDiskTypeList for region disk types.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionDiskTypeListWarning? warning;

  RegionDiskTypeList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionDiskTypeList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => DiskType.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionDiskTypeListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class RegionDisksAddResourcePoliciesRequest {
  /// Resource policies to be added to this disk.
  core.List<core.String>? resourcePolicies;

  RegionDisksAddResourcePoliciesRequest({
    this.resourcePolicies,
  });

  RegionDisksAddResourcePoliciesRequest.fromJson(core.Map json_)
      : this(
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
      };
}

typedef RegionDisksRemoveResourcePoliciesRequest
    = $DisksRemoveResourcePoliciesRequest;

class RegionDisksResizeRequest {
  /// The new size of the regional persistent disk, which is specified in GB.
  core.String? sizeGb;

  RegionDisksResizeRequest({
    this.sizeGb,
  });

  RegionDisksResizeRequest.fromJson(core.Map json_)
      : this(
          sizeGb: json_.containsKey('sizeGb')
              ? json_['sizeGb'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sizeGb != null) 'sizeGb': sizeGb!,
      };
}

class RegionInstanceGroupListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionInstanceGroupListWarningData({
    this.key,
    this.value,
  });

  RegionInstanceGroupListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionInstanceGroupListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionInstanceGroupListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionInstanceGroupListWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionInstanceGroupListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RegionInstanceGroupListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of InstanceGroup resources.
class RegionInstanceGroupList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroup resources.
  core.List<InstanceGroup>? items;

  /// The resource type.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionInstanceGroupListWarning? warning;

  RegionInstanceGroupList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionInstanceGroupList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceGroup.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionInstanceGroupListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// RegionInstanceGroupManagers.deletePerInstanceConfigs
typedef RegionInstanceGroupManagerDeleteInstanceConfigReq = $Req;

class RegionInstanceGroupManagerListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionInstanceGroupManagerListWarningData({
    this.key,
    this.value,
  });

  RegionInstanceGroupManagerListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionInstanceGroupManagerListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionInstanceGroupManagerListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionInstanceGroupManagerListWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionInstanceGroupManagerListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      RegionInstanceGroupManagerListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of managed instance groups.
class RegionInstanceGroupManagerList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceGroupManager resources.
  core.List<InstanceGroupManager>? items;

  /// The resource type, which is always compute#instanceGroupManagerList for a
  /// list of managed instance groups that exist in th regional scope.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionInstanceGroupManagerListWarning? warning;

  RegionInstanceGroupManagerList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionInstanceGroupManagerList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceGroupManager.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionInstanceGroupManagerListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// RegionInstanceGroupManagers.patchPerInstanceConfigs
class RegionInstanceGroupManagerPatchInstanceConfigReq {
  /// The list of per-instance configurations to insert or patch on this managed
  /// instance group.
  core.List<PerInstanceConfig>? perInstanceConfigs;

  RegionInstanceGroupManagerPatchInstanceConfigReq({
    this.perInstanceConfigs,
  });

  RegionInstanceGroupManagerPatchInstanceConfigReq.fromJson(core.Map json_)
      : this(
          perInstanceConfigs: json_.containsKey('perInstanceConfigs')
              ? (json_['perInstanceConfigs'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (perInstanceConfigs != null)
          'perInstanceConfigs': perInstanceConfigs!,
      };
}

/// RegionInstanceGroupManagers.updatePerInstanceConfigs
class RegionInstanceGroupManagerUpdateInstanceConfigReq {
  /// The list of per-instance configurations to insert or patch on this managed
  /// instance group.
  core.List<PerInstanceConfig>? perInstanceConfigs;

  RegionInstanceGroupManagerUpdateInstanceConfigReq({
    this.perInstanceConfigs,
  });

  RegionInstanceGroupManagerUpdateInstanceConfigReq.fromJson(core.Map json_)
      : this(
          perInstanceConfigs: json_.containsKey('perInstanceConfigs')
              ? (json_['perInstanceConfigs'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (perInstanceConfigs != null)
          'perInstanceConfigs': perInstanceConfigs!,
      };
}

typedef RegionInstanceGroupManagersAbandonInstancesRequest
    = $InstanceGroupManagersAbandonInstancesRequest;

/// RegionInstanceGroupManagers.applyUpdatesToInstances
typedef RegionInstanceGroupManagersApplyUpdatesRequest
    = $InstanceGroupManagersApplyUpdatesRequest;

/// RegionInstanceGroupManagers.createInstances
class RegionInstanceGroupManagersCreateInstancesRequest {
  /// List of specifications of per-instance configs.
  ///
  /// Required.
  core.List<PerInstanceConfig>? instances;

  RegionInstanceGroupManagersCreateInstancesRequest({
    this.instances,
  });

  RegionInstanceGroupManagersCreateInstancesRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

typedef RegionInstanceGroupManagersDeleteInstancesRequest
    = $InstanceGroupManagersDeleteInstancesRequest;

class RegionInstanceGroupManagersListErrorsResponse {
  /// The list of errors of the managed instance group.
  ///
  /// Output only.
  core.List<InstanceManagedByIgmError>? items;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  RegionInstanceGroupManagersListErrorsResponse({
    this.items,
    this.nextPageToken,
  });

  RegionInstanceGroupManagersListErrorsResponse.fromJson(core.Map json_)
      : this(
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceManagedByIgmError.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (items != null) 'items': items!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
      };
}

class RegionInstanceGroupManagersListInstanceConfigsRespWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionInstanceGroupManagersListInstanceConfigsRespWarningData({
    this.key,
    this.value,
  });

  RegionInstanceGroupManagersListInstanceConfigsRespWarningData.fromJson(
      core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionInstanceGroupManagersListInstanceConfigsRespWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionInstanceGroupManagersListInstanceConfigsRespWarningData>?
      data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionInstanceGroupManagersListInstanceConfigsRespWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionInstanceGroupManagersListInstanceConfigsRespWarning.fromJson(
      core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      RegionInstanceGroupManagersListInstanceConfigsRespWarningData
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class RegionInstanceGroupManagersListInstanceConfigsResp {
  /// The list of PerInstanceConfig.
  ///
  /// Output only.
  core.List<PerInstanceConfig>? items;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Informational warning message.
  ///
  /// Output only.
  RegionInstanceGroupManagersListInstanceConfigsRespWarning? warning;

  RegionInstanceGroupManagersListInstanceConfigsResp({
    this.items,
    this.nextPageToken,
    this.warning,
  });

  RegionInstanceGroupManagersListInstanceConfigsResp.fromJson(core.Map json_)
      : this(
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => PerInstanceConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionInstanceGroupManagersListInstanceConfigsRespWarning
                  .fromJson(
                      json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (items != null) 'items': items!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (warning != null) 'warning': warning!,
      };
}

class RegionInstanceGroupManagersListInstancesResponse {
  /// A list of managed instances.
  core.List<ManagedInstance>? managedInstances;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  RegionInstanceGroupManagersListInstancesResponse({
    this.managedInstances,
    this.nextPageToken,
  });

  RegionInstanceGroupManagersListInstancesResponse.fromJson(core.Map json_)
      : this(
          managedInstances: json_.containsKey('managedInstances')
              ? (json_['managedInstances'] as core.List)
                  .map((value) => ManagedInstance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (managedInstances != null) 'managedInstances': managedInstances!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
      };
}

typedef RegionInstanceGroupManagersRecreateRequest = $Request05;

class RegionInstanceGroupManagersSetTargetPoolsRequest {
  /// Fingerprint of the target pools information, which is a hash of the
  /// contents.
  ///
  /// This field is used for optimistic locking when you update the target pool
  /// entries. This field is optional.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The URL of all TargetPool resources to which instances in the
  /// instanceGroup field are added.
  ///
  /// The target pools automatically apply to all of the instances in the
  /// managed instance group.
  core.List<core.String>? targetPools;

  RegionInstanceGroupManagersSetTargetPoolsRequest({
    this.fingerprint,
    this.targetPools,
  });

  RegionInstanceGroupManagersSetTargetPoolsRequest.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          targetPools: json_.containsKey('targetPools')
              ? (json_['targetPools'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (targetPools != null) 'targetPools': targetPools!,
      };
}

class RegionInstanceGroupManagersSetTemplateRequest {
  /// URL of the InstanceTemplate resource from which all new instances will be
  /// created.
  core.String? instanceTemplate;

  RegionInstanceGroupManagersSetTemplateRequest({
    this.instanceTemplate,
  });

  RegionInstanceGroupManagersSetTemplateRequest.fromJson(core.Map json_)
      : this(
          instanceTemplate: json_.containsKey('instanceTemplate')
              ? json_['instanceTemplate'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceTemplate != null) 'instanceTemplate': instanceTemplate!,
      };
}

class RegionInstanceGroupsListInstancesWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionInstanceGroupsListInstancesWarningData({
    this.key,
    this.value,
  });

  RegionInstanceGroupsListInstancesWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionInstanceGroupsListInstancesWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionInstanceGroupsListInstancesWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionInstanceGroupsListInstancesWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionInstanceGroupsListInstancesWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      RegionInstanceGroupsListInstancesWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class RegionInstanceGroupsListInstances {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of InstanceWithNamedPorts resources.
  core.List<InstanceWithNamedPorts>? items;

  /// The resource type.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionInstanceGroupsListInstancesWarning? warning;

  RegionInstanceGroupsListInstances({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionInstanceGroupsListInstances.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => InstanceWithNamedPorts.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionInstanceGroupsListInstancesWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class RegionInstanceGroupsListInstancesRequest {
  /// Instances in which state should be returned.
  ///
  /// Valid options are: 'ALL', 'RUNNING'. By default, it lists all instances.
  /// Possible string values are:
  /// - "ALL" : Matches any status of the instances, running, non-running and
  /// others.
  /// - "RUNNING" : Instance is in RUNNING state if it is running.
  core.String? instanceState;

  /// Name of port user is interested in.
  ///
  /// It is optional. If it is set, only information about this ports will be
  /// returned. If it is not set, all the named ports will be returned. Always
  /// lists all instances.
  core.String? portName;

  RegionInstanceGroupsListInstancesRequest({
    this.instanceState,
    this.portName,
  });

  RegionInstanceGroupsListInstancesRequest.fromJson(core.Map json_)
      : this(
          instanceState: json_.containsKey('instanceState')
              ? json_['instanceState'] as core.String
              : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceState != null) 'instanceState': instanceState!,
        if (portName != null) 'portName': portName!,
      };
}

class RegionInstanceGroupsSetNamedPortsRequest {
  /// The fingerprint of the named ports information for this instance group.
  ///
  /// Use this optional property to prevent conflicts when multiple users change
  /// the named ports settings concurrently. Obtain the fingerprint with the
  /// instanceGroups.get method. Then, include the fingerprint in your request
  /// to ensure that you do not overwrite changes that were applied from another
  /// concurrent request.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The list of named ports to set for this instance group.
  core.List<NamedPort>? namedPorts;

  RegionInstanceGroupsSetNamedPortsRequest({
    this.fingerprint,
    this.namedPorts,
  });

  RegionInstanceGroupsSetNamedPortsRequest.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          namedPorts: json_.containsKey('namedPorts')
              ? (json_['namedPorts'] as core.List)
                  .map((value) => NamedPort.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (namedPorts != null) 'namedPorts': namedPorts!,
      };
}

class RegionListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RegionListWarningData({
    this.key,
    this.value,
  });

  RegionListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RegionListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RegionListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RegionListWarning({
    this.code,
    this.data,
    this.message,
  });

  RegionListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RegionListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of region resources.
class RegionList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Region resources.
  core.List<Region>? items;

  /// Type of resource.
  ///
  /// Always compute#regionList for lists of regions.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RegionListWarning? warning;

  RegionList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RegionList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Region.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RegionListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse {
  /// Effective firewalls from firewall policy.
  core.List<
          RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>?
      firewallPolicys;

  /// Effective firewalls on the network.
  core.List<Firewall>? firewalls;

  RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse({
    this.firewallPolicys,
    this.firewalls,
  });

  RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.fromJson(
      core.Map json_)
      : this(
          firewallPolicys: json_.containsKey('firewallPolicys')
              ? (json_['firewallPolicys'] as core.List)
                  .map((value) =>
                      RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          firewalls: json_.containsKey('firewalls')
              ? (json_['firewalls'] as core.List)
                  .map((value) => Firewall.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (firewallPolicys != null) 'firewallPolicys': firewallPolicys!,
        if (firewalls != null) 'firewalls': firewalls!,
      };
}

class RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy {
  /// The display name of the firewall policy.
  ///
  /// Output only.
  core.String? displayName;

  /// The name of the firewall policy.
  ///
  /// Output only.
  core.String? name;

  /// The rules that apply to the network.
  core.List<FirewallPolicyRule>? rules;

  /// The type of the firewall policy.
  ///
  /// Can be one of HIERARCHY, NETWORK, NETWORK_REGIONAL.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "HIERARCHY"
  /// - "NETWORK"
  /// - "NETWORK_REGIONAL"
  /// - "UNSPECIFIED"
  core.String? type;

  RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy({
    this.displayName,
    this.name,
    this.rules,
    this.type,
  });

  RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromJson(
      core.Map json_)
      : this(
          displayName: json_.containsKey('displayName')
              ? json_['displayName'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => FirewallPolicyRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (displayName != null) 'displayName': displayName!,
        if (name != null) 'name': name!,
        if (rules != null) 'rules': rules!,
        if (type != null) 'type': type!,
      };
}

typedef RegionSetLabelsRequest = $SetLabelsRequest;

class RegionSetPolicyRequest {
  /// Flatten Policy to create a backwacd compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify bindings.
  core.List<Binding>? bindings;

  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify the etag.
  core.String? etag;
  core.List<core.int> get etagAsBytes => convert.base64.decode(etag!);

  set etagAsBytes(core.List<core.int> bytes_) {
    etag =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// REQUIRED: The complete policy to be applied to the 'resource'.
  ///
  /// The size of the policy is limited to a few 10s of KB. An empty policy is
  /// in general a valid policy but certain services (like Projects) might
  /// reject them.
  Policy? policy;

  RegionSetPolicyRequest({
    this.bindings,
    this.etag,
    this.policy,
  });

  RegionSetPolicyRequest.fromJson(core.Map json_)
      : this(
          bindings: json_.containsKey('bindings')
              ? (json_['bindings'] as core.List)
                  .map((value) => Binding.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          policy: json_.containsKey('policy')
              ? Policy.fromJson(
                  json_['policy'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bindings != null) 'bindings': bindings!,
        if (etag != null) 'etag': etag!,
        if (policy != null) 'policy': policy!,
      };
}

class RegionTargetHttpsProxiesSetSslCertificatesRequest {
  /// New set of SslCertificate resources to associate with this
  /// TargetHttpsProxy resource.
  core.List<core.String>? sslCertificates;

  RegionTargetHttpsProxiesSetSslCertificatesRequest({
    this.sslCertificates,
  });

  RegionTargetHttpsProxiesSetSslCertificatesRequest.fromJson(core.Map json_)
      : this(
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
      };
}

class RegionUrlMapsValidateRequest {
  /// Content of the UrlMap to be validated.
  UrlMap? resource;

  RegionUrlMapsValidateRequest({
    this.resource,
  });

  RegionUrlMapsValidateRequest.fromJson(core.Map json_)
      : this(
          resource: json_.containsKey('resource')
              ? UrlMap.fromJson(
                  json_['resource'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resource != null) 'resource': resource!,
      };
}

/// A policy that specifies how requests intended for the route's backends are
/// shadowed to a separate mirrored backend service.
///
/// The load balancer doesn't wait for responses from the shadow service. Before
/// sending traffic to the shadow service, the host or authority header is
/// suffixed with -shadow.
class RequestMirrorPolicy {
  /// The full or partial URL to the BackendService resource being mirrored to.
  ///
  /// The backend service configured for a mirroring policy must reference
  /// backends that are of the same type as the original backend service matched
  /// in the URL map. Serverless NEG backends are not currently supported as a
  /// mirrored backend service.
  core.String? backendService;

  RequestMirrorPolicy({
    this.backendService,
  });

  RequestMirrorPolicy.fromJson(core.Map json_)
      : this(
          backendService: json_.containsKey('backendService')
              ? json_['backendService'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backendService != null) 'backendService': backendService!,
      };
}

/// Represents a reservation resource.
///
/// A reservation ensures that capacity is held in a specific zone even if the
/// reserved VMs are not running. For more information, read Reserving zonal
/// resources.
class Reservation {
  /// Full or partial URL to a parent commitment.
  ///
  /// This field displays for reservations that are tied to a commitment.
  ///
  /// Output only.
  core.String? commitment;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#reservations for reservations.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The resource name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined fully-qualified URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Share-settings for shared-reservation
  ShareSettings? shareSettings;

  /// Reservation for instances with specific machine shapes.
  AllocationSpecificSKUReservation? specificReservation;

  /// Indicates whether the reservation can be consumed by VMs with affinity for
  /// "any" reservation.
  ///
  /// If the field is set, then only VMs that target the reservation by name can
  /// consume from this reservation.
  core.bool? specificReservationRequired;

  /// The status of the reservation.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING" : Resources are being allocated for the reservation.
  /// - "DELETING" : Reservation is currently being deleted.
  /// - "INVALID"
  /// - "READY" : Reservation has allocated all its resources.
  /// - "UPDATING" : Reservation is currently being resized.
  core.String? status;

  /// Zone in which the reservation resides.
  ///
  /// A zone must be provided if the reservation is created within a commitment.
  core.String? zone;

  Reservation({
    this.commitment,
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.satisfiesPzs,
    this.selfLink,
    this.shareSettings,
    this.specificReservation,
    this.specificReservationRequired,
    this.status,
    this.zone,
  });

  Reservation.fromJson(core.Map json_)
      : this(
          commitment: json_.containsKey('commitment')
              ? json_['commitment'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          shareSettings: json_.containsKey('shareSettings')
              ? ShareSettings.fromJson(
                  json_['shareSettings'] as core.Map<core.String, core.dynamic>)
              : null,
          specificReservation: json_.containsKey('specificReservation')
              ? AllocationSpecificSKUReservation.fromJson(
                  json_['specificReservation']
                      as core.Map<core.String, core.dynamic>)
              : null,
          specificReservationRequired:
              json_.containsKey('specificReservationRequired')
                  ? json_['specificReservationRequired'] as core.bool
                  : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (commitment != null) 'commitment': commitment!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (shareSettings != null) 'shareSettings': shareSettings!,
        if (specificReservation != null)
          'specificReservation': specificReservation!,
        if (specificReservationRequired != null)
          'specificReservationRequired': specificReservationRequired!,
        if (status != null) 'status': status!,
        if (zone != null) 'zone': zone!,
      };
}

/// Specifies the reservations that this instance can consume from.
class ReservationAffinity {
  /// Specifies the type of reservation from which this instance can consume
  /// resources: ANY_RESERVATION (default), SPECIFIC_RESERVATION, or
  /// NO_RESERVATION.
  ///
  /// See Consuming reserved instances for examples.
  /// Possible string values are:
  /// - "ANY_RESERVATION" : Consume any allocation available.
  /// - "NO_RESERVATION" : Do not consume from any allocated capacity.
  /// - "SPECIFIC_RESERVATION" : Must consume from a specific reservation. Must
  /// specify key value fields for specifying the reservations.
  /// - "UNSPECIFIED"
  core.String? consumeReservationType;

  /// Corresponds to the label key of a reservation resource.
  ///
  /// To target a SPECIFIC_RESERVATION by name, specify
  /// googleapis.com/reservation-name as the key and specify the name of your
  /// reservation as its value.
  core.String? key;

  /// Corresponds to the label values of a reservation resource.
  ///
  /// This can be either a name to a reservation in the same project or
  /// "projects/different-project/reservations/some-reservation-name" to target
  /// a shared reservation in the same zone but in a different project.
  core.List<core.String>? values;

  ReservationAffinity({
    this.consumeReservationType,
    this.key,
    this.values,
  });

  ReservationAffinity.fromJson(core.Map json_)
      : this(
          consumeReservationType: json_.containsKey('consumeReservationType')
              ? json_['consumeReservationType'] as core.String
              : null,
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          values: json_.containsKey('values')
              ? (json_['values'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (consumeReservationType != null)
          'consumeReservationType': consumeReservationType!,
        if (key != null) 'key': key!,
        if (values != null) 'values': values!,
      };
}

class ReservationAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ReservationAggregatedListWarningData({
    this.key,
    this.value,
  });

  ReservationAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ReservationAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ReservationAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ReservationAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ReservationAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ReservationAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of reservations.
class ReservationAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Allocation resources.
  core.Map<core.String, ReservationsScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  ReservationAggregatedListWarning? warning;

  ReservationAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  ReservationAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    ReservationsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ReservationAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class ReservationListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ReservationListWarningData({
    this.key,
    this.value,
  });

  ReservationListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ReservationListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ReservationListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ReservationListWarning({
    this.code,
    this.data,
    this.message,
  });

  ReservationListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ReservationListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ReservationList {
  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Allocation resources.
  ///
  /// Output only.
  core.List<Reservation>? items;

  /// Type of resource.Always compute#reservationsList for listsof reservations
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ReservationListWarning? warning;

  ReservationList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ReservationList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Reservation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ReservationListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class ReservationsResizeRequest {
  /// Number of allocated resources can be resized with minimum = 1 and maximum
  /// = 1000.
  core.String? specificSkuCount;

  ReservationsResizeRequest({
    this.specificSkuCount,
  });

  ReservationsResizeRequest.fromJson(core.Map json_)
      : this(
          specificSkuCount: json_.containsKey('specificSkuCount')
              ? json_['specificSkuCount'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (specificSkuCount != null) 'specificSkuCount': specificSkuCount!,
      };
}

class ReservationsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ReservationsScopedListWarningData({
    this.key,
    this.value,
  });

  ReservationsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of reservations when the list
/// is empty.
class ReservationsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ReservationsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ReservationsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ReservationsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ReservationsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ReservationsScopedList {
  /// A list of reservations contained in this scope.
  core.List<Reservation>? reservations;

  /// Informational warning which replaces the list of reservations when the
  /// list is empty.
  ReservationsScopedListWarning? warning;

  ReservationsScopedList({
    this.reservations,
    this.warning,
  });

  ReservationsScopedList.fromJson(core.Map json_)
      : this(
          reservations: json_.containsKey('reservations')
              ? (json_['reservations'] as core.List)
                  .map((value) => Reservation.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ReservationsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (reservations != null) 'reservations': reservations!,
        if (warning != null) 'warning': warning!,
      };
}

/// Commitment for a particular resource (a Commitment is composed of one or
/// more of these).
class ResourceCommitment {
  /// Name of the accelerator type resource.
  ///
  /// Applicable only when the type is ACCELERATOR.
  core.String? acceleratorType;

  /// The amount of the resource purchased (in a type-dependent unit, such as
  /// bytes).
  ///
  /// For vCPUs, this can just be an integer. For memory, this must be provided
  /// in MB. Memory must be a multiple of 256 MB, with up to 6.5GB of memory per
  /// every vCPU.
  core.String? amount;

  /// Type of resource for which this commitment applies.
  ///
  /// Possible values are VCPU and MEMORY
  /// Possible string values are:
  /// - "ACCELERATOR"
  /// - "LOCAL_SSD"
  /// - "MEMORY"
  /// - "UNSPECIFIED"
  /// - "VCPU"
  core.String? type;

  ResourceCommitment({
    this.acceleratorType,
    this.amount,
    this.type,
  });

  ResourceCommitment.fromJson(core.Map json_)
      : this(
          acceleratorType: json_.containsKey('acceleratorType')
              ? json_['acceleratorType'] as core.String
              : null,
          amount: json_.containsKey('amount')
              ? json_['amount'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (acceleratorType != null) 'acceleratorType': acceleratorType!,
        if (amount != null) 'amount': amount!,
        if (type != null) 'type': type!,
      };
}

class ResourceGroupReference {
  /// A URI referencing one of the instance groups or network endpoint groups
  /// listed in the backend service.
  core.String? group;

  ResourceGroupReference({
    this.group,
  });

  ResourceGroupReference.fromJson(core.Map json_)
      : this(
          group:
              json_.containsKey('group') ? json_['group'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (group != null) 'group': group!,
      };
}

class ResourcePoliciesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ResourcePoliciesScopedListWarningData({
    this.key,
    this.value,
  });

  ResourcePoliciesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of resourcePolicies when the
/// list is empty.
class ResourcePoliciesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ResourcePoliciesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ResourcePoliciesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ResourcePoliciesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ResourcePoliciesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ResourcePoliciesScopedList {
  /// A list of resourcePolicies contained in this scope.
  core.List<ResourcePolicy>? resourcePolicies;

  /// Informational warning which replaces the list of resourcePolicies when the
  /// list is empty.
  ResourcePoliciesScopedListWarning? warning;

  ResourcePoliciesScopedList({
    this.resourcePolicies,
    this.warning,
  });

  ResourcePoliciesScopedList.fromJson(core.Map json_)
      : this(
          resourcePolicies: json_.containsKey('resourcePolicies')
              ? (json_['resourcePolicies'] as core.List)
                  .map((value) => ResourcePolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ResourcePoliciesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resourcePolicies != null) 'resourcePolicies': resourcePolicies!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Resource Policy resource.
///
/// You can use resource policies to schedule actions for some Compute Engine
/// resources. For example, you can use them to schedule persistent disk
/// snapshots.
class ResourcePolicy {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;
  core.String? description;

  /// Resource policy for instances for placement configuration.
  ResourcePolicyGroupPlacementPolicy? groupPlacementPolicy;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Resource policy for scheduling instance operations.
  ResourcePolicyInstanceSchedulePolicy? instanceSchedulePolicy;

  /// Type of the resource.
  ///
  /// Always compute#resource_policies for resource policies.
  ///
  /// Output only.
  core.String? kind;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The resource name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;
  core.String? region;

  /// The system status of the resource policy.
  ///
  /// Output only.
  ResourcePolicyResourceStatus? resourceStatus;

  /// Server-defined fully-qualified URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Resource policy for persistent disks for creating snapshots.
  ResourcePolicySnapshotSchedulePolicy? snapshotSchedulePolicy;

  /// The status of resource policy creation.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING" : Resource policy is being created.
  /// - "DELETING" : Resource policy is being deleted.
  /// - "EXPIRED" : Resource policy is expired and will not run again.
  /// - "INVALID"
  /// - "READY" : Resource policy is ready to be used.
  core.String? status;

  ResourcePolicy({
    this.creationTimestamp,
    this.description,
    this.groupPlacementPolicy,
    this.id,
    this.instanceSchedulePolicy,
    this.kind,
    this.name,
    this.region,
    this.resourceStatus,
    this.selfLink,
    this.snapshotSchedulePolicy,
    this.status,
  });

  ResourcePolicy.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          groupPlacementPolicy: json_.containsKey('groupPlacementPolicy')
              ? ResourcePolicyGroupPlacementPolicy.fromJson(
                  json_['groupPlacementPolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instanceSchedulePolicy: json_.containsKey('instanceSchedulePolicy')
              ? ResourcePolicyInstanceSchedulePolicy.fromJson(
                  json_['instanceSchedulePolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          resourceStatus: json_.containsKey('resourceStatus')
              ? ResourcePolicyResourceStatus.fromJson(json_['resourceStatus']
                  as core.Map<core.String, core.dynamic>)
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          snapshotSchedulePolicy: json_.containsKey('snapshotSchedulePolicy')
              ? ResourcePolicySnapshotSchedulePolicy.fromJson(
                  json_['snapshotSchedulePolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (groupPlacementPolicy != null)
          'groupPlacementPolicy': groupPlacementPolicy!,
        if (id != null) 'id': id!,
        if (instanceSchedulePolicy != null)
          'instanceSchedulePolicy': instanceSchedulePolicy!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (resourceStatus != null) 'resourceStatus': resourceStatus!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (snapshotSchedulePolicy != null)
          'snapshotSchedulePolicy': snapshotSchedulePolicy!,
        if (status != null) 'status': status!,
      };
}

class ResourcePolicyAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ResourcePolicyAggregatedListWarningData({
    this.key,
    this.value,
  });

  ResourcePolicyAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ResourcePolicyAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ResourcePolicyAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ResourcePolicyAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ResourcePolicyAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ResourcePolicyAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of resourcePolicies.
class ResourcePolicyAggregatedList {
  core.String? etag;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ResourcePolicy resources.
  core.Map<core.String, ResourcePoliciesScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  ResourcePolicyAggregatedListWarning? warning;

  ResourcePolicyAggregatedList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  ResourcePolicyAggregatedList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    ResourcePoliciesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ResourcePolicyAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

/// Time window specified for daily operations.
class ResourcePolicyDailyCycle {
  /// Defines a schedule with units measured in days.
  ///
  /// The value determines how many days pass between the start of each cycle.
  core.int? daysInCycle;

  /// A predetermined duration for the window, automatically chosen to be the
  /// smallest possible in the given scenario.
  ///
  /// Output only.
  core.String? duration;

  /// Start time of the window.
  ///
  /// This must be in UTC format that resolves to one of 00:00, 04:00, 08:00,
  /// 12:00, 16:00, or 20:00. For example, both 13:00-5 and 08:00 are valid.
  core.String? startTime;

  ResourcePolicyDailyCycle({
    this.daysInCycle,
    this.duration,
    this.startTime,
  });

  ResourcePolicyDailyCycle.fromJson(core.Map json_)
      : this(
          daysInCycle: json_.containsKey('daysInCycle')
              ? json_['daysInCycle'] as core.int
              : null,
          duration: json_.containsKey('duration')
              ? json_['duration'] as core.String
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (daysInCycle != null) 'daysInCycle': daysInCycle!,
        if (duration != null) 'duration': duration!,
        if (startTime != null) 'startTime': startTime!,
      };
}

/// A GroupPlacementPolicy specifies resource placement configuration.
///
/// It specifies the failure bucket separation as well as network locality
class ResourcePolicyGroupPlacementPolicy {
  /// The number of availability domains to spread instances across.
  ///
  /// If two instances are in different availability domain, they are not in the
  /// same low latency network.
  core.int? availabilityDomainCount;

  /// Specifies network collocation
  /// Possible string values are:
  /// - "COLLOCATED"
  /// - "UNSPECIFIED_COLLOCATION"
  core.String? collocation;

  /// Number of VMs in this placement group.
  ///
  /// Google does not recommend that you use this field unless you use a compact
  /// policy and you want your policy to work only if it contains this exact
  /// number of VMs.
  core.int? vmCount;

  ResourcePolicyGroupPlacementPolicy({
    this.availabilityDomainCount,
    this.collocation,
    this.vmCount,
  });

  ResourcePolicyGroupPlacementPolicy.fromJson(core.Map json_)
      : this(
          availabilityDomainCount: json_.containsKey('availabilityDomainCount')
              ? json_['availabilityDomainCount'] as core.int
              : null,
          collocation: json_.containsKey('collocation')
              ? json_['collocation'] as core.String
              : null,
          vmCount: json_.containsKey('vmCount')
              ? json_['vmCount'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (availabilityDomainCount != null)
          'availabilityDomainCount': availabilityDomainCount!,
        if (collocation != null) 'collocation': collocation!,
        if (vmCount != null) 'vmCount': vmCount!,
      };
}

/// Time window specified for hourly operations.
class ResourcePolicyHourlyCycle {
  /// Duration of the time window, automatically chosen to be smallest possible
  /// in the given scenario.
  ///
  /// Output only.
  core.String? duration;

  /// Defines a schedule with units measured in hours.
  ///
  /// The value determines how many hours pass between the start of each cycle.
  core.int? hoursInCycle;

  /// Time within the window to start the operations.
  ///
  /// It must be in format "HH:MM", where HH : \[00-23\] and MM : \[00-00\] GMT.
  core.String? startTime;

  ResourcePolicyHourlyCycle({
    this.duration,
    this.hoursInCycle,
    this.startTime,
  });

  ResourcePolicyHourlyCycle.fromJson(core.Map json_)
      : this(
          duration: json_.containsKey('duration')
              ? json_['duration'] as core.String
              : null,
          hoursInCycle: json_.containsKey('hoursInCycle')
              ? json_['hoursInCycle'] as core.int
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (duration != null) 'duration': duration!,
        if (hoursInCycle != null) 'hoursInCycle': hoursInCycle!,
        if (startTime != null) 'startTime': startTime!,
      };
}

/// An InstanceSchedulePolicy specifies when and how frequent certain operations
/// are performed on the instance.
class ResourcePolicyInstanceSchedulePolicy {
  /// The expiration time of the schedule.
  ///
  /// The timestamp is an RFC3339 string.
  core.String? expirationTime;

  /// The start time of the schedule.
  ///
  /// The timestamp is an RFC3339 string.
  core.String? startTime;

  /// Specifies the time zone to be used in interpreting Schedule.schedule.
  ///
  /// The value of this field must be a time zone name from the tz database:
  /// http://en.wikipedia.org/wiki/Tz_database.
  core.String? timeZone;

  /// Specifies the schedule for starting instances.
  ResourcePolicyInstanceSchedulePolicySchedule? vmStartSchedule;

  /// Specifies the schedule for stopping instances.
  ResourcePolicyInstanceSchedulePolicySchedule? vmStopSchedule;

  ResourcePolicyInstanceSchedulePolicy({
    this.expirationTime,
    this.startTime,
    this.timeZone,
    this.vmStartSchedule,
    this.vmStopSchedule,
  });

  ResourcePolicyInstanceSchedulePolicy.fromJson(core.Map json_)
      : this(
          expirationTime: json_.containsKey('expirationTime')
              ? json_['expirationTime'] as core.String
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
          timeZone: json_.containsKey('timeZone')
              ? json_['timeZone'] as core.String
              : null,
          vmStartSchedule: json_.containsKey('vmStartSchedule')
              ? ResourcePolicyInstanceSchedulePolicySchedule.fromJson(
                  json_['vmStartSchedule']
                      as core.Map<core.String, core.dynamic>)
              : null,
          vmStopSchedule: json_.containsKey('vmStopSchedule')
              ? ResourcePolicyInstanceSchedulePolicySchedule.fromJson(
                  json_['vmStopSchedule']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (expirationTime != null) 'expirationTime': expirationTime!,
        if (startTime != null) 'startTime': startTime!,
        if (timeZone != null) 'timeZone': timeZone!,
        if (vmStartSchedule != null) 'vmStartSchedule': vmStartSchedule!,
        if (vmStopSchedule != null) 'vmStopSchedule': vmStopSchedule!,
      };
}

/// Schedule for an instance operation.
class ResourcePolicyInstanceSchedulePolicySchedule {
  /// Specifies the frequency for the operation, using the unix-cron format.
  core.String? schedule;

  ResourcePolicyInstanceSchedulePolicySchedule({
    this.schedule,
  });

  ResourcePolicyInstanceSchedulePolicySchedule.fromJson(core.Map json_)
      : this(
          schedule: json_.containsKey('schedule')
              ? json_['schedule'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (schedule != null) 'schedule': schedule!,
      };
}

class ResourcePolicyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ResourcePolicyListWarningData({
    this.key,
    this.value,
  });

  ResourcePolicyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ResourcePolicyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ResourcePolicyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ResourcePolicyListWarning({
    this.code,
    this.data,
    this.message,
  });

  ResourcePolicyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ResourcePolicyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ResourcePolicyList {
  core.String? etag;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ResourcePolicy resources.
  ///
  /// Output only.
  core.List<ResourcePolicy>? items;

  /// Type of resource.Always compute#resourcePoliciesList for listsof
  /// resourcePolicies
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ResourcePolicyListWarning? warning;

  ResourcePolicyList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ResourcePolicyList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => ResourcePolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ResourcePolicyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Contains output only fields.
///
/// Use this sub-message for all output fields set on ResourcePolicy. The
/// internal structure of this "status" field should mimic the structure of
/// ResourcePolicy proto specification.
class ResourcePolicyResourceStatus {
  /// Specifies a set of output values reffering to the instance_schedule_policy
  /// system status.
  ///
  /// This field should have the same name as corresponding policy field.
  ///
  /// Output only.
  ResourcePolicyResourceStatusInstanceSchedulePolicyStatus?
      instanceSchedulePolicy;

  ResourcePolicyResourceStatus({
    this.instanceSchedulePolicy,
  });

  ResourcePolicyResourceStatus.fromJson(core.Map json_)
      : this(
          instanceSchedulePolicy: json_.containsKey('instanceSchedulePolicy')
              ? ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                  .fromJson(json_['instanceSchedulePolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceSchedulePolicy != null)
          'instanceSchedulePolicy': instanceSchedulePolicy!,
      };
}

class ResourcePolicyResourceStatusInstanceSchedulePolicyStatus {
  /// The last time the schedule successfully ran.
  ///
  /// The timestamp is an RFC3339 string.
  ///
  /// Output only.
  core.String? lastRunStartTime;

  /// The next time the schedule is planned to run.
  ///
  /// The actual time might be slightly different. The timestamp is an RFC3339
  /// string.
  ///
  /// Output only.
  core.String? nextRunStartTime;

  ResourcePolicyResourceStatusInstanceSchedulePolicyStatus({
    this.lastRunStartTime,
    this.nextRunStartTime,
  });

  ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.fromJson(
      core.Map json_)
      : this(
          lastRunStartTime: json_.containsKey('lastRunStartTime')
              ? json_['lastRunStartTime'] as core.String
              : null,
          nextRunStartTime: json_.containsKey('nextRunStartTime')
              ? json_['nextRunStartTime'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (lastRunStartTime != null) 'lastRunStartTime': lastRunStartTime!,
        if (nextRunStartTime != null) 'nextRunStartTime': nextRunStartTime!,
      };
}

/// A snapshot schedule policy specifies when and how frequently snapshots are
/// to be created for the target disk.
///
/// Also specifies how many and how long these scheduled snapshots should be
/// retained.
class ResourcePolicySnapshotSchedulePolicy {
  /// Retention policy applied to snapshots created by this resource policy.
  ResourcePolicySnapshotSchedulePolicyRetentionPolicy? retentionPolicy;

  /// A Vm Maintenance Policy specifies what kind of infrastructure maintenance
  /// we are allowed to perform on this VM and when.
  ///
  /// Schedule that is applied to disks covered by this policy.
  ResourcePolicySnapshotSchedulePolicySchedule? schedule;

  /// Properties with which snapshots are created such as labels, encryption
  /// keys.
  ResourcePolicySnapshotSchedulePolicySnapshotProperties? snapshotProperties;

  ResourcePolicySnapshotSchedulePolicy({
    this.retentionPolicy,
    this.schedule,
    this.snapshotProperties,
  });

  ResourcePolicySnapshotSchedulePolicy.fromJson(core.Map json_)
      : this(
          retentionPolicy: json_.containsKey('retentionPolicy')
              ? ResourcePolicySnapshotSchedulePolicyRetentionPolicy.fromJson(
                  json_['retentionPolicy']
                      as core.Map<core.String, core.dynamic>)
              : null,
          schedule: json_.containsKey('schedule')
              ? ResourcePolicySnapshotSchedulePolicySchedule.fromJson(
                  json_['schedule'] as core.Map<core.String, core.dynamic>)
              : null,
          snapshotProperties: json_.containsKey('snapshotProperties')
              ? ResourcePolicySnapshotSchedulePolicySnapshotProperties.fromJson(
                  json_['snapshotProperties']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (retentionPolicy != null) 'retentionPolicy': retentionPolicy!,
        if (schedule != null) 'schedule': schedule!,
        if (snapshotProperties != null)
          'snapshotProperties': snapshotProperties!,
      };
}

/// Policy for retention of scheduled snapshots.
class ResourcePolicySnapshotSchedulePolicyRetentionPolicy {
  /// Maximum age of the snapshot that is allowed to be kept.
  core.int? maxRetentionDays;

  /// Specifies the behavior to apply to scheduled snapshots when the source
  /// disk is deleted.
  /// Possible string values are:
  /// - "APPLY_RETENTION_POLICY"
  /// - "KEEP_AUTO_SNAPSHOTS"
  /// - "UNSPECIFIED_ON_SOURCE_DISK_DELETE"
  core.String? onSourceDiskDelete;

  ResourcePolicySnapshotSchedulePolicyRetentionPolicy({
    this.maxRetentionDays,
    this.onSourceDiskDelete,
  });

  ResourcePolicySnapshotSchedulePolicyRetentionPolicy.fromJson(core.Map json_)
      : this(
          maxRetentionDays: json_.containsKey('maxRetentionDays')
              ? json_['maxRetentionDays'] as core.int
              : null,
          onSourceDiskDelete: json_.containsKey('onSourceDiskDelete')
              ? json_['onSourceDiskDelete'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (maxRetentionDays != null) 'maxRetentionDays': maxRetentionDays!,
        if (onSourceDiskDelete != null)
          'onSourceDiskDelete': onSourceDiskDelete!,
      };
}

/// A schedule for disks where the schedueled operations are performed.
class ResourcePolicySnapshotSchedulePolicySchedule {
  ResourcePolicyDailyCycle? dailySchedule;
  ResourcePolicyHourlyCycle? hourlySchedule;
  ResourcePolicyWeeklyCycle? weeklySchedule;

  ResourcePolicySnapshotSchedulePolicySchedule({
    this.dailySchedule,
    this.hourlySchedule,
    this.weeklySchedule,
  });

  ResourcePolicySnapshotSchedulePolicySchedule.fromJson(core.Map json_)
      : this(
          dailySchedule: json_.containsKey('dailySchedule')
              ? ResourcePolicyDailyCycle.fromJson(
                  json_['dailySchedule'] as core.Map<core.String, core.dynamic>)
              : null,
          hourlySchedule: json_.containsKey('hourlySchedule')
              ? ResourcePolicyHourlyCycle.fromJson(json_['hourlySchedule']
                  as core.Map<core.String, core.dynamic>)
              : null,
          weeklySchedule: json_.containsKey('weeklySchedule')
              ? ResourcePolicyWeeklyCycle.fromJson(json_['weeklySchedule']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (dailySchedule != null) 'dailySchedule': dailySchedule!,
        if (hourlySchedule != null) 'hourlySchedule': hourlySchedule!,
        if (weeklySchedule != null) 'weeklySchedule': weeklySchedule!,
      };
}

/// Specified snapshot properties for scheduled snapshots created by this
/// policy.
class ResourcePolicySnapshotSchedulePolicySnapshotProperties {
  /// Chain name that the snapshot is created in.
  core.String? chainName;

  /// Indication to perform a 'guest aware' snapshot.
  core.bool? guestFlush;

  /// Labels to apply to scheduled snapshots.
  ///
  /// These can be later modified by the setLabels method. Label values may be
  /// empty.
  core.Map<core.String, core.String>? labels;

  /// Cloud Storage bucket storage location of the auto snapshot (regional or
  /// multi-regional).
  core.List<core.String>? storageLocations;

  ResourcePolicySnapshotSchedulePolicySnapshotProperties({
    this.chainName,
    this.guestFlush,
    this.labels,
    this.storageLocations,
  });

  ResourcePolicySnapshotSchedulePolicySnapshotProperties.fromJson(
      core.Map json_)
      : this(
          chainName: json_.containsKey('chainName')
              ? json_['chainName'] as core.String
              : null,
          guestFlush: json_.containsKey('guestFlush')
              ? json_['guestFlush'] as core.bool
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          storageLocations: json_.containsKey('storageLocations')
              ? (json_['storageLocations'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (chainName != null) 'chainName': chainName!,
        if (guestFlush != null) 'guestFlush': guestFlush!,
        if (labels != null) 'labels': labels!,
        if (storageLocations != null) 'storageLocations': storageLocations!,
      };
}

/// Time window specified for weekly operations.
class ResourcePolicyWeeklyCycle {
  /// Up to 7 intervals/windows, one for each day of the week.
  core.List<ResourcePolicyWeeklyCycleDayOfWeek>? dayOfWeeks;

  ResourcePolicyWeeklyCycle({
    this.dayOfWeeks,
  });

  ResourcePolicyWeeklyCycle.fromJson(core.Map json_)
      : this(
          dayOfWeeks: json_.containsKey('dayOfWeeks')
              ? (json_['dayOfWeeks'] as core.List)
                  .map((value) => ResourcePolicyWeeklyCycleDayOfWeek.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (dayOfWeeks != null) 'dayOfWeeks': dayOfWeeks!,
      };
}

class ResourcePolicyWeeklyCycleDayOfWeek {
  /// Defines a schedule that runs on specific days of the week.
  ///
  /// Specify one or more days. The following options are available: MONDAY,
  /// TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY.
  /// Possible string values are:
  /// - "FRIDAY"
  /// - "INVALID"
  /// - "MONDAY"
  /// - "SATURDAY"
  /// - "SUNDAY"
  /// - "THURSDAY"
  /// - "TUESDAY"
  /// - "WEDNESDAY"
  core.String? day;

  /// Duration of the time window, automatically chosen to be smallest possible
  /// in the given scenario.
  ///
  /// Output only.
  core.String? duration;

  /// Time within the window to start the operations.
  ///
  /// It must be in format "HH:MM", where HH : \[00-23\] and MM : \[00-00\] GMT.
  core.String? startTime;

  ResourcePolicyWeeklyCycleDayOfWeek({
    this.day,
    this.duration,
    this.startTime,
  });

  ResourcePolicyWeeklyCycleDayOfWeek.fromJson(core.Map json_)
      : this(
          day: json_.containsKey('day') ? json_['day'] as core.String : null,
          duration: json_.containsKey('duration')
              ? json_['duration'] as core.String
              : null,
          startTime: json_.containsKey('startTime')
              ? json_['startTime'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (day != null) 'day': day!,
        if (duration != null) 'duration': duration!,
        if (startTime != null) 'startTime': startTime!,
      };
}

class RouteWarningsData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RouteWarningsData({
    this.key,
    this.value,
  });

  RouteWarningsData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

class RouteWarnings {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RouteWarningsData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RouteWarnings({
    this.code,
    this.data,
    this.message,
  });

  RouteWarnings.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RouteWarningsData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Represents a Route resource.
///
/// A route defines a path from VM instances in the VPC network to a specific
/// destination. This destination can be inside or outside the VPC network. For
/// more information, read the Routes overview.
class Route {
  /// AS path.
  ///
  /// Output only.
  core.List<RouteAsPath>? asPaths;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this field when you create the resource.
  core.String? description;

  /// The destination range of outgoing packets that this route applies to.
  ///
  /// Both IPv4 and IPv6 are supported.
  core.String? destRange;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of this resource.
  ///
  /// Always compute#routes for Route resources.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase
  /// letter, and all following characters (except for the last character) must
  /// be a dash, lowercase letter, or digit. The last character must be a
  /// lowercase letter or digit.
  core.String? name;

  /// Fully-qualified URL of the network that this route applies to.
  core.String? network;

  /// The URL to a gateway that should handle matching packets.
  ///
  /// You can only specify the internet gateway using a full or partial valid
  /// URL: projects/ project/global/gateways/default-internet-gateway
  core.String? nextHopGateway;

  /// The URL to a forwarding rule of type loadBalancingScheme=INTERNAL that
  /// should handle matching packets or the IP address of the forwarding Rule.
  ///
  /// For example, the following are all valid URLs: - 10.128.0.56 -
  /// https://www.googleapis.com/compute/v1/projects/project/regions/region
  /// /forwardingRules/forwardingRule -
  /// regions/region/forwardingRules/forwardingRule
  core.String? nextHopIlb;

  /// The URL to an instance that should handle matching packets.
  ///
  /// You can specify this as a full or partial URL. For example:
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/
  core.String? nextHopInstance;

  /// The network IP address of an instance that should handle matching packets.
  ///
  /// Only IPv4 is supported.
  core.String? nextHopIp;

  /// The URL of the local network if it should handle matching packets.
  core.String? nextHopNetwork;

  /// The network peering name that should handle matching packets, which should
  /// conform to RFC1035.
  ///
  /// Output only.
  core.String? nextHopPeering;

  /// The URL to a VpnTunnel that should handle matching packets.
  core.String? nextHopVpnTunnel;

  /// The priority of this route.
  ///
  /// Priority is used to break ties in cases where there is more than one
  /// matching route of equal prefix length. In cases where multiple routes have
  /// equal prefix length, the one with the lowest-numbered priority value wins.
  /// The default value is `1000`. The priority value must be from `0` to
  /// `65535`, inclusive.
  core.int? priority;

  /// The status of the route.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : This route is processed and active.
  /// - "DROPPED" : The route is dropped due to the VPC exceeding the dynamic
  /// route limit. For dynamic route limit, please refer to the Learned route
  /// example
  /// - "INACTIVE" : This route is processed but inactive due to failure from
  /// the backend. The backend may have rejected the route
  /// - "PENDING" : This route is being processed internally. The status will
  /// change once processed.
  core.String? routeStatus;

  /// The type of this route, which can be one of the following values: -
  /// 'TRANSIT' for a transit route that this router learned from another Cloud
  /// Router and will readvertise to one of its BGP peers - 'SUBNET' for a route
  /// from a subnet of the VPC - 'BGP' for a route learned from a BGP peer of
  /// this router - 'STATIC' for a static route
  ///
  /// Output only.
  /// Possible string values are:
  /// - "BGP"
  /// - "STATIC"
  /// - "SUBNET"
  /// - "TRANSIT"
  core.String? routeType;

  /// Server-defined fully-qualified URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// A list of instance tags to which this route applies.
  core.List<core.String>? tags;

  /// If potential misconfigurations are detected for this route, this field
  /// will be populated with warning messages.
  ///
  /// Output only.
  core.List<RouteWarnings>? warnings;

  Route({
    this.asPaths,
    this.creationTimestamp,
    this.description,
    this.destRange,
    this.id,
    this.kind,
    this.name,
    this.network,
    this.nextHopGateway,
    this.nextHopIlb,
    this.nextHopInstance,
    this.nextHopIp,
    this.nextHopNetwork,
    this.nextHopPeering,
    this.nextHopVpnTunnel,
    this.priority,
    this.routeStatus,
    this.routeType,
    this.selfLink,
    this.tags,
    this.warnings,
  });

  Route.fromJson(core.Map json_)
      : this(
          asPaths: json_.containsKey('asPaths')
              ? (json_['asPaths'] as core.List)
                  .map((value) => RouteAsPath.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          destRange: json_.containsKey('destRange')
              ? json_['destRange'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          nextHopGateway: json_.containsKey('nextHopGateway')
              ? json_['nextHopGateway'] as core.String
              : null,
          nextHopIlb: json_.containsKey('nextHopIlb')
              ? json_['nextHopIlb'] as core.String
              : null,
          nextHopInstance: json_.containsKey('nextHopInstance')
              ? json_['nextHopInstance'] as core.String
              : null,
          nextHopIp: json_.containsKey('nextHopIp')
              ? json_['nextHopIp'] as core.String
              : null,
          nextHopNetwork: json_.containsKey('nextHopNetwork')
              ? json_['nextHopNetwork'] as core.String
              : null,
          nextHopPeering: json_.containsKey('nextHopPeering')
              ? json_['nextHopPeering'] as core.String
              : null,
          nextHopVpnTunnel: json_.containsKey('nextHopVpnTunnel')
              ? json_['nextHopVpnTunnel'] as core.String
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          routeStatus: json_.containsKey('routeStatus')
              ? json_['routeStatus'] as core.String
              : null,
          routeType: json_.containsKey('routeType')
              ? json_['routeType'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          tags: json_.containsKey('tags')
              ? (json_['tags'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warnings: json_.containsKey('warnings')
              ? (json_['warnings'] as core.List)
                  .map((value) => RouteWarnings.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (asPaths != null) 'asPaths': asPaths!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (destRange != null) 'destRange': destRange!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (nextHopGateway != null) 'nextHopGateway': nextHopGateway!,
        if (nextHopIlb != null) 'nextHopIlb': nextHopIlb!,
        if (nextHopInstance != null) 'nextHopInstance': nextHopInstance!,
        if (nextHopIp != null) 'nextHopIp': nextHopIp!,
        if (nextHopNetwork != null) 'nextHopNetwork': nextHopNetwork!,
        if (nextHopPeering != null) 'nextHopPeering': nextHopPeering!,
        if (nextHopVpnTunnel != null) 'nextHopVpnTunnel': nextHopVpnTunnel!,
        if (priority != null) 'priority': priority!,
        if (routeStatus != null) 'routeStatus': routeStatus!,
        if (routeType != null) 'routeType': routeType!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (tags != null) 'tags': tags!,
        if (warnings != null) 'warnings': warnings!,
      };
}

class RouteAsPath {
  /// The AS numbers of the AS Path.
  ///
  /// Output only.
  core.List<core.int>? asLists;

  /// The type of the AS Path, which can be one of the following values: -
  /// 'AS_SET': unordered set of autonomous systems that the route in has
  /// traversed - 'AS_SEQUENCE': ordered set of autonomous systems that the
  /// route has traversed - 'AS_CONFED_SEQUENCE': ordered set of Member
  /// Autonomous Systems in the local confederation that the route has traversed
  /// - 'AS_CONFED_SET': unordered set of Member Autonomous Systems in the local
  /// confederation that the route has traversed
  ///
  /// Output only.
  /// Possible string values are:
  /// - "AS_CONFED_SEQUENCE"
  /// - "AS_CONFED_SET"
  /// - "AS_SEQUENCE"
  /// - "AS_SET"
  core.String? pathSegmentType;

  RouteAsPath({
    this.asLists,
    this.pathSegmentType,
  });

  RouteAsPath.fromJson(core.Map json_)
      : this(
          asLists: json_.containsKey('asLists')
              ? (json_['asLists'] as core.List)
                  .map((value) => value as core.int)
                  .toList()
              : null,
          pathSegmentType: json_.containsKey('pathSegmentType')
              ? json_['pathSegmentType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (asLists != null) 'asLists': asLists!,
        if (pathSegmentType != null) 'pathSegmentType': pathSegmentType!,
      };
}

class RouteListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RouteListWarningData({
    this.key,
    this.value,
  });

  RouteListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RouteListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RouteListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RouteListWarning({
    this.code,
    this.data,
    this.message,
  });

  RouteListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RouteListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Route resources.
class RouteList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Route resources.
  core.List<Route>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RouteListWarning? warning;

  RouteList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RouteList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Route.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RouteListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Cloud Router resource.
///
/// For more information about Cloud Router, read the Cloud Router overview.
class Router {
  /// BGP information specific to this router.
  RouterBgp? bgp;

  /// BGP information that must be configured into the routing stack to
  /// establish BGP peering.
  ///
  /// This information must specify the peer ASN and either the interface name,
  /// IP address, or peer IP address. Please refer to RFC4273.
  core.List<RouterBgpPeer>? bgpPeers;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Indicates if a router is dedicated for use with encrypted VLAN attachments
  /// (interconnectAttachments).
  core.bool? encryptedInterconnectRouter;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Router interfaces.
  ///
  /// Each interface requires either one linked resource, (for example,
  /// linkedVpnTunnel), or IP address and IP address range (for example,
  /// ipRange), or both.
  core.List<RouterInterface>? interfaces;

  /// Type of resource.
  ///
  /// Always compute#router for routers.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// A list of NAT services created in this router.
  core.List<RouterNat>? nats;

  /// URI of the network to which this router belongs.
  core.String? network;

  /// URI of the region where the router resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  Router({
    this.bgp,
    this.bgpPeers,
    this.creationTimestamp,
    this.description,
    this.encryptedInterconnectRouter,
    this.id,
    this.interfaces,
    this.kind,
    this.name,
    this.nats,
    this.network,
    this.region,
    this.selfLink,
  });

  Router.fromJson(core.Map json_)
      : this(
          bgp: json_.containsKey('bgp')
              ? RouterBgp.fromJson(
                  json_['bgp'] as core.Map<core.String, core.dynamic>)
              : null,
          bgpPeers: json_.containsKey('bgpPeers')
              ? (json_['bgpPeers'] as core.List)
                  .map((value) => RouterBgpPeer.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          encryptedInterconnectRouter:
              json_.containsKey('encryptedInterconnectRouter')
                  ? json_['encryptedInterconnectRouter'] as core.bool
                  : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          interfaces: json_.containsKey('interfaces')
              ? (json_['interfaces'] as core.List)
                  .map((value) => RouterInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          nats: json_.containsKey('nats')
              ? (json_['nats'] as core.List)
                  .map((value) => RouterNat.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bgp != null) 'bgp': bgp!,
        if (bgpPeers != null) 'bgpPeers': bgpPeers!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (encryptedInterconnectRouter != null)
          'encryptedInterconnectRouter': encryptedInterconnectRouter!,
        if (id != null) 'id': id!,
        if (interfaces != null) 'interfaces': interfaces!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (nats != null) 'nats': nats!,
        if (network != null) 'network': network!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
      };
}

/// Description-tagged IP ranges for the router to advertise.
class RouterAdvertisedIpRange {
  /// User-specified description for the IP range.
  core.String? description;

  /// The IP range to advertise.
  ///
  /// The value must be a CIDR-formatted string.
  core.String? range;

  RouterAdvertisedIpRange({
    this.description,
    this.range,
  });

  RouterAdvertisedIpRange.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          range:
              json_.containsKey('range') ? json_['range'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (range != null) 'range': range!,
      };
}

class RouterAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RouterAggregatedListWarningData({
    this.key,
    this.value,
  });

  RouterAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RouterAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RouterAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RouterAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  RouterAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RouterAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of routers.
class RouterAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Router resources.
  core.Map<core.String, RoutersScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  RouterAggregatedListWarning? warning;

  RouterAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  RouterAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    RoutersScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? RouterAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class RouterBgp {
  /// User-specified flag to indicate which mode to use for advertisement.
  ///
  /// The options are DEFAULT or CUSTOM.
  /// Possible string values are:
  /// - "CUSTOM"
  /// - "DEFAULT"
  core.String? advertiseMode;

  /// User-specified list of prefix groups to advertise in custom mode.
  ///
  /// This field can only be populated if advertise_mode is CUSTOM and is
  /// advertised to all peers of the router. These groups will be advertised in
  /// addition to any specified prefixes. Leave this field blank to advertise no
  /// custom groups.
  core.List<core.String>? advertisedGroups;

  /// User-specified list of individual IP ranges to advertise in custom mode.
  ///
  /// This field can only be populated if advertise_mode is CUSTOM and is
  /// advertised to all peers of the router. These IP ranges will be advertised
  /// in addition to any specified groups. Leave this field blank to advertise
  /// no custom IP ranges.
  core.List<RouterAdvertisedIpRange>? advertisedIpRanges;

  /// Local BGP Autonomous System Number (ASN).
  ///
  /// Must be an RFC6996 private ASN, either 16-bit or 32-bit. The value will be
  /// fixed for this router resource. All VPN tunnels that link to this router
  /// will have the same local ASN.
  core.int? asn;

  /// The interval in seconds between BGP keepalive messages that are sent to
  /// the peer.
  ///
  /// Hold time is three times the interval at which keepalive messages are
  /// sent, and the hold time is the maximum number of seconds allowed to elapse
  /// between successive keepalive messages that BGP receives from a peer. BGP
  /// will use the smaller of either the local hold time value or the peer's
  /// hold time value as the hold time for the BGP connection between the two
  /// peers. If set, this value must be between 20 and 60. The default is 20.
  core.int? keepaliveInterval;

  RouterBgp({
    this.advertiseMode,
    this.advertisedGroups,
    this.advertisedIpRanges,
    this.asn,
    this.keepaliveInterval,
  });

  RouterBgp.fromJson(core.Map json_)
      : this(
          advertiseMode: json_.containsKey('advertiseMode')
              ? json_['advertiseMode'] as core.String
              : null,
          advertisedGroups: json_.containsKey('advertisedGroups')
              ? (json_['advertisedGroups'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          advertisedIpRanges: json_.containsKey('advertisedIpRanges')
              ? (json_['advertisedIpRanges'] as core.List)
                  .map((value) => RouterAdvertisedIpRange.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          asn: json_.containsKey('asn') ? json_['asn'] as core.int : null,
          keepaliveInterval: json_.containsKey('keepaliveInterval')
              ? json_['keepaliveInterval'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (advertiseMode != null) 'advertiseMode': advertiseMode!,
        if (advertisedGroups != null) 'advertisedGroups': advertisedGroups!,
        if (advertisedIpRanges != null)
          'advertisedIpRanges': advertisedIpRanges!,
        if (asn != null) 'asn': asn!,
        if (keepaliveInterval != null) 'keepaliveInterval': keepaliveInterval!,
      };
}

class RouterBgpPeer {
  /// User-specified flag to indicate which mode to use for advertisement.
  /// Possible string values are:
  /// - "CUSTOM"
  /// - "DEFAULT"
  core.String? advertiseMode;

  /// User-specified list of prefix groups to advertise in custom mode, which
  /// can take one of the following options: - ALL_SUBNETS: Advertises all
  /// available subnets, including peer VPC subnets.
  ///
  /// - ALL_VPC_SUBNETS: Advertises the router's own VPC subnets. Note that this
  /// field can only be populated if advertise_mode is CUSTOM and overrides the
  /// list defined for the router (in the "bgp" message). These groups are
  /// advertised in addition to any specified prefixes. Leave this field blank
  /// to advertise no custom groups.
  core.List<core.String>? advertisedGroups;

  /// User-specified list of individual IP ranges to advertise in custom mode.
  ///
  /// This field can only be populated if advertise_mode is CUSTOM and overrides
  /// the list defined for the router (in the "bgp" message). These IP ranges
  /// are advertised in addition to any specified groups. Leave this field blank
  /// to advertise no custom IP ranges.
  core.List<RouterAdvertisedIpRange>? advertisedIpRanges;

  /// The priority of routes advertised to this BGP peer.
  ///
  /// Where there is more than one matching route of maximum length, the routes
  /// with the lowest priority value win.
  core.int? advertisedRoutePriority;

  /// BFD configuration for the BGP peering.
  RouterBgpPeerBfd? bfd;

  /// The status of the BGP peer connection.
  ///
  /// If set to FALSE, any active session with the peer is terminated and all
  /// associated routing information is removed. If set to TRUE, the peer
  /// connection can be established with routing information. The default is
  /// TRUE.
  /// Possible string values are:
  /// - "FALSE"
  /// - "TRUE"
  core.String? enable;

  /// Enable IPv6 traffic over BGP Peer.
  ///
  /// If not specified, it is disabled by default.
  core.bool? enableIpv6;

  /// Name of the interface the BGP peer is associated with.
  core.String? interfaceName;

  /// IP address of the interface inside Google Cloud Platform.
  ///
  /// Only IPv4 is supported.
  core.String? ipAddress;

  /// IPv6 address of the interface inside Google Cloud Platform.
  core.String? ipv6NexthopAddress;

  /// The resource that configures and manages this BGP peer.
  ///
  /// - MANAGED_BY_USER is the default value and can be managed by you or other
  /// users - MANAGED_BY_ATTACHMENT is a BGP peer that is configured and managed
  /// by Cloud Interconnect, specifically by an InterconnectAttachment of type
  /// PARTNER. Google automatically creates, updates, and deletes this type of
  /// BGP peer when the PARTNER InterconnectAttachment is created, updated, or
  /// deleted.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "MANAGED_BY_ATTACHMENT" : The BGP peer is automatically created for
  /// PARTNER type InterconnectAttachment; Google will automatically
  /// create/delete this BGP peer when the PARTNER InterconnectAttachment is
  /// created/deleted, and Google will update the ipAddress and peerIpAddress
  /// when the PARTNER InterconnectAttachment is provisioned. This type of BGP
  /// peer cannot be created or deleted, but can be modified for all fields
  /// except for name, ipAddress and peerIpAddress.
  /// - "MANAGED_BY_USER" : Default value, the BGP peer is manually created and
  /// managed by user.
  core.String? managementType;

  /// Name of this BGP peer.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Peer BGP Autonomous System Number (ASN).
  ///
  /// Each BGP interface may use a different value.
  core.int? peerAsn;

  /// IP address of the BGP interface outside Google Cloud Platform.
  ///
  /// Only IPv4 is supported.
  core.String? peerIpAddress;

  /// IPv6 address of the BGP interface outside Google Cloud Platform.
  core.String? peerIpv6NexthopAddress;

  /// URI of the VM instance that is used as third-party router appliances such
  /// as Next Gen Firewalls, Virtual Routers, or Router Appliances.
  ///
  /// The VM instance must be located in zones contained in the same region as
  /// this Cloud Router. The VM instance is the peer side of the BGP session.
  core.String? routerApplianceInstance;

  RouterBgpPeer({
    this.advertiseMode,
    this.advertisedGroups,
    this.advertisedIpRanges,
    this.advertisedRoutePriority,
    this.bfd,
    this.enable,
    this.enableIpv6,
    this.interfaceName,
    this.ipAddress,
    this.ipv6NexthopAddress,
    this.managementType,
    this.name,
    this.peerAsn,
    this.peerIpAddress,
    this.peerIpv6NexthopAddress,
    this.routerApplianceInstance,
  });

  RouterBgpPeer.fromJson(core.Map json_)
      : this(
          advertiseMode: json_.containsKey('advertiseMode')
              ? json_['advertiseMode'] as core.String
              : null,
          advertisedGroups: json_.containsKey('advertisedGroups')
              ? (json_['advertisedGroups'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          advertisedIpRanges: json_.containsKey('advertisedIpRanges')
              ? (json_['advertisedIpRanges'] as core.List)
                  .map((value) => RouterAdvertisedIpRange.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          advertisedRoutePriority: json_.containsKey('advertisedRoutePriority')
              ? json_['advertisedRoutePriority'] as core.int
              : null,
          bfd: json_.containsKey('bfd')
              ? RouterBgpPeerBfd.fromJson(
                  json_['bfd'] as core.Map<core.String, core.dynamic>)
              : null,
          enable: json_.containsKey('enable')
              ? json_['enable'] as core.String
              : null,
          enableIpv6: json_.containsKey('enableIpv6')
              ? json_['enableIpv6'] as core.bool
              : null,
          interfaceName: json_.containsKey('interfaceName')
              ? json_['interfaceName'] as core.String
              : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
          ipv6NexthopAddress: json_.containsKey('ipv6NexthopAddress')
              ? json_['ipv6NexthopAddress'] as core.String
              : null,
          managementType: json_.containsKey('managementType')
              ? json_['managementType'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          peerAsn: json_.containsKey('peerAsn')
              ? json_['peerAsn'] as core.int
              : null,
          peerIpAddress: json_.containsKey('peerIpAddress')
              ? json_['peerIpAddress'] as core.String
              : null,
          peerIpv6NexthopAddress: json_.containsKey('peerIpv6NexthopAddress')
              ? json_['peerIpv6NexthopAddress'] as core.String
              : null,
          routerApplianceInstance: json_.containsKey('routerApplianceInstance')
              ? json_['routerApplianceInstance'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (advertiseMode != null) 'advertiseMode': advertiseMode!,
        if (advertisedGroups != null) 'advertisedGroups': advertisedGroups!,
        if (advertisedIpRanges != null)
          'advertisedIpRanges': advertisedIpRanges!,
        if (advertisedRoutePriority != null)
          'advertisedRoutePriority': advertisedRoutePriority!,
        if (bfd != null) 'bfd': bfd!,
        if (enable != null) 'enable': enable!,
        if (enableIpv6 != null) 'enableIpv6': enableIpv6!,
        if (interfaceName != null) 'interfaceName': interfaceName!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
        if (ipv6NexthopAddress != null)
          'ipv6NexthopAddress': ipv6NexthopAddress!,
        if (managementType != null) 'managementType': managementType!,
        if (name != null) 'name': name!,
        if (peerAsn != null) 'peerAsn': peerAsn!,
        if (peerIpAddress != null) 'peerIpAddress': peerIpAddress!,
        if (peerIpv6NexthopAddress != null)
          'peerIpv6NexthopAddress': peerIpv6NexthopAddress!,
        if (routerApplianceInstance != null)
          'routerApplianceInstance': routerApplianceInstance!,
      };
}

class RouterBgpPeerBfd {
  /// The minimum interval, in milliseconds, between BFD control packets
  /// received from the peer router.
  ///
  /// The actual value is negotiated between the two routers and is equal to the
  /// greater of this value and the transmit interval of the other router. If
  /// set, this value must be between 1000 and 30000. The default is 1000.
  core.int? minReceiveInterval;

  /// The minimum interval, in milliseconds, between BFD control packets
  /// transmitted to the peer router.
  ///
  /// The actual value is negotiated between the two routers and is equal to the
  /// greater of this value and the corresponding receive interval of the other
  /// router. If set, this value must be between 1000 and 30000. The default is
  /// 1000.
  core.int? minTransmitInterval;

  /// The number of consecutive BFD packets that must be missed before BFD
  /// declares that a peer is unavailable.
  ///
  /// If set, the value must be a value between 5 and 16. The default is 5.
  core.int? multiplier;

  /// The BFD session initialization mode for this BGP peer.
  ///
  /// If set to ACTIVE, the Cloud Router will initiate the BFD session for this
  /// BGP peer. If set to PASSIVE, the Cloud Router will wait for the peer
  /// router to initiate the BFD session for this BGP peer. If set to DISABLED,
  /// BFD is disabled for this BGP peer. The default is DISABLED.
  /// Possible string values are:
  /// - "ACTIVE"
  /// - "DISABLED"
  /// - "PASSIVE"
  core.String? sessionInitializationMode;

  RouterBgpPeerBfd({
    this.minReceiveInterval,
    this.minTransmitInterval,
    this.multiplier,
    this.sessionInitializationMode,
  });

  RouterBgpPeerBfd.fromJson(core.Map json_)
      : this(
          minReceiveInterval: json_.containsKey('minReceiveInterval')
              ? json_['minReceiveInterval'] as core.int
              : null,
          minTransmitInterval: json_.containsKey('minTransmitInterval')
              ? json_['minTransmitInterval'] as core.int
              : null,
          multiplier: json_.containsKey('multiplier')
              ? json_['multiplier'] as core.int
              : null,
          sessionInitializationMode:
              json_.containsKey('sessionInitializationMode')
                  ? json_['sessionInitializationMode'] as core.String
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (minReceiveInterval != null)
          'minReceiveInterval': minReceiveInterval!,
        if (minTransmitInterval != null)
          'minTransmitInterval': minTransmitInterval!,
        if (multiplier != null) 'multiplier': multiplier!,
        if (sessionInitializationMode != null)
          'sessionInitializationMode': sessionInitializationMode!,
      };
}

class RouterInterface {
  /// IP address and range of the interface.
  ///
  /// The IP range must be in the RFC3927 link-local IP address space. The value
  /// must be a CIDR-formatted string, for example: 169.254.0.1/30. NOTE: Do not
  /// truncate the address as it represents the IP address of the interface.
  core.String? ipRange;

  /// URI of the linked Interconnect attachment.
  ///
  /// It must be in the same region as the router. Each interface can have one
  /// linked resource, which can be a VPN tunnel, an Interconnect attachment, or
  /// a virtual machine instance.
  core.String? linkedInterconnectAttachment;

  /// URI of the linked VPN tunnel, which must be in the same region as the
  /// router.
  ///
  /// Each interface can have one linked resource, which can be a VPN tunnel, an
  /// Interconnect attachment, or a virtual machine instance.
  core.String? linkedVpnTunnel;

  /// The resource that configures and manages this interface.
  ///
  /// - MANAGED_BY_USER is the default value and can be managed directly by
  /// users. - MANAGED_BY_ATTACHMENT is an interface that is configured and
  /// managed by Cloud Interconnect, specifically, by an InterconnectAttachment
  /// of type PARTNER. Google automatically creates, updates, and deletes this
  /// type of interface when the PARTNER InterconnectAttachment is created,
  /// updated, or deleted.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "MANAGED_BY_ATTACHMENT" : The interface is automatically created for
  /// PARTNER type InterconnectAttachment, Google will automatically
  /// create/update/delete this interface when the PARTNER
  /// InterconnectAttachment is created/provisioned/deleted. This type of
  /// interface cannot be manually managed by user.
  /// - "MANAGED_BY_USER" : Default value, the interface is manually created and
  /// managed by user.
  core.String? managementType;

  /// Name of this interface entry.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// The regional private internal IP address that is used to establish BGP
  /// sessions to a VM instance acting as a third-party Router Appliance, such
  /// as a Next Gen Firewall, a Virtual Router, or an SD-WAN VM.
  core.String? privateIpAddress;

  /// Name of the interface that will be redundant with the current interface
  /// you are creating.
  ///
  /// The redundantInterface must belong to the same Cloud Router as the
  /// interface here. To establish the BGP session to a Router Appliance VM, you
  /// must create two BGP peers. The two BGP peers must be attached to two
  /// separate interfaces that are redundant with each other. The
  /// redundant_interface must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the redundant_interface must be 1-63 characters long and
  /// match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the
  /// first character must be a lowercase letter, and all following characters
  /// must be a dash, lowercase letter, or digit, except the last character,
  /// which cannot be a dash.
  core.String? redundantInterface;

  /// The URI of the subnetwork resource that this interface belongs to, which
  /// must be in the same region as the Cloud Router.
  ///
  /// When you establish a BGP session to a VM instance using this interface,
  /// the VM instance must belong to the same subnetwork as the subnetwork
  /// specified here.
  core.String? subnetwork;

  RouterInterface({
    this.ipRange,
    this.linkedInterconnectAttachment,
    this.linkedVpnTunnel,
    this.managementType,
    this.name,
    this.privateIpAddress,
    this.redundantInterface,
    this.subnetwork,
  });

  RouterInterface.fromJson(core.Map json_)
      : this(
          ipRange: json_.containsKey('ipRange')
              ? json_['ipRange'] as core.String
              : null,
          linkedInterconnectAttachment:
              json_.containsKey('linkedInterconnectAttachment')
                  ? json_['linkedInterconnectAttachment'] as core.String
                  : null,
          linkedVpnTunnel: json_.containsKey('linkedVpnTunnel')
              ? json_['linkedVpnTunnel'] as core.String
              : null,
          managementType: json_.containsKey('managementType')
              ? json_['managementType'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          privateIpAddress: json_.containsKey('privateIpAddress')
              ? json_['privateIpAddress'] as core.String
              : null,
          redundantInterface: json_.containsKey('redundantInterface')
              ? json_['redundantInterface'] as core.String
              : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipRange != null) 'ipRange': ipRange!,
        if (linkedInterconnectAttachment != null)
          'linkedInterconnectAttachment': linkedInterconnectAttachment!,
        if (linkedVpnTunnel != null) 'linkedVpnTunnel': linkedVpnTunnel!,
        if (managementType != null) 'managementType': managementType!,
        if (name != null) 'name': name!,
        if (privateIpAddress != null) 'privateIpAddress': privateIpAddress!,
        if (redundantInterface != null)
          'redundantInterface': redundantInterface!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
      };
}

class RouterListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RouterListWarningData({
    this.key,
    this.value,
  });

  RouterListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class RouterListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RouterListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RouterListWarning({
    this.code,
    this.data,
    this.message,
  });

  RouterListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RouterListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Router resources.
class RouterList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Router resources.
  core.List<Router>? items;

  /// Type of resource.
  ///
  /// Always compute#router for routers.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  RouterListWarning? warning;

  RouterList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  RouterList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Router.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? RouterListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Nat resource.
///
/// It enables the VMs within the specified subnetworks to access Internet
/// without external IP addresses. It specifies a list of subnetworks (and the
/// ranges within) that want to use NAT. Customers can also provide the external
/// IPs that would be used for NAT. GCP would auto-allocate ephemeral IPs if no
/// external IPs are provided.
class RouterNat {
  /// A list of URLs of the IP resources to be drained.
  ///
  /// These IPs must be valid static external IPs that have been assigned to the
  /// NAT. These IPs should be used for updating/patching a NAT only.
  core.List<core.String>? drainNatIps;

  /// Enable Dynamic Port Allocation.
  ///
  /// If not specified, it is disabled by default. If set to true, - Dynamic
  /// Port Allocation will be enabled on this NAT config. -
  /// enableEndpointIndependentMapping cannot be set to true. - If minPorts is
  /// set, minPortsPerVm must be set to a power of two greater than or equal to
  /// 32. If minPortsPerVm is not set, a minimum of 32 ports will be allocated
  /// to a VM from this NAT config.
  core.bool? enableDynamicPortAllocation;
  core.bool? enableEndpointIndependentMapping;

  /// List of NAT-ted endpoint types supported by the Nat Gateway.
  ///
  /// If the list is empty, then it will be equivalent to include
  /// ENDPOINT_TYPE_VM
  core.List<core.String>? endpointTypes;

  /// Timeout (in seconds) for ICMP connections.
  ///
  /// Defaults to 30s if not set.
  core.int? icmpIdleTimeoutSec;

  /// Configure logging on this NAT.
  RouterNatLogConfig? logConfig;

  /// Maximum number of ports allocated to a VM from this NAT config when
  /// Dynamic Port Allocation is enabled.
  ///
  /// If Dynamic Port Allocation is not enabled, this field has no effect. If
  /// Dynamic Port Allocation is enabled, and this field is set, it must be set
  /// to a power of two greater than minPortsPerVm, or 64 if minPortsPerVm is
  /// not set. If Dynamic Port Allocation is enabled and this field is not set,
  /// a maximum of 65536 ports will be allocated to a VM from this NAT config.
  core.int? maxPortsPerVm;

  /// Minimum number of ports allocated to a VM from this NAT config.
  ///
  /// If not set, a default number of ports is allocated to a VM. This is
  /// rounded up to the nearest power of 2. For example, if the value of this
  /// field is 50, at least 64 ports are allocated to a VM.
  core.int? minPortsPerVm;

  /// Unique name of this Nat service.
  ///
  /// The name must be 1-63 characters long and comply with RFC1035.
  core.String? name;

  /// Specify the NatIpAllocateOption, which can take one of the following
  /// values: - MANUAL_ONLY: Uses only Nat IP addresses provided by customers.
  ///
  /// When there are not enough specified Nat IPs, the Nat service fails for new
  /// VMs. - AUTO_ONLY: Nat IPs are allocated by Google Cloud Platform;
  /// customers can't specify any Nat IPs. When choosing AUTO_ONLY, then nat_ip
  /// should be empty.
  /// Possible string values are:
  /// - "AUTO_ONLY" : Nat IPs are allocated by GCP; customers can not specify
  /// any Nat IPs.
  /// - "MANUAL_ONLY" : Only use Nat IPs provided by customers. When specified
  /// Nat IPs are not enough then the Nat service fails for new VMs.
  core.String? natIpAllocateOption;

  /// A list of URLs of the IP resources used for this Nat service.
  ///
  /// These IP addresses must be valid static external IP addresses assigned to
  /// the project.
  core.List<core.String>? natIps;

  /// A list of rules associated with this NAT.
  core.List<RouterNatRule>? rules;

  /// Specify the Nat option, which can take one of the following values: -
  /// ALL_SUBNETWORKS_ALL_IP_RANGES: All of the IP ranges in every Subnetwork
  /// are allowed to Nat.
  ///
  /// - ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES: All of the primary IP ranges in
  /// every Subnetwork are allowed to Nat. - LIST_OF_SUBNETWORKS: A list of
  /// Subnetworks are allowed to Nat (specified in the field subnetwork below)
  /// The default is SUBNETWORK_IP_RANGE_TO_NAT_OPTION_UNSPECIFIED. Note that if
  /// this field contains ALL_SUBNETWORKS_ALL_IP_RANGES or
  /// ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES, then there should not be any other
  /// Router.Nat section in any Router for this network in this region.
  /// Possible string values are:
  /// - "ALL_SUBNETWORKS_ALL_IP_RANGES" : All the IP ranges in every Subnetwork
  /// are allowed to Nat.
  /// - "ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES" : All the primary IP ranges in
  /// every Subnetwork are allowed to Nat.
  /// - "LIST_OF_SUBNETWORKS" : A list of Subnetworks are allowed to Nat
  /// (specified in the field subnetwork below)
  core.String? sourceSubnetworkIpRangesToNat;

  /// A list of Subnetwork resources whose traffic should be translated by NAT
  /// Gateway.
  ///
  /// It is used only when LIST_OF_SUBNETWORKS is selected for the
  /// SubnetworkIpRangeToNatOption above.
  core.List<RouterNatSubnetworkToNat>? subnetworks;

  /// Timeout (in seconds) for TCP established connections.
  ///
  /// Defaults to 1200s if not set.
  core.int? tcpEstablishedIdleTimeoutSec;

  /// Timeout (in seconds) for TCP connections that are in TIME_WAIT state.
  ///
  /// Defaults to 120s if not set.
  core.int? tcpTimeWaitTimeoutSec;

  /// Timeout (in seconds) for TCP transitory connections.
  ///
  /// Defaults to 30s if not set.
  core.int? tcpTransitoryIdleTimeoutSec;

  /// Timeout (in seconds) for UDP connections.
  ///
  /// Defaults to 30s if not set.
  core.int? udpIdleTimeoutSec;

  RouterNat({
    this.drainNatIps,
    this.enableDynamicPortAllocation,
    this.enableEndpointIndependentMapping,
    this.endpointTypes,
    this.icmpIdleTimeoutSec,
    this.logConfig,
    this.maxPortsPerVm,
    this.minPortsPerVm,
    this.name,
    this.natIpAllocateOption,
    this.natIps,
    this.rules,
    this.sourceSubnetworkIpRangesToNat,
    this.subnetworks,
    this.tcpEstablishedIdleTimeoutSec,
    this.tcpTimeWaitTimeoutSec,
    this.tcpTransitoryIdleTimeoutSec,
    this.udpIdleTimeoutSec,
  });

  RouterNat.fromJson(core.Map json_)
      : this(
          drainNatIps: json_.containsKey('drainNatIps')
              ? (json_['drainNatIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          enableDynamicPortAllocation:
              json_.containsKey('enableDynamicPortAllocation')
                  ? json_['enableDynamicPortAllocation'] as core.bool
                  : null,
          enableEndpointIndependentMapping:
              json_.containsKey('enableEndpointIndependentMapping')
                  ? json_['enableEndpointIndependentMapping'] as core.bool
                  : null,
          endpointTypes: json_.containsKey('endpointTypes')
              ? (json_['endpointTypes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          icmpIdleTimeoutSec: json_.containsKey('icmpIdleTimeoutSec')
              ? json_['icmpIdleTimeoutSec'] as core.int
              : null,
          logConfig: json_.containsKey('logConfig')
              ? RouterNatLogConfig.fromJson(
                  json_['logConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          maxPortsPerVm: json_.containsKey('maxPortsPerVm')
              ? json_['maxPortsPerVm'] as core.int
              : null,
          minPortsPerVm: json_.containsKey('minPortsPerVm')
              ? json_['minPortsPerVm'] as core.int
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          natIpAllocateOption: json_.containsKey('natIpAllocateOption')
              ? json_['natIpAllocateOption'] as core.String
              : null,
          natIps: json_.containsKey('natIps')
              ? (json_['natIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => RouterNatRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          sourceSubnetworkIpRangesToNat:
              json_.containsKey('sourceSubnetworkIpRangesToNat')
                  ? json_['sourceSubnetworkIpRangesToNat'] as core.String
                  : null,
          subnetworks: json_.containsKey('subnetworks')
              ? (json_['subnetworks'] as core.List)
                  .map((value) => RouterNatSubnetworkToNat.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          tcpEstablishedIdleTimeoutSec:
              json_.containsKey('tcpEstablishedIdleTimeoutSec')
                  ? json_['tcpEstablishedIdleTimeoutSec'] as core.int
                  : null,
          tcpTimeWaitTimeoutSec: json_.containsKey('tcpTimeWaitTimeoutSec')
              ? json_['tcpTimeWaitTimeoutSec'] as core.int
              : null,
          tcpTransitoryIdleTimeoutSec:
              json_.containsKey('tcpTransitoryIdleTimeoutSec')
                  ? json_['tcpTransitoryIdleTimeoutSec'] as core.int
                  : null,
          udpIdleTimeoutSec: json_.containsKey('udpIdleTimeoutSec')
              ? json_['udpIdleTimeoutSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (drainNatIps != null) 'drainNatIps': drainNatIps!,
        if (enableDynamicPortAllocation != null)
          'enableDynamicPortAllocation': enableDynamicPortAllocation!,
        if (enableEndpointIndependentMapping != null)
          'enableEndpointIndependentMapping': enableEndpointIndependentMapping!,
        if (endpointTypes != null) 'endpointTypes': endpointTypes!,
        if (icmpIdleTimeoutSec != null)
          'icmpIdleTimeoutSec': icmpIdleTimeoutSec!,
        if (logConfig != null) 'logConfig': logConfig!,
        if (maxPortsPerVm != null) 'maxPortsPerVm': maxPortsPerVm!,
        if (minPortsPerVm != null) 'minPortsPerVm': minPortsPerVm!,
        if (name != null) 'name': name!,
        if (natIpAllocateOption != null)
          'natIpAllocateOption': natIpAllocateOption!,
        if (natIps != null) 'natIps': natIps!,
        if (rules != null) 'rules': rules!,
        if (sourceSubnetworkIpRangesToNat != null)
          'sourceSubnetworkIpRangesToNat': sourceSubnetworkIpRangesToNat!,
        if (subnetworks != null) 'subnetworks': subnetworks!,
        if (tcpEstablishedIdleTimeoutSec != null)
          'tcpEstablishedIdleTimeoutSec': tcpEstablishedIdleTimeoutSec!,
        if (tcpTimeWaitTimeoutSec != null)
          'tcpTimeWaitTimeoutSec': tcpTimeWaitTimeoutSec!,
        if (tcpTransitoryIdleTimeoutSec != null)
          'tcpTransitoryIdleTimeoutSec': tcpTransitoryIdleTimeoutSec!,
        if (udpIdleTimeoutSec != null) 'udpIdleTimeoutSec': udpIdleTimeoutSec!,
      };
}

/// Configuration of logging on a NAT.
class RouterNatLogConfig {
  /// Indicates whether or not to export logs.
  ///
  /// This is false by default.
  core.bool? enable;

  /// Specify the desired filtering of logs on this NAT.
  ///
  /// If unspecified, logs are exported for all connections handled by this NAT.
  /// This option can take one of the following values: - ERRORS_ONLY: Export
  /// logs only for connection failures. - TRANSLATIONS_ONLY: Export logs only
  /// for successful connections. - ALL: Export logs for all connections,
  /// successful and unsuccessful.
  /// Possible string values are:
  /// - "ALL" : Export logs for all (successful and unsuccessful) connections.
  /// - "ERRORS_ONLY" : Export logs for connection failures only.
  /// - "TRANSLATIONS_ONLY" : Export logs for successful connections only.
  core.String? filter;

  RouterNatLogConfig({
    this.enable,
    this.filter,
  });

  RouterNatLogConfig.fromJson(core.Map json_)
      : this(
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
          filter: json_.containsKey('filter')
              ? json_['filter'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enable != null) 'enable': enable!,
        if (filter != null) 'filter': filter!,
      };
}

class RouterNatRule {
  /// The action to be enforced for traffic that matches this rule.
  RouterNatRuleAction? action;

  /// An optional description of this rule.
  core.String? description;

  /// CEL expression that specifies the match condition that egress traffic from
  /// a VM is evaluated against.
  ///
  /// If it evaluates to true, the corresponding `action` is enforced. The
  /// following examples are valid match expressions for public NAT:
  /// "inIpRange(destination.ip, '1.1.0.0/16') || inIpRange(destination.ip,
  /// '2.2.0.0/16')" "destination.ip == '1.1.0.1' || destination.ip ==
  /// '8.8.8.8'" The following example is a valid match expression for private
  /// NAT: "nexthop.hub ==
  /// 'https://networkconnectivity.googleapis.com/v1alpha1/projects/my-project/global/hub/hub-1'"
  core.String? match;

  /// An integer uniquely identifying a rule in the list.
  ///
  /// The rule number must be a positive value between 0 and 65000, and must be
  /// unique among rules within a NAT.
  core.int? ruleNumber;

  RouterNatRule({
    this.action,
    this.description,
    this.match,
    this.ruleNumber,
  });

  RouterNatRule.fromJson(core.Map json_)
      : this(
          action: json_.containsKey('action')
              ? RouterNatRuleAction.fromJson(
                  json_['action'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          match:
              json_.containsKey('match') ? json_['match'] as core.String : null,
          ruleNumber: json_.containsKey('ruleNumber')
              ? json_['ruleNumber'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (action != null) 'action': action!,
        if (description != null) 'description': description!,
        if (match != null) 'match': match!,
        if (ruleNumber != null) 'ruleNumber': ruleNumber!,
      };
}

class RouterNatRuleAction {
  /// A list of URLs of the IP resources used for this NAT rule.
  ///
  /// These IP addresses must be valid static external IP addresses assigned to
  /// the project. This field is used for public NAT.
  core.List<core.String>? sourceNatActiveIps;

  /// A list of URLs of the IP resources to be drained.
  ///
  /// These IPs must be valid static external IPs that have been assigned to the
  /// NAT. These IPs should be used for updating/patching a NAT rule only. This
  /// field is used for public NAT.
  core.List<core.String>? sourceNatDrainIps;

  RouterNatRuleAction({
    this.sourceNatActiveIps,
    this.sourceNatDrainIps,
  });

  RouterNatRuleAction.fromJson(core.Map json_)
      : this(
          sourceNatActiveIps: json_.containsKey('sourceNatActiveIps')
              ? (json_['sourceNatActiveIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sourceNatDrainIps: json_.containsKey('sourceNatDrainIps')
              ? (json_['sourceNatDrainIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sourceNatActiveIps != null)
          'sourceNatActiveIps': sourceNatActiveIps!,
        if (sourceNatDrainIps != null) 'sourceNatDrainIps': sourceNatDrainIps!,
      };
}

/// Defines the IP ranges that want to use NAT for a subnetwork.
class RouterNatSubnetworkToNat {
  /// URL for the subnetwork resource that will use NAT.
  core.String? name;

  /// A list of the secondary ranges of the Subnetwork that are allowed to use
  /// NAT.
  ///
  /// This can be populated only if "LIST_OF_SECONDARY_IP_RANGES" is one of the
  /// values in source_ip_ranges_to_nat.
  core.List<core.String>? secondaryIpRangeNames;

  /// Specify the options for NAT ranges in the Subnetwork.
  ///
  /// All options of a single value are valid except
  /// NAT_IP_RANGE_OPTION_UNSPECIFIED. The only valid option with multiple
  /// values is: \["PRIMARY_IP_RANGE", "LIST_OF_SECONDARY_IP_RANGES"\] Default:
  /// \[ALL_IP_RANGES\]
  core.List<core.String>? sourceIpRangesToNat;

  RouterNatSubnetworkToNat({
    this.name,
    this.secondaryIpRangeNames,
    this.sourceIpRangesToNat,
  });

  RouterNatSubnetworkToNat.fromJson(core.Map json_)
      : this(
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          secondaryIpRangeNames: json_.containsKey('secondaryIpRangeNames')
              ? (json_['secondaryIpRangeNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sourceIpRangesToNat: json_.containsKey('sourceIpRangesToNat')
              ? (json_['sourceIpRangesToNat'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (name != null) 'name': name!,
        if (secondaryIpRangeNames != null)
          'secondaryIpRangeNames': secondaryIpRangeNames!,
        if (sourceIpRangesToNat != null)
          'sourceIpRangesToNat': sourceIpRangesToNat!,
      };
}

class RouterStatus {
  /// Best routes for this router's network.
  core.List<Route>? bestRoutes;

  /// Best routes learned by this router.
  core.List<Route>? bestRoutesForRouter;
  core.List<RouterStatusBgpPeerStatus>? bgpPeerStatus;
  core.List<RouterStatusNatStatus>? natStatus;

  /// URI of the network to which this router belongs.
  core.String? network;

  RouterStatus({
    this.bestRoutes,
    this.bestRoutesForRouter,
    this.bgpPeerStatus,
    this.natStatus,
    this.network,
  });

  RouterStatus.fromJson(core.Map json_)
      : this(
          bestRoutes: json_.containsKey('bestRoutes')
              ? (json_['bestRoutes'] as core.List)
                  .map((value) => Route.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          bestRoutesForRouter: json_.containsKey('bestRoutesForRouter')
              ? (json_['bestRoutesForRouter'] as core.List)
                  .map((value) => Route.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          bgpPeerStatus: json_.containsKey('bgpPeerStatus')
              ? (json_['bgpPeerStatus'] as core.List)
                  .map((value) => RouterStatusBgpPeerStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          natStatus: json_.containsKey('natStatus')
              ? (json_['natStatus'] as core.List)
                  .map((value) => RouterStatusNatStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bestRoutes != null) 'bestRoutes': bestRoutes!,
        if (bestRoutesForRouter != null)
          'bestRoutesForRouter': bestRoutesForRouter!,
        if (bgpPeerStatus != null) 'bgpPeerStatus': bgpPeerStatus!,
        if (natStatus != null) 'natStatus': natStatus!,
        if (network != null) 'network': network!,
      };
}

class RouterStatusBgpPeerStatus {
  /// Routes that were advertised to the remote BGP peer
  core.List<Route>? advertisedRoutes;
  BfdStatus? bfdStatus;

  /// IP address of the local BGP interface.
  core.String? ipAddress;

  /// URL of the VPN tunnel that this BGP peer controls.
  core.String? linkedVpnTunnel;

  /// Name of this BGP peer.
  ///
  /// Unique within the Routers resource.
  core.String? name;

  /// Number of routes learned from the remote BGP Peer.
  core.int? numLearnedRoutes;

  /// IP address of the remote BGP interface.
  core.String? peerIpAddress;

  /// URI of the VM instance that is used as third-party router appliances such
  /// as Next Gen Firewalls, Virtual Routers, or Router Appliances.
  ///
  /// The VM instance is the peer side of the BGP session.
  ///
  /// Output only.
  core.String? routerApplianceInstance;

  /// The state of the BGP session.
  ///
  /// For a list of possible values for this field, see BGP session states.
  core.String? state;

  /// Status of the BGP peer: {UP, DOWN}
  /// Possible string values are:
  /// - "DOWN"
  /// - "UNKNOWN"
  /// - "UP"
  core.String? status;

  /// Time this session has been up.
  ///
  /// Format: 14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
  core.String? uptime;

  /// Time this session has been up, in seconds.
  ///
  /// Format: 145
  core.String? uptimeSeconds;

  RouterStatusBgpPeerStatus({
    this.advertisedRoutes,
    this.bfdStatus,
    this.ipAddress,
    this.linkedVpnTunnel,
    this.name,
    this.numLearnedRoutes,
    this.peerIpAddress,
    this.routerApplianceInstance,
    this.state,
    this.status,
    this.uptime,
    this.uptimeSeconds,
  });

  RouterStatusBgpPeerStatus.fromJson(core.Map json_)
      : this(
          advertisedRoutes: json_.containsKey('advertisedRoutes')
              ? (json_['advertisedRoutes'] as core.List)
                  .map((value) => Route.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          bfdStatus: json_.containsKey('bfdStatus')
              ? BfdStatus.fromJson(
                  json_['bfdStatus'] as core.Map<core.String, core.dynamic>)
              : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
          linkedVpnTunnel: json_.containsKey('linkedVpnTunnel')
              ? json_['linkedVpnTunnel'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          numLearnedRoutes: json_.containsKey('numLearnedRoutes')
              ? json_['numLearnedRoutes'] as core.int
              : null,
          peerIpAddress: json_.containsKey('peerIpAddress')
              ? json_['peerIpAddress'] as core.String
              : null,
          routerApplianceInstance: json_.containsKey('routerApplianceInstance')
              ? json_['routerApplianceInstance'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          uptime: json_.containsKey('uptime')
              ? json_['uptime'] as core.String
              : null,
          uptimeSeconds: json_.containsKey('uptimeSeconds')
              ? json_['uptimeSeconds'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (advertisedRoutes != null) 'advertisedRoutes': advertisedRoutes!,
        if (bfdStatus != null) 'bfdStatus': bfdStatus!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
        if (linkedVpnTunnel != null) 'linkedVpnTunnel': linkedVpnTunnel!,
        if (name != null) 'name': name!,
        if (numLearnedRoutes != null) 'numLearnedRoutes': numLearnedRoutes!,
        if (peerIpAddress != null) 'peerIpAddress': peerIpAddress!,
        if (routerApplianceInstance != null)
          'routerApplianceInstance': routerApplianceInstance!,
        if (state != null) 'state': state!,
        if (status != null) 'status': status!,
        if (uptime != null) 'uptime': uptime!,
        if (uptimeSeconds != null) 'uptimeSeconds': uptimeSeconds!,
      };
}

/// Status of a NAT contained in this router.
class RouterStatusNatStatus {
  /// A list of IPs auto-allocated for NAT.
  ///
  /// Example: \["1.1.1.1", "129.2.16.89"\]
  core.List<core.String>? autoAllocatedNatIps;

  /// A list of IPs auto-allocated for NAT that are in drain mode.
  ///
  /// Example: \["1.1.1.1", "179.12.26.133"\].
  core.List<core.String>? drainAutoAllocatedNatIps;

  /// A list of IPs user-allocated for NAT that are in drain mode.
  ///
  /// Example: \["1.1.1.1", "179.12.26.133"\].
  core.List<core.String>? drainUserAllocatedNatIps;

  /// The number of extra IPs to allocate.
  ///
  /// This will be greater than 0 only if user-specified IPs are NOT enough to
  /// allow all configured VMs to use NAT. This value is meaningful only when
  /// auto-allocation of NAT IPs is *not* used.
  core.int? minExtraNatIpsNeeded;

  /// Unique name of this NAT.
  core.String? name;

  /// Number of VM endpoints (i.e., Nics) that can use NAT.
  core.int? numVmEndpointsWithNatMappings;

  /// Status of rules in this NAT.
  core.List<RouterStatusNatStatusNatRuleStatus>? ruleStatus;

  /// A list of fully qualified URLs of reserved IP address resources.
  core.List<core.String>? userAllocatedNatIpResources;

  /// A list of IPs user-allocated for NAT.
  ///
  /// They will be raw IP strings like "179.12.26.133".
  core.List<core.String>? userAllocatedNatIps;

  RouterStatusNatStatus({
    this.autoAllocatedNatIps,
    this.drainAutoAllocatedNatIps,
    this.drainUserAllocatedNatIps,
    this.minExtraNatIpsNeeded,
    this.name,
    this.numVmEndpointsWithNatMappings,
    this.ruleStatus,
    this.userAllocatedNatIpResources,
    this.userAllocatedNatIps,
  });

  RouterStatusNatStatus.fromJson(core.Map json_)
      : this(
          autoAllocatedNatIps: json_.containsKey('autoAllocatedNatIps')
              ? (json_['autoAllocatedNatIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          drainAutoAllocatedNatIps:
              json_.containsKey('drainAutoAllocatedNatIps')
                  ? (json_['drainAutoAllocatedNatIps'] as core.List)
                      .map((value) => value as core.String)
                      .toList()
                  : null,
          drainUserAllocatedNatIps:
              json_.containsKey('drainUserAllocatedNatIps')
                  ? (json_['drainUserAllocatedNatIps'] as core.List)
                      .map((value) => value as core.String)
                      .toList()
                  : null,
          minExtraNatIpsNeeded: json_.containsKey('minExtraNatIpsNeeded')
              ? json_['minExtraNatIpsNeeded'] as core.int
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          numVmEndpointsWithNatMappings:
              json_.containsKey('numVmEndpointsWithNatMappings')
                  ? json_['numVmEndpointsWithNatMappings'] as core.int
                  : null,
          ruleStatus: json_.containsKey('ruleStatus')
              ? (json_['ruleStatus'] as core.List)
                  .map((value) => RouterStatusNatStatusNatRuleStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          userAllocatedNatIpResources:
              json_.containsKey('userAllocatedNatIpResources')
                  ? (json_['userAllocatedNatIpResources'] as core.List)
                      .map((value) => value as core.String)
                      .toList()
                  : null,
          userAllocatedNatIps: json_.containsKey('userAllocatedNatIps')
              ? (json_['userAllocatedNatIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoAllocatedNatIps != null)
          'autoAllocatedNatIps': autoAllocatedNatIps!,
        if (drainAutoAllocatedNatIps != null)
          'drainAutoAllocatedNatIps': drainAutoAllocatedNatIps!,
        if (drainUserAllocatedNatIps != null)
          'drainUserAllocatedNatIps': drainUserAllocatedNatIps!,
        if (minExtraNatIpsNeeded != null)
          'minExtraNatIpsNeeded': minExtraNatIpsNeeded!,
        if (name != null) 'name': name!,
        if (numVmEndpointsWithNatMappings != null)
          'numVmEndpointsWithNatMappings': numVmEndpointsWithNatMappings!,
        if (ruleStatus != null) 'ruleStatus': ruleStatus!,
        if (userAllocatedNatIpResources != null)
          'userAllocatedNatIpResources': userAllocatedNatIpResources!,
        if (userAllocatedNatIps != null)
          'userAllocatedNatIps': userAllocatedNatIps!,
      };
}

/// Status of a NAT Rule contained in this NAT.
class RouterStatusNatStatusNatRuleStatus {
  /// A list of active IPs for NAT.
  ///
  /// Example: \["1.1.1.1", "179.12.26.133"\].
  core.List<core.String>? activeNatIps;

  /// A list of IPs for NAT that are in drain mode.
  ///
  /// Example: \["1.1.1.1", "179.12.26.133"\].
  core.List<core.String>? drainNatIps;

  /// The number of extra IPs to allocate.
  ///
  /// This will be greater than 0 only if the existing IPs in this NAT Rule are
  /// NOT enough to allow all configured VMs to use NAT.
  core.int? minExtraIpsNeeded;

  /// Number of VM endpoints (i.e., NICs) that have NAT Mappings from this NAT
  /// Rule.
  core.int? numVmEndpointsWithNatMappings;

  /// Rule number of the rule.
  core.int? ruleNumber;

  RouterStatusNatStatusNatRuleStatus({
    this.activeNatIps,
    this.drainNatIps,
    this.minExtraIpsNeeded,
    this.numVmEndpointsWithNatMappings,
    this.ruleNumber,
  });

  RouterStatusNatStatusNatRuleStatus.fromJson(core.Map json_)
      : this(
          activeNatIps: json_.containsKey('activeNatIps')
              ? (json_['activeNatIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          drainNatIps: json_.containsKey('drainNatIps')
              ? (json_['drainNatIps'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          minExtraIpsNeeded: json_.containsKey('minExtraIpsNeeded')
              ? json_['minExtraIpsNeeded'] as core.int
              : null,
          numVmEndpointsWithNatMappings:
              json_.containsKey('numVmEndpointsWithNatMappings')
                  ? json_['numVmEndpointsWithNatMappings'] as core.int
                  : null,
          ruleNumber: json_.containsKey('ruleNumber')
              ? json_['ruleNumber'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (activeNatIps != null) 'activeNatIps': activeNatIps!,
        if (drainNatIps != null) 'drainNatIps': drainNatIps!,
        if (minExtraIpsNeeded != null) 'minExtraIpsNeeded': minExtraIpsNeeded!,
        if (numVmEndpointsWithNatMappings != null)
          'numVmEndpointsWithNatMappings': numVmEndpointsWithNatMappings!,
        if (ruleNumber != null) 'ruleNumber': ruleNumber!,
      };
}

class RouterStatusResponse {
  /// Type of resource.
  core.String? kind;
  RouterStatus? result;

  RouterStatusResponse({
    this.kind,
    this.result,
  });

  RouterStatusResponse.fromJson(core.Map json_)
      : this(
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          result: json_.containsKey('result')
              ? RouterStatus.fromJson(
                  json_['result'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (kind != null) 'kind': kind!,
        if (result != null) 'result': result!,
      };
}

class RoutersPreviewResponse {
  /// Preview of given router.
  Router? resource;

  RoutersPreviewResponse({
    this.resource,
  });

  RoutersPreviewResponse.fromJson(core.Map json_)
      : this(
          resource: json_.containsKey('resource')
              ? Router.fromJson(
                  json_['resource'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (resource != null) 'resource': resource!,
      };
}

class RoutersScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  RoutersScopedListWarningData({
    this.key,
    this.value,
  });

  RoutersScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of routers when the list is
/// empty.
class RoutersScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<RoutersScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  RoutersScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  RoutersScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => RoutersScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class RoutersScopedList {
  /// A list of routers contained in this scope.
  core.List<Router>? routers;

  /// Informational warning which replaces the list of routers when the list is
  /// empty.
  RoutersScopedListWarning? warning;

  RoutersScopedList({
    this.routers,
    this.warning,
  });

  RoutersScopedList.fromJson(core.Map json_)
      : this(
          routers: json_.containsKey('routers')
              ? (json_['routers'] as core.List)
                  .map((value) => Router.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? RoutersScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (routers != null) 'routers': routers!,
        if (warning != null) 'warning': warning!,
      };
}

/// This is deprecated and has no effect.
///
/// Do not use.
class Rule {
  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  /// Possible string values are:
  /// - "ALLOW" : This is deprecated and has no effect. Do not use.
  /// - "ALLOW_WITH_LOG" : This is deprecated and has no effect. Do not use.
  /// - "DENY" : This is deprecated and has no effect. Do not use.
  /// - "DENY_WITH_LOG" : This is deprecated and has no effect. Do not use.
  /// - "LOG" : This is deprecated and has no effect. Do not use.
  /// - "NO_ACTION" : This is deprecated and has no effect. Do not use.
  core.String? action;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<Condition>? conditions;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.String? description;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<core.String>? ins;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<LogConfig>? logConfigs;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<core.String>? notIns;

  /// This is deprecated and has no effect.
  ///
  /// Do not use.
  core.List<core.String>? permissions;

  Rule({
    this.action,
    this.conditions,
    this.description,
    this.ins,
    this.logConfigs,
    this.notIns,
    this.permissions,
  });

  Rule.fromJson(core.Map json_)
      : this(
          action: json_.containsKey('action')
              ? json_['action'] as core.String
              : null,
          conditions: json_.containsKey('conditions')
              ? (json_['conditions'] as core.List)
                  .map((value) => Condition.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          ins: json_.containsKey('ins')
              ? (json_['ins'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          logConfigs: json_.containsKey('logConfigs')
              ? (json_['logConfigs'] as core.List)
                  .map((value) => LogConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          notIns: json_.containsKey('notIns')
              ? (json_['notIns'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          permissions: json_.containsKey('permissions')
              ? (json_['permissions'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (action != null) 'action': action!,
        if (conditions != null) 'conditions': conditions!,
        if (description != null) 'description': description!,
        if (ins != null) 'ins': ins!,
        if (logConfigs != null) 'logConfigs': logConfigs!,
        if (notIns != null) 'notIns': notIns!,
        if (permissions != null) 'permissions': permissions!,
      };
}

class SSLHealthCheck {
  /// The TCP port number for the health check request.
  ///
  /// The default value is 443. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, SSL health check follows behavior specified in
  /// port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// The application data to send once the SSL connection has been established
  /// (default value is empty).
  ///
  /// If both request and response are empty, the connection establishment alone
  /// will indicate health. The request data can only be ASCII.
  core.String? request;

  /// The bytes to match against the beginning of the response data.
  ///
  /// If left empty (the default value), any response will indicate health. The
  /// response data can only be ASCII.
  core.String? response;

  SSLHealthCheck({
    this.port,
    this.portName,
    this.portSpecification,
    this.proxyHeader,
    this.request,
    this.response,
  });

  SSLHealthCheck.fromJson(core.Map json_)
      : this(
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          request: json_.containsKey('request')
              ? json_['request'] as core.String
              : null,
          response: json_.containsKey('response')
              ? json_['response'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (request != null) 'request': request!,
        if (response != null) 'response': response!,
      };
}

/// DEPRECATED: Please use compute#savedDisk instead.
///
/// An instance-attached disk resource.
class SavedAttachedDisk {
  /// Specifies whether the disk will be auto-deleted when the instance is
  /// deleted (but not when the disk is detached from the instance).
  core.bool? autoDelete;

  /// Indicates that this is a boot disk.
  ///
  /// The virtual machine will use the first partition of the disk for its root
  /// filesystem.
  core.bool? boot;

  /// Specifies the name of the disk attached to the source instance.
  core.String? deviceName;

  /// The encryption key for the disk.
  CustomerEncryptionKey? diskEncryptionKey;

  /// The size of the disk in base-2 GB.
  core.String? diskSizeGb;

  /// URL of the disk type resource.
  ///
  /// For example: projects/project /zones/zone/diskTypes/pd-standard or pd-ssd
  ///
  /// Output only.
  core.String? diskType;

  /// A list of features to enable on the guest operating system.
  ///
  /// Applicable only for bootable images. Read Enabling guest operating system
  /// features to see a list of available options.
  core.List<GuestOsFeature>? guestOsFeatures;

  /// Specifies zero-based index of the disk that is attached to the source
  /// instance.
  core.int? index;

  /// Specifies the disk interface to use for attaching this disk, which is
  /// either SCSI or NVME.
  /// Possible string values are:
  /// - "NVME"
  /// - "SCSI"
  core.String? interface;

  /// Type of the resource.
  ///
  /// Always compute#attachedDisk for attached disks.
  ///
  /// Output only.
  core.String? kind;

  /// Any valid publicly visible licenses.
  ///
  /// Output only.
  core.List<core.String>? licenses;

  /// The mode in which this disk is attached to the source instance, either
  /// READ_WRITE or READ_ONLY.
  /// Possible string values are:
  /// - "READ_ONLY" : Attaches this disk in read-only mode. Multiple virtual
  /// machines can use a disk in read-only mode at a time.
  /// - "READ_WRITE" : *\[Default\]* Attaches this disk in read-write mode. Only
  /// one virtual machine at a time can be attached to a disk in read-write
  /// mode.
  core.String? mode;

  /// Specifies a URL of the disk attached to the source instance.
  core.String? source;

  /// A size of the storage used by the disk's snapshot by this machine image.
  ///
  /// Output only.
  core.String? storageBytes;

  /// An indicator whether storageBytes is in a stable state or it is being
  /// adjusted as a result of shared storage reallocation.
  ///
  /// This status can either be UPDATING, meaning the size of the snapshot is
  /// being updated, or UP_TO_DATE, meaning the size of the snapshot is
  /// up-to-date.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "UPDATING"
  /// - "UP_TO_DATE"
  core.String? storageBytesStatus;

  /// Specifies the type of the attached disk, either SCRATCH or PERSISTENT.
  /// Possible string values are:
  /// - "PERSISTENT"
  /// - "SCRATCH"
  core.String? type;

  SavedAttachedDisk({
    this.autoDelete,
    this.boot,
    this.deviceName,
    this.diskEncryptionKey,
    this.diskSizeGb,
    this.diskType,
    this.guestOsFeatures,
    this.index,
    this.interface,
    this.kind,
    this.licenses,
    this.mode,
    this.source,
    this.storageBytes,
    this.storageBytesStatus,
    this.type,
  });

  SavedAttachedDisk.fromJson(core.Map json_)
      : this(
          autoDelete: json_.containsKey('autoDelete')
              ? json_['autoDelete'] as core.bool
              : null,
          boot: json_.containsKey('boot') ? json_['boot'] as core.bool : null,
          deviceName: json_.containsKey('deviceName')
              ? json_['deviceName'] as core.String
              : null,
          diskEncryptionKey: json_.containsKey('diskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['diskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          diskType: json_.containsKey('diskType')
              ? json_['diskType'] as core.String
              : null,
          guestOsFeatures: json_.containsKey('guestOsFeatures')
              ? (json_['guestOsFeatures'] as core.List)
                  .map((value) => GuestOsFeature.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          index: json_.containsKey('index') ? json_['index'] as core.int : null,
          interface: json_.containsKey('interface')
              ? json_['interface'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          mode: json_.containsKey('mode') ? json_['mode'] as core.String : null,
          source: json_.containsKey('source')
              ? json_['source'] as core.String
              : null,
          storageBytes: json_.containsKey('storageBytes')
              ? json_['storageBytes'] as core.String
              : null,
          storageBytesStatus: json_.containsKey('storageBytesStatus')
              ? json_['storageBytesStatus'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoDelete != null) 'autoDelete': autoDelete!,
        if (boot != null) 'boot': boot!,
        if (deviceName != null) 'deviceName': deviceName!,
        if (diskEncryptionKey != null) 'diskEncryptionKey': diskEncryptionKey!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (diskType != null) 'diskType': diskType!,
        if (guestOsFeatures != null) 'guestOsFeatures': guestOsFeatures!,
        if (index != null) 'index': index!,
        if (interface != null) 'interface': interface!,
        if (kind != null) 'kind': kind!,
        if (licenses != null) 'licenses': licenses!,
        if (mode != null) 'mode': mode!,
        if (source != null) 'source': source!,
        if (storageBytes != null) 'storageBytes': storageBytes!,
        if (storageBytesStatus != null)
          'storageBytesStatus': storageBytesStatus!,
        if (type != null) 'type': type!,
      };
}

/// An instance-attached disk resource.
class SavedDisk {
  /// The architecture of the attached disk.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// Type of the resource.
  ///
  /// Always compute#savedDisk for attached disks.
  ///
  /// Output only.
  core.String? kind;

  /// Specifies a URL of the disk attached to the source instance.
  core.String? sourceDisk;

  /// Size of the individual disk snapshot used by this machine image.
  ///
  /// Output only.
  core.String? storageBytes;

  /// An indicator whether storageBytes is in a stable state or it is being
  /// adjusted as a result of shared storage reallocation.
  ///
  /// This status can either be UPDATING, meaning the size of the snapshot is
  /// being updated, or UP_TO_DATE, meaning the size of the snapshot is
  /// up-to-date.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "UPDATING"
  /// - "UP_TO_DATE"
  core.String? storageBytesStatus;

  SavedDisk({
    this.architecture,
    this.kind,
    this.sourceDisk,
    this.storageBytes,
    this.storageBytesStatus,
  });

  SavedDisk.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          sourceDisk: json_.containsKey('sourceDisk')
              ? json_['sourceDisk'] as core.String
              : null,
          storageBytes: json_.containsKey('storageBytes')
              ? json_['storageBytes'] as core.String
              : null,
          storageBytesStatus: json_.containsKey('storageBytesStatus')
              ? json_['storageBytesStatus'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (kind != null) 'kind': kind!,
        if (sourceDisk != null) 'sourceDisk': sourceDisk!,
        if (storageBytes != null) 'storageBytes': storageBytes!,
        if (storageBytesStatus != null)
          'storageBytesStatus': storageBytesStatus!,
      };
}

class ScalingScheduleStatus {
  /// The last time the scaling schedule became active.
  ///
  /// Note: this is a timestamp when a schedule actually became active, not when
  /// it was planned to do so. The timestamp is in RFC3339 text format.
  ///
  /// Output only.
  core.String? lastStartTime;

  /// The next time the scaling schedule is to become active.
  ///
  /// Note: this is a timestamp when a schedule is planned to run, but the
  /// actual time might be slightly different. The timestamp is in RFC3339 text
  /// format.
  ///
  /// Output only.
  core.String? nextStartTime;

  /// The current state of a scaling schedule.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : The current autoscaling recommendation is influenced by this
  /// scaling schedule.
  /// - "DISABLED" : This scaling schedule has been disabled by the user.
  /// - "OBSOLETE" : This scaling schedule will never become active again.
  /// - "READY" : The current autoscaling recommendation is not influenced by
  /// this scaling schedule.
  core.String? state;

  ScalingScheduleStatus({
    this.lastStartTime,
    this.nextStartTime,
    this.state,
  });

  ScalingScheduleStatus.fromJson(core.Map json_)
      : this(
          lastStartTime: json_.containsKey('lastStartTime')
              ? json_['lastStartTime'] as core.String
              : null,
          nextStartTime: json_.containsKey('nextStartTime')
              ? json_['nextStartTime'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (lastStartTime != null) 'lastStartTime': lastStartTime!,
        if (nextStartTime != null) 'nextStartTime': nextStartTime!,
        if (state != null) 'state': state!,
      };
}

/// Sets the scheduling options for an Instance.
class Scheduling {
  /// Specifies whether the instance should be automatically restarted if it is
  /// terminated by Compute Engine (not terminated by a user).
  ///
  /// You can only set the automatic restart option for standard instances.
  /// Preemptible instances cannot be automatically restarted. By default, this
  /// is set to true so an instance is automatically restarted if it is
  /// terminated by Compute Engine.
  core.bool? automaticRestart;

  /// Specifies the termination action for the instance.
  /// Possible string values are:
  /// - "DELETE" : Delete the VM.
  /// - "INSTANCE_TERMINATION_ACTION_UNSPECIFIED" : Default value. This value is
  /// unused.
  /// - "STOP" : Stop the VM without storing in-memory content. default action.
  core.String? instanceTerminationAction;

  /// An opaque location hint used to place the instance close to other
  /// resources.
  ///
  /// This field is for use by internal tools that use the public API.
  core.String? locationHint;

  /// The minimum number of virtual CPUs this instance will consume when running
  /// on a sole-tenant node.
  core.int? minNodeCpus;

  /// A set of node affinity and anti-affinity configurations.
  ///
  /// Refer to Configuring node affinity for more information. Overrides
  /// reservationAffinity.
  core.List<SchedulingNodeAffinity>? nodeAffinities;

  /// Defines the maintenance behavior for this instance.
  ///
  /// For standard instances, the default behavior is MIGRATE. For preemptible
  /// instances, the default and only possible behavior is TERMINATE. For more
  /// information, see Set VM host maintenance policy.
  /// Possible string values are:
  /// - "MIGRATE" : *\[Default\]* Allows Compute Engine to automatically migrate
  /// instances out of the way of maintenance events.
  /// - "TERMINATE" : Tells Compute Engine to terminate and (optionally) restart
  /// the instance away from the maintenance activity. If you would like your
  /// instance to be restarted, set the automaticRestart flag to true. Your
  /// instance may be restarted more than once, and it may be restarted outside
  /// the window of maintenance events.
  core.String? onHostMaintenance;

  /// Defines whether the instance is preemptible.
  ///
  /// This can only be set during instance creation or while the instance is
  /// stopped and therefore, in a `TERMINATED` state. See Instance Life Cycle
  /// for more information on the possible instance states.
  core.bool? preemptible;

  /// Specifies the provisioning model of the instance.
  /// Possible string values are:
  /// - "SPOT" : Heavily discounted, no guaranteed runtime.
  /// - "STANDARD" : Standard provisioning with user controlled runtime, no
  /// discounts.
  core.String? provisioningModel;

  Scheduling({
    this.automaticRestart,
    this.instanceTerminationAction,
    this.locationHint,
    this.minNodeCpus,
    this.nodeAffinities,
    this.onHostMaintenance,
    this.preemptible,
    this.provisioningModel,
  });

  Scheduling.fromJson(core.Map json_)
      : this(
          automaticRestart: json_.containsKey('automaticRestart')
              ? json_['automaticRestart'] as core.bool
              : null,
          instanceTerminationAction:
              json_.containsKey('instanceTerminationAction')
                  ? json_['instanceTerminationAction'] as core.String
                  : null,
          locationHint: json_.containsKey('locationHint')
              ? json_['locationHint'] as core.String
              : null,
          minNodeCpus: json_.containsKey('minNodeCpus')
              ? json_['minNodeCpus'] as core.int
              : null,
          nodeAffinities: json_.containsKey('nodeAffinities')
              ? (json_['nodeAffinities'] as core.List)
                  .map((value) => SchedulingNodeAffinity.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          onHostMaintenance: json_.containsKey('onHostMaintenance')
              ? json_['onHostMaintenance'] as core.String
              : null,
          preemptible: json_.containsKey('preemptible')
              ? json_['preemptible'] as core.bool
              : null,
          provisioningModel: json_.containsKey('provisioningModel')
              ? json_['provisioningModel'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (automaticRestart != null) 'automaticRestart': automaticRestart!,
        if (instanceTerminationAction != null)
          'instanceTerminationAction': instanceTerminationAction!,
        if (locationHint != null) 'locationHint': locationHint!,
        if (minNodeCpus != null) 'minNodeCpus': minNodeCpus!,
        if (nodeAffinities != null) 'nodeAffinities': nodeAffinities!,
        if (onHostMaintenance != null) 'onHostMaintenance': onHostMaintenance!,
        if (preemptible != null) 'preemptible': preemptible!,
        if (provisioningModel != null) 'provisioningModel': provisioningModel!,
      };
}

/// Node Affinity: the configuration of desired nodes onto which this Instance
/// could be scheduled.
class SchedulingNodeAffinity {
  /// Corresponds to the label key of Node resource.
  core.String? key;

  /// Defines the operation of node selection.
  ///
  /// Valid operators are IN for affinity and NOT_IN for anti-affinity.
  /// Possible string values are:
  /// - "IN" : Requires Compute Engine to seek for matched nodes.
  /// - "NOT_IN" : Requires Compute Engine to avoid certain nodes.
  /// - "OPERATOR_UNSPECIFIED"
  core.String? operator;

  /// Corresponds to the label values of Node resource.
  core.List<core.String>? values;

  SchedulingNodeAffinity({
    this.key,
    this.operator,
    this.values,
  });

  SchedulingNodeAffinity.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          operator: json_.containsKey('operator')
              ? json_['operator'] as core.String
              : null,
          values: json_.containsKey('values')
              ? (json_['values'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (operator != null) 'operator': operator!,
        if (values != null) 'values': values!,
      };
}

/// An instance's screenshot.
class Screenshot {
  /// The Base64-encoded screenshot data.
  ///
  /// Output only.
  core.String? contents;

  /// Type of the resource.
  ///
  /// Always compute#screenshot for the screenshots.
  ///
  /// Output only.
  core.String? kind;

  Screenshot({
    this.contents,
    this.kind,
  });

  Screenshot.fromJson(core.Map json_)
      : this(
          contents: json_.containsKey('contents')
              ? json_['contents'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (contents != null) 'contents': contents!,
        if (kind != null) 'kind': kind!,
      };
}

class SecurityPoliciesAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SecurityPoliciesAggregatedListWarningData({
    this.key,
    this.value,
  });

  SecurityPoliciesAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SecurityPoliciesAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SecurityPoliciesAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SecurityPoliciesAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SecurityPoliciesAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      SecurityPoliciesAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SecurityPoliciesAggregatedList {
  core.String? etag;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SecurityPoliciesScopedList resources.
  core.Map<core.String, SecurityPoliciesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#securityPolicyAggregatedList for lists of Security
  /// Policies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  SecurityPoliciesAggregatedListWarning? warning;

  SecurityPoliciesAggregatedList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  SecurityPoliciesAggregatedList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    SecurityPoliciesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SecurityPoliciesAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class SecurityPoliciesListPreconfiguredExpressionSetsResponse {
  SecurityPoliciesWafConfig? preconfiguredExpressionSets;

  SecurityPoliciesListPreconfiguredExpressionSetsResponse({
    this.preconfiguredExpressionSets,
  });

  SecurityPoliciesListPreconfiguredExpressionSetsResponse.fromJson(
      core.Map json_)
      : this(
          preconfiguredExpressionSets:
              json_.containsKey('preconfiguredExpressionSets')
                  ? SecurityPoliciesWafConfig.fromJson(
                      json_['preconfiguredExpressionSets']
                          as core.Map<core.String, core.dynamic>)
                  : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (preconfiguredExpressionSets != null)
          'preconfiguredExpressionSets': preconfiguredExpressionSets!,
      };
}

class SecurityPoliciesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SecurityPoliciesScopedListWarningData({
    this.key,
    this.value,
  });

  SecurityPoliciesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of security policies when the
/// list is empty.
class SecurityPoliciesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SecurityPoliciesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SecurityPoliciesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SecurityPoliciesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      SecurityPoliciesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SecurityPoliciesScopedList {
  /// A list of SecurityPolicies contained in this scope.
  core.List<SecurityPolicy>? securityPolicies;

  /// Informational warning which replaces the list of security policies when
  /// the list is empty.
  SecurityPoliciesScopedListWarning? warning;

  SecurityPoliciesScopedList({
    this.securityPolicies,
    this.warning,
  });

  SecurityPoliciesScopedList.fromJson(core.Map json_)
      : this(
          securityPolicies: json_.containsKey('securityPolicies')
              ? (json_['securityPolicies'] as core.List)
                  .map((value) => SecurityPolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SecurityPoliciesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (securityPolicies != null) 'securityPolicies': securityPolicies!,
        if (warning != null) 'warning': warning!,
      };
}

class SecurityPoliciesWafConfig {
  PreconfiguredWafSet? wafRules;

  SecurityPoliciesWafConfig({
    this.wafRules,
  });

  SecurityPoliciesWafConfig.fromJson(core.Map json_)
      : this(
          wafRules: json_.containsKey('wafRules')
              ? PreconfiguredWafSet.fromJson(
                  json_['wafRules'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (wafRules != null) 'wafRules': wafRules!,
      };
}

/// Represents a Google Cloud Armor security policy resource.
///
/// Only external backend services that use load balancers can reference a
/// security policy. For more information, see Google Cloud Armor security
/// policy overview.
class SecurityPolicy {
  SecurityPolicyAdaptiveProtectionConfig? adaptiveProtectionConfig;
  SecurityPolicyAdvancedOptionsConfig? advancedOptionsConfig;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;
  SecurityPolicyDdosProtectionConfig? ddosProtectionConfig;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Specifies a fingerprint for this resource, which is essentially a hash of
  /// the metadata's contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update metadata. You must always provide an
  /// up-to-date fingerprint hash in order to update or change metadata,
  /// otherwise the request will fail with error 412 conditionNotMet. To see the
  /// latest fingerprint, make get() request to the security policy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#securityPolicyfor security policies
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;
  SecurityPolicyRecaptchaOptionsConfig? recaptchaOptionsConfig;

  /// URL of the region where the regional security policy resides.
  ///
  /// This field is not applicable to global security policies.
  ///
  /// Output only.
  core.String? region;

  /// A list of rules that belong to this policy.
  ///
  /// There must always be a default rule (rule with priority 2147483647 and
  /// match "*"). If no rules are provided when creating a security policy, a
  /// default rule with action "allow" will be added.
  core.List<SecurityPolicyRule>? rules;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The type indicates the intended use of the security policy.
  ///
  /// - CLOUD_ARMOR: Cloud Armor backend security policies can be configured to
  /// filter incoming HTTP requests targeting backend services. They filter
  /// requests before they hit the origin servers. - CLOUD_ARMOR_EDGE: Cloud
  /// Armor edge security policies can be configured to filter incoming HTTP
  /// requests targeting backend services (including Cloud CDN-enabled) as well
  /// as backend buckets (Cloud Storage). They filter requests before the
  /// request is served from Google's cache. - CLOUD_ARMOR_INTERNAL_SERVICE:
  /// Cloud Armor internal service policies can be configured to filter HTTP
  /// requests targeting services managed by Traffic Director in a service mesh.
  /// They filter requests before the request is served from the application.
  /// This field can be set only at resource creation time.
  /// Possible string values are:
  /// - "CLOUD_ARMOR"
  /// - "CLOUD_ARMOR_EDGE"
  /// - "CLOUD_ARMOR_NETWORK"
  core.String? type;

  SecurityPolicy({
    this.adaptiveProtectionConfig,
    this.advancedOptionsConfig,
    this.creationTimestamp,
    this.ddosProtectionConfig,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.recaptchaOptionsConfig,
    this.region,
    this.rules,
    this.selfLink,
    this.type,
  });

  SecurityPolicy.fromJson(core.Map json_)
      : this(
          adaptiveProtectionConfig:
              json_.containsKey('adaptiveProtectionConfig')
                  ? SecurityPolicyAdaptiveProtectionConfig.fromJson(
                      json_['adaptiveProtectionConfig']
                          as core.Map<core.String, core.dynamic>)
                  : null,
          advancedOptionsConfig: json_.containsKey('advancedOptionsConfig')
              ? SecurityPolicyAdvancedOptionsConfig.fromJson(
                  json_['advancedOptionsConfig']
                      as core.Map<core.String, core.dynamic>)
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          ddosProtectionConfig: json_.containsKey('ddosProtectionConfig')
              ? SecurityPolicyDdosProtectionConfig.fromJson(
                  json_['ddosProtectionConfig']
                      as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          recaptchaOptionsConfig: json_.containsKey('recaptchaOptionsConfig')
              ? SecurityPolicyRecaptchaOptionsConfig.fromJson(
                  json_['recaptchaOptionsConfig']
                      as core.Map<core.String, core.dynamic>)
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          rules: json_.containsKey('rules')
              ? (json_['rules'] as core.List)
                  .map((value) => SecurityPolicyRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (adaptiveProtectionConfig != null)
          'adaptiveProtectionConfig': adaptiveProtectionConfig!,
        if (advancedOptionsConfig != null)
          'advancedOptionsConfig': advancedOptionsConfig!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (ddosProtectionConfig != null)
          'ddosProtectionConfig': ddosProtectionConfig!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (recaptchaOptionsConfig != null)
          'recaptchaOptionsConfig': recaptchaOptionsConfig!,
        if (region != null) 'region': region!,
        if (rules != null) 'rules': rules!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (type != null) 'type': type!,
      };
}

/// Configuration options for Cloud Armor Adaptive Protection (CAAP).
class SecurityPolicyAdaptiveProtectionConfig {
  /// If set to true, enables Cloud Armor Machine Learning.
  SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig?
      layer7DdosDefenseConfig;

  SecurityPolicyAdaptiveProtectionConfig({
    this.layer7DdosDefenseConfig,
  });

  SecurityPolicyAdaptiveProtectionConfig.fromJson(core.Map json_)
      : this(
          layer7DdosDefenseConfig: json_.containsKey('layer7DdosDefenseConfig')
              ? SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                  .fromJson(json_['layer7DdosDefenseConfig']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (layer7DdosDefenseConfig != null)
          'layer7DdosDefenseConfig': layer7DdosDefenseConfig!,
      };
}

/// Configuration options for L7 DDoS detection.
class SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig {
  /// If set to true, enables CAAP for L7 DDoS detection.
  core.bool? enable;

  /// Rule visibility can be one of the following: STANDARD - opaque rules.
  ///
  /// (default) PREMIUM - transparent rules.
  /// Possible string values are:
  /// - "PREMIUM"
  /// - "STANDARD"
  core.String? ruleVisibility;

  SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig({
    this.enable,
    this.ruleVisibility,
  });

  SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.fromJson(
      core.Map json_)
      : this(
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
          ruleVisibility: json_.containsKey('ruleVisibility')
              ? json_['ruleVisibility'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enable != null) 'enable': enable!,
        if (ruleVisibility != null) 'ruleVisibility': ruleVisibility!,
      };
}

class SecurityPolicyAdvancedOptionsConfig {
  /// Custom configuration to apply the JSON parsing.
  ///
  /// Only applicable when json_parsing is set to STANDARD.
  SecurityPolicyAdvancedOptionsConfigJsonCustomConfig? jsonCustomConfig;

  ///
  /// Possible string values are:
  /// - "DISABLED"
  /// - "STANDARD"
  core.String? jsonParsing;

  ///
  /// Possible string values are:
  /// - "NORMAL"
  /// - "VERBOSE"
  core.String? logLevel;

  SecurityPolicyAdvancedOptionsConfig({
    this.jsonCustomConfig,
    this.jsonParsing,
    this.logLevel,
  });

  SecurityPolicyAdvancedOptionsConfig.fromJson(core.Map json_)
      : this(
          jsonCustomConfig: json_.containsKey('jsonCustomConfig')
              ? SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.fromJson(
                  json_['jsonCustomConfig']
                      as core.Map<core.String, core.dynamic>)
              : null,
          jsonParsing: json_.containsKey('jsonParsing')
              ? json_['jsonParsing'] as core.String
              : null,
          logLevel: json_.containsKey('logLevel')
              ? json_['logLevel'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (jsonCustomConfig != null) 'jsonCustomConfig': jsonCustomConfig!,
        if (jsonParsing != null) 'jsonParsing': jsonParsing!,
        if (logLevel != null) 'logLevel': logLevel!,
      };
}

class SecurityPolicyAdvancedOptionsConfigJsonCustomConfig {
  /// A list of custom Content-Type header values to apply the JSON parsing.
  ///
  /// As per RFC 1341, a Content-Type header value has the following format:
  /// Content-Type := type "/" subtype *\[";" parameter\] When configuring a
  /// custom Content-Type header value, only the type/subtype needs to be
  /// specified, and the parameters should be excluded.
  core.List<core.String>? contentTypes;

  SecurityPolicyAdvancedOptionsConfigJsonCustomConfig({
    this.contentTypes,
  });

  SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.fromJson(core.Map json_)
      : this(
          contentTypes: json_.containsKey('contentTypes')
              ? (json_['contentTypes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (contentTypes != null) 'contentTypes': contentTypes!,
      };
}

class SecurityPolicyDdosProtectionConfig {
  ///
  /// Possible string values are:
  /// - "ADVANCED"
  /// - "STANDARD"
  core.String? ddosProtection;

  SecurityPolicyDdosProtectionConfig({
    this.ddosProtection,
  });

  SecurityPolicyDdosProtectionConfig.fromJson(core.Map json_)
      : this(
          ddosProtection: json_.containsKey('ddosProtection')
              ? json_['ddosProtection'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ddosProtection != null) 'ddosProtection': ddosProtection!,
      };
}

class SecurityPolicyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SecurityPolicyListWarningData({
    this.key,
    this.value,
  });

  SecurityPolicyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SecurityPolicyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SecurityPolicyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SecurityPolicyListWarning({
    this.code,
    this.data,
    this.message,
  });

  SecurityPolicyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SecurityPolicyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SecurityPolicyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SecurityPolicy resources.
  core.List<SecurityPolicy>? items;

  /// Type of resource.
  ///
  /// Always compute#securityPolicyList for listsof securityPolicies
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Informational warning message.
  ///
  /// Output only.
  SecurityPolicyListWarning? warning;

  SecurityPolicyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.warning,
  });

  SecurityPolicyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => SecurityPolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? SecurityPolicyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (warning != null) 'warning': warning!,
      };
}

class SecurityPolicyRecaptchaOptionsConfig {
  /// An optional field to supply a reCAPTCHA site key to be used for all the
  /// rules using the redirect action with the type of GOOGLE_RECAPTCHA under
  /// the security policy.
  ///
  /// The specified site key needs to be created from the reCAPTCHA API. The
  /// user is responsible for the validity of the specified site key. If not
  /// specified, a Google-managed site key is used.
  core.String? redirectSiteKey;

  SecurityPolicyRecaptchaOptionsConfig({
    this.redirectSiteKey,
  });

  SecurityPolicyRecaptchaOptionsConfig.fromJson(core.Map json_)
      : this(
          redirectSiteKey: json_.containsKey('redirectSiteKey')
              ? json_['redirectSiteKey'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (redirectSiteKey != null) 'redirectSiteKey': redirectSiteKey!,
      };
}

class SecurityPolicyReference {
  core.String? securityPolicy;

  SecurityPolicyReference({
    this.securityPolicy,
  });

  SecurityPolicyReference.fromJson(core.Map json_)
      : this(
          securityPolicy: json_.containsKey('securityPolicy')
              ? json_['securityPolicy'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (securityPolicy != null) 'securityPolicy': securityPolicy!,
      };
}

/// Represents a rule that describes one or more match conditions along with the
/// action to be taken when traffic matches this condition (allow or deny).
class SecurityPolicyRule {
  /// The Action to perform when the rule is matched.
  ///
  /// The following are the valid actions: - allow: allow access to target. -
  /// deny(): deny access to target, returns the HTTP response code specified
  /// (valid values are 403, 404, and 502). - rate_based_ban: limit client
  /// traffic to the configured threshold and ban the client if the traffic
  /// exceeds the threshold. Configure parameters for this action in
  /// RateLimitOptions. Requires rate_limit_options to be set. - redirect:
  /// redirect to a different target. This can either be an internal reCAPTCHA
  /// redirect, or an external URL-based redirect via a 302 response. Parameters
  /// for this action can be configured via redirectOptions. - throttle: limit
  /// client traffic to the configured threshold. Configure parameters for this
  /// action in rateLimitOptions. Requires rate_limit_options to be set for
  /// this.
  core.String? action;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Optional, additional actions that are performed on headers.
  SecurityPolicyRuleHttpHeaderAction? headerAction;

  /// Type of the resource.
  ///
  /// Always compute#securityPolicyRule for security policy rules
  ///
  /// Output only.
  core.String? kind;

  /// A match condition that incoming traffic is evaluated against.
  ///
  /// If it evaluates to true, the corresponding 'action' is enforced.
  SecurityPolicyRuleMatcher? match;

  /// If set to true, the specified action is not enforced.
  core.bool? preview;

  /// An integer indicating the priority of a rule in the list.
  ///
  /// The priority must be a positive value between 0 and 2147483647. Rules are
  /// evaluated from highest to lowest priority where 0 is the highest priority
  /// and 2147483647 is the lowest priority.
  core.int? priority;

  /// Must be specified if the action is "rate_based_ban" or "throttle".
  ///
  /// Cannot be specified for any other actions.
  SecurityPolicyRuleRateLimitOptions? rateLimitOptions;

  /// Parameters defining the redirect action.
  ///
  /// Cannot be specified for any other actions.
  SecurityPolicyRuleRedirectOptions? redirectOptions;

  SecurityPolicyRule({
    this.action,
    this.description,
    this.headerAction,
    this.kind,
    this.match,
    this.preview,
    this.priority,
    this.rateLimitOptions,
    this.redirectOptions,
  });

  SecurityPolicyRule.fromJson(core.Map json_)
      : this(
          action: json_.containsKey('action')
              ? json_['action'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          headerAction: json_.containsKey('headerAction')
              ? SecurityPolicyRuleHttpHeaderAction.fromJson(
                  json_['headerAction'] as core.Map<core.String, core.dynamic>)
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          match: json_.containsKey('match')
              ? SecurityPolicyRuleMatcher.fromJson(
                  json_['match'] as core.Map<core.String, core.dynamic>)
              : null,
          preview: json_.containsKey('preview')
              ? json_['preview'] as core.bool
              : null,
          priority: json_.containsKey('priority')
              ? json_['priority'] as core.int
              : null,
          rateLimitOptions: json_.containsKey('rateLimitOptions')
              ? SecurityPolicyRuleRateLimitOptions.fromJson(
                  json_['rateLimitOptions']
                      as core.Map<core.String, core.dynamic>)
              : null,
          redirectOptions: json_.containsKey('redirectOptions')
              ? SecurityPolicyRuleRedirectOptions.fromJson(
                  json_['redirectOptions']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (action != null) 'action': action!,
        if (description != null) 'description': description!,
        if (headerAction != null) 'headerAction': headerAction!,
        if (kind != null) 'kind': kind!,
        if (match != null) 'match': match!,
        if (preview != null) 'preview': preview!,
        if (priority != null) 'priority': priority!,
        if (rateLimitOptions != null) 'rateLimitOptions': rateLimitOptions!,
        if (redirectOptions != null) 'redirectOptions': redirectOptions!,
      };
}

class SecurityPolicyRuleHttpHeaderAction {
  /// The list of request headers to add or overwrite if they're already
  /// present.
  core.List<SecurityPolicyRuleHttpHeaderActionHttpHeaderOption>?
      requestHeadersToAdds;

  SecurityPolicyRuleHttpHeaderAction({
    this.requestHeadersToAdds,
  });

  SecurityPolicyRuleHttpHeaderAction.fromJson(core.Map json_)
      : this(
          requestHeadersToAdds: json_.containsKey('requestHeadersToAdds')
              ? (json_['requestHeadersToAdds'] as core.List)
                  .map((value) =>
                      SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (requestHeadersToAdds != null)
          'requestHeadersToAdds': requestHeadersToAdds!,
      };
}

class SecurityPolicyRuleHttpHeaderActionHttpHeaderOption {
  /// The name of the header to set.
  core.String? headerName;

  /// The value to set the named header to.
  core.String? headerValue;

  SecurityPolicyRuleHttpHeaderActionHttpHeaderOption({
    this.headerName,
    this.headerValue,
  });

  SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.fromJson(core.Map json_)
      : this(
          headerName: json_.containsKey('headerName')
              ? json_['headerName'] as core.String
              : null,
          headerValue: json_.containsKey('headerValue')
              ? json_['headerValue'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (headerName != null) 'headerName': headerName!,
        if (headerValue != null) 'headerValue': headerValue!,
      };
}

/// Represents a match condition that incoming traffic is evaluated against.
///
/// Exactly one field must be specified.
class SecurityPolicyRuleMatcher {
  /// The configuration options available when specifying versioned_expr.
  ///
  /// This field must be specified if versioned_expr is specified and cannot be
  /// specified if versioned_expr is not specified.
  SecurityPolicyRuleMatcherConfig? config;

  /// User defined CEVAL expression.
  ///
  /// A CEVAL expression is used to specify match criteria such as origin.ip,
  /// source.region_code and contents in the request header.
  Expr? expr;

  /// Preconfigured versioned expression.
  ///
  /// If this field is specified, config must also be specified. Available
  /// preconfigured expressions along with their requirements are: SRC_IPS_V1 -
  /// must specify the corresponding src_ip_range field in config.
  /// Possible string values are:
  /// - "SRC_IPS_V1" : Matches the source IP address of a request to the IP
  /// ranges supplied in config.
  core.String? versionedExpr;

  SecurityPolicyRuleMatcher({
    this.config,
    this.expr,
    this.versionedExpr,
  });

  SecurityPolicyRuleMatcher.fromJson(core.Map json_)
      : this(
          config: json_.containsKey('config')
              ? SecurityPolicyRuleMatcherConfig.fromJson(
                  json_['config'] as core.Map<core.String, core.dynamic>)
              : null,
          expr: json_.containsKey('expr')
              ? Expr.fromJson(
                  json_['expr'] as core.Map<core.String, core.dynamic>)
              : null,
          versionedExpr: json_.containsKey('versionedExpr')
              ? json_['versionedExpr'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (config != null) 'config': config!,
        if (expr != null) 'expr': expr!,
        if (versionedExpr != null) 'versionedExpr': versionedExpr!,
      };
}

class SecurityPolicyRuleMatcherConfig {
  /// CIDR IP address range.
  ///
  /// Maximum number of src_ip_ranges allowed is 10.
  core.List<core.String>? srcIpRanges;

  SecurityPolicyRuleMatcherConfig({
    this.srcIpRanges,
  });

  SecurityPolicyRuleMatcherConfig.fromJson(core.Map json_)
      : this(
          srcIpRanges: json_.containsKey('srcIpRanges')
              ? (json_['srcIpRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (srcIpRanges != null) 'srcIpRanges': srcIpRanges!,
      };
}

class SecurityPolicyRuleRateLimitOptions {
  /// Can only be specified if the action for the rule is "rate_based_ban".
  ///
  /// If specified, determines the time (in seconds) the traffic will continue
  /// to be banned by the rate limit after the rate falls below the threshold.
  core.int? banDurationSec;

  /// Can only be specified if the action for the rule is "rate_based_ban".
  ///
  /// If specified, the key will be banned for the configured 'ban_duration_sec'
  /// when the number of requests that exceed the 'rate_limit_threshold' also
  /// exceed this 'ban_threshold'.
  SecurityPolicyRuleRateLimitOptionsThreshold? banThreshold;

  /// Action to take for requests that are under the configured rate limit
  /// threshold.
  ///
  /// Valid option is "allow" only.
  core.String? conformAction;

  /// Determines the key to enforce the rate_limit_threshold on.
  ///
  /// Possible values are: - ALL: A single rate limit threshold is applied to
  /// all the requests matching this rule. This is the default value if this
  /// field 'enforce_on_key' is not configured. - IP: The source IP address of
  /// the request is the key. Each IP has this limit enforced separately. -
  /// HTTP_HEADER: The value of the HTTP header whose name is configured under
  /// "enforce_on_key_name". The key value is truncated to the first 128 bytes
  /// of the header value. If no such header is present in the request, the key
  /// type defaults to ALL. - XFF_IP: The first IP address (i.e. the originating
  /// client IP address) specified in the list of IPs under X-Forwarded-For HTTP
  /// header. If no such header is present or the value is not a valid IP, the
  /// key defaults to the source IP address of the request i.e. key type IP. -
  /// HTTP_COOKIE: The value of the HTTP cookie whose name is configured under
  /// "enforce_on_key_name". The key value is truncated to the first 128 bytes
  /// of the cookie value. If no such cookie is present in the request, the key
  /// type defaults to ALL.
  /// Possible string values are:
  /// - "ALL"
  /// - "HTTP_COOKIE"
  /// - "HTTP_HEADER"
  /// - "IP"
  /// - "XFF_IP"
  core.String? enforceOnKey;

  /// Rate limit key name applicable only for the following key types:
  /// HTTP_HEADER -- Name of the HTTP header whose value is taken as the key
  /// value.
  ///
  /// HTTP_COOKIE -- Name of the HTTP cookie whose value is taken as the key
  /// value.
  core.String? enforceOnKeyName;

  /// Action to take for requests that are above the configured rate limit
  /// threshold, to either deny with a specified HTTP response code, or redirect
  /// to a different endpoint.
  ///
  /// Valid options are "deny(status)", where valid values for status are 403,
  /// 404, 429, and 502, and "redirect" where the redirect parameters come from
  /// exceedRedirectOptions below.
  core.String? exceedAction;

  /// Parameters defining the redirect action that is used as the exceed action.
  ///
  /// Cannot be specified if the exceed action is not redirect.
  SecurityPolicyRuleRedirectOptions? exceedRedirectOptions;

  /// Threshold at which to begin ratelimiting.
  SecurityPolicyRuleRateLimitOptionsThreshold? rateLimitThreshold;

  SecurityPolicyRuleRateLimitOptions({
    this.banDurationSec,
    this.banThreshold,
    this.conformAction,
    this.enforceOnKey,
    this.enforceOnKeyName,
    this.exceedAction,
    this.exceedRedirectOptions,
    this.rateLimitThreshold,
  });

  SecurityPolicyRuleRateLimitOptions.fromJson(core.Map json_)
      : this(
          banDurationSec: json_.containsKey('banDurationSec')
              ? json_['banDurationSec'] as core.int
              : null,
          banThreshold: json_.containsKey('banThreshold')
              ? SecurityPolicyRuleRateLimitOptionsThreshold.fromJson(
                  json_['banThreshold'] as core.Map<core.String, core.dynamic>)
              : null,
          conformAction: json_.containsKey('conformAction')
              ? json_['conformAction'] as core.String
              : null,
          enforceOnKey: json_.containsKey('enforceOnKey')
              ? json_['enforceOnKey'] as core.String
              : null,
          enforceOnKeyName: json_.containsKey('enforceOnKeyName')
              ? json_['enforceOnKeyName'] as core.String
              : null,
          exceedAction: json_.containsKey('exceedAction')
              ? json_['exceedAction'] as core.String
              : null,
          exceedRedirectOptions: json_.containsKey('exceedRedirectOptions')
              ? SecurityPolicyRuleRedirectOptions.fromJson(
                  json_['exceedRedirectOptions']
                      as core.Map<core.String, core.dynamic>)
              : null,
          rateLimitThreshold: json_.containsKey('rateLimitThreshold')
              ? SecurityPolicyRuleRateLimitOptionsThreshold.fromJson(
                  json_['rateLimitThreshold']
                      as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (banDurationSec != null) 'banDurationSec': banDurationSec!,
        if (banThreshold != null) 'banThreshold': banThreshold!,
        if (conformAction != null) 'conformAction': conformAction!,
        if (enforceOnKey != null) 'enforceOnKey': enforceOnKey!,
        if (enforceOnKeyName != null) 'enforceOnKeyName': enforceOnKeyName!,
        if (exceedAction != null) 'exceedAction': exceedAction!,
        if (exceedRedirectOptions != null)
          'exceedRedirectOptions': exceedRedirectOptions!,
        if (rateLimitThreshold != null)
          'rateLimitThreshold': rateLimitThreshold!,
      };
}

class SecurityPolicyRuleRateLimitOptionsThreshold {
  /// Number of HTTP(S) requests for calculating the threshold.
  core.int? count;

  /// Interval over which the threshold is computed.
  core.int? intervalSec;

  SecurityPolicyRuleRateLimitOptionsThreshold({
    this.count,
    this.intervalSec,
  });

  SecurityPolicyRuleRateLimitOptionsThreshold.fromJson(core.Map json_)
      : this(
          count: json_.containsKey('count') ? json_['count'] as core.int : null,
          intervalSec: json_.containsKey('intervalSec')
              ? json_['intervalSec'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (count != null) 'count': count!,
        if (intervalSec != null) 'intervalSec': intervalSec!,
      };
}

class SecurityPolicyRuleRedirectOptions {
  /// Target for the redirect action.
  ///
  /// This is required if the type is EXTERNAL_302 and cannot be specified for
  /// GOOGLE_RECAPTCHA.
  core.String? target;

  /// Type of the redirect action.
  /// Possible string values are:
  /// - "EXTERNAL_302"
  /// - "GOOGLE_RECAPTCHA"
  core.String? type;

  SecurityPolicyRuleRedirectOptions({
    this.target,
    this.type,
  });

  SecurityPolicyRuleRedirectOptions.fromJson(core.Map json_)
      : this(
          target: json_.containsKey('target')
              ? json_['target'] as core.String
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (target != null) 'target': target!,
        if (type != null) 'type': type!,
      };
}

/// The authentication and authorization settings for a BackendService.
class SecuritySettings {
  /// A URL referring to a networksecurity.ClientTlsPolicy resource that
  /// describes how clients should authenticate with this service's backends.
  ///
  /// clientTlsPolicy only applies to a global BackendService with the
  /// loadBalancingScheme set to INTERNAL_SELF_MANAGED. If left blank,
  /// communications are not encrypted. Note: This field currently has no
  /// impact.
  ///
  /// Optional.
  core.String? clientTlsPolicy;

  /// A list of Subject Alternative Names (SANs) that the client verifies during
  /// a mutual TLS handshake with an server/endpoint for this BackendService.
  ///
  /// When the server presents its X.509 certificate to the client, the client
  /// inspects the certificate's subjectAltName field. If the field contains one
  /// of the specified values, the communication continues. Otherwise, it fails.
  /// This additional check enables the client to verify that the server is
  /// authorized to run the requested service. Note that the contents of the
  /// server certificate's subjectAltName field are configured by the Public Key
  /// Infrastructure which provisions server identities. Only applies to a
  /// global BackendService with loadBalancingScheme set to
  /// INTERNAL_SELF_MANAGED. Only applies when BackendService has an attached
  /// clientTlsPolicy with clientCertificate (mTLS mode). Note: This field
  /// currently has no impact.
  ///
  /// Optional.
  core.List<core.String>? subjectAltNames;

  SecuritySettings({
    this.clientTlsPolicy,
    this.subjectAltNames,
  });

  SecuritySettings.fromJson(core.Map json_)
      : this(
          clientTlsPolicy: json_.containsKey('clientTlsPolicy')
              ? json_['clientTlsPolicy'] as core.String
              : null,
          subjectAltNames: json_.containsKey('subjectAltNames')
              ? (json_['subjectAltNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (clientTlsPolicy != null) 'clientTlsPolicy': clientTlsPolicy!,
        if (subjectAltNames != null) 'subjectAltNames': subjectAltNames!,
      };
}

/// An instance serial console output.
class SerialPortOutput {
  /// The contents of the console output.
  ///
  /// Output only.
  core.String? contents;

  /// Type of the resource.
  ///
  /// Always compute#serialPortOutput for serial port output.
  ///
  /// Output only.
  core.String? kind;

  /// The position of the next byte of content, regardless of whether the
  /// content exists, following the output returned in the `contents` property.
  ///
  /// Use this value in the next request as the start parameter.
  ///
  /// Output only.
  core.String? next;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The starting byte position of the output that was returned.
  ///
  /// This should match the start parameter sent with the request. If the serial
  /// console output exceeds the size of the buffer (1 MB), older output is
  /// overwritten by newer content. The output start value will indicate the
  /// byte position of the output that was returned, which might be different
  /// than the `start` value that was specified in the request.
  core.String? start;

  SerialPortOutput({
    this.contents,
    this.kind,
    this.next,
    this.selfLink,
    this.start,
  });

  SerialPortOutput.fromJson(core.Map json_)
      : this(
          contents: json_.containsKey('contents')
              ? json_['contents'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          next: json_.containsKey('next') ? json_['next'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          start:
              json_.containsKey('start') ? json_['start'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (contents != null) 'contents': contents!,
        if (kind != null) 'kind': kind!,
        if (next != null) 'next': next!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (start != null) 'start': start!,
      };
}

class ServerBinding {
  ///
  /// Possible string values are:
  /// - "RESTART_NODE_ON_ANY_SERVER" : Node may associate with any physical
  /// server over its lifetime.
  /// - "RESTART_NODE_ON_MINIMAL_SERVERS" : Node may associate with minimal
  /// physical servers over its lifetime.
  /// - "SERVER_BINDING_TYPE_UNSPECIFIED"
  core.String? type;

  ServerBinding({
    this.type,
  });

  ServerBinding.fromJson(core.Map json_)
      : this(
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (type != null) 'type': type!,
      };
}

/// A service account.
typedef ServiceAccount = $Shared02;

/// Represents a ServiceAttachment resource.
///
/// A service attachment represents a service that a producer has exposed. It
/// encapsulates the load balancer which fronts the service runs and a list of
/// NAT IP ranges that the producers uses to represent the consumers connecting
/// to the service. next tag = 20
class ServiceAttachment {
  /// An array of connections for all the consumers connected to this service
  /// attachment.
  ///
  /// Output only.
  core.List<ServiceAttachmentConnectedEndpoint>? connectedEndpoints;

  /// The connection preference of service attachment.
  ///
  /// The value can be set to ACCEPT_AUTOMATIC. An ACCEPT_AUTOMATIC service
  /// attachment is one that always accepts the connection from consumer
  /// forwarding rules.
  /// Possible string values are:
  /// - "ACCEPT_AUTOMATIC"
  /// - "ACCEPT_MANUAL"
  /// - "CONNECTION_PREFERENCE_UNSPECIFIED"
  core.String? connectionPreference;

  /// Projects that are allowed to connect to this service attachment.
  core.List<ServiceAttachmentConsumerProjectLimit>? consumerAcceptLists;

  /// Projects that are not allowed to connect to this service attachment.
  ///
  /// The project can be specified using its id or number.
  core.List<core.String>? consumerRejectLists;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// If specified, the domain name will be used during the integration between
  /// the PSC connected endpoints and the Cloud DNS.
  ///
  /// For example, this is a valid domain name: "p.mycompany.com.". Current max
  /// number of domain names supported is 1.
  core.List<core.String>? domainNames;

  /// If true, enable the proxy protocol which is for supplying client TCP/IP
  /// address data in TCP connections that traverse proxies on their way to
  /// destination servers.
  core.bool? enableProxyProtocol;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// ServiceAttachment. An up-to-date fingerprint must be provided in order to
  /// patch/update the ServiceAttachment; otherwise, the request will fail with
  /// error 412 conditionNotMet. To see the latest fingerprint, make a get()
  /// request to retrieve the ServiceAttachment.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#serviceAttachment for service attachments.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// An array of URLs where each entry is the URL of a subnet provided by the
  /// service producer to use for NAT in this service attachment.
  core.List<core.String>? natSubnets;

  /// The URL of a forwarding rule with loadBalancingScheme INTERNAL* that is
  /// serving the endpoint identified by this service attachment.
  core.String? producerForwardingRule;

  /// An 128-bit global unique ID of the PSC service attachment.
  ///
  /// Output only.
  Uint128? pscServiceAttachmentId;

  /// URL of the region where the service attachment resides.
  ///
  /// This field applies only to the region resource. You must specify this
  /// field as part of the HTTP request URL. It is not settable as a field in
  /// the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The URL of a service serving the endpoint identified by this service
  /// attachment.
  core.String? targetService;

  ServiceAttachment({
    this.connectedEndpoints,
    this.connectionPreference,
    this.consumerAcceptLists,
    this.consumerRejectLists,
    this.creationTimestamp,
    this.description,
    this.domainNames,
    this.enableProxyProtocol,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.natSubnets,
    this.producerForwardingRule,
    this.pscServiceAttachmentId,
    this.region,
    this.selfLink,
    this.targetService,
  });

  ServiceAttachment.fromJson(core.Map json_)
      : this(
          connectedEndpoints: json_.containsKey('connectedEndpoints')
              ? (json_['connectedEndpoints'] as core.List)
                  .map((value) => ServiceAttachmentConnectedEndpoint.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          connectionPreference: json_.containsKey('connectionPreference')
              ? json_['connectionPreference'] as core.String
              : null,
          consumerAcceptLists: json_.containsKey('consumerAcceptLists')
              ? (json_['consumerAcceptLists'] as core.List)
                  .map((value) =>
                      ServiceAttachmentConsumerProjectLimit.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          consumerRejectLists: json_.containsKey('consumerRejectLists')
              ? (json_['consumerRejectLists'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          domainNames: json_.containsKey('domainNames')
              ? (json_['domainNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          enableProxyProtocol: json_.containsKey('enableProxyProtocol')
              ? json_['enableProxyProtocol'] as core.bool
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          natSubnets: json_.containsKey('natSubnets')
              ? (json_['natSubnets'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          producerForwardingRule: json_.containsKey('producerForwardingRule')
              ? json_['producerForwardingRule'] as core.String
              : null,
          pscServiceAttachmentId: json_.containsKey('pscServiceAttachmentId')
              ? Uint128.fromJson(json_['pscServiceAttachmentId']
                  as core.Map<core.String, core.dynamic>)
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          targetService: json_.containsKey('targetService')
              ? json_['targetService'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (connectedEndpoints != null)
          'connectedEndpoints': connectedEndpoints!,
        if (connectionPreference != null)
          'connectionPreference': connectionPreference!,
        if (consumerAcceptLists != null)
          'consumerAcceptLists': consumerAcceptLists!,
        if (consumerRejectLists != null)
          'consumerRejectLists': consumerRejectLists!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (domainNames != null) 'domainNames': domainNames!,
        if (enableProxyProtocol != null)
          'enableProxyProtocol': enableProxyProtocol!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (natSubnets != null) 'natSubnets': natSubnets!,
        if (producerForwardingRule != null)
          'producerForwardingRule': producerForwardingRule!,
        if (pscServiceAttachmentId != null)
          'pscServiceAttachmentId': pscServiceAttachmentId!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (targetService != null) 'targetService': targetService!,
      };
}

class ServiceAttachmentAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ServiceAttachmentAggregatedListWarningData({
    this.key,
    this.value,
  });

  ServiceAttachmentAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ServiceAttachmentAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ServiceAttachmentAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ServiceAttachmentAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ServiceAttachmentAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ServiceAttachmentAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of ServiceAttachmentsScopedList.
class ServiceAttachmentAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ServiceAttachmentsScopedList resources.
  core.Map<core.String, ServiceAttachmentsScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  ServiceAttachmentAggregatedListWarning? warning;

  ServiceAttachmentAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  ServiceAttachmentAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    ServiceAttachmentsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ServiceAttachmentAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

/// A connection connected to this service attachment.
///
/// Output only.
class ServiceAttachmentConnectedEndpoint {
  /// The url of a connected endpoint.
  core.String? endpoint;

  /// The PSC connection id of the connected endpoint.
  core.String? pscConnectionId;

  /// The status of a connected endpoint to this service attachment.
  /// Possible string values are:
  /// - "ACCEPTED" : The connection has been accepted by the producer.
  /// - "CLOSED" : The connection has been closed by the producer.
  /// - "NEEDS_ATTENTION" : The connection has been accepted by the producer,
  /// but the producer needs to take further action before the forwarding rule
  /// can serve traffic.
  /// - "PENDING" : The connection is pending acceptance by the producer.
  /// - "REJECTED" : The consumer is still connected but not using the
  /// connection.
  /// - "STATUS_UNSPECIFIED"
  core.String? status;

  ServiceAttachmentConnectedEndpoint({
    this.endpoint,
    this.pscConnectionId,
    this.status,
  });

  ServiceAttachmentConnectedEndpoint.fromJson(core.Map json_)
      : this(
          endpoint: json_.containsKey('endpoint')
              ? json_['endpoint'] as core.String
              : null,
          pscConnectionId: json_.containsKey('pscConnectionId')
              ? json_['pscConnectionId'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (endpoint != null) 'endpoint': endpoint!,
        if (pscConnectionId != null) 'pscConnectionId': pscConnectionId!,
        if (status != null) 'status': status!,
      };
}

class ServiceAttachmentConsumerProjectLimit {
  /// The value of the limit to set.
  core.int? connectionLimit;

  /// The project id or number for the project to set the limit for.
  core.String? projectIdOrNum;

  ServiceAttachmentConsumerProjectLimit({
    this.connectionLimit,
    this.projectIdOrNum,
  });

  ServiceAttachmentConsumerProjectLimit.fromJson(core.Map json_)
      : this(
          connectionLimit: json_.containsKey('connectionLimit')
              ? json_['connectionLimit'] as core.int
              : null,
          projectIdOrNum: json_.containsKey('projectIdOrNum')
              ? json_['projectIdOrNum'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (connectionLimit != null) 'connectionLimit': connectionLimit!,
        if (projectIdOrNum != null) 'projectIdOrNum': projectIdOrNum!,
      };
}

class ServiceAttachmentListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ServiceAttachmentListWarningData({
    this.key,
    this.value,
  });

  ServiceAttachmentListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ServiceAttachmentListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ServiceAttachmentListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ServiceAttachmentListWarning({
    this.code,
    this.data,
    this.message,
  });

  ServiceAttachmentListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ServiceAttachmentListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ServiceAttachmentList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of ServiceAttachment resources.
  core.List<ServiceAttachment>? items;

  /// Type of the resource.
  ///
  /// Always compute#serviceAttachment for service attachments.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ServiceAttachmentListWarning? warning;

  ServiceAttachmentList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ServiceAttachmentList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => ServiceAttachment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ServiceAttachmentListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class ServiceAttachmentsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ServiceAttachmentsScopedListWarningData({
    this.key,
    this.value,
  });

  ServiceAttachmentsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of service attachments when
/// the list is empty.
class ServiceAttachmentsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ServiceAttachmentsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ServiceAttachmentsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  ServiceAttachmentsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      ServiceAttachmentsScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class ServiceAttachmentsScopedList {
  /// A list of ServiceAttachments contained in this scope.
  core.List<ServiceAttachment>? serviceAttachments;

  /// Informational warning which replaces the list of service attachments when
  /// the list is empty.
  ServiceAttachmentsScopedListWarning? warning;

  ServiceAttachmentsScopedList({
    this.serviceAttachments,
    this.warning,
  });

  ServiceAttachmentsScopedList.fromJson(core.Map json_)
      : this(
          serviceAttachments: json_.containsKey('serviceAttachments')
              ? (json_['serviceAttachments'] as core.List)
                  .map((value) => ServiceAttachment.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? ServiceAttachmentsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (serviceAttachments != null)
          'serviceAttachments': serviceAttachments!,
        if (warning != null) 'warning': warning!,
      };
}

/// The share setting for reservations and sole tenancy node groups.
class ShareSettings {
  /// A map of project id and project config.
  ///
  /// This is only valid when share_type's value is SPECIFIC_PROJECTS.
  core.Map<core.String, ShareSettingsProjectConfig>? projectMap;

  /// Type of sharing for this shared-reservation
  /// Possible string values are:
  /// - "LOCAL" : Default value.
  /// - "ORGANIZATION" : Shared-reservation is open to entire Organization
  /// - "SHARE_TYPE_UNSPECIFIED" : Default value. This value is unused.
  /// - "SPECIFIC_PROJECTS" : Shared-reservation is open to specific projects
  core.String? shareType;

  ShareSettings({
    this.projectMap,
    this.shareType,
  });

  ShareSettings.fromJson(core.Map json_)
      : this(
          projectMap: json_.containsKey('projectMap')
              ? (json_['projectMap'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    ShareSettingsProjectConfig.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          shareType: json_.containsKey('shareType')
              ? json_['shareType'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (projectMap != null) 'projectMap': projectMap!,
        if (shareType != null) 'shareType': shareType!,
      };
}

/// Config for each project in the share settings.
class ShareSettingsProjectConfig {
  /// The project ID, should be same as the key of this project config in the
  /// parent map.
  core.String? projectId;

  ShareSettingsProjectConfig({
    this.projectId,
  });

  ShareSettingsProjectConfig.fromJson(core.Map json_)
      : this(
          projectId: json_.containsKey('projectId')
              ? json_['projectId'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (projectId != null) 'projectId': projectId!,
      };
}

/// A set of Shielded Instance options.
class ShieldedInstanceConfig {
  /// Defines whether the instance has integrity monitoring enabled.
  ///
  /// Enabled by default.
  core.bool? enableIntegrityMonitoring;

  /// Defines whether the instance has Secure Boot enabled.
  ///
  /// Disabled by default.
  core.bool? enableSecureBoot;

  /// Defines whether the instance has the vTPM enabled.
  ///
  /// Enabled by default.
  core.bool? enableVtpm;

  ShieldedInstanceConfig({
    this.enableIntegrityMonitoring,
    this.enableSecureBoot,
    this.enableVtpm,
  });

  ShieldedInstanceConfig.fromJson(core.Map json_)
      : this(
          enableIntegrityMonitoring:
              json_.containsKey('enableIntegrityMonitoring')
                  ? json_['enableIntegrityMonitoring'] as core.bool
                  : null,
          enableSecureBoot: json_.containsKey('enableSecureBoot')
              ? json_['enableSecureBoot'] as core.bool
              : null,
          enableVtpm: json_.containsKey('enableVtpm')
              ? json_['enableVtpm'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (enableIntegrityMonitoring != null)
          'enableIntegrityMonitoring': enableIntegrityMonitoring!,
        if (enableSecureBoot != null) 'enableSecureBoot': enableSecureBoot!,
        if (enableVtpm != null) 'enableVtpm': enableVtpm!,
      };
}

/// A Shielded Instance Identity.
class ShieldedInstanceIdentity {
  /// An Endorsement Key (EK) made by the RSA 2048 algorithm issued to the
  /// Shielded Instance's vTPM.
  ShieldedInstanceIdentityEntry? encryptionKey;

  /// Type of the resource.
  ///
  /// Always compute#shieldedInstanceIdentity for shielded Instance identity
  /// entry.
  ///
  /// Output only.
  core.String? kind;

  /// An Attestation Key (AK) made by the RSA 2048 algorithm issued to the
  /// Shielded Instance's vTPM.
  ShieldedInstanceIdentityEntry? signingKey;

  ShieldedInstanceIdentity({
    this.encryptionKey,
    this.kind,
    this.signingKey,
  });

  ShieldedInstanceIdentity.fromJson(core.Map json_)
      : this(
          encryptionKey: json_.containsKey('encryptionKey')
              ? ShieldedInstanceIdentityEntry.fromJson(
                  json_['encryptionKey'] as core.Map<core.String, core.dynamic>)
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          signingKey: json_.containsKey('signingKey')
              ? ShieldedInstanceIdentityEntry.fromJson(
                  json_['signingKey'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (encryptionKey != null) 'encryptionKey': encryptionKey!,
        if (kind != null) 'kind': kind!,
        if (signingKey != null) 'signingKey': signingKey!,
      };
}

/// A Shielded Instance Identity Entry.
class ShieldedInstanceIdentityEntry {
  /// A PEM-encoded X.509 certificate.
  ///
  /// This field can be empty.
  core.String? ekCert;

  /// A PEM-encoded public key.
  core.String? ekPub;

  ShieldedInstanceIdentityEntry({
    this.ekCert,
    this.ekPub,
  });

  ShieldedInstanceIdentityEntry.fromJson(core.Map json_)
      : this(
          ekCert: json_.containsKey('ekCert')
              ? json_['ekCert'] as core.String
              : null,
          ekPub:
              json_.containsKey('ekPub') ? json_['ekPub'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ekCert != null) 'ekCert': ekCert!,
        if (ekPub != null) 'ekPub': ekPub!,
      };
}

/// The policy describes the baseline against which Instance boot integrity is
/// measured.
class ShieldedInstanceIntegrityPolicy {
  /// Updates the integrity policy baseline using the measurements from the VM
  /// instance's most recent boot.
  core.bool? updateAutoLearnPolicy;

  ShieldedInstanceIntegrityPolicy({
    this.updateAutoLearnPolicy,
  });

  ShieldedInstanceIntegrityPolicy.fromJson(core.Map json_)
      : this(
          updateAutoLearnPolicy: json_.containsKey('updateAutoLearnPolicy')
              ? json_['updateAutoLearnPolicy'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (updateAutoLearnPolicy != null)
          'updateAutoLearnPolicy': updateAutoLearnPolicy!,
      };
}

/// Represents a customer-supplied Signing Key used by Cloud CDN Signed URLs
class SignedUrlKey {
  /// Name of the key.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? keyName;

  /// 128-bit key value used for signing the URL.
  ///
  /// The key value must be a valid RFC 4648 Section 5 base64url encoded string.
  core.String? keyValue;

  SignedUrlKey({
    this.keyName,
    this.keyValue,
  });

  SignedUrlKey.fromJson(core.Map json_)
      : this(
          keyName: json_.containsKey('keyName')
              ? json_['keyName'] as core.String
              : null,
          keyValue: json_.containsKey('keyValue')
              ? json_['keyValue'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (keyName != null) 'keyName': keyName!,
        if (keyValue != null) 'keyValue': keyValue!,
      };
}

/// Represents a Persistent Disk Snapshot resource.
///
/// You can use snapshots to back up data on a regular interval. For more
/// information, read Creating persistent disk snapshots.
class Snapshot {
  /// The architecture of the snapshot.
  ///
  /// Valid values are ARM64 or X86_64.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ARCHITECTURE_UNSPECIFIED" : Default value indicating Architecture is
  /// not set.
  /// - "ARM64" : Machines with architecture ARM64
  /// - "X86_64" : Machines with architecture X86_64
  core.String? architecture;

  /// Set to true if snapshots are automatically created by applying resource
  /// policy on the target disk.
  ///
  /// Output only.
  core.bool? autoCreated;

  /// Creates the new snapshot in the snapshot chain labeled with the specified
  /// name.
  ///
  /// The chain name must be 1-63 characters long and comply with RFC1035. This
  /// is an uncommon option only for advanced service owners who needs to create
  /// separate snapshot chains, for example, for chargeback tracking. When you
  /// describe your snapshot resource, this field is visible only if it has a
  /// non-empty value.
  core.String? chainName;

  /// Size in bytes of the snapshot at creation time.
  ///
  /// Output only.
  core.String? creationSizeBytes;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Size of the source disk, specified in GB.
  ///
  /// Output only.
  core.String? diskSizeGb;

  /// Number of bytes downloaded to restore a snapshot to a disk.
  ///
  /// Output only.
  core.String? downloadBytes;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#snapshot for Snapshot resources.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this snapshot, which is
  /// essentially a hash of the labels set used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve a snapshot.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels to apply to this snapshot.
  ///
  /// These can be later modified by the setLabels method. Label values may be
  /// empty.
  core.Map<core.String, core.String>? labels;

  /// Integer license codes indicating which licenses are attached to this
  /// snapshot.
  ///
  /// Output only.
  core.List<core.String>? licenseCodes;

  /// A list of public visible licenses that apply to this snapshot.
  ///
  /// This can be because the original image had licenses attached (such as a
  /// Windows image).
  ///
  /// Output only.
  core.List<core.String>? licenses;

  /// An opaque location hint used to place the snapshot close to other
  /// resources.
  ///
  /// This field is for use by internal tools that use the public API.
  core.String? locationHint;

  /// Name of the resource; provided by the client when the resource is created.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? satisfiesPzs;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Encrypts the snapshot using a customer-supplied encryption key.
  ///
  /// After you encrypt a snapshot using a customer-supplied key, you must
  /// provide the same key if you use the snapshot later. For example, you must
  /// provide the encryption key when you create a disk from the encrypted
  /// snapshot in a future request. Customer-supplied encryption keys do not
  /// protect access to metadata of the snapshot. If you do not provide an
  /// encryption key when creating the snapshot, then the snapshot will be
  /// encrypted using an automatically generated key and you do not need to
  /// provide a key to use the snapshot later.
  CustomerEncryptionKey? snapshotEncryptionKey;

  /// Indicates the type of the snapshot.
  /// Possible string values are:
  /// - "ARCHIVE"
  /// - "STANDARD"
  core.String? snapshotType;

  /// The source disk used to create this snapshot.
  core.String? sourceDisk;

  /// The customer-supplied encryption key of the source disk.
  ///
  /// Required if the source disk is protected by a customer-supplied encryption
  /// key.
  CustomerEncryptionKey? sourceDiskEncryptionKey;

  /// The ID value of the disk used to create this snapshot.
  ///
  /// This value may be used to determine whether the snapshot was taken from
  /// the current or a previous instance of a given disk name.
  ///
  /// Output only.
  core.String? sourceDiskId;

  /// URL of the resource policy which created this scheduled snapshot.
  ///
  /// Output only.
  core.String? sourceSnapshotSchedulePolicy;

  /// ID of the resource policy which created this scheduled snapshot.
  ///
  /// Output only.
  core.String? sourceSnapshotSchedulePolicyId;

  /// The status of the snapshot.
  ///
  /// This can be CREATING, DELETING, FAILED, READY, or UPLOADING.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING" : Snapshot creation is in progress.
  /// - "DELETING" : Snapshot is currently being deleted.
  /// - "FAILED" : Snapshot creation failed.
  /// - "READY" : Snapshot has been created successfully.
  /// - "UPLOADING" : Snapshot is being uploaded.
  core.String? status;

  /// A size of the storage used by the snapshot.
  ///
  /// As snapshots share storage, this number is expected to change with
  /// snapshot creation/deletion.
  ///
  /// Output only.
  core.String? storageBytes;

  /// An indicator whether storageBytes is in a stable state or it is being
  /// adjusted as a result of shared storage reallocation.
  ///
  /// This status can either be UPDATING, meaning the size of the snapshot is
  /// being updated, or UP_TO_DATE, meaning the size of the snapshot is
  /// up-to-date.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "UPDATING"
  /// - "UP_TO_DATE"
  core.String? storageBytesStatus;

  /// Cloud Storage bucket storage location of the snapshot (regional or
  /// multi-regional).
  core.List<core.String>? storageLocations;

  Snapshot({
    this.architecture,
    this.autoCreated,
    this.chainName,
    this.creationSizeBytes,
    this.creationTimestamp,
    this.description,
    this.diskSizeGb,
    this.downloadBytes,
    this.id,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.licenseCodes,
    this.licenses,
    this.locationHint,
    this.name,
    this.satisfiesPzs,
    this.selfLink,
    this.snapshotEncryptionKey,
    this.snapshotType,
    this.sourceDisk,
    this.sourceDiskEncryptionKey,
    this.sourceDiskId,
    this.sourceSnapshotSchedulePolicy,
    this.sourceSnapshotSchedulePolicyId,
    this.status,
    this.storageBytes,
    this.storageBytesStatus,
    this.storageLocations,
  });

  Snapshot.fromJson(core.Map json_)
      : this(
          architecture: json_.containsKey('architecture')
              ? json_['architecture'] as core.String
              : null,
          autoCreated: json_.containsKey('autoCreated')
              ? json_['autoCreated'] as core.bool
              : null,
          chainName: json_.containsKey('chainName')
              ? json_['chainName'] as core.String
              : null,
          creationSizeBytes: json_.containsKey('creationSizeBytes')
              ? json_['creationSizeBytes'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          diskSizeGb: json_.containsKey('diskSizeGb')
              ? json_['diskSizeGb'] as core.String
              : null,
          downloadBytes: json_.containsKey('downloadBytes')
              ? json_['downloadBytes'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          licenseCodes: json_.containsKey('licenseCodes')
              ? (json_['licenseCodes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          licenses: json_.containsKey('licenses')
              ? (json_['licenses'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          locationHint: json_.containsKey('locationHint')
              ? json_['locationHint'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          satisfiesPzs: json_.containsKey('satisfiesPzs')
              ? json_['satisfiesPzs'] as core.bool
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          snapshotEncryptionKey: json_.containsKey('snapshotEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['snapshotEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          snapshotType: json_.containsKey('snapshotType')
              ? json_['snapshotType'] as core.String
              : null,
          sourceDisk: json_.containsKey('sourceDisk')
              ? json_['sourceDisk'] as core.String
              : null,
          sourceDiskEncryptionKey: json_.containsKey('sourceDiskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['sourceDiskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceDiskId: json_.containsKey('sourceDiskId')
              ? json_['sourceDiskId'] as core.String
              : null,
          sourceSnapshotSchedulePolicy:
              json_.containsKey('sourceSnapshotSchedulePolicy')
                  ? json_['sourceSnapshotSchedulePolicy'] as core.String
                  : null,
          sourceSnapshotSchedulePolicyId:
              json_.containsKey('sourceSnapshotSchedulePolicyId')
                  ? json_['sourceSnapshotSchedulePolicyId'] as core.String
                  : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          storageBytes: json_.containsKey('storageBytes')
              ? json_['storageBytes'] as core.String
              : null,
          storageBytesStatus: json_.containsKey('storageBytesStatus')
              ? json_['storageBytesStatus'] as core.String
              : null,
          storageLocations: json_.containsKey('storageLocations')
              ? (json_['storageLocations'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (architecture != null) 'architecture': architecture!,
        if (autoCreated != null) 'autoCreated': autoCreated!,
        if (chainName != null) 'chainName': chainName!,
        if (creationSizeBytes != null) 'creationSizeBytes': creationSizeBytes!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (diskSizeGb != null) 'diskSizeGb': diskSizeGb!,
        if (downloadBytes != null) 'downloadBytes': downloadBytes!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (licenseCodes != null) 'licenseCodes': licenseCodes!,
        if (licenses != null) 'licenses': licenses!,
        if (locationHint != null) 'locationHint': locationHint!,
        if (name != null) 'name': name!,
        if (satisfiesPzs != null) 'satisfiesPzs': satisfiesPzs!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (snapshotEncryptionKey != null)
          'snapshotEncryptionKey': snapshotEncryptionKey!,
        if (snapshotType != null) 'snapshotType': snapshotType!,
        if (sourceDisk != null) 'sourceDisk': sourceDisk!,
        if (sourceDiskEncryptionKey != null)
          'sourceDiskEncryptionKey': sourceDiskEncryptionKey!,
        if (sourceDiskId != null) 'sourceDiskId': sourceDiskId!,
        if (sourceSnapshotSchedulePolicy != null)
          'sourceSnapshotSchedulePolicy': sourceSnapshotSchedulePolicy!,
        if (sourceSnapshotSchedulePolicyId != null)
          'sourceSnapshotSchedulePolicyId': sourceSnapshotSchedulePolicyId!,
        if (status != null) 'status': status!,
        if (storageBytes != null) 'storageBytes': storageBytes!,
        if (storageBytesStatus != null)
          'storageBytesStatus': storageBytesStatus!,
        if (storageLocations != null) 'storageLocations': storageLocations!,
      };
}

class SnapshotListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SnapshotListWarningData({
    this.key,
    this.value,
  });

  SnapshotListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SnapshotListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SnapshotListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SnapshotListWarning({
    this.code,
    this.data,
    this.message,
  });

  SnapshotListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SnapshotListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Snapshot resources.
class SnapshotList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Snapshot resources.
  core.List<Snapshot>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  SnapshotListWarning? warning;

  SnapshotList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  SnapshotList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Snapshot.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? SnapshotListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class SourceDiskEncryptionKey {
  /// The customer-supplied encryption key of the source disk.
  ///
  /// Required if the source disk is protected by a customer-supplied encryption
  /// key.
  CustomerEncryptionKey? diskEncryptionKey;

  /// URL of the disk attached to the source instance.
  ///
  /// This can be a full or valid partial URL. For example, the following are
  /// valid values: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /disks/disk - projects/project/zones/zone/disks/disk -
  /// zones/zone/disks/disk
  core.String? sourceDisk;

  SourceDiskEncryptionKey({
    this.diskEncryptionKey,
    this.sourceDisk,
  });

  SourceDiskEncryptionKey.fromJson(core.Map json_)
      : this(
          diskEncryptionKey: json_.containsKey('diskEncryptionKey')
              ? CustomerEncryptionKey.fromJson(json_['diskEncryptionKey']
                  as core.Map<core.String, core.dynamic>)
              : null,
          sourceDisk: json_.containsKey('sourceDisk')
              ? json_['sourceDisk'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskEncryptionKey != null) 'diskEncryptionKey': diskEncryptionKey!,
        if (sourceDisk != null) 'sourceDisk': sourceDisk!,
      };
}

/// A specification of the parameters to use when creating the instance template
/// from a source instance.
class SourceInstanceParams {
  /// Attached disks configuration.
  ///
  /// If not provided, defaults are applied: For boot disk and any other R/W
  /// disks, new custom images will be created from each disk. For read-only
  /// disks, they will be attached in read-only mode. Local SSD disks will be
  /// created as blank volumes.
  core.List<DiskInstantiationConfig>? diskConfigs;

  SourceInstanceParams({
    this.diskConfigs,
  });

  SourceInstanceParams.fromJson(core.Map json_)
      : this(
          diskConfigs: json_.containsKey('diskConfigs')
              ? (json_['diskConfigs'] as core.List)
                  .map((value) => DiskInstantiationConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (diskConfigs != null) 'diskConfigs': diskConfigs!,
      };
}

/// DEPRECATED: Please use compute#instanceProperties instead.
///
/// New properties will not be added to this field.
class SourceInstanceProperties {
  /// Enables instances created based on this machine image to send packets with
  /// source IP addresses other than their own and receive packets with
  /// destination IP addresses other than their own.
  ///
  /// If these instances will be used as an IP gateway or it will be set as the
  /// next-hop in a Route resource, specify true. If unsure, leave this set to
  /// false. See the Enable IP forwarding documentation for more information.
  core.bool? canIpForward;

  /// Whether the instance created from this machine image should be protected
  /// against deletion.
  core.bool? deletionProtection;

  /// An optional text description for the instances that are created from this
  /// machine image.
  core.String? description;

  /// An array of disks that are associated with the instances that are created
  /// from this machine image.
  core.List<SavedAttachedDisk>? disks;

  /// A list of guest accelerator cards' type and count to use for instances
  /// created from this machine image.
  core.List<AcceleratorConfig>? guestAccelerators;

  /// KeyRevocationActionType of the instance.
  ///
  /// Supported options are "STOP" and "NONE". The default value is "NONE" if it
  /// is not specified.
  /// Possible string values are:
  /// - "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED" : Default value. This value is
  /// unused.
  /// - "NONE" : Indicates user chose no operation.
  /// - "STOP" : Indicates user chose to opt for VM shutdown on key revocation.
  core.String? keyRevocationActionType;

  /// Labels to apply to instances that are created from this machine image.
  core.Map<core.String, core.String>? labels;

  /// The machine type to use for instances that are created from this machine
  /// image.
  core.String? machineType;

  /// The metadata key/value pairs to assign to instances that are created from
  /// this machine image.
  ///
  /// These pairs can consist of custom metadata or predefined keys. See Project
  /// and instance metadata for more information.
  Metadata? metadata;

  /// Minimum cpu/platform to be used by instances created from this machine
  /// image.
  ///
  /// The instance may be scheduled on the specified or newer cpu/platform.
  /// Applicable values are the friendly names of CPU platforms, such as
  /// minCpuPlatform: "Intel Haswell" or minCpuPlatform: "Intel Sandy Bridge".
  /// For more information, read Specifying a Minimum CPU Platform.
  core.String? minCpuPlatform;

  /// An array of network access configurations for this interface.
  core.List<NetworkInterface>? networkInterfaces;

  /// Specifies the scheduling options for the instances that are created from
  /// this machine image.
  Scheduling? scheduling;

  /// A list of service accounts with specified scopes.
  ///
  /// Access tokens for these service accounts are available to the instances
  /// that are created from this machine image. Use metadata queries to obtain
  /// the access tokens for these instances.
  core.List<ServiceAccount>? serviceAccounts;

  /// A list of tags to apply to the instances that are created from this
  /// machine image.
  ///
  /// The tags identify valid sources or targets for network firewalls. The
  /// setTags method can modify this list of tags. Each tag within the list must
  /// comply with RFC1035.
  Tags? tags;

  SourceInstanceProperties({
    this.canIpForward,
    this.deletionProtection,
    this.description,
    this.disks,
    this.guestAccelerators,
    this.keyRevocationActionType,
    this.labels,
    this.machineType,
    this.metadata,
    this.minCpuPlatform,
    this.networkInterfaces,
    this.scheduling,
    this.serviceAccounts,
    this.tags,
  });

  SourceInstanceProperties.fromJson(core.Map json_)
      : this(
          canIpForward: json_.containsKey('canIpForward')
              ? json_['canIpForward'] as core.bool
              : null,
          deletionProtection: json_.containsKey('deletionProtection')
              ? json_['deletionProtection'] as core.bool
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.List)
                  .map((value) => SavedAttachedDisk.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          guestAccelerators: json_.containsKey('guestAccelerators')
              ? (json_['guestAccelerators'] as core.List)
                  .map((value) => AcceleratorConfig.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          keyRevocationActionType: json_.containsKey('keyRevocationActionType')
              ? json_['keyRevocationActionType'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          machineType: json_.containsKey('machineType')
              ? json_['machineType'] as core.String
              : null,
          metadata: json_.containsKey('metadata')
              ? Metadata.fromJson(
                  json_['metadata'] as core.Map<core.String, core.dynamic>)
              : null,
          minCpuPlatform: json_.containsKey('minCpuPlatform')
              ? json_['minCpuPlatform'] as core.String
              : null,
          networkInterfaces: json_.containsKey('networkInterfaces')
              ? (json_['networkInterfaces'] as core.List)
                  .map((value) => NetworkInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          scheduling: json_.containsKey('scheduling')
              ? Scheduling.fromJson(
                  json_['scheduling'] as core.Map<core.String, core.dynamic>)
              : null,
          serviceAccounts: json_.containsKey('serviceAccounts')
              ? (json_['serviceAccounts'] as core.List)
                  .map((value) => ServiceAccount.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          tags: json_.containsKey('tags')
              ? Tags.fromJson(
                  json_['tags'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (canIpForward != null) 'canIpForward': canIpForward!,
        if (deletionProtection != null)
          'deletionProtection': deletionProtection!,
        if (description != null) 'description': description!,
        if (disks != null) 'disks': disks!,
        if (guestAccelerators != null) 'guestAccelerators': guestAccelerators!,
        if (keyRevocationActionType != null)
          'keyRevocationActionType': keyRevocationActionType!,
        if (labels != null) 'labels': labels!,
        if (machineType != null) 'machineType': machineType!,
        if (metadata != null) 'metadata': metadata!,
        if (minCpuPlatform != null) 'minCpuPlatform': minCpuPlatform!,
        if (networkInterfaces != null) 'networkInterfaces': networkInterfaces!,
        if (scheduling != null) 'scheduling': scheduling!,
        if (serviceAccounts != null) 'serviceAccounts': serviceAccounts!,
        if (tags != null) 'tags': tags!,
      };
}

/// Represents an SSL Certificate resource.
///
/// Google Compute Engine has two SSL Certificate resources: *
/// \[Global\](/compute/docs/reference/rest/v1/sslCertificates) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionSslCertificates) The
/// sslCertificates are used by: - external HTTPS load balancers - SSL proxy
/// load balancers The regionSslCertificates are used by internal HTTPS load
/// balancers. Optionally, certificate file contents that you upload can contain
/// a set of up to five PEM-encoded certificates. The API call creates an object
/// (sslCertificate) that holds this data. You can use SSL keys and certificates
/// to secure connections to a load balancer. For more information, read
/// Creating and using SSL certificates, SSL certificates quotas and limits, and
/// Troubleshooting SSL certificates.
class SslCertificate {
  /// A value read into memory from a certificate file.
  ///
  /// The certificate file must be in PEM format. The certificate chain must be
  /// no greater than 5 certs long. The chain must include at least one
  /// intermediate cert.
  core.String? certificate;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Expire time of the certificate.
  ///
  /// RFC3339
  ///
  /// Output only.
  core.String? expireTime;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#sslCertificate for SSL certificates.
  ///
  /// Output only.
  core.String? kind;

  /// Configuration and status of a managed SSL certificate.
  SslCertificateManagedSslCertificate? managed;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// A value read into memory from a write-only private key file.
  ///
  /// The private key file must be in PEM format. For security, only insert
  /// requests include this field.
  core.String? privateKey;

  /// URL of the region where the regional SSL Certificate resides.
  ///
  /// This field is not applicable to global SSL Certificate.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Configuration and status of a self-managed SSL certificate.
  SslCertificateSelfManagedSslCertificate? selfManaged;

  /// Domains associated with the certificate via Subject Alternative Name.
  ///
  /// Output only.
  core.List<core.String>? subjectAlternativeNames;

  /// (Optional) Specifies the type of SSL certificate, either "SELF_MANAGED" or
  /// "MANAGED".
  ///
  /// If not specified, the certificate is self-managed and the fields
  /// certificate and private_key are used.
  /// Possible string values are:
  /// - "MANAGED" : Google-managed SSLCertificate.
  /// - "SELF_MANAGED" : Certificate uploaded by user.
  /// - "TYPE_UNSPECIFIED"
  core.String? type;

  SslCertificate({
    this.certificate,
    this.creationTimestamp,
    this.description,
    this.expireTime,
    this.id,
    this.kind,
    this.managed,
    this.name,
    this.privateKey,
    this.region,
    this.selfLink,
    this.selfManaged,
    this.subjectAlternativeNames,
    this.type,
  });

  SslCertificate.fromJson(core.Map json_)
      : this(
          certificate: json_.containsKey('certificate')
              ? json_['certificate'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          expireTime: json_.containsKey('expireTime')
              ? json_['expireTime'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          managed: json_.containsKey('managed')
              ? SslCertificateManagedSslCertificate.fromJson(
                  json_['managed'] as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          privateKey: json_.containsKey('privateKey')
              ? json_['privateKey'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          selfManaged: json_.containsKey('selfManaged')
              ? SslCertificateSelfManagedSslCertificate.fromJson(
                  json_['selfManaged'] as core.Map<core.String, core.dynamic>)
              : null,
          subjectAlternativeNames: json_.containsKey('subjectAlternativeNames')
              ? (json_['subjectAlternativeNames'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (certificate != null) 'certificate': certificate!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (expireTime != null) 'expireTime': expireTime!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (managed != null) 'managed': managed!,
        if (name != null) 'name': name!,
        if (privateKey != null) 'privateKey': privateKey!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (selfManaged != null) 'selfManaged': selfManaged!,
        if (subjectAlternativeNames != null)
          'subjectAlternativeNames': subjectAlternativeNames!,
        if (type != null) 'type': type!,
      };
}

class SslCertificateAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslCertificateAggregatedListWarningData({
    this.key,
    this.value,
  });

  SslCertificateAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SslCertificateAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslCertificateAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslCertificateAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslCertificateAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      SslCertificateAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SslCertificateAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SslCertificatesScopedList resources.
  core.Map<core.String, SslCertificatesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#sslCertificateAggregatedList for lists of SSL Certificates.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  SslCertificateAggregatedListWarning? warning;

  SslCertificateAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  SslCertificateAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    SslCertificatesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SslCertificateAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class SslCertificateListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslCertificateListWarningData({
    this.key,
    this.value,
  });

  SslCertificateListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SslCertificateListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslCertificateListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslCertificateListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslCertificateListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslCertificateListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of SslCertificate resources.
class SslCertificateList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SslCertificate resources.
  core.List<SslCertificate>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  SslCertificateListWarning? warning;

  SslCertificateList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  SslCertificateList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => SslCertificate.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? SslCertificateListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Configuration and status of a managed SSL certificate.
class SslCertificateManagedSslCertificate {
  /// Detailed statuses of the domains specified for managed certificate
  /// resource.
  ///
  /// Output only.
  core.Map<core.String, core.String>? domainStatus;

  /// The domains for which a managed SSL certificate will be generated.
  ///
  /// Each Google-managed SSL certificate supports up to the \[maximum number of
  /// domains per Google-managed SSL
  /// certificate\](/load-balancing/docs/quotas#ssl_certificates).
  core.List<core.String>? domains;

  /// Status of the managed certificate resource.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ACTIVE" : The certificate management is working, and a certificate has
  /// been provisioned.
  /// - "MANAGED_CERTIFICATE_STATUS_UNSPECIFIED"
  /// - "PROVISIONING" : The certificate management is working. GCP will attempt
  /// to provision the first certificate.
  /// - "PROVISIONING_FAILED" : Certificate provisioning failed due to an issue
  /// with the DNS or load balancing configuration. For details of which domain
  /// failed, consult domain_status field.
  /// - "PROVISIONING_FAILED_PERMANENTLY" : Certificate provisioning failed due
  /// to an issue with the DNS or load balancing configuration. It won't be
  /// retried. To try again delete and create a new managed SslCertificate
  /// resource. For details of which domain failed, consult domain_status field.
  /// - "RENEWAL_FAILED" : Renewal of the certificate has failed due to an issue
  /// with the DNS or load balancing configuration. The existing cert is still
  /// serving; however, it will expire shortly. To provision a renewed
  /// certificate, delete and create a new managed SslCertificate resource. For
  /// details on which domain failed, consult domain_status field.
  core.String? status;

  SslCertificateManagedSslCertificate({
    this.domainStatus,
    this.domains,
    this.status,
  });

  SslCertificateManagedSslCertificate.fromJson(core.Map json_)
      : this(
          domainStatus: json_.containsKey('domainStatus')
              ? (json_['domainStatus'] as core.Map<core.String, core.dynamic>)
                  .map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          domains: json_.containsKey('domains')
              ? (json_['domains'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (domainStatus != null) 'domainStatus': domainStatus!,
        if (domains != null) 'domains': domains!,
        if (status != null) 'status': status!,
      };
}

/// Configuration and status of a self-managed SSL certificate.
class SslCertificateSelfManagedSslCertificate {
  /// A local certificate file.
  ///
  /// The certificate must be in PEM format. The certificate chain must be no
  /// greater than 5 certs long. The chain must include at least one
  /// intermediate cert.
  core.String? certificate;

  /// A write-only private key in PEM format.
  ///
  /// Only insert requests will include this field.
  core.String? privateKey;

  SslCertificateSelfManagedSslCertificate({
    this.certificate,
    this.privateKey,
  });

  SslCertificateSelfManagedSslCertificate.fromJson(core.Map json_)
      : this(
          certificate: json_.containsKey('certificate')
              ? json_['certificate'] as core.String
              : null,
          privateKey: json_.containsKey('privateKey')
              ? json_['privateKey'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (certificate != null) 'certificate': certificate!,
        if (privateKey != null) 'privateKey': privateKey!,
      };
}

class SslCertificatesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslCertificatesScopedListWarningData({
    this.key,
    this.value,
  });

  SslCertificatesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class SslCertificatesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslCertificatesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslCertificatesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslCertificatesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslCertificatesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SslCertificatesScopedList {
  /// List of SslCertificates contained in this scope.
  core.List<SslCertificate>? sslCertificates;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  SslCertificatesScopedListWarning? warning;

  SslCertificatesScopedList({
    this.sslCertificates,
    this.warning,
  });

  SslCertificatesScopedList.fromJson(core.Map json_)
      : this(
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => SslCertificate.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SslCertificatesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
        if (warning != null) 'warning': warning!,
      };
}

class SslPoliciesAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslPoliciesAggregatedListWarningData({
    this.key,
    this.value,
  });

  SslPoliciesAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SslPoliciesAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslPoliciesAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslPoliciesAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslPoliciesAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslPoliciesAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SslPoliciesAggregatedList {
  core.String? etag;

  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SslPoliciesScopedList resources.
  core.Map<core.String, SslPoliciesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#sslPolicyAggregatedList for lists of SSL Policies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  SslPoliciesAggregatedListWarning? warning;

  SslPoliciesAggregatedList({
    this.etag,
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  SslPoliciesAggregatedList.fromJson(core.Map json_)
      : this(
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    SslPoliciesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SslPoliciesAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (etag != null) 'etag': etag!,
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class SslPoliciesListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslPoliciesListWarningData({
    this.key,
    this.value,
  });

  SslPoliciesListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SslPoliciesListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslPoliciesListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslPoliciesListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslPoliciesListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslPoliciesListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SslPoliciesList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SslPolicy resources.
  core.List<SslPolicy>? items;

  /// Type of the resource.
  ///
  /// Always compute#sslPoliciesList for lists of sslPolicies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  SslPoliciesListWarning? warning;

  SslPoliciesList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  SslPoliciesList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => SslPolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? SslPoliciesListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class SslPoliciesListAvailableFeaturesResponse {
  core.List<core.String>? features;

  SslPoliciesListAvailableFeaturesResponse({
    this.features,
  });

  SslPoliciesListAvailableFeaturesResponse.fromJson(core.Map json_)
      : this(
          features: json_.containsKey('features')
              ? (json_['features'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (features != null) 'features': features!,
      };
}

class SslPoliciesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslPoliciesScopedListWarningData({
    this.key,
    this.value,
  });

  SslPoliciesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of SSL policies when the list
/// is empty.
class SslPoliciesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslPoliciesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslPoliciesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SslPoliciesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslPoliciesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SslPoliciesScopedList {
  /// A list of SslPolicies contained in this scope.
  core.List<SslPolicy>? sslPolicies;

  /// Informational warning which replaces the list of SSL policies when the
  /// list is empty.
  SslPoliciesScopedListWarning? warning;

  SslPoliciesScopedList({
    this.sslPolicies,
    this.warning,
  });

  SslPoliciesScopedList.fromJson(core.Map json_)
      : this(
          sslPolicies: json_.containsKey('sslPolicies')
              ? (json_['sslPolicies'] as core.List)
                  .map((value) => SslPolicy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SslPoliciesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslPolicies != null) 'sslPolicies': sslPolicies!,
        if (warning != null) 'warning': warning!,
      };
}

class SslPolicyWarningsData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SslPolicyWarningsData({
    this.key,
    this.value,
  });

  SslPolicyWarningsData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

class SslPolicyWarnings {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SslPolicyWarningsData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SslPolicyWarnings({
    this.code,
    this.data,
    this.message,
  });

  SslPolicyWarnings.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SslPolicyWarningsData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Represents an SSL Policy resource.
///
/// Use SSL policies to control the SSL features, such as versions and cipher
/// suites, offered by an HTTPS or SSL Proxy load balancer. For more
/// information, read SSL Policy Concepts.
class SslPolicy {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// A list of features enabled when the selected profile is CUSTOM.
  ///
  /// The method returns the set of features that can be specified in this list.
  /// This field must be empty if the profile is not CUSTOM.
  core.List<core.String>? customFeatures;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The list of features enabled in the SSL policy.
  ///
  /// Output only.
  core.List<core.String>? enabledFeatures;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a SslPolicy.
  /// An up-to-date fingerprint must be provided in order to update the
  /// SslPolicy, otherwise the request will fail with error 412 conditionNotMet.
  /// To see the latest fingerprint, make a get() request to retrieve an
  /// SslPolicy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#sslPolicyfor SSL policies.
  ///
  /// Output only.
  core.String? kind;

  /// The minimum version of SSL protocol that can be used by the clients to
  /// establish a connection with the load balancer.
  ///
  /// This can be one of TLS_1_0, TLS_1_1, TLS_1_2.
  /// Possible string values are:
  /// - "TLS_1_0" : TLS 1.0
  /// - "TLS_1_1" : TLS 1.1
  /// - "TLS_1_2" : TLS 1.2
  core.String? minTlsVersion;

  /// Name of the resource.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// Profile specifies the set of SSL features that can be used by the load
  /// balancer when negotiating SSL with clients.
  ///
  /// This can be one of COMPATIBLE, MODERN, RESTRICTED, or CUSTOM. If using
  /// CUSTOM, the set of SSL features to enable must be specified in the
  /// customFeatures field.
  /// Possible string values are:
  /// - "COMPATIBLE" : Compatible profile. Allows the broadset set of clients,
  /// even those which support only out-of-date SSL features to negotiate with
  /// the load balancer.
  /// - "CUSTOM" : Custom profile. Allow only the set of allowed SSL features
  /// specified in the customFeatures field.
  /// - "MODERN" : Modern profile. Supports a wide set of SSL features, allowing
  /// modern clients to negotiate SSL with the load balancer.
  /// - "RESTRICTED" : Restricted profile. Supports a reduced set of SSL
  /// features, intended to meet stricter compliance requirements.
  core.String? profile;

  /// URL of the region where the regional SSL policy resides.
  ///
  /// This field is not applicable to global SSL policies.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// If potential misconfigurations are detected for this SSL policy, this
  /// field will be populated with warning messages.
  ///
  /// Output only.
  core.List<SslPolicyWarnings>? warnings;

  SslPolicy({
    this.creationTimestamp,
    this.customFeatures,
    this.description,
    this.enabledFeatures,
    this.fingerprint,
    this.id,
    this.kind,
    this.minTlsVersion,
    this.name,
    this.profile,
    this.region,
    this.selfLink,
    this.warnings,
  });

  SslPolicy.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          customFeatures: json_.containsKey('customFeatures')
              ? (json_['customFeatures'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          enabledFeatures: json_.containsKey('enabledFeatures')
              ? (json_['enabledFeatures'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          minTlsVersion: json_.containsKey('minTlsVersion')
              ? json_['minTlsVersion'] as core.String
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          profile: json_.containsKey('profile')
              ? json_['profile'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warnings: json_.containsKey('warnings')
              ? (json_['warnings'] as core.List)
                  .map((value) => SslPolicyWarnings.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (customFeatures != null) 'customFeatures': customFeatures!,
        if (description != null) 'description': description!,
        if (enabledFeatures != null) 'enabledFeatures': enabledFeatures!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (minTlsVersion != null) 'minTlsVersion': minTlsVersion!,
        if (name != null) 'name': name!,
        if (profile != null) 'profile': profile!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warnings != null) 'warnings': warnings!,
      };
}

class SslPolicyReference {
  /// URL of the SSL policy resource.
  ///
  /// Set this to empty string to clear any existing SSL policy associated with
  /// the target proxy resource.
  core.String? sslPolicy;

  SslPolicyReference({
    this.sslPolicy,
  });

  SslPolicyReference.fromJson(core.Map json_)
      : this(
          sslPolicy: json_.containsKey('sslPolicy')
              ? json_['sslPolicy'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslPolicy != null) 'sslPolicy': sslPolicy!,
      };
}

class StatefulPolicy {
  StatefulPolicyPreservedState? preservedState;

  StatefulPolicy({
    this.preservedState,
  });

  StatefulPolicy.fromJson(core.Map json_)
      : this(
          preservedState: json_.containsKey('preservedState')
              ? StatefulPolicyPreservedState.fromJson(json_['preservedState']
                  as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (preservedState != null) 'preservedState': preservedState!,
      };
}

/// Configuration of preserved resources.
class StatefulPolicyPreservedState {
  /// Disks created on the instances that will be preserved on instance delete,
  /// update, etc.
  ///
  /// This map is keyed with the device names of the disks.
  core.Map<core.String, StatefulPolicyPreservedStateDiskDevice>? disks;

  StatefulPolicyPreservedState({
    this.disks,
  });

  StatefulPolicyPreservedState.fromJson(core.Map json_)
      : this(
          disks: json_.containsKey('disks')
              ? (json_['disks'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    StatefulPolicyPreservedStateDiskDevice.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (disks != null) 'disks': disks!,
      };
}

class StatefulPolicyPreservedStateDiskDevice {
  /// These stateful disks will never be deleted during autohealing, update or
  /// VM instance recreate operations.
  ///
  /// This flag is used to configure if the disk should be deleted after it is
  /// no longer used by the group, e.g. when the given instance or the whole
  /// group is deleted. Note: disks attached in READ_ONLY mode cannot be
  /// auto-deleted.
  /// Possible string values are:
  /// - "NEVER"
  /// - "ON_PERMANENT_INSTANCE_DELETION"
  core.String? autoDelete;

  StatefulPolicyPreservedStateDiskDevice({
    this.autoDelete,
  });

  StatefulPolicyPreservedStateDiskDevice.fromJson(core.Map json_)
      : this(
          autoDelete: json_.containsKey('autoDelete')
              ? json_['autoDelete'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (autoDelete != null) 'autoDelete': autoDelete!,
      };
}

/// Represents a Subnetwork resource.
///
/// A subnetwork (also known as a subnet) is a logical partition of a Virtual
/// Private Cloud network with one primary IP range and zero or more secondary
/// IP ranges. For more information, read Virtual Private Cloud (VPC) Network.
class Subnetwork {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource. This field can be set
  /// only at resource creation time.
  core.String? description;

  /// Whether to enable flow logging for this subnetwork.
  ///
  /// If this field is not explicitly set, it will not appear in get listings.
  /// If not set the default behavior is determined by the org policy, if there
  /// is no org policy specified, then it will default to disabled. This field
  /// isn't supported with the purpose field set to
  /// INTERNAL_HTTPS_LOAD_BALANCER.
  core.bool? enableFlowLogs;

  /// The external IPv6 address range that is assigned to this subnetwork.
  ///
  /// Output only.
  core.String? externalIpv6Prefix;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// Subnetwork. An up-to-date fingerprint must be provided in order to update
  /// the Subnetwork, otherwise the request will fail with error 412
  /// conditionNotMet. To see the latest fingerprint, make a get() request to
  /// retrieve a Subnetwork.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The gateway address for default routes to reach destination addresses
  /// outside this subnetwork.
  ///
  /// Output only.
  core.String? gatewayAddress;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// The internal IPv6 address range that is assigned to this subnetwork.
  ///
  /// Output only.
  core.String? internalIpv6Prefix;

  /// The range of internal addresses that are owned by this subnetwork.
  ///
  /// Provide this property when you create the subnetwork. For example,
  /// 10.0.0.0/8 or 100.64.0.0/10. Ranges must be unique and non-overlapping
  /// within a network. Only IPv4 is supported. This field is set at resource
  /// creation time. The range can be any range listed in the Valid ranges list.
  /// The range can be expanded after creation using expandIpCidrRange.
  core.String? ipCidrRange;

  /// The access type of IPv6 address this subnet holds.
  ///
  /// It's immutable and can only be specified during creation or the first time
  /// the subnet is updated into IPV4_IPV6 dual stack.
  /// Possible string values are:
  /// - "EXTERNAL" : VMs on this subnet will be assigned IPv6 addresses that are
  /// accessible via the Internet, as well as the VPC network.
  /// - "INTERNAL" : VMs on this subnet will be assigned IPv6 addresses that are
  /// only accessible over the VPC network.
  core.String? ipv6AccessType;

  /// This field is for internal use.
  ///
  /// Output only.
  core.String? ipv6CidrRange;

  /// Type of the resource.
  ///
  /// Always compute#subnetwork for Subnetwork resources.
  ///
  /// Output only.
  core.String? kind;

  /// This field denotes the VPC flow logging options for this subnetwork.
  ///
  /// If logging is enabled, logs are exported to Cloud Logging.
  SubnetworkLogConfig? logConfig;

  /// The name of the resource, provided by the client when initially creating
  /// the resource.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035.
  /// Specifically, the name must be 1-63 characters long and match the regular
  /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character
  /// must be a lowercase letter, and all following characters must be a dash,
  /// lowercase letter, or digit, except the last character, which cannot be a
  /// dash.
  core.String? name;

  /// The URL of the network to which this subnetwork belongs, provided by the
  /// client when initially creating the subnetwork.
  ///
  /// This field can be set only at resource creation time.
  core.String? network;

  /// Whether the VMs in this subnet can access Google services without assigned
  /// external IP addresses.
  ///
  /// This field can be both set at resource creation time and updated using
  /// setPrivateIpGoogleAccess.
  core.bool? privateIpGoogleAccess;

  /// This field is for internal use.
  ///
  /// This field can be both set at resource creation time and updated using
  /// patch.
  /// Possible string values are:
  /// - "DISABLE_GOOGLE_ACCESS" : Disable private IPv6 access to/from Google
  /// services.
  /// - "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE" : Bidirectional private IPv6
  /// access to/from Google services.
  /// - "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE" : Outbound private IPv6 access
  /// from VMs in this subnet to Google services.
  core.String? privateIpv6GoogleAccess;

  /// The purpose of the resource.
  ///
  /// This field can be either PRIVATE_RFC_1918 or INTERNAL_HTTPS_LOAD_BALANCER.
  /// A subnetwork with purpose set to INTERNAL_HTTPS_LOAD_BALANCER is a
  /// user-created subnetwork that is reserved for Internal HTTP(S) Load
  /// Balancing. If unspecified, the purpose defaults to PRIVATE_RFC_1918. The
  /// enableFlowLogs field isn't supported with the purpose field set to
  /// INTERNAL_HTTPS_LOAD_BALANCER.
  /// Possible string values are:
  /// - "INTERNAL_HTTPS_LOAD_BALANCER" : Subnet reserved for Internal HTTP(S)
  /// Load Balancing.
  /// - "PRIVATE" : Regular user created or automatically created subnet.
  /// - "PRIVATE_RFC_1918" : Regular user created or automatically created
  /// subnet.
  /// - "PRIVATE_SERVICE_CONNECT" : Subnetworks created for Private Service
  /// Connect in the producer network.
  /// - "REGIONAL_MANAGED_PROXY" : Subnetwork used for Regional
  /// Internal/External HTTP(S) Load Balancing.
  core.String? purpose;

  /// URL of the region where the Subnetwork resides.
  ///
  /// This field can be set only at resource creation time.
  core.String? region;

  /// The role of subnetwork.
  ///
  /// Currently, this field is only used when purpose =
  /// INTERNAL_HTTPS_LOAD_BALANCER. The value can be set to ACTIVE or BACKUP. An
  /// ACTIVE subnetwork is one that is currently being used for Internal HTTP(S)
  /// Load Balancing. A BACKUP subnetwork is one that is ready to be promoted to
  /// ACTIVE or is currently draining. This field can be updated with a patch
  /// request.
  /// Possible string values are:
  /// - "ACTIVE" : The ACTIVE subnet that is currently used.
  /// - "BACKUP" : The BACKUP subnet that could be promoted to ACTIVE.
  core.String? role;

  /// An array of configurations for secondary IP ranges for VM instances
  /// contained in this subnetwork.
  ///
  /// The primary IP of such VM must belong to the primary ipCidrRange of the
  /// subnetwork. The alias IPs may belong to either primary or secondary
  /// ranges. This field can be updated with a patch request.
  core.List<SubnetworkSecondaryRange>? secondaryIpRanges;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The stack type for the subnet.
  ///
  /// If set to IPV4_ONLY, new VMs in the subnet are assigned IPv4 addresses
  /// only. If set to IPV4_IPV6, new VMs in the subnet can be assigned both IPv4
  /// and IPv6 addresses. If not specified, IPV4_ONLY is used. This field can be
  /// both set at resource creation time and updated using patch.
  /// Possible string values are:
  /// - "IPV4_IPV6" : New VMs in this subnet can have both IPv4 and IPv6
  /// addresses.
  /// - "IPV4_ONLY" : New VMs in this subnet will only be assigned IPv4
  /// addresses.
  core.String? stackType;

  /// The state of the subnetwork, which can be one of the following values:
  /// READY: Subnetwork is created and ready to use DRAINING: only applicable to
  /// subnetworks that have the purpose set to INTERNAL_HTTPS_LOAD_BALANCER and
  /// indicates that connections to the load balancer are being drained.
  ///
  /// A subnetwork that is draining cannot be used or modified until it reaches
  /// a status of READY
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DRAINING" : Subnetwork is being drained.
  /// - "READY" : Subnetwork is ready for use.
  core.String? state;

  Subnetwork({
    this.creationTimestamp,
    this.description,
    this.enableFlowLogs,
    this.externalIpv6Prefix,
    this.fingerprint,
    this.gatewayAddress,
    this.id,
    this.internalIpv6Prefix,
    this.ipCidrRange,
    this.ipv6AccessType,
    this.ipv6CidrRange,
    this.kind,
    this.logConfig,
    this.name,
    this.network,
    this.privateIpGoogleAccess,
    this.privateIpv6GoogleAccess,
    this.purpose,
    this.region,
    this.role,
    this.secondaryIpRanges,
    this.selfLink,
    this.stackType,
    this.state,
  });

  Subnetwork.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          enableFlowLogs: json_.containsKey('enableFlowLogs')
              ? json_['enableFlowLogs'] as core.bool
              : null,
          externalIpv6Prefix: json_.containsKey('externalIpv6Prefix')
              ? json_['externalIpv6Prefix'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          gatewayAddress: json_.containsKey('gatewayAddress')
              ? json_['gatewayAddress'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          internalIpv6Prefix: json_.containsKey('internalIpv6Prefix')
              ? json_['internalIpv6Prefix'] as core.String
              : null,
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          ipv6AccessType: json_.containsKey('ipv6AccessType')
              ? json_['ipv6AccessType'] as core.String
              : null,
          ipv6CidrRange: json_.containsKey('ipv6CidrRange')
              ? json_['ipv6CidrRange'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          logConfig: json_.containsKey('logConfig')
              ? SubnetworkLogConfig.fromJson(
                  json_['logConfig'] as core.Map<core.String, core.dynamic>)
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          privateIpGoogleAccess: json_.containsKey('privateIpGoogleAccess')
              ? json_['privateIpGoogleAccess'] as core.bool
              : null,
          privateIpv6GoogleAccess: json_.containsKey('privateIpv6GoogleAccess')
              ? json_['privateIpv6GoogleAccess'] as core.String
              : null,
          purpose: json_.containsKey('purpose')
              ? json_['purpose'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          role: json_.containsKey('role') ? json_['role'] as core.String : null,
          secondaryIpRanges: json_.containsKey('secondaryIpRanges')
              ? (json_['secondaryIpRanges'] as core.List)
                  .map((value) => SubnetworkSecondaryRange.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (enableFlowLogs != null) 'enableFlowLogs': enableFlowLogs!,
        if (externalIpv6Prefix != null)
          'externalIpv6Prefix': externalIpv6Prefix!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (gatewayAddress != null) 'gatewayAddress': gatewayAddress!,
        if (id != null) 'id': id!,
        if (internalIpv6Prefix != null)
          'internalIpv6Prefix': internalIpv6Prefix!,
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (ipv6AccessType != null) 'ipv6AccessType': ipv6AccessType!,
        if (ipv6CidrRange != null) 'ipv6CidrRange': ipv6CidrRange!,
        if (kind != null) 'kind': kind!,
        if (logConfig != null) 'logConfig': logConfig!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (privateIpGoogleAccess != null)
          'privateIpGoogleAccess': privateIpGoogleAccess!,
        if (privateIpv6GoogleAccess != null)
          'privateIpv6GoogleAccess': privateIpv6GoogleAccess!,
        if (purpose != null) 'purpose': purpose!,
        if (region != null) 'region': region!,
        if (role != null) 'role': role!,
        if (secondaryIpRanges != null) 'secondaryIpRanges': secondaryIpRanges!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (stackType != null) 'stackType': stackType!,
        if (state != null) 'state': state!,
      };
}

class SubnetworkAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SubnetworkAggregatedListWarningData({
    this.key,
    this.value,
  });

  SubnetworkAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SubnetworkAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SubnetworkAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SubnetworkAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SubnetworkAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SubnetworkAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SubnetworkAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of SubnetworksScopedList resources.
  core.Map<core.String, SubnetworksScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#subnetworkAggregatedList for aggregated lists of
  /// subnetworks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  SubnetworkAggregatedListWarning? warning;

  SubnetworkAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  SubnetworkAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    SubnetworksScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SubnetworkAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class SubnetworkListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SubnetworkListWarningData({
    this.key,
    this.value,
  });

  SubnetworkListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class SubnetworkListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SubnetworkListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SubnetworkListWarning({
    this.code,
    this.data,
    this.message,
  });

  SubnetworkListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SubnetworkListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of Subnetwork resources.
class SubnetworkList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Subnetwork resources.
  core.List<Subnetwork>? items;

  /// Type of resource.
  ///
  /// Always compute#subnetworkList for lists of subnetworks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  SubnetworkListWarning? warning;

  SubnetworkList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  SubnetworkList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Subnetwork.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? SubnetworkListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// The available logging options for this subnetwork.
class SubnetworkLogConfig {
  /// Can only be specified if VPC flow logging for this subnetwork is enabled.
  ///
  /// Toggles the aggregation interval for collecting flow logs. Increasing the
  /// interval time will reduce the amount of generated flow logs for long
  /// lasting connections. Default is an interval of 5 seconds per connection.
  /// Possible string values are:
  /// - "INTERVAL_10_MIN"
  /// - "INTERVAL_15_MIN"
  /// - "INTERVAL_1_MIN"
  /// - "INTERVAL_30_SEC"
  /// - "INTERVAL_5_MIN"
  /// - "INTERVAL_5_SEC"
  core.String? aggregationInterval;

  /// Whether to enable flow logging for this subnetwork.
  ///
  /// If this field is not explicitly set, it will not appear in get listings.
  /// If not set the default behavior is determined by the org policy, if there
  /// is no org policy specified, then it will default to disabled.
  core.bool? enable;

  /// Can only be specified if VPC flow logs for this subnetwork is enabled.
  ///
  /// The filter expression is used to define which VPC flow logs should be
  /// exported to Cloud Logging.
  core.String? filterExpr;

  /// Can only be specified if VPC flow logging for this subnetwork is enabled.
  ///
  /// The value of the field must be in \[0, 1\]. Set the sampling rate of VPC
  /// flow logs within the subnetwork where 1.0 means all collected logs are
  /// reported and 0.0 means no logs are reported. Default is 0.5 unless
  /// otherwise specified by the org policy, which means half of all collected
  /// logs are reported.
  core.double? flowSampling;

  /// Can only be specified if VPC flow logs for this subnetwork is enabled.
  ///
  /// Configures whether all, none or a subset of metadata fields should be
  /// added to the reported VPC flow logs. Default is EXCLUDE_ALL_METADATA.
  /// Possible string values are:
  /// - "CUSTOM_METADATA"
  /// - "EXCLUDE_ALL_METADATA"
  /// - "INCLUDE_ALL_METADATA"
  core.String? metadata;

  /// Can only be specified if VPC flow logs for this subnetwork is enabled and
  /// "metadata" was set to CUSTOM_METADATA.
  core.List<core.String>? metadataFields;

  SubnetworkLogConfig({
    this.aggregationInterval,
    this.enable,
    this.filterExpr,
    this.flowSampling,
    this.metadata,
    this.metadataFields,
  });

  SubnetworkLogConfig.fromJson(core.Map json_)
      : this(
          aggregationInterval: json_.containsKey('aggregationInterval')
              ? json_['aggregationInterval'] as core.String
              : null,
          enable:
              json_.containsKey('enable') ? json_['enable'] as core.bool : null,
          filterExpr: json_.containsKey('filterExpr')
              ? json_['filterExpr'] as core.String
              : null,
          flowSampling: json_.containsKey('flowSampling')
              ? (json_['flowSampling'] as core.num).toDouble()
              : null,
          metadata: json_.containsKey('metadata')
              ? json_['metadata'] as core.String
              : null,
          metadataFields: json_.containsKey('metadataFields')
              ? (json_['metadataFields'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (aggregationInterval != null)
          'aggregationInterval': aggregationInterval!,
        if (enable != null) 'enable': enable!,
        if (filterExpr != null) 'filterExpr': filterExpr!,
        if (flowSampling != null) 'flowSampling': flowSampling!,
        if (metadata != null) 'metadata': metadata!,
        if (metadataFields != null) 'metadataFields': metadataFields!,
      };
}

/// Represents a secondary IP range of a subnetwork.
class SubnetworkSecondaryRange {
  /// The range of IP addresses belonging to this subnetwork secondary range.
  ///
  /// Provide this property when you create the subnetwork. Ranges must be
  /// unique and non-overlapping with all primary and secondary IP ranges within
  /// a network. Only IPv4 is supported. The range can be any range listed in
  /// the Valid ranges list.
  core.String? ipCidrRange;

  /// The name associated with this subnetwork secondary range, used when adding
  /// an alias IP range to a VM instance.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035. The name
  /// must be unique within the subnetwork.
  core.String? rangeName;

  SubnetworkSecondaryRange({
    this.ipCidrRange,
    this.rangeName,
  });

  SubnetworkSecondaryRange.fromJson(core.Map json_)
      : this(
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          rangeName: json_.containsKey('rangeName')
              ? json_['rangeName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (rangeName != null) 'rangeName': rangeName!,
      };
}

class SubnetworksExpandIpCidrRangeRequest {
  /// The IP (in CIDR format or netmask) of internal addresses that are legal on
  /// this Subnetwork.
  ///
  /// This range should be disjoint from other subnetworks within this network.
  /// This range can only be larger than (i.e. a superset of) the range
  /// previously defined before the update.
  core.String? ipCidrRange;

  SubnetworksExpandIpCidrRangeRequest({
    this.ipCidrRange,
  });

  SubnetworksExpandIpCidrRangeRequest.fromJson(core.Map json_)
      : this(
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
      };
}

class SubnetworksScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  SubnetworksScopedListWarningData({
    this.key,
    this.value,
  });

  SubnetworksScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// An informational warning that appears when the list of addresses is empty.
class SubnetworksScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<SubnetworksScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  SubnetworksScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  SubnetworksScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => SubnetworksScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class SubnetworksScopedList {
  /// A list of subnetworks contained in this scope.
  core.List<Subnetwork>? subnetworks;

  /// An informational warning that appears when the list of addresses is empty.
  SubnetworksScopedListWarning? warning;

  SubnetworksScopedList({
    this.subnetworks,
    this.warning,
  });

  SubnetworksScopedList.fromJson(core.Map json_)
      : this(
          subnetworks: json_.containsKey('subnetworks')
              ? (json_['subnetworks'] as core.List)
                  .map((value) => Subnetwork.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? SubnetworksScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (subnetworks != null) 'subnetworks': subnetworks!,
        if (warning != null) 'warning': warning!,
      };
}

class SubnetworksSetPrivateIpGoogleAccessRequest {
  core.bool? privateIpGoogleAccess;

  SubnetworksSetPrivateIpGoogleAccessRequest({
    this.privateIpGoogleAccess,
  });

  SubnetworksSetPrivateIpGoogleAccessRequest.fromJson(core.Map json_)
      : this(
          privateIpGoogleAccess: json_.containsKey('privateIpGoogleAccess')
              ? json_['privateIpGoogleAccess'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (privateIpGoogleAccess != null)
          'privateIpGoogleAccess': privateIpGoogleAccess!,
      };
}

/// Subsetting configuration for this BackendService.
///
/// Currently this is applicable only for Internal TCP/UDP load balancing,
/// Internal HTTP(S) load balancing and Traffic Director.
class Subsetting {
  ///
  /// Possible string values are:
  /// - "CONSISTENT_HASH_SUBSETTING" : Subsetting based on consistent hashing.
  /// For Traffic Director, the number of backends per backend group (the subset
  /// size) is based on the `subset_size` parameter. For Internal HTTP(S) load
  /// balancing, the number of backends per backend group (the subset size) is
  /// dynamically adjusted in two cases: - As the number of proxy instances
  /// participating in Internal HTTP(S) load balancing increases, the subset
  /// size decreases. - When the total number of backends in a network exceeds
  /// the capacity of a single proxy instance, subset sizes are reduced
  /// automatically for each service that has backend subsetting enabled.
  /// - "NONE" : No Subsetting. Clients may open connections and send traffic to
  /// all backends of this backend service. This can lead to performance issues
  /// if there is substantial imbalance in the count of clients and backends.
  core.String? policy;

  Subsetting({
    this.policy,
  });

  Subsetting.fromJson(core.Map json_)
      : this(
          policy: json_.containsKey('policy')
              ? json_['policy'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (policy != null) 'policy': policy!,
      };
}

class TCPHealthCheck {
  /// The TCP port number for the health check request.
  ///
  /// The default value is 80. Valid values are 1 through 65535.
  core.int? port;

  /// Port name as defined in InstanceGroup#NamedPort#name.
  ///
  /// If both port and port_name are defined, port takes precedence.
  core.String? portName;

  /// Specifies how port is selected for health checking, can be one of
  /// following values: USE_FIXED_PORT: The port number in port is used for
  /// health checking.
  ///
  /// USE_NAMED_PORT: The portName is used for health checking.
  /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each
  /// network endpoint is used for health checking. For other backends, the port
  /// or named port specified in the Backend Service is used for health
  /// checking. If not specified, TCP health check follows behavior specified in
  /// port and portName fields.
  /// Possible string values are:
  /// - "USE_FIXED_PORT" : The port number in port is used for health checking.
  /// - "USE_NAMED_PORT" : The portName is used for health checking.
  /// - "USE_SERVING_PORT" : For NetworkEndpointGroup, the port specified for
  /// each network endpoint is used for health checking. For other backends, the
  /// port or named port specified in the Backend Service is used for health
  /// checking.
  core.String? portSpecification;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// The application data to send once the TCP connection has been established
  /// (default value is empty).
  ///
  /// If both request and response are empty, the connection establishment alone
  /// will indicate health. The request data can only be ASCII.
  core.String? request;

  /// The bytes to match against the beginning of the response data.
  ///
  /// If left empty (the default value), any response will indicate health. The
  /// response data can only be ASCII.
  core.String? response;

  TCPHealthCheck({
    this.port,
    this.portName,
    this.portSpecification,
    this.proxyHeader,
    this.request,
    this.response,
  });

  TCPHealthCheck.fromJson(core.Map json_)
      : this(
          port: json_.containsKey('port') ? json_['port'] as core.int : null,
          portName: json_.containsKey('portName')
              ? json_['portName'] as core.String
              : null,
          portSpecification: json_.containsKey('portSpecification')
              ? json_['portSpecification'] as core.String
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          request: json_.containsKey('request')
              ? json_['request'] as core.String
              : null,
          response: json_.containsKey('response')
              ? json_['response'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (port != null) 'port': port!,
        if (portName != null) 'portName': portName!,
        if (portSpecification != null) 'portSpecification': portSpecification!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (request != null) 'request': request!,
        if (response != null) 'response': response!,
      };
}

/// A set of instance tags.
class Tags {
  /// Specifies a fingerprint for this request, which is essentially a hash of
  /// the tags' contents and used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update tags. You must always provide an
  /// up-to-date fingerprint hash in order to update or change tags. To see the
  /// latest fingerprint, make get() request to the instance.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// An array of tags.
  ///
  /// Each tag must be 1-63 characters long, and comply with RFC1035.
  core.List<core.String>? items;

  Tags({
    this.fingerprint,
    this.items,
  });

  Tags.fromJson(core.Map json_)
      : this(
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (items != null) 'items': items!,
      };
}

/// Represents a Target gRPC Proxy resource.
///
/// A target gRPC proxy is a component of load balancers intended for load
/// balancing gRPC traffic. Only global forwarding rules with load balancing
/// scheme INTERNAL_SELF_MANAGED can reference a target gRPC proxy. The target
/// gRPC Proxy references a URL map that specifies how traffic is routed to gRPC
/// backend services.
class TargetGrpcProxy {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// TargetGrpcProxy. An up-to-date fingerprint must be provided in order to
  /// patch/update the TargetGrpcProxy; otherwise, the request will fail with
  /// error 412 conditionNotMet. To see the latest fingerprint, make a get()
  /// request to retrieve the TargetGrpcProxy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource type.
  ///
  /// The server generates this identifier.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#targetGrpcProxy for target grpc proxies.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Server-defined URL with id for the resource.
  ///
  /// Output only.
  core.String? selfLinkWithId;

  /// URL to the UrlMap resource that defines the mapping from URL to the
  /// BackendService.
  ///
  /// The protocol field in the BackendService must be set to GRPC.
  core.String? urlMap;

  /// If true, indicates that the BackendServices referenced by the urlMap may
  /// be accessed by gRPC applications without using a sidecar proxy.
  ///
  /// This will enable configuration checks on urlMap and its referenced
  /// BackendServices to not allow unsupported features. A gRPC application must
  /// use "xds:///" scheme in the target URI of the service it is connecting to.
  /// If false, indicates that the BackendServices referenced by the urlMap will
  /// be accessed by gRPC applications via a sidecar proxy. In this case, a gRPC
  /// application must not use "xds:///" scheme in the target URI of the service
  /// it is connecting to
  core.bool? validateForProxyless;

  TargetGrpcProxy({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.selfLink,
    this.selfLinkWithId,
    this.urlMap,
    this.validateForProxyless,
  });

  TargetGrpcProxy.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          selfLinkWithId: json_.containsKey('selfLinkWithId')
              ? json_['selfLinkWithId'] as core.String
              : null,
          urlMap: json_.containsKey('urlMap')
              ? json_['urlMap'] as core.String
              : null,
          validateForProxyless: json_.containsKey('validateForProxyless')
              ? json_['validateForProxyless'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (selfLinkWithId != null) 'selfLinkWithId': selfLinkWithId!,
        if (urlMap != null) 'urlMap': urlMap!,
        if (validateForProxyless != null)
          'validateForProxyless': validateForProxyless!,
      };
}

class TargetGrpcProxyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetGrpcProxyListWarningData({
    this.key,
    this.value,
  });

  TargetGrpcProxyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetGrpcProxyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetGrpcProxyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetGrpcProxyListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetGrpcProxyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetGrpcProxyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetGrpcProxyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetGrpcProxy resources.
  core.List<TargetGrpcProxy>? items;

  /// Type of the resource.
  ///
  /// Always compute#targetGrpcProxy for target grpc proxies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetGrpcProxyListWarning? warning;

  TargetGrpcProxyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetGrpcProxyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetGrpcProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetGrpcProxyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetHttpProxiesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetHttpProxiesScopedListWarningData({
    this.key,
    this.value,
  });

  TargetHttpProxiesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class TargetHttpProxiesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetHttpProxiesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetHttpProxiesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetHttpProxiesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetHttpProxiesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetHttpProxiesScopedList {
  /// A list of TargetHttpProxies contained in this scope.
  core.List<TargetHttpProxy>? targetHttpProxies;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  TargetHttpProxiesScopedListWarning? warning;

  TargetHttpProxiesScopedList({
    this.targetHttpProxies,
    this.warning,
  });

  TargetHttpProxiesScopedList.fromJson(core.Map json_)
      : this(
          targetHttpProxies: json_.containsKey('targetHttpProxies')
              ? (json_['targetHttpProxies'] as core.List)
                  .map((value) => TargetHttpProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetHttpProxiesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetHttpProxies != null) 'targetHttpProxies': targetHttpProxies!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Target HTTP Proxy resource.
///
/// Google Compute Engine has two Target HTTP Proxy resources: *
/// \[Global\](/compute/docs/reference/rest/v1/targetHttpProxies) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionTargetHttpProxies) A
/// target HTTP proxy is a component of GCP HTTP load balancers. *
/// targetHttpProxies are used by external HTTP load balancers and Traffic
/// Director. * regionTargetHttpProxies are used by internal HTTP load
/// balancers. Forwarding rules reference a target HTTP proxy, and the target
/// proxy then references a URL map. For more information, read Using Target
/// Proxies and Forwarding rule concepts.
class TargetHttpProxy {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// TargetHttpProxy. An up-to-date fingerprint must be provided in order to
  /// patch/update the TargetHttpProxy; otherwise, the request will fail with
  /// error 412 conditionNotMet. To see the latest fingerprint, make a get()
  /// request to retrieve the TargetHttpProxy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#targetHttpProxy for target HTTP proxies.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// This field only applies when the forwarding rule that references this
  /// target proxy has a loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  ///
  /// When this field is set to true, Envoy proxies set up inbound traffic
  /// interception and bind to the IP address and port specified in the
  /// forwarding rule. This is generally useful when using Traffic Director to
  /// configure Envoy as a gateway or middle proxy (in other words, not a
  /// sidecar proxy). The Envoy proxy listens for inbound requests and handles
  /// requests when it receives them. The default is false.
  core.bool? proxyBind;

  /// URL of the region where the regional Target HTTP Proxy resides.
  ///
  /// This field is not applicable to global Target HTTP Proxies.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// URL to the UrlMap resource that defines the mapping from URL to the
  /// BackendService.
  core.String? urlMap;

  TargetHttpProxy({
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.proxyBind,
    this.region,
    this.selfLink,
    this.urlMap,
  });

  TargetHttpProxy.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          proxyBind: json_.containsKey('proxyBind')
              ? json_['proxyBind'] as core.bool
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          urlMap: json_.containsKey('urlMap')
              ? json_['urlMap'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (proxyBind != null) 'proxyBind': proxyBind!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (urlMap != null) 'urlMap': urlMap!,
      };
}

class TargetHttpProxyAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetHttpProxiesScopedList resources.
  core.Map<core.String, TargetHttpProxiesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#targetHttpProxyAggregatedList for lists of Target HTTP
  /// Proxies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  TargetHttpProxyAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
  });

  TargetHttpProxyAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    TargetHttpProxiesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
      };
}

class TargetHttpProxyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetHttpProxyListWarningData({
    this.key,
    this.value,
  });

  TargetHttpProxyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetHttpProxyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetHttpProxyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetHttpProxyListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetHttpProxyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetHttpProxyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// A list of TargetHttpProxy resources.
class TargetHttpProxyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetHttpProxy resources.
  core.List<TargetHttpProxy>? items;

  /// Type of resource.
  ///
  /// Always compute#targetHttpProxyList for lists of target HTTP proxies.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetHttpProxyListWarning? warning;

  TargetHttpProxyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetHttpProxyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetHttpProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetHttpProxyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetHttpsProxiesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetHttpsProxiesScopedListWarningData({
    this.key,
    this.value,
  });

  TargetHttpsProxiesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class TargetHttpsProxiesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetHttpsProxiesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetHttpsProxiesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetHttpsProxiesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetHttpsProxiesScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetHttpsProxiesScopedList {
  /// A list of TargetHttpsProxies contained in this scope.
  core.List<TargetHttpsProxy>? targetHttpsProxies;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  TargetHttpsProxiesScopedListWarning? warning;

  TargetHttpsProxiesScopedList({
    this.targetHttpsProxies,
    this.warning,
  });

  TargetHttpsProxiesScopedList.fromJson(core.Map json_)
      : this(
          targetHttpsProxies: json_.containsKey('targetHttpsProxies')
              ? (json_['targetHttpsProxies'] as core.List)
                  .map((value) => TargetHttpsProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetHttpsProxiesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetHttpsProxies != null)
          'targetHttpsProxies': targetHttpsProxies!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetHttpsProxiesSetCertificateMapRequest {
  /// URL of the Certificate Map to associate with this TargetHttpsProxy.
  core.String? certificateMap;

  TargetHttpsProxiesSetCertificateMapRequest({
    this.certificateMap,
  });

  TargetHttpsProxiesSetCertificateMapRequest.fromJson(core.Map json_)
      : this(
          certificateMap: json_.containsKey('certificateMap')
              ? json_['certificateMap'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (certificateMap != null) 'certificateMap': certificateMap!,
      };
}

class TargetHttpsProxiesSetQuicOverrideRequest {
  /// QUIC policy for the TargetHttpsProxy resource.
  /// Possible string values are:
  /// - "DISABLE" : The load balancer will not attempt to negotiate QUIC with
  /// clients.
  /// - "ENABLE" : The load balancer will attempt to negotiate QUIC with
  /// clients.
  /// - "NONE" : No overrides to the default QUIC policy. This option is
  /// implicit if no QUIC override has been specified in the request.
  core.String? quicOverride;

  TargetHttpsProxiesSetQuicOverrideRequest({
    this.quicOverride,
  });

  TargetHttpsProxiesSetQuicOverrideRequest.fromJson(core.Map json_)
      : this(
          quicOverride: json_.containsKey('quicOverride')
              ? json_['quicOverride'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (quicOverride != null) 'quicOverride': quicOverride!,
      };
}

class TargetHttpsProxiesSetSslCertificatesRequest {
  /// New set of SslCertificate resources to associate with this
  /// TargetHttpsProxy resource.
  ///
  /// At least one SSL certificate must be specified. Currently, you may specify
  /// up to 15 SSL certificates.
  core.List<core.String>? sslCertificates;

  TargetHttpsProxiesSetSslCertificatesRequest({
    this.sslCertificates,
  });

  TargetHttpsProxiesSetSslCertificatesRequest.fromJson(core.Map json_)
      : this(
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
      };
}

/// Represents a Target HTTPS Proxy resource.
///
/// Google Compute Engine has two Target HTTPS Proxy resources: *
/// \[Global\](/compute/docs/reference/rest/v1/targetHttpsProxies) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionTargetHttpsProxies) A
/// target HTTPS proxy is a component of GCP HTTPS load balancers. *
/// targetHttpsProxies are used by external HTTPS load balancers. *
/// regionTargetHttpsProxies are used by internal HTTPS load balancers.
/// Forwarding rules reference a target HTTPS proxy, and the target proxy then
/// references a URL map. For more information, read Using Target Proxies and
/// Forwarding rule concepts.
class TargetHttpsProxy {
  /// A URL referring to a networksecurity.AuthorizationPolicy resource that
  /// describes how the proxy should authorize inbound traffic.
  ///
  /// If left blank, access will not be restricted by an authorization policy.
  /// Refer to the AuthorizationPolicy resource for additional details.
  /// authorizationPolicy only applies to a global TargetHttpsProxy attached to
  /// globalForwardingRules with the loadBalancingScheme set to
  /// INTERNAL_SELF_MANAGED. Note: This field currently has no impact.
  ///
  /// Optional.
  core.String? authorizationPolicy;

  /// URL of a certificate map that identifies a certificate map associated with
  /// the given target proxy.
  ///
  /// This field can only be set for global target proxies. If set,
  /// sslCertificates will be ignored.
  core.String? certificateMap;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field will be ignored when inserting a
  /// TargetHttpsProxy. An up-to-date fingerprint must be provided in order to
  /// patch the TargetHttpsProxy; otherwise, the request will fail with error
  /// 412 conditionNotMet. To see the latest fingerprint, make a get() request
  /// to retrieve the TargetHttpsProxy.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#targetHttpsProxy for target HTTPS proxies.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// This field only applies when the forwarding rule that references this
  /// target proxy has a loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  ///
  /// When this field is set to true, Envoy proxies set up inbound traffic
  /// interception and bind to the IP address and port specified in the
  /// forwarding rule. This is generally useful when using Traffic Director to
  /// configure Envoy as a gateway or middle proxy (in other words, not a
  /// sidecar proxy). The Envoy proxy listens for inbound requests and handles
  /// requests when it receives them. The default is false.
  core.bool? proxyBind;

  /// Specifies the QUIC override policy for this TargetHttpsProxy resource.
  ///
  /// This setting determines whether the load balancer attempts to negotiate
  /// QUIC with clients. You can specify NONE, ENABLE, or DISABLE. - When
  /// quic-override is set to NONE, Google manages whether QUIC is used. - When
  /// quic-override is set to ENABLE, the load balancer uses QUIC when possible.
  /// - When quic-override is set to DISABLE, the load balancer doesn't use
  /// QUIC. - If the quic-override flag is not specified, NONE is implied.
  /// Possible string values are:
  /// - "DISABLE" : The load balancer will not attempt to negotiate QUIC with
  /// clients.
  /// - "ENABLE" : The load balancer will attempt to negotiate QUIC with
  /// clients.
  /// - "NONE" : No overrides to the default QUIC policy. This option is
  /// implicit if no QUIC override has been specified in the request.
  core.String? quicOverride;

  /// URL of the region where the regional TargetHttpsProxy resides.
  ///
  /// This field is not applicable to global TargetHttpsProxies.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// A URL referring to a networksecurity.ServerTlsPolicy resource that
  /// describes how the proxy should authenticate inbound traffic.
  ///
  /// serverTlsPolicy only applies to a global TargetHttpsProxy attached to
  /// globalForwardingRules with the loadBalancingScheme set to
  /// INTERNAL_SELF_MANAGED. If left blank, communications are not encrypted.
  /// Note: This field currently has no impact.
  ///
  /// Optional.
  core.String? serverTlsPolicy;

  /// URLs to SslCertificate resources that are used to authenticate connections
  /// between users and the load balancer.
  ///
  /// At least one SSL certificate must be specified. Currently, you may specify
  /// up to 15 SSL certificates. sslCertificates do not apply when the load
  /// balancing scheme is set to INTERNAL_SELF_MANAGED.
  core.List<core.String>? sslCertificates;

  /// URL of SslPolicy resource that will be associated with the
  /// TargetHttpsProxy resource.
  ///
  /// If not set, the TargetHttpsProxy resource has no SSL policy configured.
  core.String? sslPolicy;

  /// A fully-qualified or valid partial URL to the UrlMap resource that defines
  /// the mapping from URL to the BackendService.
  ///
  /// For example, the following are all valid URLs for specifying a URL map: -
  /// https://www.googleapis.compute/v1/projects/project/global/urlMaps/ url-map
  /// - projects/project/global/urlMaps/url-map - global/urlMaps/url-map
  core.String? urlMap;

  TargetHttpsProxy({
    this.authorizationPolicy,
    this.certificateMap,
    this.creationTimestamp,
    this.description,
    this.fingerprint,
    this.id,
    this.kind,
    this.name,
    this.proxyBind,
    this.quicOverride,
    this.region,
    this.selfLink,
    this.serverTlsPolicy,
    this.sslCertificates,
    this.sslPolicy,
    this.urlMap,
  });

  TargetHttpsProxy.fromJson(core.Map json_)
      : this(
          authorizationPolicy: json_.containsKey('authorizationPolicy')
              ? json_['authorizationPolicy'] as core.String
              : null,
          certificateMap: json_.containsKey('certificateMap')
              ? json_['certificateMap'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          proxyBind: json_.containsKey('proxyBind')
              ? json_['proxyBind'] as core.bool
              : null,
          quicOverride: json_.containsKey('quicOverride')
              ? json_['quicOverride'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          serverTlsPolicy: json_.containsKey('serverTlsPolicy')
              ? json_['serverTlsPolicy'] as core.String
              : null,
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sslPolicy: json_.containsKey('sslPolicy')
              ? json_['sslPolicy'] as core.String
              : null,
          urlMap: json_.containsKey('urlMap')
              ? json_['urlMap'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (authorizationPolicy != null)
          'authorizationPolicy': authorizationPolicy!,
        if (certificateMap != null) 'certificateMap': certificateMap!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (proxyBind != null) 'proxyBind': proxyBind!,
        if (quicOverride != null) 'quicOverride': quicOverride!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (serverTlsPolicy != null) 'serverTlsPolicy': serverTlsPolicy!,
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
        if (sslPolicy != null) 'sslPolicy': sslPolicy!,
        if (urlMap != null) 'urlMap': urlMap!,
      };
}

class TargetHttpsProxyAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetHttpsProxyAggregatedListWarningData({
    this.key,
    this.value,
  });

  TargetHttpsProxyAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetHttpsProxyAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetHttpsProxyAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetHttpsProxyAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetHttpsProxyAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetHttpsProxyAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetHttpsProxyAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetHttpsProxiesScopedList resources.
  core.Map<core.String, TargetHttpsProxiesScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#targetHttpsProxyAggregatedList for lists of Target HTTP
  /// Proxies.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  TargetHttpsProxyAggregatedListWarning? warning;

  TargetHttpsProxyAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  TargetHttpsProxyAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    TargetHttpsProxiesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetHttpsProxyAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetHttpsProxyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetHttpsProxyListWarningData({
    this.key,
    this.value,
  });

  TargetHttpsProxyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetHttpsProxyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetHttpsProxyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetHttpsProxyListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetHttpsProxyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetHttpsProxyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetHttpsProxy resources.
class TargetHttpsProxyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetHttpsProxy resources.
  core.List<TargetHttpsProxy>? items;

  /// Type of resource.
  ///
  /// Always compute#targetHttpsProxyList for lists of target HTTPS proxies.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetHttpsProxyListWarning? warning;

  TargetHttpsProxyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetHttpsProxyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetHttpsProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetHttpsProxyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Target Instance resource.
///
/// You can use a target instance to handle traffic for one or more forwarding
/// rules, which is ideal for forwarding protocol traffic that is managed by a
/// single source. For example, ESP, AH, TCP, or UDP. For more information, read
/// Target instances.
class TargetInstance {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A URL to the virtual machine instance that handles traffic for this target
  /// instance.
  ///
  /// When creating a target instance, you can provide the fully-qualified URL
  /// or a valid partial URL to the desired virtual machine. For example, the
  /// following are all valid URLs: -
  /// https://www.googleapis.com/compute/v1/projects/project/zones/zone
  /// /instances/instance - projects/project/zones/zone/instances/instance -
  /// zones/zone/instances/instance
  core.String? instance;

  /// The type of the resource.
  ///
  /// Always compute#targetInstance for target instances.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Must have a value of NO_NAT.
  ///
  /// Protocol forwarding delivers packets while preserving the destination IP
  /// address of the forwarding rule referencing the target instance.
  /// Possible string values are:
  /// - "NO_NAT" : No NAT performed.
  core.String? natPolicy;

  /// The URL of the network this target instance uses to forward traffic.
  ///
  /// If not specified, the traffic will be forwarded to the network that the
  /// default network interface belongs to.
  core.String? network;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// URL of the zone where the target instance resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? zone;

  TargetInstance({
    this.creationTimestamp,
    this.description,
    this.id,
    this.instance,
    this.kind,
    this.name,
    this.natPolicy,
    this.network,
    this.selfLink,
    this.zone,
  });

  TargetInstance.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instance: json_.containsKey('instance')
              ? json_['instance'] as core.String
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          natPolicy: json_.containsKey('natPolicy')
              ? json_['natPolicy'] as core.String
              : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          zone: json_.containsKey('zone') ? json_['zone'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (instance != null) 'instance': instance!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (natPolicy != null) 'natPolicy': natPolicy!,
        if (network != null) 'network': network!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (zone != null) 'zone': zone!,
      };
}

class TargetInstanceAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetInstanceAggregatedListWarningData({
    this.key,
    this.value,
  });

  TargetInstanceAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetInstanceAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetInstanceAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetInstanceAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetInstanceAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetInstanceAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetInstanceAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetInstance resources.
  core.Map<core.String, TargetInstancesScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  TargetInstanceAggregatedListWarning? warning;

  TargetInstanceAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  TargetInstanceAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    TargetInstancesScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetInstanceAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetInstanceListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetInstanceListWarningData({
    this.key,
    this.value,
  });

  TargetInstanceListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetInstanceListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetInstanceListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetInstanceListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetInstanceListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetInstanceListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetInstance resources.
class TargetInstanceList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetInstance resources.
  core.List<TargetInstance>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetInstanceListWarning? warning;

  TargetInstanceList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetInstanceList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetInstance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetInstanceListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetInstancesScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetInstancesScopedListWarningData({
    this.key,
    this.value,
  });

  TargetInstancesScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
class TargetInstancesScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetInstancesScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetInstancesScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetInstancesScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetInstancesScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetInstancesScopedList {
  /// A list of target instances contained in this scope.
  core.List<TargetInstance>? targetInstances;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  TargetInstancesScopedListWarning? warning;

  TargetInstancesScopedList({
    this.targetInstances,
    this.warning,
  });

  TargetInstancesScopedList.fromJson(core.Map json_)
      : this(
          targetInstances: json_.containsKey('targetInstances')
              ? (json_['targetInstances'] as core.List)
                  .map((value) => TargetInstance.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetInstancesScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetInstances != null) 'targetInstances': targetInstances!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Target Pool resource.
///
/// Target pools are used for network TCP/UDP load balancing. A target pool
/// references member instances, an associated legacy HttpHealthCheck resource,
/// and, optionally, a backup target pool. For more information, read Using
/// target pools.
class TargetPool {
  /// The server-defined URL for the resource.
  ///
  /// This field is applicable only when the containing target pool is serving a
  /// forwarding rule as the primary pool, and its failoverRatio field is
  /// properly set to a value between \[0, 1\]. backupPool and failoverRatio
  /// together define the fallback behavior of the primary target pool: if the
  /// ratio of the healthy instances in the primary pool is at or below
  /// failoverRatio, traffic arriving at the load-balanced IP will be directed
  /// to the backup pool. In case where failoverRatio and backupPool are not
  /// set, or all the instances in the backup pool are unhealthy, the traffic
  /// will be directed back to the primary pool in the "force" mode, where
  /// traffic will be spread to the healthy instances with the best effort, or
  /// to all instances when no instance is healthy.
  core.String? backupPool;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// This field is applicable only when the containing target pool is serving a
  /// forwarding rule as the primary pool (i.e., not as a backup pool to some
  /// other target pool).
  ///
  /// The value of the field must be in \[0, 1\]. If set, backupPool must also
  /// be set. They together define the fallback behavior of the primary target
  /// pool: if the ratio of the healthy instances in the primary pool is at or
  /// below this number, traffic arriving at the load-balanced IP will be
  /// directed to the backup pool. In case where failoverRatio is not set or all
  /// the instances in the backup pool are unhealthy, the traffic will be
  /// directed back to the primary pool in the "force" mode, where traffic will
  /// be spread to the healthy instances with the best effort, or to all
  /// instances when no instance is healthy.
  core.double? failoverRatio;

  /// The URL of the HttpHealthCheck resource.
  ///
  /// A member instance in this pool is considered healthy if and only if the
  /// health checks pass. Only legacy HttpHealthChecks are supported. Only one
  /// health check may be specified.
  core.List<core.String>? healthChecks;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of resource URLs to the virtual machine instances serving this
  /// pool.
  ///
  /// They must live in zones contained in the same region as this pool.
  core.List<core.String>? instances;

  /// Type of the resource.
  ///
  /// Always compute#targetPool for target pools.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the region where the target pool resides.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Session affinity option, must be one of the following values: NONE:
  /// Connections from the same client IP may go to any instance in the pool.
  ///
  /// CLIENT_IP: Connections from the same client IP will go to the same
  /// instance in the pool while that instance remains healthy. CLIENT_IP_PROTO:
  /// Connections from the same client IP with the same IP protocol will go to
  /// the same instance in the pool while that instance remains healthy.
  /// Possible string values are:
  /// - "CLIENT_IP" : 2-tuple hash on packet's source and destination IP
  /// addresses. Connections from the same source IP address to the same
  /// destination IP address will be served by the same backend VM while that VM
  /// remains healthy.
  /// - "CLIENT_IP_NO_DESTINATION" : 1-tuple hash only on packet's source IP
  /// address. Connections from the same source IP address will be served by the
  /// same backend VM while that VM remains healthy. This option can only be
  /// used for Internal TCP/UDP Load Balancing.
  /// - "CLIENT_IP_PORT_PROTO" : 5-tuple hash on packet's source and destination
  /// IP addresses, IP protocol, and source and destination ports. Connections
  /// for the same IP protocol from the same source IP address and port to the
  /// same destination IP address and port will be served by the same backend VM
  /// while that VM remains healthy. This option cannot be used for HTTP(S) load
  /// balancing.
  /// - "CLIENT_IP_PROTO" : 3-tuple hash on packet's source and destination IP
  /// addresses, and IP protocol. Connections for the same IP protocol from the
  /// same source IP address to the same destination IP address will be served
  /// by the same backend VM while that VM remains healthy. This option cannot
  /// be used for HTTP(S) load balancing.
  /// - "GENERATED_COOKIE" : Hash based on a cookie generated by the L7
  /// loadbalancer. Only valid for HTTP(S) load balancing.
  /// - "HEADER_FIELD" : The hash is based on a user specified header field.
  /// - "HTTP_COOKIE" : The hash is based on a user provided cookie.
  /// - "NONE" : No session affinity. Connections from the same client IP may go
  /// to any instance in the pool.
  core.String? sessionAffinity;

  TargetPool({
    this.backupPool,
    this.creationTimestamp,
    this.description,
    this.failoverRatio,
    this.healthChecks,
    this.id,
    this.instances,
    this.kind,
    this.name,
    this.region,
    this.selfLink,
    this.sessionAffinity,
  });

  TargetPool.fromJson(core.Map json_)
      : this(
          backupPool: json_.containsKey('backupPool')
              ? json_['backupPool'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          failoverRatio: json_.containsKey('failoverRatio')
              ? (json_['failoverRatio'] as core.num).toDouble()
              : null,
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sessionAffinity: json_.containsKey('sessionAffinity')
              ? json_['sessionAffinity'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backupPool != null) 'backupPool': backupPool!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (failoverRatio != null) 'failoverRatio': failoverRatio!,
        if (healthChecks != null) 'healthChecks': healthChecks!,
        if (id != null) 'id': id!,
        if (instances != null) 'instances': instances!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sessionAffinity != null) 'sessionAffinity': sessionAffinity!,
      };
}

class TargetPoolAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetPoolAggregatedListWarningData({
    this.key,
    this.value,
  });

  TargetPoolAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetPoolAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetPoolAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetPoolAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetPoolAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetPoolAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetPoolAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetPool resources.
  core.Map<core.String, TargetPoolsScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#targetPoolAggregatedList for aggregated lists of target
  /// pools.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  TargetPoolAggregatedListWarning? warning;

  TargetPoolAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  TargetPoolAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    TargetPoolsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetPoolAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetPoolInstanceHealth {
  core.List<HealthStatus>? healthStatus;

  /// Type of resource.
  ///
  /// Always compute#targetPoolInstanceHealth when checking the health of an
  /// instance.
  ///
  /// Output only.
  core.String? kind;

  TargetPoolInstanceHealth({
    this.healthStatus,
    this.kind,
  });

  TargetPoolInstanceHealth.fromJson(core.Map json_)
      : this(
          healthStatus: json_.containsKey('healthStatus')
              ? (json_['healthStatus'] as core.List)
                  .map((value) => HealthStatus.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthStatus != null) 'healthStatus': healthStatus!,
        if (kind != null) 'kind': kind!,
      };
}

class TargetPoolListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetPoolListWarningData({
    this.key,
    this.value,
  });

  TargetPoolListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetPoolListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetPoolListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetPoolListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetPoolListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetPoolListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetPool resources.
class TargetPoolList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetPool resources.
  core.List<TargetPool>? items;

  /// Type of resource.
  ///
  /// Always compute#targetPoolList for lists of target pools.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetPoolListWarning? warning;

  TargetPoolList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetPoolList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetPool.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetPoolListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetPoolsAddHealthCheckRequest {
  /// The HttpHealthCheck to add to the target pool.
  core.List<HealthCheckReference>? healthChecks;

  TargetPoolsAddHealthCheckRequest({
    this.healthChecks,
  });

  TargetPoolsAddHealthCheckRequest.fromJson(core.Map json_)
      : this(
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => HealthCheckReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthChecks != null) 'healthChecks': healthChecks!,
      };
}

class TargetPoolsAddInstanceRequest {
  /// A full or partial URL to an instance to add to this target pool.
  ///
  /// This can be a full or partial URL. For example, the following are valid
  /// URLs: -
  /// https://www.googleapis.com/compute/v1/projects/project-id/zones/zone
  /// /instances/instance-name -
  /// projects/project-id/zones/zone/instances/instance-name -
  /// zones/zone/instances/instance-name
  core.List<InstanceReference>? instances;

  TargetPoolsAddInstanceRequest({
    this.instances,
  });

  TargetPoolsAddInstanceRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => InstanceReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

class TargetPoolsRemoveHealthCheckRequest {
  /// Health check URL to be removed.
  ///
  /// This can be a full or valid partial URL. For example, the following are
  /// valid URLs: - https://www.googleapis.com/compute/beta/projects/project
  /// /global/httpHealthChecks/health-check -
  /// projects/project/global/httpHealthChecks/health-check -
  /// global/httpHealthChecks/health-check
  core.List<HealthCheckReference>? healthChecks;

  TargetPoolsRemoveHealthCheckRequest({
    this.healthChecks,
  });

  TargetPoolsRemoveHealthCheckRequest.fromJson(core.Map json_)
      : this(
          healthChecks: json_.containsKey('healthChecks')
              ? (json_['healthChecks'] as core.List)
                  .map((value) => HealthCheckReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (healthChecks != null) 'healthChecks': healthChecks!,
      };
}

class TargetPoolsRemoveInstanceRequest {
  /// URLs of the instances to be removed from target pool.
  core.List<InstanceReference>? instances;

  TargetPoolsRemoveInstanceRequest({
    this.instances,
  });

  TargetPoolsRemoveInstanceRequest.fromJson(core.Map json_)
      : this(
          instances: json_.containsKey('instances')
              ? (json_['instances'] as core.List)
                  .map((value) => InstanceReference.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instances != null) 'instances': instances!,
      };
}

class TargetPoolsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetPoolsScopedListWarningData({
    this.key,
    this.value,
  });

  TargetPoolsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
class TargetPoolsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetPoolsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetPoolsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetPoolsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetPoolsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetPoolsScopedList {
  /// A list of target pools contained in this scope.
  core.List<TargetPool>? targetPools;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  TargetPoolsScopedListWarning? warning;

  TargetPoolsScopedList({
    this.targetPools,
    this.warning,
  });

  TargetPoolsScopedList.fromJson(core.Map json_)
      : this(
          targetPools: json_.containsKey('targetPools')
              ? (json_['targetPools'] as core.List)
                  .map((value) => TargetPool.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetPoolsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetPools != null) 'targetPools': targetPools!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetReference {
  core.String? target;

  TargetReference({
    this.target,
  });

  TargetReference.fromJson(core.Map json_)
      : this(
          target: json_.containsKey('target')
              ? json_['target'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (target != null) 'target': target!,
      };
}

class TargetSslProxiesSetBackendServiceRequest {
  /// The URL of the new BackendService resource for the targetSslProxy.
  core.String? service;

  TargetSslProxiesSetBackendServiceRequest({
    this.service,
  });

  TargetSslProxiesSetBackendServiceRequest.fromJson(core.Map json_)
      : this(
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (service != null) 'service': service!,
      };
}

class TargetSslProxiesSetCertificateMapRequest {
  /// URL of the Certificate Map to associate with this TargetSslProxy.
  core.String? certificateMap;

  TargetSslProxiesSetCertificateMapRequest({
    this.certificateMap,
  });

  TargetSslProxiesSetCertificateMapRequest.fromJson(core.Map json_)
      : this(
          certificateMap: json_.containsKey('certificateMap')
              ? json_['certificateMap'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (certificateMap != null) 'certificateMap': certificateMap!,
      };
}

typedef TargetSslProxiesSetProxyHeaderRequest = $ProxiesSetProxyHeaderRequest;

class TargetSslProxiesSetSslCertificatesRequest {
  /// New set of URLs to SslCertificate resources to associate with this
  /// TargetSslProxy.
  ///
  /// At least one SSL certificate must be specified. Currently, you may specify
  /// up to 15 SSL certificates.
  core.List<core.String>? sslCertificates;

  TargetSslProxiesSetSslCertificatesRequest({
    this.sslCertificates,
  });

  TargetSslProxiesSetSslCertificatesRequest.fromJson(core.Map json_)
      : this(
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
      };
}

/// Represents a Target SSL Proxy resource.
///
/// A target SSL proxy is a component of a SSL Proxy load balancer. Global
/// forwarding rules reference a target SSL proxy, and the target proxy then
/// references an external backend service. For more information, read Using
/// Target Proxies.
class TargetSslProxy {
  /// URL of a certificate map that identifies a certificate map associated with
  /// the given target proxy.
  ///
  /// This field can only be set for global target proxies. If set,
  /// sslCertificates will be ignored.
  core.String? certificateMap;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#targetSslProxy for target SSL proxies.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// URL to the BackendService resource.
  core.String? service;

  /// URLs to SslCertificate resources that are used to authenticate connections
  /// to Backends.
  ///
  /// At least one SSL certificate must be specified. Currently, you may specify
  /// up to 15 SSL certificates. sslCertificates do not apply when the load
  /// balancing scheme is set to INTERNAL_SELF_MANAGED.
  core.List<core.String>? sslCertificates;

  /// URL of SslPolicy resource that will be associated with the TargetSslProxy
  /// resource.
  ///
  /// If not set, the TargetSslProxy resource will not have any SSL policy
  /// configured.
  core.String? sslPolicy;

  TargetSslProxy({
    this.certificateMap,
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.proxyHeader,
    this.selfLink,
    this.service,
    this.sslCertificates,
    this.sslPolicy,
  });

  TargetSslProxy.fromJson(core.Map json_)
      : this(
          certificateMap: json_.containsKey('certificateMap')
              ? json_['certificateMap'] as core.String
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
          sslCertificates: json_.containsKey('sslCertificates')
              ? (json_['sslCertificates'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          sslPolicy: json_.containsKey('sslPolicy')
              ? json_['sslPolicy'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (certificateMap != null) 'certificateMap': certificateMap!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (service != null) 'service': service!,
        if (sslCertificates != null) 'sslCertificates': sslCertificates!,
        if (sslPolicy != null) 'sslPolicy': sslPolicy!,
      };
}

class TargetSslProxyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetSslProxyListWarningData({
    this.key,
    this.value,
  });

  TargetSslProxyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetSslProxyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetSslProxyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetSslProxyListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetSslProxyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetSslProxyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetSslProxy resources.
class TargetSslProxyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetSslProxy resources.
  core.List<TargetSslProxy>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetSslProxyListWarning? warning;

  TargetSslProxyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetSslProxyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetSslProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetSslProxyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetTcpProxiesSetBackendServiceRequest {
  /// The URL of the new BackendService resource for the targetTcpProxy.
  core.String? service;

  TargetTcpProxiesSetBackendServiceRequest({
    this.service,
  });

  TargetTcpProxiesSetBackendServiceRequest.fromJson(core.Map json_)
      : this(
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (service != null) 'service': service!,
      };
}

typedef TargetTcpProxiesSetProxyHeaderRequest = $ProxiesSetProxyHeaderRequest;

/// Represents a Target TCP Proxy resource.
///
/// A target TCP proxy is a component of a TCP Proxy load balancer. Global
/// forwarding rules reference target TCP proxy, and the target proxy then
/// references an external backend service. For more information, read TCP Proxy
/// Load Balancing overview.
class TargetTcpProxy {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#targetTcpProxy for target TCP proxies.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// This field only applies when the forwarding rule that references this
  /// target proxy has a loadBalancingScheme set to INTERNAL_SELF_MANAGED.
  ///
  /// When this field is set to true, Envoy proxies set up inbound traffic
  /// interception and bind to the IP address and port specified in the
  /// forwarding rule. This is generally useful when using Traffic Director to
  /// configure Envoy as a gateway or middle proxy (in other words, not a
  /// sidecar proxy). The Envoy proxy listens for inbound requests and handles
  /// requests when it receives them. The default is false.
  core.bool? proxyBind;

  /// Specifies the type of proxy header to append before sending data to the
  /// backend, either NONE or PROXY_V1.
  ///
  /// The default is NONE.
  /// Possible string values are:
  /// - "NONE"
  /// - "PROXY_V1"
  core.String? proxyHeader;

  /// URL of the region where the regional TCP proxy resides.
  ///
  /// This field is not applicable to global TCP proxy.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// URL to the BackendService resource.
  core.String? service;

  TargetTcpProxy({
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.proxyBind,
    this.proxyHeader,
    this.region,
    this.selfLink,
    this.service,
  });

  TargetTcpProxy.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          proxyBind: json_.containsKey('proxyBind')
              ? json_['proxyBind'] as core.bool
              : null,
          proxyHeader: json_.containsKey('proxyHeader')
              ? json_['proxyHeader'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (proxyBind != null) 'proxyBind': proxyBind!,
        if (proxyHeader != null) 'proxyHeader': proxyHeader!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (service != null) 'service': service!,
      };
}

class TargetTcpProxyListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetTcpProxyListWarningData({
    this.key,
    this.value,
  });

  TargetTcpProxyListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetTcpProxyListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetTcpProxyListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetTcpProxyListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetTcpProxyListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetTcpProxyListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetTcpProxy resources.
class TargetTcpProxyList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetTcpProxy resources.
  core.List<TargetTcpProxy>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetTcpProxyListWarning? warning;

  TargetTcpProxyList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetTcpProxyList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetTcpProxy.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetTcpProxyListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Target VPN Gateway resource.
///
/// The target VPN gateway resource represents a Classic Cloud VPN gateway. For
/// more information, read the the Cloud VPN Overview.
class TargetVpnGateway {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// A list of URLs to the ForwardingRule resources.
  ///
  /// ForwardingRules are created using compute.forwardingRules.insert and
  /// associated with a VPN gateway.
  ///
  /// Output only.
  core.List<core.String>? forwardingRules;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#targetVpnGateway for target VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the network to which this VPN gateway is attached.
  ///
  /// Provided by the client when the VPN gateway is created.
  core.String? network;

  /// URL of the region where the target VPN gateway resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The status of the VPN gateway, which can be one of the following:
  /// CREATING, READY, FAILED, or DELETING.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CREATING"
  /// - "DELETING"
  /// - "FAILED"
  /// - "READY"
  core.String? status;

  /// A list of URLs to VpnTunnel resources.
  ///
  /// VpnTunnels are created using the compute.vpntunnels.insert method and
  /// associated with a VPN gateway.
  ///
  /// Output only.
  core.List<core.String>? tunnels;

  TargetVpnGateway({
    this.creationTimestamp,
    this.description,
    this.forwardingRules,
    this.id,
    this.kind,
    this.name,
    this.network,
    this.region,
    this.selfLink,
    this.status,
    this.tunnels,
  });

  TargetVpnGateway.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          forwardingRules: json_.containsKey('forwardingRules')
              ? (json_['forwardingRules'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          tunnels: json_.containsKey('tunnels')
              ? (json_['tunnels'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (forwardingRules != null) 'forwardingRules': forwardingRules!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (tunnels != null) 'tunnels': tunnels!,
      };
}

class TargetVpnGatewayAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetVpnGatewayAggregatedListWarningData({
    this.key,
    this.value,
  });

  TargetVpnGatewayAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetVpnGatewayAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetVpnGatewayAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetVpnGatewayAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetVpnGatewayAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetVpnGatewayAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetVpnGatewayAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetVpnGateway resources.
  core.Map<core.String, TargetVpnGatewaysScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#targetVpnGateway for target VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  TargetVpnGatewayAggregatedListWarning? warning;

  TargetVpnGatewayAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  TargetVpnGatewayAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    TargetVpnGatewaysScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetVpnGatewayAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetVpnGatewayListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetVpnGatewayListWarningData({
    this.key,
    this.value,
  });

  TargetVpnGatewayListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class TargetVpnGatewayListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetVpnGatewayListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetVpnGatewayListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetVpnGatewayListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => TargetVpnGatewayListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of TargetVpnGateway resources.
class TargetVpnGatewayList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of TargetVpnGateway resources.
  core.List<TargetVpnGateway>? items;

  /// Type of resource.
  ///
  /// Always compute#targetVpnGateway for target VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  TargetVpnGatewayListWarning? warning;

  TargetVpnGatewayList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  TargetVpnGatewayList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => TargetVpnGateway.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? TargetVpnGatewayListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class TargetVpnGatewaysScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  TargetVpnGatewaysScopedListWarningData({
    this.key,
    this.value,
  });

  TargetVpnGatewaysScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
///
/// Output only.
class TargetVpnGatewaysScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<TargetVpnGatewaysScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  TargetVpnGatewaysScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  TargetVpnGatewaysScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      TargetVpnGatewaysScopedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class TargetVpnGatewaysScopedList {
  /// A list of target VPN gateways contained in this scope.
  ///
  /// Output only.
  core.List<TargetVpnGateway>? targetVpnGateways;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  ///
  /// Output only.
  TargetVpnGatewaysScopedListWarning? warning;

  TargetVpnGatewaysScopedList({
    this.targetVpnGateways,
    this.warning,
  });

  TargetVpnGatewaysScopedList.fromJson(core.Map json_)
      : this(
          targetVpnGateways: json_.containsKey('targetVpnGateways')
              ? (json_['targetVpnGateways'] as core.List)
                  .map((value) => TargetVpnGateway.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? TargetVpnGatewaysScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (targetVpnGateways != null) 'targetVpnGateways': targetVpnGateways!,
        if (warning != null) 'warning': warning!,
      };
}

class TestFailure {
  /// The actual output URL evaluated by a load balancer containing the scheme,
  /// host, path and query parameters.
  core.String? actualOutputUrl;

  /// Actual HTTP status code for rule with `urlRedirect` calculated by load
  /// balancer
  core.int? actualRedirectResponseCode;

  /// BackendService or BackendBucket returned by load balancer.
  core.String? actualService;

  /// The expected output URL evaluated by a load balancer containing the
  /// scheme, host, path and query parameters.
  core.String? expectedOutputUrl;

  /// Expected HTTP status code for rule with `urlRedirect` calculated by load
  /// balancer
  core.int? expectedRedirectResponseCode;

  /// Expected BackendService or BackendBucket resource the given URL should be
  /// mapped to.
  core.String? expectedService;

  /// HTTP headers of the request.
  core.List<UrlMapTestHeader>? headers;

  /// Host portion of the URL.
  core.String? host;

  /// Path portion including query parameters in the URL.
  core.String? path;

  TestFailure({
    this.actualOutputUrl,
    this.actualRedirectResponseCode,
    this.actualService,
    this.expectedOutputUrl,
    this.expectedRedirectResponseCode,
    this.expectedService,
    this.headers,
    this.host,
    this.path,
  });

  TestFailure.fromJson(core.Map json_)
      : this(
          actualOutputUrl: json_.containsKey('actualOutputUrl')
              ? json_['actualOutputUrl'] as core.String
              : null,
          actualRedirectResponseCode:
              json_.containsKey('actualRedirectResponseCode')
                  ? json_['actualRedirectResponseCode'] as core.int
                  : null,
          actualService: json_.containsKey('actualService')
              ? json_['actualService'] as core.String
              : null,
          expectedOutputUrl: json_.containsKey('expectedOutputUrl')
              ? json_['expectedOutputUrl'] as core.String
              : null,
          expectedRedirectResponseCode:
              json_.containsKey('expectedRedirectResponseCode')
                  ? json_['expectedRedirectResponseCode'] as core.int
                  : null,
          expectedService: json_.containsKey('expectedService')
              ? json_['expectedService'] as core.String
              : null,
          headers: json_.containsKey('headers')
              ? (json_['headers'] as core.List)
                  .map((value) => UrlMapTestHeader.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          path: json_.containsKey('path') ? json_['path'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (actualOutputUrl != null) 'actualOutputUrl': actualOutputUrl!,
        if (actualRedirectResponseCode != null)
          'actualRedirectResponseCode': actualRedirectResponseCode!,
        if (actualService != null) 'actualService': actualService!,
        if (expectedOutputUrl != null) 'expectedOutputUrl': expectedOutputUrl!,
        if (expectedRedirectResponseCode != null)
          'expectedRedirectResponseCode': expectedRedirectResponseCode!,
        if (expectedService != null) 'expectedService': expectedService!,
        if (headers != null) 'headers': headers!,
        if (host != null) 'host': host!,
        if (path != null) 'path': path!,
      };
}

typedef TestPermissionsRequest = $TestPermissionsRequest;
typedef TestPermissionsResponse = $PermissionsResponse;

class Uint128 {
  core.String? high;
  core.String? low;

  Uint128({
    this.high,
    this.low,
  });

  Uint128.fromJson(core.Map json_)
      : this(
          high: json_.containsKey('high') ? json_['high'] as core.String : null,
          low: json_.containsKey('low') ? json_['low'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (high != null) 'high': high!,
        if (low != null) 'low': low!,
      };
}

/// Represents a URL Map resource.
///
/// Compute Engine has two URL Map resources: *
/// \[Global\](/compute/docs/reference/rest/v1/urlMaps) *
/// \[Regional\](/compute/docs/reference/rest/v1/regionUrlMaps) A URL map
/// resource is a component of certain types of cloud load balancers and Traffic
/// Director: * urlMaps are used by external HTTP(S) load balancers and Traffic
/// Director. * regionUrlMaps are used by internal HTTP(S) load balancers. For a
/// list of supported URL map features by the load balancer type, see the Load
/// balancing features: Routing and traffic management table. For a list of
/// supported URL map features for Traffic Director, see the Traffic Director
/// features: Routing and traffic management table. This resource defines
/// mappings from hostnames and URL paths to either a backend service or a
/// backend bucket. To use the global urlMaps resource, the backend service must
/// have a loadBalancingScheme of either EXTERNAL or INTERNAL_SELF_MANAGED. To
/// use the regionUrlMaps resource, the backend service must have a
/// loadBalancingScheme of INTERNAL_MANAGED. For more information, read URL Map
/// Concepts.
class UrlMap {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// defaultRouteAction takes effect when none of the hostRules match.
  ///
  /// The load balancer performs advanced routing actions, such as URL rewrites
  /// and header transformations, before forwarding the request to the selected
  /// backend. If defaultRouteAction specifies any weightedBackendServices,
  /// defaultService must not be set. Conversely if defaultService is set,
  /// defaultRouteAction cannot contain any weightedBackendServices. Only one of
  /// defaultRouteAction or defaultUrlRedirect must be set. URL maps for Classic
  /// external HTTP(S) load balancers only support the urlRewrite action within
  /// defaultRouteAction. defaultRouteAction has no effect when the URL map is
  /// bound to a target gRPC proxy that has the validateForProxyless field set
  /// to true.
  HttpRouteAction? defaultRouteAction;

  /// The full or partial URL of the defaultService resource to which traffic is
  /// directed if none of the hostRules match.
  ///
  /// If defaultRouteAction is also specified, advanced routing actions, such as
  /// URL rewrites, take effect before sending the request to the backend.
  /// However, if defaultService is specified, defaultRouteAction cannot contain
  /// any weightedBackendServices. Conversely, if routeAction specifies any
  /// weightedBackendServices, service must not be specified. Only one of
  /// defaultService, defaultUrlRedirect , or
  /// defaultRouteAction.weightedBackendService must be set. defaultService has
  /// no effect when the URL map is bound to a target gRPC proxy that has the
  /// validateForProxyless field set to true.
  core.String? defaultService;

  /// When none of the specified hostRules match, the request is redirected to a
  /// URL specified by defaultUrlRedirect.
  ///
  /// If defaultUrlRedirect is specified, defaultService or defaultRouteAction
  /// must not be set. Not supported when the URL map is bound to a target gRPC
  /// proxy.
  HttpRedirectAction? defaultUrlRedirect;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Fingerprint of this resource.
  ///
  /// A hash of the contents stored in this object. This field is used in
  /// optimistic locking. This field is ignored when inserting a UrlMap. An
  /// up-to-date fingerprint must be provided in order to update the UrlMap,
  /// otherwise the request will fail with error 412 conditionNotMet. To see the
  /// latest fingerprint, make a get() request to retrieve a UrlMap.
  core.String? fingerprint;
  core.List<core.int> get fingerprintAsBytes =>
      convert.base64.decode(fingerprint!);

  set fingerprintAsBytes(core.List<core.int> bytes_) {
    fingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Specifies changes to request and response headers that need to take effect
  /// for the selected backendService.
  ///
  /// The headerAction specified here take effect after headerAction specified
  /// under pathMatcher. headerAction is not supported for load balancers that
  /// have their loadBalancingScheme set to EXTERNAL. Not supported when the URL
  /// map is bound to a target gRPC proxy that has validateForProxyless field
  /// set to true.
  HttpHeaderAction? headerAction;

  /// The list of host rules to use against the URL.
  core.List<HostRule>? hostRules;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#urlMaps for url maps.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// The list of named PathMatchers to use against the URL.
  core.List<PathMatcher>? pathMatchers;

  /// URL of the region where the regional URL map resides.
  ///
  /// This field is not applicable to global URL maps. You must specify this
  /// field as part of the HTTP request URL. It is not settable as a field in
  /// the request body.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The list of expected URL mapping tests.
  ///
  /// Request to update the UrlMap succeeds only if all test cases pass. You can
  /// specify a maximum of 100 tests per UrlMap. Not supported when the URL map
  /// is bound to a target gRPC proxy that has validateForProxyless field set to
  /// true.
  core.List<UrlMapTest>? tests;

  UrlMap({
    this.creationTimestamp,
    this.defaultRouteAction,
    this.defaultService,
    this.defaultUrlRedirect,
    this.description,
    this.fingerprint,
    this.headerAction,
    this.hostRules,
    this.id,
    this.kind,
    this.name,
    this.pathMatchers,
    this.region,
    this.selfLink,
    this.tests,
  });

  UrlMap.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          defaultRouteAction: json_.containsKey('defaultRouteAction')
              ? HttpRouteAction.fromJson(json_['defaultRouteAction']
                  as core.Map<core.String, core.dynamic>)
              : null,
          defaultService: json_.containsKey('defaultService')
              ? json_['defaultService'] as core.String
              : null,
          defaultUrlRedirect: json_.containsKey('defaultUrlRedirect')
              ? HttpRedirectAction.fromJson(json_['defaultUrlRedirect']
                  as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          fingerprint: json_.containsKey('fingerprint')
              ? json_['fingerprint'] as core.String
              : null,
          headerAction: json_.containsKey('headerAction')
              ? HttpHeaderAction.fromJson(
                  json_['headerAction'] as core.Map<core.String, core.dynamic>)
              : null,
          hostRules: json_.containsKey('hostRules')
              ? (json_['hostRules'] as core.List)
                  .map((value) => HostRule.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          pathMatchers: json_.containsKey('pathMatchers')
              ? (json_['pathMatchers'] as core.List)
                  .map((value) => PathMatcher.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          tests: json_.containsKey('tests')
              ? (json_['tests'] as core.List)
                  .map((value) => UrlMapTest.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (defaultRouteAction != null)
          'defaultRouteAction': defaultRouteAction!,
        if (defaultService != null) 'defaultService': defaultService!,
        if (defaultUrlRedirect != null)
          'defaultUrlRedirect': defaultUrlRedirect!,
        if (description != null) 'description': description!,
        if (fingerprint != null) 'fingerprint': fingerprint!,
        if (headerAction != null) 'headerAction': headerAction!,
        if (hostRules != null) 'hostRules': hostRules!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (pathMatchers != null) 'pathMatchers': pathMatchers!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (tests != null) 'tests': tests!,
      };
}

class UrlMapListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  UrlMapListWarningData({
    this.key,
    this.value,
  });

  UrlMapListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class UrlMapListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<UrlMapListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  UrlMapListWarning({
    this.code,
    this.data,
    this.message,
  });

  UrlMapListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => UrlMapListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of UrlMap resources.
class UrlMapList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of UrlMap resources.
  core.List<UrlMap>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  UrlMapListWarning? warning;

  UrlMapList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  UrlMapList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => UrlMap.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? UrlMapListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class UrlMapReference {
  core.String? urlMap;

  UrlMapReference({
    this.urlMap,
  });

  UrlMapReference.fromJson(core.Map json_)
      : this(
          urlMap: json_.containsKey('urlMap')
              ? json_['urlMap'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (urlMap != null) 'urlMap': urlMap!,
      };
}

/// Message for the expected URL mappings.
class UrlMapTest {
  /// Description of this test case.
  core.String? description;

  /// The expected output URL evaluated by the load balancer containing the
  /// scheme, host, path and query parameters.
  ///
  /// For rules that forward requests to backends, the test passes only when
  /// expectedOutputUrl matches the request forwarded by the load balancer to
  /// backends. For rules with urlRewrite, the test verifies that the forwarded
  /// request matches hostRewrite and pathPrefixRewrite in the urlRewrite
  /// action. When service is specified, expectedOutputUrl\`s scheme is ignored.
  /// For rules with urlRedirect, the test passes only if expectedOutputUrl
  /// matches the URL in the load balancer's redirect response. If urlRedirect
  /// specifies https_redirect, the test passes only if the scheme in
  /// expectedOutputUrl is also set to HTTPS. If urlRedirect specifies
  /// strip_query, the test passes only if expectedOutputUrl does not contain
  /// any query parameters. expectedOutputUrl is optional when service is
  /// specified.
  core.String? expectedOutputUrl;

  /// For rules with urlRedirect, the test passes only if
  /// expectedRedirectResponseCode matches the HTTP status code in load
  /// balancer's redirect response.
  ///
  /// expectedRedirectResponseCode cannot be set when service is set.
  core.int? expectedRedirectResponseCode;

  /// HTTP headers for this request.
  ///
  /// If headers contains a host header, then host must also match the header
  /// value.
  core.List<UrlMapTestHeader>? headers;

  /// Host portion of the URL.
  ///
  /// If headers contains a host header, then host must also match the header
  /// value.
  core.String? host;

  /// Path portion of the URL.
  core.String? path;

  /// Expected BackendService or BackendBucket resource the given URL should be
  /// mapped to.
  ///
  /// The service field cannot be set if expectedRedirectResponseCode is set.
  core.String? service;

  UrlMapTest({
    this.description,
    this.expectedOutputUrl,
    this.expectedRedirectResponseCode,
    this.headers,
    this.host,
    this.path,
    this.service,
  });

  UrlMapTest.fromJson(core.Map json_)
      : this(
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          expectedOutputUrl: json_.containsKey('expectedOutputUrl')
              ? json_['expectedOutputUrl'] as core.String
              : null,
          expectedRedirectResponseCode:
              json_.containsKey('expectedRedirectResponseCode')
                  ? json_['expectedRedirectResponseCode'] as core.int
                  : null,
          headers: json_.containsKey('headers')
              ? (json_['headers'] as core.List)
                  .map((value) => UrlMapTestHeader.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          host: json_.containsKey('host') ? json_['host'] as core.String : null,
          path: json_.containsKey('path') ? json_['path'] as core.String : null,
          service: json_.containsKey('service')
              ? json_['service'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (description != null) 'description': description!,
        if (expectedOutputUrl != null) 'expectedOutputUrl': expectedOutputUrl!,
        if (expectedRedirectResponseCode != null)
          'expectedRedirectResponseCode': expectedRedirectResponseCode!,
        if (headers != null) 'headers': headers!,
        if (host != null) 'host': host!,
        if (path != null) 'path': path!,
        if (service != null) 'service': service!,
      };
}

/// HTTP headers used in UrlMapTests.
typedef UrlMapTestHeader = $Header;

/// Message representing the validation result for a UrlMap.
class UrlMapValidationResult {
  core.List<core.String>? loadErrors;

  /// Whether the given UrlMap can be successfully loaded.
  ///
  /// If false, 'loadErrors' indicates the reasons.
  core.bool? loadSucceeded;
  core.List<TestFailure>? testFailures;

  /// If successfully loaded, this field indicates whether the test passed.
  ///
  /// If false, 'testFailures's indicate the reason of failure.
  core.bool? testPassed;

  UrlMapValidationResult({
    this.loadErrors,
    this.loadSucceeded,
    this.testFailures,
    this.testPassed,
  });

  UrlMapValidationResult.fromJson(core.Map json_)
      : this(
          loadErrors: json_.containsKey('loadErrors')
              ? (json_['loadErrors'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          loadSucceeded: json_.containsKey('loadSucceeded')
              ? json_['loadSucceeded'] as core.bool
              : null,
          testFailures: json_.containsKey('testFailures')
              ? (json_['testFailures'] as core.List)
                  .map((value) => TestFailure.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          testPassed: json_.containsKey('testPassed')
              ? json_['testPassed'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (loadErrors != null) 'loadErrors': loadErrors!,
        if (loadSucceeded != null) 'loadSucceeded': loadSucceeded!,
        if (testFailures != null) 'testFailures': testFailures!,
        if (testPassed != null) 'testPassed': testPassed!,
      };
}

class UrlMapsAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  UrlMapsAggregatedListWarningData({
    this.key,
    this.value,
  });

  UrlMapsAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class UrlMapsAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<UrlMapsAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  UrlMapsAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  UrlMapsAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => UrlMapsAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class UrlMapsAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of UrlMapsScopedList resources.
  core.Map<core.String, UrlMapsScopedList>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  UrlMapsAggregatedListWarning? warning;

  UrlMapsAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  UrlMapsAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    UrlMapsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? UrlMapsAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class UrlMapsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  UrlMapsScopedListWarningData({
    this.key,
    this.value,
  });

  UrlMapsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of backend services when the
/// list is empty.
class UrlMapsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<UrlMapsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  UrlMapsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  UrlMapsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => UrlMapsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class UrlMapsScopedList {
  /// A list of UrlMaps contained in this scope.
  core.List<UrlMap>? urlMaps;

  /// Informational warning which replaces the list of backend services when the
  /// list is empty.
  UrlMapsScopedListWarning? warning;

  UrlMapsScopedList({
    this.urlMaps,
    this.warning,
  });

  UrlMapsScopedList.fromJson(core.Map json_)
      : this(
          urlMaps: json_.containsKey('urlMaps')
              ? (json_['urlMaps'] as core.List)
                  .map((value) => UrlMap.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? UrlMapsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (urlMaps != null) 'urlMaps': urlMaps!,
        if (warning != null) 'warning': warning!,
      };
}

class UrlMapsValidateRequest {
  /// Specifies the load balancer type(s) this validation request is for.
  ///
  /// Use EXTERNAL_MANAGED for HTTP/HTTPS External Global Load Balancer with
  /// Advanced Traffic Management. Use EXTERNAL for Classic HTTP/HTTPS External
  /// Global Load Balancer. Other load balancer types are not supported. For
  /// more information, refer to Choosing a load balancer. If unspecified, the
  /// load balancing scheme will be inferred from the backend service resources
  /// this URL map references. If that can not be inferred (for example, this
  /// URL map only references backend buckets, or this Url map is for rewrites
  /// and redirects only and doesn't reference any backends), EXTERNAL will be
  /// used as the default type. If specified, the scheme(s) must not conflict
  /// with the load balancing scheme of the backend service resources this Url
  /// map references.
  core.List<core.String>? loadBalancingSchemes;

  /// Content of the UrlMap to be validated.
  UrlMap? resource;

  UrlMapsValidateRequest({
    this.loadBalancingSchemes,
    this.resource,
  });

  UrlMapsValidateRequest.fromJson(core.Map json_)
      : this(
          loadBalancingSchemes: json_.containsKey('loadBalancingSchemes')
              ? (json_['loadBalancingSchemes'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          resource: json_.containsKey('resource')
              ? UrlMap.fromJson(
                  json_['resource'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (loadBalancingSchemes != null)
          'loadBalancingSchemes': loadBalancingSchemes!,
        if (resource != null) 'resource': resource!,
      };
}

class UrlMapsValidateResponse {
  UrlMapValidationResult? result;

  UrlMapsValidateResponse({
    this.result,
  });

  UrlMapsValidateResponse.fromJson(core.Map json_)
      : this(
          result: json_.containsKey('result')
              ? UrlMapValidationResult.fromJson(
                  json_['result'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (result != null) 'result': result!,
      };
}

/// The spec for modifying the path before sending the request to the matched
/// backend service.
class UrlRewrite {
  /// Before forwarding the request to the selected service, the request's host
  /// header is replaced with contents of hostRewrite.
  ///
  /// The value must be from 1 to 255 characters.
  core.String? hostRewrite;

  /// Before forwarding the request to the selected backend service, the
  /// matching portion of the request's path is replaced by pathPrefixRewrite.
  ///
  /// The value must be from 1 to 1024 characters.
  core.String? pathPrefixRewrite;

  UrlRewrite({
    this.hostRewrite,
    this.pathPrefixRewrite,
  });

  UrlRewrite.fromJson(core.Map json_)
      : this(
          hostRewrite: json_.containsKey('hostRewrite')
              ? json_['hostRewrite'] as core.String
              : null,
          pathPrefixRewrite: json_.containsKey('pathPrefixRewrite')
              ? json_['pathPrefixRewrite'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (hostRewrite != null) 'hostRewrite': hostRewrite!,
        if (pathPrefixRewrite != null) 'pathPrefixRewrite': pathPrefixRewrite!,
      };
}

/// Subnetwork which the current user has compute.subnetworks.use permission on.
class UsableSubnetwork {
  /// The external IPv6 address range that is assigned to this subnetwork.
  ///
  /// Output only.
  core.String? externalIpv6Prefix;

  /// The internal IPv6 address range that is assigned to this subnetwork.
  ///
  /// Output only.
  core.String? internalIpv6Prefix;

  /// The range of internal addresses that are owned by this subnetwork.
  core.String? ipCidrRange;

  /// The access type of IPv6 address this subnet holds.
  ///
  /// It's immutable and can only be specified during creation or the first time
  /// the subnet is updated into IPV4_IPV6 dual stack.
  /// Possible string values are:
  /// - "EXTERNAL" : VMs on this subnet will be assigned IPv6 addresses that are
  /// accessible via the Internet, as well as the VPC network.
  /// - "INTERNAL" : VMs on this subnet will be assigned IPv6 addresses that are
  /// only accessible over the VPC network.
  core.String? ipv6AccessType;

  /// Network URL.
  core.String? network;

  /// The purpose of the resource.
  ///
  /// This field can be either PRIVATE_RFC_1918 or INTERNAL_HTTPS_LOAD_BALANCER.
  /// A subnetwork with purpose set to INTERNAL_HTTPS_LOAD_BALANCER is a
  /// user-created subnetwork that is reserved for Internal HTTP(S) Load
  /// Balancing. If unspecified, the purpose defaults to PRIVATE_RFC_1918. The
  /// enableFlowLogs field isn't supported with the purpose field set to
  /// INTERNAL_HTTPS_LOAD_BALANCER.
  /// Possible string values are:
  /// - "INTERNAL_HTTPS_LOAD_BALANCER" : Subnet reserved for Internal HTTP(S)
  /// Load Balancing.
  /// - "PRIVATE" : Regular user created or automatically created subnet.
  /// - "PRIVATE_RFC_1918" : Regular user created or automatically created
  /// subnet.
  /// - "PRIVATE_SERVICE_CONNECT" : Subnetworks created for Private Service
  /// Connect in the producer network.
  /// - "REGIONAL_MANAGED_PROXY" : Subnetwork used for Regional
  /// Internal/External HTTP(S) Load Balancing.
  core.String? purpose;

  /// The role of subnetwork.
  ///
  /// Currently, this field is only used when purpose =
  /// INTERNAL_HTTPS_LOAD_BALANCER. The value can be set to ACTIVE or BACKUP. An
  /// ACTIVE subnetwork is one that is currently being used for Internal HTTP(S)
  /// Load Balancing. A BACKUP subnetwork is one that is ready to be promoted to
  /// ACTIVE or is currently draining. This field can be updated with a patch
  /// request.
  /// Possible string values are:
  /// - "ACTIVE" : The ACTIVE subnet that is currently used.
  /// - "BACKUP" : The BACKUP subnet that could be promoted to ACTIVE.
  core.String? role;

  /// Secondary IP ranges.
  core.List<UsableSubnetworkSecondaryRange>? secondaryIpRanges;

  /// The stack type for the subnet.
  ///
  /// If set to IPV4_ONLY, new VMs in the subnet are assigned IPv4 addresses
  /// only. If set to IPV4_IPV6, new VMs in the subnet can be assigned both IPv4
  /// and IPv6 addresses. If not specified, IPV4_ONLY is used. This field can be
  /// both set at resource creation time and updated using patch.
  /// Possible string values are:
  /// - "IPV4_IPV6" : New VMs in this subnet can have both IPv4 and IPv6
  /// addresses.
  /// - "IPV4_ONLY" : New VMs in this subnet will only be assigned IPv4
  /// addresses.
  core.String? stackType;

  /// Subnetwork URL.
  core.String? subnetwork;

  UsableSubnetwork({
    this.externalIpv6Prefix,
    this.internalIpv6Prefix,
    this.ipCidrRange,
    this.ipv6AccessType,
    this.network,
    this.purpose,
    this.role,
    this.secondaryIpRanges,
    this.stackType,
    this.subnetwork,
  });

  UsableSubnetwork.fromJson(core.Map json_)
      : this(
          externalIpv6Prefix: json_.containsKey('externalIpv6Prefix')
              ? json_['externalIpv6Prefix'] as core.String
              : null,
          internalIpv6Prefix: json_.containsKey('internalIpv6Prefix')
              ? json_['internalIpv6Prefix'] as core.String
              : null,
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          ipv6AccessType: json_.containsKey('ipv6AccessType')
              ? json_['ipv6AccessType'] as core.String
              : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          purpose: json_.containsKey('purpose')
              ? json_['purpose'] as core.String
              : null,
          role: json_.containsKey('role') ? json_['role'] as core.String : null,
          secondaryIpRanges: json_.containsKey('secondaryIpRanges')
              ? (json_['secondaryIpRanges'] as core.List)
                  .map((value) => UsableSubnetworkSecondaryRange.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          subnetwork: json_.containsKey('subnetwork')
              ? json_['subnetwork'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (externalIpv6Prefix != null)
          'externalIpv6Prefix': externalIpv6Prefix!,
        if (internalIpv6Prefix != null)
          'internalIpv6Prefix': internalIpv6Prefix!,
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (ipv6AccessType != null) 'ipv6AccessType': ipv6AccessType!,
        if (network != null) 'network': network!,
        if (purpose != null) 'purpose': purpose!,
        if (role != null) 'role': role!,
        if (secondaryIpRanges != null) 'secondaryIpRanges': secondaryIpRanges!,
        if (stackType != null) 'stackType': stackType!,
        if (subnetwork != null) 'subnetwork': subnetwork!,
      };
}

/// Secondary IP range of a usable subnetwork.
class UsableSubnetworkSecondaryRange {
  /// The range of IP addresses belonging to this subnetwork secondary range.
  core.String? ipCidrRange;

  /// The name associated with this subnetwork secondary range, used when adding
  /// an alias IP range to a VM instance.
  ///
  /// The name must be 1-63 characters long, and comply with RFC1035. The name
  /// must be unique within the subnetwork.
  core.String? rangeName;

  UsableSubnetworkSecondaryRange({
    this.ipCidrRange,
    this.rangeName,
  });

  UsableSubnetworkSecondaryRange.fromJson(core.Map json_)
      : this(
          ipCidrRange: json_.containsKey('ipCidrRange')
              ? json_['ipCidrRange'] as core.String
              : null,
          rangeName: json_.containsKey('rangeName')
              ? json_['rangeName'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (ipCidrRange != null) 'ipCidrRange': ipCidrRange!,
        if (rangeName != null) 'rangeName': rangeName!,
      };
}

class UsableSubnetworksAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  UsableSubnetworksAggregatedListWarningData({
    this.key,
    this.value,
  });

  UsableSubnetworksAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class UsableSubnetworksAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<UsableSubnetworksAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  UsableSubnetworksAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  UsableSubnetworksAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) =>
                      UsableSubnetworksAggregatedListWarningData.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class UsableSubnetworksAggregatedList {
  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// \[Output\] A list of usable subnetwork URLs.
  core.List<UsableSubnetwork>? items;

  /// Type of resource.
  ///
  /// Always compute#usableSubnetworksAggregatedList for aggregated lists of
  /// usable subnetworks.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results. In special cases listUsable may return 0
  /// subnetworks and nextPageToken which still should be used to get the next
  /// page of results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  UsableSubnetworksAggregatedListWarning? warning;

  UsableSubnetworksAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  UsableSubnetworksAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => UsableSubnetwork.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? UsableSubnetworksAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// The location in Cloud Storage and naming method of the daily usage report.
///
/// Contains bucket_name and report_name prefix.
class UsageExportLocation {
  /// The name of an existing bucket in Cloud Storage where the usage report
  /// object is stored.
  ///
  /// The Google Service Account is granted write access to this bucket. This
  /// can either be the bucket name by itself, such as example-bucket, or the
  /// bucket name with gs:// or https://storage.googleapis.com/ in front of it,
  /// such as gs://example-bucket.
  core.String? bucketName;

  /// An optional prefix for the name of the usage report object stored in
  /// bucketName.
  ///
  /// If not supplied, defaults to usage_gce. The report is stored as a CSV file
  /// named report_name_prefix_gce_YYYYMMDD.csv where YYYYMMDD is the day of the
  /// usage according to Pacific Time. If you supply a prefix, it should conform
  /// to Cloud Storage object naming conventions.
  core.String? reportNamePrefix;

  UsageExportLocation({
    this.bucketName,
    this.reportNamePrefix,
  });

  UsageExportLocation.fromJson(core.Map json_)
      : this(
          bucketName: json_.containsKey('bucketName')
              ? json_['bucketName'] as core.String
              : null,
          reportNamePrefix: json_.containsKey('reportNamePrefix')
              ? json_['reportNamePrefix'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bucketName != null) 'bucketName': bucketName!,
        if (reportNamePrefix != null) 'reportNamePrefix': reportNamePrefix!,
      };
}

/// Contain information of Nat mapping for a VM endpoint (i.e., NIC).
class VmEndpointNatMappings {
  /// Name of the VM instance which the endpoint belongs to
  core.String? instanceName;
  core.List<VmEndpointNatMappingsInterfaceNatMappings>? interfaceNatMappings;

  VmEndpointNatMappings({
    this.instanceName,
    this.interfaceNatMappings,
  });

  VmEndpointNatMappings.fromJson(core.Map json_)
      : this(
          instanceName: json_.containsKey('instanceName')
              ? json_['instanceName'] as core.String
              : null,
          interfaceNatMappings: json_.containsKey('interfaceNatMappings')
              ? (json_['interfaceNatMappings'] as core.List)
                  .map((value) =>
                      VmEndpointNatMappingsInterfaceNatMappings.fromJson(
                          value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (instanceName != null) 'instanceName': instanceName!,
        if (interfaceNatMappings != null)
          'interfaceNatMappings': interfaceNatMappings!,
      };
}

/// Contain information of Nat mapping for an interface of this endpoint.
class VmEndpointNatMappingsInterfaceNatMappings {
  /// List of all drain IP:port-range mappings assigned to this interface.
  ///
  /// These ranges are inclusive, that is, both the first and the last ports can
  /// be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\].
  core.List<core.String>? drainNatIpPortRanges;

  /// A list of all IP:port-range mappings assigned to this interface.
  ///
  /// These ranges are inclusive, that is, both the first and the last ports can
  /// be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\].
  core.List<core.String>? natIpPortRanges;

  /// Total number of drain ports across all NAT IPs allocated to this
  /// interface.
  ///
  /// It equals to the aggregated port number in the field
  /// drain_nat_ip_port_ranges.
  core.int? numTotalDrainNatPorts;

  /// Total number of ports across all NAT IPs allocated to this interface.
  ///
  /// It equals to the aggregated port number in the field nat_ip_port_ranges.
  core.int? numTotalNatPorts;

  /// Information about mappings provided by rules in this NAT.
  core.List<VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings>?
      ruleMappings;

  /// Alias IP range for this interface endpoint.
  ///
  /// It will be a private (RFC 1918) IP range. Examples: "10.33.4.55/32", or
  /// "192.168.5.0/24".
  core.String? sourceAliasIpRange;

  /// Primary IP of the VM for this NIC.
  core.String? sourceVirtualIp;

  VmEndpointNatMappingsInterfaceNatMappings({
    this.drainNatIpPortRanges,
    this.natIpPortRanges,
    this.numTotalDrainNatPorts,
    this.numTotalNatPorts,
    this.ruleMappings,
    this.sourceAliasIpRange,
    this.sourceVirtualIp,
  });

  VmEndpointNatMappingsInterfaceNatMappings.fromJson(core.Map json_)
      : this(
          drainNatIpPortRanges: json_.containsKey('drainNatIpPortRanges')
              ? (json_['drainNatIpPortRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          natIpPortRanges: json_.containsKey('natIpPortRanges')
              ? (json_['natIpPortRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          numTotalDrainNatPorts: json_.containsKey('numTotalDrainNatPorts')
              ? json_['numTotalDrainNatPorts'] as core.int
              : null,
          numTotalNatPorts: json_.containsKey('numTotalNatPorts')
              ? json_['numTotalNatPorts'] as core.int
              : null,
          ruleMappings: json_.containsKey('ruleMappings')
              ? (json_['ruleMappings'] as core.List)
                  .map((value) =>
                      VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                          .fromJson(
                              value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          sourceAliasIpRange: json_.containsKey('sourceAliasIpRange')
              ? json_['sourceAliasIpRange'] as core.String
              : null,
          sourceVirtualIp: json_.containsKey('sourceVirtualIp')
              ? json_['sourceVirtualIp'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (drainNatIpPortRanges != null)
          'drainNatIpPortRanges': drainNatIpPortRanges!,
        if (natIpPortRanges != null) 'natIpPortRanges': natIpPortRanges!,
        if (numTotalDrainNatPorts != null)
          'numTotalDrainNatPorts': numTotalDrainNatPorts!,
        if (numTotalNatPorts != null) 'numTotalNatPorts': numTotalNatPorts!,
        if (ruleMappings != null) 'ruleMappings': ruleMappings!,
        if (sourceAliasIpRange != null)
          'sourceAliasIpRange': sourceAliasIpRange!,
        if (sourceVirtualIp != null) 'sourceVirtualIp': sourceVirtualIp!,
      };
}

/// Contains information of NAT Mappings provided by a NAT Rule.
class VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings {
  /// List of all drain IP:port-range mappings assigned to this interface by
  /// this rule.
  ///
  /// These ranges are inclusive, that is, both the first and the last ports can
  /// be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\].
  core.List<core.String>? drainNatIpPortRanges;

  /// A list of all IP:port-range mappings assigned to this interface by this
  /// rule.
  ///
  /// These ranges are inclusive, that is, both the first and the last ports can
  /// be used for NAT. Example: \["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"\].
  core.List<core.String>? natIpPortRanges;

  /// Total number of drain ports across all NAT IPs allocated to this interface
  /// by this rule.
  ///
  /// It equals the aggregated port number in the field
  /// drain_nat_ip_port_ranges.
  core.int? numTotalDrainNatPorts;

  /// Total number of ports across all NAT IPs allocated to this interface by
  /// this rule.
  ///
  /// It equals the aggregated port number in the field nat_ip_port_ranges.
  core.int? numTotalNatPorts;

  /// Rule number of the NAT Rule.
  core.int? ruleNumber;

  VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings({
    this.drainNatIpPortRanges,
    this.natIpPortRanges,
    this.numTotalDrainNatPorts,
    this.numTotalNatPorts,
    this.ruleNumber,
  });

  VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.fromJson(
      core.Map json_)
      : this(
          drainNatIpPortRanges: json_.containsKey('drainNatIpPortRanges')
              ? (json_['drainNatIpPortRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          natIpPortRanges: json_.containsKey('natIpPortRanges')
              ? (json_['natIpPortRanges'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          numTotalDrainNatPorts: json_.containsKey('numTotalDrainNatPorts')
              ? json_['numTotalDrainNatPorts'] as core.int
              : null,
          numTotalNatPorts: json_.containsKey('numTotalNatPorts')
              ? json_['numTotalNatPorts'] as core.int
              : null,
          ruleNumber: json_.containsKey('ruleNumber')
              ? json_['ruleNumber'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (drainNatIpPortRanges != null)
          'drainNatIpPortRanges': drainNatIpPortRanges!,
        if (natIpPortRanges != null) 'natIpPortRanges': natIpPortRanges!,
        if (numTotalDrainNatPorts != null)
          'numTotalDrainNatPorts': numTotalDrainNatPorts!,
        if (numTotalNatPorts != null) 'numTotalNatPorts': numTotalNatPorts!,
        if (ruleNumber != null) 'ruleNumber': ruleNumber!,
      };
}

class VmEndpointNatMappingsListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VmEndpointNatMappingsListWarningData({
    this.key,
    this.value,
  });

  VmEndpointNatMappingsListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class VmEndpointNatMappingsListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VmEndpointNatMappingsListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VmEndpointNatMappingsListWarning({
    this.code,
    this.data,
    this.message,
  });

  VmEndpointNatMappingsListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VmEndpointNatMappingsListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of VmEndpointNatMappings.
class VmEndpointNatMappingsList {
  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#vmEndpointNatMappingsList for lists of Nat mappings of VM
  /// endpoints.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// A list of Nat mapping information of VM endpoints.
  ///
  /// Output only.
  core.List<VmEndpointNatMappings>? result;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  VmEndpointNatMappingsListWarning? warning;

  VmEndpointNatMappingsList({
    this.id,
    this.kind,
    this.nextPageToken,
    this.result,
    this.selfLink,
    this.warning,
  });

  VmEndpointNatMappingsList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          result: json_.containsKey('result')
              ? (json_['result'] as core.List)
                  .map((value) => VmEndpointNatMappings.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? VmEndpointNatMappingsListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (result != null) 'result': result!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a HA VPN gateway.
///
/// HA VPN is a high-availability (HA) Cloud VPN solution that lets you securely
/// connect your on-premises network to your Google Cloud Virtual Private Cloud
/// network through an IPsec VPN connection in a single region. For more
/// information about Cloud HA VPN solutions, see Cloud VPN topologies .
class VpnGateway {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of resource.
  ///
  /// Always compute#vpnGateway for VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// A fingerprint for the labels being applied to this VpnGateway, which is
  /// essentially a hash of the labels set used for optimistic locking.
  ///
  /// The fingerprint is initially generated by Compute Engine and changes after
  /// every request to modify or update labels. You must always provide an
  /// up-to-date fingerprint hash in order to update or change labels, otherwise
  /// the request will fail with error 412 conditionNotMet. To see the latest
  /// fingerprint, make a get() request to retrieve an VpnGateway.
  core.String? labelFingerprint;
  core.List<core.int> get labelFingerprintAsBytes =>
      convert.base64.decode(labelFingerprint!);

  set labelFingerprintAsBytes(core.List<core.int> bytes_) {
    labelFingerprint =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// Labels for this resource.
  ///
  /// These can only be added or modified by the setLabels method. Each label
  /// key/value pair must comply with RFC1035. Label values may be empty.
  core.Map<core.String, core.String>? labels;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the network to which this VPN gateway is attached.
  ///
  /// Provided by the client when the VPN gateway is created.
  core.String? network;

  /// URL of the region where the VPN gateway resides.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// The stack type for this VPN gateway to identify the IP protocols that are
  /// enabled.
  ///
  /// If not specified, IPV4_ONLY will be used.
  /// Possible string values are:
  /// - "IPV4_IPV6" : Enable VPN gateway with both IPv4 and IPv6 protocols.
  /// - "IPV4_ONLY" : Enable VPN gateway with only IPv4 protocol.
  core.String? stackType;

  /// The list of VPN interfaces associated with this VPN gateway.
  core.List<VpnGatewayVpnGatewayInterface>? vpnInterfaces;

  VpnGateway({
    this.creationTimestamp,
    this.description,
    this.id,
    this.kind,
    this.labelFingerprint,
    this.labels,
    this.name,
    this.network,
    this.region,
    this.selfLink,
    this.stackType,
    this.vpnInterfaces,
  });

  VpnGateway.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          labelFingerprint: json_.containsKey('labelFingerprint')
              ? json_['labelFingerprint'] as core.String
              : null,
          labels: json_.containsKey('labels')
              ? (json_['labels'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    item as core.String,
                  ),
                )
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          network: json_.containsKey('network')
              ? json_['network'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          stackType: json_.containsKey('stackType')
              ? json_['stackType'] as core.String
              : null,
          vpnInterfaces: json_.containsKey('vpnInterfaces')
              ? (json_['vpnInterfaces'] as core.List)
                  .map((value) => VpnGatewayVpnGatewayInterface.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (labelFingerprint != null) 'labelFingerprint': labelFingerprint!,
        if (labels != null) 'labels': labels!,
        if (name != null) 'name': name!,
        if (network != null) 'network': network!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (stackType != null) 'stackType': stackType!,
        if (vpnInterfaces != null) 'vpnInterfaces': vpnInterfaces!,
      };
}

class VpnGatewayAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnGatewayAggregatedListWarningData({
    this.key,
    this.value,
  });

  VpnGatewayAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class VpnGatewayAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnGatewayAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnGatewayAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnGatewayAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnGatewayAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class VpnGatewayAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of VpnGateway resources.
  core.Map<core.String, VpnGatewaysScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#vpnGateway for VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  VpnGatewayAggregatedListWarning? warning;

  VpnGatewayAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  VpnGatewayAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    VpnGatewaysScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? VpnGatewayAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class VpnGatewayListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnGatewayListWarningData({
    this.key,
    this.value,
  });

  VpnGatewayListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class VpnGatewayListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnGatewayListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnGatewayListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnGatewayListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnGatewayListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of VpnGateway resources.
class VpnGatewayList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of VpnGateway resources.
  core.List<VpnGateway>? items;

  /// Type of resource.
  ///
  /// Always compute#vpnGateway for VPN gateways.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  VpnGatewayListWarning? warning;

  VpnGatewayList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  VpnGatewayList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => VpnGateway.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? VpnGatewayListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class VpnGatewayStatus {
  /// List of VPN connection for this VpnGateway.
  core.List<VpnGatewayStatusVpnConnection>? vpnConnections;

  VpnGatewayStatus({
    this.vpnConnections,
  });

  VpnGatewayStatus.fromJson(core.Map json_)
      : this(
          vpnConnections: json_.containsKey('vpnConnections')
              ? (json_['vpnConnections'] as core.List)
                  .map((value) => VpnGatewayStatusVpnConnection.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (vpnConnections != null) 'vpnConnections': vpnConnections!,
      };
}

/// Describes the high availability requirement state for the VPN connection
/// between this Cloud VPN gateway and a peer gateway.
class VpnGatewayStatusHighAvailabilityRequirementState {
  /// Indicates the high availability requirement state for the VPN connection.
  ///
  /// Valid values are CONNECTION_REDUNDANCY_MET, CONNECTION_REDUNDANCY_NOT_MET.
  /// Possible string values are:
  /// - "CONNECTION_REDUNDANCY_MET" : VPN tunnels are configured with adequate
  /// redundancy from Cloud VPN gateway to the peer VPN gateway. For both
  /// GCP-to-non-GCP and GCP-to-GCP connections, the adequate redundancy is a
  /// pre-requirement for users to get 99.99% availability on GCP side; please
  /// note that for any connection, end-to-end 99.99% availability is subject to
  /// proper configuration on the peer VPN gateway.
  /// - "CONNECTION_REDUNDANCY_NOT_MET" : VPN tunnels are not configured with
  /// adequate redundancy from the Cloud VPN gateway to the peer gateway
  core.String? state;

  /// Indicates the reason why the VPN connection does not meet the high
  /// availability redundancy criteria/requirement.
  ///
  /// Valid values is INCOMPLETE_TUNNELS_COVERAGE.
  /// Possible string values are:
  /// - "INCOMPLETE_TUNNELS_COVERAGE"
  core.String? unsatisfiedReason;

  VpnGatewayStatusHighAvailabilityRequirementState({
    this.state,
    this.unsatisfiedReason,
  });

  VpnGatewayStatusHighAvailabilityRequirementState.fromJson(core.Map json_)
      : this(
          state:
              json_.containsKey('state') ? json_['state'] as core.String : null,
          unsatisfiedReason: json_.containsKey('unsatisfiedReason')
              ? json_['unsatisfiedReason'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (state != null) 'state': state!,
        if (unsatisfiedReason != null) 'unsatisfiedReason': unsatisfiedReason!,
      };
}

/// Contains some information about a VPN tunnel.
class VpnGatewayStatusTunnel {
  /// The VPN gateway interface this VPN tunnel is associated with.
  core.int? localGatewayInterface;

  /// The peer gateway interface this VPN tunnel is connected to, the peer
  /// gateway could either be an external VPN gateway or GCP VPN gateway.
  core.int? peerGatewayInterface;

  /// URL reference to the VPN tunnel.
  core.String? tunnelUrl;

  VpnGatewayStatusTunnel({
    this.localGatewayInterface,
    this.peerGatewayInterface,
    this.tunnelUrl,
  });

  VpnGatewayStatusTunnel.fromJson(core.Map json_)
      : this(
          localGatewayInterface: json_.containsKey('localGatewayInterface')
              ? json_['localGatewayInterface'] as core.int
              : null,
          peerGatewayInterface: json_.containsKey('peerGatewayInterface')
              ? json_['peerGatewayInterface'] as core.int
              : null,
          tunnelUrl: json_.containsKey('tunnelUrl')
              ? json_['tunnelUrl'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (localGatewayInterface != null)
          'localGatewayInterface': localGatewayInterface!,
        if (peerGatewayInterface != null)
          'peerGatewayInterface': peerGatewayInterface!,
        if (tunnelUrl != null) 'tunnelUrl': tunnelUrl!,
      };
}

/// A VPN connection contains all VPN tunnels connected from this VpnGateway to
/// the same peer gateway.
///
/// The peer gateway could either be a external VPN gateway or GCP VPN gateway.
class VpnGatewayStatusVpnConnection {
  /// URL reference to the peer external VPN gateways to which the VPN tunnels
  /// in this VPN connection are connected.
  ///
  /// This field is mutually exclusive with peer_gcp_gateway.
  core.String? peerExternalGateway;

  /// URL reference to the peer side VPN gateways to which the VPN tunnels in
  /// this VPN connection are connected.
  ///
  /// This field is mutually exclusive with peer_gcp_gateway.
  core.String? peerGcpGateway;

  /// HighAvailabilityRequirementState for the VPN connection.
  VpnGatewayStatusHighAvailabilityRequirementState? state;

  /// List of VPN tunnels that are in this VPN connection.
  core.List<VpnGatewayStatusTunnel>? tunnels;

  VpnGatewayStatusVpnConnection({
    this.peerExternalGateway,
    this.peerGcpGateway,
    this.state,
    this.tunnels,
  });

  VpnGatewayStatusVpnConnection.fromJson(core.Map json_)
      : this(
          peerExternalGateway: json_.containsKey('peerExternalGateway')
              ? json_['peerExternalGateway'] as core.String
              : null,
          peerGcpGateway: json_.containsKey('peerGcpGateway')
              ? json_['peerGcpGateway'] as core.String
              : null,
          state: json_.containsKey('state')
              ? VpnGatewayStatusHighAvailabilityRequirementState.fromJson(
                  json_['state'] as core.Map<core.String, core.dynamic>)
              : null,
          tunnels: json_.containsKey('tunnels')
              ? (json_['tunnels'] as core.List)
                  .map((value) => VpnGatewayStatusTunnel.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (peerExternalGateway != null)
          'peerExternalGateway': peerExternalGateway!,
        if (peerGcpGateway != null) 'peerGcpGateway': peerGcpGateway!,
        if (state != null) 'state': state!,
        if (tunnels != null) 'tunnels': tunnels!,
      };
}

/// A VPN gateway interface.
class VpnGatewayVpnGatewayInterface {
  /// Numeric identifier for this VPN interface associated with the VPN gateway.
  ///
  /// Output only.
  core.int? id;

  /// URL of the VLAN attachment (interconnectAttachment) resource for this VPN
  /// gateway interface.
  ///
  /// When the value of this field is present, the VPN gateway is used for HA
  /// VPN over Cloud Interconnect; all egress or ingress traffic for this VPN
  /// gateway interface goes through the specified VLAN attachment resource.
  core.String? interconnectAttachment;

  /// IP address for this VPN interface associated with the VPN gateway.
  ///
  /// The IP address could be either a regional external IP address or a
  /// regional internal IP address. The two IP addresses for a VPN gateway must
  /// be all regional external or regional internal IP addresses. There cannot
  /// be a mix of regional external IP addresses and regional internal IP
  /// addresses. For HA VPN over Cloud Interconnect, the IP addresses for both
  /// interfaces could either be regional internal IP addresses or regional
  /// external IP addresses. For regular (non HA VPN over Cloud Interconnect) HA
  /// VPN tunnels, the IP address must be a regional external IP address.
  ///
  /// Output only.
  core.String? ipAddress;

  VpnGatewayVpnGatewayInterface({
    this.id,
    this.interconnectAttachment,
    this.ipAddress,
  });

  VpnGatewayVpnGatewayInterface.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.int : null,
          interconnectAttachment: json_.containsKey('interconnectAttachment')
              ? json_['interconnectAttachment'] as core.String
              : null,
          ipAddress: json_.containsKey('ipAddress')
              ? json_['ipAddress'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (interconnectAttachment != null)
          'interconnectAttachment': interconnectAttachment!,
        if (ipAddress != null) 'ipAddress': ipAddress!,
      };
}

class VpnGatewaysGetStatusResponse {
  VpnGatewayStatus? result;

  VpnGatewaysGetStatusResponse({
    this.result,
  });

  VpnGatewaysGetStatusResponse.fromJson(core.Map json_)
      : this(
          result: json_.containsKey('result')
              ? VpnGatewayStatus.fromJson(
                  json_['result'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (result != null) 'result': result!,
      };
}

class VpnGatewaysScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnGatewaysScopedListWarningData({
    this.key,
    this.value,
  });

  VpnGatewaysScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
///
/// Output only.
class VpnGatewaysScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnGatewaysScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnGatewaysScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnGatewaysScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnGatewaysScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class VpnGatewaysScopedList {
  /// A list of VPN gateways contained in this scope.
  ///
  /// Output only.
  core.List<VpnGateway>? vpnGateways;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  ///
  /// Output only.
  VpnGatewaysScopedListWarning? warning;

  VpnGatewaysScopedList({
    this.vpnGateways,
    this.warning,
  });

  VpnGatewaysScopedList.fromJson(core.Map json_)
      : this(
          vpnGateways: json_.containsKey('vpnGateways')
              ? (json_['vpnGateways'] as core.List)
                  .map((value) => VpnGateway.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? VpnGatewaysScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (vpnGateways != null) 'vpnGateways': vpnGateways!,
        if (warning != null) 'warning': warning!,
      };
}

/// Represents a Cloud VPN Tunnel resource.
///
/// For more information about VPN, read the the Cloud VPN Overview.
class VpnTunnel {
  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// An optional description of this resource.
  ///
  /// Provide this property when you create the resource.
  core.String? description;

  /// Detailed status message for the VPN tunnel.
  ///
  /// Output only.
  core.String? detailedStatus;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// IKE protocol version to use when establishing the VPN tunnel with the peer
  /// VPN gateway.
  ///
  /// Acceptable IKE versions are 1 or 2. The default version is 2.
  core.int? ikeVersion;

  /// Type of resource.
  ///
  /// Always compute#vpnTunnel for VPN tunnels.
  ///
  /// Output only.
  core.String? kind;

  /// Local traffic selector to use when establishing the VPN tunnel with the
  /// peer VPN gateway.
  ///
  /// The value should be a CIDR formatted string, for example: 192.168.0.0/16.
  /// The ranges must be disjoint. Only IPv4 is supported.
  core.List<core.String>? localTrafficSelector;

  /// Name of the resource.
  ///
  /// Provided by the client when the resource is created. The name must be 1-63
  /// characters long, and comply with RFC1035. Specifically, the name must be
  /// 1-63 characters long and match the regular expression
  /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
  /// lowercase letter, and all following characters must be a dash, lowercase
  /// letter, or digit, except the last character, which cannot be a dash.
  core.String? name;

  /// URL of the peer side external VPN gateway to which this VPN tunnel is
  /// connected.
  ///
  /// Provided by the client when the VPN tunnel is created. This field is
  /// exclusive with the field peerGcpGateway.
  core.String? peerExternalGateway;

  /// The interface ID of the external VPN gateway to which this VPN tunnel is
  /// connected.
  ///
  /// Provided by the client when the VPN tunnel is created.
  core.int? peerExternalGatewayInterface;

  /// URL of the peer side HA GCP VPN gateway to which this VPN tunnel is
  /// connected.
  ///
  /// Provided by the client when the VPN tunnel is created. This field can be
  /// used when creating highly available VPN from VPC network to VPC network,
  /// the field is exclusive with the field peerExternalGateway. If provided,
  /// the VPN tunnel will automatically use the same vpnGatewayInterface ID in
  /// the peer GCP VPN gateway.
  core.String? peerGcpGateway;

  /// IP address of the peer VPN gateway.
  ///
  /// Only IPv4 is supported.
  core.String? peerIp;

  /// URL of the region where the VPN tunnel resides.
  ///
  /// You must specify this field as part of the HTTP request URL. It is not
  /// settable as a field in the request body.
  ///
  /// Output only.
  core.String? region;

  /// Remote traffic selectors to use when establishing the VPN tunnel with the
  /// peer VPN gateway.
  ///
  /// The value should be a CIDR formatted string, for example: 192.168.0.0/16.
  /// The ranges should be disjoint. Only IPv4 is supported.
  core.List<core.String>? remoteTrafficSelector;

  /// URL of the router resource to be used for dynamic routing.
  core.String? router;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Shared secret used to set the secure session between the Cloud VPN gateway
  /// and the peer VPN gateway.
  core.String? sharedSecret;

  /// Hash of the shared secret.
  core.String? sharedSecretHash;

  /// The status of the VPN tunnel, which can be one of the following: -
  /// PROVISIONING: Resource is being allocated for the VPN tunnel.
  ///
  /// - WAITING_FOR_FULL_CONFIG: Waiting to receive all VPN-related configs from
  /// the user. Network, TargetVpnGateway, VpnTunnel, ForwardingRule, and Route
  /// resources are needed to setup the VPN tunnel. - FIRST_HANDSHAKE:
  /// Successful first handshake with the peer VPN. - ESTABLISHED: Secure
  /// session is successfully established with the peer VPN. - NETWORK_ERROR:
  /// Deprecated, replaced by NO_INCOMING_PACKETS - AUTHORIZATION_ERROR: Auth
  /// error (for example, bad shared secret). - NEGOTIATION_FAILURE: Handshake
  /// failed. - DEPROVISIONING: Resources are being deallocated for the VPN
  /// tunnel. - FAILED: Tunnel creation has failed and the tunnel is not ready
  /// to be used. - NO_INCOMING_PACKETS: No incoming packets from peer. -
  /// REJECTED: Tunnel configuration was rejected, can be result of being denied
  /// access. - ALLOCATING_RESOURCES: Cloud VPN is in the process of allocating
  /// all required resources. - STOPPED: Tunnel is stopped due to its Forwarding
  /// Rules being deleted for Classic VPN tunnels or the project is in frozen
  /// state. - PEER_IDENTITY_MISMATCH: Peer identity does not match peer IP,
  /// probably behind NAT. - TS_NARROWING_NOT_ALLOWED: Traffic selector
  /// narrowing not allowed for an HA-VPN tunnel.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "ALLOCATING_RESOURCES" : Cloud VPN is in the process of allocating all
  /// required resources (specifically, a borg task).
  /// - "AUTHORIZATION_ERROR" : Auth error (e.g. bad shared secret).
  /// - "DEPROVISIONING" : Resources is being deallocated for the VPN tunnel.
  /// - "ESTABLISHED" : Secure session is successfully established with peer
  /// VPN.
  /// - "FAILED" : Tunnel creation has failed and the tunnel is not ready to be
  /// used.
  /// - "FIRST_HANDSHAKE" : Successful first handshake with peer VPN.
  /// - "NEGOTIATION_FAILURE" : Handshake failed.
  /// - "NETWORK_ERROR" : Deprecated, replaced by NO_INCOMING_PACKETS
  /// - "NO_INCOMING_PACKETS" : No incoming packets from peer
  /// - "PROVISIONING" : Resource is being allocated for the VPN tunnel.
  /// - "REJECTED" : Tunnel configuration was rejected, can be result of being
  /// denylisted.
  /// - "STOPPED" : Tunnel is stopped due to its Forwarding Rules being deleted.
  /// - "WAITING_FOR_FULL_CONFIG" : Waiting to receive all VPN-related configs
  /// from user. Network, TargetVpnGateway, VpnTunnel, ForwardingRule and Route
  /// resources are needed to setup VPN tunnel.
  core.String? status;

  /// URL of the Target VPN gateway with which this VPN tunnel is associated.
  ///
  /// Provided by the client when the VPN tunnel is created.
  core.String? targetVpnGateway;

  /// URL of the VPN gateway with which this VPN tunnel is associated.
  ///
  /// Provided by the client when the VPN tunnel is created. This must be used
  /// (instead of target_vpn_gateway) if a High Availability VPN gateway
  /// resource is created.
  core.String? vpnGateway;

  /// The interface ID of the VPN gateway with which this VPN tunnel is
  /// associated.
  core.int? vpnGatewayInterface;

  VpnTunnel({
    this.creationTimestamp,
    this.description,
    this.detailedStatus,
    this.id,
    this.ikeVersion,
    this.kind,
    this.localTrafficSelector,
    this.name,
    this.peerExternalGateway,
    this.peerExternalGatewayInterface,
    this.peerGcpGateway,
    this.peerIp,
    this.region,
    this.remoteTrafficSelector,
    this.router,
    this.selfLink,
    this.sharedSecret,
    this.sharedSecretHash,
    this.status,
    this.targetVpnGateway,
    this.vpnGateway,
    this.vpnGatewayInterface,
  });

  VpnTunnel.fromJson(core.Map json_)
      : this(
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          detailedStatus: json_.containsKey('detailedStatus')
              ? json_['detailedStatus'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          ikeVersion: json_.containsKey('ikeVersion')
              ? json_['ikeVersion'] as core.int
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          localTrafficSelector: json_.containsKey('localTrafficSelector')
              ? (json_['localTrafficSelector'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          peerExternalGateway: json_.containsKey('peerExternalGateway')
              ? json_['peerExternalGateway'] as core.String
              : null,
          peerExternalGatewayInterface:
              json_.containsKey('peerExternalGatewayInterface')
                  ? json_['peerExternalGatewayInterface'] as core.int
                  : null,
          peerGcpGateway: json_.containsKey('peerGcpGateway')
              ? json_['peerGcpGateway'] as core.String
              : null,
          peerIp: json_.containsKey('peerIp')
              ? json_['peerIp'] as core.String
              : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          remoteTrafficSelector: json_.containsKey('remoteTrafficSelector')
              ? (json_['remoteTrafficSelector'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          router: json_.containsKey('router')
              ? json_['router'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          sharedSecret: json_.containsKey('sharedSecret')
              ? json_['sharedSecret'] as core.String
              : null,
          sharedSecretHash: json_.containsKey('sharedSecretHash')
              ? json_['sharedSecretHash'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          targetVpnGateway: json_.containsKey('targetVpnGateway')
              ? json_['targetVpnGateway'] as core.String
              : null,
          vpnGateway: json_.containsKey('vpnGateway')
              ? json_['vpnGateway'] as core.String
              : null,
          vpnGatewayInterface: json_.containsKey('vpnGatewayInterface')
              ? json_['vpnGatewayInterface'] as core.int
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (description != null) 'description': description!,
        if (detailedStatus != null) 'detailedStatus': detailedStatus!,
        if (id != null) 'id': id!,
        if (ikeVersion != null) 'ikeVersion': ikeVersion!,
        if (kind != null) 'kind': kind!,
        if (localTrafficSelector != null)
          'localTrafficSelector': localTrafficSelector!,
        if (name != null) 'name': name!,
        if (peerExternalGateway != null)
          'peerExternalGateway': peerExternalGateway!,
        if (peerExternalGatewayInterface != null)
          'peerExternalGatewayInterface': peerExternalGatewayInterface!,
        if (peerGcpGateway != null) 'peerGcpGateway': peerGcpGateway!,
        if (peerIp != null) 'peerIp': peerIp!,
        if (region != null) 'region': region!,
        if (remoteTrafficSelector != null)
          'remoteTrafficSelector': remoteTrafficSelector!,
        if (router != null) 'router': router!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (sharedSecret != null) 'sharedSecret': sharedSecret!,
        if (sharedSecretHash != null) 'sharedSecretHash': sharedSecretHash!,
        if (status != null) 'status': status!,
        if (targetVpnGateway != null) 'targetVpnGateway': targetVpnGateway!,
        if (vpnGateway != null) 'vpnGateway': vpnGateway!,
        if (vpnGatewayInterface != null)
          'vpnGatewayInterface': vpnGatewayInterface!,
      };
}

class VpnTunnelAggregatedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnTunnelAggregatedListWarningData({
    this.key,
    this.value,
  });

  VpnTunnelAggregatedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class VpnTunnelAggregatedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnTunnelAggregatedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnTunnelAggregatedListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnTunnelAggregatedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnTunnelAggregatedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class VpnTunnelAggregatedList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of VpnTunnelsScopedList resources.
  core.Map<core.String, VpnTunnelsScopedList>? items;

  /// Type of resource.
  ///
  /// Always compute#vpnTunnel for VPN tunnels.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Unreachable resources.
  ///
  /// Output only.
  core.List<core.String>? unreachables;

  /// Informational warning message.
  ///
  /// Output only.
  VpnTunnelAggregatedListWarning? warning;

  VpnTunnelAggregatedList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.unreachables,
    this.warning,
  });

  VpnTunnelAggregatedList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.Map<core.String, core.dynamic>).map(
                  (key, item) => core.MapEntry(
                    key,
                    VpnTunnelsScopedList.fromJson(
                        item as core.Map<core.String, core.dynamic>),
                  ),
                )
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          unreachables: json_.containsKey('unreachables')
              ? (json_['unreachables'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? VpnTunnelAggregatedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (unreachables != null) 'unreachables': unreachables!,
        if (warning != null) 'warning': warning!,
      };
}

class VpnTunnelListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnTunnelListWarningData({
    this.key,
    this.value,
  });

  VpnTunnelListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class VpnTunnelListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnTunnelListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnTunnelListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnTunnelListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnTunnelListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of VpnTunnel resources.
class VpnTunnelList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of VpnTunnel resources.
  core.List<VpnTunnel>? items;

  /// Type of resource.
  ///
  /// Always compute#vpnTunnel for VPN tunnels.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  VpnTunnelListWarning? warning;

  VpnTunnelList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  VpnTunnelList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => VpnTunnel.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? VpnTunnelListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

class VpnTunnelsScopedListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  VpnTunnelsScopedListWarningData({
    this.key,
    this.value,
  });

  VpnTunnelsScopedListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning which replaces the list of addresses when the list is
/// empty.
class VpnTunnelsScopedListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<VpnTunnelsScopedListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  VpnTunnelsScopedListWarning({
    this.code,
    this.data,
    this.message,
  });

  VpnTunnelsScopedListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => VpnTunnelsScopedListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class VpnTunnelsScopedList {
  /// A list of VPN tunnels contained in this scope.
  core.List<VpnTunnel>? vpnTunnels;

  /// Informational warning which replaces the list of addresses when the list
  /// is empty.
  VpnTunnelsScopedListWarning? warning;

  VpnTunnelsScopedList({
    this.vpnTunnels,
    this.warning,
  });

  VpnTunnelsScopedList.fromJson(core.Map json_)
      : this(
          vpnTunnels: json_.containsKey('vpnTunnels')
              ? (json_['vpnTunnels'] as core.List)
                  .map((value) => VpnTunnel.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          warning: json_.containsKey('warning')
              ? VpnTunnelsScopedListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (vpnTunnels != null) 'vpnTunnels': vpnTunnels!,
        if (warning != null) 'warning': warning!,
      };
}

class WafExpressionSet {
  /// A list of alternate IDs.
  ///
  /// The format should be: - E.g. XSS-stable Generic suffix like "stable" is
  /// particularly useful if a policy likes to avail newer set of expressions
  /// without having to change the policy. A given alias name can't be used for
  /// more than one entity set.
  core.List<core.String>? aliases;

  /// List of available expressions.
  core.List<WafExpressionSetExpression>? expressions;

  /// Google specified expression set ID.
  ///
  /// The format should be: - E.g. XSS-20170329 required
  core.String? id;

  WafExpressionSet({
    this.aliases,
    this.expressions,
    this.id,
  });

  WafExpressionSet.fromJson(core.Map json_)
      : this(
          aliases: json_.containsKey('aliases')
              ? (json_['aliases'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          expressions: json_.containsKey('expressions')
              ? (json_['expressions'] as core.List)
                  .map((value) => WafExpressionSetExpression.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (aliases != null) 'aliases': aliases!,
        if (expressions != null) 'expressions': expressions!,
        if (id != null) 'id': id!,
      };
}

class WafExpressionSetExpression {
  /// Expression ID should uniquely identify the origin of the expression.
  ///
  /// E.g. owasp-crs-v020901-id973337 identifies Owasp core rule set version
  /// 2.9.1 rule id 973337. The ID could be used to determine the individual
  /// attack definition that has been detected. It could also be used to exclude
  /// it from the policy in case of false positive. required
  core.String? id;

  WafExpressionSetExpression({
    this.id,
  });

  WafExpressionSetExpression.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
      };
}

/// In contrast to a single BackendService in HttpRouteAction to which all
/// matching traffic is directed to, WeightedBackendService allows traffic to be
/// split across multiple backend services.
///
/// The volume of traffic for each backend service is proportional to the weight
/// specified in each WeightedBackendService
class WeightedBackendService {
  /// The full or partial URL to the default BackendService resource.
  ///
  /// Before forwarding the request to backendService, the load balancer applies
  /// any relevant headerActions specified as part of this backendServiceWeight.
  core.String? backendService;

  /// Specifies changes to request and response headers that need to take effect
  /// for the selected backendService.
  ///
  /// headerAction specified here take effect before headerAction in the
  /// enclosing HttpRouteRule, PathMatcher and UrlMap. headerAction is not
  /// supported for load balancers that have their loadBalancingScheme set to
  /// EXTERNAL. Not supported when the URL map is bound to a target gRPC proxy
  /// that has validateForProxyless field set to true.
  HttpHeaderAction? headerAction;

  /// Specifies the fraction of traffic sent to a backend service, computed as
  /// weight / (sum of all weightedBackendService weights in routeAction) .
  ///
  /// The selection of a backend service is determined only for new traffic.
  /// Once a user's request has been directed to a backend service, subsequent
  /// requests are sent to the same backend service as determined by the backend
  /// service's session affinity policy. The value must be from 0 to 1000.
  core.int? weight;

  WeightedBackendService({
    this.backendService,
    this.headerAction,
    this.weight,
  });

  WeightedBackendService.fromJson(core.Map json_)
      : this(
          backendService: json_.containsKey('backendService')
              ? json_['backendService'] as core.String
              : null,
          headerAction: json_.containsKey('headerAction')
              ? HttpHeaderAction.fromJson(
                  json_['headerAction'] as core.Map<core.String, core.dynamic>)
              : null,
          weight:
              json_.containsKey('weight') ? json_['weight'] as core.int : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (backendService != null) 'backendService': backendService!,
        if (headerAction != null) 'headerAction': headerAction!,
        if (weight != null) 'weight': weight!,
      };
}

class XpnHostListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  XpnHostListWarningData({
    this.key,
    this.value,
  });

  XpnHostListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class XpnHostListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<XpnHostListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  XpnHostListWarning({
    this.code,
    this.data,
    this.message,
  });

  XpnHostListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => XpnHostListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

class XpnHostList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of shared VPC host project URLs.
  ///
  /// Output only.
  core.List<Project>? items;

  /// Type of resource.
  ///
  /// Always compute#xpnHostList for lists of shared VPC hosts.
  ///
  /// Output only.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  XpnHostListWarning? warning;

  XpnHostList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  XpnHostList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Project.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? XpnHostListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

/// Service resource (a.k.a service project) ID.
class XpnResourceId {
  /// The ID of the service resource.
  ///
  /// In the case of projects, this field supports project id (e.g.,
  /// my-project-123) and project number (e.g. 12345678).
  core.String? id;

  /// The type of the service resource.
  /// Possible string values are:
  /// - "PROJECT"
  /// - "XPN_RESOURCE_TYPE_UNSPECIFIED"
  core.String? type;

  XpnResourceId({
    this.id,
    this.type,
  });

  XpnResourceId.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          type: json_.containsKey('type') ? json_['type'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (type != null) 'type': type!,
      };
}

/// Represents a Zone resource.
///
/// A zone is a deployment area. These deployment areas are subsets of a region.
/// For example the zone us-east1-a is located in the us-east1 region. For more
/// information, read Regions and Zones.
class Zone {
  /// Available cpu/platform selections for the zone.
  ///
  /// Output only.
  core.List<core.String>? availableCpuPlatforms;

  /// Creation timestamp in RFC3339 text format.
  ///
  /// Output only.
  core.String? creationTimestamp;

  /// The deprecation status associated with this zone.
  ///
  /// Output only.
  DeprecationStatus? deprecated;

  /// Textual description of the resource.
  ///
  /// Output only.
  core.String? description;

  /// The unique identifier for the resource.
  ///
  /// This identifier is defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// Type of the resource.
  ///
  /// Always compute#zone for zones.
  ///
  /// Output only.
  core.String? kind;

  /// Name of the resource.
  ///
  /// Output only.
  core.String? name;

  /// Full URL reference to the region which hosts the zone.
  ///
  /// Output only.
  core.String? region;

  /// Server-defined URL for the resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Status of the zone, either UP or DOWN.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "DOWN"
  /// - "UP"
  core.String? status;

  /// Reserved for future use.
  ///
  /// Output only.
  core.bool? supportsPzs;

  Zone({
    this.availableCpuPlatforms,
    this.creationTimestamp,
    this.deprecated,
    this.description,
    this.id,
    this.kind,
    this.name,
    this.region,
    this.selfLink,
    this.status,
    this.supportsPzs,
  });

  Zone.fromJson(core.Map json_)
      : this(
          availableCpuPlatforms: json_.containsKey('availableCpuPlatforms')
              ? (json_['availableCpuPlatforms'] as core.List)
                  .map((value) => value as core.String)
                  .toList()
              : null,
          creationTimestamp: json_.containsKey('creationTimestamp')
              ? json_['creationTimestamp'] as core.String
              : null,
          deprecated: json_.containsKey('deprecated')
              ? DeprecationStatus.fromJson(
                  json_['deprecated'] as core.Map<core.String, core.dynamic>)
              : null,
          description: json_.containsKey('description')
              ? json_['description'] as core.String
              : null,
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          name: json_.containsKey('name') ? json_['name'] as core.String : null,
          region: json_.containsKey('region')
              ? json_['region'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          status: json_.containsKey('status')
              ? json_['status'] as core.String
              : null,
          supportsPzs: json_.containsKey('supportsPzs')
              ? json_['supportsPzs'] as core.bool
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (availableCpuPlatforms != null)
          'availableCpuPlatforms': availableCpuPlatforms!,
        if (creationTimestamp != null) 'creationTimestamp': creationTimestamp!,
        if (deprecated != null) 'deprecated': deprecated!,
        if (description != null) 'description': description!,
        if (id != null) 'id': id!,
        if (kind != null) 'kind': kind!,
        if (name != null) 'name': name!,
        if (region != null) 'region': region!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (status != null) 'status': status!,
        if (supportsPzs != null) 'supportsPzs': supportsPzs!,
      };
}

class ZoneListWarningData {
  /// A key that provides more detail on the warning being returned.
  ///
  /// For example, for warnings where there are no results in a list request for
  /// a particular zone, this key might be scope and the key value might be the
  /// zone name. Other examples might be a key indicating a deprecated resource
  /// and a suggested replacement, or a warning about invalid network settings
  /// (for example, if an instance attempts to perform IP forwarding but is not
  /// enabled for IP forwarding).
  ///
  /// Output only.
  core.String? key;

  /// A warning data value corresponding to the key.
  ///
  /// Output only.
  core.String? value;

  ZoneListWarningData({
    this.key,
    this.value,
  });

  ZoneListWarningData.fromJson(core.Map json_)
      : this(
          key: json_.containsKey('key') ? json_['key'] as core.String : null,
          value:
              json_.containsKey('value') ? json_['value'] as core.String : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (key != null) 'key': key!,
        if (value != null) 'value': value!,
      };
}

/// Informational warning message.
///
/// Output only.
class ZoneListWarning {
  /// A warning code, if applicable.
  ///
  /// For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no
  /// results in the response.
  ///
  /// Output only.
  /// Possible string values are:
  /// - "CLEANUP_FAILED" : Warning about failed cleanup of transient changes
  /// made by a failed operation.
  /// - "DEPRECATED_RESOURCE_USED" : A link to a deprecated resource was
  /// created.
  /// - "DEPRECATED_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as deprecated
  /// - "DISK_SIZE_LARGER_THAN_IMAGE_SIZE" : The user created a boot disk that
  /// is larger than image size.
  /// - "EXPERIMENTAL_TYPE_USED" : When deploying and at least one of the
  /// resources has a type marked as experimental
  /// - "EXTERNAL_API_WARNING" : Warning that is present in an external api call
  /// - "FIELD_VALUE_OVERRIDEN" : Warning that value of a field has been
  /// overridden. Deprecated unused field.
  /// - "INJECTED_KERNELS_DEPRECATED" : The operation involved use of an
  /// injected kernel, which is deprecated.
  /// - "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB" : A WEIGHTED_MAGLEV
  /// backend service is associated with a health check that is not of type
  /// HTTP/HTTPS/HTTP2.
  /// - "LARGE_DEPLOYMENT_WARNING" : When deploying a deployment with a
  /// exceedingly large number of resources
  /// - "MISSING_TYPE_DEPENDENCY" : A resource depends on a missing type
  /// - "NEXT_HOP_ADDRESS_NOT_ASSIGNED" : The route's nextHopIp address is not
  /// assigned to an instance on the network.
  /// - "NEXT_HOP_CANNOT_IP_FORWARD" : The route's next hop instance cannot ip
  /// forward.
  /// - "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE" : The route's nextHopInstance
  /// URL refers to an instance that does not have an ipv6 interface on the same
  /// network as the route.
  /// - "NEXT_HOP_INSTANCE_NOT_FOUND" : The route's nextHopInstance URL refers
  /// to an instance that does not exist.
  /// - "NEXT_HOP_INSTANCE_NOT_ON_NETWORK" : The route's nextHopInstance URL
  /// refers to an instance that is not on the same network as the route.
  /// - "NEXT_HOP_NOT_RUNNING" : The route's next hop instance does not have a
  /// status of RUNNING.
  /// - "NOT_CRITICAL_ERROR" : Error which is not critical. We decided to
  /// continue the process despite the mentioned error.
  /// - "NO_RESULTS_ON_PAGE" : No results are present on a particular list page.
  /// - "PARTIAL_SUCCESS" : Success is reported, but some results may be missing
  /// due to errors
  /// - "REQUIRED_TOS_AGREEMENT" : The user attempted to use a resource that
  /// requires a TOS they have not accepted.
  /// - "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING" : Warning that a resource is
  /// in use.
  /// - "RESOURCE_NOT_DELETED" : One or more of the resources set to auto-delete
  /// could not be deleted because they were in use.
  /// - "SCHEMA_VALIDATION_IGNORED" : When a resource schema validation is
  /// ignored.
  /// - "SINGLE_INSTANCE_PROPERTY_TEMPLATE" : Instance template used in instance
  /// group manager is valid as such, but its application does not make a lot of
  /// sense, because it allows only single instance in instance group.
  /// - "UNDECLARED_PROPERTIES" : When undeclared properties in the schema are
  /// present
  /// - "UNREACHABLE" : A given scope cannot be reached.
  core.String? code;

  /// Metadata about this warning in key: value format.
  ///
  /// For example: "data": \[ { "key": "scope", "value": "zones/us-east1-d" }
  ///
  /// Output only.
  core.List<ZoneListWarningData>? data;

  /// A human-readable description of the warning code.
  ///
  /// Output only.
  core.String? message;

  ZoneListWarning({
    this.code,
    this.data,
    this.message,
  });

  ZoneListWarning.fromJson(core.Map json_)
      : this(
          code: json_.containsKey('code') ? json_['code'] as core.String : null,
          data: json_.containsKey('data')
              ? (json_['data'] as core.List)
                  .map((value) => ZoneListWarningData.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          message: json_.containsKey('message')
              ? json_['message'] as core.String
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (code != null) 'code': code!,
        if (data != null) 'data': data!,
        if (message != null) 'message': message!,
      };
}

/// Contains a list of zone resources.
class ZoneList {
  /// Unique identifier for the resource; defined by the server.
  ///
  /// Output only.
  core.String? id;

  /// A list of Zone resources.
  core.List<Zone>? items;

  /// Type of resource.
  core.String? kind;

  /// This token allows you to get the next page of results for list requests.
  ///
  /// If the number of results is larger than maxResults, use the nextPageToken
  /// as a value for the query parameter pageToken in the next list request.
  /// Subsequent list requests will have their own nextPageToken to continue
  /// paging through the results.
  ///
  /// Output only.
  core.String? nextPageToken;

  /// Server-defined URL for this resource.
  ///
  /// Output only.
  core.String? selfLink;

  /// Informational warning message.
  ///
  /// Output only.
  ZoneListWarning? warning;

  ZoneList({
    this.id,
    this.items,
    this.kind,
    this.nextPageToken,
    this.selfLink,
    this.warning,
  });

  ZoneList.fromJson(core.Map json_)
      : this(
          id: json_.containsKey('id') ? json_['id'] as core.String : null,
          items: json_.containsKey('items')
              ? (json_['items'] as core.List)
                  .map((value) => Zone.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          kind: json_.containsKey('kind') ? json_['kind'] as core.String : null,
          nextPageToken: json_.containsKey('nextPageToken')
              ? json_['nextPageToken'] as core.String
              : null,
          selfLink: json_.containsKey('selfLink')
              ? json_['selfLink'] as core.String
              : null,
          warning: json_.containsKey('warning')
              ? ZoneListWarning.fromJson(
                  json_['warning'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (id != null) 'id': id!,
        if (items != null) 'items': items!,
        if (kind != null) 'kind': kind!,
        if (nextPageToken != null) 'nextPageToken': nextPageToken!,
        if (selfLink != null) 'selfLink': selfLink!,
        if (warning != null) 'warning': warning!,
      };
}

typedef ZoneSetLabelsRequest = $SetLabelsRequest;

class ZoneSetPolicyRequest {
  /// Flatten Policy to create a backwacd compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify bindings.
  core.List<Binding>? bindings;

  /// Flatten Policy to create a backward compatible wire-format.
  ///
  /// Deprecated. Use 'policy' to specify the etag.
  core.String? etag;
  core.List<core.int> get etagAsBytes => convert.base64.decode(etag!);

  set etagAsBytes(core.List<core.int> bytes_) {
    etag =
        convert.base64.encode(bytes_).replaceAll('/', '_').replaceAll('+', '-');
  }

  /// REQUIRED: The complete policy to be applied to the 'resource'.
  ///
  /// The size of the policy is limited to a few 10s of KB. An empty policy is
  /// in general a valid policy but certain services (like Projects) might
  /// reject them.
  Policy? policy;

  ZoneSetPolicyRequest({
    this.bindings,
    this.etag,
    this.policy,
  });

  ZoneSetPolicyRequest.fromJson(core.Map json_)
      : this(
          bindings: json_.containsKey('bindings')
              ? (json_['bindings'] as core.List)
                  .map((value) => Binding.fromJson(
                      value as core.Map<core.String, core.dynamic>))
                  .toList()
              : null,
          etag: json_.containsKey('etag') ? json_['etag'] as core.String : null,
          policy: json_.containsKey('policy')
              ? Policy.fromJson(
                  json_['policy'] as core.Map<core.String, core.dynamic>)
              : null,
        );

  core.Map<core.String, core.dynamic> toJson() => {
        if (bindings != null) 'bindings': bindings!,
        if (etag != null) 'etag': etag!,
        if (policy != null) 'policy': policy!,
      };
}
